************************************************************************
* sanc_cc_v1.40 package.
************************************************************************
* File (cc_ff_1314_1920.F) is created on Tue Aug  9 22:35:35 MSD 2011.
************************************************************************
* This is the FORTRAN module (cc_ff_1314_1920) to calculate 1-loop EW
* form factors for the anti-up + dn -> tn + ta^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ff_1314_1920 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ff_ew_ll,ff_ew_ld,ff_ew_rd

      real*8 a0fw,a0fz,a0fh,a0fta
      complex*16 b0ptazta,b0ptahta,b0ptacw
      complex*16 b0fqswz,b0fqswh,b0fqswc,b0ftawc,b0ftazta,b0ftstac,b0ft
     & scc,b0fcwta,b0ftahta,b0fqstac,b0fqscc
      complex*16 c0tacqswcz,c0tacqsztaw,c0tacqshtaw,c0tactstazc,c0tacts
     & cwc,c0tacustazc,c0ccqswcz,c0cctscwta,c0cctsczc,c0ccuscwta,c0tacqs
     & tazc,c0tacqsctaw,c0ccqsczc
      complex*16 b0d2tazta
      complex*16 d0cctacqstswczta,d0cctacqstszcwc,d0ccctaqsuswczc,d0ccc
     & taqsuszcwta
      complex*16 javsubqstsctaw,javsubqsusctaw
      real*8 sdet3ictaqs,sdet3ictats,sdet3ictaus
      real*8 invftaw
      complex*16 propwqs,propiwqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      cmw2 = mw2

      propiwqs = (cmw2+qs)
      propwqs = 1d0/propiwqs
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      a0fta = log(rtam2/thmu2) - 1d0
      b0ptazta = b0p(-rtam2,zm2,tam2)
      b0ptahta = b0p(-rtam2,hm2,tam2)
      b0ptacw = b0p(-rtam2,cm2,wm2)
      b0fqswz = b0f(qs,thmu2,wm2,zm2)
      b0fqswh = b0f(qs,thmu2,wm2,hm2)
      b0fqswc = b0f(qs,thmu2,mw2,cm2)
      b0ftawc = b0f(-rtam2,thmu2,wm2,cm2)
      b0ftazta = b0f(-rtam2,thmu2,zm2,tam2)
      b0ftstac = b0f(ts,thmu2,tam2,cm2)
      b0ftscc = b0f(ts,thmu2,cm2,cm2)
      b0fcwta = b0f(0d0,thmu2,wm2,tam2)
      b0ftahta = b0f(-rtam2,thmu2,hm2,tam2)
      b0fqstac = b0f(qs,thmu2,tam2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      c0tacqswcz = c01(-rtam2,1d-6,qs,wm2,cm2,zm2)
      c0tacqsztaw = c01(-rtam2,1d-6,qs,zm2,tam2,wm2)
      c0tacqshtaw = c01(-rtam2,1d-6,qs,hm2,tam2,wm2)
      c0tactstazc = c01(-rtam2,0d0,ts,tam2,zm2,cm2)
      c0tactscwc = c01(-rtam2,0d0,ts,cm2,wm2,cm2)
      c0tacustazc = c01(-rtam2,0d0,us,tam2,zm2,cm2)
      c0ccqswcz = c01(0d0,0d0,qs,wm2,cm2,zm2)
      c0cctscwta = c01(0d0,0d0,ts,cm2,wm2,tam2)
      c0cctsczc = c01(0d0,0d0,ts,cm2,zm2,cm2)
      c0ccuscwta = c01(0d0,0d0,us,cm2,wm2,tam2)
      c0tacqstazc = c01(-rtam2,0d0,qs,tam2,zm2,cm2)
      c0tacqsctaw = dreal(c01(-rtam2,0d0,qs,cm2,tam2,mw2))
      c0ccqsczc = c01(0d0,0d0,qs,cm2,zm2,cm2)
      b0d2tazta = b0d2(-rtam2,thmu2,zm2,tam2)
      d0cctacqstswczta =
     & d0(0d0,0d0,rtam2,0d0,-qs,-ts,rwm2,0d0,rzm2,rtam2)
      d0cctacqstszcwc =
     & d0(0d0,0d0,rtam2,0d0,-qs,-ts,rzm2,0d0,rwm2,0d0)
      d0ccctaqsuswczc =
     & d0(0d0,0d0,0d0,rtam2,-qs,-us,rwm2,0d0,rzm2,0d0)
      d0ccctaqsuszcwta =
     & d0(0d0,0d0,0d0,rtam2,-qs,-us,rzm2,0d0,rwm2,rtam2)
      javsubqstsctaw = javsub(qs,ts,cm2,tam2,mw2)
      javsubqsusctaw = javsub(qs,us,cm2,tam2,mw2)
      sdet3ictaqs = 1d0/(qs+(mta)**2)
      sdet3ictats = 1d0/(ts+(mta)**2)
      sdet3ictaus = 1d0/(us+(mta)**2)
      invftaw = 1d0/(1d0-rtam2/rwm2)

      ff_ew_ll =
     & +mta**2*(1d0/16/mw**2+1d0/8*vmata/mw**2-1d0/8*vpata/mw**2-2*sdet3
     & ictaqs**2*qta*mw**2+2*sdet3ictaqs**2*ctw**2*qta*mw**2-1d0/8*b0d2t
     & azta/ctw**2*vmata**2)
     & +mta**4*(2*sdet3ictaqs**2*qta-2*sdet3ictaqs**2*ctw**2*qta)
     & +propwqs*a0fw*(-1d0/12/ctw**2*mw**2-1d0/12*mh**2-5*mw**2+3*mw**4/
     & mh**2)
     & +propwqs*a0fz*(1d0/12/ctw**4*mw**2+3d0/2/ctw**4*mw**4/mh**2+2d0/3
     & /ctw**2*mw**2-2*mw**2)
     & +propwqs*a0fh*(-1d0/12/qs*mh**4+1d0/2*mh**2)
     & +propwqs*b0fqswz*(1d0/12/ctw**4*mw**2+4d0/3/ctw**2*mw**2-17d0/3*m
     & w**2-4*ctw**2*mw**2)
     & +propwqs*b0fqswh*(-1d0/12/qs*mh**4-1d0/3*mh**2+mw**2)
     & +propwqs*b0fqswc*(-4*mw**2+4*ctw**2*mw**2)
     & +propwqs*(1d0/ctw**4*mw**4/mh**2-1d0/6/ctw**2*mw**2-1d0/6*mh**2-6
     & 4d0/9*mw**2-mw**2*zmwzwbos+2*mw**4/mh**2)
     & +propiwqs*mta**2*(-8*qdn*qta/ts/us+8*ctw**2*qdn*qta/ts/us-4*sdet3
     & ictaqs*qdn*qta/qs-8*sdet3ictaqs*qdn*qta/ts-8*sdet3ictaqs*qdn*qta/
     & us+4*sdet3ictaqs*ctw**2*qdn*qta/qs+8*sdet3ictaqs*ctw**2*qdn*qta/t
     & s+8*sdet3ictaqs*ctw**2*qdn*qta/us+2*sdet3ictats*qdn*qta/us-2*sdet
     & 3ictats*ctw**2*qdn*qta/us)
     & +propiwqs*d0cctacqstswczta*mta**2*(1d0/4/ctw**6*vpadn*vpata/qs/us
     & *mw**4+1d0/4/ctw**6*vpadn*vpata/us**2*mw**4-1d0/4/ctw**4*vpadn*vm
     & ata/qs*mw**2-1d0/4/ctw**4*vpadn*vmata/us*mw**2-1d0/4/ctw**4*vpadn
     & *vpata/qs/us*mw**4+1d0/4/ctw**4*vpadn*vpata/qs*mw**2+1d0/2/ctw**4
     & *vpadn*vpata/us*mw**2+1d0/2/ctw**4*vpadn*vpata*ts/us**2*mw**2+1d0
     & /4/ctw**2*vpadn*vmata/qs*mw**2-1d0/4/ctw**2*vpadn*vmata/us*mw**2+
     & 1d0/4/ctw**2*vpadn*vmata*ts/us-1d0/4/ctw**2*vpadn*vpata/qs*mw**2-
     & 1d0/4/ctw**2*vpadn*vpata/us**2*mw**4+1d0/4/ctw**2*vpadn*vpata/us*
     & mw**2-1d0/4/ctw**2*vpadn*vpata+1d0/ctw**2*vpadn*vpata*ts/us**2*mw
     & **2-1d0/4/ctw**2*vpadn*vpata*ts/us-3d0/4/ctw**2*vpadn*vpata*ts**2
     & /us**2)
     & +propiwqs*d0cctacqstswczta*mta**4*(1d0/4/ctw**6*vpadn*vpata/qs/us
     & **2*mw**4-1d0/4/ctw**4*vpadn*vmata/qs/us*mw**2+1d0/4/ctw**4*vpadn
     & *vpata/qs/us*mw**2+1d0/4/ctw**2*vpadn*vmata/us+1d0/2/ctw**2*vpadn
     & *vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata/us-3d0/4/ctw**2*vpadn
     & *vpata*ts/us**2)
     & +propiwqs*d0cctacqstswczta*mta**6*(-1d0/4/ctw**2*vpadn*vpata/us**
     & 2)
     & +propiwqs*d0cctacqstswczta*(-1d0/4/ctw**6*vpadn*vpata*ts/us**2*mw
     & **4-1d0/2/ctw**4*vpadn*vpata/us*mw**4-1d0/2/ctw**4*vpadn*vpata*ts
     & /us**2*mw**4+1d0/2/ctw**4*vpadn*vpata*ts**2/us**2*mw**2-1d0/4/ctw
     & **2*vpadn*vpata*ts/us**2*mw**4-1d0/4/ctw**2*vpadn*vpata*ts+1d0/2/
     & ctw**2*vpadn*vpata*ts**2/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata*ts*
     & *3/us**2)
     & +propiwqs*d0cctacqstszcwc*mta**2*(-1d0/4/ctw**6*vpaup*vpatn/us**2
     & *mw**4-1d0/4/ctw**4*vpaup*vpatn/qs/us*mw**4-1d0/4/ctw**4*vpaup*vp
     & atn/qs*mw**2+1d0/2/ctw**4*vpaup*vpatn*ts/us**2*mw**2+1d0/4/ctw**2
     & *vpaup*vpatn/qs/us*mw**4+1d0/4/ctw**2*vpaup*vpatn/qs*mw**2+1d0/4/
     & ctw**2*vpaup*vpatn/us**2*mw**4+1d0/4/ctw**2*vpaup*vpatn/us*mw**2-
     & 1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2)
     & +propiwqs*d0cctacqstszcwc*mta**4*(1d0/4/ctw**2*vpaup*vpatn/qs/us*
     & *2*mw**4+1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2)
     & +propiwqs*d0cctacqstszcwc*(-1d0/4/ctw**6*vpaup*vpatn*ts/us**2*mw*
     & *4-1d0/2/ctw**4*vpaup*vpatn/us*mw**4-1d0/2/ctw**4*vpaup*vpatn*ts/
     & us**2*mw**4+1d0/2/ctw**4*vpaup*vpatn*ts**2/us**2*mw**2-1d0/4/ctw*
     & *2*vpaup*vpatn*ts/us**2*mw**4-1d0/4/ctw**2*vpaup*vpatn*ts+1d0/2/c
     & tw**2*vpaup*vpatn*ts**2/us**2*mw**2-1d0/4/ctw**2*vpaup*vpatn*ts**
     & 3/us**2)
     & +propiwqs*d0ccctaqsuswczc*(1d0/2/ctw**2*vpadn*vpatn*us)
     & +propiwqs*d0ccctaqsuszcwta*mta**2*(-1d0/4/ctw**4*vpaup*vmata/qs*m
     & w**2+1d0/4/ctw**2*vpaup*vmata/qs*mw**2+1d0/4/ctw**2*vpaup*vmata+1
     & d0/2/ctw**2*vpaup*vpata)
     & +propiwqs*d0ccctaqsuszcwta*mta**4*(1d0/4/ctw**2*vpaup*vmata/qs/us
     & *mw**2+1d0/4/ctw**2*vpaup*vmata/us)
     & +propiwqs*d0ccctaqsuszcwta*(1d0/2/ctw**2*vpaup*vpata*us)
     & +propiwqs*c0tacqswcz*mta**2*(2/ctw**4*vpaup*vpatn/ts/us*mw**2+1d0
     & /4/ctw**2*vpaup*vpatn/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn/us+sde
     & t3ictaqs/ctw**4*vpaup*vpatn/qs*mw**2+2*sdet3ictaqs/ctw**4*vpaup*v
     & patn/ts*mw**2+2*sdet3ictaqs/ctw**4*vpaup*vpatn/us*mw**2-1d0/2*sde
     & t3ictaqs/ctw**2*vpaup*vpatn/qs*mw**2)
     & +propiwqs*c0tacqswcz*mta**4*(1d0/4/ctw**2*vpaup*vpatn/qs/us**2*mw
     & **2+1d0/4/ctw**2*vpaup*vpatn/qs/us)
     & +propiwqs*c0tacqswcz*(-1d0/ctw**4*vpaup*vpatn/qs*mw**2-1d0/4/ctw*
     & *4*vpaup*vpatn/us*mw**2-1d0/4/ctw**4*vpaup*vpatn*ts/us**2*mw**2-1
     & d0/2/ctw**2*vpadn*vpatn+1d0/2/ctw**2*vpaup*vpatn/qs*mw**2-1d0/4/c
     & tw**2*vpaup*vpatn/us*mw**2+3d0/4/ctw**2*vpaup*vpatn-1d0/4/ctw**2*
     & vpaup*vpatn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2+2
     & *sdet3ictaqs/ctw**4*vpaup*vpatn*mw**2-1d0/2*sdet3ictaqs/ctw**2*vp
     & aup*vpatn*mw**2+1d0/2*sdet3ictaqs/ctw**2*vpaup*vpatn*us+1d0/2*sde
     & t3ictaqs/ctw**2*vpaup*vpatn*ts+sdet3ictaqs**2/ctw**4*vpaup*vpatn*
     & us*mw**2+sdet3ictaqs**2/ctw**4*vpaup*vpatn*ts*mw**2)
     & +propiwqs*c0tacqsztaw*mta**2*(1d0/4/ctw**4*vpadn*vpata/us**2*mw**
     & 2-1d0/4/ctw**2*vpadn*vmata/us+2/ctw**2*vpadn*vpata/ts/us*mw**2+1d
     & 0/2/ctw**2*vpadn*vpata/us+1d0/4/ctw**2*vpadn*vpata*ts/us**2+1d0/4
     & /ctw**2*vpaup*vmata/us-1d0/2*sdet3ictaqs/ctw**4*vpadn*vpata/qs*mw
     & **2+sdet3ictaqs/ctw**2*vpadn*vpata/qs*mw**2+2*sdet3ictaqs/ctw**2*
     & vpadn*vpata/ts*mw**2+2*sdet3ictaqs/ctw**2*vpadn*vpata/us*mw**2-sd
     & et3ictaqs/ctw**2*vpadn*vpata-sdet3ictaqs**2/ctw**2*vpadn*vpata*us
     & -sdet3ictaqs**2/ctw**2*vpadn*vpata*ts)
     & +propiwqs*c0tacqsztaw*mta**4*(1d0/4/ctw**4*vpadn*vpata/qs/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vmata/qs/us+1d0/4/ctw**2*vpadn*vpata/qs/u
     & s-2/ctw**2*vpadn*vpata/ts/us+1d0/4/ctw**2*vpaup*vmata/qs/us-2*sde
     & t3ictaqs/ctw**2*vpadn*vpata/ts-2*sdet3ictaqs/ctw**2*vpadn*vpata/u
     & s)
     & +propiwqs*c0tacqsztaw*(1d0/2/ctw**4*vpadn*vpata/qs*mw**2-1d0/4/ct
     & w**4*vpadn*vpata/us*mw**2-1d0/4/ctw**4*vpadn*vpata*ts/us**2*mw**2
     & -1d0/ctw**2*vpadn*vpata/qs*mw**2-1d0/4/ctw**2*vpadn*vpata/us*mw**
     & 2+1d0/4/ctw**2*vpadn*vpata-1d0/4/ctw**2*vpadn*vpata*ts/us**2*mw**
     & 2+1d0/4/ctw**2*vpadn*vpata*ts**2/us**2-1d0/2/ctw**2*vpaup*vpata-1
     & d0/2*sdet3ictaqs/ctw**4*vpadn*vpata*mw**2+2*sdet3ictaqs/ctw**2*vp
     & adn*vpata*mw**2+sdet3ictaqs**2/ctw**2*vpadn*vpata*us*mw**2+sdet3i
     & ctaqs**2/ctw**2*vpadn*vpata*ts*mw**2)
     & +propiwqs*c0tactstazc*mta**2*(1d0/4/ctw**4*vpadn*vpata/qs/us*mw**
     & 2-1d0/4/ctw**2*vpadn*vmata/qs+1d0/4/ctw**2*vpadn*vmata/us+1d0/4/c
     & tw**2*vpadn*vpata/qs+1d0/4/ctw**2*vpadn*vpata/us**2*mw**2-1d0/2/c
     & tw**2*vpadn*vpata*ts/us**2+1d0/2*sdet3ictats/ctw**4*vpadn*vpata/u
     & s*mw**2)
     & +propiwqs*c0tactstazc*mta**4*(-1d0/4/ctw**2*vpadn*vpata/us**2)
     & +propiwqs*c0tactstazc*(1d0/4/ctw**4*vpadn*vpata*ts/us**2*mw**2+1d
     & 0/4/ctw**2*vpadn*vpata*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpata*ts
     & /us-1d0/4/ctw**2*vpadn*vpata*ts**2/us**2)
     & +propiwqs*c0tactscwc*mta**2*(1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2
     & +1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2+1d0/4/ctw**2*vpaup*vpatn/qs
     & -1d0/4/ctw**2*vpaup*vpatn*ts/us**2+1d0/2*sdet3ictats/ctw**2*vpaup
     & *vpatn/us*mw**2)
     & +propiwqs*c0tactscwc*(1d0/4/ctw**4*vpaup*vpatn*ts/us**2*mw**2+1d0
     & /4/ctw**2*vpaup*vpatn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn*ts/
     & us-1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2)
     & +propiwqs*c0tacustazc*mta**2*(-1d0/4/ctw**2*vpaup*vmata/qs)
     & +propiwqs*c0tacustazc*mta**4*(-1d0/4/ctw**2*vpaup*vmata/qs/us)
     & +propiwqs*c0ccqswcz*mta**2*(-1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2
     & -1d0/4/ctw**2*vpadn*vmata/us-1d0/4/ctw**2*vpadn*vpata/us**2*mw**2
     & +1d0/4/ctw**2*vpadn*vpata/us+1d0/2/ctw**2*vpadn*vpata*ts/us**2-1d
     & 0/4/ctw**2*vpaup*vmata/us+1d0/4/ctw**2*vpaup*vpatn*ts/us**2)
     & +propiwqs*c0ccqswcz*mta**4*(1d0/4/ctw**2*vpadn*vpata/us**2)
     & +propiwqs*c0ccqswcz*(-1d0/4/ctw**4*vpadn*vpata/us*mw**2-1d0/4/ctw
     & **4*vpadn*vpata*ts/us**2*mw**2-1d0/4/ctw**4*vpaup*vpatn/us*mw**2-
     & 1d0/4/ctw**4*vpaup*vpatn*ts/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata/
     & us*mw**2+1d0/4/ctw**2*vpadn*vpata-1d0/4/ctw**2*vpadn*vpata*ts/us*
     & *2*mw**2+1d0/4/ctw**2*vpadn*vpata*ts**2/us**2-1d0/2/ctw**2*vpadn*
     & vpatn-1d0/2/ctw**2*vpaup*vpata-1d0/4/ctw**2*vpaup*vpatn/us*mw**2+
     & 1d0/4/ctw**2*vpaup*vpatn-1d0/4/ctw**2*vpaup*vpatn*ts/us**2*mw**2+
     & 1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2)
     & +propiwqs*c0cctscwta*mta**2*(-1d0/4/ctw**4*vpadn*vpata/qs/us*mw**
     & 2-1d0/4/ctw**4*vpadn*vpata/us**2*mw**2+1d0/4/ctw**2*vpadn*vmata/q
     & s+1d0/4/ctw**2*vpadn*vmata/us-1d0/4/ctw**2*vpadn*vpata/qs-1d0/4/c
     & tw**2*vpadn*vpata/us-1d0/4/ctw**2*vpadn*vpata*ts/us**2-qdn*qta*ts
     & /us**2+ctw**2*qdn*qta*ts/us**2)
     & +propiwqs*c0cctscwta*mta**4*(-1d0/4/ctw**4*vpadn*vpata/qs/us**2*m
     & w**2+1d0/4/ctw**2*vpadn*vmata/qs/us-1d0/4/ctw**2*vpadn*vpata/qs/u
     & s)
     & +propiwqs*c0cctscwta*(1d0/4/ctw**4*vpadn*vpata*ts/us**2*mw**2+1d0
     & /4/ctw**2*vpadn*vpata*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpata*ts/
     & us-1d0/4/ctw**2*vpadn*vpata*ts**2/us**2+qdn*qta*ts/us**2*mw**2+qd
     & n*qta*ts/us-qdn*qta*ts**2/us**2-ctw**2*qdn*qta*ts/us**2*mw**2-ctw
     & **2*qdn*qta*ts/us+ctw**2*qdn*qta*ts**2/us**2)
     & +propiwqs*c0cctsczc*mta**2*(-1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2
     & -1d0/4/ctw**2*vpaup*vpatn/qs-1d0/4/ctw**2*vpaup*vpatn/us**2*mw**2
     & -1d0/4/ctw**2*vpaup*vpatn/us)
     & +propiwqs*c0cctsczc*mta**4*(-1d0/4/ctw**2*vpaup*vpatn/qs/us**2*mw
     & **2-1d0/4/ctw**2*vpaup*vpatn/qs/us)
     & +propiwqs*c0cctsczc*(1d0/4/ctw**4*vpaup*vpatn*ts/us**2*mw**2+1d0/
     & 4/ctw**2*vpaup*vpatn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn*ts/u
     & s-1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2)
     & +propiwqs*c0ccuscwta*mta**2*(1d0/4/ctw**2*vpaup*vmata/qs+qup*qta/
     & qs-ctw**2*qup*qta/qs)
     & +propiwqs*a0fw*(-4/qs+3/qs*mw**2/mh**2)
     & +propiwqs*a0fz*mta**2*(-1d0/2*sdet3ictaqs/ctw**2*vpaup*vpatn/qs)
     & +propiwqs*a0fz*(3d0/2/ctw**4/qs*mw**2/mh**2+1d0/2/ctw**2*vpaup*vp
     & atn/qs-1d0/2*sdet3ictaqs/ctw**2*vpaup*vpatn)
     & +propiwqs*a0fta*mta**2*(8*stw**2*qdn*qta/ts/us+8*sdet3ictaqs*stw*
     & *2*qdn*qta/ts+8*sdet3ictaqs*stw**2*qdn*qta/us-2*sdet3ictats*stw**
     & 2*qdn*qta/us)
     & +propiwqs*b0ftawc*mta**2*(-2/ctw**2*vpaup*vpatn/ts/us-sdet3ictaqs
     & /ctw**2*vpaup*vpatn/qs-2*sdet3ictaqs/ctw**2*vpaup*vpatn/ts-2*sdet
     & 3ictaqs/ctw**2*vpaup*vpatn/us+1d0/2*sdet3ictats/ctw**2*vpaup*vpat
     & n/us)
     & +propiwqs*b0ftawc*(1d0/ctw**2*vpaup*vpatn/qs-2*sdet3ictaqs/ctw**2
     & *vpaup*vpatn-sdet3ictaqs**2/ctw**2*vpaup*vpatn*us-sdet3ictaqs**2/
     & ctw**2*vpaup*vpatn*ts)
     & +propiwqs*b0ftazta*mta**2*(-2/ctw**2*vpadn*vpata/ts/us-sdet3ictaq
     & s/ctw**2*vpadn*vpata/qs-2*sdet3ictaqs/ctw**2*vpadn*vpata/ts-2*sde
     & t3ictaqs/ctw**2*vpadn*vpata/us+1d0/2*sdet3ictats/ctw**2*vpadn*vpa
     & ta/us)
     & +propiwqs*b0ftazta*(1d0/ctw**2*vpadn*vpata/qs-2*sdet3ictaqs/ctw**
     & 2*vpadn*vpata-sdet3ictaqs**2/ctw**2*vpadn*vpata*us-sdet3ictaqs**2
     & /ctw**2*vpadn*vpata*ts)
     & +propiwqs*b0fqswz*mta**2*(2/ctw**2*vpadn*vpata/ts/us+2/ctw**2*vpa
     & up*vpatn/ts/us+1d0/2*sdet3ictaqs/ctw**2*vpadn*vpata/qs+2*sdet3ict
     & aqs/ctw**2*vpadn*vpata/ts+2*sdet3ictaqs/ctw**2*vpadn*vpata/us+1d0
     & /2*sdet3ictaqs/ctw**2*vpaup*vpatn/qs+2*sdet3ictaqs/ctw**2*vpaup*v
     & patn/ts+2*sdet3ictaqs/ctw**2*vpaup*vpatn/us)
     & +propiwqs*b0fqswz*(5d0/6/ctw**2/qs-1d0/2/ctw**2*vpadn*vpata/qs-1d
     & 0/2/ctw**2*vpadn*vpata/us-1d0/2/ctw**2*vpaup*vpatn/qs-1d0/2/ctw**
     & 2*vpaup*vpatn/us-53d0/12/qs-14d0/3*ctw**2/qs+3d0/2*sdet3ictaqs/ct
     & w**2*vpadn*vpata+3d0/2*sdet3ictaqs/ctw**2*vpaup*vpatn+sdet3ictaqs
     & **2/ctw**2*vpadn*vpata*us+sdet3ictaqs**2/ctw**2*vpadn*vpata*ts+sd
     & et3ictaqs**2/ctw**2*vpaup*vpatn*us+sdet3ictaqs**2/ctw**2*vpaup*vp
     & atn*ts)
     & +propiwqs*b0fqswh*(11d0/12/qs)
     & +propiwqs*b0fqswc*mta**2*(8*qdn*qta/ts/us-8*ctw**2*qdn*qta/ts/us+
     & 2*sdet3ictaqs*qdn*qta/qs+8*sdet3ictaqs*qdn*qta/ts+8*sdet3ictaqs*q
     & dn*qta/us-2*sdet3ictaqs*ctw**2*qdn*qta/qs-8*sdet3ictaqs*ctw**2*qd
     & n*qta/ts-8*sdet3ictaqs*ctw**2*qdn*qta/us)
     & +propiwqs*b0fqswc*(-14d0/3/qs-2*qdn*qta/qs-2*qdn*qta/us+14d0/3*ct
     & w**2/qs+2*ctw**2*qdn*qta/qs+2*ctw**2*qdn*qta/us+6*sdet3ictaqs*qdn
     & *qta-6*sdet3ictaqs*ctw**2*qdn*qta+4*sdet3ictaqs**2*qdn*qta*us+4*s
     & det3ictaqs**2*qdn*qta*ts-4*sdet3ictaqs**2*ctw**2*qdn*qta*us-4*sde
     & t3ictaqs**2*ctw**2*qdn*qta*ts)
     & +propiwqs*b0ftstac*mta**2*(-1d0/2*sdet3ictats/ctw**2*vpadn*vpata/
     & us-2*sdet3ictats*qdn*qta/us+2*sdet3ictats*ctw**2*qdn*qta/us)
     & +propiwqs*b0ftstac*(1d0/2/ctw**2*vpadn*vpata/us+2*qdn*qta/us-2*ct
     & w**2*qdn*qta/us)
     & +propiwqs*b0ftscc*mta**2*(-1d0/2*sdet3ictats/ctw**2*vpaup*vpatn/u
     & s)
     & +propiwqs*b0ftscc*(1d0/2/ctw**2*vpaup*vpatn/us)
     & +propiwqs*b0fcwta*mta**2*(1d0/2*sdet3ictaqs/ctw**2*vpadn*vpata/qs
     & +2*sdet3ictaqs*qdn*qta/qs-2*sdet3ictaqs*ctw**2*qdn*qta/qs)
     & +propiwqs*b0fcwta*(-1d0/2/ctw**2*vpadn*vpata/qs-2*qdn*qta/qs+2*ct
     & w**2*qdn*qta/qs+1d0/2*sdet3ictaqs/ctw**2*vpadn*vpata+2*sdet3ictaq
     & s*qdn*qta-2*sdet3ictaqs*ctw**2*qdn*qta)
     & +propiwqs*(1d0/ctw**4/qs*mw**2/mh**2-1d0/6/ctw**2/qs-64d0/9/qs+2/
     & qs*mw**2/mh**2+4*qdn*qta/qs-4*ctw**2*qdn*qta/qs-8*sdet3ictaqs*qdn
     & *qta+8*sdet3ictaqs*ctw**2*qdn*qta-4*sdet3ictaqs**2*qdn*qta*us-4*s
     & det3ictaqs**2*qdn*qta*ts+4*sdet3ictaqs**2*ctw**2*qdn*qta*us+4*sde
     & t3ictaqs**2*ctw**2*qdn*qta*ts)
     & +javsubqstsctaw*mta**2*(qdn*qta/us**2*mw**4+qdn*qta-4*qdn*qta*ts/
     & us**2*mw**2+3*qdn*qta*ts**2/us**2-ctw**2*qdn*qta/us**2*mw**4-ctw*
     & *2*qdn*qta+4*ctw**2*qdn*qta*ts/us**2*mw**2-3*ctw**2*qdn*qta*ts**2
     & /us**2)
     & +javsubqstsctaw*mta**4*(-2*qdn*qta/us**2*mw**2+3*qdn*qta*ts/us**2
     & +2*ctw**2*qdn*qta/us**2*mw**2-3*ctw**2*qdn*qta*ts/us**2)
     & +javsubqstsctaw*mta**6*(qdn*qta/us**2-ctw**2*qdn*qta/us**2)
     & +javsubqstsctaw*(qdn*qta*ts/us**2*mw**4+qdn*qta*ts-2*qdn*qta*ts**
     & 2/us**2*mw**2+qdn*qta*ts**3/us**2-ctw**2*qdn*qta*ts/us**2*mw**4-c
     & tw**2*qdn*qta*ts+2*ctw**2*qdn*qta*ts**2/us**2*mw**2-ctw**2*qdn*qt
     & a*ts**3/us**2)
     & +javsubqsusctaw*mta**2*(-qup*qta/qs*mw**2-3*qup*qta+ctw**2*qup*qt
     & a/qs*mw**2+3*ctw**2*qup*qta)
     & +javsubqsusctaw*mta**4*(-qup*qta/qs/us*mw**2-qup*qta/us+ctw**2*qu
     & p*qta/qs/us*mw**2+ctw**2*qup*qta/us)
     & +javsubqsusctaw*(-2*qup*qta*us+2*ctw**2*qup*qta*us)
     & +c0tacqswcz*mta**2*(vpatn+1d0/2*sdet3ictaqs/ctw**4*vpatn*mw**2-sd
     & et3ictaqs**2/ctw**4*vpatn*mw**4)
     & +c0tacqswcz*(-1d0/ctw**2*vpatn*mw**2-vpatn*mw**2+sdet3ictaqs/ctw*
     & *2*vpatn*mw**4)
     & +c0tacqsztaw*mta**2*(-1d0/2/ctw**2*vpata+3d0/2*vmata-1d0/2*vpata-
     & 1d0/4*sdet3ictaqs/ctw**2*vmata*mw**2+3d0/4*sdet3ictaqs/ctw**2*vpa
     & ta*mw**2+1d0/2*sdet3ictaqs*vmata*mw**2+1d0/2*sdet3ictaqs*vpata*mw
     & **2+sdet3ictaqs**2*vpata*mw**4)
     & +c0tacqsztaw*mta**4*(-1d0/4*vmata/mw**2+1d0/4*vpata/mw**2+1d0/4*s
     & det3ictaqs/ctw**2*vmata+1d0/4*sdet3ictaqs/ctw**2*vpata-sdet3ictaq
     & s*vmata-1d0/4*sdet3ictaqs**2*vmata*mw**2-7d0/4*sdet3ictaqs**2*vpa
     & ta*mw**2)
     & +c0tacqsztaw*mta**6*(1d0/2*sdet3ictaqs*vmata/mw**2-1d0/2*sdet3ict
     & aqs*vpata/mw**2+1d0/2*sdet3ictaqs**2*vmata+1d0/2*sdet3ictaqs**2*v
     & pata)
     & +c0tacqsztaw*mta**8*(-1d0/4*sdet3ictaqs**2*vmata/mw**2+1d0/4*sdet
     & 3ictaqs**2*vpata/mw**2)
     & +c0tacqsztaw*(1d0/ctw**2*vpata*mw**2+vpata*mw**2-sdet3ictaqs/ctw*
     & *2*vpata*mw**4)
     & +c0tacqshtaw*mta**2*(1d0/2+1d0/4*sdet3ictaqs*mh**2-1d0/2*sdet3ict
     & aqs*mw**2)
     & +c0tacqshtaw*mta**4*(-1d0/4/mw**2-1d0/4*sdet3ictaqs/mw**2*mh**2-1
     & d0/4*sdet3ictaqs**2*mw**2)
     & +c0tacqshtaw*mta**6*(1d0/2*sdet3ictaqs/mw**2+1d0/2*sdet3ictaqs**2
     & )
     & +c0tacqshtaw*mta**8*(-1d0/4*sdet3ictaqs**2/mw**2)
     & +c0tacqstazc*mta**2*(-1d0/2*sdet3ictaqs/ctw**4*vpatn*vpata*mw**2+
     & 1d0/2*sdet3ictaqs**2/ctw**6*vpatn*vpata*mw**4)
     & +c0tacqstazc*(1d0/ctw**4*vpatn*vpata*mw**2+1d0/2/ctw**2*vpatn*vpa
     & ta*us+1d0/2/ctw**2*vpatn*vpata*ts-1d0/2*sdet3ictaqs/ctw**6*vpatn*
     & vpata*mw**4)
     & +c0tacqsctaw*mta**2*(-stw**2/us*mw**2-2*stw**2+stw**2*ts/us-8*stw
     & **2*qdn/ts/us*mw**4-stw**2*qdn/us*mw**2+2*stw**2*qdn+stw**2*qdn*t
     & s/us-2*sdet3ictaqs*stw**2*mw**2-4*sdet3ictaqs*stw**2*qdn/qs*mw**4
     & -8*sdet3ictaqs*stw**2*qdn/ts*mw**4-8*sdet3ictaqs*stw**2*qdn/us*mw
     & **4-2*sdet3ictaqs**2*stw**2*mw**4-sdet3ictaus*stw**2*mw**2+sdet3i
     & ctaus*stw**2*ts-sdet3ictaus*stw**2*qdn*mw**2+sdet3ictaus*stw**2*q
     & dn*ts)
     & +c0tacqsctaw*mta**4*(-stw**2/qs/us*mw**2-stw**2*qdn/qs/us*mw**2+1
     & 6*stw**2*qdn/ts/us*mw**2+2*sdet3ictaqs*stw**2+16*sdet3ictaqs*stw*
     & *2*qdn/ts*mw**2+16*sdet3ictaqs*stw**2*qdn/us*mw**2+4*sdet3ictaqs*
     & *2*stw**2*mw**2-sdet3ictaus*stw**2/qs*mw**2-sdet3ictaus*stw**2/us
     & *mw**2+sdet3ictaus*stw**2*ts/us-sdet3ictaus*stw**2*qdn/qs*mw**2-s
     & det3ictaus*stw**2*qdn/us*mw**2+sdet3ictaus*stw**2*qdn*ts/us)
     & +c0tacqsctaw*mta**6*(-8*stw**2*qdn/ts/us-8*sdet3ictaqs*stw**2*qdn
     & /ts-8*sdet3ictaqs*stw**2*qdn/us-2*sdet3ictaqs**2*stw**2-sdet3icta
     & us*stw**2/qs/us*mw**2-sdet3ictaus*stw**2*qdn/qs/us*mw**2)
     & +c0tacqsctaw*(4*stw**2*qdn/qs*mw**4-4*sdet3ictaqs*stw**2*qdn*mw**
     & 4)
     & +c0ccqswcz*(-1d0/ctw**2*vpadn/qs*mw**4+1d0/ctw**2*vpadn*mw**2+1d0
     & /ctw**2*vpaup/qs*mw**4-1d0/ctw**2*vpaup*mw**2+vpadn*mw**2-vpaup*m
     & w**2)
     & +c0ccqsczc*mta**2*(1d0/2/ctw**2*vpaup*vpadn)
     & +c0ccqsczc*(-1d0/2/ctw**6*vpaup*vpadn/qs*mw**4+1d0/ctw**4*vpaup*v
     & padn*mw**2+1d0/2/ctw**2*vpaup*vpadn*us+1d0/2/ctw**2*vpaup*vpadn*t
     & s)
     & +c0cctscwta*mta**2*(qdn*qta/us**2*mw**4+qdn*qta-4*qdn*qta*ts/us**
     & 2*mw**2+3*qdn*qta*ts**2/us**2-ctw**2*qdn*qta/us**2*mw**4-ctw**2*q
     & dn*qta+4*ctw**2*qdn*qta*ts/us**2*mw**2-3*ctw**2*qdn*qta*ts**2/us*
     & *2)
     & +c0cctscwta*mta**4*(-2*qdn*qta/us**2*mw**2+3*qdn*qta*ts/us**2+2*c
     & tw**2*qdn*qta/us**2*mw**2-3*ctw**2*qdn*qta*ts/us**2)
     & +c0cctscwta*mta**6*(qdn*qta/us**2-ctw**2*qdn*qta/us**2)
     & +c0cctscwta*(qdn*qta*ts/us**2*mw**4+qdn*qta*ts-2*qdn*qta*ts**2/us
     & **2*mw**2+qdn*qta*ts**3/us**2-ctw**2*qdn*qta*ts/us**2*mw**4-ctw**
     & 2*qdn*qta*ts+2*ctw**2*qdn*qta*ts**2/us**2*mw**2-ctw**2*qdn*qta*ts
     & **3/us**2)
     & +c0ccuscwta*mta**2*(-qup*qta/qs*mw**2-3*qup*qta+ctw**2*qup*qta/qs
     & *mw**2+3*ctw**2*qup*qta)
     & +c0ccuscwta*mta**4*(-qup*qta/qs/us*mw**2-qup*qta/us+ctw**2*qup*qt
     & a/qs/us*mw**2+ctw**2*qup*qta/us)
     & +c0ccuscwta*(-2*qup*qta*us+2*ctw**2*qup*qta*us)
     & +a0fw*mta**2*(1d0/8*sdet3ictaqs+1d0/8*sdet3ictaqs*vmata-1d0/8*sde
     & t3ictaqs*vpata)
     & +a0fw*(65d0/8+1d0/12/ctw**2/qs*mw**2+1d0/12/qs*mh**2+23d0/6/qs*mw
     & **2-3/qs*mw**4/mh**2-3*mw**2/mh**2-1d0/2*vpadn/qs*mw**2+vpadn+1d0
     & /2*vpaup/qs*mw**2-vpaup-qdn/qs*mw**2+2*qdn+qup/qs*mw**2-2*qup+ctw
     & **2*qdn/qs*mw**2-2*ctw**2*qdn-ctw**2*qup/qs*mw**2+2*ctw**2*qup-1d
     & 0/2*sdet3ictaqs*vpata*mw**2-sdet3ictaqs*qta*mw**2+sdet3ictaqs*ctw
     & **2*qta*mw**2+7d0/8*invftaw+invftaw*vpata+2*invftaw*qta-2*invftaw
     & *ctw**2*qta-3d0/8*invftaw**2)
     & +a0fz*(-1d0/12/ctw**4/qs*mw**2-3d0/2/ctw**4/qs*mw**4/mh**2-3d0/2/
     & ctw**4*mw**2/mh**2+1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-7d0/12/ctw**
     & 2/qs*mw**2+1d0/16/ctw**2*vmata**2+1d0/8/ctw**2*vpata*vmata-1d0/16
     & /ctw**2*vpata**2-1d0/2/ctw**2*vpatn*vpata+1d0/8/ctw**2*vpatn**2-1
     & d0/2/ctw**2*vpadn/qs*mw**2+1d0/8/ctw**2*vpadn**2+1d0/2/ctw**2*vpa
     & up/qs*mw**2-1d0/ctw**2*vpaup*vpadn+1d0/8/ctw**2*vpaup**2+2d0/3/qs
     & *mw**2-vpatn+vpadn-vpaup+1d0/4*sdet3ictaqs/ctw**4*vpatn*vpata*mw*
     & *2+1d0/2*sdet3ictaqs/ctw**2*vpatn*mw**2)
     & +a0fh*(1d0/12/qs*mh**2-1d0/16/mw**2*mh**2)
     & +a0fta*mta**2*(3d0/16/mw**2-1d0/8*vpata*vmata/mw**2+1d0/16*vpata*
     & *2/mw**2+1d0/4*stw**4*qta**2/mw**2+1d0/2*sdet3ictaqs*vpata+sdet3i
     & ctaqs*stw**2*qta+2*sdet3ictaqs**2*stw**2*qta*mw**2-7d0/8*invftaw/
     & mw**2-invftaw*vpata/mw**2-2*invftaw*stw**2*qta/mw**2+3d0/8*invfta
     & w**2/mw**2)
     & +a0fta*mta**4*(-1d0/8*sdet3ictaqs/mw**2-1d0/8*sdet3ictaqs*vmata/m
     & w**2+1d0/8*sdet3ictaqs*vpata/mw**2-2*sdet3ictaqs**2*stw**2*qta)
     & +a0fta*(-3d0/8+3d0/8*invftaw)
     & +b0ftawc*mta**2*(-1d0/2*sdet3ictaqs/ctw**2*vpatn-1d0/2*sdet3ictaq
     & s*vpatn+sdet3ictaqs**2/ctw**2*vpatn*mw**2)
     & +b0ftawc*(-3d0/8+vpatn-1d0/2*sdet3ictaqs*vpatn*mw**2)
     & +b0ftazta*mta**2*(3d0/8*sdet3ictaqs/ctw**2*vmata+1d0/8*sdet3ictaq
     & s/ctw**2*vpata-1d0/2*sdet3ictaqs/ctw**2*vpatn*vpata-1d0/2*sdet3ic
     & taqs*vmata+1d0/2*sdet3ictaqs*vpata+1d0/2*sdet3ictaqs**2/ctw**4*vp
     & atn*vpata*mw**2-sdet3ictaqs**2*vpata*mw**2)
     & +b0ftazta*mta**4*(1d0/4*sdet3ictaqs*vmata/mw**2-1d0/4*sdet3ictaqs
     & *vpata/mw**2+1d0/4*sdet3ictaqs**2*vmata+3d0/4*sdet3ictaqs**2*vpat
     & a)
     & +b0ftazta*mta**6*(-1d0/4*sdet3ictaqs**2*vmata/mw**2+1d0/4*sdet3ic
     & taqs**2*vpata/mw**2)
     & +b0ftazta*(1d0/16/ctw**2*vmata**2+1d0/8/ctw**2*vpata*vmata-3d0/16
     & /ctw**2*vpata**2+1d0/2/ctw**2*vpatn*vpata-vpata-1d0/4*sdet3ictaqs
     & /ctw**4*vpatn*vpata*mw**2+1d0/2*sdet3ictaqs/ctw**2*vpata*mw**2)
     & +b0ftahta*mta**2*(1d0/2*sdet3ictaqs-1d0/8*sdet3ictaqs/mw**2*mh**2
     & )
     & +b0ftahta*mta**4*(1d0/4*sdet3ictaqs/mw**2+1d0/4*sdet3ictaqs**2)
     & +b0ftahta*mta**6*(-1d0/4*sdet3ictaqs**2/mw**2)
     & +b0ftahta*(-1d0/16/mw**2*mh**2)
     & +b0fqswz*mta**2*(1d0/8*vmata/mw**2-1d0/8*vpata/mw**2-3d0/8*sdet3i
     & ctaqs/ctw**2*vmata-1d0/8*sdet3ictaqs/ctw**2*vpata+1d0/2*sdet3icta
     & qs/ctw**2*vpatn+5d0/8*sdet3ictaqs*vmata-1d0/8*sdet3ictaqs*vpata+1
     & d0/2*sdet3ictaqs*vpatn-sdet3ictaqs**2/ctw**2*vpatn*mw**2+sdet3ict
     & aqs**2*vpata*mw**2)
     & +b0fqswz*mta**4*(-3d0/8*sdet3ictaqs*vmata/mw**2+3d0/8*sdet3ictaqs
     & *vpata/mw**2-1d0/4*sdet3ictaqs**2*vmata-3d0/4*sdet3ictaqs**2*vpat
     & a)
     & +b0fqswz*mta**6*(1d0/4*sdet3ictaqs**2*vmata/mw**2-1d0/4*sdet3icta
     & qs**2*vpata/mw**2)
     & +b0fqswz*(13d0/3-1d0/12/ctw**4/qs*mw**2-4d0/3/ctw**2/qs*mw**2-5d0
     & /6/ctw**2-1d0/2/ctw**2*vpadn/qs*mw**2+1d0/2/ctw**2*vpaup/qs*mw**2
     & +17d0/3/qs*mw**2+1d0/2*vpata-1d0/2*vpatn-1d0/2*vpadn/qs*mw**2+1d0
     & /2*vpadn+1d0/2*vpaup/qs*mw**2-1d0/2*vpaup+4*ctw**2/qs*mw**2+8*ctw
     & **2-1d0/2*sdet3ictaqs/ctw**2*vpata*mw**2+1d0/2*sdet3ictaqs/ctw**2
     & *vpatn*mw**2-1d0/2*sdet3ictaqs*vpata*mw**2+1d0/2*sdet3ictaqs*vpat
     & n*mw**2)
     & +b0fqswh*mta**2*(1d0/8/mw**2-3d0/8*sdet3ictaqs+1d0/8*sdet3ictaqs/
     & mw**2*mh**2)
     & +b0fqswh*mta**4*(-3d0/8*sdet3ictaqs/mw**2-1d0/4*sdet3ictaqs**2)
     & +b0fqswh*mta**6*(1d0/4*sdet3ictaqs**2/mw**2)
     & +b0fqswh*(-1+1d0/6/qs*mh**2-1d0/qs*mw**2)
     & +b0fqswc*mta**2*(sdet3ictaqs*qta-sdet3ictaqs*ctw**2*qta+2*sdet3ic
     & taqs**2*qta*mw**2-2*sdet3ictaqs**2*ctw**2*qta*mw**2)
     & +b0fqswc*mta**4*(-2*sdet3ictaqs**2*qta+2*sdet3ictaqs**2*ctw**2*qt
     & a)
     & +b0fqswc*(8+4/qs*mw**2+qta-qdn/qs*mw**2+qdn+qup/qs*mw**2-qup-4*ct
     & w**2/qs*mw**2-8*ctw**2-ctw**2*qta+ctw**2*qdn/qs*mw**2-ctw**2*qdn-
     & ctw**2*qup/qs*mw**2+ctw**2*qup-sdet3ictaqs*qta*mw**2+sdet3ictaqs*
     & ctw**2*qta*mw**2)
     & +b0fqstac*mta**2*(1d0/2*sdet3ictaqs/ctw**2*vpatn*vpata-1d0/2*sdet
     & 3ictaqs**2/ctw**4*vpatn*vpata*mw**2)
     & +b0fqstac*(-3d0/4/ctw**2*vpatn*vpata+1d0/2*sdet3ictaqs/ctw**4*vpa
     & tn*vpata*mw**2)
     & +b0fqscc*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-3d0/4/ctw**2*vpaup*vp
     & adn-3*qup*qdn+3*ctw**2*qup*qdn)
     & +dreal(b0ptazta)*mta**2*(1d0/8/ctw**2*vmata**2-3d0/4/ctw**2*vpata
     & *vmata+1d0/8/ctw**2*vpata**2)
     & +dreal(b0ptazta)*(-1d0/8/ctw**4*vmata**2*mw**2-1d0/8/ctw**4*vpata
     & **2*mw**2)
     & +dreal(b0ptahta)*mta**2*(-1d0/8/mw**2*mh**2)
     & +dreal(b0ptahta)*mta**4*(1d0/2/mw**2)
     & +dreal(b0ptacw)*mta**2*(1d0/8)
     & +dreal(b0ptacw)*mta**4*(1d0/8/mw**2)
     & +dreal(b0ptacw)*(-1d0/4*mw**2)
     & +110d0/9+1d0/stw**2*ctw**2*deltarhofer+1d0/stw**2*ctw**2*deltarho
     & bos-1d0/ctw**4/qs*mw**4/mh**2-1d0/ctw**4*mw**2/mh**2+1d0/6/ctw**2
     & /qs*mw**2+1d0/6/ctw**2-1d0/16/ctw**2*vmata**2+1d0/8/ctw**2*vpata*
     & *2-1d0/2/ctw**2*vpatn*vpata+3d0/16/ctw**2*vpatn**2+3d0/16/ctw**2*
     & vpadn**2-1d0/2/ctw**2*vpaup*vpadn+3d0/16/ctw**2*vpaup**2+64d0/9/q
     & s*mw**2-2/qs*mw**4/mh**2+caldwfer-za1fer-za1bos-2*mw**2/mh**2-2*q
     & ta-3d0/2*qta**2-2*qdn-3d0/2*qdn**2+2*qup+2*qup*qdn-3d0/2*qup**2+2
     & *ctw**2*qta+3d0/2*ctw**2*qta**2+2*ctw**2*qdn+3d0/2*ctw**2*qdn**2-
     & 2*ctw**2*qup-2*ctw**2*qup*qdn+3d0/2*ctw**2*qup**2+3d0/8*invftaw

      ff_ew_ld =
     & +mta*(-1d0/4*sdet3ictaqs/ctw**2*vpatn*vpata-1d0/2*sdet3ictaqs*vpa
     & ta+1d0/2*sdet3ictaqs*vpatn-sdet3ictaqs*qta+sdet3ictaqs*ctw**2*qta
     & +2*sdet3ictaqs**2*qta*mw**2-2*sdet3ictaqs**2*ctw**2*qta*mw**2)
     & +mta**3*(1d0/8*sdet3ictaqs/mw**2+1d0/8*sdet3ictaqs*vmata/mw**2-1d
     & 0/8*sdet3ictaqs*vpata/mw**2-8*sdet3ictaqs**2*qta+8*sdet3ictaqs**2
     & *ctw**2*qta-6*sdet3ictaqs**3*qta*mw**2+6*sdet3ictaqs**3*ctw**2*qt
     & a*mw**2)
     & +mta**5*(6*sdet3ictaqs**3*qta-6*sdet3ictaqs**3*ctw**2*qta)
     & +propiwqs*mta*(-qdn*qta/ts/us+ctw**2*qdn*qta/ts/us-sdet3ictaqs*qd
     & n*qta/ts+sdet3ictaqs*qdn*qta/us+sdet3ictaqs*ctw**2*qdn*qta/ts-sde
     & t3ictaqs*ctw**2*qdn*qta/us+2*sdet3ictats*qdn*qta/us-2*sdet3ictats
     & *ctw**2*qdn*qta/us)
     & +propiwqs*d0cctacqstswczta*mta*(1d0/4/ctw**6*vpadn*vpata/qs/us*mw
     & **4+1d0/4/ctw**6*vpadn*vpata/us**2*mw**4-1d0/4/ctw**4*vpadn*vmata
     & /qs*mw**2-1d0/4/ctw**4*vpadn*vmata/us*mw**2-1d0/4/ctw**4*vpadn*vp
     & ata/qs/us*mw**4+1d0/4/ctw**4*vpadn*vpata/qs*mw**2+1d0/2/ctw**4*vp
     & adn*vpata/us**2*mw**4+1d0/4/ctw**4*vpadn*vpata/us*mw**2-1d0/2/ctw
     & **4*vpadn*vpata*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vmata/qs*mw**2-
     & 1d0/4/ctw**2*vpadn*vmata/us*mw**2+1d0/4/ctw**2*vpadn*vmata*ts/us-
     & 1d0/4/ctw**2*vpadn*vpata/qs*mw**2+1d0/4/ctw**2*vpadn*vpata/us**2*
     & mw**4-1d0/2/ctw**2*vpadn*vpata*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*
     & vpata*ts**2/us**2)
     & +propiwqs*d0cctacqstswczta*mta**3*(1d0/4/ctw**6*vpadn*vpata/qs/us
     & **2*mw**4-1d0/4/ctw**4*vpadn*vmata/qs/us*mw**2+1d0/4/ctw**4*vpadn
     & *vpata/qs/us*mw**2-1d0/2/ctw**4*vpadn*vpata/us**2*mw**2+1d0/4/ctw
     & **2*vpadn*vmata/us+1d0/4/ctw**2*vpadn*vpata/ts/us**2*mw**4-1d0/4/
     & ctw**2*vpadn*vpata/ts/us*mw**2-1d0/ctw**2*vpadn*vpata/us**2*mw**2
     & +1d0/4/ctw**2*vpadn*vpata/us+3d0/4/ctw**2*vpadn*vpata*ts/us**2)
     & +propiwqs*d0cctacqstswczta*mta**5*(-1d0/2/ctw**2*vpadn*vpata/ts/u
     & s**2*mw**2+1d0/4/ctw**2*vpadn*vpata/ts/us+3d0/4/ctw**2*vpadn*vpat
     & a/us**2)
     & +propiwqs*d0cctacqstswczta*mta**7*(1d0/4/ctw**2*vpadn*vpata/ts/us
     & **2)
     & +propiwqs*d0cctacqstszcwc*mta*(1d0/4/ctw**6*vpaup*vpatn/us**2*mw*
     & *4-1d0/4/ctw**4*vpaup*vpatn/qs/us*mw**4-1d0/4/ctw**4*vpaup*vpatn/
     & qs*mw**2+1d0/2/ctw**4*vpaup*vpatn/us**2*mw**4-1d0/2/ctw**4*vpaup*
     & vpatn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**4+1d0/4/c
     & tw**2*vpaup*vpatn/qs*mw**2+1d0/4/ctw**2*vpaup*vpatn/us**2*mw**4+1
     & d0/4/ctw**2*vpaup*vpatn/us*mw**2-1d0/2/ctw**2*vpaup*vpatn*ts/us**
     & 2*mw**2+1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2)
     & +propiwqs*d0cctacqstszcwc*mta**3*(1d0/4/ctw**6*vpaup*vpatn/ts/us*
     & *2*mw**4-1d0/2/ctw**4*vpaup*vpatn/us**2*mw**2+1d0/4/ctw**2*vpaup*
     & vpatn/qs/us**2*mw**4+1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2+1d0/4/c
     & tw**2*vpaup*vpatn*ts/us**2)
     & +propiwqs*d0ccctaqsuszcwta*mta*(-1d0/4/ctw**4*vpaup*vmata/qs*mw**
     & 2+1d0/4/ctw**4*vpaup*vmata/ts*mw**2+1d0/4/ctw**2*vpaup*vmata/qs*m
     & w**2+1d0/4/ctw**2*vpaup*vmata/ts*mw**2-1d0/4/ctw**2*vpaup*vmata/t
     & s*us)
     & +propiwqs*d0ccctaqsuszcwta*mta**3*(1d0/4/ctw**2*vpaup*vmata/qs/us
     & *mw**2+1d0/4/ctw**2*vpaup*vmata/ts/us*mw**2-1d0/2/ctw**2*vpaup*vm
     & ata/ts)
     & +propiwqs*d0ccctaqsuszcwta*mta**5*(-1d0/4/ctw**2*vpaup*vmata/ts/u
     & s)
     & +propiwqs*c0tacqswcz*mta*(1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2+1d
     & 0/4/ctw**2*vpaup*vpatn/us**2*mw**2-1d0/4/ctw**2*vpaup*vpatn*ts/us
     & **2+1d0/4*sdet3ictaqs/ctw**4*vpaup*vpatn/ts*mw**2-1d0/4*sdet3icta
     & qs/ctw**4*vpaup*vpatn/us*mw**2)
     & +propiwqs*c0tacqswcz*mta**3*(1d0/4/ctw**2*vpaup*vpatn/qs/us**2*mw
     & **2+1d0/4/ctw**2*vpaup*vpatn/qs/us)
     & +propiwqs*c0tacqsztaw*mta*(1d0/4/ctw**4*vpadn*vpata/us**2*mw**2-1
     & d0/4/ctw**2*vpadn*vmata/us+1d0/4/ctw**2*vpadn*vpata/us**2*mw**2-1
     & d0/4/ctw**2*vpadn*vpata*ts/us**2+1d0/4/ctw**2*vpaup*vmata/ts+1d0/
     & 4*sdet3ictaqs/ctw**2*vpadn*vpata/ts*mw**2-1d0/4*sdet3ictaqs/ctw**
     & 2*vpadn*vpata/us*mw**2)
     & +propiwqs*c0tacqsztaw*mta**3*(1d0/4/ctw**4*vpadn*vpata/qs/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vmata/qs/us+1d0/4/ctw**2*vpadn*vpata/qs/u
     & s-1d0/4/ctw**2*vpadn*vpata/us**2+1d0/4/ctw**2*vpaup*vmata/qs/us-1
     & d0/4*sdet3ictaqs/ctw**2*vpadn*vpata/ts+1d0/4*sdet3ictaqs/ctw**2*v
     & padn*vpata/us)
     & +propiwqs*c0tactstazc*mta*(1d0/4/ctw**4*vpadn*vpata/qs/us*mw**2-1
     & d0/4/ctw**4*vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vmata/qs+1
     & d0/4/ctw**2*vpadn*vmata/us+1d0/4/ctw**2*vpadn*vpata/qs-1d0/4/ctw*
     & *2*vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata/us+1d0/4/ctw*
     & *2*vpadn*vpata*ts/us**2+1d0/2*sdet3ictats/ctw**4*vpadn*vpata/us*m
     & w**2)
     & +propiwqs*c0tactstazc*mta**3*(-1d0/4/ctw**2*vpadn*vpata/ts/us**2*
     & mw**2+1d0/2/ctw**2*vpadn*vpata/us**2)
     & +propiwqs*c0tactstazc*mta**5*(1d0/4/ctw**2*vpadn*vpata/ts/us**2)
     & +propiwqs*c0tactscwc*mta*(-1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2+1
     & d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2+1d0/4/ctw**2*vpaup*vpatn/qs-1
     & d0/4/ctw**2*vpaup*vpatn/us**2*mw**2-1d0/4/ctw**2*vpaup*vpatn/us+1
     & d0/4/ctw**2*vpaup*vpatn*ts/us**2+1d0/2*sdet3ictats/ctw**2*vpaup*v
     & patn/us*mw**2)
     & +propiwqs*c0tactscwc*mta**3*(-1d0/4/ctw**4*vpaup*vpatn/ts/us**2*m
     & w**2+1d0/4/ctw**2*vpaup*vpatn/us**2)
     & +propiwqs*c0tacustazc*mta*(-1d0/4/ctw**2*vpaup*vmata/qs-1d0/4/ctw
     & **2*vpaup*vmata/ts)
     & +propiwqs*c0tacustazc*mta**3*(-1d0/4/ctw**2*vpaup*vmata/qs/us-1d0
     & /4/ctw**2*vpaup*vmata/ts/us)
     & +propiwqs*c0ccqswcz*mta*(1d0/4/ctw**4*vpadn*vpata/us**2*mw**2+1d0
     & /4/ctw**4*vpaup*vpatn/ts/us*mw**2+1d0/4/ctw**4*vpaup*vpatn/us**2*
     & mw**2-1d0/4/ctw**2*vpadn*vmata/us+1d0/4/ctw**2*vpadn*vpata/ts/us*
     & mw**2+1d0/4/ctw**2*vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vpa
     & ta*ts/us**2+1d0/4/ctw**2*vpaup*vmata/ts+1d0/4/ctw**2*vpaup*vpatn/
     & us**2*mw**2-1d0/4/ctw**2*vpaup*vpatn*ts/us**2)
     & +propiwqs*c0ccqswcz*mta**3*(1d0/4/ctw**4*vpaup*vpatn/ts/us**2*mw*
     & *2+1d0/4/ctw**2*vpadn*vpata/ts/us**2*mw**2-1d0/4/ctw**2*vpadn*vpa
     & ta/ts/us-1d0/2/ctw**2*vpadn*vpata/us**2+1d0/4/ctw**2*vpaup*vmata/
     & ts/us-1d0/4/ctw**2*vpaup*vpatn/us**2)
     & +propiwqs*c0ccqswcz*mta**5*(-1d0/4/ctw**2*vpadn*vpata/ts/us**2)
     & +propiwqs*c0cctscwta*mta*(-1d0/4/ctw**4*vpadn*vpata/qs/us*mw**2-1
     & d0/4/ctw**4*vpadn*vpata/us**2*mw**2+1d0/4/ctw**2*vpadn*vmata/qs+1
     & d0/4/ctw**2*vpadn*vmata/us-1d0/4/ctw**2*vpadn*vpata/qs-1d0/4/ctw*
     & *2*vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata/us+1d0/4/ctw*
     & *2*vpadn*vpata*ts/us**2-qdn*qta/us**2*mw**2+qdn*qta*ts/us**2+ctw*
     & *2*qdn*qta/us**2*mw**2-ctw**2*qdn*qta*ts/us**2)
     & +propiwqs*c0cctscwta*mta**3*(-1d0/4/ctw**4*vpadn*vpata/qs/us**2*m
     & w**2+1d0/4/ctw**2*vpadn*vmata/qs/us-1d0/4/ctw**2*vpadn*vpata/qs/u
     & s+1d0/4/ctw**2*vpadn*vpata/us**2+qdn*qta/us**2-ctw**2*qdn*qta/us*
     & *2)
     & +propiwqs*c0cctsczc*mta*(-1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2-1d
     & 0/4/ctw**2*vpaup*vpatn/qs/us*mw**2-1d0/4/ctw**2*vpaup*vpatn/qs-1d
     & 0/4/ctw**2*vpaup*vpatn/us**2*mw**2-1d0/4/ctw**2*vpaup*vpatn/us+1d
     & 0/4/ctw**2*vpaup*vpatn*ts/us**2)
     & +propiwqs*c0cctsczc*mta**3*(-1d0/4/ctw**2*vpaup*vpatn/qs/us**2*mw
     & **2-1d0/4/ctw**2*vpaup*vpatn/qs/us)
     & +propiwqs*c0ccuscwta*mta*(1d0/4/ctw**2*vpaup*vmata/qs-1d0/4/ctw**
     & 2*vpaup*vmata/ts+qup*qta/qs-qup*qta/ts-ctw**2*qup*qta/qs+ctw**2*q
     & up*qta/ts)
     & +propiwqs*a0fta*mta*(stw**2*qdn*qta/ts/us+sdet3ictaqs*stw**2*qdn*
     & qta/ts-sdet3ictaqs*stw**2*qdn*qta/us-2*sdet3ictats*stw**2*qdn*qta
     & /us)
     & +propiwqs*b0ftawc*mta*(-1d0/4/ctw**2*vpaup*vpatn/ts/us-1d0/4*sdet
     & 3ictaqs/ctw**2*vpaup*vpatn/ts+1d0/4*sdet3ictaqs/ctw**2*vpaup*vpat
     & n/us+1d0/2*sdet3ictats/ctw**2*vpaup*vpatn/us)
     & +propiwqs*b0ftazta*mta*(-1d0/4/ctw**2*vpadn*vpata/ts/us-1d0/4*sde
     & t3ictaqs/ctw**2*vpadn*vpata/ts+1d0/4*sdet3ictaqs/ctw**2*vpadn*vpa
     & ta/us+1d0/2*sdet3ictats/ctw**2*vpadn*vpata/us)
     & +propiwqs*b0fqswz*mta*(1d0/4/ctw**2*vpadn*vpata/ts/us+1d0/4/ctw**
     & 2*vpaup*vpatn/ts/us+1d0/4*sdet3ictaqs/ctw**2*vpadn*vpata/ts-1d0/4
     & *sdet3ictaqs/ctw**2*vpadn*vpata/us+1d0/4*sdet3ictaqs/ctw**2*vpaup
     & *vpatn/ts-1d0/4*sdet3ictaqs/ctw**2*vpaup*vpatn/us)
     & +propiwqs*b0fqswc*mta*(qdn*qta/ts/us-ctw**2*qdn*qta/ts/us+sdet3ic
     & taqs*qdn*qta/ts-sdet3ictaqs*qdn*qta/us-sdet3ictaqs*ctw**2*qdn*qta
     & /ts+sdet3ictaqs*ctw**2*qdn*qta/us)
     & +propiwqs*b0ftstac*mta*(-1d0/2*sdet3ictats/ctw**2*vpadn*vpata/us-
     & 2*sdet3ictats*qdn*qta/us+2*sdet3ictats*ctw**2*qdn*qta/us)
     & +propiwqs*b0ftscc*mta*(-1d0/2*sdet3ictats/ctw**2*vpaup*vpatn/us)
     & +javsubqstsctaw*mta*(-qdn*qta/us**2*mw**4+qdn*qta/us*mw**2+2*qdn*
     & qta*ts/us**2*mw**2-qdn*qta*ts/us-qdn*qta*ts**2/us**2+ctw**2*qdn*q
     & ta/us**2*mw**4-ctw**2*qdn*qta/us*mw**2-2*ctw**2*qdn*qta*ts/us**2*
     & mw**2+ctw**2*qdn*qta*ts/us+ctw**2*qdn*qta*ts**2/us**2)
     & +javsubqstsctaw*mta**3*(-qdn*qta/ts/us**2*mw**4+qdn*qta/ts/us*mw*
     & *2+4*qdn*qta/us**2*mw**2-2*qdn*qta/us-3*qdn*qta*ts/us**2+ctw**2*q
     & dn*qta/ts/us**2*mw**4-ctw**2*qdn*qta/ts/us*mw**2-4*ctw**2*qdn*qta
     & /us**2*mw**2+2*ctw**2*qdn*qta/us+3*ctw**2*qdn*qta*ts/us**2)
     & +javsubqstsctaw*mta**5*(2*qdn*qta/ts/us**2*mw**2-qdn*qta/ts/us-3*
     & qdn*qta/us**2-2*ctw**2*qdn*qta/ts/us**2*mw**2+ctw**2*qdn*qta/ts/u
     & s+3*ctw**2*qdn*qta/us**2)
     & +javsubqstsctaw*mta**7*(-qdn*qta/ts/us**2+ctw**2*qdn*qta/ts/us**2
     & )
     & +javsubqsusctaw*mta*(-qup*qta/qs*mw**2-qup*qta/ts*mw**2+qup*qta/t
     & s*us+ctw**2*qup*qta/qs*mw**2+ctw**2*qup*qta/ts*mw**2-ctw**2*qup*q
     & ta/ts*us)
     & +javsubqsusctaw*mta**3*(-qup*qta/qs/us*mw**2-qup*qta/ts/us*mw**2+
     & 2*qup*qta/ts+ctw**2*qup*qta/qs/us*mw**2+ctw**2*qup*qta/ts/us*mw**
     & 2-2*ctw**2*qup*qta/ts)
     & +javsubqsusctaw*mta**5*(qup*qta/ts/us-ctw**2*qup*qta/ts/us)
     & +c0tacqswcz*mta*(-1d0/2*sdet3ictaqs/ctw**2*vpatn*mw**2+sdet3ictaq
     & s**2/ctw**4*vpatn*mw**4+2*sdet3ictaqs**2/ctw**2*vpatn*mw**4)
     & +c0tacqswcz*mta**3*(1d0/2*sdet3ictaqs/ctw**2*vpatn+sdet3ictaqs**2
     & /ctw**4*vpatn*mw**2-2*sdet3ictaqs**2/ctw**2*vpatn*mw**2-3*sdet3ic
     & taqs**3/ctw**4*vpatn*mw**4)
     & +c0tacqsztaw*mta*(-2*sdet3ictaqs/ctw**2*vmata*mw**2+1d0/2*sdet3ic
     & taqs/ctw**2*vpata*mw**2-sdet3ictaqs*vmata*mw**2-2*sdet3ictaqs**2/
     & ctw**2*vpata*mw**4-sdet3ictaqs**2*vpata*mw**4)
     & +c0tacqsztaw*mta**3*(1d0/4*vmata/mw**2-1d0/4*vpata/mw**2+3d0/4*sd
     & et3ictaqs/ctw**2*vmata-1d0/4*sdet3ictaqs/ctw**2*vpata+9d0/2*sdet3
     & ictaqs*vmata-1d0/2*sdet3ictaqs*vpata+1d0/2*sdet3ictaqs**2/ctw**2*
     & vmata*mw**2+3d0/2*sdet3ictaqs**2/ctw**2*vpata*mw**2+13d0/4*sdet3i
     & ctaqs**2*vmata*mw**2+19d0/4*sdet3ictaqs**2*vpata*mw**2+3*sdet3ict
     & aqs**3*vpata*mw**4)
     & +c0tacqsztaw*mta**5*(-5d0/4*sdet3ictaqs*vmata/mw**2+5d0/4*sdet3ic
     & taqs*vpata/mw**2-1d0/2*sdet3ictaqs**2/ctw**2*vmata+1d0/2*sdet3ict
     & aqs**2/ctw**2*vpata-5*sdet3ictaqs**2*vmata-2*sdet3ictaqs**2*vpata
     & -3d0/4*sdet3ictaqs**3*vmata*mw**2-21d0/4*sdet3ictaqs**3*vpata*mw*
     & *2)
     & +c0tacqsztaw*mta**7*(7d0/4*sdet3ictaqs**2*vmata/mw**2-7d0/4*sdet3
     & ictaqs**2*vpata/mw**2+3d0/2*sdet3ictaqs**3*vmata+3d0/2*sdet3ictaq
     & s**3*vpata)
     & +c0tacqsztaw*mta**9*(-3d0/4*sdet3ictaqs**3*vmata/mw**2+3d0/4*sdet
     & 3ictaqs**3*vpata/mw**2)
     & +c0tacqshtaw*mta*(1d0/2*sdet3ictaqs*mh**2)
     & +c0tacqshtaw*mta**3*(-1d0/4/mw**2-sdet3ictaqs-1d0/4*sdet3ictaqs/m
     & w**2*mh**2+1d0/2*sdet3ictaqs**2*mh**2-3d0/4*sdet3ictaqs**2*mw**2)
     & 
     & +c0tacqshtaw*mta**5*(1d0/4*sdet3ictaqs/mw**2-1d0/2*sdet3ictaqs**2
     & /mw**2*mh**2-3d0/4*sdet3ictaqs**3*mw**2)
     & +c0tacqshtaw*mta**7*(3d0/4*sdet3ictaqs**2/mw**2+3d0/2*sdet3ictaqs
     & **3)
     & +c0tacqshtaw*mta**9*(-3d0/4*sdet3ictaqs**3/mw**2)
     & +c0tacqstazc*mta*(1d0/2/ctw**2*vpatn*vmata-1d0/2/ctw**2*vpatn*vpa
     & ta-sdet3ictaqs/ctw**4*vpatn*vmata*mw**2+2*sdet3ictaqs/ctw**4*vpat
     & n*vpata*mw**2-3d0/2*sdet3ictaqs**2/ctw**6*vpatn*vpata*mw**4)
     & +c0tacqstazc*mta**3*(sdet3ictaqs**2/ctw**4*vpatn*vmata*mw**2-sdet
     & 3ictaqs**2/ctw**4*vpatn*vpata*mw**2+3d0/2*sdet3ictaqs**3/ctw**6*v
     & patn*vpata*mw**4)
     & +c0tacqsctaw*mta*(-stw**2*qdn/ts*mw**2+2*sdet3ictaqs*stw**2*mw**2
     & -sdet3ictaqs*stw**2*qdn/ts*mw**4+sdet3ictaqs*stw**2*qdn/us*mw**4+
     & 2*sdet3ictaqs**2*stw**2*mw**4+sdet3ictats*stw**2*qdn/us*mw**4-sde
     & t3ictats*stw**2*qdn*mw**2)
     & +c0tacqsctaw*mta**3*(-stw**2/qs/us*mw**2-stw**2/us-stw**2*qdn/qs/
     & us*mw**2+stw**2*qdn/ts-stw**2*qdn/us-8*sdet3ictaqs*stw**2+2*sdet3
     & ictaqs*stw**2*qdn/ts*mw**2-2*sdet3ictaqs*stw**2*qdn/us*mw**2-16*s
     & det3ictaqs**2*stw**2*mw**2-6*sdet3ictaqs**3*stw**2*mw**4+sdet3ict
     & ats*stw**2*qdn/ts/us*mw**4-sdet3ictats*stw**2*qdn/ts*mw**2-2*sdet
     & 3ictats*stw**2*qdn/us*mw**2+sdet3ictats*stw**2*qdn-sdet3ictaus*st
     & w**2/qs*mw**2-sdet3ictaus*stw**2-sdet3ictaus*stw**2*qdn/qs*mw**2-
     & sdet3ictaus*stw**2*qdn)
     & +c0tacqsctaw*mta**5*(-sdet3ictaqs*stw**2*qdn/ts+sdet3ictaqs*stw**
     & 2*qdn/us+14*sdet3ictaqs**2*stw**2+12*sdet3ictaqs**3*stw**2*mw**2-
     & 2*sdet3ictats*stw**2*qdn/ts/us*mw**2+sdet3ictats*stw**2*qdn/ts+sd
     & et3ictats*stw**2*qdn/us-sdet3ictaus*stw**2/qs/us*mw**2-sdet3ictau
     & s*stw**2/us-sdet3ictaus*stw**2*qdn/qs/us*mw**2-sdet3ictaus*stw**2
     & *qdn/us)
     & +c0tacqsctaw*mta**7*(-6*sdet3ictaqs**3*stw**2+sdet3ictats*stw**2*
     & qdn/ts/us)
     & +c0cctscwta*mta*(-qdn*qta/us**2*mw**4+qdn*qta/us*mw**2+2*qdn*qta*
     & ts/us**2*mw**2-qdn*qta*ts/us-qdn*qta*ts**2/us**2+ctw**2*qdn*qta/u
     & s**2*mw**4-ctw**2*qdn*qta/us*mw**2-2*ctw**2*qdn*qta*ts/us**2*mw**
     & 2+ctw**2*qdn*qta*ts/us+ctw**2*qdn*qta*ts**2/us**2)
     & +c0cctscwta*mta**3*(-qdn*qta/ts/us**2*mw**4+qdn*qta/ts/us*mw**2+4
     & *qdn*qta/us**2*mw**2-2*qdn*qta/us-3*qdn*qta*ts/us**2+ctw**2*qdn*q
     & ta/ts/us**2*mw**4-ctw**2*qdn*qta/ts/us*mw**2-4*ctw**2*qdn*qta/us*
     & *2*mw**2+2*ctw**2*qdn*qta/us+3*ctw**2*qdn*qta*ts/us**2)
     & +c0cctscwta*mta**5*(2*qdn*qta/ts/us**2*mw**2-qdn*qta/ts/us-3*qdn*
     & qta/us**2-2*ctw**2*qdn*qta/ts/us**2*mw**2+ctw**2*qdn*qta/ts/us+3*
     & ctw**2*qdn*qta/us**2)
     & +c0cctscwta*mta**7*(-qdn*qta/ts/us**2+ctw**2*qdn*qta/ts/us**2)
     & +c0ccuscwta*mta*(-qup*qta/qs*mw**2-qup*qta/ts*mw**2+qup*qta/ts*us
     & +ctw**2*qup*qta/qs*mw**2+ctw**2*qup*qta/ts*mw**2-ctw**2*qup*qta/t
     & s*us)
     & +c0ccuscwta*mta**3*(-qup*qta/qs/us*mw**2-qup*qta/ts/us*mw**2+2*qu
     & p*qta/ts+ctw**2*qup*qta/qs/us*mw**2+ctw**2*qup*qta/ts/us*mw**2-2*
     & ctw**2*qup*qta/ts)
     & +c0ccuscwta*mta**5*(qup*qta/ts/us-ctw**2*qup*qta/ts/us)
     & +a0fw/mta*(-1d0/2*sdet3ictaqs*vpatn*mw**2)
     & +a0fw*mta*(1d0/4*sdet3ictaqs-1d0/4*sdet3ictaqs*vmata+1d0/4*sdet3i
     & ctaqs*vpata-3d0/2*sdet3ictaqs**2*vpata*mw**2-3*sdet3ictaqs**2*qta
     & *mw**2+3*sdet3ictaqs**2*ctw**2*qta*mw**2+1d0/4*sdet3ictaqs*invfta
     & w-5d0/4*sdet3ictaqs*invftaw*vmata+1d0/4*sdet3ictaqs*invftaw*vpata
     & -2*sdet3ictaqs*invftaw*qta+2*sdet3ictaqs*invftaw*ctw**2*qta)
     & +a0fw*mta**3*(3d0/8*sdet3ictaqs**2+3d0/8*sdet3ictaqs**2*vmata-3d0
     & /8*sdet3ictaqs**2*vpata)
     & +a0fz/mta*(-1d0/4*sdet3ictaqs/ctw**4*vpatn*vpata*mw**2+1d0/2*sdet
     & 3ictaqs/ctw**2*vpata*mw**2)
     & +a0fz*mta*(-1d0/8*sdet3ictaqs/ctw**2*vmata+1d0/8*sdet3ictaqs/ctw*
     & *2*vpata-1d0/2*sdet3ictaqs/ctw**2*vpatn+1d0/2*sdet3ictaqs/ctw**2*
     & vpatn*vmata-1d0/2*sdet3ictaqs/ctw**2*vpatn*vpata+3d0/4*sdet3ictaq
     & s**2/ctw**4*vpatn*vpata*mw**2+3d0/2*sdet3ictaqs**2/ctw**2*vpatn*m
     & w**2)
     & +a0fh*mta*(-1d0/8*sdet3ictaqs/mw**2*mh**2)
     & +a0fta*mta*(1d0/4*sdet3ictaqs/ctw**2*vpatn*vpata-1d0/2*sdet3ictaq
     & s*vpata-sdet3ictaqs*stw**2*qta-2*sdet3ictaqs**2*stw**2*qta*mw**2)
     & 
     & +a0fta*mta**3*(-1d0/8*sdet3ictaqs/mw**2+3d0/8*sdet3ictaqs*vmata/m
     & w**2-3d0/8*sdet3ictaqs*vpata/mw**2+3d0/2*sdet3ictaqs**2*vpata+11*
     & sdet3ictaqs**2*stw**2*qta+6*sdet3ictaqs**3*stw**2*qta*mw**2-1d0/4
     & *sdet3ictaqs*invftaw/mw**2+5d0/4*sdet3ictaqs*invftaw*vmata/mw**2-
     & 1d0/4*sdet3ictaqs*invftaw*vpata/mw**2+2*sdet3ictaqs*invftaw*stw**
     & 2*qta/mw**2)
     & +a0fta*mta**5*(-3d0/8*sdet3ictaqs**2/mw**2-3d0/8*sdet3ictaqs**2*v
     & mata/mw**2+3d0/8*sdet3ictaqs**2*vpata/mw**2-6*sdet3ictaqs**3*stw*
     & *2*qta)
     & +b0ftawc/mta*(-1d0/2*sdet3ictaqs*vpatn*mw**2)
     & +b0ftawc*mta*(1d0/2*sdet3ictaqs*vpatn-sdet3ictaqs**2/ctw**2*vpatn
     & *mw**2-1d0/2*sdet3ictaqs**2*vpatn*mw**2)
     & +b0ftawc*mta**3*(-sdet3ictaqs**2/ctw**2*vpatn+1d0/2*sdet3ictaqs**
     & 2*vpatn+3*sdet3ictaqs**3/ctw**2*vpatn*mw**2)
     & +b0ftazta/mta*(-1d0/4*sdet3ictaqs/ctw**4*vpatn*vpata*mw**2+1d0/2*
     & sdet3ictaqs/ctw**2*vpata*mw**2)
     & +b0ftazta*mta*(3d0/8*sdet3ictaqs/ctw**2*vmata+1d0/8*sdet3ictaqs/c
     & tw**2*vpata-1d0/2*sdet3ictaqs/ctw**2*vpatn*vmata+sdet3ictaqs/ctw*
     & *2*vpatn*vpata+sdet3ictaqs*vmata-sdet3ictaqs*vpata-3d0/4*sdet3ict
     & aqs**2/ctw**4*vpatn*vpata*mw**2+1d0/2*sdet3ictaqs**2/ctw**2*vpata
     & *mw**2+sdet3ictaqs**2*vpata*mw**2)
     & +b0ftazta*mta**3*(-1d0/4*sdet3ictaqs*vmata/mw**2+1d0/4*sdet3ictaq
     & s*vpata/mw**2-1d0/8*sdet3ictaqs**2/ctw**2*vmata+1d0/8*sdet3ictaqs
     & **2/ctw**2*vpata+sdet3ictaqs**2/ctw**2*vpatn*vmata-sdet3ictaqs**2
     & /ctw**2*vpatn*vpata-13d0/4*sdet3ictaqs**2*vmata-3d0/4*sdet3ictaqs
     & **2*vpata+3d0/2*sdet3ictaqs**3/ctw**4*vpatn*vpata*mw**2-3*sdet3ic
     & taqs**3*vpata*mw**2)
     & +b0ftazta*mta**5*(sdet3ictaqs**2*vmata/mw**2-sdet3ictaqs**2*vpata
     & /mw**2+3d0/4*sdet3ictaqs**3*vmata+9d0/4*sdet3ictaqs**3*vpata)
     & +b0ftazta*mta**7*(-3d0/4*sdet3ictaqs**3*vmata/mw**2+3d0/4*sdet3ic
     & taqs**3*vpata/mw**2)
     & +b0ftahta*mta*(-1d0/8*sdet3ictaqs/mw**2*mh**2)
     & +b0ftahta*mta**3*(1d0/4*sdet3ictaqs/mw**2+3d0/4*sdet3ictaqs**2-1d
     & 0/8*sdet3ictaqs**2/mw**2*mh**2)
     & +b0ftahta*mta**5*(3d0/4*sdet3ictaqs**3)
     & +b0ftahta*mta**7*(-3d0/4*sdet3ictaqs**3/mw**2)
     & +b0fqswz*mta*(-1d0/2*sdet3ictaqs/ctw**2*vmata-1d0/2*sdet3ictaqs/c
     & tw**2*vpatn-5d0/2*sdet3ictaqs*vmata+sdet3ictaqs*vpata-1d0/2*sdet3
     & ictaqs*vpatn-1d0/2*sdet3ictaqs**2/ctw**2*vpata*mw**2+5d0/2*sdet3i
     & ctaqs**2/ctw**2*vpatn*mw**2-5d0/2*sdet3ictaqs**2*vpata*mw**2+1d0/
     & 2*sdet3ictaqs**2*vpatn*mw**2)
     & +b0fqswz*mta**3*(5d0/8*sdet3ictaqs*vmata/mw**2-5d0/8*sdet3ictaqs*
     & vpata/mw**2+1d0/8*sdet3ictaqs**2/ctw**2*vmata-1d0/8*sdet3ictaqs**
     & 2/ctw**2*vpata+sdet3ictaqs**2/ctw**2*vpatn+29d0/8*sdet3ictaqs**2*
     & vmata+15d0/8*sdet3ictaqs**2*vpata-1d0/2*sdet3ictaqs**2*vpatn-3*sd
     & et3ictaqs**3/ctw**2*vpatn*mw**2+3*sdet3ictaqs**3*vpata*mw**2)
     & +b0fqswz*mta**5*(-11d0/8*sdet3ictaqs**2*vmata/mw**2+11d0/8*sdet3i
     & ctaqs**2*vpata/mw**2-3d0/4*sdet3ictaqs**3*vmata-9d0/4*sdet3ictaqs
     & **3*vpata)
     & +b0fqswz*mta**7*(3d0/4*sdet3ictaqs**3*vmata/mw**2-3d0/4*sdet3icta
     & qs**3*vpata/mw**2)
     & +b0fqswh*mta*(1d0/2*sdet3ictaqs)
     & +b0fqswh*mta**3*(-3d0/8*sdet3ictaqs/mw**2-3d0/8*sdet3ictaqs**2+1d
     & 0/8*sdet3ictaqs**2/mw**2*mh**2)
     & +b0fqswh*mta**5*(-3d0/8*sdet3ictaqs**2/mw**2-3d0/4*sdet3ictaqs**3
     & )
     & +b0fqswh*mta**7*(3d0/4*sdet3ictaqs**3/mw**2)
     & +b0fqswc*mta*(-3*sdet3ictaqs*qta+3*sdet3ictaqs*ctw**2*qta-5*sdet3
     & ictaqs**2*qta*mw**2+5*sdet3ictaqs**2*ctw**2*qta*mw**2)
     & +b0fqswc*mta**3*(11*sdet3ictaqs**2*qta-11*sdet3ictaqs**2*ctw**2*q
     & ta+6*sdet3ictaqs**3*qta*mw**2-6*sdet3ictaqs**3*ctw**2*qta*mw**2)
     & +b0fqswc*mta**5*(-6*sdet3ictaqs**3*qta+6*sdet3ictaqs**3*ctw**2*qt
     & a)
     & +b0fqstac*mta*(sdet3ictaqs/ctw**2*vpatn*vmata-5d0/4*sdet3ictaqs/c
     & tw**2*vpatn*vpata+3d0/2*sdet3ictaqs**2/ctw**4*vpatn*vpata*mw**2)
     & +b0fqstac*mta**3*(-sdet3ictaqs**2/ctw**2*vpatn*vmata+sdet3ictaqs*
     & *2/ctw**2*vpatn*vpata-3d0/2*sdet3ictaqs**3/ctw**4*vpatn*vpata*mw*
     & *2)

      ff_ew_rd =
     & 0

      ffarray(1,1) = ff_ew_ll
      ffarray(1,2) = ff_ew_ld
      ffarray(1,3) = ff_ew_rd

      return
      end
