************************************************************************
* File (nc_br_1313_1212.f) created on Mon Oct  29 17:40:27 CEST 2018.
************************************************************************
* This is the FORTRAN module (nc_ho_1313_1212) to calculate weak HO
* corrections for the up + anti-up -> el+ + el- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2018.
*
* http://sanc.jinr.ru/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ho_1313_1212 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 kappaz
      complex*16 chizs,chizsc,chizspr,chizsprc

      real*8 deltarho,deltarho1,deltarho2,ftjrrho,FTJRrho2,xt
      real*8 born0,born1,born2,cosfel
      
      cmz2 = mz2
      s = -qs
      t = -ts
      u = -us
      
      cosf = (t-u)/s
      sinf = dsqrt(1d0-cosf**2)

      cosfel = cosf

      kappaz   = gf*rzm2/(dsqrt(2d0)*8d0*pi)/alpha
      if (irun.eq.0) then
         chizs = 4d0*kappaz*s/(s-cmz2)
      else
         chizs = 4d0*kappaz*s/(s-dcmplx(mz**2,-s*wz/mz))
      endif
      chizsc   = dconjg(chizs)

      xt=sr2*gf*mtp**2/16/pi**2
      ftjrrho=FTJRrho2(mh**2/mtp**2)
      deltarho =3d0*xt*(1+ftjrrho*xt)*(1-2d0*alphas/9/pi*(pi**2+3))
      deltarho1=3*xt
      deltarho2=deltarho-deltarho1
      
      born0=0d0
      born1=0d0
      born2=0d0

      born2=
     & +deltarho**2*(+1d0/6/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*ctw2**
     & 2-1d0/3/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*stw2*ctw2**2+1d0/6/
     & pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*stw2**2*ctw2**2+1d0/12*chiz
     & s/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2*ctw2**3+1d0/12*chi
     & zs/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**2*ctw2**3+1d0/12
     & *chizs/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**2-1d
     & 0/6*chizs/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2*ctw2**3-1d0
     & /6*chizs/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2**2*ctw2**3-1
     & d0/6*chizs/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2**3*ctw2**2
     & -1d0/6*chizs/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2*ctw2**3-
     & 1d0/6*chizs/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2**2*ctw2**
     & 3-1d0/6*chizs/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2**3*ctw2
     & **2+chizs/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**2*ctw2**3+1
     & d0/3*chizs/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**2-
     & 1d0/3*chizs/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**3
     & +1d0/2*chizs*chizsc/pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**2
     & *ctw2**4+chizs*chizsc/pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2*
     & *3*ctw2**4+1d0/2*chizs*chizsc/pi*sr2**6*gf**2*ael**2*aup**2*mz**4
     & /s*stw2**4*ctw2**2+chizs*chizsc/pi*sr2**6*gf**2*ael**2*aup**2*mz*
     & *4/s*stw2**4*ctw2**3-2d0/3*chizs*chizsc/pi*sr2**6*gf**2*qup*ael**
     & 2*aup*mz**4/s*stw2**2*ctw2**4-5d0/3*chizs*chizsc/pi*sr2**6*gf**2*
     & qup*ael**2*aup*mz**4/s*stw2**3*ctw2**4-chizs*chizsc/pi*sr2**6*gf*
     & *2*qup*ael**2*aup*mz**4/s*stw2**4*ctw2**2-5d0/3*chizs*chizsc/pi*s
     & r2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**4*ctw2**3+1d0/3*chizs*ch
     & izsc/pi*sr2**6*gf**2*qup**2*ael**2*mz**4/s*stw2**2*ctw2**4+4d0/3*
     & chizs*chizsc/pi*sr2**6*gf**2*qup**2*ael**2*mz**4/s*stw2**3*ctw2**
     & 4+chizs*chizsc/pi*sr2**6*gf**2*qup**2*ael**2*mz**4/s*stw2**4*ctw2
     & **2+4d0/3*chizs*chizsc/pi*sr2**6*gf**2*qup**2*ael**2*mz**4/s*stw2
     & **4*ctw2**3-2d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel*ael*aup**2*mz*
     & *4/s*stw2**2*ctw2**4-5d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel*ael*a
     & up**2*mz**4/s*stw2**3*ctw2**4-chizs*chizsc/pi*sr2**6*gf**2*qel*ae
     & l*aup**2*mz**4/s*stw2**4*ctw2**2-5d0/3*chizs*chizsc/pi*sr2**6*gf*
     & *2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**3+2d0/3*chizs*chizsc/pi*s
     & r2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**2*ctw2**4+8d0/3*chizs*c
     & hizsc/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**4+2*c
     & hizs*chizsc/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**4*ctw2*
     & *2+8d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw
     & 2**4*ctw2**3-2*chizs*chizsc/pi*sr2**6*gf**2*qel*qup**2*ael*mz**4/
     & s*stw2**3*ctw2**4-2*chizs*chizsc/pi*sr2**6*gf**2*qel*qup**2*ael*m
     & z**4/s*stw2**4*ctw2**2-2*chizs*chizsc/pi*sr2**6*gf**2*qel*qup**2*
     & ael*mz**4/s*stw2**4*ctw2**3+1d0/3*chizs*chizsc/pi*sr2**6*gf**2*qe
     & l**2*aup**2*mz**4/s*stw2**2*ctw2**4+4d0/3*chizs*chizsc/pi*sr2**6*
     & gf**2*qel**2*aup**2*mz**4/s*stw2**3*ctw2**4+chizs*chizsc/pi*sr2**
     & 6*gf**2*qel**2*aup**2*mz**4/s*stw2**4*ctw2**2+4d0/3*chizs*chizsc/
     & pi*sr2**6*gf**2*qel**2*aup**2*mz**4/s*stw2**4*ctw2**3-2*chizs*chi
     & zsc/pi*sr2**6*gf**2*qel**2*qup*aup*mz**4/s*stw2**3*ctw2**4-2*chiz
     & s*chizsc/pi*sr2**6*gf**2*qel**2*qup*aup*mz**4/s*stw2**4*ctw2**2-2
     & *chizs*chizsc/pi*sr2**6*gf**2*qel**2*qup*aup*mz**4/s*stw2**4*ctw2
     & **3+2*chizs*chizsc/pi*sr2**6*gf**2*qel**2*qup**2*mz**4/s*stw2**4*
     & ctw2**2+4d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel**2*qup**2*mz**4/s*
     & stw2**4*ctw2**3+2d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel**2*qup**2*
     & mz**4/s*stw2**4*ctw2**4+chizs*chizsc*cosfel/pi*sr2**6*gf**2*ael**
     & 2*aup**2*mz**4/s*stw2**2*ctw2**4+2*chizs*chizsc*cosfel/pi*sr2**6*
     & gf**2*ael**2*aup**2*mz**4/s*stw2**3*ctw2**4+chizs*chizsc*cosfel/p
     & i*sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**4*ctw2**2+2*chizs*chiz
     & sc*cosfel/pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**4*ctw2**3-4
     & d0/3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*s
     & tw2**2*ctw2**4-10d0/3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*qup*ael
     & **2*aup*mz**4/s*stw2**3*ctw2**4-2*chizs*chizsc*cosfel/pi*sr2**6*g
     & f**2*qup*ael**2*aup*mz**4/s*stw2**4*ctw2**2-10d0/3*chizs*chizsc*c
     & osfel/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**4*ctw2**3-4d0/
     & 3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2
     & **2*ctw2**4-10d0/3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*qel*ael*au
     & p**2*mz**4/s*stw2**3*ctw2**4-2*chizs*chizsc*cosfel/pi*sr2**6*gf**
     & 2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**2-10d0/3*chizs*chizsc*cosf
     & el/pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**3+4d0/3*c
     & hizs*chizsc*cosfel/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**
     & 2*ctw2**4+16d0/3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*qel*qup*ael*
     & aup*mz**4/s*stw2**3*ctw2**4+4*chizs*chizsc*cosfel/pi*sr2**6*gf**2
     & *qel*qup*ael*aup*mz**4/s*stw2**4*ctw2**2+16d0/3*chizs*chizsc*cosf
     & el/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**4*ctw2**3+1d0/2*
     & chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2
     & **2*ctw2**4+chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*ael**2*aup**2*
     & mz**4/s*stw2**3*ctw2**4+1d0/2*chizs*chizsc*cosfel**2/pi*sr2**6*gf
     & **2*ael**2*aup**2*mz**4/s*stw2**4*ctw2**2+chizs*chizsc*cosfel**2/
     & pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**4*ctw2**3-2d0/3*chizs
     & *chizsc*cosfel**2/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**2*
     & ctw2**4-5d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qup*ael**2*a
     & up*mz**4/s*stw2**3*ctw2**4-chizs*chizsc*cosfel**2/pi*sr2**6*gf**2
     & *qup*ael**2*aup*mz**4/s*stw2**4*ctw2**2-5d0/3*chizs*chizsc*cosfel
     & **2/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**4*ctw2**3+1d0/3*
     & chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qup**2*ael**2*mz**4/s*stw2
     & **2*ctw2**4+4d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qup**2*a
     & el**2*mz**4/s*stw2**3*ctw2**4+chizs*chizsc*cosfel**2/pi*sr2**6*gf
     & **2*qup**2*ael**2*mz**4/s*stw2**4*ctw2**2+4d0/3*chizs*chizsc*cosf
     & el**2/pi*sr2**6*gf**2*qup**2*ael**2*mz**4/s*stw2**4*ctw2**3-2d0/3
     & *chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*st
     & w2**2*ctw2**4-5d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*ae
     & l*aup**2*mz**4/s*stw2**3*ctw2**4-chizs*chizsc*cosfel**2/pi*sr2**6
     & *gf**2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**2-5d0/3*chizs*chizsc*
     & cosfel**2/pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**3+
     & 2d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**
     & 4/s*stw2**2*ctw2**4+8d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*
     & qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**4+2*chizs*chizsc*cosfel**2/
     & pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**4*ctw2**2+8d0/3*chi
     & zs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2*
     & *4*ctw2**3-2*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*qup**2*ae
     & l*mz**4/s*stw2**3*ctw2**4-2*chizs*chizsc*cosfel**2/pi*sr2**6*gf**
     & 2*qel*qup**2*ael*mz**4/s*stw2**4*ctw2**2-2*chizs*chizsc*cosfel**2
     & /pi*sr2**6*gf**2*qel*qup**2*ael*mz**4/s*stw2**4*ctw2**3+1d0/3*chi
     & zs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel**2*aup**2*mz**4/s*stw2**2
     & *ctw2**4+4d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel**2*aup*
     & *2*mz**4/s*stw2**3*ctw2**4+chizs*chizsc*cosfel**2/pi*sr2**6*gf**2
     & *qel**2*aup**2*mz**4/s*stw2**4*ctw2**2+4d0/3*chizs*chizsc*cosfel*
     & *2/pi*sr2**6*gf**2*qel**2*aup**2*mz**4/s*stw2**4*ctw2**3-2*chizs*
     & chizsc*cosfel**2/pi*sr2**6*gf**2*qel**2*qup*aup*mz**4/s*stw2**3*c
     & tw2**4-2*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel**2*qup*aup*mz
     & **4/s*stw2**4*ctw2**2-2*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qe
     & l**2*qup*aup*mz**4/s*stw2**4*ctw2**3+2*chizs*chizsc*cosfel**2/pi*
     & sr2**6*gf**2*qel**2*qup**2*mz**4/s*stw2**4*ctw2**2+4d0/3*chizs*ch
     & izsc*cosfel**2/pi*sr2**6*gf**2*qel**2*qup**2*mz**4/s*stw2**4*ctw2
     & **3+2d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel**2*qup**2*mz
     & **4/s*stw2**4*ctw2**4+1d0/6*chizs*cosfel/pi*sr2**4*gf**2*qel*qup*
     & ael*aup*mz**4/s*stw2*ctw2**3+1d0/6*chizs*cosfel/pi*sr2**4*gf**2*q
     & el*qup*ael*aup*mz**4/s*stw2**2*ctw2**3+1d0/6*chizs*cosfel/pi*sr2*
     & *4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**2+1d0/12*chizs*cos
     & fel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2*ctw2**3+1d0/1
     & 2*chizs*cosfel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**2
     & *ctw2**3+1d0/12*chizs*cosfel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*m
     & z**4/s*stw2**3*ctw2**2-1d0/6*chizs*cosfel**2/pi*sr2**4*gf**2*qel*
     & qup**2*ael*mz**4/s*stw2*ctw2**3-1d0/6*chizs*cosfel**2/pi*sr2**4*g
     & f**2*qel*qup**2*ael*mz**4/s*stw2**2*ctw2**3-1d0/6*chizs*cosfel**2
     & /pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2**3*ctw2**2-1d0/6*chi
     & zs*cosfel**2/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2*ctw2**3-
     & 1d0/6*chizs*cosfel**2/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2
     & **2*ctw2**3-1d0/6*chizs*cosfel**2/pi*sr2**4*gf**2*qel**2*qup*aup*
     & mz**4/s*stw2**3*ctw2**2+chizs*cosfel**2/pi*sr2**4*gf**2*qel**2*qu
     & p**2*mz**4/s*stw2**2*ctw2**3+1d0/3*chizs*cosfel**2/pi*sr2**4*gf**
     & 2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**2-1d0/3*chizs*cosfel**2/pi*
     & sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**3+1d0/12*chizsc/
     & pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2*ctw2**3+1d0/12*chizs
     & c/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**2*ctw2**3+1d0/12*
     & chizsc/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**2-1d
     & 0/6*chizsc/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2*ctw2**3-1d
     & 0/6*chizsc/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2**2*ctw2**3
     & -1d0/6*chizsc/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2**3*ctw2
     & **2-1d0/6*chizsc/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2*ctw2
     & **3-1d0/6*chizsc/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2**2*c
     & tw2**3-1d0/6*chizsc/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2**
     & 3*ctw2**2+chizsc/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**2*ct
     & w2**3+1d0/3*chizsc/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3*
     & ctw2**2-1d0/3*chizsc/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**
     & 3*ctw2**3+1d0/6*chizsc*cosfel/pi*sr2**4*gf**2*qel*qup*ael*aup*mz*
     & *4/s*stw2*ctw2**3+1d0/6*chizsc*cosfel/pi*sr2**4*gf**2*qel*qup*ael
     & *aup*mz**4/s*stw2**2*ctw2**3+1d0/6*chizsc*cosfel/pi*sr2**4*gf**2*
     & qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**2+1d0/12*chizsc*cosfel**2/p
     & i*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2*ctw2**3+1d0/12*chizsc
     & *cosfel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**2*ctw2**
     & 3+1d0/12*chizsc*cosfel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s
     & *stw2**3*ctw2**2-1d0/6*chizsc*cosfel**2/pi*sr2**4*gf**2*qel*qup**
     & 2*ael*mz**4/s*stw2*ctw2**3-1d0/6*chizsc*cosfel**2/pi*sr2**4*gf**2
     & *qel*qup**2*ael*mz**4/s*stw2**2*ctw2**3-1d0/6*chizsc*cosfel**2/pi
     & *sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2**3*ctw2**2-1d0/6*chizsc
     & *cosfel**2/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2*ctw2**3-1d
     & 0/6*chizsc*cosfel**2/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2*
     & *2*ctw2**3-1d0/6*chizsc*cosfel**2/pi*sr2**4*gf**2*qel**2*qup*aup*
     & mz**4/s*stw2**3*ctw2**2+chizsc*cosfel**2/pi*sr2**4*gf**2*qel**2*q
     & up**2*mz**4/s*stw2**2*ctw2**3+1d0/3*chizsc*cosfel**2/pi*sr2**4*gf
     & **2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**2-1d0/3*chizsc*cosfel**2/
     & pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**3+1d0/6*cosfe
     & l**2/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*ctw2**2-1d0/3*cosfel**
     & 2/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*stw2*ctw2**2+1d0/6*cosfel
     & **2/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*stw2**2*ctw2**2)
      born1=
     & +deltarho2*(+1d0/3/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*stw2*ctw
     & 2**2-1d0/3/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*stw2**2*ctw2**2+
     & 1d0/12*chizs/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2*ctw2**3
     & +1d0/12*chizs/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**2*ctw
     & 2**3+1d0/12*chizs/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**3
     & *ctw2**2-1d0/3*chizs/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2*
     & *2*ctw2**3-1d0/6*chizs/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw
     & 2**3*ctw2**2-1d0/3*chizs/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*s
     & tw2**2*ctw2**3-1d0/6*chizs/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s
     & *stw2**3*ctw2**2+1d0/3*chizs/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/
     & s*stw2**3*ctw2**2+2d0/3*chizs/pi*sr2**4*gf**2*qel**2*qup**2*mz**4
     & /s*stw2**3*ctw2**3+1d0/3*chizs*chizsc/pi*sr2**6*gf**2*ael**2*aup*
     & *2*mz**4/s*stw2**2*ctw2**4+2d0/3*chizs*chizsc/pi*sr2**6*gf**2*ael
     & **2*aup**2*mz**4/s*stw2**3*ctw2**4+1d0/3*chizs*chizsc/pi*sr2**6*g
     & f**2*ael**2*aup**2*mz**4/s*stw2**4*ctw2**2+2d0/3*chizs*chizsc/pi*
     & sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**4*ctw2**3-1d0/3*chizs*ch
     & izsc/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**2*ctw2**4-chizs
     & *chizsc/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**3*ctw2**4-2d
     & 0/3*chizs*chizsc/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**4*c
     & tw2**2-chizs*chizsc/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**
     & 4*ctw2**3+2d0/3*chizs*chizsc/pi*sr2**6*gf**2*qup**2*ael**2*mz**4/
     & s*stw2**3*ctw2**4+2d0/3*chizs*chizsc/pi*sr2**6*gf**2*qup**2*ael**
     & 2*mz**4/s*stw2**4*ctw2**2+2d0/3*chizs*chizsc/pi*sr2**6*gf**2*qup*
     & *2*ael**2*mz**4/s*stw2**4*ctw2**3-1d0/3*chizs*chizsc/pi*sr2**6*gf
     & **2*qel*ael*aup**2*mz**4/s*stw2**2*ctw2**4-chizs*chizsc/pi*sr2**6
     & *gf**2*qel*ael*aup**2*mz**4/s*stw2**3*ctw2**4-2d0/3*chizs*chizsc/
     & pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**2-chizs*chiz
     & sc/pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**3+4d0/3*c
     & hizs*chizsc/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**3*ctw2*
     & *4+4d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw
     & 2**4*ctw2**2+4d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel*qup*ael*aup*m
     & z**4/s*stw2**4*ctw2**3-4d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel*qup
     & **2*ael*mz**4/s*stw2**4*ctw2**2-2d0/3*chizs*chizsc/pi*sr2**6*gf**
     & 2*qel*qup**2*ael*mz**4/s*stw2**4*ctw2**3+2d0/3*chizs*chizsc/pi*sr
     & 2**6*gf**2*qel**2*aup**2*mz**4/s*stw2**3*ctw2**4+2d0/3*chizs*chiz
     & sc/pi*sr2**6*gf**2*qel**2*aup**2*mz**4/s*stw2**4*ctw2**2+2d0/3*ch
     & izs*chizsc/pi*sr2**6*gf**2*qel**2*aup**2*mz**4/s*stw2**4*ctw2**3-
     & 4d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel**2*qup*aup*mz**4/s*stw2**4
     & *ctw2**2-2d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel**2*qup*aup*mz**4/
     & s*stw2**4*ctw2**3+4d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel**2*qup**
     & 2*mz**4/s*stw2**4*ctw2**2-4d0/3*chizs*chizsc/pi*sr2**6*gf**2*qel*
     & *2*qup**2*mz**4/s*stw2**4*ctw2**4+2d0/3*chizs*chizsc*cosfel/pi*sr
     & 2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**2*ctw2**4+4d0/3*chizs*chiz
     & sc*cosfel/pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**3*ctw2**4+2
     & d0/3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*st
     & w2**4*ctw2**2+4d0/3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*ael**2*au
     & p**2*mz**4/s*stw2**4*ctw2**3-2d0/3*chizs*chizsc*cosfel/pi*sr2**6*
     & gf**2*qup*ael**2*aup*mz**4/s*stw2**2*ctw2**4-2*chizs*chizsc*cosfe
     & l/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**3*ctw2**4-4d0/3*ch
     & izs*chizsc*cosfel/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**4*
     & ctw2**2-2*chizs*chizsc*cosfel/pi*sr2**6*gf**2*qup*ael**2*aup*mz**
     & 4/s*stw2**4*ctw2**3-2d0/3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*qel
     & *ael*aup**2*mz**4/s*stw2**2*ctw2**4-2*chizs*chizsc*cosfel/pi*sr2*
     & *6*gf**2*qel*ael*aup**2*mz**4/s*stw2**3*ctw2**4-4d0/3*chizs*chizs
     & c*cosfel/pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**2-2
     & *chizs*chizsc*cosfel/pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2*
     & *4*ctw2**3+8d0/3*chizs*chizsc*cosfel/pi*sr2**6*gf**2*qel*qup*ael*
     & aup*mz**4/s*stw2**3*ctw2**4+8d0/3*chizs*chizsc*cosfel/pi*sr2**6*g
     & f**2*qel*qup*ael*aup*mz**4/s*stw2**4*ctw2**2+8d0/3*chizs*chizsc*c
     & osfel/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**4*ctw2**3+1d0
     & /3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*s
     & tw2**2*ctw2**4+2d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*ael**
     & 2*aup**2*mz**4/s*stw2**3*ctw2**4+1d0/3*chizs*chizsc*cosfel**2/pi*
     & sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**4*ctw2**2+2d0/3*chizs*ch
     & izsc*cosfel**2/pi*sr2**6*gf**2*ael**2*aup**2*mz**4/s*stw2**4*ctw2
     & **3-1d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qup*ael**2*aup*m
     & z**4/s*stw2**2*ctw2**4-chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qup
     & *ael**2*aup*mz**4/s*stw2**3*ctw2**4-2d0/3*chizs*chizsc*cosfel**2/
     & pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**4*ctw2**2-chizs*chiz
     & sc*cosfel**2/pi*sr2**6*gf**2*qup*ael**2*aup*mz**4/s*stw2**4*ctw2*
     & *3+2d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qup**2*ael**2*mz*
     & *4/s*stw2**3*ctw2**4+2d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2
     & *qup**2*ael**2*mz**4/s*stw2**4*ctw2**2+2d0/3*chizs*chizsc*cosfel*
     & *2/pi*sr2**6*gf**2*qup**2*ael**2*mz**4/s*stw2**4*ctw2**3-1d0/3*ch
     & izs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2*
     & *2*ctw2**4-chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*ael*aup**2*
     & mz**4/s*stw2**3*ctw2**4-2d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf
     & **2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**2-chizs*chizsc*cosfel**2
     & /pi*sr2**6*gf**2*qel*ael*aup**2*mz**4/s*stw2**4*ctw2**3+4d0/3*chi
     & zs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2*
     & *3*ctw2**4+4d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*qup*a
     & el*aup*mz**4/s*stw2**4*ctw2**2+4d0/3*chizs*chizsc*cosfel**2/pi*sr
     & 2**6*gf**2*qel*qup*ael*aup*mz**4/s*stw2**4*ctw2**3-4d0/3*chizs*ch
     & izsc*cosfel**2/pi*sr2**6*gf**2*qel*qup**2*ael*mz**4/s*stw2**4*ctw
     & 2**2-2d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel*qup**2*ael*
     & mz**4/s*stw2**4*ctw2**3+2d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf
     & **2*qel**2*aup**2*mz**4/s*stw2**3*ctw2**4+2d0/3*chizs*chizsc*cosf
     & el**2/pi*sr2**6*gf**2*qel**2*aup**2*mz**4/s*stw2**4*ctw2**2+2d0/3
     & *chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel**2*aup**2*mz**4/s*stw
     & 2**4*ctw2**3-4d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel**2*
     & qup*aup*mz**4/s*stw2**4*ctw2**2-2d0/3*chizs*chizsc*cosfel**2/pi*s
     & r2**6*gf**2*qel**2*qup*aup*mz**4/s*stw2**4*ctw2**3+4d0/3*chizs*ch
     & izsc*cosfel**2/pi*sr2**6*gf**2*qel**2*qup**2*mz**4/s*stw2**4*ctw2
     & **2-4d0/3*chizs*chizsc*cosfel**2/pi*sr2**6*gf**2*qel**2*qup**2*mz
     & **4/s*stw2**4*ctw2**4+1d0/6*chizs*cosfel/pi*sr2**4*gf**2*qel*qup*
     & ael*aup*mz**4/s*stw2*ctw2**3+1d0/6*chizs*cosfel/pi*sr2**4*gf**2*q
     & el*qup*ael*aup*mz**4/s*stw2**2*ctw2**3+1d0/6*chizs*cosfel/pi*sr2*
     & *4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**2+1d0/12*chizs*cos
     & fel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2*ctw2**3+1d0/1
     & 2*chizs*cosfel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**2
     & *ctw2**3+1d0/12*chizs*cosfel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*m
     & z**4/s*stw2**3*ctw2**2-1d0/3*chizs*cosfel**2/pi*sr2**4*gf**2*qel*
     & qup**2*ael*mz**4/s*stw2**2*ctw2**3-1d0/6*chizs*cosfel**2/pi*sr2**
     & 4*gf**2*qel*qup**2*ael*mz**4/s*stw2**3*ctw2**2-1d0/3*chizs*cosfel
     & **2/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2**2*ctw2**3-1d0/6*
     & chizs*cosfel**2/pi*sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2**3*ct
     & w2**2+1d0/3*chizs*cosfel**2/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s
     & *stw2**3*ctw2**2+2d0/3*chizs*cosfel**2/pi*sr2**4*gf**2*qel**2*qup
     & **2*mz**4/s*stw2**3*ctw2**3+1d0/12*chizsc/pi*sr2**4*gf**2*qel*qup
     & *ael*aup*mz**4/s*stw2*ctw2**3+1d0/12*chizsc/pi*sr2**4*gf**2*qel*q
     & up*ael*aup*mz**4/s*stw2**2*ctw2**3+1d0/12*chizsc/pi*sr2**4*gf**2*
     & qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**2-1d0/3*chizsc/pi*sr2**4*gf
     & **2*qel*qup**2*ael*mz**4/s*stw2**2*ctw2**3-1d0/6*chizsc/pi*sr2**4
     & *gf**2*qel*qup**2*ael*mz**4/s*stw2**3*ctw2**2-1d0/3*chizsc/pi*sr2
     & **4*gf**2*qel**2*qup*aup*mz**4/s*stw2**2*ctw2**3-1d0/6*chizsc/pi*
     & sr2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2**3*ctw2**2+1d0/3*chizsc/
     & pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**2+2d0/3*chizs
     & c/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**3+1d0/6*chi
     & zsc*cosfel/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2*ctw2**3+1
     & d0/6*chizsc*cosfel/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**
     & 2*ctw2**3+1d0/6*chizsc*cosfel/pi*sr2**4*gf**2*qel*qup*ael*aup*mz*
     & *4/s*stw2**3*ctw2**2+1d0/12*chizsc*cosfel**2/pi*sr2**4*gf**2*qel*
     & qup*ael*aup*mz**4/s*stw2*ctw2**3+1d0/12*chizsc*cosfel**2/pi*sr2**
     & 4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**2*ctw2**3+1d0/12*chizsc*cos
     & fel**2/pi*sr2**4*gf**2*qel*qup*ael*aup*mz**4/s*stw2**3*ctw2**2-1d
     & 0/3*chizsc*cosfel**2/pi*sr2**4*gf**2*qel*qup**2*ael*mz**4/s*stw2*
     & *2*ctw2**3-1d0/6*chizsc*cosfel**2/pi*sr2**4*gf**2*qel*qup**2*ael*
     & mz**4/s*stw2**3*ctw2**2-1d0/3*chizsc*cosfel**2/pi*sr2**4*gf**2*qe
     & l**2*qup*aup*mz**4/s*stw2**2*ctw2**3-1d0/6*chizsc*cosfel**2/pi*sr
     & 2**4*gf**2*qel**2*qup*aup*mz**4/s*stw2**3*ctw2**2+1d0/3*chizsc*co
     & sfel**2/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3*ctw2**2+2d0
     & /3*chizsc*cosfel**2/pi*sr2**4*gf**2*qel**2*qup**2*mz**4/s*stw2**3
     & *ctw2**3+1d0/3*cosfel**2/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*st
     & w2*ctw2**2-1d0/3*cosfel**2/pi*sr2**2*gf**2*qel**2*qup**2*mz**4/s*
     & stw2**2*ctw2**2)

      if (iho.eq.1) then
         born = born1
      elseif (iho.eq.2) then
         born = born1 + born2
      endif

      born = born* conhc      
      virt = 0d0
      soft = 0d0
      hard = 0d0

      return
      end
************************************************************************
