************************************************************************
* sanc_cc_v1.50 package.
************************************************************************
* File (cc_ff_1413_43.F) is created on Thu Jan 19 01:31:46 MSK 2012.
************************************************************************
* This is the FORTRAN module (cc_ff_1413_43) to calculate 1-loop EW
* form factors for the anti-dn + up -> H   + W^+ process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ff_1413_43 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ffgp0ew,ffgp1ew,ffgp2ew

      real*8 det3iwhqs
      real*8 a0fw,a0fz,a0fh,a0fmo,a0fch,a0fst,a0fta,a0ftp,a0fbt
      complex*16 b0pwwz,b0pdnzdn,b0pupzup,b0phww,b0phzz,b0phhh,b0pwwh
      complex*16 b0fqswz,b0fqswh,b0fqswc,b0fqsmoc,b0fqschst,b0fqstac,b0
     & fqstpbt,b0fqscc,b0fhww,b0fhzz,b0fhhh,b0fhmomo,b0fhchch,b0fhstst,b
     & 0fhtata,b0fhtptp,b0fhbtbt,b0fwwz,b0fwwh,b0fwmnmo,b0fwchst,b0fwtnt
     & a,b0fwtpbt,b0fqsupdn,b0fqsmnmo,b0fqstnta,b0ftswup,b0ftszdn,b0fusw
     & dn,b0fuszup,b0fwupdn
      complex*16 c0updnqswdnz,c0updnqszupw,c0updnqsupzdn,c0hdntswwup,c0
     & hdntszzdn,c0hupuswwdn,c0hupuszzup,c0wdnuswzdn,c0wdnuszwup,c0wdnus
     & updnz,c0wuptswzup,c0wuptszwdn,c0wuptsdnupz,c0whqswzz,c0whqswhh,c0
     & whqszww,c0whqshww,c0whqsmnmomo,c0whqschstst,c0whqsstchch,c0whqstn
     & tata,c0whqstpbtbt,c0whqsbttptp,c0whqscww
      complex*16 d0dnuphwqsuswupzz,d0dnuphwqsuszdnww,d0dnupwhqstswupzw,
     & d0dnupwhqstszdnwz,d0wuphdntsusdnupzz
      complex*16 jawsubqstswhw,jawsubqsuswhw
      real*8 sdet3ichts,sdet3ichus,sdet4iwhtsus,sdet3icwus,sdet3icwts
      complex*16 propwqs,propiwqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      cmw2 = rwm2

      propiwqs = (cmw2+qs)
      propwqs = 1d0/propiwqs
      det3iwhqs = 1d0/(-1d0/4d0*((-rwm2)**2+(-rhm2)**2+(qs)**2
     & -2d0*(-rwm2)*(-rhm2)-2d0*(-rwm2)*(qs)
     & -2d0*(-rhm2)*(qs)))
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      a0fmo = log(rmom2/thmu2) - 1d0
      a0fch = log(rchm2/thmu2) - 1d0
      a0fst = log(rstm2/thmu2) - 1d0
      a0fta = log(rtam2/thmu2) - 1d0
      a0ftp = log(rtpm2/thmu2) - 1d0
      a0fbt = log(rbtm2/thmu2) - 1d0
      b0pwwz = b0p(-rwm2,wm2,zm2)
      b0pdnzdn = b0p(-rdnm2,zm2,dnm2)
      b0pupzup = b0p(-rupm2,zm2,upm2)
      b0phww = b0p(-rhm2,wm2,wm2)
      b0phzz = b0p(-rhm2,zm2,zm2)
      b0phhh = b0p(-rhm2,hm2,hm2)
      b0pwwh = b0p(-rwm2,wm2,hm2)
      b0fqswz = b0f(qs,thmu2,wm2,zm2)
      b0fqswh = b0f(qs,thmu2,wm2,hm2)
      b0fqswc = b0f(qs,thmu2,wm2,cm2)
      b0fqsmoc = b0f(qs,thmu2,mom2,cm2)
      b0fqschst = b0f(qs,thmu2,chm2,stm2)
      b0fqstac = b0f(qs,thmu2,tam2,cm2)
      b0fqstpbt = b0f(qs,thmu2,tpm2,btm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      b0fhww = b0f(-rhm2,thmu2,wm2,wm2)
      b0fhzz = b0f(-rhm2,thmu2,zm2,zm2)
      b0fhhh = b0f(-rhm2,thmu2,hm2,hm2)
      b0fhmomo = b0f(-rhm2,thmu2,mom2,mom2)
      b0fhchch = b0f(-rhm2,thmu2,chm2,chm2)
      b0fhstst = b0f(-rhm2,thmu2,stm2,stm2)
      b0fhtata = b0f(-rhm2,thmu2,tam2,tam2)
      b0fhtptp = b0f(-rhm2,thmu2,tpm2,tpm2)
      b0fhbtbt = b0f(-rhm2,thmu2,btm2,btm2)
      b0fwwz = b0f(-rwm2,thmu2,wm2,zm2)
      b0fwwh = b0f(-rwm2,thmu2,wm2,hm2)
      b0fwmnmo = b0f(-rwm2,thmu2,mnm2,mom2)
      b0fwchst = b0f(-rwm2,thmu2,chm2,stm2)
      b0fwtnta = b0f(-rwm2,thmu2,tnm2,tam2)
      b0fwtpbt = b0f(-rwm2,thmu2,tpm2,btm2)
      b0fqsupdn = b0f(qs,thmu2,upm2,dnm2)
      b0fqsmnmo = b0f(qs,thmu2,mnm2,mom2)
      b0fqstnta = b0f(qs,thmu2,tnm2,tam2)
      b0ftswup = b0f(ts,thmu2,wm2,upm2)
      b0ftszdn = b0f(ts,thmu2,zm2,dnm2)
      b0fuswdn = b0f(us,thmu2,wm2,dnm2)
      b0fuszup = b0f(us,thmu2,zm2,upm2)
      b0fwupdn = b0f(-rwm2,thmu2,upm2,dnm2)
      c0updnqswdnz = -c0(rupm2,rdnm2,-qs,rwm2,rdnm2,rzm2)
      c0updnqszupw = -c0(rupm2,rdnm2,-qs,rzm2,rupm2,rwm2)
      c0updnqsupzdn = -c0(rupm2,rdnm2,-qs,rupm2,rzm2,rdnm2)
      c0hdntswwup = -c0(rhm2,rdnm2,-ts,rwm2,rwm2,rupm2)
      c0hdntszzdn = -c0(rhm2,rdnm2,-ts,rzm2,rzm2,rdnm2)
      c0hupuswwdn = -c0(rhm2,rupm2,-us,rwm2,rwm2,rdnm2)
      c0hupuszzup = -c0(rhm2,rupm2,-us,rzm2,rzm2,rupm2)
      c0wdnuswzdn = -c0(rwm2,rdnm2,-us,rwm2,rzm2,rdnm2)
      c0wdnuszwup = -c0(rwm2,rdnm2,-us,rzm2,rwm2,rupm2)
      c0wdnusupdnz = -c0(rwm2,rdnm2,-us,rupm2,rdnm2,rzm2)
      c0wuptswzup = -c0(rwm2,rupm2,-ts,rwm2,rzm2,rupm2)
      c0wuptszwdn = -c0(rwm2,rupm2,-ts,rzm2,rwm2,rdnm2)
      c0wuptsdnupz = -c0(rwm2,rupm2,-ts,rdnm2,rupm2,rzm2)
      c0whqswzz = -c0(rwm2,rhm2,-qs,rwm2,rzm2,rzm2)
      c0whqswhh = -c0(rwm2,rhm2,-qs,rwm2,rhm2,rhm2)
      c0whqszww = -c0(rwm2,rhm2,-qs,rzm2,rwm2,rwm2)
      c0whqshww = -c0(rwm2,rhm2,-qs,rhm2,rwm2,rwm2)
      c0whqsmnmomo = -c0(rwm2,rhm2,-qs,rmnm2,rmom2,rmom2)
      c0whqschstst = -c0(rwm2,rhm2,-qs,rchm2,rstm2,rstm2)
      c0whqsstchch = -c0(rwm2,rhm2,-qs,rstm2,rchm2,rchm2)
      c0whqstntata = -c0(rwm2,rhm2,-qs,rtnm2,rtam2,rtam2)
      c0whqstpbtbt = -c0(rwm2,rhm2,-qs,rtpm2,rbtm2,rbtm2)
      c0whqsbttptp = -c0(rwm2,rhm2,-qs,rbtm2,rtpm2,rtpm2)
      c0whqscww = -c0(rwm2,rhm2,-qs,0d0,rwm2,rwm2)
      d0dnuphwqsuswupzz =
     & d0(rdnm2,rupm2,rhm2,rwm2,-qs,-us,rwm2,rupm2,rzm2,rzm2)
      d0dnuphwqsuszdnww =
     & d0(rdnm2,rupm2,rhm2,rwm2,-qs,-us,rzm2,rdnm2,rwm2,rwm2)
      d0dnupwhqstswupzw =
     & d0(rdnm2,rupm2,rwm2,rhm2,-qs,-ts,rwm2,rupm2,rzm2,rwm2)
      d0dnupwhqstszdnwz =
     & d0(rdnm2,rupm2,rwm2,rhm2,-qs,-ts,rzm2,rdnm2,rwm2,rzm2)
      d0wuphdntsusdnupzz =
     & d0(rwm2,rupm2,rhm2,rdnm2,-ts,-us,rdnm2,rupm2,rzm2,rzm2)
      jawsubqstswhw = jawsub(qs,ts,wm2,hm2,mw2)
      jawsubqsuswhw = jawsub(qs,us,wm2,hm2,mw2)
      sdet3ichts = 1d0/(ts+(mh)**2)
      sdet3ichus = 1d0/(us+(mh)**2)
      sdet4iwhtsus = 1d0/(ts*us-rwm2*rhm2)
      sdet3icwus = 1d0/(us+(mw)**2)
      sdet3icwts = 1d0/(ts+(mw)**2)

      ffgp0ew=
     & +1d0/stw**2*(deltarhofer+deltarhobos)
     & +cfq*(1d0/3-1d0/2/mw**2*mbt**2-1d0/2/mw**2*mtp**2-1d0/2/mw**2*mst
     & **2-1d0/2/mw**2*mch**2)
     & +cfl*(1d0/3-1d0/2/mw**2*mta**2-1d0/2/mw**2*mmo**2)
     & +stw**2*(2*dreal(b0pwwz)*mw**2)
     & +stw**2*qdn*(-2)
     & +stw**2*qdn**2*(-3d0/2)
     & +stw**2*qup*(2)
     & +stw**2*qup*qdn*(2)
     & +stw**2*qup**2*(-3d0/2)
     & +jawsubqstswhw*stw**2*qup*(2*sdet4iwhtsus**2/qs*mw**8*mh**4+6*sde
     & t4iwhtsus**2/qs*ts*mw**6*mh**4+6*sdet4iwhtsus**2/qs*ts**2*mw**4*m
     & h**4+4*sdet4iwhtsus**2/qs*ts**2*mw**6*mh**2+2*sdet4iwhtsus**2/qs*
     & ts**3*mw**2*mh**4+8*sdet4iwhtsus**2/qs*ts**3*mw**4*mh**2+4*sdet4i
     & whtsus**2/qs*ts**4*mw**2*mh**2+2*sdet4iwhtsus**2/qs*ts**4*mw**4+2
     & *sdet4iwhtsus**2/qs*ts**5*mw**2)
     & +jawsubqstswhw*propiwqs*stw**2*qup*(-sdet4iwhtsus**2/qs*mw**6*mh*
     & *4-sdet4iwhtsus**2/qs*mw**8*mh**2-3*sdet4iwhtsus**2/qs*ts*mw**4*m
     & h**4-sdet4iwhtsus**2/qs*ts*mw**6*mh**2-sdet4iwhtsus**2/qs*ts*mw**
     & 8-3*sdet4iwhtsus**2/qs*ts**2*mw**2*mh**4-sdet4iwhtsus**2/qs*ts**2
     & *mw**4*mh**2-2*sdet4iwhtsus**2/qs*ts**2*mw**6-sdet4iwhtsus**2/qs*
     & ts**3*mh**4-3*sdet4iwhtsus**2/qs*ts**3*mw**2*mh**2-2*sdet4iwhtsus
     & **2/qs*ts**4*mh**2-sdet4iwhtsus**2/qs*ts**5-sdet4iwhtsus**2*mw**6
     & *mh**2-5*sdet4iwhtsus**2*ts*mw**4*mh**2-2*sdet4iwhtsus**2*ts*mw**
     & 6-7*sdet4iwhtsus**2*ts**2*mw**2*mh**2-5*sdet4iwhtsus**2*ts**2*mw*
     & *4-3*sdet4iwhtsus**2*ts**3*mh**2-6*sdet4iwhtsus**2*ts**3*mw**2-3*
     & sdet4iwhtsus**2*ts**4-sdet4iwhtsus**2*qs*ts*mw**4-3*sdet4iwhtsus*
     & *2*qs*ts**2*mw**2-2*sdet4iwhtsus**2*qs*ts**3)
     & +jawsubqsuswhw*stw**2*qdn*(-2*sdet4iwhtsus**2/qs*mw**8*mh**4-6*sd
     & et4iwhtsus**2/qs*us*mw**6*mh**4-6*sdet4iwhtsus**2/qs*us**2*mw**4*
     & mh**4-4*sdet4iwhtsus**2/qs*us**2*mw**6*mh**2-2*sdet4iwhtsus**2/qs
     & *us**3*mw**2*mh**4-8*sdet4iwhtsus**2/qs*us**3*mw**4*mh**2-4*sdet4
     & iwhtsus**2/qs*us**4*mw**2*mh**2-2*sdet4iwhtsus**2/qs*us**4*mw**4-
     & 2*sdet4iwhtsus**2/qs*us**5*mw**2)
     & +jawsubqsuswhw*propiwqs*stw**2*qdn*(sdet4iwhtsus**2/qs*mw**6*mh**
     & 4+sdet4iwhtsus**2/qs*mw**8*mh**2+3*sdet4iwhtsus**2/qs*us*mw**4*mh
     & **4+sdet4iwhtsus**2/qs*us*mw**6*mh**2+sdet4iwhtsus**2/qs*us*mw**8
     & +3*sdet4iwhtsus**2/qs*us**2*mw**2*mh**4+sdet4iwhtsus**2/qs*us**2*
     & mw**4*mh**2+2*sdet4iwhtsus**2/qs*us**2*mw**6+sdet4iwhtsus**2/qs*u
     & s**3*mh**4+3*sdet4iwhtsus**2/qs*us**3*mw**2*mh**2+2*sdet4iwhtsus*
     & *2/qs*us**4*mh**2+sdet4iwhtsus**2/qs*us**5+sdet4iwhtsus**2*mw**6*
     & mh**2+5*sdet4iwhtsus**2*us*mw**4*mh**2+2*sdet4iwhtsus**2*us*mw**6
     & +7*sdet4iwhtsus**2*us**2*mw**2*mh**2+5*sdet4iwhtsus**2*us**2*mw**
     & 4+3*sdet4iwhtsus**2*us**3*mh**2+6*sdet4iwhtsus**2*us**3*mw**2+3*s
     & det4iwhtsus**2*us**4+sdet4iwhtsus**2*qs*us*mw**4+3*sdet4iwhtsus**
     & 2*qs*us**2*mw**2+2*sdet4iwhtsus**2*qs*us**3)
     & +propwqs*cfq*(1d0/3*mbt**2+1d0/3*mtp**2+1d0/3*mst**2+1d0/3*mch**2
     & -1d0/3*mw**2)
     & +propwqs*cfl*(1d0/3*mta**2+1d0/3*mmo**2-1d0/3*mw**2)
     & +propwqs*a0fw*(-1d0/12/ctw**2*mw**2-1d0/12*mh**2-mw**2+3*mw**4/mh
     & **2)
     & +propwqs*a0fz*(1d0/12/ctw**4*mw**2+3d0/2/ctw**4*mw**4/mh**2+2d0/3
     & /ctw**2*mw**2-2*mw**2)
     & +propwqs*a0fh*(1d0/12/mw**2*mh**4+1d0/2*mh**2)
     & +propwqs*a0fmo*cfl*(-1d0/6/mw**2*mmo**4-2/mh**2*mmo**4+1d0/3*mmo*
     & *2)
     & +propwqs*a0fch*cfq*(1d0/6/mw**2*mch**2*mst**2-1d0/6/mw**2*mch**4-
     & 2/mh**2*mch**4+1d0/3*mch**2)
     & +propwqs*a0fst*cfq*(-1d0/6/mw**2*mst**4+1d0/6/mw**2*mch**2*mst**2
     & -2/mh**2*mst**4+1d0/3*mst**2)
     & +propwqs*a0fta*cfl*(-1d0/6/mw**2*mta**4-2/mh**2*mta**4+1d0/3*mta*
     & *2)
     & +propwqs*a0ftp*cfq*(1d0/6/mw**2*mtp**2*mbt**2-1d0/6/mw**2*mtp**4-
     & 2/mh**2*mtp**4+1d0/3*mtp**2)
     & +propwqs*a0fbt*cfq*(-1d0/6/mw**2*mbt**4+1d0/6/mw**2*mtp**2*mbt**2
     & -2/mh**2*mbt**4+1d0/3*mbt**2)
     & +propwqs*b0fqswz*stw**2*(4*mw**2)
     & +propwqs*b0fqswz*(1d0/12/ctw**4*mw**2+4d0/3/ctw**2*mw**2-29d0/3*m
     & w**2)
     & +propwqs*b0fqswh*(1d0/12/mw**2*mh**4-1d0/3*mh**2+mw**2)
     & +propwqs*b0fqswc*stw**2*(-4*mw**2)
     & +propwqs*b0fqsmoc*cfl*(-1d0/6/mw**2*mmo**4-1d0/6*mmo**2+1d0/3*mw*
     & *2)
     & +propwqs*b0fqschst*cfq*(-1d0/6/mw**2*mst**4+1d0/3/mw**2*mch**2*ms
     & t**2-1d0/6/mw**2*mch**4-1d0/6*mst**2-1d0/6*mch**2+1d0/3*mw**2)
     & +propwqs*b0fqstac*cfl*(-1d0/6/mw**2*mta**4-1d0/6*mta**2+1d0/3*mw*
     & *2)
     & +propwqs*b0fqstpbt*cfq*(-1d0/6/mw**2*mbt**4+1d0/3/mw**2*mtp**2*mb
     & t**2-1d0/6/mw**2*mtp**4-1d0/6*mbt**2-1d0/6*mtp**2+1d0/3*mw**2)
     & +propwqs*b0fqscc*cfq*(1d0/3*mw**2)
     & +propwqs*b0fqscc*cfl*(1d0/3*mw**2)
     & +propwqs*(1d0/ctw**4*mw**4/mh**2-1d0/6/ctw**2*mw**2-1d0/6*mh**2-2
     & 8d0/9*mw**2-mw**2*tadfer-mw**2*zmwzwfer-mw**2*zmwzwbos+2*mw**4/mh
     & **2-4*log(mw**2/thmu2)*mw**2)
     & +propiwqs*stw**2*(-det3iwhqs*mw**2)
     & +propiwqs*d0dnuphwqsuswupzz*(-1d0/2/ctw**6*vpaup/qs*mw**4+7d0/4/c
     & tw**4*vpaup/qs*mw**4+3d0/4/ctw**4*vpaup/qs*us*mw**2-5d0/4/ctw**4*
     & vpaup*mw**2-3d0/4/ctw**2*vpaup/qs*mw**2*mh**2-1d0/2/ctw**2*vpaup/
     & qs*mw**4-3d0/4/ctw**2*vpaup/qs*us*mw**2-1d0/ctw**2*vpaup*mw**2-3d
     & 0/4/ctw**2*vpaup*us-1d0/2*sdet4iwhtsus/ctw**6*vpaup/qs*mw**6*mh**
     & 2+1d0/2*sdet4iwhtsus/ctw**6*vpaup/qs*mw**8-1d0/2*sdet4iwhtsus/ctw
     & **6*vpaup/qs*us*mw**4*mh**2+1d0/2*sdet4iwhtsus/ctw**6*vpaup/qs*us
     & *mw**6-1d0/2*sdet4iwhtsus/ctw**6*vpaup*mw**4*mh**2+1d0/2*sdet4iwh
     & tsus/ctw**6*vpaup*mw**6-1d0/2*sdet4iwhtsus/ctw**6*vpaup*ts*mw**4-
     & sdet4iwhtsus/ctw**4*vpaup*us*mw**2*mh**2+1d0/2*sdet4iwhtsus/ctw**
     & 2*vpaup/qs*mw**4*mh**4-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mw**6*m
     & h**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*us*mw**4*mh**2-1d0/2*sdet
     & 4iwhtsus/ctw**2*vpaup/qs*us*mw**6+1d0/2*sdet4iwhtsus/ctw**2*vpaup
     & *us*mw**2*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*us*mw**4-1d0/2*sd
     & et4iwhtsus/ctw**2*vpaup*us**2*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpa
     & up*us**2*mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*us**3)
     & +propiwqs*d0dnuphwqsuszdnww*(1d0/4/ctw**4*vpadn/qs*mw**2*mh**2+1d
     & 0/2/ctw**4*vpadn/qs*mw**4+1d0/4/ctw**4*vpadn/qs*us*mw**2+1d0/2/ct
     & w**2*vpadn/qs*mw**2*mh**2-5d0/4/ctw**2*vpadn/qs*mw**4+1d0/4/ctw**
     & 2*vpadn/qs*us*mw**2+3d0/4/ctw**2*vpadn*mw**2-1d0/4/ctw**2*vpadn*u
     & s-1d0/2*vpadn/qs*us*mw**2+3d0/2*vpadn*mw**2+vpadn*us-1d0/2*sdet4i
     & whtsus/ctw**4*vpadn/qs*mw**4*mh**4+1d0/2*sdet4iwhtsus/ctw**4*vpad
     & n/qs*mw**6*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*us*mw**4*mh**
     & 2+1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*us*mw**6+1d0/2*sdet4iwhtsus/
     & ctw**4*vpadn*us*mw**4-sdet4iwhtsus/ctw**2*vpadn*mw**4*mh**2-sdet4
     & iwhtsus/ctw**2*vpadn*us*mw**2*mh**2-sdet4iwhtsus/ctw**2*vpadn*us*
     & *2*mw**2+1d0/2*sdet4iwhtsus*vpadn/qs*mw**6*mh**2-1d0/2*sdet4iwhts
     & us*vpadn/qs*mw**8+1d0/2*sdet4iwhtsus*vpadn/qs*us*mw**4*mh**2-1d0/
     & 2*sdet4iwhtsus*vpadn/qs*us*mw**6+3d0/2*sdet4iwhtsus*vpadn*mw**4*m
     & h**2-1d0/2*sdet4iwhtsus*vpadn*mw**6+3d0/2*sdet4iwhtsus*vpadn*us*m
     & w**2*mh**2+1d0/2*sdet4iwhtsus*vpadn*us**2*mh**2+1d0/2*sdet4iwhtsu
     & s*vpadn*us**2*mw**2+1d0/2*sdet4iwhtsus*vpadn*us**3+1d0/2*sdet4iwh
     & tsus*vpadn*ts*mw**4)
     & +propiwqs*d0dnupwhqstswupzw*(-1d0/4/ctw**4*vpaup/qs*mw**2*mh**2-1
     & d0/2/ctw**4*vpaup/qs*mw**4-1d0/4/ctw**4*vpaup/qs*ts*mw**2-1d0/2/c
     & tw**2*vpaup/qs*mw**2*mh**2+5d0/4/ctw**2*vpaup/qs*mw**4-1d0/4/ctw*
     & *2*vpaup/qs*ts*mw**2-3d0/4/ctw**2*vpaup*mw**2+1d0/4/ctw**2*vpaup*
     & ts+1d0/2*vpaup/qs*ts*mw**2-3d0/2*vpaup*mw**2-vpaup*ts+1d0/2*sdet4
     & iwhtsus/ctw**4*vpaup/qs*mw**4*mh**4-1d0/2*sdet4iwhtsus/ctw**4*vpa
     & up/qs*mw**6*mh**2+1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*ts*mw**4*mh*
     & *2-1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*ts*mw**6-1d0/2*sdet4iwhtsus
     & /ctw**4*vpaup*ts*mw**4+sdet4iwhtsus/ctw**2*vpaup*mw**4*mh**2+sdet
     & 4iwhtsus/ctw**2*vpaup*ts*mw**2*mh**2+sdet4iwhtsus/ctw**2*vpaup*ts
     & **2*mw**2-1d0/2*sdet4iwhtsus*vpaup/qs*mw**6*mh**2+1d0/2*sdet4iwht
     & sus*vpaup/qs*mw**8-1d0/2*sdet4iwhtsus*vpaup/qs*ts*mw**4*mh**2+1d0
     & /2*sdet4iwhtsus*vpaup/qs*ts*mw**6-3d0/2*sdet4iwhtsus*vpaup*mw**4*
     & mh**2+1d0/2*sdet4iwhtsus*vpaup*mw**6-1d0/2*sdet4iwhtsus*vpaup*us*
     & mw**4-3d0/2*sdet4iwhtsus*vpaup*ts*mw**2*mh**2-1d0/2*sdet4iwhtsus*
     & vpaup*ts**2*mh**2-1d0/2*sdet4iwhtsus*vpaup*ts**2*mw**2-1d0/2*sdet
     & 4iwhtsus*vpaup*ts**3)
     & +propiwqs*d0dnupwhqstszdnwz*(1d0/2/ctw**6*vpadn/qs*mw**4-7d0/4/ct
     & w**4*vpadn/qs*mw**4-3d0/4/ctw**4*vpadn/qs*ts*mw**2+5d0/4/ctw**4*v
     & padn*mw**2+3d0/4/ctw**2*vpadn/qs*mw**2*mh**2+1d0/2/ctw**2*vpadn/q
     & s*mw**4+3d0/4/ctw**2*vpadn/qs*ts*mw**2+1d0/ctw**2*vpadn*mw**2+3d0
     & /4/ctw**2*vpadn*ts+1d0/2*sdet4iwhtsus/ctw**6*vpadn/qs*mw**6*mh**2
     & -1d0/2*sdet4iwhtsus/ctw**6*vpadn/qs*mw**8+1d0/2*sdet4iwhtsus/ctw*
     & *6*vpadn/qs*ts*mw**4*mh**2-1d0/2*sdet4iwhtsus/ctw**6*vpadn/qs*ts*
     & mw**6+1d0/2*sdet4iwhtsus/ctw**6*vpadn*mw**4*mh**2-1d0/2*sdet4iwht
     & sus/ctw**6*vpadn*mw**6+1d0/2*sdet4iwhtsus/ctw**6*vpadn*us*mw**4+s
     & det4iwhtsus/ctw**4*vpadn*ts*mw**2*mh**2-1d0/2*sdet4iwhtsus/ctw**2
     & *vpadn/qs*mw**4*mh**4+1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*mw**6*mh
     & **2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*ts*mw**4*mh**2+1d0/2*sdet4
     & iwhtsus/ctw**2*vpadn/qs*ts*mw**6-1d0/2*sdet4iwhtsus/ctw**2*vpadn*
     & ts*mw**2*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn*ts*mw**4+1d0/2*sde
     & t4iwhtsus/ctw**2*vpadn*ts**2*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpad
     & n*ts**2*mw**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn*ts**3)
     & +propiwqs*d0wuphdntsusdnupzz*(3d0/4/ctw**6*vpaup*vpadn/qs*mw**2*m
     & h**2-3d0/4/ctw**6*vpaup*vpadn/qs*mw**4+3d0/4/ctw**6*vpaup*vpadn*m
     & w**2+1d0/2/ctw**4*vpaup*vpadn/qs*mw**2*mh**2+1d0/2/ctw**4*vpaup*v
     & padn/qs*us*mh**2+1d0/2/ctw**4*vpaup*vpadn/qs*us*mw**2+1d0/2/ctw**
     & 4*vpaup*vpadn/qs*us**2+1d0/2/ctw**4*vpaup*vpadn*mw**2+1d0/2/ctw**
     & 4*vpaup*vpadn*us+sdet4iwhtsus/ctw**8*vpaup*vpadn/qs*mw**6*mh**2+1
     & d0/4*sdet4iwhtsus/ctw**8*vpaup*vpadn/qs*us*mw**4*mh**2+1d0/4*sdet
     & 4iwhtsus/ctw**8*vpaup*vpadn/qs*us*mw**6+1d0/4*sdet4iwhtsus/ctw**8
     & *vpaup*vpadn/qs*ts*mw**4*mh**2+1d0/4*sdet4iwhtsus/ctw**8*vpaup*vp
     & adn/qs*ts*mw**6+1d0/4*sdet4iwhtsus/ctw**8*vpaup*vpadn*us*mw**4+1d
     & 0/4*sdet4iwhtsus/ctw**8*vpaup*vpadn*ts*mw**4)
     & +propiwqs*c0updnqswdnz*(-1d0/ctw**2*vpadn/qs*mw**2-1d0/2/ctw**2*v
     & padn-vpadn-1d0/2*sdet4iwhtsus/ctw**4*vpadn*mw**2*mh**2-1d0/2*sdet
     & 4iwhtsus/ctw**4*vpadn*us*mw**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn*mw
     & **2*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn*us*mw**2-1d0/2*sdet4iwh
     & tsus/ctw**2*vpadn*ts*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn*ts**2-
     & sdet4iwhtsus*vpadn*mw**2*mh**2-1d0/2*sdet4iwhtsus*vpadn*us*mh**2-
     & 1d0/2*sdet4iwhtsus*vpadn*us*mw**2-1d0/2*sdet4iwhtsus*vpadn*us**2-
     & 1d0/2*sdet4iwhtsus*vpadn*ts*mw**2)
     & +propiwqs*c0updnqszupw*(1d0/ctw**2*vpaup/qs*mw**2+1d0/2/ctw**2*vp
     & aup+vpaup+1d0/2*sdet4iwhtsus/ctw**4*vpaup*mw**2*mh**2+1d0/2*sdet4
     & iwhtsus/ctw**4*vpaup*ts*mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*mw*
     & *2*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup*us*mh**2+1d0/2*sdet4iwht
     & sus/ctw**2*vpaup*us**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*ts*mw**2+s
     & det4iwhtsus*vpaup*mw**2*mh**2+1d0/2*sdet4iwhtsus*vpaup*us*mw**2+1
     & d0/2*sdet4iwhtsus*vpaup*ts*mh**2+1d0/2*sdet4iwhtsus*vpaup*ts*mw**
     & 2+1d0/2*sdet4iwhtsus*vpaup*ts**2)
     & +propiwqs*c0updnqsupzdn*(-1d0/2/ctw**6*vpaup*vpadn/qs*mw**2-1d0/2
     & /ctw**2*vpaup*vpadn)
     & +propiwqs*c0hdntswwup*stw**2*qup*(2+1d0/qs*mh**2-1d0/qs*mw**2+1d0
     & /qs*ts-sdet4iwhtsus*mw**2*mh**2-sdet4iwhtsus*ts*mh**2-sdet4iwhtsu
     & s*ts**2)
     & +propiwqs*c0hdntswwup*(1d0/4/ctw**2*vpaup/qs*mh**2+1d0/2/ctw**2*v
     & paup/qs*mw**2+1d0/4/ctw**2*vpaup/qs*ts+1d0/2*vpaup/qs*mh**2-1d0/2
     & *vpaup/qs*mw**2+1d0/2*vpaup/qs*ts+vpaup-sdet3ichts*mw**2-1d0/2*sd
     & et4iwhtsus/ctw**2*vpaup/qs*mw**2*mh**4+1d0/2*sdet4iwhtsus/ctw**2*
     & vpaup/qs*mw**4*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*ts*mw**2*
     & mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*ts*mw**4+1d0/2*sdet4iwht
     & sus/ctw**2*vpaup*ts*mw**2-1d0/2*sdet4iwhtsus*vpaup*mw**2*mh**2-1d
     & 0/2*sdet4iwhtsus*vpaup*ts*mh**2-1d0/2*sdet4iwhtsus*vpaup*ts**2)
     & +propiwqs*c0hdntszzdn*(1d0/2/ctw**4*vpadn/qs*mw**2-1d0/2/ctw**4*v
     & paup*vpadn/qs*mw**2-1d0/2/ctw**4*vpaup*vpadn/qs*us-3d0/4/ctw**2*v
     & padn/qs*mh**2-1d0/2/ctw**2*vpadn/qs*mw**2-3d0/4/ctw**2*vpadn/qs*t
     & s-1d0/ctw**2*vpadn-1d0/2*sdet3ichts/ctw**6*vpadn**2*mw**2+1d0/2*s
     & det4iwhtsus/ctw**6*vpaup*vpadn/qs*mw**4*mh**2+1d0/4*sdet4iwhtsus/
     & ctw**6*vpaup*vpadn/qs*us*mw**2*mh**2+1d0/4*sdet4iwhtsus/ctw**6*vp
     & aup*vpadn/qs*ts*mw**4+1d0/4*sdet4iwhtsus/ctw**6*vpaup*vpadn*ts*mw
     & **2+1d0/2*sdet4iwhtsus/ctw**4*vpadn*mw**2*mh**2+1d0/2*sdet4iwhtsu
     & s/ctw**2*vpadn/qs*mw**2*mh**4-1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*
     & mw**4*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*ts*mw**2*mh**2-1d0
     & /2*sdet4iwhtsus/ctw**2*vpadn/qs*ts*mw**4+1d0/2*sdet4iwhtsus/ctw**
     & 2*vpadn*ts*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn*ts*mw**2+1d0/2*s
     & det4iwhtsus/ctw**2*vpadn*ts**2)
     & +propiwqs*c0hupuswwdn*stw**2*qdn*(-2-1d0/qs*mh**2+1d0/qs*mw**2-1d
     & 0/qs*us+sdet4iwhtsus*mw**2*mh**2+sdet4iwhtsus*us*mh**2+sdet4iwhts
     & us*us**2)
     & +propiwqs*c0hupuswwdn*(-1d0/4/ctw**2*vpadn/qs*mh**2-1d0/2/ctw**2*
     & vpadn/qs*mw**2-1d0/4/ctw**2*vpadn/qs*us-1d0/2*vpadn/qs*mh**2+1d0/
     & 2*vpadn/qs*mw**2-1d0/2*vpadn/qs*us-vpadn-sdet3ichus*mw**2+1d0/2*s
     & det4iwhtsus/ctw**2*vpadn/qs*mw**2*mh**4-1d0/2*sdet4iwhtsus/ctw**2
     & *vpadn/qs*mw**4*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*us*mw**2
     & *mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*us*mw**4-1d0/2*sdet4iwh
     & tsus/ctw**2*vpadn*us*mw**2+1d0/2*sdet4iwhtsus*vpadn*mw**2*mh**2+1
     & d0/2*sdet4iwhtsus*vpadn*us*mh**2+1d0/2*sdet4iwhtsus*vpadn*us**2)
     & +propiwqs*c0hupuszzup*(-1d0/2/ctw**4*vpaup/qs*mw**2+1d0/2/ctw**4*
     & vpaup*vpadn/qs*mh**2+1d0/2/ctw**4*vpaup*vpadn/qs*us+1d0/2/ctw**4*
     & vpaup*vpadn+3d0/4/ctw**2*vpaup/qs*mh**2+1d0/2/ctw**2*vpaup/qs*mw*
     & *2+3d0/4/ctw**2*vpaup/qs*us+1d0/ctw**2*vpaup-1d0/2*sdet3ichus/ctw
     & **6*vpaup**2*mw**2+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*mw**4
     & *mh**2+1d0/4*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*us*mw**4+1d0/4*sd
     & et4iwhtsus/ctw**6*vpaup*vpadn/qs*ts*mw**2*mh**2+1d0/4*sdet4iwhtsu
     & s/ctw**6*vpaup*vpadn*us*mw**2-1d0/2*sdet4iwhtsus/ctw**4*vpaup*mw*
     & *2*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mw**2*mh**4+1d0/2*sde
     & t4iwhtsus/ctw**2*vpaup/qs*mw**4*mh**2-1d0/2*sdet4iwhtsus/ctw**2*v
     & paup/qs*us*mw**2*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*us*mw**
     & 4-1d0/2*sdet4iwhtsus/ctw**2*vpaup*us*mh**2+1d0/2*sdet4iwhtsus/ctw
     & **2*vpaup*us*mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*us**2)
     & +propiwqs*c0wdnuswzdn*(3d0/4/ctw**2*vpadn/qs*mw**2+1d0/4/ctw**2*v
     & padn/qs*us+1d0/2*vpadn/qs*us-1d0/2*sdet4iwhtsus/ctw**2*vpadn*us*m
     & w**2-1d0/2*sdet4iwhtsus*vpadn/qs*mw**4*mh**2+1d0/2*sdet4iwhtsus*v
     & padn/qs*mw**6-1d0/2*sdet4iwhtsus*vpadn/qs*us*mw**2*mh**2+1d0/2*sd
     & et4iwhtsus*vpadn/qs*us*mw**4+1d0/2*sdet4iwhtsus*vpadn*mw**4+1d0/2
     & *sdet4iwhtsus*vpadn*us*mw**2+1d0/2*sdet4iwhtsus*vpadn*us**2)
     & +propiwqs*c0wdnuszwup*(1d0/2/ctw**4*vpaup/qs*mw**2-5d0/4/ctw**2*v
     & paup/qs*mw**2-3d0/4/ctw**2*vpaup/qs*us+1d0/2*sdet4iwhtsus/ctw**4*
     & vpaup/qs*mw**4*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*mw**6+1d0
     & /2*sdet4iwhtsus/ctw**4*vpaup/qs*us*mw**2*mh**2-1d0/2*sdet4iwhtsus
     & /ctw**4*vpaup/qs*us*mw**4-1d0/2*sdet4iwhtsus/ctw**4*vpaup*mw**4-1
     & d0/2*sdet4iwhtsus/ctw**2*vpaup*us**2)
     & +propiwqs*c0wdnusupdnz*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2+1d0/2/c
     & tw**4*vpaup*vpadn/qs*us-1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*
     & mw**4*mh**2-1d0/4*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*us*mw**2*mh*
     & *2-1d0/4*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*ts*mw**4-1d0/4*sdet4i
     & whtsus/ctw**6*vpaup*vpadn*us*mw**2)
     & +propiwqs*c0wuptswzup*(-3d0/4/ctw**2*vpaup/qs*mw**2-1d0/4/ctw**2*
     & vpaup/qs*ts-1d0/2*vpaup/qs*ts+1d0/2*sdet4iwhtsus/ctw**2*vpaup*ts*
     & mw**2+1d0/2*sdet4iwhtsus*vpaup/qs*mw**4*mh**2-1d0/2*sdet4iwhtsus*
     & vpaup/qs*mw**6+1d0/2*sdet4iwhtsus*vpaup/qs*ts*mw**2*mh**2-1d0/2*s
     & det4iwhtsus*vpaup/qs*ts*mw**4-1d0/2*sdet4iwhtsus*vpaup*mw**4-1d0/
     & 2*sdet4iwhtsus*vpaup*ts*mw**2-1d0/2*sdet4iwhtsus*vpaup*ts**2)
     & +propiwqs*c0wuptszwdn*(-1d0/2/ctw**4*vpadn/qs*mw**2+5d0/4/ctw**2*
     & vpadn/qs*mw**2+3d0/4/ctw**2*vpadn/qs*ts-1d0/2*sdet4iwhtsus/ctw**4
     & *vpadn/qs*mw**4*mh**2+1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*mw**6-1d
     & 0/2*sdet4iwhtsus/ctw**4*vpadn/qs*ts*mw**2*mh**2+1d0/2*sdet4iwhtsu
     & s/ctw**4*vpadn/qs*ts*mw**4+1d0/2*sdet4iwhtsus/ctw**4*vpadn*mw**4+
     & 1d0/2*sdet4iwhtsus/ctw**2*vpadn*ts**2)
     & +propiwqs*c0wuptsdnupz*(-1d0/2/ctw**4*vpaup*vpadn/qs*mh**2-1d0/2/
     & ctw**4*vpaup*vpadn/qs*us-1d0/2/ctw**4*vpaup*vpadn-1d0/2*sdet4iwht
     & sus/ctw**6*vpaup*vpadn/qs*mw**4*mh**2-1d0/4*sdet4iwhtsus/ctw**6*v
     & paup*vpadn/qs*us*mw**4-1d0/4*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*t
     & s*mw**2*mh**2-1d0/4*sdet4iwhtsus/ctw**6*vpaup*vpadn*ts*mw**2)
     & +propiwqs*c0whqswzz*(2+3d0/4/ctw**2*vpadn/qs*mh**2-3d0/4/ctw**2*v
     & padn/qs*mw**2-1d0/4/ctw**2*vpadn-3d0/4/ctw**2*vpaup/qs*mh**2+3d0/
     & 4/ctw**2*vpaup/qs*mw**2+1d0/4/ctw**2*vpaup+1d0/16*det3iwhqs/ctw**
     & 4*mw**4+1d0/16*det3iwhqs/ctw**4*qs*mw**2+1d0/16*det3iwhqs/ctw**2*
     & mh**4+21d0/16*det3iwhqs/ctw**2*mw**2*mh**2+9d0/8*det3iwhqs/ctw**2
     & *mw**4+1d0/16*det3iwhqs/ctw**2*qs*mh**2+9d0/8*det3iwhqs/ctw**2*qs
     & *mw**2-1d0/8*det3iwhqs*mh**4-41d0/16*det3iwhqs*mw**2*mh**2-5d0/4*
     & det3iwhqs*mw**4-1d0/16*det3iwhqs*qs*mh**2-5d0/4*det3iwhqs*qs*mw**
     & 2+1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*mw**4*mh**2-1d0/2*sdet4iwhts
     & us/ctw**4*vpadn/qs*mw**6+1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*ts*mw
     & **2*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*ts*mw**4-1d0/2*sdet4
     & iwhtsus/ctw**4*vpadn*mw**4+1d0/2*sdet4iwhtsus/ctw**4*vpadn*us*mw*
     & *2-1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*mw**4*mh**2+1d0/2*sdet4iwht
     & sus/ctw**4*vpaup/qs*mw**6-1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*us*m
     & w**2*mh**2+1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*us*mw**4+1d0/2*sdet
     & 4iwhtsus/ctw**4*vpaup*mw**4-1d0/2*sdet4iwhtsus/ctw**4*vpaup*ts*mw
     & **2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*mw**2*mh**4+1d0/2*sdet4iwh
     & tsus/ctw**2*vpadn/qs*mw**4*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/
     & qs*ts*mw**2*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*ts*mw**4+1d0
     & /2*sdet4iwhtsus/ctw**2*vpadn*ts*mw**2-1d0/2*sdet4iwhtsus/ctw**2*v
     & padn*ts**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mw**2*mh**4-1d0/2*s
     & det4iwhtsus/ctw**2*vpaup/qs*mw**4*mh**2+1d0/2*sdet4iwhtsus/ctw**2
     & *vpaup/qs*us*mw**2*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*us*mw
     & **4-1d0/2*sdet4iwhtsus/ctw**2*vpaup*us*mw**2+1d0/2*sdet4iwhtsus/c
     & tw**2*vpaup*us**2)
     & +propiwqs*c0whqswhh*(-3d0/16*det3iwhqs/mw**2*mh**6-3d0/8*det3iwhq
     & s*mh**4-27d0/16*det3iwhqs*mw**2*mh**2-3d0/4*det3iwhqs*mw**4-3d0/1
     & 6*det3iwhqs*qs*mh**2-3d0/4*det3iwhqs*qs*mw**2)
     & +propiwqs*c0whqszww*stw**2*(-3d0/2-det3iwhqs*mw**4-det3iwhqs*qs*m
     & w**2)
     & +propiwqs*c0whqszww*(2+1d0/4/ctw**2*vpadn/qs*mh**2-1d0/4/ctw**2*v
     & padn/qs*mw**2-1d0/4/ctw**2*vpaup/qs*mh**2+1d0/4/ctw**2*vpaup/qs*m
     & w**2+1d0/2*vpadn/qs*mh**2-1d0/2*vpadn/qs*mw**2-1d0/4*vpadn-1d0/2*
     & vpaup/qs*mh**2+1d0/2*vpaup/qs*mw**2+1d0/4*vpaup-1d0/8*det3iwhqs/c
     & tw**4*mw**2*mh**2-1d0/16*det3iwhqs/ctw**4*mw**4-1d0/16*det3iwhqs/
     & ctw**4*qs*mw**2-1d0/16*det3iwhqs/ctw**2*mh**4-3d0/16*det3iwhqs/ct
     & w**2*mw**2*mh**2-1d0/8*det3iwhqs/ctw**2*mw**4-1d0/16*det3iwhqs/ct
     & w**2*qs*mh**2-1d0/8*det3iwhqs/ctw**2*qs*mw**2-15d0/16*det3iwhqs*m
     & w**2*mh**2+1d0/8*det3iwhqs*mw**4+1d0/16*det3iwhqs*qs*mh**2+1d0/8*
     & det3iwhqs*qs*mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*mw**2*mh**4
     & +1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*mw**4*mh**2-1d0/2*sdet4iwhtsu
     & s/ctw**2*vpadn/qs*us*mw**2*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn/
     & qs*us*mw**4-1d0/2*sdet4iwhtsus/ctw**2*vpadn*mw**2*mh**2+1d0/2*sde
     & t4iwhtsus/ctw**2*vpadn*us*mw**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup/q
     & s*mw**2*mh**4-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mw**4*mh**2+1d0/
     & 2*sdet4iwhtsus/ctw**2*vpaup/qs*ts*mw**2*mh**2-1d0/2*sdet4iwhtsus/
     & ctw**2*vpaup/qs*ts*mw**4+1d0/2*sdet4iwhtsus/ctw**2*vpaup*mw**2*mh
     & **2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*ts*mw**2+1d0/2*sdet4iwhtsus*v
     & padn/qs*mw**4*mh**2-1d0/2*sdet4iwhtsus*vpadn/qs*mw**6+1d0/2*sdet4
     & iwhtsus*vpadn/qs*us*mw**2*mh**2-1d0/2*sdet4iwhtsus*vpadn/qs*us*mw
     & **4+1d0/2*sdet4iwhtsus*vpadn*mw**2*mh**2-1d0/2*sdet4iwhtsus*vpadn
     & *mw**4-1d0/2*sdet4iwhtsus*vpadn*us**2+1d0/2*sdet4iwhtsus*vpadn*ts
     & *mw**2-1d0/2*sdet4iwhtsus*vpaup/qs*mw**4*mh**2+1d0/2*sdet4iwhtsus
     & *vpaup/qs*mw**6-1d0/2*sdet4iwhtsus*vpaup/qs*ts*mw**2*mh**2+1d0/2*
     & sdet4iwhtsus*vpaup/qs*ts*mw**4-1d0/2*sdet4iwhtsus*vpaup*mw**2*mh*
     & *2+1d0/2*sdet4iwhtsus*vpaup*mw**4-1d0/2*sdet4iwhtsus*vpaup*us*mw*
     & *2+1d0/2*sdet4iwhtsus*vpaup*ts**2)
     & +propiwqs*c0whqshww*(-3d0/16*det3iwhqs/mw**2*mh**6-det3iwhqs*mh**
     & 4-55d0/16*det3iwhqs*mw**2*mh**2-11d0/8*det3iwhqs*mw**4-1d0/8*det3
     & iwhqs*qs/mw**2*mh**4-7d0/16*det3iwhqs*qs*mh**2-11d0/8*det3iwhqs*q
     & s*mw**2)
     & +propiwqs*c0whqsmnmomo*cfl*(-1d0/4/mw**2*mmo**2-3d0/8*det3iwhqs/m
     & w**2*mh**2*mmo**4-3d0/8*det3iwhqs*mmo**4+1d0/8*det3iwhqs*mh**2*mm
     & o**2-1d0/8*det3iwhqs*mw**2*mmo**2-1d0/16*det3iwhqs*us/mw**2*mh**2
     & *mmo**2-1d0/16*det3iwhqs*us*mmo**2-1d0/4*det3iwhqs*ts/mw**2*mmo**
     & 4-1d0/4*det3iwhqs*ts*mmo**2-1d0/16*det3iwhqs*ts*us/mw**2*mmo**2-1
     & d0/16*det3iwhqs*ts**2/mw**2*mmo**2-3d0/8*det3iwhqs*qs/mw**2*mmo**
     & 4-1d0/8*det3iwhqs*qs*mmo**2-1d0/16*det3iwhqs*qs*us/mw**2*mmo**2)
     & +propiwqs*c0whqschstst*cfq*(-1d0/4/mw**2*mst**2-3d0/8*det3iwhqs/m
     & w**2*mh**2*mst**4+3d0/8*det3iwhqs/mw**2*mh**2*mch**2*mst**2-3d0/8
     & *det3iwhqs*mst**4+3d0/8*det3iwhqs*mch**2*mst**2+1d0/8*det3iwhqs*m
     & h**2*mst**2-1d0/8*det3iwhqs*mw**2*mst**2-1d0/16*det3iwhqs*us/mw**
     & 2*mh**2*mst**2-1d0/16*det3iwhqs*us*mst**2-1d0/4*det3iwhqs*ts/mw**
     & 2*mst**4+1d0/4*det3iwhqs*ts/mw**2*mch**2*mst**2-1d0/4*det3iwhqs*t
     & s*mst**2-1d0/16*det3iwhqs*ts*us/mw**2*mst**2-1d0/16*det3iwhqs*ts*
     & *2/mw**2*mst**2-3d0/8*det3iwhqs*qs/mw**2*mst**4+3d0/8*det3iwhqs*q
     & s/mw**2*mch**2*mst**2-1d0/8*det3iwhqs*qs*mst**2-1d0/16*det3iwhqs*
     & qs*us/mw**2*mst**2)
     & +propiwqs*c0whqsstchch*cfq*(-1d0/4/mw**2*mch**2+1d0/8*det3iwhqs/m
     & w**2*mh**2*mch**2*mst**2-1d0/8*det3iwhqs/mw**2*mh**2*mch**4+1d0/8
     & *det3iwhqs*mch**2*mst**2-1d0/8*det3iwhqs*mch**4+3d0/8*det3iwhqs*m
     & h**2*mch**2+1d0/8*det3iwhqs*mw**2*mch**2+1d0/16*det3iwhqs*us/mw**
     & 2*mh**2*mch**2+1d0/16*det3iwhqs*us*mch**2-1d0/4*det3iwhqs*ts/mw**
     & 2*mch**2*mst**2+1d0/4*det3iwhqs*ts/mw**2*mch**4+1d0/4*det3iwhqs*t
     & s*mch**2+1d0/16*det3iwhqs*ts*us/mw**2*mch**2+1d0/16*det3iwhqs*ts*
     & *2/mw**2*mch**2+1d0/8*det3iwhqs*qs/mw**2*mch**2*mst**2-1d0/8*det3
     & iwhqs*qs/mw**2*mch**4+1d0/8*det3iwhqs*qs*mch**2+1d0/16*det3iwhqs*
     & qs*us/mw**2*mch**2)
     & +propiwqs*c0whqstntata*cfl*(-1d0/4/mw**2*mta**2-3d0/8*det3iwhqs/m
     & w**2*mh**2*mta**4-3d0/8*det3iwhqs*mta**4+1d0/8*det3iwhqs*mh**2*mt
     & a**2-1d0/8*det3iwhqs*mw**2*mta**2-1d0/16*det3iwhqs*us/mw**2*mh**2
     & *mta**2-1d0/16*det3iwhqs*us*mta**2-1d0/4*det3iwhqs*ts/mw**2*mta**
     & 4-1d0/4*det3iwhqs*ts*mta**2-1d0/16*det3iwhqs*ts*us/mw**2*mta**2-1
     & d0/16*det3iwhqs*ts**2/mw**2*mta**2-3d0/8*det3iwhqs*qs/mw**2*mta**
     & 4-1d0/8*det3iwhqs*qs*mta**2-1d0/16*det3iwhqs*qs*us/mw**2*mta**2)
     & +propiwqs*c0whqstpbtbt*cfq*(-1d0/4/mw**2*mbt**2-3d0/8*det3iwhqs/m
     & w**2*mh**2*mbt**4+3d0/8*det3iwhqs/mw**2*mh**2*mtp**2*mbt**2-3d0/8
     & *det3iwhqs*mbt**4+3d0/8*det3iwhqs*mtp**2*mbt**2+1d0/8*det3iwhqs*m
     & h**2*mbt**2-1d0/8*det3iwhqs*mw**2*mbt**2-1d0/16*det3iwhqs*us/mw**
     & 2*mh**2*mbt**2-1d0/16*det3iwhqs*us*mbt**2-1d0/4*det3iwhqs*ts/mw**
     & 2*mbt**4+1d0/4*det3iwhqs*ts/mw**2*mtp**2*mbt**2-1d0/4*det3iwhqs*t
     & s*mbt**2-1d0/16*det3iwhqs*ts*us/mw**2*mbt**2-1d0/16*det3iwhqs*ts*
     & *2/mw**2*mbt**2-3d0/8*det3iwhqs*qs/mw**2*mbt**4+3d0/8*det3iwhqs*q
     & s/mw**2*mtp**2*mbt**2-1d0/8*det3iwhqs*qs*mbt**2-1d0/16*det3iwhqs*
     & qs*us/mw**2*mbt**2)
     & +propiwqs*c0whqsbttptp*cfq*(-1d0/4/mw**2*mtp**2+1d0/8*det3iwhqs/m
     & w**2*mh**2*mtp**2*mbt**2-1d0/8*det3iwhqs/mw**2*mh**2*mtp**4+1d0/8
     & *det3iwhqs*mtp**2*mbt**2-1d0/8*det3iwhqs*mtp**4+3d0/8*det3iwhqs*m
     & h**2*mtp**2+1d0/8*det3iwhqs*mw**2*mtp**2+1d0/16*det3iwhqs*us/mw**
     & 2*mh**2*mtp**2+1d0/16*det3iwhqs*us*mtp**2-1d0/4*det3iwhqs*ts/mw**
     & 2*mtp**2*mbt**2+1d0/4*det3iwhqs*ts/mw**2*mtp**4+1d0/4*det3iwhqs*t
     & s*mtp**2+1d0/16*det3iwhqs*ts*us/mw**2*mtp**2+1d0/16*det3iwhqs*ts*
     & *2/mw**2*mtp**2+1d0/8*det3iwhqs*qs/mw**2*mtp**2*mbt**2-1d0/8*det3
     & iwhqs*qs/mw**2*mtp**4+1d0/8*det3iwhqs*qs*mtp**2+1d0/16*det3iwhqs*
     & qs*us/mw**2*mtp**2)
     & +propiwqs*c0whqscww*stw**2*(3d0/2+det3iwhqs*mw**4+det3iwhqs*qs*mw
     & **2)
     & +propiwqs*c0whqscww*stw**2*qdn*(-1d0/2+1d0/qs*mh**2-1d0/qs*mw**2+
     & sdet4iwhtsus/qs*mw**4*mh**2-sdet4iwhtsus/qs*mw**6+sdet4iwhtsus/qs
     & *us*mw**2*mh**2-sdet4iwhtsus/qs*us*mw**4+sdet4iwhtsus*mw**2*mh**2
     & -sdet4iwhtsus*mw**4-sdet4iwhtsus*us**2+sdet4iwhtsus*ts*mw**2-sdet
     & 4iwhtsus**2/qs*mw**6*mh**4-sdet4iwhtsus**2/qs*mw**8*mh**2-3*sdet4
     & iwhtsus**2/qs*us*mw**4*mh**4-sdet4iwhtsus**2/qs*us*mw**6*mh**2-sd
     & et4iwhtsus**2/qs*us*mw**8-3*sdet4iwhtsus**2/qs*us**2*mw**2*mh**4-
     & sdet4iwhtsus**2/qs*us**2*mw**4*mh**2-2*sdet4iwhtsus**2/qs*us**2*m
     & w**6-sdet4iwhtsus**2/qs*us**3*mh**4-3*sdet4iwhtsus**2/qs*us**3*mw
     & **2*mh**2-2*sdet4iwhtsus**2/qs*us**4*mh**2-sdet4iwhtsus**2/qs*us*
     & *5-sdet4iwhtsus**2*mw**6*mh**2-5*sdet4iwhtsus**2*us*mw**4*mh**2-2
     & *sdet4iwhtsus**2*us*mw**6-7*sdet4iwhtsus**2*us**2*mw**2*mh**2-5*s
     & det4iwhtsus**2*us**2*mw**4-3*sdet4iwhtsus**2*us**3*mh**2-6*sdet4i
     & whtsus**2*us**3*mw**2-3*sdet4iwhtsus**2*us**4-sdet4iwhtsus**2*qs*
     & us*mw**4-3*sdet4iwhtsus**2*qs*us**2*mw**2-2*sdet4iwhtsus**2*qs*us
     & **3)
     & +propiwqs*c0whqscww*stw**2*qup*(1d0/2-1d0/qs*mh**2+1d0/qs*mw**2-s
     & det4iwhtsus/qs*mw**4*mh**2+sdet4iwhtsus/qs*mw**6-sdet4iwhtsus/qs*
     & ts*mw**2*mh**2+sdet4iwhtsus/qs*ts*mw**4-sdet4iwhtsus*mw**2*mh**2+
     & sdet4iwhtsus*mw**4-sdet4iwhtsus*us*mw**2+sdet4iwhtsus*ts**2+sdet4
     & iwhtsus**2/qs*mw**6*mh**4+sdet4iwhtsus**2/qs*mw**8*mh**2+3*sdet4i
     & whtsus**2/qs*ts*mw**4*mh**4+sdet4iwhtsus**2/qs*ts*mw**6*mh**2+sde
     & t4iwhtsus**2/qs*ts*mw**8+3*sdet4iwhtsus**2/qs*ts**2*mw**2*mh**4+s
     & det4iwhtsus**2/qs*ts**2*mw**4*mh**2+2*sdet4iwhtsus**2/qs*ts**2*mw
     & **6+sdet4iwhtsus**2/qs*ts**3*mh**4+3*sdet4iwhtsus**2/qs*ts**3*mw*
     & *2*mh**2+2*sdet4iwhtsus**2/qs*ts**4*mh**2+sdet4iwhtsus**2/qs*ts**
     & 5+sdet4iwhtsus**2*mw**6*mh**2+5*sdet4iwhtsus**2*ts*mw**4*mh**2+2*
     & sdet4iwhtsus**2*ts*mw**6+7*sdet4iwhtsus**2*ts**2*mw**2*mh**2+5*sd
     & et4iwhtsus**2*ts**2*mw**4+3*sdet4iwhtsus**2*ts**3*mh**2+6*sdet4iw
     & htsus**2*ts**3*mw**2+3*sdet4iwhtsus**2*ts**4+sdet4iwhtsus**2*qs*t
     & s*mw**4+3*sdet4iwhtsus**2*qs*ts**2*mw**2+2*sdet4iwhtsus**2*qs*ts*
     & *3)
     & +propiwqs*a0fw*stw**2*(det3iwhqs*mw**2)
     & +propiwqs*a0fw*stw**2*qdn*(-1d0/qs)
     & +propiwqs*a0fw*stw**2*qup*(1d0/qs)
     & +propiwqs*a0fw*(1d0/12/ctw**2/qs+1d0/12/qs/mw**2*mh**2-1d0/6/qs-1
     & d0/2*vpadn/qs+1d0/2*vpaup/qs)
     & +propiwqs*a0fz*(-1d0/12/ctw**4/qs+1d0/2/ctw**4*vpaup*vpadn/qs-7d0
     & /12/ctw**2/qs-1d0/2/ctw**2*vpadn/qs+1d0/2/ctw**2*vpaup/qs+2d0/3/q
     & s)
     & +propiwqs*a0fh*(-1d0/12/qs/mw**4*mh**4+1d0/12/qs/mw**2*mh**2)
     & +propiwqs*a0fmo*cfl*(1d0/6/qs/mw**4*mmo**4)
     & +propiwqs*a0fch*cfq*(-1d0/6/qs/mw**4*mch**2*mst**2+1d0/6/qs/mw**4
     & *mch**4)
     & +propiwqs*a0fst*cfq*(1d0/6/qs/mw**4*mst**4-1d0/6/qs/mw**4*mch**2*
     & mst**2)
     & +propiwqs*a0fta*cfl*(1d0/6/qs/mw**4*mta**4)
     & +propiwqs*a0ftp*cfq*(-1d0/6/qs/mw**4*mtp**2*mbt**2+1d0/6/qs/mw**4
     & *mtp**4)
     & +propiwqs*a0fbt*cfq*(1d0/6/qs/mw**4*mbt**4-1d0/6/qs/mw**4*mtp**2*
     & mbt**2)
     & +propiwqs*b0fhww*(1d0/8*det3iwhqs/ctw**2*mh**2+1d0/16*det3iwhqs/c
     & tw**2*mw**2+1d0/16*det3iwhqs/ctw**2*qs+3d0/16*det3iwhqs/mw**2*mh*
     & *4+3d0/2*det3iwhqs*mh**2+det3iwhqs*mw**2+1d0/8*det3iwhqs*qs/mw**2
     & *mh**2+det3iwhqs*qs-sdet3ichts-sdet3ichus)
     & +propiwqs*b0fhzz*(-1d0/16*det3iwhqs/ctw**2*mh**2+1d0/32*det3iwhqs
     & /mw**2*mh**4+25d0/32*det3iwhqs*mh**2+5d0/8*det3iwhqs*mw**2+1d0/32
     & *det3iwhqs*qs/mw**2*mh**2+5d0/8*det3iwhqs*qs-1d0/2*sdet3ichts/ctw
     & **4*vpadn**2-1d0/2*sdet3ichus/ctw**4*vpaup**2)
     & +propiwqs*b0fhhh*(-9d0/32*det3iwhqs/mw**2*mh**4-27d0/32*det3iwhqs
     & *mh**2-3d0/8*det3iwhqs*mw**2-3d0/32*det3iwhqs*qs/mw**2*mh**2-3d0/
     & 8*det3iwhqs*qs)
     & +propiwqs*b0fhmomo*cfl*(-1d0/4*det3iwhqs/mw**2*mh**2*mmo**2-1d0/4
     & *det3iwhqs*mmo**2-1d0/4*det3iwhqs*ts/mw**2*mmo**2-1d0/4*det3iwhqs
     & *qs/mw**2*mmo**2)
     & +propiwqs*b0fhchch*cfq*(1d0/4*det3iwhqs*ts/mw**2*mch**2)
     & +propiwqs*b0fhstst*cfq*(-1d0/4*det3iwhqs/mw**2*mh**2*mst**2-1d0/4
     & *det3iwhqs*mst**2-1d0/4*det3iwhqs*ts/mw**2*mst**2-1d0/4*det3iwhqs
     & *qs/mw**2*mst**2)
     & +propiwqs*b0fhtata*cfl*(-1d0/4*det3iwhqs/mw**2*mh**2*mta**2-1d0/4
     & *det3iwhqs*mta**2-1d0/4*det3iwhqs*ts/mw**2*mta**2-1d0/4*det3iwhqs
     & *qs/mw**2*mta**2)
     & +propiwqs*b0fhtptp*cfq*(1d0/4*det3iwhqs*ts/mw**2*mtp**2)
     & +propiwqs*b0fhbtbt*cfq*(-1d0/4*det3iwhqs/mw**2*mh**2*mbt**2-1d0/4
     & *det3iwhqs*mbt**2-1d0/4*det3iwhqs*ts/mw**2*mbt**2-1d0/4*det3iwhqs
     & *qs/mw**2*mbt**2)
     & +propiwqs*b0fwwz*stw**2*(det3iwhqs*mw**2)
     & +propiwqs*b0fwwz*(-1d0/16*det3iwhqs/ctw**4*mw**2-7d0/16*det3iwhqs
     & /ctw**2*mw**2-3d0/16*det3iwhqs*mh**2-11d0/16*det3iwhqs*mw**2-1d0/
     & 16*det3iwhqs*qs)
     & +propiwqs*b0fwwh*(1d0/16*det3iwhqs/mw**2*mh**4+1d0/16*det3iwhqs*m
     & h**2-1d0/8*det3iwhqs*mw**2+1d0/16*det3iwhqs*qs/mw**2*mh**2)
     & +propiwqs*b0fwmnmo*cfl*(1d0/8*det3iwhqs/mw**2*mmo**4-1d0/16*det3i
     & whqs/mw**2*mh**2*mmo**2+1d0/16*det3iwhqs*mmo**2-1d0/8*det3iwhqs*t
     & s/mw**2*mmo**2-1d0/16*det3iwhqs*qs/mw**2*mmo**2)
     & +propiwqs*b0fwchst*cfq*(1d0/8*det3iwhqs/mw**2*mst**4-1d0/4*det3iw
     & hqs/mw**2*mch**2*mst**2+1d0/8*det3iwhqs/mw**2*mch**4-1d0/16*det3i
     & whqs/mw**2*mh**2*mst**2+1d0/16*det3iwhqs/mw**2*mh**2*mch**2+1d0/1
     & 6*det3iwhqs*mst**2+3d0/16*det3iwhqs*mch**2-1d0/8*det3iwhqs*ts/mw*
     & *2*mst**2+1d0/8*det3iwhqs*ts/mw**2*mch**2-1d0/16*det3iwhqs*qs/mw*
     & *2*mst**2+1d0/16*det3iwhqs*qs/mw**2*mch**2)
     & +propiwqs*b0fwtnta*cfl*(1d0/8*det3iwhqs/mw**2*mta**4-1d0/16*det3i
     & whqs/mw**2*mh**2*mta**2+1d0/16*det3iwhqs*mta**2-1d0/8*det3iwhqs*t
     & s/mw**2*mta**2-1d0/16*det3iwhqs*qs/mw**2*mta**2)
     & +propiwqs*b0fwtpbt*cfq*(1d0/8*det3iwhqs/mw**2*mbt**4-1d0/4*det3iw
     & hqs/mw**2*mtp**2*mbt**2+1d0/8*det3iwhqs/mw**2*mtp**4-1d0/16*det3i
     & whqs/mw**2*mh**2*mbt**2+1d0/16*det3iwhqs/mw**2*mh**2*mtp**2+1d0/1
     & 6*det3iwhqs*mbt**2+3d0/16*det3iwhqs*mtp**2-1d0/8*det3iwhqs*ts/mw*
     & *2*mbt**2+1d0/8*det3iwhqs*ts/mw**2*mtp**2-1d0/16*det3iwhqs*qs/mw*
     & *2*mbt**2+1d0/16*det3iwhqs*qs/mw**2*mtp**2)
     & +propiwqs*b0fqswz*stw**2*(2d0/3/qs+1d0/2*det3iwhqs*mh**2-1d0/2*de
     & t3iwhqs*mw**2+1d0/2*det3iwhqs*qs)
     & +propiwqs*b0fqswz*(-1d0/12/ctw**4/qs-1d0/2/ctw**2/qs-1d0/2/ctw**2
     & *vpadn/qs+1d0/2/ctw**2*vpaup/qs+7d0/12/qs-1d0/2*vpadn/qs+1d0/2*vp
     & aup/qs+1d0/16*det3iwhqs/ctw**4*mw**2-1d0/16*det3iwhqs/ctw**2*mh**
     & 2+3d0/8*det3iwhqs/ctw**2*mw**2-1d0/16*det3iwhqs/ctw**2*qs-1d0/16*
     & det3iwhqs/mw**2*mh**4-19d0/16*det3iwhqs*mh**2-1d0/2*det3iwhqs*mw*
     & *2-1d0/16*det3iwhqs*qs/mw**2*mh**2-9d0/8*det3iwhqs*qs)
     & +propiwqs*b0fqswh*(-1d0/12/qs/mw**4*mh**4+1d0/6/qs/mw**2*mh**2-1d
     & 0/12/qs+1d0/16*det3iwhqs/mw**2*mh**4-1d0/8*det3iwhqs*mh**2+1d0/16
     & *det3iwhqs*mw**2-1d0/16*det3iwhqs*qs/mw**2*mh**2-1d0/16*det3iwhqs
     & *qs)
     & +propiwqs*b0fqswc*stw**2*(-2d0/3/qs-1d0/2*det3iwhqs*mh**2+1d0/2*d
     & et3iwhqs*mw**2-1d0/2*det3iwhqs*qs)
     & +propiwqs*b0fqswc*stw**2*qdn*(-1d0/qs)
     & +propiwqs*b0fqswc*stw**2*qup*(1d0/qs)
     & +propiwqs*b0fqsupdn*(1d0/2/ctw**4*vpaup*vpadn/qs)
     & +propiwqs*b0fqsmnmo*cfl*(-1d0/8*det3iwhqs/mw**2*mmo**4+5d0/16*det
     & 3iwhqs/mw**2*mh**2*mmo**2+3d0/16*det3iwhqs*mmo**2+3d0/8*det3iwhqs
     & *ts/mw**2*mmo**2+5d0/16*det3iwhqs*qs/mw**2*mmo**2)
     & +propiwqs*b0fqsmoc*cfl*(1d0/6/qs/mw**4*mmo**4)
     & +propiwqs*b0fqschst*cfq*(1d0/6/qs/mw**4*mst**4-1d0/3/qs/mw**4*mch
     & **2*mst**2+1d0/6/qs/mw**4*mch**4-1d0/8*det3iwhqs/mw**2*mst**4+1d0
     & /4*det3iwhqs/mw**2*mch**2*mst**2-1d0/8*det3iwhqs/mw**2*mch**4+5d0
     & /16*det3iwhqs/mw**2*mh**2*mst**2-1d0/16*det3iwhqs/mw**2*mh**2*mch
     & **2+3d0/16*det3iwhqs*mst**2-3d0/16*det3iwhqs*mch**2+3d0/8*det3iwh
     & qs*ts/mw**2*mst**2-3d0/8*det3iwhqs*ts/mw**2*mch**2+5d0/16*det3iwh
     & qs*qs/mw**2*mst**2-1d0/16*det3iwhqs*qs/mw**2*mch**2)
     & +propiwqs*b0fqstnta*cfl*(-1d0/8*det3iwhqs/mw**2*mta**4+5d0/16*det
     & 3iwhqs/mw**2*mh**2*mta**2+3d0/16*det3iwhqs*mta**2+3d0/8*det3iwhqs
     & *ts/mw**2*mta**2+5d0/16*det3iwhqs*qs/mw**2*mta**2)
     & +propiwqs*b0fqstac*cfl*(1d0/6/qs/mw**4*mta**4)
     & +propiwqs*b0fqstpbt*cfq*(1d0/6/qs/mw**4*mbt**4-1d0/3/qs/mw**4*mtp
     & **2*mbt**2+1d0/6/qs/mw**4*mtp**4-1d0/8*det3iwhqs/mw**2*mbt**4+1d0
     & /4*det3iwhqs/mw**2*mtp**2*mbt**2-1d0/8*det3iwhqs/mw**2*mtp**4+5d0
     & /16*det3iwhqs/mw**2*mh**2*mbt**2-1d0/16*det3iwhqs/mw**2*mh**2*mtp
     & **2+3d0/16*det3iwhqs*mbt**2-3d0/16*det3iwhqs*mtp**2+3d0/8*det3iwh
     & qs*ts/mw**2*mbt**2-3d0/8*det3iwhqs*ts/mw**2*mtp**2+5d0/16*det3iwh
     & qs*qs/mw**2*mbt**2-1d0/16*det3iwhqs*qs/mw**2*mtp**2)
     & +propiwqs*b0ftswup*(sdet3ichts)
     & +propiwqs*b0ftszdn*(1d0/2*sdet3ichts/ctw**4*vpadn**2)
     & +propiwqs*b0fuswdn*(sdet3ichus)
     & +propiwqs*b0fuszup*(1d0/2*sdet3ichus/ctw**4*vpaup**2)
     & +c0updnqswdnz*(2/ctw**2*vpadn*mw**2+vpadn*mw**2)
     & +c0updnqszupw*(-2/ctw**2*vpaup*mw**2-vpaup*mw**2)
     & +c0updnqsupzdn*(1d0/2/ctw**6*vpaup*vpadn*mw**2+1d0/ctw**4*vpaup*v
     & padn*mw**2+1d0/2/ctw**2*vpaup*vpadn*mw**2)
     & +c0whqswzz*(3d0/4/ctw**4*mw**2-5d0/2/ctw**2*mw**2+9d0/4*mh**2-9*m
     & w**2+1d0/8*det3iwhqs/ctw**6*mw**4*mh**2+3d0/4*det3iwhqs/ctw**4*mw
     & **4*mh**2-9d0/2*det3iwhqs/ctw**2*mw**4*mh**2+5*det3iwhqs*mw**4*mh
     & **2)
     & +c0whqswhh*(-3d0/4/mw**2*mh**4+3d0/4*mh**2-3*mw**2+3*det3iwhqs*mw
     & **4*mh**2)
     & +c0whqszww*stw**2*(-2*mh**2+4*mw**2)
     & +c0whqszww*(-1d0/4/ctw**4*mw**2+1d0/4/ctw**2*mh**2+1d0/2/ctw**2*m
     & w**2+2*mh**2-11*mw**2+3d0/8*det3iwhqs/ctw**4*mw**4*mh**2+det3iwhq
     & s/ctw**2*mw**4*mh**2)
     & +c0whqshww*(-1d0/2/mw**2*mh**4-2*mh**2-5*mw**2+6*det3iwhqs*mw**4*
     & mh**2)
     & +c0whqsmnmomo*cfl*(-1d0/2/mw**2*mmo**4+1d0/2*mmo**2-1d0/4*det3iwh
     & qs/mw**2*mh**2*mmo**6+1d0/2*det3iwhqs*mh**2*mmo**4-1d0/4*det3iwhq
     & s*mw**2*mh**2*mmo**2)
     & +c0whqschstst*cfq*(-1d0/2/mw**2*mst**4+1d0/2/mw**2*mch**2*mst**2+
     & 1d0/2*mst**2-1d0/4*det3iwhqs/mw**2*mh**2*mst**6+1d0/2*det3iwhqs/m
     & w**2*mh**2*mch**2*mst**4-1d0/4*det3iwhqs/mw**2*mh**2*mch**4*mst**
     & 2+1d0/2*det3iwhqs*mh**2*mst**4-1d0/2*det3iwhqs*mh**2*mch**2*mst**
     & 2-1d0/4*det3iwhqs*mw**2*mh**2*mst**2)
     & +c0whqsstchch*cfq*(1d0/2/mw**2*mch**2*mst**2-1d0/2/mw**2*mch**4+1
     & d0/2*mch**2-1d0/4*det3iwhqs/mw**2*mh**2*mch**2*mst**4+1d0/2*det3i
     & whqs/mw**2*mh**2*mch**4*mst**2-1d0/4*det3iwhqs/mw**2*mh**2*mch**6
     & -1d0/2*det3iwhqs*mh**2*mch**2*mst**2+1d0/2*det3iwhqs*mh**2*mch**4
     & -1d0/4*det3iwhqs*mw**2*mh**2*mch**2)
     & +c0whqstntata*cfl*(-1d0/2/mw**2*mta**4+1d0/2*mta**2-1d0/4*det3iwh
     & qs/mw**2*mh**2*mta**6+1d0/2*det3iwhqs*mh**2*mta**4-1d0/4*det3iwhq
     & s*mw**2*mh**2*mta**2)
     & +c0whqstpbtbt*cfq*(-1d0/2/mw**2*mbt**4+1d0/2/mw**2*mtp**2*mbt**2+
     & 1d0/2*mbt**2-1d0/4*det3iwhqs/mw**2*mh**2*mbt**6+1d0/2*det3iwhqs/m
     & w**2*mh**2*mtp**2*mbt**4-1d0/4*det3iwhqs/mw**2*mh**2*mtp**4*mbt**
     & 2+1d0/2*det3iwhqs*mh**2*mbt**4-1d0/2*det3iwhqs*mh**2*mtp**2*mbt**
     & 2-1d0/4*det3iwhqs*mw**2*mh**2*mbt**2)
     & +c0whqsbttptp*cfq*(1d0/2/mw**2*mtp**2*mbt**2-1d0/2/mw**2*mtp**4+1
     & d0/2*mtp**2-1d0/4*det3iwhqs/mw**2*mh**2*mtp**2*mbt**4+1d0/2*det3i
     & whqs/mw**2*mh**2*mtp**4*mbt**2-1d0/4*det3iwhqs/mw**2*mh**2*mtp**6
     & -1d0/2*det3iwhqs*mh**2*mtp**2*mbt**2+1d0/2*det3iwhqs*mh**2*mtp**4
     & -1d0/4*det3iwhqs*mw**2*mh**2*mtp**2)
     & +c0whqscww*stw**2*(2*mh**2-4*mw**2)
     & +c0whqscww*stw**2*qdn*(2*sdet4iwhtsus**2/qs*mw**8*mh**4+6*sdet4iw
     & htsus**2/qs*us*mw**6*mh**4+6*sdet4iwhtsus**2/qs*us**2*mw**4*mh**4
     & +4*sdet4iwhtsus**2/qs*us**2*mw**6*mh**2+2*sdet4iwhtsus**2/qs*us**
     & 3*mw**2*mh**4+8*sdet4iwhtsus**2/qs*us**3*mw**4*mh**2+4*sdet4iwhts
     & us**2/qs*us**4*mw**2*mh**2+2*sdet4iwhtsus**2/qs*us**4*mw**4+2*sde
     & t4iwhtsus**2/qs*us**5*mw**2)
     & +c0whqscww*stw**2*qup*(-2*sdet4iwhtsus**2/qs*mw**8*mh**4-6*sdet4i
     & whtsus**2/qs*ts*mw**6*mh**4-6*sdet4iwhtsus**2/qs*ts**2*mw**4*mh**
     & 4-4*sdet4iwhtsus**2/qs*ts**2*mw**6*mh**2-2*sdet4iwhtsus**2/qs*ts*
     & *3*mw**2*mh**4-8*sdet4iwhtsus**2/qs*ts**3*mw**4*mh**2-4*sdet4iwht
     & sus**2/qs*ts**4*mw**2*mh**2-2*sdet4iwhtsus**2/qs*ts**4*mw**4-2*sd
     & et4iwhtsus**2/qs*ts**5*mw**2)
     & +a0fw*stw**2*(-1d0/2)
     & +a0fw*stw**2*qdn*(3)
     & +a0fw*stw**2*qup*(-3)
     & +a0fw*(13d0/2-1d0/8/ctw**2-1d0/8/mw**2*mh**2-3d0/2*mw**2/mh**2+3d
     & 0/2*vpadn-3d0/2*vpaup)
     & +a0fz*(-1+1d0/8/ctw**4-3d0/4/ctw**4*mw**2/mh**2-1d0/2/ctw**4*vpau
     & p*vpadn+3d0/4/ctw**2+1d0/2/ctw**2*vpadn+1d0/8/ctw**2*vpadn**2-1d0
     & /2/ctw**2*vpaup-1d0/ctw**2*vpaup*vpadn+1d0/8/ctw**2*vpaup**2+vpad
     & n-vpaup)
     & +a0fh*(1d0/8/mw**4*mh**4-1d0/2/mw**2*mh**2)
     & +a0fmo*cfl*(-1d0/6/mw**4*mmo**4+1d0/mw**2/mh**2*mmo**4)
     & +a0fch*cfq*(1d0/6/mw**4*mch**2*mst**2-1d0/6/mw**4*mch**4+1d0/mw**
     & 2/mh**2*mch**4)
     & +a0fst*cfq*(-1d0/6/mw**4*mst**4+1d0/6/mw**4*mch**2*mst**2+1d0/mw*
     & *2/mh**2*mst**4)
     & +a0fta*cfl*(-1d0/6/mw**4*mta**4+1d0/mw**2/mh**2*mta**4)
     & +a0ftp*cfq*(1d0/6/mw**4*mtp**2*mbt**2-1d0/6/mw**4*mtp**4+1d0/mw**
     & 2/mh**2*mtp**4)
     & +a0fbt*cfq*(-1d0/6/mw**4*mbt**4+1d0/6/mw**4*mtp**2*mbt**2+1d0/mw*
     & *2/mh**2*mbt**4)
     & +b0fhww*(5d0/2+1d0/4/ctw**2+1d0/4/mw**2*mh**2-3d0/8*det3iwhqs/ctw
     & **2*mw**2*mh**2-5d0/2*det3iwhqs*mw**2*mh**2)
     & +b0fhzz*(1d0/2+1d0/4/ctw**2+1d0/8*det3iwhqs/ctw**4*mw**2*mh**2+de
     & t3iwhqs/ctw**2*mw**2*mh**2-5d0/2*det3iwhqs*mw**2*mh**2)
     & +b0fhhh*(-3d0/2-3d0/4/mw**2*mh**2+3d0/2*det3iwhqs*mw**2*mh**2)
     & +b0fhmomo*cfl*(-1d0/4*det3iwhqs/mw**2*mh**2*mmo**4+1d0/4*det3iwhq
     & s*mh**2*mmo**2)
     & +b0fhchch*cfq*(1d0/4*det3iwhqs/mw**2*mh**2*mch**2*mst**2-1d0/4*de
     & t3iwhqs/mw**2*mh**2*mch**4+1d0/4*det3iwhqs*mh**2*mch**2)
     & +b0fhstst*cfq*(-1d0/4*det3iwhqs/mw**2*mh**2*mst**4+1d0/4*det3iwhq
     & s/mw**2*mh**2*mch**2*mst**2+1d0/4*det3iwhqs*mh**2*mst**2)
     & +b0fhtata*cfl*(-1d0/4*det3iwhqs/mw**2*mh**2*mta**4+1d0/4*det3iwhq
     & s*mh**2*mta**2)
     & +b0fhtptp*cfq*(1d0/4*det3iwhqs/mw**2*mh**2*mtp**2*mbt**2-1d0/4*de
     & t3iwhqs/mw**2*mh**2*mtp**4+1d0/4*det3iwhqs*mh**2*mtp**2)
     & +b0fhbtbt*cfq*(-1d0/4*det3iwhqs/mw**2*mh**2*mbt**4+1d0/4*det3iwhq
     & s/mw**2*mh**2*mtp**2*mbt**2+1d0/4*det3iwhqs*mh**2*mbt**2)
     & +b0fwwz*stw**2*(-2)
     & +b0fwwz*(31d0/12+1d0/24/ctw**4-1d0/4/ctw**2-1d0/16*det3iwhqs/ctw*
     & *4*mw**2*mh**2-5d0/16*det3iwhqs/ctw**2*mw**2*mh**2+7d0/4*det3iwhq
     & s*mw**2*mh**2)
     & +b0fwwh*(-1d0/2+1d0/24/mw**4*mh**4+1d0/6/mw**2*mh**2)
     & +b0fwmnmo*cfl*(1d0/4/mw**2*mmo**2+1d0/8*det3iwhqs/mw**2*mh**2*mmo
     & **4-1d0/16*det3iwhqs/mw**2*mh**4*mmo**2+1d0/16*det3iwhqs*mh**2*mm
     & o**2+1d0/4*det3iwhqs*mw**2*mmo**2-1d0/8*det3iwhqs*ts/mw**2*mh**2*
     & mmo**2+1d0/2*det3iwhqs*ts*mmo**2-1d0/16*det3iwhqs*qs/mw**2*mh**2*
     & mmo**2+1d0/4*det3iwhqs*qs*mmo**2)
     & +b0fwchst*cfq*(1d0/4/mw**2*mst**2+1d0/4/mw**2*mch**2+1d0/8*det3iw
     & hqs/mw**2*mh**2*mst**4-1d0/4*det3iwhqs/mw**2*mh**2*mch**2*mst**2+
     & 1d0/8*det3iwhqs/mw**2*mh**2*mch**4-1d0/16*det3iwhqs/mw**2*mh**4*m
     & st**2+1d0/16*det3iwhqs/mw**2*mh**4*mch**2+1d0/16*det3iwhqs*mh**2*
     & mst**2-5d0/16*det3iwhqs*mh**2*mch**2+1d0/4*det3iwhqs*mw**2*mst**2
     & -1d0/4*det3iwhqs*mw**2*mch**2-1d0/8*det3iwhqs*ts/mw**2*mh**2*mst*
     & *2+1d0/8*det3iwhqs*ts/mw**2*mh**2*mch**2+1d0/2*det3iwhqs*ts*mst**
     & 2-1d0/2*det3iwhqs*ts*mch**2-1d0/16*det3iwhqs*qs/mw**2*mh**2*mst**
     & 2+1d0/16*det3iwhqs*qs/mw**2*mh**2*mch**2+1d0/4*det3iwhqs*qs*mst**
     & 2-1d0/4*det3iwhqs*qs*mch**2)
     & +b0fwtnta*cfl*(1d0/4/mw**2*mta**2+1d0/8*det3iwhqs/mw**2*mh**2*mta
     & **4-1d0/16*det3iwhqs/mw**2*mh**4*mta**2+1d0/16*det3iwhqs*mh**2*mt
     & a**2+1d0/4*det3iwhqs*mw**2*mta**2-1d0/8*det3iwhqs*ts/mw**2*mh**2*
     & mta**2+1d0/2*det3iwhqs*ts*mta**2-1d0/16*det3iwhqs*qs/mw**2*mh**2*
     & mta**2+1d0/4*det3iwhqs*qs*mta**2)
     & +b0fwtpbt*cfq*(1d0/4/mw**2*mbt**2+1d0/4/mw**2*mtp**2+1d0/8*det3iw
     & hqs/mw**2*mh**2*mbt**4-1d0/4*det3iwhqs/mw**2*mh**2*mtp**2*mbt**2+
     & 1d0/8*det3iwhqs/mw**2*mh**2*mtp**4-1d0/16*det3iwhqs/mw**2*mh**4*m
     & bt**2+1d0/16*det3iwhqs/mw**2*mh**4*mtp**2+1d0/16*det3iwhqs*mh**2*
     & mbt**2-5d0/16*det3iwhqs*mh**2*mtp**2+1d0/4*det3iwhqs*mw**2*mbt**2
     & -1d0/4*det3iwhqs*mw**2*mtp**2-1d0/8*det3iwhqs*ts/mw**2*mh**2*mbt*
     & *2+1d0/8*det3iwhqs*ts/mw**2*mh**2*mtp**2+1d0/2*det3iwhqs*ts*mbt**
     & 2-1d0/2*det3iwhqs*ts*mtp**2-1d0/16*det3iwhqs*qs/mw**2*mh**2*mbt**
     & 2+1d0/16*det3iwhqs*qs/mw**2*mh**2*mtp**2+1d0/4*det3iwhqs*qs*mbt**
     & 2-1d0/4*det3iwhqs*qs*mtp**2)
     & +b0fqswz*stw**2*(-4)
     & +b0fqswz*(47d0/12+1d0/12/ctw**4+1d0/2/ctw**2*vpadn-1d0/2/ctw**2*v
     & paup+vpadn-vpaup-1d0/16*det3iwhqs/ctw**4*mw**2*mh**2-5d0/16*det3i
     & whqs/ctw**2*mw**2*mh**2+7d0/4*det3iwhqs*mw**2*mh**2)
     & +b0fqswh*(-1d0/2+1d0/12/mw**4*mh**4+1d0/12/mw**2*mh**2)
     & +b0fqswc*stw**2*(4)
     & +b0fqswc*stw**2*qdn*(2)
     & +b0fqswc*stw**2*qup*(-2)
     & +b0fqsupdn*stw**2*qup*qdn*(-3)
     & +b0fqsupdn*(-1d0/2/ctw**4*vpaup*vpadn-3d0/4/ctw**2*vpaup*vpadn)
     & +b0fqsmnmo*cfl*(1d0/4/mw**2*mmo**2+1d0/8*det3iwhqs/mw**2*mh**2*mm
     & o**4+1d0/16*det3iwhqs/mw**2*mh**4*mmo**2-5d0/16*det3iwhqs*mh**2*m
     & mo**2-1d0/4*det3iwhqs*mw**2*mmo**2+1d0/8*det3iwhqs*ts/mw**2*mh**2
     & *mmo**2-1d0/2*det3iwhqs*ts*mmo**2+1d0/16*det3iwhqs*qs/mw**2*mh**2
     & *mmo**2-1d0/4*det3iwhqs*qs*mmo**2)
     & +b0fqsmoc*cfl*(-1d0/3-1d0/6/mw**4*mmo**4)
     & +b0fqschst*cfq*(-1d0/3-1d0/6/mw**4*mst**4+1d0/3/mw**4*mch**2*mst*
     & *2-1d0/6/mw**4*mch**4+1d0/4/mw**2*mst**2+1d0/4/mw**2*mch**2+1d0/8
     & *det3iwhqs/mw**2*mh**2*mst**4-1d0/4*det3iwhqs/mw**2*mh**2*mch**2*
     & mst**2+1d0/8*det3iwhqs/mw**2*mh**2*mch**4+1d0/16*det3iwhqs/mw**2*
     & mh**4*mst**2-1d0/16*det3iwhqs/mw**2*mh**4*mch**2-5d0/16*det3iwhqs
     & *mh**2*mst**2+1d0/16*det3iwhqs*mh**2*mch**2-1d0/4*det3iwhqs*mw**2
     & *mst**2+1d0/4*det3iwhqs*mw**2*mch**2+1d0/8*det3iwhqs*ts/mw**2*mh*
     & *2*mst**2-1d0/8*det3iwhqs*ts/mw**2*mh**2*mch**2-1d0/2*det3iwhqs*t
     & s*mst**2+1d0/2*det3iwhqs*ts*mch**2+1d0/16*det3iwhqs*qs/mw**2*mh**
     & 2*mst**2-1d0/16*det3iwhqs*qs/mw**2*mh**2*mch**2-1d0/4*det3iwhqs*q
     & s*mst**2+1d0/4*det3iwhqs*qs*mch**2)
     & +b0fqstnta*cfl*(1d0/4/mw**2*mta**2+1d0/8*det3iwhqs/mw**2*mh**2*mt
     & a**4+1d0/16*det3iwhqs/mw**2*mh**4*mta**2-5d0/16*det3iwhqs*mh**2*m
     & ta**2-1d0/4*det3iwhqs*mw**2*mta**2+1d0/8*det3iwhqs*ts/mw**2*mh**2
     & *mta**2-1d0/2*det3iwhqs*ts*mta**2+1d0/16*det3iwhqs*qs/mw**2*mh**2
     & *mta**2-1d0/4*det3iwhqs*qs*mta**2)
     & +b0fqstac*cfl*(-1d0/3-1d0/6/mw**4*mta**4)
     & +b0fqstpbt*cfq*(-1d0/3-1d0/6/mw**4*mbt**4+1d0/3/mw**4*mtp**2*mbt*
     & *2-1d0/6/mw**4*mtp**4+1d0/4/mw**2*mbt**2+1d0/4/mw**2*mtp**2+1d0/8
     & *det3iwhqs/mw**2*mh**2*mbt**4-1d0/4*det3iwhqs/mw**2*mh**2*mtp**2*
     & mbt**2+1d0/8*det3iwhqs/mw**2*mh**2*mtp**4+1d0/16*det3iwhqs/mw**2*
     & mh**4*mbt**2-1d0/16*det3iwhqs/mw**2*mh**4*mtp**2-5d0/16*det3iwhqs
     & *mh**2*mbt**2+1d0/16*det3iwhqs*mh**2*mtp**2-1d0/4*det3iwhqs*mw**2
     & *mbt**2+1d0/4*det3iwhqs*mw**2*mtp**2+1d0/8*det3iwhqs*ts/mw**2*mh*
     & *2*mbt**2-1d0/8*det3iwhqs*ts/mw**2*mh**2*mtp**2-1d0/2*det3iwhqs*t
     & s*mbt**2+1d0/2*det3iwhqs*ts*mtp**2+1d0/16*det3iwhqs*qs/mw**2*mh**
     & 2*mbt**2-1d0/16*det3iwhqs*qs/mw**2*mh**2*mtp**2-1d0/4*det3iwhqs*q
     & s*mbt**2+1d0/4*det3iwhqs*qs*mtp**2)
     & +b0fqscc*cfq*(-1d0/3)
     & +b0fqscc*cfl*(-1d0/3)
     & +137d0/12-1d0/2/ctw**4*mw**2/mh**2+1d0/4/ctw**2-1d0/16/ctw**2*vma
     & dn**2+1d0/8/ctw**2*vpadn**2-1d0/16/ctw**2*vmaup**2-1d0/2/ctw**2*v
     & paup*vpadn+1d0/8/ctw**2*vpaup**2+3d0/4/mw**2*mh**2+1d0/2*tadfer+1
     & d0/2*zh1fer+1d0/2*zw1fer-deltarhofer+1d0/2*zmwzwfer-za1fer-deltar
     & hobos+1d0/2*zmwzwbos-za1bos-mw**2/mh**2-1d0/8*dreal(b0pdnzdn)/ctw
     & **4*vmadn**2*mw**2-1d0/8*dreal(b0pdnzdn)/ctw**4*vpadn**2*mw**2-1d
     & 0/8*dreal(b0pupzup)/ctw**4*vmaup**2*mw**2-1d0/8*dreal(b0pupzup)/c
     & tw**4*vpaup**2*mw**2+1d0/8*dreal(b0phww)/mw**2*mh**4-1d0/2*dreal(
     & b0phww)*mh**2+3d0/2*dreal(b0phww)*mw**2+3d0/4*dreal(b0phzz)/ctw**
     & 4*mw**2-1d0/4*dreal(b0phzz)/ctw**2*mh**2+1d0/16*dreal(b0phzz)/mw*
     & *2*mh**4+9d0/16*dreal(b0phhh)/mw**2*mh**4+1d0/24*dreal(b0pwwz)/ct
     & w**4*mw**2+2d0/3*dreal(b0pwwz)/ctw**2*mw**2-29d0/6*dreal(b0pwwz)*
     & mw**2+1d0/24*dreal(b0pwwh)/mw**2*mh**4-1d0/6*dreal(b0pwwh)*mh**2+
     & 1d0/2*dreal(b0pwwh)*mw**2

      ffgp1ew=
     & +cfq*(1d0/4*det3iwhqs/mw**2*mh**2*mbt**2+1d0/4*det3iwhqs/mw**2*mh
     & **2*mtp**2+1d0/4*det3iwhqs/mw**2*mh**2*mst**2+1d0/4*det3iwhqs/mw*
     & *2*mh**2*mch**2-1d0/2*det3iwhqs*mbt**2-1d0/2*det3iwhqs*mtp**2-1d0
     & /2*det3iwhqs*mst**2-1d0/2*det3iwhqs*mch**2)
     & +cfl*(1d0/4*det3iwhqs/mw**2*mh**2*mta**2+1d0/4*det3iwhqs/mw**2*mh
     & **2*mmo**2-1d0/2*det3iwhqs*mta**2-1d0/2*det3iwhqs*mmo**2)
     & +stw**2*(det3iwhqs*mh**2)
     & +jawsubqstswhw*propiwqs*stw**2*qup*(2*sdet4iwhtsus**2/qs*mw**6*mh
     & **2-2*sdet4iwhtsus**2/qs*mw**8+6*sdet4iwhtsus**2/qs*ts*mw**4*mh**
     & 2-4*sdet4iwhtsus**2/qs*ts*mw**6+6*sdet4iwhtsus**2/qs*ts**2*mw**2*
     & mh**2+2*sdet4iwhtsus**2/qs*ts**3*mh**2+4*sdet4iwhtsus**2/qs*ts**3
     & *mw**2+2*sdet4iwhtsus**2/qs*ts**4-2*sdet4iwhtsus**2*mw**6-4*sdet4
     & iwhtsus**2*ts*mw**4-2*sdet4iwhtsus**2*ts**2*mw**2)
     & +jawsubqsuswhw*propiwqs*stw**2*qdn*(-2*sdet4iwhtsus**2*mw**4*mh**
     & 2-2*sdet4iwhtsus**2*mw**6-4*sdet4iwhtsus**2*us*mw**2*mh**2-4*sdet
     & 4iwhtsus**2*us*mw**4-2*sdet4iwhtsus**2*us**2*mh**2-4*sdet4iwhtsus
     & **2*us**2*mw**2-2*sdet4iwhtsus**2*us**3-2*sdet4iwhtsus**2*qs*mw**
     & 4-4*sdet4iwhtsus**2*qs*us*mw**2-2*sdet4iwhtsus**2*qs*us**2)
     & +propiwqs*cfq*(1d0/4*det3iwhqs/mw**2*mbt**2+1d0/4*det3iwhqs/mw**2
     & *mtp**2+1d0/4*det3iwhqs/mw**2*mst**2+1d0/4*det3iwhqs/mw**2*mch**2
     & )
     & +propiwqs*cfl*(1d0/4*det3iwhqs/mw**2*mta**2+1d0/4*det3iwhqs/mw**2
     & *mmo**2)
     & +propiwqs*stw**2*(det3iwhqs+3d0/2*det3iwhqs**2*mw**2*mh**2-3d0/2*
     & det3iwhqs**2*mw**4+3d0/2*det3iwhqs**2*qs*mw**2)
     & +propiwqs*stw**2*qdn*(det3iwhqs*sdet4iwhtsus*mw**2*mh**2+det3iwhq
     & s*sdet4iwhtsus*mw**4+2*det3iwhqs*sdet4iwhtsus*ts*mw**2+det3iwhqs*
     & sdet4iwhtsus*qs*mw**2-4*sdet3icwus*sdet4iwhtsus*mw**2)
     & +propiwqs*stw**2*qup*(det3iwhqs*sdet4iwhtsus*mw**2*mh**2+det3iwhq
     & s*sdet4iwhtsus*mw**4+2*det3iwhqs*sdet4iwhtsus*ts*mw**2+det3iwhqs*
     & sdet4iwhtsus*qs*mw**2)
     & +propiwqs*d0dnuphwqsuswupzz*(-1d0/2/ctw**4*vpaup/qs*mw**2+1d0/2/c
     & tw**2*vpaup/qs*mw**2+1d0/ctw**2*vpaup+sdet4iwhtsus/ctw**4*vpaup/q
     & s*mw**4*mh**2+sdet4iwhtsus/ctw**4*vpaup/qs*us*mw**4+3d0/2*sdet4iw
     & htsus/ctw**4*vpaup*mw**2*mh**2+2*sdet4iwhtsus/ctw**4*vpaup*mw**4+
     & sdet4iwhtsus/ctw**4*vpaup*us*mw**2+2*sdet4iwhtsus/ctw**4*vpaup*ts
     & *mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mw**2*mh**4-3d0/2*sdet4
     & iwhtsus/ctw**2*vpaup/qs*mw**4*mh**2+sdet4iwhtsus/ctw**2*vpaup/qs*
     & mw**6-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*us*mw**2*mh**2-1d0/2*sde
     & t4iwhtsus/ctw**2*vpaup/qs*us*mw**4+1d0/2*sdet4iwhtsus/ctw**2*vpau
     & p*us*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup*us*mw**2+1d0/2*sdet4iw
     & htsus/ctw**2*vpaup*us**2+sdet4iwhtsus**2/ctw**6*vpaup*ts*mw**4*mh
     & **2+sdet4iwhtsus**2/ctw**6*vpaup*ts**2*mw**4+2*sdet4iwhtsus**2/ct
     & w**4*vpaup*mw**4*mh**4+2*sdet4iwhtsus**2/ctw**4*vpaup*us*mw**4*mh
     & **2+sdet4iwhtsus**2/ctw**2*vpaup/qs*mw**4*mh**6-2*sdet4iwhtsus**2
     & /ctw**2*vpaup/qs*mw**6*mh**4+sdet4iwhtsus**2/ctw**2*vpaup/qs*mw**
     & 8*mh**2+sdet4iwhtsus**2/ctw**2*vpaup/qs*us*mw**4*mh**4-2*sdet4iwh
     & tsus**2/ctw**2*vpaup/qs*us*mw**6*mh**2+sdet4iwhtsus**2/ctw**2*vpa
     & up/qs*us*mw**8+sdet4iwhtsus**2/ctw**2*vpaup*us*mw**2*mh**4-2*sdet
     & 4iwhtsus**2/ctw**2*vpaup*us*mw**4*mh**2+sdet4iwhtsus**2/ctw**2*vp
     & aup*us*mw**6+2*sdet4iwhtsus**2/ctw**2*vpaup*us**2*mw**2*mh**2-sde
     & t4iwhtsus**2/ctw**2*vpaup*us**2*mw**4+sdet4iwhtsus**2/ctw**2*vpau
     & p*us**3*mw**2)
     & +propiwqs*d0dnuphwqsuszdnww*(-1d0/2/ctw**4*vpadn/qs*mw**2+1d0/2/c
     & tw**2*vpadn/qs*mw**2-vpadn+1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*mw*
     & *2*mh**4+3d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*mw**4*mh**2-sdet4iwht
     & sus/ctw**4*vpadn/qs*mw**6+1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*us*m
     & w**2*mh**2+1d0/2*sdet4iwhtsus/ctw**4*vpadn/qs*us*mw**4-1d0/2*sdet
     & 4iwhtsus/ctw**4*vpadn*us*mw**2-sdet4iwhtsus/ctw**2*vpadn/qs*mw**4
     & *mh**2-sdet4iwhtsus/ctw**2*vpadn/qs*us*mw**4+5d0/2*sdet4iwhtsus/c
     & tw**2*vpadn*mw**2*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn*us*mh**2+
     & 2*sdet4iwhtsus/ctw**2*vpadn*us*mw**2+1d0/2*sdet4iwhtsus/ctw**2*vp
     & adn*us**2-4*sdet4iwhtsus*vpadn*mw**2*mh**2-2*sdet4iwhtsus*vpadn*m
     & w**4-sdet4iwhtsus*vpadn*us*mh**2-3*sdet4iwhtsus*vpadn*us*mw**2-sd
     & et4iwhtsus*vpadn*us**2-2*sdet4iwhtsus*vpadn*ts*mw**2-sdet4iwhtsus
     & **2/ctw**4*vpadn/qs*mw**4*mh**6+2*sdet4iwhtsus**2/ctw**4*vpadn/qs
     & *mw**6*mh**4-sdet4iwhtsus**2/ctw**4*vpadn/qs*mw**8*mh**2-sdet4iwh
     & tsus**2/ctw**4*vpadn/qs*us*mw**4*mh**4+2*sdet4iwhtsus**2/ctw**4*v
     & padn/qs*us*mw**6*mh**2-sdet4iwhtsus**2/ctw**4*vpadn/qs*us*mw**8-s
     & det4iwhtsus**2/ctw**4*vpadn*mw**4*mh**4-sdet4iwhtsus**2/ctw**4*vp
     & adn*us*mw**6+2*sdet4iwhtsus**2/ctw**2*vpadn*mw**4*mh**4+2*sdet4iw
     & htsus**2/ctw**2*vpadn*mw**6*mh**2+4*sdet4iwhtsus**2/ctw**2*vpadn*
     & us*mw**4*mh**2+2*sdet4iwhtsus**2/ctw**2*vpadn*us**2*mw**4+2*sdet4
     & iwhtsus**2/ctw**2*vpadn*ts*mw**4*mh**2-3*sdet4iwhtsus**2*vpadn*mw
     & **4*mh**4-2*sdet4iwhtsus**2*vpadn*mw**6*mh**2-sdet4iwhtsus**2*vpa
     & dn*us*mw**2*mh**4-4*sdet4iwhtsus**2*vpadn*us*mw**4*mh**2-2*sdet4i
     & whtsus**2*vpadn*us**2*mw**2*mh**2-sdet4iwhtsus**2*vpadn*us**2*mw*
     & *4-sdet4iwhtsus**2*vpadn*us**3*mw**2-3*sdet4iwhtsus**2*vpadn*ts*m
     & w**4*mh**2-sdet4iwhtsus**2*vpadn*ts**2*mw**4)
     & +propiwqs*d0dnupwhqstswupzw*(-1d0/ctw**2*vpaup/qs*mw**2+vpaup/qs*
     & mw**2-sdet4iwhtsus/ctw**2*vpaup/qs*mw**6-sdet4iwhtsus/ctw**2*vpau
     & p/qs*ts*mw**4-sdet4iwhtsus/ctw**2*vpaup*mw**4+sdet4iwhtsus*vpaup/
     & qs*mw**6+sdet4iwhtsus*vpaup/qs*ts*mw**2*mh**2+2*sdet4iwhtsus*vpau
     & p*mw**4+2*sdet4iwhtsus*vpaup*ts*mw**2+sdet4iwhtsus**2/ctw**4*vpau
     & p*ts*mw**4*mh**2+sdet4iwhtsus**2/ctw**4*vpaup*ts**2*mw**4-2*sdet4
     & iwhtsus**2/ctw**2*vpaup*mw**6*mh**2-4*sdet4iwhtsus**2/ctw**2*vpau
     & p*ts*mw**4*mh**2-2*sdet4iwhtsus**2/ctw**2*vpaup*ts**2*mw**2*mh**2
     & -2*sdet4iwhtsus**2/ctw**2*vpaup*ts**2*mw**4-2*sdet4iwhtsus**2/ctw
     & **2*vpaup*ts**3*mw**2-sdet4iwhtsus**2*vpaup/qs*mw**6*mh**4+2*sdet
     & 4iwhtsus**2*vpaup/qs*mw**8*mh**2-sdet4iwhtsus**2*vpaup/qs*mw**10-
     & sdet4iwhtsus**2*vpaup/qs*ts*mw**4*mh**4+2*sdet4iwhtsus**2*vpaup/q
     & s*ts*mw**6*mh**2-sdet4iwhtsus**2*vpaup/qs*ts*mw**8+4*sdet4iwhtsus
     & **2*vpaup*mw**6*mh**2-sdet4iwhtsus**2*vpaup*mw**8+sdet4iwhtsus**2
     & *vpaup*us*mw**6+5*sdet4iwhtsus**2*vpaup*ts*mw**4*mh**2+4*sdet4iwh
     & tsus**2*vpaup*ts**2*mw**2*mh**2+sdet4iwhtsus**2*vpaup*ts**2*mw**4
     & +sdet4iwhtsus**2*vpaup*ts**3*mh**2+2*sdet4iwhtsus**2*vpaup*ts**3*
     & mw**2+sdet4iwhtsus**2*vpaup*ts**4)
     & +propiwqs*d0dnupwhqstszdnwz*(-1d0/ctw**4*vpadn/qs*mw**2+1d0/ctw**
     & 2*vpadn/qs*mw**2+sdet4iwhtsus/ctw**6*vpadn/qs*mw**4*mh**2-2*sdet4
     & iwhtsus/ctw**6*vpadn/qs*mw**6-sdet4iwhtsus/ctw**6*vpadn/qs*ts*mw*
     & *4-sdet4iwhtsus/ctw**6*vpadn*mw**4-sdet4iwhtsus/ctw**4*vpadn/qs*m
     & w**4*mh**2+2*sdet4iwhtsus/ctw**4*vpadn/qs*mw**6-sdet4iwhtsus/ctw*
     & *4*vpadn/qs*ts*mw**2*mh**2+2*sdet4iwhtsus/ctw**4*vpadn/qs*ts*mw**
     & 4-2*sdet4iwhtsus/ctw**4*vpadn*ts*mw**2+sdet4iwhtsus**2/ctw**6*vpa
     & dn/qs*mw**6*mh**4-2*sdet4iwhtsus**2/ctw**6*vpadn/qs*mw**8*mh**2+s
     & det4iwhtsus**2/ctw**6*vpadn/qs*mw**10+sdet4iwhtsus**2/ctw**6*vpad
     & n/qs*ts*mw**4*mh**4-2*sdet4iwhtsus**2/ctw**6*vpadn/qs*ts*mw**6*mh
     & **2+sdet4iwhtsus**2/ctw**6*vpadn/qs*ts*mw**8-2*sdet4iwhtsus**2/ct
     & w**6*vpadn*mw**6*mh**2+sdet4iwhtsus**2/ctw**6*vpadn*mw**8-sdet4iw
     & htsus**2/ctw**6*vpadn*us*mw**6-2*sdet4iwhtsus**2/ctw**4*vpadn*ts*
     & mw**4*mh**2-2*sdet4iwhtsus**2/ctw**4*vpadn*ts**2*mw**2*mh**2-sdet
     & 4iwhtsus**2/ctw**2*vpadn*ts**3*mh**2-sdet4iwhtsus**2/ctw**2*vpadn
     & *ts**4)
     & +propiwqs*d0wuphdntsusdnupzz*(-1d0/2/ctw**6*vpaup*vpadn/qs*mw**2-
     & 1d0/2/ctw**4*vpaup*vpadn/qs*mh**2-1d0/2/ctw**4*vpaup*vpadn/qs*us-
     & 1d0/2/ctw**4*vpaup*vpadn+1d0/2*sdet4iwhtsus/ctw**8*vpaup*vpadn/qs
     & *mw**4*mh**2-1d0/2*sdet4iwhtsus/ctw**8*vpaup*vpadn/qs*mw**6-sdet4
     & iwhtsus/ctw**6*vpaup*vpadn/qs*mw**4*mh**2+sdet4iwhtsus/ctw**6*vpa
     & up*vpadn/qs*mw**6-sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*ts*mw**2*mh*
     & *2+sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*ts*mw**4-sdet4iwhtsus/ctw**
     & 6*vpaup*vpadn*ts*mw**2+1d0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpadn/q
     & s*mw**6*mh**4-3d0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpadn/qs*mw**8*m
     & h**2-1d0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpadn/qs*us*mw**8+1d0/2*s
     & det4iwhtsus**2/ctw**8*vpaup*vpadn/qs*ts*mw**4*mh**4-sdet4iwhtsus*
     & *2/ctw**8*vpaup*vpadn/qs*ts*mw**6*mh**2-1d0/2*sdet4iwhtsus**2/ctw
     & **8*vpaup*vpadn*us*mw**6+1d0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpadn
     & *ts*mw**4*mh**2-1d0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpadn*ts**2*mw
     & **4)
     & +propiwqs*c0updnqswdnz*(sdet4iwhtsus/ctw**4*vpadn*mw**2-1d0/2*sde
     & t4iwhtsus/ctw**2*vpadn*mh**2-2*sdet4iwhtsus/ctw**2*vpadn*mw**2-1d
     & 0/2*sdet4iwhtsus/ctw**2*vpadn*us+sdet4iwhtsus*vpadn*mh**2+3*sdet4
     & iwhtsus*vpadn*mw**2+sdet4iwhtsus*vpadn*us+sdet4iwhtsus*vpadn*ts+2
     & *sdet4iwhtsus**2/ctw**4*vpadn*mw**4*mh**2+sdet4iwhtsus**2/ctw**4*
     & vpadn*us*mw**4+sdet4iwhtsus**2/ctw**4*vpadn*ts*mw**2*mh**2-2*sdet
     & 4iwhtsus**2/ctw**2*vpadn*mw**4*mh**2-sdet4iwhtsus**2/ctw**2*vpadn
     & *us*mw**4+sdet4iwhtsus**2/ctw**2*vpadn*ts**2*mh**2+sdet4iwhtsus**
     & 2/ctw**2*vpadn*ts**2*mw**2+sdet4iwhtsus**2/ctw**2*vpadn*ts**3+sde
     & t4iwhtsus**2*vpadn*mw**2*mh**4+3*sdet4iwhtsus**2*vpadn*mw**4*mh**
     & 2+2*sdet4iwhtsus**2*vpadn*us*mw**2*mh**2+sdet4iwhtsus**2*vpadn*us
     & *mw**4+sdet4iwhtsus**2*vpadn*us**2*mw**2+2*sdet4iwhtsus**2*vpadn*
     & ts*mw**2*mh**2+sdet4iwhtsus**2*vpadn*ts*mw**4+sdet4iwhtsus**2*vpa
     & dn*ts**2*mw**2)
     & +propiwqs*c0updnqszupw*(-sdet4iwhtsus/ctw**4*vpaup*mw**2-1d0/2*sd
     & et4iwhtsus/ctw**2*vpaup*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*us-
     & sdet4iwhtsus/ctw**2*vpaup*ts-sdet4iwhtsus*vpaup*mw**2-sdet4iwhtsu
     & s**2/ctw**4*vpaup*mw**4*mh**2-sdet4iwhtsus**2/ctw**4*vpaup*ts*mw*
     & *2*mh**2-sdet4iwhtsus**2/ctw**4*vpaup*ts*mw**4-sdet4iwhtsus**2/ct
     & w**4*vpaup*ts**2*mw**2-sdet4iwhtsus**2/ctw**2*vpaup*mw**2*mh**4+s
     & det4iwhtsus**2/ctw**2*vpaup*mw**4*mh**2-2*sdet4iwhtsus**2/ctw**2*
     & vpaup*us*mw**2*mh**2-sdet4iwhtsus**2/ctw**2*vpaup*us**2*mw**2+sde
     & t4iwhtsus**2/ctw**2*vpaup*ts*mw**2*mh**2+sdet4iwhtsus**2/ctw**2*v
     & paup*ts*mw**4+sdet4iwhtsus**2/ctw**2*vpaup*ts**2*mw**2-3*sdet4iwh
     & tsus**2*vpaup*mw**4*mh**2-sdet4iwhtsus**2*vpaup*us*mw**4-3*sdet4i
     & whtsus**2*vpaup*ts*mw**2*mh**2-sdet4iwhtsus**2*vpaup*ts*mw**4-sde
     & t4iwhtsus**2*vpaup*ts**2*mh**2-2*sdet4iwhtsus**2*vpaup*ts**2*mw**
     & 2-sdet4iwhtsus**2*vpaup*ts**3)
     & +propiwqs*c0hdntswwup*stw**2*qup*(2/qs-4*sdet3ichts*sdet4iwhtsus*
     & mw**2*mh**2+2*sdet4iwhtsus/qs*mw**4+2*sdet4iwhtsus/qs*ts*mw**2+4*
     & sdet4iwhtsus*mw**2-2*sdet4iwhtsus*ts+2*sdet4iwhtsus**2*mw**4*mh**
     & 2+4*sdet4iwhtsus**2*ts*mw**2*mh**2+2*sdet4iwhtsus**2*ts**2*mh**2+
     & 2*sdet4iwhtsus**2*ts**2*mw**2+2*sdet4iwhtsus**2*ts**3)
     & +propiwqs*c0hdntswwup*(vpaup/qs-2*sdet3ichts*sdet4iwhtsus*vpaup*m
     & w**2*mh**2+sdet4iwhtsus*vpaup/qs*mw**4+sdet4iwhtsus*vpaup/qs*ts*m
     & w**2+2*sdet4iwhtsus*vpaup*mw**2-sdet4iwhtsus*vpaup*ts-sdet4iwhtsu
     & s**2/ctw**2*vpaup*ts*mw**2*mh**2-sdet4iwhtsus**2/ctw**2*vpaup*ts*
     & *2*mw**2+sdet4iwhtsus**2*vpaup*mw**4*mh**2+2*sdet4iwhtsus**2*vpau
     & p*ts*mw**2*mh**2+sdet4iwhtsus**2*vpaup*ts**2*mh**2+sdet4iwhtsus**
     & 2*vpaup*ts**2*mw**2+sdet4iwhtsus**2*vpaup*ts**3)
     & +propiwqs*c0hdntszzdn*(1d0/2/ctw**4*vpaup*vpadn/qs-1d0/ctw**2*vpa
     & dn/qs-sdet3ichts/ctw**6*vpaup*vpadn/qs*mw**2+2*sdet3ichts*sdet4iw
     & htsus/ctw**4*vpadn*mw**2*mh**2-1d0/2*sdet4iwhtsus/ctw**6*vpaup*vp
     & adn/qs*mw**4-1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*ts*mw**2-sd
     & et4iwhtsus/ctw**4*vpadn/qs*mw**4-sdet4iwhtsus/ctw**4*vpadn/qs*ts*
     & mw**2-2*sdet4iwhtsus/ctw**4*vpadn*mw**2-1d0/2*sdet4iwhtsus/ctw**4
     & *vpaup*vpadn*ts+sdet4iwhtsus/ctw**2*vpadn*ts-1d0/2*sdet4iwhtsus**
     & 2/ctw**6*vpaup*vpadn/qs*mw**4*mh**4-1d0/2*sdet4iwhtsus**2/ctw**6*
     & vpaup*vpadn/qs*mw**6*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpa
     & dn/qs*us*mw**4*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*
     & ts*mw**4*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn*ts**2*mw*
     & *2-sdet4iwhtsus**2/ctw**4*vpadn*mw**4*mh**2-sdet4iwhtsus**2/ctw**
     & 4*vpadn*ts*mw**2*mh**2-sdet4iwhtsus**2/ctw**2*vpadn*ts**2*mh**2-s
     & det4iwhtsus**2/ctw**2*vpadn*ts**3)
     & +propiwqs*c0hupuswwdn*stw**2*qdn*(-2*sdet4iwhtsus*mh**2-2*sdet4iw
     & htsus*mw**2-2*sdet4iwhtsus*us-2*sdet4iwhtsus**2*mw**2*mh**4-2*sde
     & t4iwhtsus**2*mw**4*mh**2-4*sdet4iwhtsus**2*us*mw**2*mh**2-2*sdet4
     & iwhtsus**2*us**2*mw**2-2*sdet4iwhtsus**2*ts*mw**2*mh**2)
     & +propiwqs*c0hupuswwdn*(1d0/2/ctw**2*vpadn/qs-1d0/2*sdet4iwhtsus/c
     & tw**2*vpadn/qs*mh**4-3d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*mw**2*mh*
     & *2+sdet4iwhtsus/ctw**2*vpadn/qs*mw**4-1d0/2*sdet4iwhtsus/ctw**2*v
     & padn/qs*us*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*us*mw**2+1d0/
     & 2*sdet4iwhtsus/ctw**2*vpadn*us-sdet4iwhtsus*vpadn*mh**2-sdet4iwht
     & sus*vpadn*mw**2-sdet4iwhtsus*vpadn*us+sdet4iwhtsus**2/ctw**2*vpad
     & n/qs*mw**2*mh**6-2*sdet4iwhtsus**2/ctw**2*vpadn/qs*mw**4*mh**4+sd
     & et4iwhtsus**2/ctw**2*vpadn/qs*mw**6*mh**2+sdet4iwhtsus**2/ctw**2*
     & vpadn/qs*us*mw**2*mh**4-2*sdet4iwhtsus**2/ctw**2*vpadn/qs*us*mw**
     & 4*mh**2+sdet4iwhtsus**2/ctw**2*vpadn/qs*us*mw**6+sdet4iwhtsus**2/
     & ctw**2*vpadn*mw**2*mh**4+sdet4iwhtsus**2/ctw**2*vpadn*us*mw**4-sd
     & et4iwhtsus**2*vpadn*mw**2*mh**4-sdet4iwhtsus**2*vpadn*mw**4*mh**2
     & -2*sdet4iwhtsus**2*vpadn*us*mw**2*mh**2-sdet4iwhtsus**2*vpadn*us*
     & *2*mw**2-sdet4iwhtsus**2*vpadn*ts*mw**2*mh**2)
     & +propiwqs*c0hupuszzup*(-1d0/2/ctw**4*vpaup*vpadn/qs-1d0/2/ctw**2*
     & vpaup/qs+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*mw**2*mh**2-sde
     & t4iwhtsus/ctw**6*vpaup*vpadn/qs*mw**4-1d0/2*sdet4iwhtsus/ctw**6*v
     & paup*vpadn/qs*ts*mw**2+sdet4iwhtsus/ctw**4*vpaup*mw**2-sdet4iwhts
     & us/ctw**4*vpaup*vpadn/qs*mw**2*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vp
     & aup*vpadn/qs*us*mw**2-1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*ts
     & *mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mh**4+3d0/2*sdet4iwhtsu
     & s/ctw**2*vpaup/qs*mw**2*mh**2-sdet4iwhtsus/ctw**2*vpaup/qs*mw**4+
     & 1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*us*mh**2+1d0/2*sdet4iwhtsus/ct
     & w**2*vpaup/qs*us*mw**2+sdet4iwhtsus/ctw**2*vpaup*mh**2+1d0/2*sdet
     & 4iwhtsus/ctw**2*vpaup*us+sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*mw
     & **4*mh**4-sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*mw**6*mh**2+1d0/2
     & *sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*us*mw**4*mh**2-1d0/2*sdet4
     & iwhtsus**2/ctw**6*vpaup*vpadn/qs*us*mw**6+1d0/2*sdet4iwhtsus**2/c
     & tw**6*vpaup*vpadn/qs*ts*mw**2*mh**4-1d0/2*sdet4iwhtsus**2/ctw**6*
     & vpaup*vpadn/qs*ts*mw**4*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*
     & vpadn*us*mw**4+1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn*ts*mw**2*
     & mh**2+sdet4iwhtsus**2/ctw**4*vpaup*mw**4*mh**2+sdet4iwhtsus**2/ct
     & w**4*vpaup*ts*mw**2*mh**2-sdet4iwhtsus**2/ctw**2*vpaup/qs*mw**2*m
     & h**6+2*sdet4iwhtsus**2/ctw**2*vpaup/qs*mw**4*mh**4-sdet4iwhtsus**
     & 2/ctw**2*vpaup/qs*mw**6*mh**2-sdet4iwhtsus**2/ctw**2*vpaup/qs*us*
     & mw**2*mh**4+2*sdet4iwhtsus**2/ctw**2*vpaup/qs*us*mw**4*mh**2-sdet
     & 4iwhtsus**2/ctw**2*vpaup/qs*us*mw**6+2*sdet4iwhtsus**2/ctw**2*vpa
     & up*us*mw**2*mh**2-sdet4iwhtsus**2/ctw**2*vpaup*us*mw**4+sdet4iwht
     & sus**2/ctw**2*vpaup*us**2*mw**2)
     & +propiwqs*c0wdnuswzdn*(-1d0/2/ctw**2*vpadn/qs-2*sdet3icwus*sdet4i
     & whtsus/ctw**2*vpadn*mw**4+sdet4iwhtsus/ctw**2*vpadn/qs*mw**2*mh**
     & 2+sdet4iwhtsus/ctw**2*vpadn/qs*us*mw**2+2*sdet4iwhtsus/ctw**2*vpa
     & dn*mw**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn*us-2*sdet4iwhtsus*vpadn*
     & mw**2-sdet4iwhtsus*vpadn*us+sdet4iwhtsus**2/ctw**2*vpadn*mw**4*mh
     & **2+sdet4iwhtsus**2/ctw**2*vpadn*us*mw**4-2*sdet4iwhtsus**2*vpadn
     & *mw**4*mh**2-sdet4iwhtsus**2*vpadn*us*mw**2*mh**2-sdet4iwhtsus**2
     & *vpadn*us*mw**4-sdet4iwhtsus**2*vpadn*us**2*mw**2-sdet4iwhtsus**2
     & *vpadn*ts*mw**4)
     & +propiwqs*c0wdnuszwup*(1d0/2/ctw**2*vpaup/qs+2*sdet3icwus*sdet4iw
     & htsus/ctw**2*vpaup*mw**4+sdet4iwhtsus/ctw**4*vpaup*mw**2-sdet4iwh
     & tsus/ctw**2*vpaup/qs*mw**2*mh**2-sdet4iwhtsus/ctw**2*vpaup/qs*us*
     & mw**2-sdet4iwhtsus/ctw**2*vpaup*mw**2+1d0/2*sdet4iwhtsus/ctw**2*v
     & paup*us+sdet4iwhtsus**2/ctw**4*vpaup*mw**4*mh**2+sdet4iwhtsus**2/
     & ctw**4*vpaup*ts*mw**4+sdet4iwhtsus**2/ctw**2*vpaup*us*mw**2*mh**2
     & +sdet4iwhtsus**2/ctw**2*vpaup*us**2*mw**2)
     & +propiwqs*c0wdnusupdnz*(-1d0/2/ctw**4*vpaup*vpadn/qs-sdet3icwus/c
     & tw**6*vpaup*vpadn/qs*mw**2+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/
     & qs*mw**4+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*ts*mw**2+1d0/2*
     & sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*mw**2*mh**2+1d0/2*sdet4iwhtsus
     & /ctw**4*vpaup*vpadn/qs*mw**4+1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpad
     & n/qs*us*mw**2+1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*ts*mw**2+1
     & d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn*us*mw**4-1d0/2*sdet4iwhts
     & us**2/ctw**6*vpaup*vpadn*ts*mw**4)
     & +propiwqs*c0wuptswzup*(-vpaup/qs-sdet4iwhtsus*vpaup/qs*mw**4-sdet
     & 4iwhtsus*vpaup/qs*ts*mh**2-sdet4iwhtsus*vpaup*ts-sdet4iwhtsus**2/
     & ctw**2*vpaup*ts*mw**4-sdet4iwhtsus**2/ctw**2*vpaup*ts**2*mw**2+sd
     & et4iwhtsus**2*vpaup/qs*mw**4*mh**4-2*sdet4iwhtsus**2*vpaup/qs*mw*
     & *6*mh**2+sdet4iwhtsus**2*vpaup/qs*mw**8+sdet4iwhtsus**2*vpaup/qs*
     & ts*mw**2*mh**4-2*sdet4iwhtsus**2*vpaup/qs*ts*mw**4*mh**2+sdet4iwh
     & tsus**2*vpaup/qs*ts*mw**6+sdet4iwhtsus**2*vpaup*mw**6+sdet4iwhtsu
     & s**2*vpaup*ts*mw**2*mh**2+sdet4iwhtsus**2*vpaup*ts*mw**4+2*sdet4i
     & whtsus**2*vpaup*ts**2*mw**2+sdet4iwhtsus**2*vpaup*ts**3)
     & +propiwqs*c0wuptszwdn*(1d0/ctw**2*vpadn/qs-sdet4iwhtsus/ctw**4*vp
     & adn/qs*mw**2*mh**2+2*sdet4iwhtsus/ctw**4*vpadn/qs*mw**4+sdet4iwht
     & sus/ctw**4*vpadn/qs*ts*mw**2+sdet4iwhtsus/ctw**2*vpadn/qs*mw**2*m
     & h**2-sdet4iwhtsus/ctw**2*vpadn/qs*mw**4+sdet4iwhtsus/ctw**2*vpadn
     & /qs*ts*mh**2-sdet4iwhtsus/ctw**2*vpadn/qs*ts*mw**2+sdet4iwhtsus/c
     & tw**2*vpadn*ts-sdet4iwhtsus**2/ctw**4*vpadn/qs*mw**4*mh**4+2*sdet
     & 4iwhtsus**2/ctw**4*vpadn/qs*mw**6*mh**2-sdet4iwhtsus**2/ctw**4*vp
     & adn/qs*mw**8-sdet4iwhtsus**2/ctw**4*vpadn/qs*ts*mw**2*mh**4+2*sde
     & t4iwhtsus**2/ctw**4*vpadn/qs*ts*mw**4*mh**2-sdet4iwhtsus**2/ctw**
     & 4*vpadn/qs*ts*mw**6-sdet4iwhtsus**2/ctw**4*vpadn*mw**6-sdet4iwhts
     & us**2/ctw**4*vpadn*ts*mw**2*mh**2-sdet4iwhtsus**2/ctw**2*vpadn*ts
     & **2*mw**2-sdet4iwhtsus**2/ctw**2*vpadn*ts**3)
     & +propiwqs*c0wuptsdnupz*(1d0/2/ctw**4*vpaup*vpadn/qs-1d0/2*sdet4iw
     & htsus/ctw**6*vpaup*vpadn/qs*mw**2*mh**2+sdet4iwhtsus/ctw**6*vpaup
     & *vpadn/qs*mw**4+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*ts*mw**2
     & +1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*mw**2*mh**2-1d0/2*sdet4
     & iwhtsus/ctw**4*vpaup*vpadn/qs*mw**4+1d0/2*sdet4iwhtsus/ctw**4*vpa
     & up*vpadn/qs*ts*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*ts*
     & mw**2+1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn*ts-1d0/2*sdet4iwhtsus
     & **2/ctw**6*vpaup*vpadn/qs*mw**4*mh**4+3d0/2*sdet4iwhtsus**2/ctw**
     & 6*vpaup*vpadn/qs*mw**6*mh**2+1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*v
     & padn/qs*us*mw**6-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*ts*m
     & w**2*mh**4+sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*ts*mw**4*mh**2-1
     & d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn*ts*mw**2*mh**2+1d0/2*sdet
     & 4iwhtsus**2/ctw**6*vpaup*vpadn*ts*mw**4+1d0/2*sdet4iwhtsus**2/ctw
     & **6*vpaup*vpadn*ts**2*mw**2)
     & +propiwqs*c0whqswzz*(1d0/2*det3iwhqs/ctw**4*mw**2-1d0/2*det3iwhqs
     & /ctw**4*vpadn*mw**2-1d0/2*det3iwhqs/ctw**4*vpaup*mw**2+15d0/4*det
     & 3iwhqs/ctw**2*mw**2-1d0/4*det3iwhqs/ctw**2*qs-1d0/4*det3iwhqs*mh*
     & *2-1d0/8*det3iwhqs*mw**2-1d0/8*det3iwhqs*qs+3d0/16*det3iwhqs**2/c
     & tw**6*mw**4*mh**2+3d0/16*det3iwhqs**2/ctw**6*mw**6+3d0/16*det3iwh
     & qs**2/ctw**6*qs*mw**4+3d0/32*det3iwhqs**2/ctw**4*mw**2*mh**4+27d0
     & /32*det3iwhqs**2/ctw**4*mw**4*mh**2+21d0/16*det3iwhqs**2/ctw**4*m
     & w**6+3d0/32*det3iwhqs**2/ctw**4*qs*mw**2*mh**2+21d0/16*det3iwhqs*
     & *2/ctw**4*qs*mw**4-3d0/8*det3iwhqs**2/ctw**2*mw**2*mh**4-39d0/4*d
     & et3iwhqs**2/ctw**2*mw**4*mh**2-27d0/8*det3iwhqs**2/ctw**2*mw**6-2
     & 7d0/8*det3iwhqs**2/ctw**2*qs*mw**4+3d0/32*det3iwhqs**2*mh**6+63d0
     & /32*det3iwhqs**2*mw**2*mh**4+147d0/16*det3iwhqs**2*mw**4*mh**2+15
     & d0/4*det3iwhqs**2*mw**6+3d0/32*det3iwhqs**2*qs*mh**4+27d0/16*det3
     & iwhqs**2*qs*mw**2*mh**2+15d0/4*det3iwhqs**2*qs*mw**4+1d0/2*det3iw
     & hqs*sdet4iwhtsus/ctw**4*vpadn*mw**4*mh**2-1d0/2*det3iwhqs*sdet4iw
     & htsus/ctw**4*vpadn*ts**2*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**
     & 4*vpaup*mw**4*mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**4*vpaup*ts*
     & *2*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*mw**2*mh**4-1d
     & 0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*mw**4*mh**2-det3iwhqs*sde
     & t4iwhtsus/ctw**2*vpadn*ts*mw**2*mh**2-1d0/2*det3iwhqs*sdet4iwhtsu
     & s/ctw**2*vpadn*qs*mw**2*mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2
     & *vpaup*mw**2*mh**4-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**
     & 4*mh**2-det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*ts*mw**2*mh**2-1d0/2*
     & det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*qs*mw**2*mh**2+sdet4iwhtsus/c
     & tw**4*vpadn/qs*mw**2*mh**2-sdet4iwhtsus/ctw**4*vpadn/qs*mw**4-sde
     & t4iwhtsus/ctw**4*vpadn*mw**2-sdet4iwhtsus/ctw**4*vpaup*mw**2-sdet
     & 4iwhtsus/ctw**2*vpadn/qs*mw**2*mh**2+sdet4iwhtsus/ctw**2*vpadn/qs
     & *mw**4-sdet4iwhtsus/ctw**2*vpadn/qs*ts*mh**2+sdet4iwhtsus/ctw**2*
     & vpadn/qs*ts*mw**2+sdet4iwhtsus/ctw**2*vpadn*mw**2-1d0/2*sdet4iwht
     & sus/ctw**2*vpaup/qs*mh**4-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mw**
     & 2*mh**2+sdet4iwhtsus/ctw**2*vpaup/qs*mw**4-1d0/2*sdet4iwhtsus/ctw
     & **2*vpaup/qs*us*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*us*mw**2
     & -1d0/2*sdet4iwhtsus/ctw**2*vpaup*mh**2-1d0/2*sdet4iwhtsus/ctw**2*
     & vpaup*us+sdet4iwhtsus/ctw**2*vpaup*ts+sdet4iwhtsus**2/ctw**4*vpad
     & n/qs*mw**4*mh**4-2*sdet4iwhtsus**2/ctw**4*vpadn/qs*mw**6*mh**2+sd
     & et4iwhtsus**2/ctw**4*vpadn/qs*mw**8+sdet4iwhtsus**2/ctw**4*vpadn/
     & qs*ts*mw**2*mh**4-2*sdet4iwhtsus**2/ctw**4*vpadn/qs*ts*mw**4*mh**
     & 2+sdet4iwhtsus**2/ctw**4*vpadn/qs*ts*mw**6-sdet4iwhtsus**2/ctw**4
     & *vpadn*mw**4*mh**2+sdet4iwhtsus**2/ctw**4*vpadn*mw**6-sdet4iwhtsu
     & s**2/ctw**4*vpadn*us*mw**4+sdet4iwhtsus**2/ctw**4*vpadn*ts*mw**2*
     & mh**2-sdet4iwhtsus**2/ctw**4*vpaup*mw**4*mh**2+sdet4iwhtsus**2/ct
     & w**4*vpaup*ts**2*mw**2-sdet4iwhtsus**2/ctw**2*vpadn*ts*mw**2*mh**
     & 2+sdet4iwhtsus**2/ctw**2*vpadn*ts**3+sdet4iwhtsus**2/ctw**2*vpaup
     & /qs*mw**2*mh**6-2*sdet4iwhtsus**2/ctw**2*vpaup/qs*mw**4*mh**4+sde
     & t4iwhtsus**2/ctw**2*vpaup/qs*mw**6*mh**2+sdet4iwhtsus**2/ctw**2*v
     & paup/qs*us*mw**2*mh**4-2*sdet4iwhtsus**2/ctw**2*vpaup/qs*us*mw**4
     & *mh**2+sdet4iwhtsus**2/ctw**2*vpaup/qs*us*mw**6+sdet4iwhtsus**2/c
     & tw**2*vpaup*mw**2*mh**4-sdet4iwhtsus**2/ctw**2*vpaup*us*mw**2*mh*
     & *2+sdet4iwhtsus**2/ctw**2*vpaup*us*mw**4-sdet4iwhtsus**2/ctw**2*v
     & paup*us**2*mw**2)
     & +propiwqs*c0whqswhh*(-3d0/4*det3iwhqs/mw**2*mh**4-6*det3iwhqs*mh*
     & *2-21d0/8*det3iwhqs*mw**2-3d0/4*det3iwhqs*qs/mw**2*mh**2-21d0/8*d
     & et3iwhqs*qs+9d0/32*det3iwhqs**2/mw**2*mh**8+45d0/32*det3iwhqs**2*
     & mw**2*mh**4+81d0/16*det3iwhqs**2*mw**4*mh**2+9d0/4*det3iwhqs**2*m
     & w**6+9d0/32*det3iwhqs**2*qs/mw**2*mh**6+9d0/32*det3iwhqs**2*qs*mh
     & **4+9d0/16*det3iwhqs**2*qs*mw**2*mh**2+9d0/4*det3iwhqs**2*qs*mw**
     & 4)
     & +propiwqs*c0whqszww*stw**2*(det3iwhqs*mh**2-5*det3iwhqs*mw**2+det
     & 3iwhqs*qs-3d0/2*det3iwhqs**2*mw**2*mh**4+9d0/2*det3iwhqs**2*mw**4
     & *mh**2-3*det3iwhqs**2*mw**6-3d0/2*det3iwhqs**2*qs*mw**2*mh**2-3*d
     & et3iwhqs**2*qs*mw**4)
     & +propiwqs*c0whqszww*(-3d0/8*det3iwhqs/ctw**2*mh**2-3d0/8*det3iwhq
     & s/ctw**2*mw**2-1d0/8*det3iwhqs/ctw**2*qs-1d0/2*det3iwhqs/ctw**2*v
     & padn*mw**2-1d0/2*det3iwhqs/ctw**2*vpaup*mw**2+1d0/8*det3iwhqs*mh*
     & *2+9d0/2*det3iwhqs*mw**2-1d0/4*det3iwhqs*qs+det3iwhqs*vpadn*mw**2
     & +det3iwhqs*vpaup*mw**2+3d0/32*det3iwhqs**2/ctw**4*mw**2*mh**4+21d
     & 0/32*det3iwhqs**2/ctw**4*mw**4*mh**2+3d0/8*det3iwhqs**2/ctw**4*mw
     & **6+3d0/32*det3iwhqs**2/ctw**4*qs*mw**2*mh**2+3d0/8*det3iwhqs**2/
     & ctw**4*qs*mw**4+3d0/16*det3iwhqs**2/ctw**2*mw**2*mh**4+27d0/16*de
     & t3iwhqs**2/ctw**2*mw**4*mh**2+9d0/8*det3iwhqs**2/ctw**2*mw**6-3d0
     & /16*det3iwhqs**2/ctw**2*qs*mw**2*mh**2+9d0/8*det3iwhqs**2/ctw**2*
     & qs*mw**4+3d0/32*det3iwhqs**2*mh**6+45d0/32*det3iwhqs**2*mw**2*mh*
     & *4-15d0/8*det3iwhqs**2*mw**4*mh**2+3d0/8*det3iwhqs**2*mw**6+3d0/3
     & 2*det3iwhqs**2*qs*mh**4+15d0/8*det3iwhqs**2*qs*mw**2*mh**2+3d0/8*
     & det3iwhqs**2*qs*mw**4+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*m
     & w**4*mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*ts**2*mw**2+
     & 1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**4*mh**2-1d0/2*det3i
     & whqs*sdet4iwhtsus/ctw**2*vpaup*ts**2*mw**2+1d0/2*det3iwhqs*sdet4i
     & whtsus*vpadn*mw**2*mh**4-1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*mw**4
     & *mh**2+det3iwhqs*sdet4iwhtsus*vpadn*ts*mw**2*mh**2+det3iwhqs*sdet
     & 4iwhtsus*vpadn*ts**2*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*qs*
     & mw**2*mh**2+1d0/2*det3iwhqs*sdet4iwhtsus*vpaup*mw**2*mh**4-1d0/2*
     & det3iwhqs*sdet4iwhtsus*vpaup*mw**4*mh**2+det3iwhqs*sdet4iwhtsus*v
     & paup*ts*mw**2*mh**2+det3iwhqs*sdet4iwhtsus*vpaup*ts**2*mw**2+1d0/
     & 2*det3iwhqs*sdet4iwhtsus*vpaup*qs*mw**2*mh**2+1d0/2*sdet4iwhtsus/
     & ctw**2*vpadn/qs*mh**4+1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*mw**2*mh
     & **2-sdet4iwhtsus/ctw**2*vpadn/qs*mw**4+1d0/2*sdet4iwhtsus/ctw**2*
     & vpadn/qs*us*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*us*mw**2+1d0
     & /2*sdet4iwhtsus/ctw**2*vpadn*mh**2-sdet4iwhtsus/ctw**2*vpadn*mw**
     & 2-1d0/2*sdet4iwhtsus/ctw**2*vpadn*us-sdet4iwhtsus/ctw**2*vpaup*mw
     & **2+2*sdet4iwhtsus*vpadn*mw**2+sdet4iwhtsus*vpadn*us-sdet4iwhtsus
     & *vpadn*ts+sdet4iwhtsus*vpaup/qs*ts*mh**2-sdet4iwhtsus*vpaup/qs*ts
     & *mw**2+sdet4iwhtsus*vpaup*mw**2-sdet4iwhtsus**2/ctw**2*vpadn/qs*m
     & w**2*mh**6+2*sdet4iwhtsus**2/ctw**2*vpadn/qs*mw**4*mh**4-sdet4iwh
     & tsus**2/ctw**2*vpadn/qs*mw**6*mh**2-sdet4iwhtsus**2/ctw**2*vpadn/
     & qs*us*mw**2*mh**4+2*sdet4iwhtsus**2/ctw**2*vpadn/qs*us*mw**4*mh**
     & 2-sdet4iwhtsus**2/ctw**2*vpadn/qs*us*mw**6-sdet4iwhtsus**2/ctw**2
     & *vpadn*mw**2*mh**4+sdet4iwhtsus**2/ctw**2*vpadn*mw**4*mh**2-sdet4
     & iwhtsus**2/ctw**2*vpadn*us*mw**4+sdet4iwhtsus**2/ctw**2*vpadn*ts*
     & mw**2*mh**2-sdet4iwhtsus**2/ctw**2*vpaup*mw**4*mh**2+sdet4iwhtsus
     & **2/ctw**2*vpaup*ts**2*mw**2+sdet4iwhtsus**2*vpadn*us*mw**2*mh**2
     & +sdet4iwhtsus**2*vpadn*us**2*mw**2-sdet4iwhtsus**2*vpadn*ts*mw**2
     & *mh**2-sdet4iwhtsus**2*vpadn*ts**2*mw**2-sdet4iwhtsus**2*vpaup/qs
     & *mw**4*mh**4+2*sdet4iwhtsus**2*vpaup/qs*mw**6*mh**2-sdet4iwhtsus*
     & *2*vpaup/qs*mw**8-sdet4iwhtsus**2*vpaup/qs*ts*mw**2*mh**4+2*sdet4
     & iwhtsus**2*vpaup/qs*ts*mw**4*mh**2-sdet4iwhtsus**2*vpaup/qs*ts*mw
     & **6+2*sdet4iwhtsus**2*vpaup*mw**4*mh**2-sdet4iwhtsus**2*vpaup*mw*
     & *6+sdet4iwhtsus**2*vpaup*us*mw**4-sdet4iwhtsus**2*vpaup*ts**2*mw*
     & *2-sdet4iwhtsus**2*vpaup*ts**3)
     & +propiwqs*c0whqshww*(-7d0/8*det3iwhqs/mw**2*mh**4-7*det3iwhqs*mh*
     & *2-11d0/4*det3iwhqs*mw**2-3d0/8*det3iwhqs*qs/mw**2*mh**2-7d0/2*de
     & t3iwhqs*qs+3d0/32*det3iwhqs**2/mw**2*mh**8+15d0/16*det3iwhqs**2*m
     & h**6+87d0/32*det3iwhqs**2*mw**2*mh**4+75d0/8*det3iwhqs**2*mw**4*m
     & h**2+39d0/8*det3iwhqs**2*mw**6+3d0/32*det3iwhqs**2*qs/mw**2*mh**6
     & +9d0/32*det3iwhqs**2*qs*mh**4+9d0/8*det3iwhqs**2*qs*mw**2*mh**2+3
     & 9d0/8*det3iwhqs**2*qs*mw**4)
     & +propiwqs*c0whqsmnmomo*cfl*(-5d0/4*det3iwhqs/mw**2*mmo**4+1d0/4*d
     & et3iwhqs/mw**2*mh**2*mmo**2-1d0/2*det3iwhqs*mmo**2+1d0/4*det3iwhq
     & s*qs/mw**2*mmo**2-3d0/8*det3iwhqs**2/mw**2*mh**2*mmo**6-3d0/8*det
     & 3iwhqs**2*mmo**6+3d0/2*det3iwhqs**2*mh**2*mmo**4-3d0/8*det3iwhqs*
     & *2*mh**4*mmo**2-3d0/8*det3iwhqs**2*mw**4*mmo**2-3d0/8*det3iwhqs**
     & 2*qs/mw**2*mmo**6-3d0/8*det3iwhqs**2*qs*mh**2*mmo**2-3d0/8*det3iw
     & hqs**2*qs*mw**2*mmo**2)
     & +propiwqs*c0whqschstst*cfq*(-5d0/4*det3iwhqs/mw**2*mst**4+3d0/4*d
     & et3iwhqs/mw**2*mch**2*mst**2+1d0/4*det3iwhqs/mw**2*mh**2*mst**2-1
     & d0/2*det3iwhqs*mst**2+1d0/4*det3iwhqs*qs/mw**2*mst**2-3d0/8*det3i
     & whqs**2/mw**2*mh**2*mst**6+3d0/4*det3iwhqs**2/mw**2*mh**2*mch**2*
     & mst**4-3d0/8*det3iwhqs**2/mw**2*mh**2*mch**4*mst**2-3d0/8*det3iwh
     & qs**2*mst**6+3d0/4*det3iwhqs**2*mch**2*mst**4-3d0/8*det3iwhqs**2*
     & mch**4*mst**2+3d0/2*det3iwhqs**2*mh**2*mst**4-3d0/2*det3iwhqs**2*
     & mh**2*mch**2*mst**2-3d0/8*det3iwhqs**2*mh**4*mst**2-3d0/8*det3iwh
     & qs**2*mw**4*mst**2-3d0/8*det3iwhqs**2*qs/mw**2*mst**6+3d0/4*det3i
     & whqs**2*qs/mw**2*mch**2*mst**4-3d0/8*det3iwhqs**2*qs/mw**2*mch**4
     & *mst**2-3d0/8*det3iwhqs**2*qs*mh**2*mst**2-3d0/8*det3iwhqs**2*qs*
     & mw**2*mst**2)
     & +propiwqs*c0whqsstchch*cfq*(1d0/4*det3iwhqs/mw**2*mch**2*mst**2-3
     & d0/4*det3iwhqs/mw**2*mch**4-1d0/4*det3iwhqs*mch**2-3d0/8*det3iwhq
     & s**2/mw**2*mh**2*mch**2*mst**4+3d0/4*det3iwhqs**2/mw**2*mh**2*mch
     & **4*mst**2-3d0/8*det3iwhqs**2/mw**2*mh**2*mch**6-3d0/8*det3iwhqs*
     & *2*mch**2*mst**4+3d0/4*det3iwhqs**2*mch**4*mst**2-3d0/8*det3iwhqs
     & **2*mch**6-3d0/2*det3iwhqs**2*mh**2*mch**2*mst**2+3d0/2*det3iwhqs
     & **2*mh**2*mch**4-3d0/8*det3iwhqs**2*mh**4*mch**2-3d0/8*det3iwhqs*
     & *2*mw**4*mch**2-3d0/8*det3iwhqs**2*qs/mw**2*mch**2*mst**4+3d0/4*d
     & et3iwhqs**2*qs/mw**2*mch**4*mst**2-3d0/8*det3iwhqs**2*qs/mw**2*mc
     & h**6-3d0/8*det3iwhqs**2*qs*mh**2*mch**2-3d0/8*det3iwhqs**2*qs*mw*
     & *2*mch**2)
     & +propiwqs*c0whqstntata*cfl*(-5d0/4*det3iwhqs/mw**2*mta**4+1d0/4*d
     & et3iwhqs/mw**2*mh**2*mta**2-1d0/2*det3iwhqs*mta**2+1d0/4*det3iwhq
     & s*qs/mw**2*mta**2-3d0/8*det3iwhqs**2/mw**2*mh**2*mta**6-3d0/8*det
     & 3iwhqs**2*mta**6+3d0/2*det3iwhqs**2*mh**2*mta**4-3d0/8*det3iwhqs*
     & *2*mh**4*mta**2-3d0/8*det3iwhqs**2*mw**4*mta**2-3d0/8*det3iwhqs**
     & 2*qs/mw**2*mta**6-3d0/8*det3iwhqs**2*qs*mh**2*mta**2-3d0/8*det3iw
     & hqs**2*qs*mw**2*mta**2)
     & +propiwqs*c0whqstpbtbt*cfq*(-5d0/4*det3iwhqs/mw**2*mbt**4+3d0/4*d
     & et3iwhqs/mw**2*mtp**2*mbt**2+1d0/4*det3iwhqs/mw**2*mh**2*mbt**2-1
     & d0/2*det3iwhqs*mbt**2+1d0/4*det3iwhqs*qs/mw**2*mbt**2-3d0/8*det3i
     & whqs**2/mw**2*mh**2*mbt**6+3d0/4*det3iwhqs**2/mw**2*mh**2*mtp**2*
     & mbt**4-3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**4*mbt**2-3d0/8*det3iwh
     & qs**2*mbt**6+3d0/4*det3iwhqs**2*mtp**2*mbt**4-3d0/8*det3iwhqs**2*
     & mtp**4*mbt**2+3d0/2*det3iwhqs**2*mh**2*mbt**4-3d0/2*det3iwhqs**2*
     & mh**2*mtp**2*mbt**2-3d0/8*det3iwhqs**2*mh**4*mbt**2-3d0/8*det3iwh
     & qs**2*mw**4*mbt**2-3d0/8*det3iwhqs**2*qs/mw**2*mbt**6+3d0/4*det3i
     & whqs**2*qs/mw**2*mtp**2*mbt**4-3d0/8*det3iwhqs**2*qs/mw**2*mtp**4
     & *mbt**2-3d0/8*det3iwhqs**2*qs*mh**2*mbt**2-3d0/8*det3iwhqs**2*qs*
     & mw**2*mbt**2)
     & +propiwqs*c0whqsbttptp*cfq*(1d0/4*det3iwhqs/mw**2*mtp**2*mbt**2-3
     & d0/4*det3iwhqs/mw**2*mtp**4-1d0/4*det3iwhqs*mtp**2-3d0/8*det3iwhq
     & s**2/mw**2*mh**2*mtp**2*mbt**4+3d0/4*det3iwhqs**2/mw**2*mh**2*mtp
     & **4*mbt**2-3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**6-3d0/8*det3iwhqs*
     & *2*mtp**2*mbt**4+3d0/4*det3iwhqs**2*mtp**4*mbt**2-3d0/8*det3iwhqs
     & **2*mtp**6-3d0/2*det3iwhqs**2*mh**2*mtp**2*mbt**2+3d0/2*det3iwhqs
     & **2*mh**2*mtp**4-3d0/8*det3iwhqs**2*mh**4*mtp**2-3d0/8*det3iwhqs*
     & *2*mw**4*mtp**2-3d0/8*det3iwhqs**2*qs/mw**2*mtp**2*mbt**4+3d0/4*d
     & et3iwhqs**2*qs/mw**2*mtp**4*mbt**2-3d0/8*det3iwhqs**2*qs/mw**2*mt
     & p**6-3d0/8*det3iwhqs**2*qs*mh**2*mtp**2-3d0/8*det3iwhqs**2*qs*mw*
     & *2*mtp**2)
     & +propiwqs*c0whqscww*stw**2*(-det3iwhqs*mh**2+5*det3iwhqs*mw**2-de
     & t3iwhqs*qs+3d0/2*det3iwhqs**2*mw**2*mh**4-9d0/2*det3iwhqs**2*mw**
     & 4*mh**2+3*det3iwhqs**2*mw**6+3d0/2*det3iwhqs**2*qs*mw**2*mh**2+3*
     & det3iwhqs**2*qs*mw**4)
     & +propiwqs*c0whqscww*stw**2*qdn*(2*det3iwhqs*mw**2+det3iwhqs*sdet4
     & iwhtsus*mw**2*mh**4-det3iwhqs*sdet4iwhtsus*mw**4*mh**2+2*det3iwhq
     & s*sdet4iwhtsus*ts*mw**2*mh**2+2*det3iwhqs*sdet4iwhtsus*ts**2*mw**
     & 2+det3iwhqs*sdet4iwhtsus*qs*mw**2*mh**2+4*sdet4iwhtsus*mw**2+2*sd
     & et4iwhtsus*us-2*sdet4iwhtsus*ts+2*sdet4iwhtsus**2*mw**4*mh**2+2*s
     & det4iwhtsus**2*mw**6+6*sdet4iwhtsus**2*us*mw**2*mh**2+4*sdet4iwht
     & sus**2*us*mw**4+2*sdet4iwhtsus**2*us**2*mh**2+6*sdet4iwhtsus**2*u
     & s**2*mw**2+2*sdet4iwhtsus**2*us**3-2*sdet4iwhtsus**2*ts*mw**2*mh*
     & *2-2*sdet4iwhtsus**2*ts**2*mw**2+2*sdet4iwhtsus**2*qs*mw**4+4*sde
     & t4iwhtsus**2*qs*us*mw**2+2*sdet4iwhtsus**2*qs*us**2)
     & +propiwqs*c0whqscww*stw**2*qup*(2*det3iwhqs*mw**2+det3iwhqs*sdet4
     & iwhtsus*mw**2*mh**4-det3iwhqs*sdet4iwhtsus*mw**4*mh**2+2*det3iwhq
     & s*sdet4iwhtsus*ts*mw**2*mh**2+2*det3iwhqs*sdet4iwhtsus*ts**2*mw**
     & 2+det3iwhqs*sdet4iwhtsus*qs*mw**2*mh**2+2*sdet4iwhtsus/qs*ts*mh**
     & 2-2*sdet4iwhtsus/qs*ts*mw**2+2*sdet4iwhtsus*mw**2-2*sdet4iwhtsus*
     & *2/qs*mw**4*mh**4+2*sdet4iwhtsus**2/qs*mw**6*mh**2-2*sdet4iwhtsus
     & **2/qs*ts*mw**2*mh**4-2*sdet4iwhtsus**2/qs*ts*mw**4*mh**2+2*sdet4
     & iwhtsus**2/qs*ts*mw**6-6*sdet4iwhtsus**2/qs*ts**2*mw**2*mh**2-2*s
     & det4iwhtsus**2/qs*ts**3*mh**2-4*sdet4iwhtsus**2/qs*ts**3*mw**2-2*
     & sdet4iwhtsus**2/qs*ts**4+4*sdet4iwhtsus**2*mw**4*mh**2+2*sdet4iwh
     & tsus**2*us*mw**4+4*sdet4iwhtsus**2*ts*mw**4-2*sdet4iwhtsus**2*ts*
     & *3)
     & +propiwqs*a0fw*stw**2*(-det3iwhqs-3d0/2*det3iwhqs**2*mw**2*mh**2+
     & 3d0/2*det3iwhqs**2*mw**4-3d0/2*det3iwhqs**2*qs*mw**2)
     & +propiwqs*a0fw*stw**2*qdn*(-det3iwhqs*sdet4iwhtsus*mw**2*mh**2-de
     & t3iwhqs*sdet4iwhtsus*mw**4-2*det3iwhqs*sdet4iwhtsus*ts*mw**2-det3
     & iwhqs*sdet4iwhtsus*qs*mw**2+4*sdet3icwus*sdet4iwhtsus*mw**2)
     & +propiwqs*a0fw*stw**2*qup*(-det3iwhqs*sdet4iwhtsus*mw**2*mh**2-de
     & t3iwhqs*sdet4iwhtsus*mw**4-2*det3iwhqs*sdet4iwhtsus*ts*mw**2-det3
     & iwhqs*sdet4iwhtsus*qs*mw**2)
     & +propiwqs*a0fh*(-1d0/4*det3iwhqs-1d0/2*det3iwhqs/mw**2*mh**2-1d0/
     & 4*det3iwhqs*qs/mw**2)
     & +propiwqs*b0fhww*stw**2*qdn*(det3iwhqs-det3iwhqs*sdet4iwhtsus*mw*
     & *2*mh**2+det3iwhqs*sdet4iwhtsus*ts**2)
     & +propiwqs*b0fhww*stw**2*qup*(det3iwhqs-det3iwhqs*sdet4iwhtsus*mw*
     & *2*mh**2+det3iwhqs*sdet4iwhtsus*ts**2-4*sdet3ichts*sdet4iwhtsus*m
     & h**2+4*sdet4iwhtsus)
     & +propiwqs*b0fhww*(3d0/2*det3iwhqs+5d0/8*det3iwhqs/mw**2*mh**2+1d0
     & /4*det3iwhqs*qs/mw**2+1d0/2*det3iwhqs*vpadn+1d0/2*det3iwhqs*vpaup
     & -3d0/32*det3iwhqs**2/ctw**2*mh**4-21d0/32*det3iwhqs**2/ctw**2*mw*
     & *2*mh**2-3d0/8*det3iwhqs**2/ctw**2*mw**4-3d0/32*det3iwhqs**2/ctw*
     & *2*qs*mh**2-3d0/8*det3iwhqs**2/ctw**2*qs*mw**2-3d0/32*det3iwhqs**
     & 2/mw**2*mh**6-27d0/32*det3iwhqs**2*mh**4-93d0/16*det3iwhqs**2*mw*
     & *2*mh**2-3d0/4*det3iwhqs**2*mw**4-3d0/32*det3iwhqs**2*qs/mw**2*mh
     & **4-3d0/16*det3iwhqs**2*qs*mh**2-3d0/4*det3iwhqs**2*qs*mw**2-1d0/
     & 2*det3iwhqs*sdet4iwhtsus*vpadn*mw**2*mh**2+1d0/2*det3iwhqs*sdet4i
     & whtsus*vpadn*ts**2-1d0/2*det3iwhqs*sdet4iwhtsus*vpaup*mw**2*mh**2
     & +1d0/2*det3iwhqs*sdet4iwhtsus*vpaup*ts**2-2*sdet3ichts*sdet4iwhts
     & us*vpaup*mh**2+2*sdet4iwhtsus*vpaup)
     & +propiwqs*b0fhzz*(det3iwhqs+1d0/8*det3iwhqs/ctw**2-1d0/2*det3iwhq
     & s/ctw**2*vpadn-1d0/2*det3iwhqs/ctw**2*vpaup+1d0/16*det3iwhqs/mw**
     & 2*mh**2+3d0/16*det3iwhqs**2/ctw**4*mw**2*mh**2+3d0/16*det3iwhqs**
     & 2/ctw**4*mw**4+3d0/16*det3iwhqs**2/ctw**4*qs*mw**2+3d0/32*det3iwh
     & qs**2/ctw**2*mh**4+45d0/32*det3iwhqs**2/ctw**2*mw**2*mh**2+3d0/2*
     & det3iwhqs**2/ctw**2*mw**4+3d0/32*det3iwhqs**2/ctw**2*qs*mh**2+3d0
     & /2*det3iwhqs**2/ctw**2*qs*mw**2-9d0/32*det3iwhqs**2*mh**4-171d0/3
     & 2*det3iwhqs**2*mw**2*mh**2-15d0/8*det3iwhqs**2*mw**4-3d0/32*det3i
     & whqs**2*qs*mh**2-15d0/8*det3iwhqs**2*qs*mw**2+1d0/2*det3iwhqs*sde
     & t4iwhtsus/ctw**2*vpadn*mw**2*mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/c
     & tw**2*vpadn*ts**2+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**2
     & *mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*ts**2-sdet3ichts
     & /ctw**4*vpaup*vpadn/qs+2*sdet3ichts*sdet4iwhtsus/ctw**2*vpadn*mh*
     & *2-sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*mw**2-sdet4iwhtsus/ctw**4*v
     & paup*vpadn/qs*ts-2*sdet4iwhtsus/ctw**2*vpadn)
     & +propiwqs*b0fhhh*(-3d0/4*det3iwhqs-21d0/16*det3iwhqs/mw**2*mh**2-
     & 3d0/4*det3iwhqs*qs/mw**2+9d0/32*det3iwhqs**2/mw**2*mh**6+9d0/16*d
     & et3iwhqs**2*mh**4+81d0/32*det3iwhqs**2*mw**2*mh**2+9d0/8*det3iwhq
     & s**2*mw**4+9d0/32*det3iwhqs**2*qs/mw**2*mh**4+9d0/32*det3iwhqs**2
     & *qs*mh**2+9d0/8*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fhmomo*cfl*(-1d0/2*det3iwhqs/mw**2*mmo**2-3d0/8*det3i
     & whqs**2/mw**2*mh**2*mmo**4-3d0/8*det3iwhqs**2*mmo**4+3d0/4*det3iw
     & hqs**2*mh**2*mmo**2-3d0/8*det3iwhqs**2*qs/mw**2*mmo**4)
     & +propiwqs*b0fhchch*cfq*(3d0/8*det3iwhqs**2/mw**2*mh**2*mch**2*mst
     & **2-3d0/8*det3iwhqs**2/mw**2*mh**2*mch**4+3d0/8*det3iwhqs**2*mch*
     & *2*mst**2-3d0/8*det3iwhqs**2*mch**4+3d0/4*det3iwhqs**2*mh**2*mch*
     & *2+3d0/8*det3iwhqs**2*qs/mw**2*mch**2*mst**2-3d0/8*det3iwhqs**2*q
     & s/mw**2*mch**4)
     & +propiwqs*b0fhstst*cfq*(-1d0/2*det3iwhqs/mw**2*mst**2-3d0/8*det3i
     & whqs**2/mw**2*mh**2*mst**4+3d0/8*det3iwhqs**2/mw**2*mh**2*mch**2*
     & mst**2-3d0/8*det3iwhqs**2*mst**4+3d0/8*det3iwhqs**2*mch**2*mst**2
     & +3d0/4*det3iwhqs**2*mh**2*mst**2-3d0/8*det3iwhqs**2*qs/mw**2*mst*
     & *4+3d0/8*det3iwhqs**2*qs/mw**2*mch**2*mst**2)
     & +propiwqs*b0fhtata*cfl*(-1d0/2*det3iwhqs/mw**2*mta**2-3d0/8*det3i
     & whqs**2/mw**2*mh**2*mta**4-3d0/8*det3iwhqs**2*mta**4+3d0/4*det3iw
     & hqs**2*mh**2*mta**2-3d0/8*det3iwhqs**2*qs/mw**2*mta**4)
     & +propiwqs*b0fhtptp*cfq*(3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**2*mbt
     & **2-3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**4+3d0/8*det3iwhqs**2*mtp*
     & *2*mbt**2-3d0/8*det3iwhqs**2*mtp**4+3d0/4*det3iwhqs**2*mh**2*mtp*
     & *2+3d0/8*det3iwhqs**2*qs/mw**2*mtp**2*mbt**2-3d0/8*det3iwhqs**2*q
     & s/mw**2*mtp**4)
     & +propiwqs*b0fhbtbt*cfq*(-1d0/2*det3iwhqs/mw**2*mbt**2-3d0/8*det3i
     & whqs**2/mw**2*mh**2*mbt**4+3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**2*
     & mbt**2-3d0/8*det3iwhqs**2*mbt**4+3d0/8*det3iwhqs**2*mtp**2*mbt**2
     & +3d0/4*det3iwhqs**2*mh**2*mbt**2-3d0/8*det3iwhqs**2*qs/mw**2*mbt*
     & *4+3d0/8*det3iwhqs**2*qs/mw**2*mtp**2*mbt**2)
     & +propiwqs*b0fwwz*stw**2*(-det3iwhqs-3d0/2*det3iwhqs**2*mw**2*mh**
     & 2+3d0/2*det3iwhqs**2*mw**4-3d0/2*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fwwz*(1d0/4*det3iwhqs+1d0/4*det3iwhqs/ctw**2-3d0/16*d
     & et3iwhqs**2/ctw**4*mw**4+3d0/16*det3iwhqs**2/ctw**2*mw**2*mh**2-9
     & d0/8*det3iwhqs**2/ctw**2*mw**4+3d0/16*det3iwhqs**2/ctw**2*qs*mw**
     & 2+3d0/16*det3iwhqs**2*mh**4+57d0/16*det3iwhqs**2*mw**2*mh**2+3d0/
     & 2*det3iwhqs**2*mw**4+3d0/16*det3iwhqs**2*qs*mh**2+27d0/8*det3iwhq
     & s**2*qs*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*mw**2*mh*
     & *2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*mw**4-det3iwhqs*sdet
     & 4iwhtsus/ctw**2*vpadn*ts*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**
     & 2*vpadn*qs*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**2*
     & mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**4-det3iwhqs*s
     & det4iwhtsus/ctw**2*vpaup*ts*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ct
     & w**2*vpaup*qs*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*mw**2*mh**
     & 2+1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*mw**4+det3iwhqs*sdet4iwhtsus
     & *vpadn*ts*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*qs*mw**2+1d0/2
     & *det3iwhqs*sdet4iwhtsus*vpaup*mw**2*mh**2+1d0/2*det3iwhqs*sdet4iw
     & htsus*vpaup*mw**4+det3iwhqs*sdet4iwhtsus*vpaup*ts*mw**2+1d0/2*det
     & 3iwhqs*sdet4iwhtsus*vpaup*qs*mw**2+2*sdet3icwus*sdet4iwhtsus/ctw*
     & *2*vpaup*mw**2-2*sdet3icwus*sdet4iwhtsus*vpadn*mw**2)
     & +propiwqs*b0fwwh*(3d0/8*det3iwhqs+1d0/4*det3iwhqs/mw**2*mh**2+1d0
     & /8*det3iwhqs*qs/mw**2-3d0/16*det3iwhqs**2*mh**4+3d0/8*det3iwhqs**
     & 2*mw**2*mh**2-3d0/16*det3iwhqs**2*mw**4+3d0/16*det3iwhqs**2*qs*mh
     & **2+3d0/16*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fwupdn*(sdet3icwus/ctw**4*vpaup*vpadn/qs-sdet4iwhtsus
     & /ctw**4*vpaup*vpadn/qs*mw**2-sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*t
     & s)
     & +propiwqs*b0fwmnmo*cfl*(-1d0/4*det3iwhqs/mw**2*mmo**2+3d0/8*det3i
     & whqs**2*mmo**4-3d0/8*det3iwhqs**2*mh**2*mmo**2-3d0/8*det3iwhqs**2
     & *qs*mmo**2)
     & +propiwqs*b0fwchst*cfq*(-1d0/4*det3iwhqs/mw**2*mst**2+3d0/8*det3i
     & whqs**2*mst**4-3d0/4*det3iwhqs**2*mch**2*mst**2+3d0/8*det3iwhqs**
     & 2*mch**4-3d0/8*det3iwhqs**2*mh**2*mst**2-3d0/8*det3iwhqs**2*mh**2
     & *mch**2-3d0/8*det3iwhqs**2*qs*mst**2-3d0/8*det3iwhqs**2*qs*mch**2
     & )
     & +propiwqs*b0fwtnta*cfl*(-1d0/4*det3iwhqs/mw**2*mta**2+3d0/8*det3i
     & whqs**2*mta**4-3d0/8*det3iwhqs**2*mh**2*mta**2-3d0/8*det3iwhqs**2
     & *qs*mta**2)
     & +propiwqs*b0fwtpbt*cfq*(-1d0/4*det3iwhqs/mw**2*mbt**2+3d0/8*det3i
     & whqs**2*mbt**4-3d0/4*det3iwhqs**2*mtp**2*mbt**2+3d0/8*det3iwhqs**
     & 2*mtp**4-3d0/8*det3iwhqs**2*mh**2*mbt**2-3d0/8*det3iwhqs**2*mh**2
     & *mtp**2-3d0/8*det3iwhqs**2*qs*mbt**2-3d0/8*det3iwhqs**2*qs*mtp**2
     & )
     & +propiwqs*b0fqswz*stw**2*(2*det3iwhqs+3*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fqswz*(-19d0/8*det3iwhqs-3d0/8*det3iwhqs/ctw**2+1d0/2
     & *det3iwhqs/ctw**2*vpadn+1d0/2*det3iwhqs/ctw**2*vpaup-1d0/8*det3iw
     & hqs/mw**2*mh**2-1d0/2*det3iwhqs*vpadn-1d0/2*det3iwhqs*vpaup-3d0/1
     & 6*det3iwhqs**2/ctw**4*mw**2*mh**2-3d0/16*det3iwhqs**2/ctw**4*qs*m
     & w**2-15d0/16*det3iwhqs**2/ctw**2*mw**2*mh**2-21d0/16*det3iwhqs**2
     & /ctw**2*qs*mw**2+3d0/16*det3iwhqs**2*mh**4+39d0/8*det3iwhqs**2*mw
     & **2*mh**2+3d0/16*det3iwhqs**2*mw**4-3d0/16*det3iwhqs**2*qs*mh**2-
     & 27d0/16*det3iwhqs**2*qs*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2
     & *vpadn*mw**4+det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*ts*mw**2+1d0/2*d
     & et3iwhqs*sdet4iwhtsus/ctw**2*vpadn*ts**2+1d0/2*det3iwhqs*sdet4iwh
     & tsus/ctw**2*vpadn*qs*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vp
     & aup*mw**4+det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*ts*mw**2+1d0/2*det3
     & iwhqs*sdet4iwhtsus/ctw**2*vpaup*ts**2+1d0/2*det3iwhqs*sdet4iwhtsu
     & s/ctw**2*vpaup*qs*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*mw**4-
     & det3iwhqs*sdet4iwhtsus*vpadn*ts*mw**2-1d0/2*det3iwhqs*sdet4iwhtsu
     & s*vpadn*ts**2-1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*qs*mw**2-1d0/2*d
     & et3iwhqs*sdet4iwhtsus*vpaup*mw**4-det3iwhqs*sdet4iwhtsus*vpaup*ts
     & *mw**2-1d0/2*det3iwhqs*sdet4iwhtsus*vpaup*ts**2-1d0/2*det3iwhqs*s
     & det4iwhtsus*vpaup*qs*mw**2)
     & +propiwqs*b0fqswh*(-1d0/4*det3iwhqs+1d0/8*det3iwhqs*qs/mw**2-3d0/
     & 16*det3iwhqs**2/mw**2*mh**6+3d0/8*det3iwhqs**2*mh**4-3d0/16*det3i
     & whqs**2*mw**2*mh**2-3d0/16*det3iwhqs**2*qs/mw**2*mh**4-3d0/16*det
     & 3iwhqs**2*qs*mh**2-3d0/8*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fqswc*stw**2*(-2*det3iwhqs-3*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fqswc*stw**2*qdn*(-det3iwhqs-det3iwhqs*sdet4iwhtsus*m
     & w**4-2*det3iwhqs*sdet4iwhtsus*ts*mw**2-det3iwhqs*sdet4iwhtsus*ts*
     & *2-det3iwhqs*sdet4iwhtsus*qs*mw**2)
     & +propiwqs*b0fqswc*stw**2*qup*(-det3iwhqs-det3iwhqs*sdet4iwhtsus*m
     & w**4-2*det3iwhqs*sdet4iwhtsus*ts*mw**2-det3iwhqs*sdet4iwhtsus*ts*
     & *2-det3iwhqs*sdet4iwhtsus*qs*mw**2)
     & +propiwqs*b0fqsmnmo*cfl*(3d0/4*det3iwhqs/mw**2*mmo**2+3d0/8*det3i
     & whqs**2/mw**2*mh**2*mmo**4-3d0/8*det3iwhqs**2*mh**2*mmo**2+3d0/8*
     & det3iwhqs**2*qs/mw**2*mmo**4+3d0/8*det3iwhqs**2*qs*mmo**2)
     & +propiwqs*b0fqschst*cfq*(3d0/4*det3iwhqs/mw**2*mst**2+3d0/8*det3i
     & whqs**2/mw**2*mh**2*mst**4-3d0/4*det3iwhqs**2/mw**2*mh**2*mch**2*
     & mst**2+3d0/8*det3iwhqs**2/mw**2*mh**2*mch**4-3d0/8*det3iwhqs**2*m
     & h**2*mst**2-3d0/8*det3iwhqs**2*mh**2*mch**2+3d0/8*det3iwhqs**2*qs
     & /mw**2*mst**4-3d0/4*det3iwhqs**2*qs/mw**2*mch**2*mst**2+3d0/8*det
     & 3iwhqs**2*qs/mw**2*mch**4+3d0/8*det3iwhqs**2*qs*mst**2+3d0/8*det3
     & iwhqs**2*qs*mch**2)
     & +propiwqs*b0fqstnta*cfl*(3d0/4*det3iwhqs/mw**2*mta**2+3d0/8*det3i
     & whqs**2/mw**2*mh**2*mta**4-3d0/8*det3iwhqs**2*mh**2*mta**2+3d0/8*
     & det3iwhqs**2*qs/mw**2*mta**4+3d0/8*det3iwhqs**2*qs*mta**2)
     & +propiwqs*b0fqstpbt*cfq*(3d0/4*det3iwhqs/mw**2*mbt**2+3d0/8*det3i
     & whqs**2/mw**2*mh**2*mbt**4-3d0/4*det3iwhqs**2/mw**2*mh**2*mtp**2*
     & mbt**2+3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**4-3d0/8*det3iwhqs**2*m
     & h**2*mbt**2-3d0/8*det3iwhqs**2*mh**2*mtp**2+3d0/8*det3iwhqs**2*qs
     & /mw**2*mbt**4-3d0/4*det3iwhqs**2*qs/mw**2*mtp**2*mbt**2+3d0/8*det
     & 3iwhqs**2*qs/mw**2*mtp**4+3d0/8*det3iwhqs**2*qs*mbt**2+3d0/8*det3
     & iwhqs**2*qs*mtp**2)
     & +propiwqs*b0ftswup*stw**2*qup*(4*sdet3ichts*sdet4iwhtsus*mh**2-4*
     & sdet4iwhtsus)
     & +propiwqs*b0ftswup*(2*sdet3ichts*sdet4iwhtsus*vpaup*mh**2-2*sdet4
     & iwhtsus*vpaup)
     & +propiwqs*b0ftszdn*(sdet3ichts/ctw**4*vpaup*vpadn/qs-2*sdet3ichts
     & *sdet4iwhtsus/ctw**2*vpadn*mh**2+sdet4iwhtsus/ctw**4*vpaup*vpadn/
     & qs*mw**2+sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*ts+2*sdet4iwhtsus/ctw
     & **2*vpadn)
     & +propiwqs*b0fuswdn*stw**2*qdn*(4*sdet3icwus*sdet4iwhtsus*mw**2)
     & +propiwqs*b0fuswdn*(2*sdet3icwus*sdet4iwhtsus*vpadn*mw**2)
     & +propiwqs*b0fuszup*(-sdet3icwus/ctw**4*vpaup*vpadn/qs-2*sdet3icwu
     & s*sdet4iwhtsus/ctw**2*vpaup*mw**2+sdet4iwhtsus/ctw**4*vpaup*vpadn
     & /qs*mw**2+sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*ts)
     & +propiwqs*(-15d0/8*det3iwhqs-1d0/8*det3iwhqs/ctw**2+3d0/8*det3iwh
     & qs/mw**2*mh**2+3d0/8*det3iwhqs*qs/mw**2)
     & +c0whqswzz*(7d0/2+1d0/2*det3iwhqs/ctw**6*mw**4-1d0/4*det3iwhqs/ct
     & w**4*mw**2*mh**2+11d0/4*det3iwhqs/ctw**4*mw**4+1d0/4*det3iwhqs/ct
     & w**2*mw**2*mh**2-35d0/2*det3iwhqs/ctw**2*mw**4+13d0/4*det3iwhqs*m
     & w**2*mh**2+15*det3iwhqs*mw**4-3d0/8*det3iwhqs**2/ctw**6*mw**6*mh*
     & *2-9d0/4*det3iwhqs**2/ctw**4*mw**6*mh**2+27d0/2*det3iwhqs**2/ctw*
     & *2*mw**6*mh**2-15*det3iwhqs**2*mw**6*mh**2)
     & +c0whqswhh*(-21d0/2-3/mw**2*mh**2+51d0/4*det3iwhqs*mw**2*mh**2+9*
     & det3iwhqs*mw**4-9*det3iwhqs**2*mw**6*mh**2)
     & +c0whqszww*(4-1d0/2/ctw**2+1d0/4*det3iwhqs/ctw**4*mw**2*mh**2+5d0
     & /4*det3iwhqs/ctw**4*mw**4-det3iwhqs/ctw**2*mw**2*mh**2+7d0/2*det3
     & iwhqs/ctw**2*mw**4+4*det3iwhqs*mw**2*mh**2-4*det3iwhqs*mw**4-9d0/
     & 8*det3iwhqs**2/ctw**4*mw**6*mh**2-3*det3iwhqs**2/ctw**2*mw**6*mh*
     & *2)
     & +c0whqshww*(-13-3d0/2/mw**2*mh**2+17*det3iwhqs*mw**2*mh**2+18*det
     & 3iwhqs*mw**4-18*det3iwhqs**2*mw**6*mh**2)
     & +c0whqsmnmomo*cfl*(-det3iwhqs/mw**2*mmo**6+1d0/4*det3iwhqs/mw**2*
     & mh**2*mmo**4+2*det3iwhqs*mmo**4-1d0/4*det3iwhqs*mh**2*mmo**2-det3
     & iwhqs*mw**2*mmo**2+3d0/4*det3iwhqs**2*mh**2*mmo**6-3d0/2*det3iwhq
     & s**2*mw**2*mh**2*mmo**4+3d0/4*det3iwhqs**2*mw**4*mh**2*mmo**2)
     & +c0whqschstst*cfq*(-det3iwhqs/mw**2*mst**6+2*det3iwhqs/mw**2*mch*
     & *2*mst**4-det3iwhqs/mw**2*mch**4*mst**2+1d0/4*det3iwhqs/mw**2*mh*
     & *2*mst**4-3d0/4*det3iwhqs/mw**2*mh**2*mch**2*mst**2+2*det3iwhqs*m
     & st**4-det3iwhqs*mch**2*mst**2-1d0/4*det3iwhqs*mh**2*mst**2-det3iw
     & hqs*mw**2*mst**2+3d0/4*det3iwhqs**2*mh**2*mst**6-3d0/2*det3iwhqs*
     & *2*mh**2*mch**2*mst**4+3d0/4*det3iwhqs**2*mh**2*mch**4*mst**2-3d0
     & /2*det3iwhqs**2*mw**2*mh**2*mst**4+3d0/2*det3iwhqs**2*mw**2*mh**2
     & *mch**2*mst**2+3d0/4*det3iwhqs**2*mw**4*mh**2*mst**2)
     & +c0whqsstchch*cfq*(-det3iwhqs/mw**2*mch**2*mst**4+2*det3iwhqs/mw*
     & *2*mch**4*mst**2-det3iwhqs/mw**2*mch**6-3d0/4*det3iwhqs/mw**2*mh*
     & *2*mch**2*mst**2+1d0/4*det3iwhqs/mw**2*mh**2*mch**4-det3iwhqs*mch
     & **2*mst**2+2*det3iwhqs*mch**4-1d0/4*det3iwhqs*mh**2*mch**2-det3iw
     & hqs*mw**2*mch**2+3d0/4*det3iwhqs**2*mh**2*mch**2*mst**4-3d0/2*det
     & 3iwhqs**2*mh**2*mch**4*mst**2+3d0/4*det3iwhqs**2*mh**2*mch**6+3d0
     & /2*det3iwhqs**2*mw**2*mh**2*mch**2*mst**2-3d0/2*det3iwhqs**2*mw**
     & 2*mh**2*mch**4+3d0/4*det3iwhqs**2*mw**4*mh**2*mch**2)
     & +c0whqstntata*cfl*(-det3iwhqs/mw**2*mta**6+1d0/4*det3iwhqs/mw**2*
     & mh**2*mta**4+2*det3iwhqs*mta**4-1d0/4*det3iwhqs*mh**2*mta**2-det3
     & iwhqs*mw**2*mta**2+3d0/4*det3iwhqs**2*mh**2*mta**6-3d0/2*det3iwhq
     & s**2*mw**2*mh**2*mta**4+3d0/4*det3iwhqs**2*mw**4*mh**2*mta**2)
     & +c0whqstpbtbt*cfq*(-det3iwhqs/mw**2*mbt**6+2*det3iwhqs/mw**2*mtp*
     & *2*mbt**4-det3iwhqs/mw**2*mtp**4*mbt**2+1d0/4*det3iwhqs/mw**2*mh*
     & *2*mbt**4-3d0/4*det3iwhqs/mw**2*mh**2*mtp**2*mbt**2+2*det3iwhqs*m
     & bt**4-det3iwhqs*mtp**2*mbt**2-1d0/4*det3iwhqs*mh**2*mbt**2-det3iw
     & hqs*mw**2*mbt**2+3d0/4*det3iwhqs**2*mh**2*mbt**6-3d0/2*det3iwhqs*
     & *2*mh**2*mtp**2*mbt**4+3d0/4*det3iwhqs**2*mh**2*mtp**4*mbt**2-3d0
     & /2*det3iwhqs**2*mw**2*mh**2*mbt**4+3d0/2*det3iwhqs**2*mw**2*mh**2
     & *mtp**2*mbt**2+3d0/4*det3iwhqs**2*mw**4*mh**2*mbt**2)
     & +c0whqsbttptp*cfq*(-det3iwhqs/mw**2*mtp**2*mbt**4+2*det3iwhqs/mw*
     & *2*mtp**4*mbt**2-det3iwhqs/mw**2*mtp**6-3d0/4*det3iwhqs/mw**2*mh*
     & *2*mtp**2*mbt**2+1d0/4*det3iwhqs/mw**2*mh**2*mtp**4-det3iwhqs*mtp
     & **2*mbt**2+2*det3iwhqs*mtp**4-1d0/4*det3iwhqs*mh**2*mtp**2-det3iw
     & hqs*mw**2*mtp**2+3d0/4*det3iwhqs**2*mh**2*mtp**2*mbt**4-3d0/2*det
     & 3iwhqs**2*mh**2*mtp**4*mbt**2+3d0/4*det3iwhqs**2*mh**2*mtp**6+3d0
     & /2*det3iwhqs**2*mw**2*mh**2*mtp**2*mbt**2-3d0/2*det3iwhqs**2*mw**
     & 2*mh**2*mtp**4+3d0/4*det3iwhqs**2*mw**4*mh**2*mtp**2)
     & +a0fw*stw**2*(-det3iwhqs*mh**2)
     & +a0fw*(-1d0/4*det3iwhqs/ctw**2*mw**2-1d0/4*det3iwhqs*mh**2+1d0/2*
     & det3iwhqs*mw**2)
     & +a0fz*(1d0/4*det3iwhqs/ctw**4*mw**2+7d0/4*det3iwhqs/ctw**2*mw**2-
     & 2*det3iwhqs*mw**2)
     & +a0fh*(-1d0/mw**2+3d0/4*det3iwhqs*mh**2)
     & +a0fmo*cfl*(-1d0/2*det3iwhqs/mw**2*mmo**4)
     & +a0fch*cfq*(1d0/2*det3iwhqs/mw**2*mch**2*mst**2-1d0/2*det3iwhqs/m
     & w**2*mch**4)
     & +a0fst*cfq*(-1d0/2*det3iwhqs/mw**2*mst**4+1d0/2*det3iwhqs/mw**2*m
     & ch**2*mst**2)
     & +a0fta*cfl*(-1d0/2*det3iwhqs/mw**2*mta**4)
     & +a0ftp*cfq*(1d0/2*det3iwhqs/mw**2*mtp**2*mbt**2-1d0/2*det3iwhqs/m
     & w**2*mtp**4)
     & +a0fbt*cfq*(-1d0/2*det3iwhqs/mw**2*mbt**4+1d0/2*det3iwhqs/mw**2*m
     & tp**2*mbt**2)
     & +b0fhww*(1d0/mw**2-1d0/4*det3iwhqs/ctw**2*mh**2-5d0/4*det3iwhqs/c
     & tw**2*mw**2-3*det3iwhqs*mh**2-6*det3iwhqs*mw**2+9d0/8*det3iwhqs**
     & 2/ctw**2*mw**4*mh**2+15d0/2*det3iwhqs**2*mw**4*mh**2)
     & +b0fhzz*(1d0/2*det3iwhqs/ctw**4*mw**2-1d0/4*det3iwhqs/ctw**2*mh**
     & 2+4*det3iwhqs/ctw**2*mw**2-3d0/8*det3iwhqs*mh**2-15d0/2*det3iwhqs
     & *mw**2-3d0/8*det3iwhqs**2/ctw**4*mw**4*mh**2-3*det3iwhqs**2/ctw**
     & 2*mw**4*mh**2+15d0/2*det3iwhqs**2*mw**4*mh**2)
     & +b0fhhh*(-3/mw**2+33d0/8*det3iwhqs*mh**2+9d0/2*det3iwhqs*mw**2-9d
     & 0/2*det3iwhqs**2*mw**4*mh**2)
     & +b0fhmomo*cfl*(-det3iwhqs/mw**2*mmo**4+1d0/4*det3iwhqs/mw**2*mh**
     & 2*mmo**2+1d0/2*det3iwhqs*mmo**2+3d0/4*det3iwhqs**2*mh**2*mmo**4-3
     & d0/4*det3iwhqs**2*mw**2*mh**2*mmo**2)
     & +b0fhchch*cfq*(det3iwhqs/mw**2*mch**2*mst**2-det3iwhqs/mw**2*mch*
     & *4+1d0/4*det3iwhqs/mw**2*mh**2*mch**2+1d0/2*det3iwhqs*mch**2-3d0/
     & 4*det3iwhqs**2*mh**2*mch**2*mst**2+3d0/4*det3iwhqs**2*mh**2*mch**
     & 4-3d0/4*det3iwhqs**2*mw**2*mh**2*mch**2)
     & +b0fhstst*cfq*(-det3iwhqs/mw**2*mst**4+det3iwhqs/mw**2*mch**2*mst
     & **2+1d0/4*det3iwhqs/mw**2*mh**2*mst**2+1d0/2*det3iwhqs*mst**2+3d0
     & /4*det3iwhqs**2*mh**2*mst**4-3d0/4*det3iwhqs**2*mh**2*mch**2*mst*
     & *2-3d0/4*det3iwhqs**2*mw**2*mh**2*mst**2)
     & +b0fhtata*cfl*(-det3iwhqs/mw**2*mta**4+1d0/4*det3iwhqs/mw**2*mh**
     & 2*mta**2+1d0/2*det3iwhqs*mta**2+3d0/4*det3iwhqs**2*mh**2*mta**4-3
     & d0/4*det3iwhqs**2*mw**2*mh**2*mta**2)
     & +b0fhtptp*cfq*(det3iwhqs/mw**2*mtp**2*mbt**2-det3iwhqs/mw**2*mtp*
     & *4+1d0/4*det3iwhqs/mw**2*mh**2*mtp**2+1d0/2*det3iwhqs*mtp**2-3d0/
     & 4*det3iwhqs**2*mh**2*mtp**2*mbt**2+3d0/4*det3iwhqs**2*mh**2*mtp**
     & 4-3d0/4*det3iwhqs**2*mw**2*mh**2*mtp**2)
     & +b0fhbtbt*cfq*(-det3iwhqs/mw**2*mbt**4+det3iwhqs/mw**2*mtp**2*mbt
     & **2+1d0/4*det3iwhqs/mw**2*mh**2*mbt**2+1d0/2*det3iwhqs*mbt**2+3d0
     & /4*det3iwhqs**2*mh**2*mbt**4-3d0/4*det3iwhqs**2*mh**2*mtp**2*mbt*
     & *2-3d0/4*det3iwhqs**2*mw**2*mh**2*mbt**2)
     & +b0fwwz*stw**2*(-det3iwhqs*mh**2)
     & +b0fwwz*(-1d0/8*det3iwhqs/ctw**4*mw**2+1d0/4*det3iwhqs/ctw**2*mh*
     & *2-5d0/8*det3iwhqs/ctw**2*mw**2+3d0/8*det3iwhqs*mh**2+15d0/4*det3
     & iwhqs*mw**2+3d0/16*det3iwhqs**2/ctw**4*mw**4*mh**2+15d0/16*det3iw
     & hqs**2/ctw**2*mw**4*mh**2-21d0/4*det3iwhqs**2*mw**4*mh**2)
     & +b0fwwh*(1d0/2/mw**2-1d0/2*det3iwhqs*mh**2)
     & +b0fwmnmo*cfl*(1d0/4*det3iwhqs/mw**2*mmo**4-1d0/4*det3iwhqs/mw**2
     & *mh**2*mmo**2+1d0/4*det3iwhqs*mmo**2-3d0/8*det3iwhqs**2*mh**2*mmo
     & **4+3d0/8*det3iwhqs**2*mw**2*mh**2*mmo**2)
     & +b0fwchst*cfq*(1d0/4*det3iwhqs/mw**2*mst**4-1d0/2*det3iwhqs/mw**2
     & *mch**2*mst**2+1d0/4*det3iwhqs/mw**2*mch**4-1d0/4*det3iwhqs/mw**2
     & *mh**2*mst**2+1d0/4*det3iwhqs*mst**2-3d0/4*det3iwhqs*mch**2-3d0/8
     & *det3iwhqs**2*mh**2*mst**4+3d0/4*det3iwhqs**2*mh**2*mch**2*mst**2
     & -3d0/8*det3iwhqs**2*mh**2*mch**4+3d0/8*det3iwhqs**2*mw**2*mh**2*m
     & st**2+3d0/8*det3iwhqs**2*mw**2*mh**2*mch**2)
     & +b0fwtnta*cfl*(1d0/4*det3iwhqs/mw**2*mta**4-1d0/4*det3iwhqs/mw**2
     & *mh**2*mta**2+1d0/4*det3iwhqs*mta**2-3d0/8*det3iwhqs**2*mh**2*mta
     & **4+3d0/8*det3iwhqs**2*mw**2*mh**2*mta**2)
     & +b0fwtpbt*cfq*(1d0/4*det3iwhqs/mw**2*mbt**4-1d0/2*det3iwhqs/mw**2
     & *mtp**2*mbt**2+1d0/4*det3iwhqs/mw**2*mtp**4-1d0/4*det3iwhqs/mw**2
     & *mh**2*mbt**2+1d0/4*det3iwhqs*mbt**2-3d0/4*det3iwhqs*mtp**2-3d0/8
     & *det3iwhqs**2*mh**2*mbt**4+3d0/4*det3iwhqs**2*mh**2*mtp**2*mbt**2
     & -3d0/8*det3iwhqs**2*mh**2*mtp**4+3d0/8*det3iwhqs**2*mw**2*mh**2*m
     & bt**2+3d0/8*det3iwhqs**2*mw**2*mh**2*mtp**2)
     & +b0fqswz*stw**2*(-det3iwhqs*mh**2)
     & +b0fqswz*(-1d0/8*det3iwhqs/ctw**4*mw**2+1d0/4*det3iwhqs/ctw**2*mh
     & **2-5d0/8*det3iwhqs/ctw**2*mw**2+3d0/8*det3iwhqs*mh**2+15d0/4*det
     & 3iwhqs*mw**2+3d0/16*det3iwhqs**2/ctw**4*mw**4*mh**2+15d0/16*det3i
     & whqs**2/ctw**2*mw**4*mh**2-21d0/4*det3iwhqs**2*mw**4*mh**2)
     & +b0fqswh*(1d0/2/mw**2-1d0/2*det3iwhqs*mh**2)
     & +b0fqswc*stw**2*(det3iwhqs*mh**2)
     & +b0fqsmnmo*cfl*(1d0/4*det3iwhqs/mw**2*mmo**4-3d0/4*det3iwhqs*mmo*
     & *2-3d0/8*det3iwhqs**2*mh**2*mmo**4+3d0/8*det3iwhqs**2*mw**2*mh**2
     & *mmo**2)
     & +b0fqschst*cfq*(1d0/4*det3iwhqs/mw**2*mst**4-1d0/2*det3iwhqs/mw**
     & 2*mch**2*mst**2+1d0/4*det3iwhqs/mw**2*mch**4-1d0/4*det3iwhqs/mw**
     & 2*mh**2*mch**2-3d0/4*det3iwhqs*mst**2+1d0/4*det3iwhqs*mch**2-3d0/
     & 8*det3iwhqs**2*mh**2*mst**4+3d0/4*det3iwhqs**2*mh**2*mch**2*mst**
     & 2-3d0/8*det3iwhqs**2*mh**2*mch**4+3d0/8*det3iwhqs**2*mw**2*mh**2*
     & mst**2+3d0/8*det3iwhqs**2*mw**2*mh**2*mch**2)
     & +b0fqstnta*cfl*(1d0/4*det3iwhqs/mw**2*mta**4-3d0/4*det3iwhqs*mta*
     & *2-3d0/8*det3iwhqs**2*mh**2*mta**4+3d0/8*det3iwhqs**2*mw**2*mh**2
     & *mta**2)
     & +b0fqstpbt*cfq*(1d0/4*det3iwhqs/mw**2*mbt**4-1d0/2*det3iwhqs/mw**
     & 2*mtp**2*mbt**2+1d0/4*det3iwhqs/mw**2*mtp**4-1d0/4*det3iwhqs/mw**
     & 2*mh**2*mtp**2-3d0/4*det3iwhqs*mbt**2+1d0/4*det3iwhqs*mtp**2-3d0/
     & 8*det3iwhqs**2*mh**2*mbt**4+3d0/4*det3iwhqs**2*mh**2*mtp**2*mbt**
     & 2-3d0/8*det3iwhqs**2*mh**2*mtp**4+3d0/8*det3iwhqs**2*mw**2*mh**2*
     & mbt**2+3d0/8*det3iwhqs**2*mw**2*mh**2*mtp**2)
     & +3d0/2/mw**2-1d0/8*det3iwhqs/ctw**2*mh**2+1d0/4*det3iwhqs/ctw**2*
     & mw**2-3*det3iwhqs*mh**2+9d0/2*det3iwhqs*mw**2

      ffgp2ew=
     & +cfq*(1d0/4*det3iwhqs/mw**2*mh**2*mbt**2+1d0/4*det3iwhqs/mw**2*mh
     & **2*mtp**2+1d0/4*det3iwhqs/mw**2*mh**2*mst**2+1d0/4*det3iwhqs/mw*
     & *2*mh**2*mch**2-1d0/2*det3iwhqs*mbt**2-1d0/2*det3iwhqs*mtp**2-1d0
     & /2*det3iwhqs*mst**2-1d0/2*det3iwhqs*mch**2)
     & +cfl*(1d0/4*det3iwhqs/mw**2*mh**2*mta**2+1d0/4*det3iwhqs/mw**2*mh
     & **2*mmo**2-1d0/2*det3iwhqs*mta**2-1d0/2*det3iwhqs*mmo**2)
     & +stw**2*(det3iwhqs*mh**2)
     & +jawsubqstswhw*propiwqs*stw**2*qup*(2*sdet4iwhtsus**2*mw**4*mh**2
     & +2*sdet4iwhtsus**2*mw**6+4*sdet4iwhtsus**2*ts*mw**2*mh**2+4*sdet4
     & iwhtsus**2*ts*mw**4+2*sdet4iwhtsus**2*ts**2*mh**2+4*sdet4iwhtsus*
     & *2*ts**2*mw**2+2*sdet4iwhtsus**2*ts**3+2*sdet4iwhtsus**2*qs*mw**4
     & +4*sdet4iwhtsus**2*qs*ts*mw**2+2*sdet4iwhtsus**2*qs*ts**2)
     & +jawsubqsuswhw*propiwqs*stw**2*qdn*(-2*sdet4iwhtsus**2/qs*mw**6*m
     & h**2+2*sdet4iwhtsus**2/qs*mw**8-6*sdet4iwhtsus**2/qs*us*mw**4*mh*
     & *2+4*sdet4iwhtsus**2/qs*us*mw**6-6*sdet4iwhtsus**2/qs*us**2*mw**2
     & *mh**2-2*sdet4iwhtsus**2/qs*us**3*mh**2-4*sdet4iwhtsus**2/qs*us**
     & 3*mw**2-2*sdet4iwhtsus**2/qs*us**4+2*sdet4iwhtsus**2*mw**6+4*sdet
     & 4iwhtsus**2*us*mw**4+2*sdet4iwhtsus**2*us**2*mw**2)
     & +propiwqs*cfq*(1d0/4*det3iwhqs/mw**2*mbt**2+1d0/4*det3iwhqs/mw**2
     & *mtp**2+1d0/4*det3iwhqs/mw**2*mst**2+1d0/4*det3iwhqs/mw**2*mch**2
     & )
     & +propiwqs*cfl*(1d0/4*det3iwhqs/mw**2*mta**2+1d0/4*det3iwhqs/mw**2
     & *mmo**2)
     & +propiwqs*stw**2*(det3iwhqs+3d0/2*det3iwhqs**2*mw**2*mh**2-3d0/2*
     & det3iwhqs**2*mw**4+3d0/2*det3iwhqs**2*qs*mw**2)
     & +propiwqs*stw**2*qdn*(det3iwhqs*sdet4iwhtsus*mw**2*mh**2+det3iwhq
     & s*sdet4iwhtsus*mw**4+2*det3iwhqs*sdet4iwhtsus*ts*mw**2+det3iwhqs*
     & sdet4iwhtsus*qs*mw**2)
     & +propiwqs*stw**2*qup*(det3iwhqs*sdet4iwhtsus*mw**2*mh**2+det3iwhq
     & s*sdet4iwhtsus*mw**4+2*det3iwhqs*sdet4iwhtsus*ts*mw**2+det3iwhqs*
     & sdet4iwhtsus*qs*mw**2+4*sdet3icwts*sdet4iwhtsus*mw**2)
     & +propiwqs*d0dnuphwqsuswupzz*(1d0/ctw**4*vpaup/qs*mw**2-1d0/ctw**2
     & *vpaup/qs*mw**2-sdet4iwhtsus/ctw**6*vpaup/qs*mw**4*mh**2+2*sdet4i
     & whtsus/ctw**6*vpaup/qs*mw**6+sdet4iwhtsus/ctw**6*vpaup/qs*us*mw**
     & 4+sdet4iwhtsus/ctw**6*vpaup*mw**4+sdet4iwhtsus/ctw**4*vpaup/qs*mw
     & **4*mh**2-2*sdet4iwhtsus/ctw**4*vpaup/qs*mw**6+sdet4iwhtsus/ctw**
     & 4*vpaup/qs*us*mw**2*mh**2-2*sdet4iwhtsus/ctw**4*vpaup/qs*us*mw**4
     & +2*sdet4iwhtsus/ctw**4*vpaup*us*mw**2-sdet4iwhtsus**2/ctw**6*vpau
     & p/qs*mw**6*mh**4+2*sdet4iwhtsus**2/ctw**6*vpaup/qs*mw**8*mh**2-sd
     & et4iwhtsus**2/ctw**6*vpaup/qs*mw**10-sdet4iwhtsus**2/ctw**6*vpaup
     & /qs*us*mw**4*mh**4+2*sdet4iwhtsus**2/ctw**6*vpaup/qs*us*mw**6*mh*
     & *2-sdet4iwhtsus**2/ctw**6*vpaup/qs*us*mw**8+2*sdet4iwhtsus**2/ctw
     & **6*vpaup*mw**6*mh**2-sdet4iwhtsus**2/ctw**6*vpaup*mw**8+sdet4iwh
     & tsus**2/ctw**6*vpaup*ts*mw**6+2*sdet4iwhtsus**2/ctw**4*vpaup*us*m
     & w**4*mh**2+2*sdet4iwhtsus**2/ctw**4*vpaup*us**2*mw**2*mh**2+sdet4
     & iwhtsus**2/ctw**2*vpaup*us**3*mh**2+sdet4iwhtsus**2/ctw**2*vpaup*
     & us**4)
     & +propiwqs*d0dnuphwqsuszdnww*(1d0/ctw**2*vpadn/qs*mw**2-vpadn/qs*m
     & w**2+sdet4iwhtsus/ctw**2*vpadn/qs*mw**6+sdet4iwhtsus/ctw**2*vpadn
     & /qs*us*mw**4+sdet4iwhtsus/ctw**2*vpadn*mw**4-sdet4iwhtsus*vpadn/q
     & s*mw**6-sdet4iwhtsus*vpadn/qs*us*mw**2*mh**2-2*sdet4iwhtsus*vpadn
     & *mw**4-2*sdet4iwhtsus*vpadn*us*mw**2-sdet4iwhtsus**2/ctw**4*vpadn
     & *us*mw**4*mh**2-sdet4iwhtsus**2/ctw**4*vpadn*us**2*mw**4+2*sdet4i
     & whtsus**2/ctw**2*vpadn*mw**6*mh**2+4*sdet4iwhtsus**2/ctw**2*vpadn
     & *us*mw**4*mh**2+2*sdet4iwhtsus**2/ctw**2*vpadn*us**2*mw**2*mh**2+
     & 2*sdet4iwhtsus**2/ctw**2*vpadn*us**2*mw**4+2*sdet4iwhtsus**2/ctw*
     & *2*vpadn*us**3*mw**2+sdet4iwhtsus**2*vpadn/qs*mw**6*mh**4-2*sdet4
     & iwhtsus**2*vpadn/qs*mw**8*mh**2+sdet4iwhtsus**2*vpadn/qs*mw**10+s
     & det4iwhtsus**2*vpadn/qs*us*mw**4*mh**4-2*sdet4iwhtsus**2*vpadn/qs
     & *us*mw**6*mh**2+sdet4iwhtsus**2*vpadn/qs*us*mw**8-4*sdet4iwhtsus*
     & *2*vpadn*mw**6*mh**2+sdet4iwhtsus**2*vpadn*mw**8-5*sdet4iwhtsus**
     & 2*vpadn*us*mw**4*mh**2-4*sdet4iwhtsus**2*vpadn*us**2*mw**2*mh**2-
     & sdet4iwhtsus**2*vpadn*us**2*mw**4-sdet4iwhtsus**2*vpadn*us**3*mh*
     & *2-2*sdet4iwhtsus**2*vpadn*us**3*mw**2-sdet4iwhtsus**2*vpadn*us**
     & 4-sdet4iwhtsus**2*vpadn*ts*mw**6)
     & +propiwqs*d0dnupwhqstswupzw*(1d0/2/ctw**4*vpaup/qs*mw**2-1d0/2/ct
     & w**2*vpaup/qs*mw**2+vpaup-1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*mw**
     & 2*mh**4-3d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*mw**4*mh**2+sdet4iwhts
     & us/ctw**4*vpaup/qs*mw**6-1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*ts*mw
     & **2*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vpaup/qs*ts*mw**4+1d0/2*sdet4
     & iwhtsus/ctw**4*vpaup*ts*mw**2+sdet4iwhtsus/ctw**2*vpaup/qs*mw**4*
     & mh**2+sdet4iwhtsus/ctw**2*vpaup/qs*ts*mw**4-5d0/2*sdet4iwhtsus/ct
     & w**2*vpaup*mw**2*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*ts*mh**2-2
     & *sdet4iwhtsus/ctw**2*vpaup*ts*mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpa
     & up*ts**2+4*sdet4iwhtsus*vpaup*mw**2*mh**2+2*sdet4iwhtsus*vpaup*mw
     & **4+2*sdet4iwhtsus*vpaup*us*mw**2+sdet4iwhtsus*vpaup*ts*mh**2+3*s
     & det4iwhtsus*vpaup*ts*mw**2+sdet4iwhtsus*vpaup*ts**2+sdet4iwhtsus*
     & *2/ctw**4*vpaup/qs*mw**4*mh**6-2*sdet4iwhtsus**2/ctw**4*vpaup/qs*
     & mw**6*mh**4+sdet4iwhtsus**2/ctw**4*vpaup/qs*mw**8*mh**2+sdet4iwht
     & sus**2/ctw**4*vpaup/qs*ts*mw**4*mh**4-2*sdet4iwhtsus**2/ctw**4*vp
     & aup/qs*ts*mw**6*mh**2+sdet4iwhtsus**2/ctw**4*vpaup/qs*ts*mw**8+sd
     & et4iwhtsus**2/ctw**4*vpaup*mw**4*mh**4+sdet4iwhtsus**2/ctw**4*vpa
     & up*ts*mw**6-2*sdet4iwhtsus**2/ctw**2*vpaup*mw**4*mh**4-2*sdet4iwh
     & tsus**2/ctw**2*vpaup*mw**6*mh**2-2*sdet4iwhtsus**2/ctw**2*vpaup*u
     & s*mw**4*mh**2-4*sdet4iwhtsus**2/ctw**2*vpaup*ts*mw**4*mh**2-2*sde
     & t4iwhtsus**2/ctw**2*vpaup*ts**2*mw**4+3*sdet4iwhtsus**2*vpaup*mw*
     & *4*mh**4+2*sdet4iwhtsus**2*vpaup*mw**6*mh**2+3*sdet4iwhtsus**2*vp
     & aup*us*mw**4*mh**2+sdet4iwhtsus**2*vpaup*us**2*mw**4+sdet4iwhtsus
     & **2*vpaup*ts*mw**2*mh**4+4*sdet4iwhtsus**2*vpaup*ts*mw**4*mh**2+2
     & *sdet4iwhtsus**2*vpaup*ts**2*mw**2*mh**2+sdet4iwhtsus**2*vpaup*ts
     & **2*mw**4+sdet4iwhtsus**2*vpaup*ts**3*mw**2)
     & +propiwqs*d0dnupwhqstszdnwz*(1d0/2/ctw**4*vpadn/qs*mw**2-1d0/2/ct
     & w**2*vpadn/qs*mw**2-1d0/ctw**2*vpadn-sdet4iwhtsus/ctw**4*vpadn/qs
     & *mw**4*mh**2-sdet4iwhtsus/ctw**4*vpadn/qs*ts*mw**4-3d0/2*sdet4iwh
     & tsus/ctw**4*vpadn*mw**2*mh**2-2*sdet4iwhtsus/ctw**4*vpadn*mw**4-2
     & *sdet4iwhtsus/ctw**4*vpadn*us*mw**2-sdet4iwhtsus/ctw**4*vpadn*ts*
     & mw**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*mw**2*mh**4+3d0/2*sdet4i
     & whtsus/ctw**2*vpadn/qs*mw**4*mh**2-sdet4iwhtsus/ctw**2*vpadn/qs*m
     & w**6+1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*ts*mw**2*mh**2+1d0/2*sdet
     & 4iwhtsus/ctw**2*vpadn/qs*ts*mw**4-1d0/2*sdet4iwhtsus/ctw**2*vpadn
     & *ts*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn*ts*mw**2-1d0/2*sdet4iwh
     & tsus/ctw**2*vpadn*ts**2-sdet4iwhtsus**2/ctw**6*vpadn*us*mw**4*mh*
     & *2-sdet4iwhtsus**2/ctw**6*vpadn*us**2*mw**4-2*sdet4iwhtsus**2/ctw
     & **4*vpadn*mw**4*mh**4-2*sdet4iwhtsus**2/ctw**4*vpadn*ts*mw**4*mh*
     & *2-sdet4iwhtsus**2/ctw**2*vpadn/qs*mw**4*mh**6+2*sdet4iwhtsus**2/
     & ctw**2*vpadn/qs*mw**6*mh**4-sdet4iwhtsus**2/ctw**2*vpadn/qs*mw**8
     & *mh**2-sdet4iwhtsus**2/ctw**2*vpadn/qs*ts*mw**4*mh**4+2*sdet4iwht
     & sus**2/ctw**2*vpadn/qs*ts*mw**6*mh**2-sdet4iwhtsus**2/ctw**2*vpad
     & n/qs*ts*mw**8-sdet4iwhtsus**2/ctw**2*vpadn*ts*mw**2*mh**4+2*sdet4
     & iwhtsus**2/ctw**2*vpadn*ts*mw**4*mh**2-sdet4iwhtsus**2/ctw**2*vpa
     & dn*ts*mw**6-2*sdet4iwhtsus**2/ctw**2*vpadn*ts**2*mw**2*mh**2+sdet
     & 4iwhtsus**2/ctw**2*vpadn*ts**2*mw**4-sdet4iwhtsus**2/ctw**2*vpadn
     & *ts**3*mw**2)
     & +propiwqs*d0wuphdntsusdnupzz*(-1d0/2/ctw**6*vpaup*vpadn/qs*mw**2+
     & 1d0/2/ctw**4*vpaup*vpadn/qs*mw**2+1d0/2/ctw**4*vpaup*vpadn/qs*us+
     & 1d0/2*sdet4iwhtsus/ctw**8*vpaup*vpadn/qs*mw**4*mh**2-1d0/2*sdet4i
     & whtsus/ctw**8*vpaup*vpadn/qs*mw**6-sdet4iwhtsus/ctw**6*vpaup*vpad
     & n/qs*mw**4*mh**2+sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*mw**6-sdet4iw
     & htsus/ctw**6*vpaup*vpadn/qs*us*mw**2*mh**2+sdet4iwhtsus/ctw**6*vp
     & aup*vpadn/qs*us*mw**4-sdet4iwhtsus/ctw**6*vpaup*vpadn*us*mw**2+1d
     & 0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpadn/qs*mw**6*mh**4-3d0/2*sdet4
     & iwhtsus**2/ctw**8*vpaup*vpadn/qs*mw**8*mh**2+1d0/2*sdet4iwhtsus**
     & 2/ctw**8*vpaup*vpadn/qs*us*mw**4*mh**4-sdet4iwhtsus**2/ctw**8*vpa
     & up*vpadn/qs*us*mw**6*mh**2-1d0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpa
     & dn/qs*ts*mw**8+1d0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpadn*us*mw**4*
     & mh**2-1d0/2*sdet4iwhtsus**2/ctw**8*vpaup*vpadn*us**2*mw**4-1d0/2*
     & sdet4iwhtsus**2/ctw**8*vpaup*vpadn*ts*mw**6)
     & +propiwqs*c0updnqswdnz*(sdet4iwhtsus/ctw**4*vpadn*mw**2+1d0/2*sde
     & t4iwhtsus/ctw**2*vpadn*mh**2+sdet4iwhtsus/ctw**2*vpadn*us+1d0/2*s
     & det4iwhtsus/ctw**2*vpadn*ts+sdet4iwhtsus*vpadn*mw**2+sdet4iwhtsus
     & **2/ctw**4*vpadn*mw**4*mh**2+sdet4iwhtsus**2/ctw**4*vpadn*us*mw**
     & 2*mh**2+sdet4iwhtsus**2/ctw**4*vpadn*us*mw**4+sdet4iwhtsus**2/ctw
     & **4*vpadn*us**2*mw**2+sdet4iwhtsus**2/ctw**2*vpadn*mw**2*mh**4-sd
     & et4iwhtsus**2/ctw**2*vpadn*mw**4*mh**2-sdet4iwhtsus**2/ctw**2*vpa
     & dn*us*mw**2*mh**2-sdet4iwhtsus**2/ctw**2*vpadn*us*mw**4-sdet4iwht
     & sus**2/ctw**2*vpadn*us**2*mw**2+2*sdet4iwhtsus**2/ctw**2*vpadn*ts
     & *mw**2*mh**2+sdet4iwhtsus**2/ctw**2*vpadn*ts**2*mw**2+3*sdet4iwht
     & sus**2*vpadn*mw**4*mh**2+3*sdet4iwhtsus**2*vpadn*us*mw**2*mh**2+s
     & det4iwhtsus**2*vpadn*us*mw**4+sdet4iwhtsus**2*vpadn*us**2*mh**2+2
     & *sdet4iwhtsus**2*vpadn*us**2*mw**2+sdet4iwhtsus**2*vpadn*us**3+sd
     & et4iwhtsus**2*vpadn*ts*mw**4)
     & +propiwqs*c0updnqszupw*(-sdet4iwhtsus/ctw**4*vpaup*mw**2+1d0/2*sd
     & et4iwhtsus/ctw**2*vpaup*mh**2+2*sdet4iwhtsus/ctw**2*vpaup*mw**2+1
     & d0/2*sdet4iwhtsus/ctw**2*vpaup*ts-sdet4iwhtsus*vpaup*mh**2-3*sdet
     & 4iwhtsus*vpaup*mw**2-sdet4iwhtsus*vpaup*us-sdet4iwhtsus*vpaup*ts-
     & 2*sdet4iwhtsus**2/ctw**4*vpaup*mw**4*mh**2-sdet4iwhtsus**2/ctw**4
     & *vpaup*us*mw**2*mh**2-sdet4iwhtsus**2/ctw**4*vpaup*ts*mw**4+2*sde
     & t4iwhtsus**2/ctw**2*vpaup*mw**4*mh**2-sdet4iwhtsus**2/ctw**2*vpau
     & p*us**2*mh**2-sdet4iwhtsus**2/ctw**2*vpaup*us**2*mw**2-sdet4iwhts
     & us**2/ctw**2*vpaup*us**3+sdet4iwhtsus**2/ctw**2*vpaup*ts*mw**4-sd
     & et4iwhtsus**2*vpaup*mw**2*mh**4-3*sdet4iwhtsus**2*vpaup*mw**4*mh*
     & *2-2*sdet4iwhtsus**2*vpaup*us*mw**2*mh**2-sdet4iwhtsus**2*vpaup*u
     & s*mw**4-sdet4iwhtsus**2*vpaup*us**2*mw**2-2*sdet4iwhtsus**2*vpaup
     & *ts*mw**2*mh**2-sdet4iwhtsus**2*vpaup*ts*mw**4-sdet4iwhtsus**2*vp
     & aup*ts**2*mw**2)
     & +propiwqs*c0hdntswwup*stw**2*qup*(2*sdet4iwhtsus*mh**2+2*sdet4iwh
     & tsus*mw**2+2*sdet4iwhtsus*ts+2*sdet4iwhtsus**2*mw**2*mh**4+2*sdet
     & 4iwhtsus**2*mw**4*mh**2+2*sdet4iwhtsus**2*us*mw**2*mh**2+4*sdet4i
     & whtsus**2*ts*mw**2*mh**2+2*sdet4iwhtsus**2*ts**2*mw**2)
     & +propiwqs*c0hdntswwup*(-1d0/2/ctw**2*vpaup/qs+1d0/2*sdet4iwhtsus/
     & ctw**2*vpaup/qs*mh**4+3d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mw**2*mh
     & **2-sdet4iwhtsus/ctw**2*vpaup/qs*mw**4+1d0/2*sdet4iwhtsus/ctw**2*
     & vpaup/qs*ts*mh**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*ts*mw**2-1d0
     & /2*sdet4iwhtsus/ctw**2*vpaup*ts+sdet4iwhtsus*vpaup*mh**2+sdet4iwh
     & tsus*vpaup*mw**2+sdet4iwhtsus*vpaup*ts-sdet4iwhtsus**2/ctw**2*vpa
     & up/qs*mw**2*mh**6+2*sdet4iwhtsus**2/ctw**2*vpaup/qs*mw**4*mh**4-s
     & det4iwhtsus**2/ctw**2*vpaup/qs*mw**6*mh**2-sdet4iwhtsus**2/ctw**2
     & *vpaup/qs*ts*mw**2*mh**4+2*sdet4iwhtsus**2/ctw**2*vpaup/qs*ts*mw*
     & *4*mh**2-sdet4iwhtsus**2/ctw**2*vpaup/qs*ts*mw**6-sdet4iwhtsus**2
     & /ctw**2*vpaup*mw**2*mh**4-sdet4iwhtsus**2/ctw**2*vpaup*ts*mw**4+s
     & det4iwhtsus**2*vpaup*mw**2*mh**4+sdet4iwhtsus**2*vpaup*mw**4*mh**
     & 2+sdet4iwhtsus**2*vpaup*us*mw**2*mh**2+2*sdet4iwhtsus**2*vpaup*ts
     & *mw**2*mh**2+sdet4iwhtsus**2*vpaup*ts**2*mw**2)
     & +propiwqs*c0hdntszzdn*(-1d0/2/ctw**4*vpaup*vpadn/qs+1d0/2/ctw**2*
     & vpadn/qs+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*mw**2*mh**2-sde
     & t4iwhtsus/ctw**6*vpaup*vpadn/qs*mw**4-1d0/2*sdet4iwhtsus/ctw**6*v
     & paup*vpadn/qs*us*mw**2-sdet4iwhtsus/ctw**4*vpadn*mw**2-sdet4iwhts
     & us/ctw**4*vpaup*vpadn/qs*mw**2*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vp
     & aup*vpadn/qs*us*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*ts
     & *mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*mh**4-3d0/2*sdet4iwhtsu
     & s/ctw**2*vpadn/qs*mw**2*mh**2+sdet4iwhtsus/ctw**2*vpadn/qs*mw**4-
     & 1d0/2*sdet4iwhtsus/ctw**2*vpadn/qs*ts*mh**2-1d0/2*sdet4iwhtsus/ct
     & w**2*vpadn/qs*ts*mw**2-sdet4iwhtsus/ctw**2*vpadn*mh**2-1d0/2*sdet
     & 4iwhtsus/ctw**2*vpadn*ts+sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*mw
     & **4*mh**4-sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*mw**6*mh**2+1d0/2
     & *sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*us*mw**2*mh**4-1d0/2*sdet4
     & iwhtsus**2/ctw**6*vpaup*vpadn/qs*us*mw**4*mh**2+1d0/2*sdet4iwhtsu
     & s**2/ctw**6*vpaup*vpadn/qs*ts*mw**4*mh**2-1d0/2*sdet4iwhtsus**2/c
     & tw**6*vpaup*vpadn/qs*ts*mw**6+1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*
     & vpadn*us*mw**2*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn*ts*
     & mw**4-sdet4iwhtsus**2/ctw**4*vpadn*mw**4*mh**2-sdet4iwhtsus**2/ct
     & w**4*vpadn*us*mw**2*mh**2+sdet4iwhtsus**2/ctw**2*vpadn/qs*mw**2*m
     & h**6-2*sdet4iwhtsus**2/ctw**2*vpadn/qs*mw**4*mh**4+sdet4iwhtsus**
     & 2/ctw**2*vpadn/qs*mw**6*mh**2+sdet4iwhtsus**2/ctw**2*vpadn/qs*ts*
     & mw**2*mh**4-2*sdet4iwhtsus**2/ctw**2*vpadn/qs*ts*mw**4*mh**2+sdet
     & 4iwhtsus**2/ctw**2*vpadn/qs*ts*mw**6-2*sdet4iwhtsus**2/ctw**2*vpa
     & dn*ts*mw**2*mh**2+sdet4iwhtsus**2/ctw**2*vpadn*ts*mw**4-sdet4iwht
     & sus**2/ctw**2*vpadn*ts**2*mw**2)
     & +propiwqs*c0hupuswwdn*stw**2*qdn*(-2/qs+4*sdet3ichus*sdet4iwhtsus
     & *mw**2*mh**2-2*sdet4iwhtsus/qs*mw**4-2*sdet4iwhtsus/qs*us*mw**2-4
     & *sdet4iwhtsus*mw**2+2*sdet4iwhtsus*us-2*sdet4iwhtsus**2*mw**4*mh*
     & *2-4*sdet4iwhtsus**2*us*mw**2*mh**2-2*sdet4iwhtsus**2*us**2*mh**2
     & -2*sdet4iwhtsus**2*us**2*mw**2-2*sdet4iwhtsus**2*us**3)
     & +propiwqs*c0hupuswwdn*(-vpadn/qs+2*sdet3ichus*sdet4iwhtsus*vpadn*
     & mw**2*mh**2-sdet4iwhtsus*vpadn/qs*mw**4-sdet4iwhtsus*vpadn/qs*us*
     & mw**2-2*sdet4iwhtsus*vpadn*mw**2+sdet4iwhtsus*vpadn*us+sdet4iwhts
     & us**2/ctw**2*vpadn*us*mw**2*mh**2+sdet4iwhtsus**2/ctw**2*vpadn*us
     & **2*mw**2-sdet4iwhtsus**2*vpadn*mw**4*mh**2-2*sdet4iwhtsus**2*vpa
     & dn*us*mw**2*mh**2-sdet4iwhtsus**2*vpadn*us**2*mh**2-sdet4iwhtsus*
     & *2*vpadn*us**2*mw**2-sdet4iwhtsus**2*vpadn*us**3)
     & +propiwqs*c0hupuszzup*(1d0/2/ctw**4*vpaup*vpadn/qs+1d0/ctw**2*vpa
     & up/qs-sdet3ichus/ctw**6*vpaup*vpadn/qs*mw**2-2*sdet3ichus*sdet4iw
     & htsus/ctw**4*vpaup*mw**2*mh**2-1d0/2*sdet4iwhtsus/ctw**6*vpaup*vp
     & adn/qs*mw**4-1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*us*mw**2+sd
     & et4iwhtsus/ctw**4*vpaup/qs*mw**4+sdet4iwhtsus/ctw**4*vpaup/qs*us*
     & mw**2+2*sdet4iwhtsus/ctw**4*vpaup*mw**2-1d0/2*sdet4iwhtsus/ctw**4
     & *vpaup*vpadn*us-sdet4iwhtsus/ctw**2*vpaup*us-1d0/2*sdet4iwhtsus**
     & 2/ctw**6*vpaup*vpadn/qs*mw**4*mh**4-1d0/2*sdet4iwhtsus**2/ctw**6*
     & vpaup*vpadn/qs*mw**6*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpa
     & dn/qs*us*mw**4*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*
     & ts*mw**4*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn*us**2*mw*
     & *2+sdet4iwhtsus**2/ctw**4*vpaup*mw**4*mh**2+sdet4iwhtsus**2/ctw**
     & 4*vpaup*us*mw**2*mh**2+sdet4iwhtsus**2/ctw**2*vpaup*us**2*mh**2+s
     & det4iwhtsus**2/ctw**2*vpaup*us**3)
     & +propiwqs*c0wdnuswzdn*(vpadn/qs+sdet4iwhtsus*vpadn/qs*mw**4+sdet4
     & iwhtsus*vpadn/qs*us*mh**2+sdet4iwhtsus*vpadn*us+sdet4iwhtsus**2/c
     & tw**2*vpadn*us*mw**4+sdet4iwhtsus**2/ctw**2*vpadn*us**2*mw**2-sde
     & t4iwhtsus**2*vpadn/qs*mw**4*mh**4+2*sdet4iwhtsus**2*vpadn/qs*mw**
     & 6*mh**2-sdet4iwhtsus**2*vpadn/qs*mw**8-sdet4iwhtsus**2*vpadn/qs*u
     & s*mw**2*mh**4+2*sdet4iwhtsus**2*vpadn/qs*us*mw**4*mh**2-sdet4iwht
     & sus**2*vpadn/qs*us*mw**6-sdet4iwhtsus**2*vpadn*mw**6-sdet4iwhtsus
     & **2*vpadn*us*mw**2*mh**2-sdet4iwhtsus**2*vpadn*us*mw**4-2*sdet4iw
     & htsus**2*vpadn*us**2*mw**2-sdet4iwhtsus**2*vpadn*us**3)
     & +propiwqs*c0wdnuszwup*(-1d0/ctw**2*vpaup/qs+sdet4iwhtsus/ctw**4*v
     & paup/qs*mw**2*mh**2-2*sdet4iwhtsus/ctw**4*vpaup/qs*mw**4-sdet4iwh
     & tsus/ctw**4*vpaup/qs*us*mw**2-sdet4iwhtsus/ctw**2*vpaup/qs*mw**2*
     & mh**2+sdet4iwhtsus/ctw**2*vpaup/qs*mw**4-sdet4iwhtsus/ctw**2*vpau
     & p/qs*us*mh**2+sdet4iwhtsus/ctw**2*vpaup/qs*us*mw**2-sdet4iwhtsus/
     & ctw**2*vpaup*us+sdet4iwhtsus**2/ctw**4*vpaup/qs*mw**4*mh**4-2*sde
     & t4iwhtsus**2/ctw**4*vpaup/qs*mw**6*mh**2+sdet4iwhtsus**2/ctw**4*v
     & paup/qs*mw**8+sdet4iwhtsus**2/ctw**4*vpaup/qs*us*mw**2*mh**4-2*sd
     & et4iwhtsus**2/ctw**4*vpaup/qs*us*mw**4*mh**2+sdet4iwhtsus**2/ctw*
     & *4*vpaup/qs*us*mw**6+sdet4iwhtsus**2/ctw**4*vpaup*mw**6+sdet4iwht
     & sus**2/ctw**4*vpaup*us*mw**2*mh**2+sdet4iwhtsus**2/ctw**2*vpaup*u
     & s**2*mw**2+sdet4iwhtsus**2/ctw**2*vpaup*us**3)
     & +propiwqs*c0wdnusupdnz*(1d0/2/ctw**4*vpaup*vpadn/qs-1d0/2*sdet4iw
     & htsus/ctw**6*vpaup*vpadn/qs*mw**2*mh**2+sdet4iwhtsus/ctw**6*vpaup
     & *vpadn/qs*mw**4+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*us*mw**2
     & +1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*mw**2*mh**2-1d0/2*sdet4
     & iwhtsus/ctw**4*vpaup*vpadn/qs*mw**4+1d0/2*sdet4iwhtsus/ctw**4*vpa
     & up*vpadn/qs*us*mh**2-1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*us*
     & mw**2+1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn*us-1d0/2*sdet4iwhtsus
     & **2/ctw**6*vpaup*vpadn/qs*mw**4*mh**4+3d0/2*sdet4iwhtsus**2/ctw**
     & 6*vpaup*vpadn/qs*mw**6*mh**2-1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*v
     & padn/qs*us*mw**2*mh**4+sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*us*m
     & w**4*mh**2+1d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn/qs*ts*mw**6-1
     & d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn*us*mw**2*mh**2+1d0/2*sdet
     & 4iwhtsus**2/ctw**6*vpaup*vpadn*us*mw**4+1d0/2*sdet4iwhtsus**2/ctw
     & **6*vpaup*vpadn*us**2*mw**2)
     & +propiwqs*c0wuptswzup*(1d0/2/ctw**2*vpaup/qs+2*sdet3icwts*sdet4iw
     & htsus/ctw**2*vpaup*mw**4-sdet4iwhtsus/ctw**2*vpaup/qs*mw**2*mh**2
     & -sdet4iwhtsus/ctw**2*vpaup/qs*ts*mw**2-2*sdet4iwhtsus/ctw**2*vpau
     & p*mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*ts+2*sdet4iwhtsus*vpaup*m
     & w**2+sdet4iwhtsus*vpaup*ts-sdet4iwhtsus**2/ctw**2*vpaup*mw**4*mh*
     & *2-sdet4iwhtsus**2/ctw**2*vpaup*ts*mw**4+2*sdet4iwhtsus**2*vpaup*
     & mw**4*mh**2+sdet4iwhtsus**2*vpaup*us*mw**4+sdet4iwhtsus**2*vpaup*
     & ts*mw**2*mh**2+sdet4iwhtsus**2*vpaup*ts*mw**4+sdet4iwhtsus**2*vpa
     & up*ts**2*mw**2)
     & +propiwqs*c0wuptszwdn*(-1d0/2/ctw**2*vpadn/qs-2*sdet3icwts*sdet4i
     & whtsus/ctw**2*vpadn*mw**4-sdet4iwhtsus/ctw**4*vpadn*mw**2+sdet4iw
     & htsus/ctw**2*vpadn/qs*mw**2*mh**2+sdet4iwhtsus/ctw**2*vpadn/qs*ts
     & *mw**2+sdet4iwhtsus/ctw**2*vpadn*mw**2-1d0/2*sdet4iwhtsus/ctw**2*
     & vpadn*ts-sdet4iwhtsus**2/ctw**4*vpadn*mw**4*mh**2-sdet4iwhtsus**2
     & /ctw**4*vpadn*us*mw**4-sdet4iwhtsus**2/ctw**2*vpadn*ts*mw**2*mh**
     & 2-sdet4iwhtsus**2/ctw**2*vpadn*ts**2*mw**2)
     & +propiwqs*c0wuptsdnupz*(-1d0/2/ctw**4*vpaup*vpadn/qs-sdet3icwts/c
     & tw**6*vpaup*vpadn/qs*mw**2+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/
     & qs*mw**4+1d0/2*sdet4iwhtsus/ctw**6*vpaup*vpadn/qs*us*mw**2+1d0/2*
     & sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*mw**2*mh**2+1d0/2*sdet4iwhtsus
     & /ctw**4*vpaup*vpadn/qs*mw**4+1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpad
     & n/qs*us*mw**2+1d0/2*sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*ts*mw**2-1
     & d0/2*sdet4iwhtsus**2/ctw**6*vpaup*vpadn*us*mw**4+1d0/2*sdet4iwhts
     & us**2/ctw**6*vpaup*vpadn*ts*mw**4)
     & +propiwqs*c0whqswzz*(1d0/2*det3iwhqs/ctw**4*mw**2-1d0/2*det3iwhqs
     & /ctw**4*vpadn*mw**2-1d0/2*det3iwhqs/ctw**4*vpaup*mw**2+15d0/4*det
     & 3iwhqs/ctw**2*mw**2-1d0/4*det3iwhqs/ctw**2*qs-1d0/4*det3iwhqs*mh*
     & *2-1d0/8*det3iwhqs*mw**2-1d0/8*det3iwhqs*qs+3d0/16*det3iwhqs**2/c
     & tw**6*mw**4*mh**2+3d0/16*det3iwhqs**2/ctw**6*mw**6+3d0/16*det3iwh
     & qs**2/ctw**6*qs*mw**4+3d0/32*det3iwhqs**2/ctw**4*mw**2*mh**4+27d0
     & /32*det3iwhqs**2/ctw**4*mw**4*mh**2+21d0/16*det3iwhqs**2/ctw**4*m
     & w**6+3d0/32*det3iwhqs**2/ctw**4*qs*mw**2*mh**2+21d0/16*det3iwhqs*
     & *2/ctw**4*qs*mw**4-3d0/8*det3iwhqs**2/ctw**2*mw**2*mh**4-39d0/4*d
     & et3iwhqs**2/ctw**2*mw**4*mh**2-27d0/8*det3iwhqs**2/ctw**2*mw**6-2
     & 7d0/8*det3iwhqs**2/ctw**2*qs*mw**4+3d0/32*det3iwhqs**2*mh**6+63d0
     & /32*det3iwhqs**2*mw**2*mh**4+147d0/16*det3iwhqs**2*mw**4*mh**2+15
     & d0/4*det3iwhqs**2*mw**6+3d0/32*det3iwhqs**2*qs*mh**4+27d0/16*det3
     & iwhqs**2*qs*mw**2*mh**2+15d0/4*det3iwhqs**2*qs*mw**4+1d0/2*det3iw
     & hqs*sdet4iwhtsus/ctw**4*vpadn*mw**4*mh**2-1d0/2*det3iwhqs*sdet4iw
     & htsus/ctw**4*vpadn*ts**2*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**
     & 4*vpaup*mw**4*mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**4*vpaup*ts*
     & *2*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*mw**2*mh**4-1d
     & 0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*mw**4*mh**2-det3iwhqs*sde
     & t4iwhtsus/ctw**2*vpadn*ts*mw**2*mh**2-1d0/2*det3iwhqs*sdet4iwhtsu
     & s/ctw**2*vpadn*qs*mw**2*mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2
     & *vpaup*mw**2*mh**4-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**
     & 4*mh**2-det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*ts*mw**2*mh**2-1d0/2*
     & det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*qs*mw**2*mh**2-sdet4iwhtsus/c
     & tw**4*vpadn*mw**2-sdet4iwhtsus/ctw**4*vpaup/qs*mw**2*mh**2+sdet4i
     & whtsus/ctw**4*vpaup/qs*mw**4-sdet4iwhtsus/ctw**4*vpaup*mw**2+1d0/
     & 2*sdet4iwhtsus/ctw**2*vpadn/qs*mh**4+1d0/2*sdet4iwhtsus/ctw**2*vp
     & adn/qs*mw**2*mh**2-sdet4iwhtsus/ctw**2*vpadn/qs*mw**4+1d0/2*sdet4
     & iwhtsus/ctw**2*vpadn/qs*ts*mh**2-1d0/2*sdet4iwhtsus/ctw**2*vpadn/
     & qs*ts*mw**2+1d0/2*sdet4iwhtsus/ctw**2*vpadn*mh**2-sdet4iwhtsus/ct
     & w**2*vpadn*us+1d0/2*sdet4iwhtsus/ctw**2*vpadn*ts+sdet4iwhtsus/ctw
     & **2*vpaup/qs*mw**2*mh**2-sdet4iwhtsus/ctw**2*vpaup/qs*mw**4+sdet4
     & iwhtsus/ctw**2*vpaup/qs*us*mh**2-sdet4iwhtsus/ctw**2*vpaup/qs*us*
     & mw**2-sdet4iwhtsus/ctw**2*vpaup*mw**2+sdet4iwhtsus**2/ctw**4*vpad
     & n*mw**4*mh**2-sdet4iwhtsus**2/ctw**4*vpadn*us**2*mw**2-sdet4iwhts
     & us**2/ctw**4*vpaup/qs*mw**4*mh**4+2*sdet4iwhtsus**2/ctw**4*vpaup/
     & qs*mw**6*mh**2-sdet4iwhtsus**2/ctw**4*vpaup/qs*mw**8-sdet4iwhtsus
     & **2/ctw**4*vpaup/qs*us*mw**2*mh**4+2*sdet4iwhtsus**2/ctw**4*vpaup
     & /qs*us*mw**4*mh**2-sdet4iwhtsus**2/ctw**4*vpaup/qs*us*mw**6+sdet4
     & iwhtsus**2/ctw**4*vpaup*mw**4*mh**2-sdet4iwhtsus**2/ctw**4*vpaup*
     & mw**6-sdet4iwhtsus**2/ctw**4*vpaup*us*mw**2*mh**2+sdet4iwhtsus**2
     & /ctw**4*vpaup*ts*mw**4-sdet4iwhtsus**2/ctw**2*vpadn/qs*mw**2*mh**
     & 6+2*sdet4iwhtsus**2/ctw**2*vpadn/qs*mw**4*mh**4-sdet4iwhtsus**2/c
     & tw**2*vpadn/qs*mw**6*mh**2-sdet4iwhtsus**2/ctw**2*vpadn/qs*ts*mw*
     & *2*mh**4+2*sdet4iwhtsus**2/ctw**2*vpadn/qs*ts*mw**4*mh**2-sdet4iw
     & htsus**2/ctw**2*vpadn/qs*ts*mw**6-sdet4iwhtsus**2/ctw**2*vpadn*mw
     & **2*mh**4+sdet4iwhtsus**2/ctw**2*vpadn*ts*mw**2*mh**2-sdet4iwhtsu
     & s**2/ctw**2*vpadn*ts*mw**4+sdet4iwhtsus**2/ctw**2*vpadn*ts**2*mw*
     & *2+sdet4iwhtsus**2/ctw**2*vpaup*us*mw**2*mh**2-sdet4iwhtsus**2/ct
     & w**2*vpaup*us**3)
     & +propiwqs*c0whqswhh*(-3d0/4*det3iwhqs/mw**2*mh**4-6*det3iwhqs*mh*
     & *2-21d0/8*det3iwhqs*mw**2-3d0/4*det3iwhqs*qs/mw**2*mh**2-21d0/8*d
     & et3iwhqs*qs+9d0/32*det3iwhqs**2/mw**2*mh**8+45d0/32*det3iwhqs**2*
     & mw**2*mh**4+81d0/16*det3iwhqs**2*mw**4*mh**2+9d0/4*det3iwhqs**2*m
     & w**6+9d0/32*det3iwhqs**2*qs/mw**2*mh**6+9d0/32*det3iwhqs**2*qs*mh
     & **4+9d0/16*det3iwhqs**2*qs*mw**2*mh**2+9d0/4*det3iwhqs**2*qs*mw**
     & 4)
     & +propiwqs*c0whqszww*stw**2*(det3iwhqs*mh**2-5*det3iwhqs*mw**2+det
     & 3iwhqs*qs-3d0/2*det3iwhqs**2*mw**2*mh**4+9d0/2*det3iwhqs**2*mw**4
     & *mh**2-3*det3iwhqs**2*mw**6-3d0/2*det3iwhqs**2*qs*mw**2*mh**2-3*d
     & et3iwhqs**2*qs*mw**4)
     & +propiwqs*c0whqszww*(-3d0/8*det3iwhqs/ctw**2*mh**2-3d0/8*det3iwhq
     & s/ctw**2*mw**2-1d0/8*det3iwhqs/ctw**2*qs-1d0/2*det3iwhqs/ctw**2*v
     & padn*mw**2-1d0/2*det3iwhqs/ctw**2*vpaup*mw**2+1d0/8*det3iwhqs*mh*
     & *2+9d0/2*det3iwhqs*mw**2-1d0/4*det3iwhqs*qs+det3iwhqs*vpadn*mw**2
     & +det3iwhqs*vpaup*mw**2+3d0/32*det3iwhqs**2/ctw**4*mw**2*mh**4+21d
     & 0/32*det3iwhqs**2/ctw**4*mw**4*mh**2+3d0/8*det3iwhqs**2/ctw**4*mw
     & **6+3d0/32*det3iwhqs**2/ctw**4*qs*mw**2*mh**2+3d0/8*det3iwhqs**2/
     & ctw**4*qs*mw**4+3d0/16*det3iwhqs**2/ctw**2*mw**2*mh**4+27d0/16*de
     & t3iwhqs**2/ctw**2*mw**4*mh**2+9d0/8*det3iwhqs**2/ctw**2*mw**6-3d0
     & /16*det3iwhqs**2/ctw**2*qs*mw**2*mh**2+9d0/8*det3iwhqs**2/ctw**2*
     & qs*mw**4+3d0/32*det3iwhqs**2*mh**6+45d0/32*det3iwhqs**2*mw**2*mh*
     & *4-15d0/8*det3iwhqs**2*mw**4*mh**2+3d0/8*det3iwhqs**2*mw**6+3d0/3
     & 2*det3iwhqs**2*qs*mh**4+15d0/8*det3iwhqs**2*qs*mw**2*mh**2+3d0/8*
     & det3iwhqs**2*qs*mw**4+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*m
     & w**4*mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*ts**2*mw**2+
     & 1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**4*mh**2-1d0/2*det3i
     & whqs*sdet4iwhtsus/ctw**2*vpaup*ts**2*mw**2+1d0/2*det3iwhqs*sdet4i
     & whtsus*vpadn*mw**2*mh**4-1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*mw**4
     & *mh**2+det3iwhqs*sdet4iwhtsus*vpadn*ts*mw**2*mh**2+det3iwhqs*sdet
     & 4iwhtsus*vpadn*ts**2*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*qs*
     & mw**2*mh**2+1d0/2*det3iwhqs*sdet4iwhtsus*vpaup*mw**2*mh**4-1d0/2*
     & det3iwhqs*sdet4iwhtsus*vpaup*mw**4*mh**2+det3iwhqs*sdet4iwhtsus*v
     & paup*ts*mw**2*mh**2+det3iwhqs*sdet4iwhtsus*vpaup*ts**2*mw**2+1d0/
     & 2*det3iwhqs*sdet4iwhtsus*vpaup*qs*mw**2*mh**2-sdet4iwhtsus/ctw**2
     & *vpadn*mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*mh**4-1d0/2*sdet4
     & iwhtsus/ctw**2*vpaup/qs*mw**2*mh**2+sdet4iwhtsus/ctw**2*vpaup/qs*
     & mw**4-1d0/2*sdet4iwhtsus/ctw**2*vpaup/qs*ts*mh**2+1d0/2*sdet4iwht
     & sus/ctw**2*vpaup/qs*ts*mw**2-1d0/2*sdet4iwhtsus/ctw**2*vpaup*mh**
     & 2-sdet4iwhtsus/ctw**2*vpaup*mw**2+1d0/2*sdet4iwhtsus/ctw**2*vpaup
     & *ts-sdet4iwhtsus*vpadn/qs*us*mh**2+sdet4iwhtsus*vpadn/qs*us*mw**2
     & +3*sdet4iwhtsus*vpadn*mw**2+2*sdet4iwhtsus*vpaup*mw**2+sdet4iwhts
     & us*vpaup*us-sdet4iwhtsus*vpaup*ts+sdet4iwhtsus**2/ctw**2*vpadn*mw
     & **4*mh**2-sdet4iwhtsus**2/ctw**2*vpadn*us**2*mw**2+sdet4iwhtsus**
     & 2/ctw**2*vpaup/qs*mw**2*mh**6-2*sdet4iwhtsus**2/ctw**2*vpaup/qs*m
     & w**4*mh**4+sdet4iwhtsus**2/ctw**2*vpaup/qs*mw**6*mh**2+sdet4iwhts
     & us**2/ctw**2*vpaup/qs*ts*mw**2*mh**4-2*sdet4iwhtsus**2/ctw**2*vpa
     & up/qs*ts*mw**4*mh**2+sdet4iwhtsus**2/ctw**2*vpaup/qs*ts*mw**6+sde
     & t4iwhtsus**2/ctw**2*vpaup*mw**2*mh**4-sdet4iwhtsus**2/ctw**2*vpau
     & p*mw**4*mh**2-sdet4iwhtsus**2/ctw**2*vpaup*us*mw**2*mh**2+sdet4iw
     & htsus**2/ctw**2*vpaup*ts*mw**4+sdet4iwhtsus**2*vpadn/qs*mw**4*mh*
     & *4-2*sdet4iwhtsus**2*vpadn/qs*mw**6*mh**2+sdet4iwhtsus**2*vpadn/q
     & s*mw**8+sdet4iwhtsus**2*vpadn/qs*us*mw**2*mh**4-2*sdet4iwhtsus**2
     & *vpadn/qs*us*mw**4*mh**2+sdet4iwhtsus**2*vpadn/qs*us*mw**6-2*sdet
     & 4iwhtsus**2*vpadn*mw**4*mh**2+sdet4iwhtsus**2*vpadn*mw**6+sdet4iw
     & htsus**2*vpadn*us**2*mw**2+sdet4iwhtsus**2*vpadn*us**3-sdet4iwhts
     & us**2*vpadn*ts*mw**4+sdet4iwhtsus**2*vpaup*us*mw**2*mh**2+sdet4iw
     & htsus**2*vpaup*us**2*mw**2-sdet4iwhtsus**2*vpaup*ts*mw**2*mh**2-s
     & det4iwhtsus**2*vpaup*ts**2*mw**2)
     & +propiwqs*c0whqshww*(-7d0/8*det3iwhqs/mw**2*mh**4-7*det3iwhqs*mh*
     & *2-11d0/4*det3iwhqs*mw**2-3d0/8*det3iwhqs*qs/mw**2*mh**2-7d0/2*de
     & t3iwhqs*qs+3d0/32*det3iwhqs**2/mw**2*mh**8+15d0/16*det3iwhqs**2*m
     & h**6+87d0/32*det3iwhqs**2*mw**2*mh**4+75d0/8*det3iwhqs**2*mw**4*m
     & h**2+39d0/8*det3iwhqs**2*mw**6+3d0/32*det3iwhqs**2*qs/mw**2*mh**6
     & +9d0/32*det3iwhqs**2*qs*mh**4+9d0/8*det3iwhqs**2*qs*mw**2*mh**2+3
     & 9d0/8*det3iwhqs**2*qs*mw**4)
     & +propiwqs*c0whqsmnmomo*cfl*(-3d0/4*det3iwhqs/mw**2*mmo**4-1d0/4*d
     & et3iwhqs*mmo**2-3d0/8*det3iwhqs**2/mw**2*mh**2*mmo**6-3d0/8*det3i
     & whqs**2*mmo**6+3d0/2*det3iwhqs**2*mh**2*mmo**4-3d0/8*det3iwhqs**2
     & *mh**4*mmo**2-3d0/8*det3iwhqs**2*mw**4*mmo**2-3d0/8*det3iwhqs**2*
     & qs/mw**2*mmo**6-3d0/8*det3iwhqs**2*qs*mh**2*mmo**2-3d0/8*det3iwhq
     & s**2*qs*mw**2*mmo**2)
     & +propiwqs*c0whqschstst*cfq*(-3d0/4*det3iwhqs/mw**2*mst**4+1d0/4*d
     & et3iwhqs/mw**2*mch**2*mst**2-1d0/4*det3iwhqs*mst**2-3d0/8*det3iwh
     & qs**2/mw**2*mh**2*mst**6+3d0/4*det3iwhqs**2/mw**2*mh**2*mch**2*ms
     & t**4-3d0/8*det3iwhqs**2/mw**2*mh**2*mch**4*mst**2-3d0/8*det3iwhqs
     & **2*mst**6+3d0/4*det3iwhqs**2*mch**2*mst**4-3d0/8*det3iwhqs**2*mc
     & h**4*mst**2+3d0/2*det3iwhqs**2*mh**2*mst**4-3d0/2*det3iwhqs**2*mh
     & **2*mch**2*mst**2-3d0/8*det3iwhqs**2*mh**4*mst**2-3d0/8*det3iwhqs
     & **2*mw**4*mst**2-3d0/8*det3iwhqs**2*qs/mw**2*mst**6+3d0/4*det3iwh
     & qs**2*qs/mw**2*mch**2*mst**4-3d0/8*det3iwhqs**2*qs/mw**2*mch**4*m
     & st**2-3d0/8*det3iwhqs**2*qs*mh**2*mst**2-3d0/8*det3iwhqs**2*qs*mw
     & **2*mst**2)
     & +propiwqs*c0whqsstchch*cfq*(3d0/4*det3iwhqs/mw**2*mch**2*mst**2-5
     & d0/4*det3iwhqs/mw**2*mch**4+1d0/4*det3iwhqs/mw**2*mh**2*mch**2-1d
     & 0/2*det3iwhqs*mch**2+1d0/4*det3iwhqs*qs/mw**2*mch**2-3d0/8*det3iw
     & hqs**2/mw**2*mh**2*mch**2*mst**4+3d0/4*det3iwhqs**2/mw**2*mh**2*m
     & ch**4*mst**2-3d0/8*det3iwhqs**2/mw**2*mh**2*mch**6-3d0/8*det3iwhq
     & s**2*mch**2*mst**4+3d0/4*det3iwhqs**2*mch**4*mst**2-3d0/8*det3iwh
     & qs**2*mch**6-3d0/2*det3iwhqs**2*mh**2*mch**2*mst**2+3d0/2*det3iwh
     & qs**2*mh**2*mch**4-3d0/8*det3iwhqs**2*mh**4*mch**2-3d0/8*det3iwhq
     & s**2*mw**4*mch**2-3d0/8*det3iwhqs**2*qs/mw**2*mch**2*mst**4+3d0/4
     & *det3iwhqs**2*qs/mw**2*mch**4*mst**2-3d0/8*det3iwhqs**2*qs/mw**2*
     & mch**6-3d0/8*det3iwhqs**2*qs*mh**2*mch**2-3d0/8*det3iwhqs**2*qs*m
     & w**2*mch**2)
     & +propiwqs*c0whqstntata*cfl*(-3d0/4*det3iwhqs/mw**2*mta**4-1d0/4*d
     & et3iwhqs*mta**2-3d0/8*det3iwhqs**2/mw**2*mh**2*mta**6-3d0/8*det3i
     & whqs**2*mta**6+3d0/2*det3iwhqs**2*mh**2*mta**4-3d0/8*det3iwhqs**2
     & *mh**4*mta**2-3d0/8*det3iwhqs**2*mw**4*mta**2-3d0/8*det3iwhqs**2*
     & qs/mw**2*mta**6-3d0/8*det3iwhqs**2*qs*mh**2*mta**2-3d0/8*det3iwhq
     & s**2*qs*mw**2*mta**2)
     & +propiwqs*c0whqstpbtbt*cfq*(-3d0/4*det3iwhqs/mw**2*mbt**4+1d0/4*d
     & et3iwhqs/mw**2*mtp**2*mbt**2-1d0/4*det3iwhqs*mbt**2-3d0/8*det3iwh
     & qs**2/mw**2*mh**2*mbt**6+3d0/4*det3iwhqs**2/mw**2*mh**2*mtp**2*mb
     & t**4-3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**4*mbt**2-3d0/8*det3iwhqs
     & **2*mbt**6+3d0/4*det3iwhqs**2*mtp**2*mbt**4-3d0/8*det3iwhqs**2*mt
     & p**4*mbt**2+3d0/2*det3iwhqs**2*mh**2*mbt**4-3d0/2*det3iwhqs**2*mh
     & **2*mtp**2*mbt**2-3d0/8*det3iwhqs**2*mh**4*mbt**2-3d0/8*det3iwhqs
     & **2*mw**4*mbt**2-3d0/8*det3iwhqs**2*qs/mw**2*mbt**6+3d0/4*det3iwh
     & qs**2*qs/mw**2*mtp**2*mbt**4-3d0/8*det3iwhqs**2*qs/mw**2*mtp**4*m
     & bt**2-3d0/8*det3iwhqs**2*qs*mh**2*mbt**2-3d0/8*det3iwhqs**2*qs*mw
     & **2*mbt**2)
     & +propiwqs*c0whqsbttptp*cfq*(3d0/4*det3iwhqs/mw**2*mtp**2*mbt**2-5
     & d0/4*det3iwhqs/mw**2*mtp**4+1d0/4*det3iwhqs/mw**2*mh**2*mtp**2-1d
     & 0/2*det3iwhqs*mtp**2+1d0/4*det3iwhqs*qs/mw**2*mtp**2-3d0/8*det3iw
     & hqs**2/mw**2*mh**2*mtp**2*mbt**4+3d0/4*det3iwhqs**2/mw**2*mh**2*m
     & tp**4*mbt**2-3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**6-3d0/8*det3iwhq
     & s**2*mtp**2*mbt**4+3d0/4*det3iwhqs**2*mtp**4*mbt**2-3d0/8*det3iwh
     & qs**2*mtp**6-3d0/2*det3iwhqs**2*mh**2*mtp**2*mbt**2+3d0/2*det3iwh
     & qs**2*mh**2*mtp**4-3d0/8*det3iwhqs**2*mh**4*mtp**2-3d0/8*det3iwhq
     & s**2*mw**4*mtp**2-3d0/8*det3iwhqs**2*qs/mw**2*mtp**2*mbt**4+3d0/4
     & *det3iwhqs**2*qs/mw**2*mtp**4*mbt**2-3d0/8*det3iwhqs**2*qs/mw**2*
     & mtp**6-3d0/8*det3iwhqs**2*qs*mh**2*mtp**2-3d0/8*det3iwhqs**2*qs*m
     & w**2*mtp**2)
     & +propiwqs*c0whqscww*stw**2*(-det3iwhqs*mh**2+5*det3iwhqs*mw**2-de
     & t3iwhqs*qs+3d0/2*det3iwhqs**2*mw**2*mh**4-9d0/2*det3iwhqs**2*mw**
     & 4*mh**2+3*det3iwhqs**2*mw**6+3d0/2*det3iwhqs**2*qs*mw**2*mh**2+3*
     & det3iwhqs**2*qs*mw**4)
     & +propiwqs*c0whqscww*stw**2*qdn*(2*det3iwhqs*mw**2+det3iwhqs*sdet4
     & iwhtsus*mw**2*mh**4-det3iwhqs*sdet4iwhtsus*mw**4*mh**2+2*det3iwhq
     & s*sdet4iwhtsus*ts*mw**2*mh**2+2*det3iwhqs*sdet4iwhtsus*ts**2*mw**
     & 2+det3iwhqs*sdet4iwhtsus*qs*mw**2*mh**2-2*sdet4iwhtsus/qs*us*mh**
     & 2+2*sdet4iwhtsus/qs*us*mw**2+6*sdet4iwhtsus*mw**2+2*sdet4iwhtsus*
     & *2/qs*mw**4*mh**4-2*sdet4iwhtsus**2/qs*mw**6*mh**2+2*sdet4iwhtsus
     & **2/qs*us*mw**2*mh**4+2*sdet4iwhtsus**2/qs*us*mw**4*mh**2-2*sdet4
     & iwhtsus**2/qs*us*mw**6+6*sdet4iwhtsus**2/qs*us**2*mw**2*mh**2+2*s
     & det4iwhtsus**2/qs*us**3*mh**2+4*sdet4iwhtsus**2/qs*us**3*mw**2+2*
     & sdet4iwhtsus**2/qs*us**4-4*sdet4iwhtsus**2*mw**4*mh**2-4*sdet4iwh
     & tsus**2*us*mw**4+2*sdet4iwhtsus**2*us**3-2*sdet4iwhtsus**2*ts*mw*
     & *4)
     & +propiwqs*c0whqscww*stw**2*qup*(2*det3iwhqs*mw**2+det3iwhqs*sdet4
     & iwhtsus*mw**2*mh**4-det3iwhqs*sdet4iwhtsus*mw**4*mh**2+2*det3iwhq
     & s*sdet4iwhtsus*ts*mw**2*mh**2+2*det3iwhqs*sdet4iwhtsus*ts**2*mw**
     & 2+det3iwhqs*sdet4iwhtsus*qs*mw**2*mh**2+4*sdet4iwhtsus*mw**2+2*sd
     & et4iwhtsus*us-2*sdet4iwhtsus*ts-2*sdet4iwhtsus**2*mw**4*mh**2-2*s
     & det4iwhtsus**2*mw**6+2*sdet4iwhtsus**2*us*mw**2*mh**2+2*sdet4iwht
     & sus**2*us**2*mw**2-6*sdet4iwhtsus**2*ts*mw**2*mh**2-4*sdet4iwhtsu
     & s**2*ts*mw**4-2*sdet4iwhtsus**2*ts**2*mh**2-6*sdet4iwhtsus**2*ts*
     & *2*mw**2-2*sdet4iwhtsus**2*ts**3-2*sdet4iwhtsus**2*qs*mw**4-4*sde
     & t4iwhtsus**2*qs*ts*mw**2-2*sdet4iwhtsus**2*qs*ts**2)
     & +propiwqs*a0fw*stw**2*(-det3iwhqs-3d0/2*det3iwhqs**2*mw**2*mh**2+
     & 3d0/2*det3iwhqs**2*mw**4-3d0/2*det3iwhqs**2*qs*mw**2)
     & +propiwqs*a0fw*stw**2*qdn*(-det3iwhqs*sdet4iwhtsus*mw**2*mh**2-de
     & t3iwhqs*sdet4iwhtsus*mw**4-2*det3iwhqs*sdet4iwhtsus*ts*mw**2-det3
     & iwhqs*sdet4iwhtsus*qs*mw**2)
     & +propiwqs*a0fw*stw**2*qup*(-det3iwhqs*sdet4iwhtsus*mw**2*mh**2-de
     & t3iwhqs*sdet4iwhtsus*mw**4-2*det3iwhqs*sdet4iwhtsus*ts*mw**2-det3
     & iwhqs*sdet4iwhtsus*qs*mw**2-4*sdet3icwts*sdet4iwhtsus*mw**2)
     & +propiwqs*a0fh*(-1d0/4*det3iwhqs-1d0/2*det3iwhqs/mw**2*mh**2-1d0/
     & 4*det3iwhqs*qs/mw**2)
     & +propiwqs*b0fhww*stw**2*qdn*(det3iwhqs-det3iwhqs*sdet4iwhtsus*mw*
     & *2*mh**2+det3iwhqs*sdet4iwhtsus*ts**2+4*sdet3ichus*sdet4iwhtsus*m
     & h**2)
     & +propiwqs*b0fhww*stw**2*qup*(det3iwhqs-det3iwhqs*sdet4iwhtsus*mw*
     & *2*mh**2+det3iwhqs*sdet4iwhtsus*ts**2+4*sdet4iwhtsus)
     & +propiwqs*b0fhww*(3d0/2*det3iwhqs+5d0/8*det3iwhqs/mw**2*mh**2+1d0
     & /4*det3iwhqs*qs/mw**2+1d0/2*det3iwhqs*vpadn+1d0/2*det3iwhqs*vpaup
     & -3d0/32*det3iwhqs**2/ctw**2*mh**4-21d0/32*det3iwhqs**2/ctw**2*mw*
     & *2*mh**2-3d0/8*det3iwhqs**2/ctw**2*mw**4-3d0/32*det3iwhqs**2/ctw*
     & *2*qs*mh**2-3d0/8*det3iwhqs**2/ctw**2*qs*mw**2-3d0/32*det3iwhqs**
     & 2/mw**2*mh**6-27d0/32*det3iwhqs**2*mh**4-93d0/16*det3iwhqs**2*mw*
     & *2*mh**2-3d0/4*det3iwhqs**2*mw**4-3d0/32*det3iwhqs**2*qs/mw**2*mh
     & **4-3d0/16*det3iwhqs**2*qs*mh**2-3d0/4*det3iwhqs**2*qs*mw**2-1d0/
     & 2*det3iwhqs*sdet4iwhtsus*vpadn*mw**2*mh**2+1d0/2*det3iwhqs*sdet4i
     & whtsus*vpadn*ts**2-1d0/2*det3iwhqs*sdet4iwhtsus*vpaup*mw**2*mh**2
     & +1d0/2*det3iwhqs*sdet4iwhtsus*vpaup*ts**2+2*sdet3ichus*sdet4iwhts
     & us*vpadn*mh**2+2*sdet4iwhtsus*vpaup)
     & +propiwqs*b0fhzz*(det3iwhqs+1d0/8*det3iwhqs/ctw**2-1d0/2*det3iwhq
     & s/ctw**2*vpadn-1d0/2*det3iwhqs/ctw**2*vpaup+1d0/16*det3iwhqs/mw**
     & 2*mh**2+3d0/16*det3iwhqs**2/ctw**4*mw**2*mh**2+3d0/16*det3iwhqs**
     & 2/ctw**4*mw**4+3d0/16*det3iwhqs**2/ctw**4*qs*mw**2+3d0/32*det3iwh
     & qs**2/ctw**2*mh**4+45d0/32*det3iwhqs**2/ctw**2*mw**2*mh**2+3d0/2*
     & det3iwhqs**2/ctw**2*mw**4+3d0/32*det3iwhqs**2/ctw**2*qs*mh**2+3d0
     & /2*det3iwhqs**2/ctw**2*qs*mw**2-9d0/32*det3iwhqs**2*mh**4-171d0/3
     & 2*det3iwhqs**2*mw**2*mh**2-15d0/8*det3iwhqs**2*mw**4-3d0/32*det3i
     & whqs**2*qs*mh**2-15d0/8*det3iwhqs**2*qs*mw**2+1d0/2*det3iwhqs*sde
     & t4iwhtsus/ctw**2*vpadn*mw**2*mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/c
     & tw**2*vpadn*ts**2+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**2
     & *mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*ts**2-sdet3ichus
     & /ctw**4*vpaup*vpadn/qs-2*sdet3ichus*sdet4iwhtsus/ctw**2*vpaup*mh*
     & *2-sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*mw**2-sdet4iwhtsus/ctw**4*v
     & paup*vpadn/qs*us-2*sdet4iwhtsus/ctw**2*vpadn)
     & +propiwqs*b0fhhh*(-3d0/4*det3iwhqs-21d0/16*det3iwhqs/mw**2*mh**2-
     & 3d0/4*det3iwhqs*qs/mw**2+9d0/32*det3iwhqs**2/mw**2*mh**6+9d0/16*d
     & et3iwhqs**2*mh**4+81d0/32*det3iwhqs**2*mw**2*mh**2+9d0/8*det3iwhq
     & s**2*mw**4+9d0/32*det3iwhqs**2*qs/mw**2*mh**4+9d0/32*det3iwhqs**2
     & *qs*mh**2+9d0/8*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fhmomo*cfl*(-3d0/8*det3iwhqs**2/mw**2*mh**2*mmo**4-3d
     & 0/8*det3iwhqs**2*mmo**4+3d0/4*det3iwhqs**2*mh**2*mmo**2-3d0/8*det
     & 3iwhqs**2*qs/mw**2*mmo**4)
     & +propiwqs*b0fhchch*cfq*(-1d0/2*det3iwhqs/mw**2*mch**2+3d0/8*det3i
     & whqs**2/mw**2*mh**2*mch**2*mst**2-3d0/8*det3iwhqs**2/mw**2*mh**2*
     & mch**4+3d0/8*det3iwhqs**2*mch**2*mst**2-3d0/8*det3iwhqs**2*mch**4
     & +3d0/4*det3iwhqs**2*mh**2*mch**2+3d0/8*det3iwhqs**2*qs/mw**2*mch*
     & *2*mst**2-3d0/8*det3iwhqs**2*qs/mw**2*mch**4)
     & +propiwqs*b0fhstst*cfq*(-3d0/8*det3iwhqs**2/mw**2*mh**2*mst**4+3d
     & 0/8*det3iwhqs**2/mw**2*mh**2*mch**2*mst**2-3d0/8*det3iwhqs**2*mst
     & **4+3d0/8*det3iwhqs**2*mch**2*mst**2+3d0/4*det3iwhqs**2*mh**2*mst
     & **2-3d0/8*det3iwhqs**2*qs/mw**2*mst**4+3d0/8*det3iwhqs**2*qs/mw**
     & 2*mch**2*mst**2)
     & +propiwqs*b0fhtata*cfl*(-3d0/8*det3iwhqs**2/mw**2*mh**2*mta**4-3d
     & 0/8*det3iwhqs**2*mta**4+3d0/4*det3iwhqs**2*mh**2*mta**2-3d0/8*det
     & 3iwhqs**2*qs/mw**2*mta**4)
     & +propiwqs*b0fhtptp*cfq*(-1d0/2*det3iwhqs/mw**2*mtp**2+3d0/8*det3i
     & whqs**2/mw**2*mh**2*mtp**2*mbt**2-3d0/8*det3iwhqs**2/mw**2*mh**2*
     & mtp**4+3d0/8*det3iwhqs**2*mtp**2*mbt**2-3d0/8*det3iwhqs**2*mtp**4
     & +3d0/4*det3iwhqs**2*mh**2*mtp**2+3d0/8*det3iwhqs**2*qs/mw**2*mtp*
     & *2*mbt**2-3d0/8*det3iwhqs**2*qs/mw**2*mtp**4)
     & +propiwqs*b0fhbtbt*cfq*(-3d0/8*det3iwhqs**2/mw**2*mh**2*mbt**4+3d
     & 0/8*det3iwhqs**2/mw**2*mh**2*mtp**2*mbt**2-3d0/8*det3iwhqs**2*mbt
     & **4+3d0/8*det3iwhqs**2*mtp**2*mbt**2+3d0/4*det3iwhqs**2*mh**2*mbt
     & **2-3d0/8*det3iwhqs**2*qs/mw**2*mbt**4+3d0/8*det3iwhqs**2*qs/mw**
     & 2*mtp**2*mbt**2)
     & +propiwqs*b0fwwz*stw**2*(-det3iwhqs-3d0/2*det3iwhqs**2*mw**2*mh**
     & 2+3d0/2*det3iwhqs**2*mw**4-3d0/2*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fwwz*(1d0/4*det3iwhqs+1d0/4*det3iwhqs/ctw**2-3d0/16*d
     & et3iwhqs**2/ctw**4*mw**4+3d0/16*det3iwhqs**2/ctw**2*mw**2*mh**2-9
     & d0/8*det3iwhqs**2/ctw**2*mw**4+3d0/16*det3iwhqs**2/ctw**2*qs*mw**
     & 2+3d0/16*det3iwhqs**2*mh**4+57d0/16*det3iwhqs**2*mw**2*mh**2+3d0/
     & 2*det3iwhqs**2*mw**4+3d0/16*det3iwhqs**2*qs*mh**2+27d0/8*det3iwhq
     & s**2*qs*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*mw**2*mh*
     & *2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*mw**4-det3iwhqs*sdet
     & 4iwhtsus/ctw**2*vpadn*ts*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**
     & 2*vpadn*qs*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**2*
     & mh**2-1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*mw**4-det3iwhqs*s
     & det4iwhtsus/ctw**2*vpaup*ts*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus/ct
     & w**2*vpaup*qs*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*mw**2*mh**
     & 2+1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*mw**4+det3iwhqs*sdet4iwhtsus
     & *vpadn*ts*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*qs*mw**2+1d0/2
     & *det3iwhqs*sdet4iwhtsus*vpaup*mw**2*mh**2+1d0/2*det3iwhqs*sdet4iw
     & htsus*vpaup*mw**4+det3iwhqs*sdet4iwhtsus*vpaup*ts*mw**2+1d0/2*det
     & 3iwhqs*sdet4iwhtsus*vpaup*qs*mw**2-2*sdet3icwts*sdet4iwhtsus/ctw*
     & *2*vpadn*mw**2+2*sdet3icwts*sdet4iwhtsus*vpaup*mw**2)
     & +propiwqs*b0fwwh*(3d0/8*det3iwhqs+1d0/4*det3iwhqs/mw**2*mh**2+1d0
     & /8*det3iwhqs*qs/mw**2-3d0/16*det3iwhqs**2*mh**4+3d0/8*det3iwhqs**
     & 2*mw**2*mh**2-3d0/16*det3iwhqs**2*mw**4+3d0/16*det3iwhqs**2*qs*mh
     & **2+3d0/16*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fwupdn*(sdet3icwts/ctw**4*vpaup*vpadn/qs-sdet4iwhtsus
     & /ctw**4*vpaup*vpadn/qs*mw**2-sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*u
     & s)
     & +propiwqs*b0fwmnmo*cfl*(3d0/8*det3iwhqs**2*mmo**4-3d0/8*det3iwhqs
     & **2*mh**2*mmo**2-3d0/8*det3iwhqs**2*qs*mmo**2)
     & +propiwqs*b0fwchst*cfq*(-1d0/4*det3iwhqs/mw**2*mch**2+3d0/8*det3i
     & whqs**2*mst**4-3d0/4*det3iwhqs**2*mch**2*mst**2+3d0/8*det3iwhqs**
     & 2*mch**4-3d0/8*det3iwhqs**2*mh**2*mst**2-3d0/8*det3iwhqs**2*mh**2
     & *mch**2-3d0/8*det3iwhqs**2*qs*mst**2-3d0/8*det3iwhqs**2*qs*mch**2
     & )
     & +propiwqs*b0fwtnta*cfl*(3d0/8*det3iwhqs**2*mta**4-3d0/8*det3iwhqs
     & **2*mh**2*mta**2-3d0/8*det3iwhqs**2*qs*mta**2)
     & +propiwqs*b0fwtpbt*cfq*(-1d0/4*det3iwhqs/mw**2*mtp**2+3d0/8*det3i
     & whqs**2*mbt**4-3d0/4*det3iwhqs**2*mtp**2*mbt**2+3d0/8*det3iwhqs**
     & 2*mtp**4-3d0/8*det3iwhqs**2*mh**2*mbt**2-3d0/8*det3iwhqs**2*mh**2
     & *mtp**2-3d0/8*det3iwhqs**2*qs*mbt**2-3d0/8*det3iwhqs**2*qs*mtp**2
     & )
     & +propiwqs*b0fqswz*stw**2*(2*det3iwhqs+3*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fqswz*(-19d0/8*det3iwhqs-3d0/8*det3iwhqs/ctw**2+1d0/2
     & *det3iwhqs/ctw**2*vpadn+1d0/2*det3iwhqs/ctw**2*vpaup-1d0/8*det3iw
     & hqs/mw**2*mh**2-1d0/2*det3iwhqs*vpadn-1d0/2*det3iwhqs*vpaup-3d0/1
     & 6*det3iwhqs**2/ctw**4*mw**2*mh**2-3d0/16*det3iwhqs**2/ctw**4*qs*m
     & w**2-15d0/16*det3iwhqs**2/ctw**2*mw**2*mh**2-21d0/16*det3iwhqs**2
     & /ctw**2*qs*mw**2+3d0/16*det3iwhqs**2*mh**4+39d0/8*det3iwhqs**2*mw
     & **2*mh**2+3d0/16*det3iwhqs**2*mw**4-3d0/16*det3iwhqs**2*qs*mh**2-
     & 27d0/16*det3iwhqs**2*qs*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2
     & *vpadn*mw**4+det3iwhqs*sdet4iwhtsus/ctw**2*vpadn*ts*mw**2+1d0/2*d
     & et3iwhqs*sdet4iwhtsus/ctw**2*vpadn*ts**2+1d0/2*det3iwhqs*sdet4iwh
     & tsus/ctw**2*vpadn*qs*mw**2+1d0/2*det3iwhqs*sdet4iwhtsus/ctw**2*vp
     & aup*mw**4+det3iwhqs*sdet4iwhtsus/ctw**2*vpaup*ts*mw**2+1d0/2*det3
     & iwhqs*sdet4iwhtsus/ctw**2*vpaup*ts**2+1d0/2*det3iwhqs*sdet4iwhtsu
     & s/ctw**2*vpaup*qs*mw**2-1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*mw**4-
     & det3iwhqs*sdet4iwhtsus*vpadn*ts*mw**2-1d0/2*det3iwhqs*sdet4iwhtsu
     & s*vpadn*ts**2-1d0/2*det3iwhqs*sdet4iwhtsus*vpadn*qs*mw**2-1d0/2*d
     & et3iwhqs*sdet4iwhtsus*vpaup*mw**4-det3iwhqs*sdet4iwhtsus*vpaup*ts
     & *mw**2-1d0/2*det3iwhqs*sdet4iwhtsus*vpaup*ts**2-1d0/2*det3iwhqs*s
     & det4iwhtsus*vpaup*qs*mw**2+2*sdet4iwhtsus/ctw**2*vpadn+2*sdet4iwh
     & tsus/ctw**2*vpaup-2*sdet4iwhtsus*vpadn-2*sdet4iwhtsus*vpaup)
     & +propiwqs*b0fqswh*(-1d0/4*det3iwhqs+1d0/8*det3iwhqs*qs/mw**2-3d0/
     & 16*det3iwhqs**2/mw**2*mh**6+3d0/8*det3iwhqs**2*mh**4-3d0/16*det3i
     & whqs**2*mw**2*mh**2-3d0/16*det3iwhqs**2*qs/mw**2*mh**4-3d0/16*det
     & 3iwhqs**2*qs*mh**2-3d0/8*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fqswc*stw**2*(-2*det3iwhqs-3*det3iwhqs**2*qs*mw**2)
     & +propiwqs*b0fqswc*stw**2*qdn*(-det3iwhqs-det3iwhqs*sdet4iwhtsus*m
     & w**4-2*det3iwhqs*sdet4iwhtsus*ts*mw**2-det3iwhqs*sdet4iwhtsus*ts*
     & *2-det3iwhqs*sdet4iwhtsus*qs*mw**2-4*sdet4iwhtsus)
     & +propiwqs*b0fqswc*stw**2*qup*(-det3iwhqs-det3iwhqs*sdet4iwhtsus*m
     & w**4-2*det3iwhqs*sdet4iwhtsus*ts*mw**2-det3iwhqs*sdet4iwhtsus*ts*
     & *2-det3iwhqs*sdet4iwhtsus*qs*mw**2-4*sdet4iwhtsus)
     & +propiwqs*b0fqsmnmo*cfl*(3d0/8*det3iwhqs**2/mw**2*mh**2*mmo**4-3d
     & 0/8*det3iwhqs**2*mh**2*mmo**2+3d0/8*det3iwhqs**2*qs/mw**2*mmo**4+
     & 3d0/8*det3iwhqs**2*qs*mmo**2)
     & +propiwqs*b0fqschst*cfq*(3d0/4*det3iwhqs/mw**2*mch**2+3d0/8*det3i
     & whqs**2/mw**2*mh**2*mst**4-3d0/4*det3iwhqs**2/mw**2*mh**2*mch**2*
     & mst**2+3d0/8*det3iwhqs**2/mw**2*mh**2*mch**4-3d0/8*det3iwhqs**2*m
     & h**2*mst**2-3d0/8*det3iwhqs**2*mh**2*mch**2+3d0/8*det3iwhqs**2*qs
     & /mw**2*mst**4-3d0/4*det3iwhqs**2*qs/mw**2*mch**2*mst**2+3d0/8*det
     & 3iwhqs**2*qs/mw**2*mch**4+3d0/8*det3iwhqs**2*qs*mst**2+3d0/8*det3
     & iwhqs**2*qs*mch**2)
     & +propiwqs*b0fqstnta*cfl*(3d0/8*det3iwhqs**2/mw**2*mh**2*mta**4-3d
     & 0/8*det3iwhqs**2*mh**2*mta**2+3d0/8*det3iwhqs**2*qs/mw**2*mta**4+
     & 3d0/8*det3iwhqs**2*qs*mta**2)
     & +propiwqs*b0fqstpbt*cfq*(3d0/4*det3iwhqs/mw**2*mtp**2+3d0/8*det3i
     & whqs**2/mw**2*mh**2*mbt**4-3d0/4*det3iwhqs**2/mw**2*mh**2*mtp**2*
     & mbt**2+3d0/8*det3iwhqs**2/mw**2*mh**2*mtp**4-3d0/8*det3iwhqs**2*m
     & h**2*mbt**2-3d0/8*det3iwhqs**2*mh**2*mtp**2+3d0/8*det3iwhqs**2*qs
     & /mw**2*mbt**4-3d0/4*det3iwhqs**2*qs/mw**2*mtp**2*mbt**2+3d0/8*det
     & 3iwhqs**2*qs/mw**2*mtp**4+3d0/8*det3iwhqs**2*qs*mbt**2+3d0/8*det3
     & iwhqs**2*qs*mtp**2)
     & +propiwqs*b0ftswup*stw**2*qup*(-4*sdet3icwts*sdet4iwhtsus*mw**2)
     & +propiwqs*b0ftswup*(-2*sdet3icwts*sdet4iwhtsus*vpaup*mw**2)
     & +propiwqs*b0ftszdn*(-sdet3icwts/ctw**4*vpaup*vpadn/qs+2*sdet3icwt
     & s*sdet4iwhtsus/ctw**2*vpadn*mw**2+sdet4iwhtsus/ctw**4*vpaup*vpadn
     & /qs*mw**2+sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*us)
     & +propiwqs*b0fuswdn*stw**2*qdn*(-4*sdet3ichus*sdet4iwhtsus*mh**2+4
     & *sdet4iwhtsus)
     & +propiwqs*b0fuswdn*(-2*sdet3ichus*sdet4iwhtsus*vpadn*mh**2+2*sdet
     & 4iwhtsus*vpadn)
     & +propiwqs*b0fuszup*(sdet3ichus/ctw**4*vpaup*vpadn/qs+2*sdet3ichus
     & *sdet4iwhtsus/ctw**2*vpaup*mh**2+sdet4iwhtsus/ctw**4*vpaup*vpadn/
     & qs*mw**2+sdet4iwhtsus/ctw**4*vpaup*vpadn/qs*us-2*sdet4iwhtsus/ctw
     & **2*vpaup)
     & +propiwqs*(-15d0/8*det3iwhqs-1d0/8*det3iwhqs/ctw**2+3d0/8*det3iwh
     & qs/mw**2*mh**2+3d0/8*det3iwhqs*qs/mw**2)
     & +c0whqswzz*(7d0/2+1d0/2*det3iwhqs/ctw**6*mw**4-1d0/4*det3iwhqs/ct
     & w**4*mw**2*mh**2+11d0/4*det3iwhqs/ctw**4*mw**4+1d0/4*det3iwhqs/ct
     & w**2*mw**2*mh**2-35d0/2*det3iwhqs/ctw**2*mw**4+13d0/4*det3iwhqs*m
     & w**2*mh**2+15*det3iwhqs*mw**4-3d0/8*det3iwhqs**2/ctw**6*mw**6*mh*
     & *2-9d0/4*det3iwhqs**2/ctw**4*mw**6*mh**2+27d0/2*det3iwhqs**2/ctw*
     & *2*mw**6*mh**2-15*det3iwhqs**2*mw**6*mh**2)
     & +c0whqswhh*(-21d0/2-3/mw**2*mh**2+51d0/4*det3iwhqs*mw**2*mh**2+9*
     & det3iwhqs*mw**4-9*det3iwhqs**2*mw**6*mh**2)
     & +c0whqszww*(4-1d0/2/ctw**2+1d0/4*det3iwhqs/ctw**4*mw**2*mh**2+5d0
     & /4*det3iwhqs/ctw**4*mw**4-det3iwhqs/ctw**2*mw**2*mh**2+7d0/2*det3
     & iwhqs/ctw**2*mw**4+4*det3iwhqs*mw**2*mh**2-4*det3iwhqs*mw**4-9d0/
     & 8*det3iwhqs**2/ctw**4*mw**6*mh**2-3*det3iwhqs**2/ctw**2*mw**6*mh*
     & *2)
     & +c0whqshww*(-13-3d0/2/mw**2*mh**2+17*det3iwhqs*mw**2*mh**2+18*det
     & 3iwhqs*mw**4-18*det3iwhqs**2*mw**6*mh**2)
     & +c0whqsmnmomo*cfl*(-det3iwhqs/mw**2*mmo**6+1d0/4*det3iwhqs/mw**2*
     & mh**2*mmo**4+2*det3iwhqs*mmo**4-1d0/4*det3iwhqs*mh**2*mmo**2-det3
     & iwhqs*mw**2*mmo**2+3d0/4*det3iwhqs**2*mh**2*mmo**6-3d0/2*det3iwhq
     & s**2*mw**2*mh**2*mmo**4+3d0/4*det3iwhqs**2*mw**4*mh**2*mmo**2)
     & +c0whqschstst*cfq*(-det3iwhqs/mw**2*mst**6+2*det3iwhqs/mw**2*mch*
     & *2*mst**4-det3iwhqs/mw**2*mch**4*mst**2+1d0/4*det3iwhqs/mw**2*mh*
     & *2*mst**4-3d0/4*det3iwhqs/mw**2*mh**2*mch**2*mst**2+2*det3iwhqs*m
     & st**4-det3iwhqs*mch**2*mst**2-1d0/4*det3iwhqs*mh**2*mst**2-det3iw
     & hqs*mw**2*mst**2+3d0/4*det3iwhqs**2*mh**2*mst**6-3d0/2*det3iwhqs*
     & *2*mh**2*mch**2*mst**4+3d0/4*det3iwhqs**2*mh**2*mch**4*mst**2-3d0
     & /2*det3iwhqs**2*mw**2*mh**2*mst**4+3d0/2*det3iwhqs**2*mw**2*mh**2
     & *mch**2*mst**2+3d0/4*det3iwhqs**2*mw**4*mh**2*mst**2)
     & +c0whqsstchch*cfq*(-det3iwhqs/mw**2*mch**2*mst**4+2*det3iwhqs/mw*
     & *2*mch**4*mst**2-det3iwhqs/mw**2*mch**6-3d0/4*det3iwhqs/mw**2*mh*
     & *2*mch**2*mst**2+1d0/4*det3iwhqs/mw**2*mh**2*mch**4-det3iwhqs*mch
     & **2*mst**2+2*det3iwhqs*mch**4-1d0/4*det3iwhqs*mh**2*mch**2-det3iw
     & hqs*mw**2*mch**2+3d0/4*det3iwhqs**2*mh**2*mch**2*mst**4-3d0/2*det
     & 3iwhqs**2*mh**2*mch**4*mst**2+3d0/4*det3iwhqs**2*mh**2*mch**6+3d0
     & /2*det3iwhqs**2*mw**2*mh**2*mch**2*mst**2-3d0/2*det3iwhqs**2*mw**
     & 2*mh**2*mch**4+3d0/4*det3iwhqs**2*mw**4*mh**2*mch**2)
     & +c0whqstntata*cfl*(-det3iwhqs/mw**2*mta**6+1d0/4*det3iwhqs/mw**2*
     & mh**2*mta**4+2*det3iwhqs*mta**4-1d0/4*det3iwhqs*mh**2*mta**2-det3
     & iwhqs*mw**2*mta**2+3d0/4*det3iwhqs**2*mh**2*mta**6-3d0/2*det3iwhq
     & s**2*mw**2*mh**2*mta**4+3d0/4*det3iwhqs**2*mw**4*mh**2*mta**2)
     & +c0whqstpbtbt*cfq*(-det3iwhqs/mw**2*mbt**6+2*det3iwhqs/mw**2*mtp*
     & *2*mbt**4-det3iwhqs/mw**2*mtp**4*mbt**2+1d0/4*det3iwhqs/mw**2*mh*
     & *2*mbt**4-3d0/4*det3iwhqs/mw**2*mh**2*mtp**2*mbt**2+2*det3iwhqs*m
     & bt**4-det3iwhqs*mtp**2*mbt**2-1d0/4*det3iwhqs*mh**2*mbt**2-det3iw
     & hqs*mw**2*mbt**2+3d0/4*det3iwhqs**2*mh**2*mbt**6-3d0/2*det3iwhqs*
     & *2*mh**2*mtp**2*mbt**4+3d0/4*det3iwhqs**2*mh**2*mtp**4*mbt**2-3d0
     & /2*det3iwhqs**2*mw**2*mh**2*mbt**4+3d0/2*det3iwhqs**2*mw**2*mh**2
     & *mtp**2*mbt**2+3d0/4*det3iwhqs**2*mw**4*mh**2*mbt**2)
     & +c0whqsbttptp*cfq*(-det3iwhqs/mw**2*mtp**2*mbt**4+2*det3iwhqs/mw*
     & *2*mtp**4*mbt**2-det3iwhqs/mw**2*mtp**6-3d0/4*det3iwhqs/mw**2*mh*
     & *2*mtp**2*mbt**2+1d0/4*det3iwhqs/mw**2*mh**2*mtp**4-det3iwhqs*mtp
     & **2*mbt**2+2*det3iwhqs*mtp**4-1d0/4*det3iwhqs*mh**2*mtp**2-det3iw
     & hqs*mw**2*mtp**2+3d0/4*det3iwhqs**2*mh**2*mtp**2*mbt**4-3d0/2*det
     & 3iwhqs**2*mh**2*mtp**4*mbt**2+3d0/4*det3iwhqs**2*mh**2*mtp**6+3d0
     & /2*det3iwhqs**2*mw**2*mh**2*mtp**2*mbt**2-3d0/2*det3iwhqs**2*mw**
     & 2*mh**2*mtp**4+3d0/4*det3iwhqs**2*mw**4*mh**2*mtp**2)
     & +a0fw*stw**2*(-det3iwhqs*mh**2)
     & +a0fw*(-1d0/4*det3iwhqs/ctw**2*mw**2-1d0/4*det3iwhqs*mh**2+1d0/2*
     & det3iwhqs*mw**2)
     & +a0fz*(1d0/4*det3iwhqs/ctw**4*mw**2+7d0/4*det3iwhqs/ctw**2*mw**2-
     & 2*det3iwhqs*mw**2)
     & +a0fh*(-1d0/mw**2+3d0/4*det3iwhqs*mh**2)
     & +a0fmo*cfl*(-1d0/2*det3iwhqs/mw**2*mmo**4)
     & +a0fch*cfq*(1d0/2*det3iwhqs/mw**2*mch**2*mst**2-1d0/2*det3iwhqs/m
     & w**2*mch**4)
     & +a0fst*cfq*(-1d0/2*det3iwhqs/mw**2*mst**4+1d0/2*det3iwhqs/mw**2*m
     & ch**2*mst**2)
     & +a0fta*cfl*(-1d0/2*det3iwhqs/mw**2*mta**4)
     & +a0ftp*cfq*(1d0/2*det3iwhqs/mw**2*mtp**2*mbt**2-1d0/2*det3iwhqs/m
     & w**2*mtp**4)
     & +a0fbt*cfq*(-1d0/2*det3iwhqs/mw**2*mbt**4+1d0/2*det3iwhqs/mw**2*m
     & tp**2*mbt**2)
     & +b0fhww*(1d0/mw**2-1d0/4*det3iwhqs/ctw**2*mh**2-5d0/4*det3iwhqs/c
     & tw**2*mw**2-3*det3iwhqs*mh**2-6*det3iwhqs*mw**2+9d0/8*det3iwhqs**
     & 2/ctw**2*mw**4*mh**2+15d0/2*det3iwhqs**2*mw**4*mh**2)
     & +b0fhzz*(1d0/2*det3iwhqs/ctw**4*mw**2-1d0/4*det3iwhqs/ctw**2*mh**
     & 2+4*det3iwhqs/ctw**2*mw**2-3d0/8*det3iwhqs*mh**2-15d0/2*det3iwhqs
     & *mw**2-3d0/8*det3iwhqs**2/ctw**4*mw**4*mh**2-3*det3iwhqs**2/ctw**
     & 2*mw**4*mh**2+15d0/2*det3iwhqs**2*mw**4*mh**2)
     & +b0fhhh*(-3/mw**2+33d0/8*det3iwhqs*mh**2+9d0/2*det3iwhqs*mw**2-9d
     & 0/2*det3iwhqs**2*mw**4*mh**2)
     & +b0fhmomo*cfl*(-det3iwhqs/mw**2*mmo**4+1d0/4*det3iwhqs/mw**2*mh**
     & 2*mmo**2+1d0/2*det3iwhqs*mmo**2+3d0/4*det3iwhqs**2*mh**2*mmo**4-3
     & d0/4*det3iwhqs**2*mw**2*mh**2*mmo**2)
     & +b0fhchch*cfq*(det3iwhqs/mw**2*mch**2*mst**2-det3iwhqs/mw**2*mch*
     & *4+1d0/4*det3iwhqs/mw**2*mh**2*mch**2+1d0/2*det3iwhqs*mch**2-3d0/
     & 4*det3iwhqs**2*mh**2*mch**2*mst**2+3d0/4*det3iwhqs**2*mh**2*mch**
     & 4-3d0/4*det3iwhqs**2*mw**2*mh**2*mch**2)
     & +b0fhstst*cfq*(-det3iwhqs/mw**2*mst**4+det3iwhqs/mw**2*mch**2*mst
     & **2+1d0/4*det3iwhqs/mw**2*mh**2*mst**2+1d0/2*det3iwhqs*mst**2+3d0
     & /4*det3iwhqs**2*mh**2*mst**4-3d0/4*det3iwhqs**2*mh**2*mch**2*mst*
     & *2-3d0/4*det3iwhqs**2*mw**2*mh**2*mst**2)
     & +b0fhtata*cfl*(-det3iwhqs/mw**2*mta**4+1d0/4*det3iwhqs/mw**2*mh**
     & 2*mta**2+1d0/2*det3iwhqs*mta**2+3d0/4*det3iwhqs**2*mh**2*mta**4-3
     & d0/4*det3iwhqs**2*mw**2*mh**2*mta**2)
     & +b0fhtptp*cfq*(det3iwhqs/mw**2*mtp**2*mbt**2-det3iwhqs/mw**2*mtp*
     & *4+1d0/4*det3iwhqs/mw**2*mh**2*mtp**2+1d0/2*det3iwhqs*mtp**2-3d0/
     & 4*det3iwhqs**2*mh**2*mtp**2*mbt**2+3d0/4*det3iwhqs**2*mh**2*mtp**
     & 4-3d0/4*det3iwhqs**2*mw**2*mh**2*mtp**2)
     & +b0fhbtbt*cfq*(-det3iwhqs/mw**2*mbt**4+det3iwhqs/mw**2*mtp**2*mbt
     & **2+1d0/4*det3iwhqs/mw**2*mh**2*mbt**2+1d0/2*det3iwhqs*mbt**2+3d0
     & /4*det3iwhqs**2*mh**2*mbt**4-3d0/4*det3iwhqs**2*mh**2*mtp**2*mbt*
     & *2-3d0/4*det3iwhqs**2*mw**2*mh**2*mbt**2)
     & +b0fwwz*stw**2*(-det3iwhqs*mh**2)
     & +b0fwwz*(-1d0/8*det3iwhqs/ctw**4*mw**2+1d0/4*det3iwhqs/ctw**2*mh*
     & *2-5d0/8*det3iwhqs/ctw**2*mw**2+3d0/8*det3iwhqs*mh**2+15d0/4*det3
     & iwhqs*mw**2+3d0/16*det3iwhqs**2/ctw**4*mw**4*mh**2+15d0/16*det3iw
     & hqs**2/ctw**2*mw**4*mh**2-21d0/4*det3iwhqs**2*mw**4*mh**2)
     & +b0fwwh*(1d0/2/mw**2-1d0/2*det3iwhqs*mh**2)
     & +b0fwmnmo*cfl*(1d0/4*det3iwhqs/mw**2*mmo**4-3d0/4*det3iwhqs*mmo**
     & 2-3d0/8*det3iwhqs**2*mh**2*mmo**4+3d0/8*det3iwhqs**2*mw**2*mh**2*
     & mmo**2)
     & +b0fwchst*cfq*(1d0/4*det3iwhqs/mw**2*mst**4-1d0/2*det3iwhqs/mw**2
     & *mch**2*mst**2+1d0/4*det3iwhqs/mw**2*mch**4-1d0/4*det3iwhqs/mw**2
     & *mh**2*mch**2-3d0/4*det3iwhqs*mst**2+1d0/4*det3iwhqs*mch**2-3d0/8
     & *det3iwhqs**2*mh**2*mst**4+3d0/4*det3iwhqs**2*mh**2*mch**2*mst**2
     & -3d0/8*det3iwhqs**2*mh**2*mch**4+3d0/8*det3iwhqs**2*mw**2*mh**2*m
     & st**2+3d0/8*det3iwhqs**2*mw**2*mh**2*mch**2)
     & +b0fwtnta*cfl*(1d0/4*det3iwhqs/mw**2*mta**4-3d0/4*det3iwhqs*mta**
     & 2-3d0/8*det3iwhqs**2*mh**2*mta**4+3d0/8*det3iwhqs**2*mw**2*mh**2*
     & mta**2)
     & +b0fwtpbt*cfq*(1d0/4*det3iwhqs/mw**2*mbt**4-1d0/2*det3iwhqs/mw**2
     & *mtp**2*mbt**2+1d0/4*det3iwhqs/mw**2*mtp**4-1d0/4*det3iwhqs/mw**2
     & *mh**2*mtp**2-3d0/4*det3iwhqs*mbt**2+1d0/4*det3iwhqs*mtp**2-3d0/8
     & *det3iwhqs**2*mh**2*mbt**4+3d0/4*det3iwhqs**2*mh**2*mtp**2*mbt**2
     & -3d0/8*det3iwhqs**2*mh**2*mtp**4+3d0/8*det3iwhqs**2*mw**2*mh**2*m
     & bt**2+3d0/8*det3iwhqs**2*mw**2*mh**2*mtp**2)
     & +b0fqswz*stw**2*(-det3iwhqs*mh**2)
     & +b0fqswz*(-1d0/8*det3iwhqs/ctw**4*mw**2+1d0/4*det3iwhqs/ctw**2*mh
     & **2-5d0/8*det3iwhqs/ctw**2*mw**2+3d0/8*det3iwhqs*mh**2+15d0/4*det
     & 3iwhqs*mw**2+3d0/16*det3iwhqs**2/ctw**4*mw**4*mh**2+15d0/16*det3i
     & whqs**2/ctw**2*mw**4*mh**2-21d0/4*det3iwhqs**2*mw**4*mh**2)
     & +b0fqswh*(1d0/2/mw**2-1d0/2*det3iwhqs*mh**2)
     & +b0fqswc*stw**2*(det3iwhqs*mh**2)
     & +b0fqsmnmo*cfl*(1d0/4*det3iwhqs/mw**2*mmo**4-1d0/4*det3iwhqs/mw**
     & 2*mh**2*mmo**2+1d0/4*det3iwhqs*mmo**2-3d0/8*det3iwhqs**2*mh**2*mm
     & o**4+3d0/8*det3iwhqs**2*mw**2*mh**2*mmo**2)
     & +b0fqschst*cfq*(1d0/4*det3iwhqs/mw**2*mst**4-1d0/2*det3iwhqs/mw**
     & 2*mch**2*mst**2+1d0/4*det3iwhqs/mw**2*mch**4-1d0/4*det3iwhqs/mw**
     & 2*mh**2*mst**2+1d0/4*det3iwhqs*mst**2-3d0/4*det3iwhqs*mch**2-3d0/
     & 8*det3iwhqs**2*mh**2*mst**4+3d0/4*det3iwhqs**2*mh**2*mch**2*mst**
     & 2-3d0/8*det3iwhqs**2*mh**2*mch**4+3d0/8*det3iwhqs**2*mw**2*mh**2*
     & mst**2+3d0/8*det3iwhqs**2*mw**2*mh**2*mch**2)
     & +b0fqstnta*cfl*(1d0/4*det3iwhqs/mw**2*mta**4-1d0/4*det3iwhqs/mw**
     & 2*mh**2*mta**2+1d0/4*det3iwhqs*mta**2-3d0/8*det3iwhqs**2*mh**2*mt
     & a**4+3d0/8*det3iwhqs**2*mw**2*mh**2*mta**2)
     & +b0fqstpbt*cfq*(1d0/4*det3iwhqs/mw**2*mbt**4-1d0/2*det3iwhqs/mw**
     & 2*mtp**2*mbt**2+1d0/4*det3iwhqs/mw**2*mtp**4-1d0/4*det3iwhqs/mw**
     & 2*mh**2*mbt**2+1d0/4*det3iwhqs*mbt**2-3d0/4*det3iwhqs*mtp**2-3d0/
     & 8*det3iwhqs**2*mh**2*mbt**4+3d0/4*det3iwhqs**2*mh**2*mtp**2*mbt**
     & 2-3d0/8*det3iwhqs**2*mh**2*mtp**4+3d0/8*det3iwhqs**2*mw**2*mh**2*
     & mbt**2+3d0/8*det3iwhqs**2*mw**2*mh**2*mtp**2)
     & +3d0/2/mw**2-1d0/8*det3iwhqs/ctw**2*mh**2+1d0/4*det3iwhqs/ctw**2*
     & mw**2-3*det3iwhqs*mh**2+9d0/2*det3iwhqs*mw**2

      ffarray(1,1) = ffgp0ew
      ffarray(1,2) = ffgp1ew
      ffarray(1,3) = ffgp2ew

      return
      end
