************************************************************************
* sanc_nc_v1.30 package.
************************************************************************
* File (nc_ff_1313_42.F) is created on Wed Apr 18 13:43:49 MSK 2012.
************************************************************************
* This is the FORTRAN module (nc_ff_1313_42) to calculate 1-loop EW
* form factors for the anti-up + up -> H + Z process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ff_1313_42 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ffgp0,ffgp1,ffgp2,ffgm0,ffgm1,ffgm2

      real*8 det3izhqs
      real*8 a0fw,a0fz,a0fh
      complex*16 b0phww,b0phzz,b0phhh,b0pzww,b0pzzh,b0pccz
      complex*16 b0fqsww,b0fqszh,b0fhww,b0fhzz,b0fhhh,b0fhmomo,b0fhchch
     & ,b0fhstst,b0fhtata,b0fhtptp,b0fhbtbt,b0fzww,b0fzzh,b0fzmomo,b0fzc
     & hch,b0fzstst,b0fztata,b0fztptp,b0fzbtbt,b0fqsmomo,b0fqschch,b0fqs
     & stst,b0fqstata,b0fqstptp,b0fqsbtbt,b0ftswc,b0ftszc,b0fuswc,b0fusz
     & c,b0fqscc,b0fzcc
      complex*16 c0zhqswww,c0zhqszhh,c0zhqshzz,c0zhqsmomomo,c0zhqschchc
     & h,c0zhqsststst,c0zhqstatata,c0zhqstptptp,c0zhqsbtbtbt,c0chtscww,c
     & 0chtsczz,c0chuscww,c0chusczz,c0cztswcc,c0cztszcc,c0cztscww,c0czus
     & wcc,c0czuszcc,c0czuscww,c0ccqswcw,c0ccqscwc,c0ccqsczc
      complex*16 d0zchctsusccww,d0zchctsuscczz,d0cchzqsuswcww,d0cczhqst
     & swcww
      real*8 sdet3ichts,sdet3ichus,sdet4izhtsus,sdet3iczus,sdet3iczts
      complex*16 propzqs,propizqs,propzqsc

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      cmz2 = rzm2

      if (irun.eq.0) then
         propizqs = (cmz2+qs)
      else
         propizqs = (dcmplx(mz**2,+qs*wz/mz)+qs)
      endif
      propzqs = 1d0/propizqs
      propzqsc = dconjg(propzqs)
      det3izhqs = 1d0/(-1d0/4d0*((-rzm2)**2+(-rhm2)**2+(qs)**2
     & -2d0*(-rzm2)*(-rhm2)-2d0*(-rzm2)*(qs)
     & -2d0*(-rhm2)*(qs)))
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      b0phww = b0p(-rhm2,wm2,wm2)
      b0phzz = b0p(-rhm2,zm2,zm2)
      b0phhh = b0p(-rhm2,hm2,hm2)
      b0pzww = b0p(-rzm2,wm2,wm2)
      b0pzzh = b0p(-rzm2,zm2,hm2)
      b0pccz = b0p(0d0,cm2,zm2)
      b0fqsww = b0f(qs,thmu2,wm2,wm2)
      b0fqszh = b0f(qs,thmu2,zm2,hm2)
      b0fhww = b0f(-rhm2,thmu2,wm2,wm2)
      b0fhzz = b0f(-rhm2,thmu2,zm2,zm2)
      b0fhhh = b0f(-rhm2,thmu2,hm2,hm2)
      b0fhmomo = b0f(-rhm2,thmu2,mom2,mom2)
      b0fhchch = b0f(-rhm2,thmu2,chm2,chm2)
      b0fhstst = b0f(-rhm2,thmu2,stm2,stm2)
      b0fhtata = b0f(-rhm2,thmu2,tam2,tam2)
      b0fhtptp = b0f(-rhm2,thmu2,tpm2,tpm2)
      b0fhbtbt = b0f(-rhm2,thmu2,btm2,btm2)
      b0fzww = b0f(-rzm2,thmu2,wm2,wm2)
      b0fzzh = b0f(-rzm2,thmu2,zm2,hm2)
      b0fzmomo = b0f(-rzm2,thmu2,mom2,mom2)
      b0fzchch = b0f(-rzm2,thmu2,chm2,chm2)
      b0fzstst = b0f(-rzm2,thmu2,stm2,stm2)
      b0fztata = b0f(-rzm2,thmu2,tam2,tam2)
      b0fztptp = b0f(-rzm2,thmu2,tpm2,tpm2)
      b0fzbtbt = b0f(-rzm2,thmu2,btm2,btm2)
      b0fqsmomo = b0f(qs,thmu2,mom2,mom2)
      b0fqschch = b0f(qs,thmu2,chm2,chm2)
      b0fqsstst = b0f(qs,thmu2,stm2,stm2)
      b0fqstata = b0f(qs,thmu2,tam2,tam2)
      b0fqstptp = b0f(qs,thmu2,tpm2,tpm2)
      b0fqsbtbt = b0f(qs,thmu2,btm2,btm2)
      b0ftswc = b0f(ts,thmu2,wm2,cm2)
      b0ftszc = b0f(ts,thmu2,zm2,cm2)
      b0fuswc = b0f(us,thmu2,wm2,cm2)
      b0fuszc = b0f(us,thmu2,zm2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      b0fzcc = b0f(-rzm2,thmu2,cm2,cm2)
      c0zhqswww = -c0(rzm2,rhm2,-qs,rwm2,rwm2,rwm2)
      c0zhqszhh = -c0(rzm2,rhm2,-qs,rzm2,rhm2,rhm2)
      c0zhqshzz = -c0(rzm2,rhm2,-qs,rhm2,rzm2,rzm2)
      c0zhqsmomomo = -c0(rzm2,rhm2,-qs,rmom2,rmom2,rmom2)
      c0zhqschchch = -c0(rzm2,rhm2,-qs,rchm2,rchm2,rchm2)
      c0zhqsststst = -c0(rzm2,rhm2,-qs,rstm2,rstm2,rstm2)
      c0zhqstatata = -c0(rzm2,rhm2,-qs,rtam2,rtam2,rtam2)
      c0zhqstptptp = -c0(rzm2,rhm2,-qs,rtpm2,rtpm2,rtpm2)
      c0zhqsbtbtbt = -c0(rzm2,rhm2,-qs,rbtm2,rbtm2,rbtm2)
      c0chtscww = -c0(0d0,rhm2,-ts,0d0,rwm2,rwm2)
      c0chtsczz = -c0(0d0,rhm2,-ts,0d0,rzm2,rzm2)
      c0chuscww = -c0(0d0,rhm2,-us,0d0,rwm2,rwm2)
      c0chusczz = -c0(0d0,rhm2,-us,0d0,rzm2,rzm2)
      c0cztswcc = -c0(0d0,rzm2,-ts,rwm2,0d0,0d0)
      c0cztszcc = -c0(0d0,rzm2,-ts,rzm2,0d0,0d0)
      c0cztscww = -c0(0d0,rzm2,-ts,0d0,rwm2,rwm2)
      c0czuswcc = -c0(0d0,rzm2,-us,rwm2,0d0,0d0)
      c0czuszcc = -c0(0d0,rzm2,-us,rzm2,0d0,0d0)
      c0czuscww = -c0(0d0,rzm2,-us,0d0,rwm2,rwm2)
      c0ccqswcw = -c0(0d0,0d0,-qs,rwm2,0d0,rwm2)
      c0ccqscwc = -c0(0d0,0d0,-qs,0d0,rwm2,0d0)
      c0ccqsczc = -c0(0d0,0d0,-qs,0d0,rzm2,0d0)
      d0zchctsusccww =
     & d0(rzm2,0d0,rhm2,0d0,-ts,-us,0d0,0d0,rwm2,rwm2)
      d0zchctsuscczz =
     & d0(rzm2,0d0,rhm2,0d0,-ts,-us,0d0,0d0,rzm2,rzm2)
      d0cchzqsuswcww =
     & d0(0d0,0d0,rhm2,rzm2,-qs,-us,rwm2,0d0,rwm2,rwm2)
      d0cczhqstswcww =
     & d0(0d0,0d0,rzm2,rhm2,-qs,-ts,rwm2,0d0,rwm2,rwm2)
      sdet3ichts = 1d0/(ts+(mh)**2)
      sdet3ichus = 1d0/(us+(mh)**2)
      sdet4izhtsus = 1d0/(ts*us-rzm2*rhm2)
      sdet3iczus = 1d0/(us+(mz)**2)
      sdet3iczts = 1d0/(ts+(mz)**2)

      ffgp0=
     & +1d0/vpaup*(1d0/9+1d0/stw**2*deltarhofer+1d0/stw**2*deltarhobos-1
     & d0/stw*ctw*zmsqrfer+caldzfer-zz1fer-deltarhofer-deltarhobos+10d0/
     & 3*ctw**2+4*ctw**4)
     & +1d0/vpaup*vpadn*(-1)
     & +cfq*(-1d0/2/ctw**2*vmabt**2/mz**2*mbt**2-1d0/2/ctw**2*vpabt**2/m
     & z**2*mbt**2-1d0/2/ctw**2*vmatp**2/mz**2*mtp**2-1d0/2/ctw**2*vpatp
     & **2/mz**2*mtp**2-1d0/2/ctw**2*vmast**2/mz**2*mst**2-1d0/2/ctw**2*
     & vpast**2/mz**2*mst**2-1d0/2/ctw**2*vmach**2/mz**2*mch**2-1d0/2/ct
     & w**2*vpach**2/mz**2*mch**2)
     & +cfl*(-1d0/2/ctw**2*vmata**2/mz**2*mta**2-1d0/2/ctw**2*vpata**2/m
     & z**2*mta**2-1d0/2/ctw**2*vmamo**2/mz**2*mmo**2-1d0/2/ctw**2*vpamo
     & **2/mz**2*mmo**2)
     & +vmaup**2*(-1d0/8/ctw**2)
     & +vpaup**2*(-1d0/4/ctw**2)
     & +qup/vpaup*(2*pizgfer-2*caldzfer+2*zz1fer-2*ctw**2*pizgfer+2*ctw*
     & *2*caldzfer-2*ctw**2*zz1fer+2*stw*ctw*zmsqrfer)
     & +propzqs/vpaup*(-1d0/6/ctw**2*mh**2-1d0/18/ctw**2*mz**2+1d0/ctw**
     & 2*mz**4/mh**2-5d0/9*mz**2-mz**2*zmzzzbos-8d0/3*ctw**2*mz**2+2*ctw
     & **2*mz**4/mh**2-4*ctw**4*mz**2)
     & +propzqs*qup/vpaup*(1d0/3/ctw**2*mh**2+1d0/9/ctw**2*mz**2-2/ctw**
     & 2*mz**4/mh**2-1d0/3*mh**2+mz**2+2*mz**2*zmzzzbos+2*mz**4/mh**2+38
     & d0/9*ctw**2*mz**2-2*ctw**2*mz**2*zmzzzbos-4*ctw**2*mz**4/mh**2+8d
     & 0/3*ctw**4*mz**2+4*ctw**4*mz**4/mh**2-8*ctw**6*mz**2)
     & +propzqs*a0fw/vpaup*(1d0/6*mz**2-8d0/3*ctw**2*mz**2+3*ctw**2*mz**
     & 4/mh**2-4*ctw**4*mz**2)
     & +propzqs*a0fw*qup/vpaup*(-1d0/3*mz**2+17d0/3*ctw**2*mz**2-6*ctw**
     & 2*mz**4/mh**2+8d0/3*ctw**4*mz**2+6*ctw**4*mz**4/mh**2-8*ctw**6*mz
     & **2)
     & +propzqs*a0fz/vpaup*(-1d0/12/ctw**2*mh**2+1d0/6/ctw**2*mz**2+3d0/
     & 2/ctw**2*mz**4/mh**2)
     & +propzqs*a0fz*qup/vpaup*(1d0/6/ctw**2*mh**2-1d0/3/ctw**2*mz**2-3/
     & ctw**2*mz**4/mh**2-1d0/6*mh**2+1d0/3*mz**2+3*mz**4/mh**2)
     & +propzqs*a0fh/vpaup*(1d0/12/ctw**2/mz**2*mh**4+1d0/2/ctw**2*mh**2
     & )
     & +propzqs*a0fh*qup/vpaup*(-1d0/6/ctw**2/mz**2*mh**4-1d0/ctw**2*mh*
     & *2+1d0/6/mz**2*mh**4+mh**2)
     & +propzqs*b0fqsww/vpaup*(1d0/12/ctw**2*mz**2+4d0/3*mz**2-17d0/3*ct
     & w**2*mz**2-4*ctw**4*mz**2)
     & +propzqs*b0fqsww*qup/vpaup*(-1d0/6/ctw**2*mz**2-5d0/2*mz**2+14*ct
     & w**2*mz**2-10d0/3*ctw**4*mz**2-8*ctw**6*mz**2)
     & +propzqs*b0fqszh/vpaup*(1d0/12/ctw**2/mz**2*mh**4-1d0/3/ctw**2*mh
     & **2+1d0/ctw**2*mz**2)
     & +propzqs*b0fqszh*qup/vpaup*(-1d0/6/ctw**2/mz**2*mh**4+2d0/3/ctw**
     & 2*mh**2-2/ctw**2*mz**2+1d0/6/mz**2*mh**4-2d0/3*mh**2+2*mz**2)
     & +propizqs*qup/vpaup/qs*(-1d0/mz**2*mh**2+3*ctw**2/mz**2*mh**2-2d0
     & /3*ctw**2-2*ctw**4/mz**2*mh**2+14d0/3*ctw**4-4*ctw**6)
     & +propizqs*qup/vpaup*cfq/qs*(-2*qbt*vmabt/mz**2*mbt**2-2*qbt*vpabt
     & /mz**2*mbt**2-2*qtp*vmatp/mz**2*mtp**2-2*qtp*vpatp/mz**2*mtp**2-2
     & *qst*vmast/mz**2*mst**2-2*qst*vpast/mz**2*mst**2-2*qch*vmach/mz**
     & 2*mch**2-2*qch*vpach/mz**2*mch**2+2*ctw**2*qbt*vmabt/mz**2*mbt**2
     & +2*ctw**2*qbt*vpabt/mz**2*mbt**2+2*ctw**2*qtp*vmatp/mz**2*mtp**2+
     & 2*ctw**2*qtp*vpatp/mz**2*mtp**2+2*ctw**2*qst*vmast/mz**2*mst**2+2
     & *ctw**2*qst*vpast/mz**2*mst**2+2*ctw**2*qch*vmach/mz**2*mch**2+2*
     & ctw**2*qch*vpach/mz**2*mch**2)
     & +propizqs*qup/vpaup*cfl/qs*(-2*qta*vmata/mz**2*mta**2-2*qta*vpata
     & /mz**2*mta**2-2*qmo*vmamo/mz**2*mmo**2-2*qmo*vpamo/mz**2*mmo**2+2
     & *ctw**2*qta*vmata/mz**2*mta**2+2*ctw**2*qta*vpata/mz**2*mta**2+2*
     & ctw**2*qmo*vmamo/mz**2*mmo**2+2*ctw**2*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqswww*qs*(-1d0/8/ctw**2*mz**2+1d0/2*mz**2
     & -1d0/2*ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*qup/vpaup*(1d0/2*mh**4-3d0/2*ctw**2
     & *mh**4+ctw**2*mz**2*mh**2+ctw**4*mh**4-7*ctw**4*mz**2*mh**2+6*ctw
     & **6*mz**2*mh**2)
     & +propizqs*det3izhqs*c0zhqswww*(-1d0/8/ctw**2*mh**4-1d0/4/ctw**2*m
     & z**2*mh**2-1d0/8/ctw**2*mz**4+1d0/2*mh**4+3d0/4*mz**2*mh**2+1d0/2
     & *mz**4-1d0/2*ctw**2*mh**4-1d0/2*ctw**2*mz**4-3*ctw**4*mz**2*mh**2
     & )
     & +propizqs*det3izhqs*c0zhqszhh*qs*(-3d0/16/ctw**2*mh**2-3d0/4/ctw*
     & *2*mz**2)
     & +propizqs*det3izhqs*c0zhqszhh*(-3d0/16/ctw**2/mz**2*mh**6-3d0/8/c
     & tw**2*mh**4-27d0/16/ctw**2*mz**2*mh**2-3d0/4/ctw**2*mz**4)
     & +propizqs*det3izhqs*c0zhqshzz*qs*(-1d0/8/ctw**2/mz**2*mh**4-7d0/1
     & 6/ctw**2*mh**2-11d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqshzz*(-3d0/16/ctw**2/mz**2*mh**6-1d0/ctw
     & **2*mh**4-55d0/16/ctw**2*mz**2*mh**2-11d0/8/ctw**2*mz**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*cfl*(1d0/4/ctw**2*vmamo**2*mh**2
     & *mmo**2+1d0/4/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup/vpaup*cfl*(qmo*vmamo*mh**2*m
     & mo**2+qmo*vpamo*mh**2*mmo**2-ctw**2*qmo*vmamo*mh**2*mmo**2-ctw**2
     & *qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqschchch*cfq*(1d0/4/ctw**2*vmach**2*mh**2
     & *mch**2+1d0/4/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*qup/vpaup*cfq*(qch*vmach*mh**2*m
     & ch**2+qch*vpach*mh**2*mch**2-ctw**2*qch*vmach*mh**2*mch**2-ctw**2
     & *qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs*c0zhqsststst*cfq*(1d0/4/ctw**2*vmast**2*mh**2
     & *mst**2+1d0/4/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*qup/vpaup*cfq*(qst*vmast*mh**2*m
     & st**2+qst*vpast*mh**2*mst**2-ctw**2*qst*vmast*mh**2*mst**2-ctw**2
     & *qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs*c0zhqstatata*cfl*(1d0/4/ctw**2*vmata**2*mh**2
     & *mta**2+1d0/4/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*qup/vpaup*cfl*(qta*vmata*mh**2*m
     & ta**2+qta*vpata*mh**2*mta**2-ctw**2*qta*vmata*mh**2*mta**2-ctw**2
     & *qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*cfq*(1d0/4/ctw**2*vmatp**2*mh**2
     & *mtp**2+1d0/4/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qup/vpaup*cfq*(qtp*vmatp*mh**2*m
     & tp**2+qtp*vpatp*mh**2*mtp**2-ctw**2*qtp*vmatp*mh**2*mtp**2-ctw**2
     & *qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*cfq*(1d0/4/ctw**2*vmabt**2*mh**2
     & *mbt**2+1d0/4/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup/vpaup*cfq*(qbt*vmabt*mh**2*m
     & bt**2+qbt*vpabt*mh**2*mbt**2-ctw**2*qbt*vmabt*mh**2*mbt**2-ctw**2
     & *qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fhww*qs*(-3d0/8+1d0/16/ctw**2/mz**2*mh**2+1
     & d0/8/ctw**2-1d0/4/mz**2*mh**2+1d0/4*ctw**2/mz**2*mh**2+3d0/2*ctw*
     & *4)
     & +propizqs*det3izhqs*b0fhww*qup/vpaup/qs*(1d0/4*mz**2*mh**2-1d0/4*
     & mz**4-1d0/4*ctw**2*mz**2*mh**2+1d0/4*ctw**2*mz**4-3*ctw**4*mz**2*
     & mh**2+3*ctw**4*mz**4+3*ctw**6*mz**2*mh**2-3*ctw**6*mz**4)
     & +propizqs*det3izhqs*b0fhww*qup/vpaup*(-1d0/4/mz**2*mh**4-mh**2-1d
     & 0/2*mz**2+3d0/4*ctw**2/mz**2*mh**4+5d0/2*ctw**2*mh**2+1d0/2*ctw**
     & 2*mz**2-1d0/2*ctw**4/mz**2*mh**4+3d0/2*ctw**4*mh**2+6*ctw**4*mz**
     & 2-3*ctw**6*mh**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qup/vpaup*qs*(-1d0/4-1d0/4/mz**2*mh**2
     & +3d0/4*ctw**2/mz**2*mh**2+1d0/4*ctw**2-1d0/2*ctw**4/mz**2*mh**2+3
     & *ctw**4-3*ctw**6)
     & +propizqs*det3izhqs*b0fhww*(1d0/16/ctw**2/mz**2*mh**4+5d0/16/ctw*
     & *2*mh**2+1d0/8/ctw**2*mz**2-1d0/4/mz**2*mh**4-9d0/8*mh**2-3d0/8*m
     & z**2+1d0/4*ctw**2/mz**2*mh**4+3d0/4*ctw**2*mh**2+3d0/2*ctw**4*mh*
     & *2+3d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs*b0fhzz*qs*(3d0/32/ctw**2/mz**2*mh**2+7d0/16/c
     & tw**2)
     & +propizqs*det3izhqs*b0fhzz*(5d0/32/ctw**2/mz**2*mh**4+29d0/32/ctw
     & **2*mh**2+7d0/16/ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fhhh*qs*(-3d0/32/ctw**2/mz**2*mh**2-3d0/8/c
     & tw**2)
     & +propizqs*det3izhqs*b0fhhh*(-9d0/32/ctw**2/mz**2*mh**4-27d0/32/ct
     & w**2*mh**2-3d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh
     & **2*mmo**2-1d0/8/ctw**2*vmamo**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz*
     & *2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl*qs*(-1d0/8/ctw**2*vmamo**2/mz**2
     & *mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup/vpaup*cfl/qs*(1d0/2*qmo*vmamo*mh
     & **2*mmo**2-1d0/2*qmo*vmamo*mz**2*mmo**2+1d0/2*qmo*vpamo*mh**2*mmo
     & **2-1d0/2*qmo*vpamo*mz**2*mmo**2-1d0/2*ctw**2*qmo*vmamo*mh**2*mmo
     & **2+1d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2-1d0/2*ctw**2*qmo*vpamo*mh
     & **2*mmo**2+1d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup/vpaup*cfl*(-1d0/2*qmo*vmamo/mz**
     & 2*mh**2*mmo**2-qmo*vmamo*mmo**2-1d0/2*qmo*vpamo/mz**2*mh**2*mmo**
     & 2-qmo*vpamo*mmo**2+1d0/2*ctw**2*qmo*vmamo/mz**2*mh**2*mmo**2+ctw*
     & *2*qmo*vmamo*mmo**2+1d0/2*ctw**2*qmo*vpamo/mz**2*mh**2*mmo**2+ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup/vpaup*cfl*qs*(-1d0/2*qmo*vmamo/m
     & z**2*mmo**2-1d0/2*qmo*vpamo/mz**2*mmo**2+1d0/2*ctw**2*qmo*vmamo/m
     & z**2*mmo**2+1d0/2*ctw**2*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh
     & **2*mch**2-1d0/8/ctw**2*vmach**2*mch**2-1d0/8/ctw**2*vpach**2/mz*
     & *2*mh**2*mch**2-1d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*cfq*qs*(-1d0/8/ctw**2*vmach**2/mz**2
     & *mch**2-1d0/8/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup/vpaup*cfq/qs*(1d0/2*qch*vmach*mh
     & **2*mch**2-1d0/2*qch*vmach*mz**2*mch**2+1d0/2*qch*vpach*mh**2*mch
     & **2-1d0/2*qch*vpach*mz**2*mch**2-1d0/2*ctw**2*qch*vmach*mh**2*mch
     & **2+1d0/2*ctw**2*qch*vmach*mz**2*mch**2-1d0/2*ctw**2*qch*vpach*mh
     & **2*mch**2+1d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup/vpaup*cfq*(-1d0/2*qch*vmach/mz**
     & 2*mh**2*mch**2-qch*vmach*mch**2-1d0/2*qch*vpach/mz**2*mh**2*mch**
     & 2-qch*vpach*mch**2+1d0/2*ctw**2*qch*vmach/mz**2*mh**2*mch**2+ctw*
     & *2*qch*vmach*mch**2+1d0/2*ctw**2*qch*vpach/mz**2*mh**2*mch**2+ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup/vpaup*cfq*qs*(-1d0/2*qch*vmach/m
     & z**2*mch**2-1d0/2*qch*vpach/mz**2*mch**2+1d0/2*ctw**2*qch*vmach/m
     & z**2*mch**2+1d0/2*ctw**2*qch*vpach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh
     & **2*mst**2-1d0/8/ctw**2*vmast**2*mst**2-1d0/8/ctw**2*vpast**2/mz*
     & *2*mh**2*mst**2-1d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*cfq*qs*(-1d0/8/ctw**2*vmast**2/mz**2
     & *mst**2-1d0/8/ctw**2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup/vpaup*cfq/qs*(1d0/2*qst*vmast*mh
     & **2*mst**2-1d0/2*qst*vmast*mz**2*mst**2+1d0/2*qst*vpast*mh**2*mst
     & **2-1d0/2*qst*vpast*mz**2*mst**2-1d0/2*ctw**2*qst*vmast*mh**2*mst
     & **2+1d0/2*ctw**2*qst*vmast*mz**2*mst**2-1d0/2*ctw**2*qst*vpast*mh
     & **2*mst**2+1d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup/vpaup*cfq*(-1d0/2*qst*vmast/mz**
     & 2*mh**2*mst**2-qst*vmast*mst**2-1d0/2*qst*vpast/mz**2*mh**2*mst**
     & 2-qst*vpast*mst**2+1d0/2*ctw**2*qst*vmast/mz**2*mh**2*mst**2+ctw*
     & *2*qst*vmast*mst**2+1d0/2*ctw**2*qst*vpast/mz**2*mh**2*mst**2+ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup/vpaup*cfq*qs*(-1d0/2*qst*vmast/m
     & z**2*mst**2-1d0/2*qst*vpast/mz**2*mst**2+1d0/2*ctw**2*qst*vmast/m
     & z**2*mst**2+1d0/2*ctw**2*qst*vpast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh
     & **2*mta**2-1d0/8/ctw**2*vmata**2*mta**2-1d0/8/ctw**2*vpata**2/mz*
     & *2*mh**2*mta**2-1d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*cfl*qs*(-1d0/8/ctw**2*vmata**2/mz**2
     & *mta**2-1d0/8/ctw**2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup/vpaup*cfl/qs*(1d0/2*qta*vmata*mh
     & **2*mta**2-1d0/2*qta*vmata*mz**2*mta**2+1d0/2*qta*vpata*mh**2*mta
     & **2-1d0/2*qta*vpata*mz**2*mta**2-1d0/2*ctw**2*qta*vmata*mh**2*mta
     & **2+1d0/2*ctw**2*qta*vmata*mz**2*mta**2-1d0/2*ctw**2*qta*vpata*mh
     & **2*mta**2+1d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup/vpaup*cfl*(-1d0/2*qta*vmata/mz**
     & 2*mh**2*mta**2-qta*vmata*mta**2-1d0/2*qta*vpata/mz**2*mh**2*mta**
     & 2-qta*vpata*mta**2+1d0/2*ctw**2*qta*vmata/mz**2*mh**2*mta**2+ctw*
     & *2*qta*vmata*mta**2+1d0/2*ctw**2*qta*vpata/mz**2*mh**2*mta**2+ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup/vpaup*cfl*qs*(-1d0/2*qta*vmata/m
     & z**2*mta**2-1d0/2*qta*vpata/mz**2*mta**2+1d0/2*ctw**2*qta*vmata/m
     & z**2*mta**2+1d0/2*ctw**2*qta*vpata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh
     & **2*mtp**2-1d0/8/ctw**2*vmatp**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz*
     & *2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq*qs*(-1d0/8/ctw**2*vmatp**2/mz**2
     & *mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup/vpaup*cfq/qs*(1d0/2*qtp*vmatp*mh
     & **2*mtp**2-1d0/2*qtp*vmatp*mz**2*mtp**2+1d0/2*qtp*vpatp*mh**2*mtp
     & **2-1d0/2*qtp*vpatp*mz**2*mtp**2-1d0/2*ctw**2*qtp*vmatp*mh**2*mtp
     & **2+1d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2-1d0/2*ctw**2*qtp*vpatp*mh
     & **2*mtp**2+1d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup/vpaup*cfq*(-1d0/2*qtp*vmatp/mz**
     & 2*mh**2*mtp**2-qtp*vmatp*mtp**2-1d0/2*qtp*vpatp/mz**2*mh**2*mtp**
     & 2-qtp*vpatp*mtp**2+1d0/2*ctw**2*qtp*vmatp/mz**2*mh**2*mtp**2+ctw*
     & *2*qtp*vmatp*mtp**2+1d0/2*ctw**2*qtp*vpatp/mz**2*mh**2*mtp**2+ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup/vpaup*cfq*qs*(-1d0/2*qtp*vmatp/m
     & z**2*mtp**2-1d0/2*qtp*vpatp/mz**2*mtp**2+1d0/2*ctw**2*qtp*vmatp/m
     & z**2*mtp**2+1d0/2*ctw**2*qtp*vpatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh
     & **2*mbt**2-1d0/8/ctw**2*vmabt**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz*
     & *2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq*qs*(-1d0/8/ctw**2*vmabt**2/mz**2
     & *mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup/vpaup*cfq/qs*(1d0/2*qbt*vmabt*mh
     & **2*mbt**2-1d0/2*qbt*vmabt*mz**2*mbt**2+1d0/2*qbt*vpabt*mh**2*mbt
     & **2-1d0/2*qbt*vpabt*mz**2*mbt**2-1d0/2*ctw**2*qbt*vmabt*mh**2*mbt
     & **2+1d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2-1d0/2*ctw**2*qbt*vpabt*mh
     & **2*mbt**2+1d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup/vpaup*cfq*(-1d0/2*qbt*vmabt/mz**
     & 2*mh**2*mbt**2-qbt*vmabt*mbt**2-1d0/2*qbt*vpabt/mz**2*mh**2*mbt**
     & 2-qbt*vpabt*mbt**2+1d0/2*ctw**2*qbt*vmabt/mz**2*mh**2*mbt**2+ctw*
     & *2*qbt*vmabt*mbt**2+1d0/2*ctw**2*qbt*vpabt/mz**2*mh**2*mbt**2+ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup/vpaup*cfq*qs*(-1d0/2*qbt*vmabt/m
     & z**2*mbt**2-1d0/2*qbt*vpabt/mz**2*mbt**2+1d0/2*ctw**2*qbt*vmabt/m
     & z**2*mbt**2+1d0/2*ctw**2*qbt*vpabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzww*qs*(1d0/4-1d0/16/ctw**2-1d0/4*ctw**2)
     & +propizqs*det3izhqs*b0fzww*qup/vpaup/qs*(-1d0/4*mz**2*mh**2+1d0/4
     & *mz**4+1d0/4*ctw**2*mz**2*mh**2-1d0/4*ctw**2*mz**4+3*ctw**4*mz**2
     & *mh**2-3*ctw**4*mz**4-3*ctw**6*mz**2*mh**2+3*ctw**6*mz**4)
     & +propizqs*det3izhqs*b0fzww*qup/vpaup*(3d0/4*mh**2+1d0/2*mz**2-9d0
     & /4*ctw**2*mh**2-ctw**2*mz**2+3d0/2*ctw**4*mh**2-5d0/2*ctw**4*mz**
     & 2+3*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fzww*qup/vpaup*qs*(1d0/4-3d0/4*ctw**2+1d0/2
     & *ctw**4)
     & +propizqs*det3izhqs*b0fzww*(-3d0/16/ctw**2*mh**2-1d0/16/ctw**2*mz
     & **2+3d0/4*mh**2+1d0/8*mz**2-3d0/4*ctw**2*mh**2+1d0/4*ctw**2*mz**2
     & -3d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs*b0fzzh*qs*(1d0/16/ctw**2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fzzh*(1d0/16/ctw**2/mz**2*mh**4+1d0/16/ctw*
     & *2*mh**2-1d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fzmomo*cfl*(1d0/8/ctw**2*vmamo**2*mmo**2+1d
     & 0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*qup/vpaup*cfl/qs*(-1d0/2*qmo*vmamo*m
     & h**2*mmo**2+1d0/2*qmo*vmamo*mz**2*mmo**2-1d0/2*qmo*vpamo*mh**2*mm
     & o**2+1d0/2*qmo*vpamo*mz**2*mmo**2+1d0/2*ctw**2*qmo*vmamo*mh**2*mm
     & o**2-1d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+1d0/2*ctw**2*qmo*vpamo*m
     & h**2*mmo**2-1d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*qup/vpaup*cfl*(1d0/2*qmo*vmamo*mmo**
     & 2+1d0/2*qmo*vpamo*mmo**2-1d0/2*ctw**2*qmo*vmamo*mmo**2-1d0/2*ctw*
     & *2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*cfq*(1d0/8/ctw**2*vmach**2*mch**2+1d
     & 0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*qup/vpaup*cfq/qs*(-1d0/2*qch*vmach*m
     & h**2*mch**2+1d0/2*qch*vmach*mz**2*mch**2-1d0/2*qch*vpach*mh**2*mc
     & h**2+1d0/2*qch*vpach*mz**2*mch**2+1d0/2*ctw**2*qch*vmach*mh**2*mc
     & h**2-1d0/2*ctw**2*qch*vmach*mz**2*mch**2+1d0/2*ctw**2*qch*vpach*m
     & h**2*mch**2-1d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*qup/vpaup*cfq*(1d0/2*qch*vmach*mch**
     & 2+1d0/2*qch*vpach*mch**2-1d0/2*ctw**2*qch*vmach*mch**2-1d0/2*ctw*
     & *2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fzstst*cfq*(1d0/8/ctw**2*vmast**2*mst**2+1d
     & 0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*qup/vpaup*cfq/qs*(-1d0/2*qst*vmast*m
     & h**2*mst**2+1d0/2*qst*vmast*mz**2*mst**2-1d0/2*qst*vpast*mh**2*ms
     & t**2+1d0/2*qst*vpast*mz**2*mst**2+1d0/2*ctw**2*qst*vmast*mh**2*ms
     & t**2-1d0/2*ctw**2*qst*vmast*mz**2*mst**2+1d0/2*ctw**2*qst*vpast*m
     & h**2*mst**2-1d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*qup/vpaup*cfq*(1d0/2*qst*vmast*mst**
     & 2+1d0/2*qst*vpast*mst**2-1d0/2*ctw**2*qst*vmast*mst**2-1d0/2*ctw*
     & *2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fztata*cfl*(1d0/8/ctw**2*vmata**2*mta**2+1d
     & 0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*qup/vpaup*cfl/qs*(-1d0/2*qta*vmata*m
     & h**2*mta**2+1d0/2*qta*vmata*mz**2*mta**2-1d0/2*qta*vpata*mh**2*mt
     & a**2+1d0/2*qta*vpata*mz**2*mta**2+1d0/2*ctw**2*qta*vmata*mh**2*mt
     & a**2-1d0/2*ctw**2*qta*vmata*mz**2*mta**2+1d0/2*ctw**2*qta*vpata*m
     & h**2*mta**2-1d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*qup/vpaup*cfl*(1d0/2*qta*vmata*mta**
     & 2+1d0/2*qta*vpata*mta**2-1d0/2*ctw**2*qta*vmata*mta**2-1d0/2*ctw*
     & *2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fztptp*cfq*(1d0/8/ctw**2*vmatp**2*mtp**2+1d
     & 0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*qup/vpaup*cfq/qs*(-1d0/2*qtp*vmatp*m
     & h**2*mtp**2+1d0/2*qtp*vmatp*mz**2*mtp**2-1d0/2*qtp*vpatp*mh**2*mt
     & p**2+1d0/2*qtp*vpatp*mz**2*mtp**2+1d0/2*ctw**2*qtp*vmatp*mh**2*mt
     & p**2-1d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+1d0/2*ctw**2*qtp*vpatp*m
     & h**2*mtp**2-1d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*qup/vpaup*cfq*(1d0/2*qtp*vmatp*mtp**
     & 2+1d0/2*qtp*vpatp*mtp**2-1d0/2*ctw**2*qtp*vmatp*mtp**2-1d0/2*ctw*
     & *2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*cfq*(1d0/8/ctw**2*vmabt**2*mbt**2+1d
     & 0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*qup/vpaup*cfq/qs*(-1d0/2*qbt*vmabt*m
     & h**2*mbt**2+1d0/2*qbt*vmabt*mz**2*mbt**2-1d0/2*qbt*vpabt*mh**2*mb
     & t**2+1d0/2*qbt*vpabt*mz**2*mbt**2+1d0/2*ctw**2*qbt*vmabt*mh**2*mb
     & t**2-1d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+1d0/2*ctw**2*qbt*vpabt*m
     & h**2*mbt**2-1d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*qup/vpaup*cfq*(1d0/2*qbt*vmabt*mbt**
     & 2+1d0/2*qbt*vpabt*mbt**2-1d0/2*ctw**2*qbt*vmabt*mbt**2-1d0/2*ctw*
     & *2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*qs*(1d0/8-1d0/16/ctw**2/mz**2*mh**2-1
     & d0/16/ctw**2+1d0/4/mz**2*mh**2-1d0/4*ctw**2/mz**2*mh**2+1d0/4*ctw
     & **2-3d0/2*ctw**4)
     & +propizqs*det3izhqs*b0fqsww*qup/vpaup*(1d0/4/mz**2*mh**4+1d0/4*mh
     & **2-3d0/4*ctw**2/mz**2*mh**4-1d0/4*ctw**2*mh**2+1d0/2*ctw**2*mz**
     & 2+1d0/2*ctw**4/mz**2*mh**4-3*ctw**4*mh**2-7d0/2*ctw**4*mz**2+3*ct
     & w**6*mh**2+3*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fqsww*qup/vpaup*qs*(1d0/4/mz**2*mh**2-3d0/4
     & *ctw**2/mz**2*mh**2+1d0/2*ctw**2+1d0/2*ctw**4/mz**2*mh**2-7d0/2*c
     & tw**4+3*ctw**6)
     & +propizqs*det3izhqs*b0fqsww*(-1d0/16/ctw**2/mz**2*mh**4-1d0/8/ctw
     & **2*mh**2-1d0/16/ctw**2*mz**2+1d0/4/mz**2*mh**4+3d0/8*mh**2+1d0/4
     & *mz**2-1d0/4*ctw**2/mz**2*mh**4-1d0/4*ctw**2*mz**2-3d0/2*ctw**4*m
     & h**2)
     & +propizqs*det3izhqs*b0fqszh*qs*(-1d0/16/ctw**2/mz**2*mh**2-1d0/16
     & /ctw**2)
     & +propizqs*det3izhqs*b0fqszh*(1d0/16/ctw**2/mz**2*mh**4-1d0/8/ctw*
     & *2*mh**2+1d0/16/ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fqsmomo*cfl*(1d0/8/ctw**2*vmamo**2/mz**2*mh
     & **2*mmo**2+1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*cfl*qs*(1d0/8/ctw**2*vmamo**2/mz**2
     & *mmo**2+1d0/8/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*qup/vpaup*cfl*(1d0/2*qmo*vmamo/mz**
     & 2*mh**2*mmo**2+1d0/2*qmo*vmamo*mmo**2+1d0/2*qmo*vpamo/mz**2*mh**2
     & *mmo**2+1d0/2*qmo*vpamo*mmo**2-1d0/2*ctw**2*qmo*vmamo/mz**2*mh**2
     & *mmo**2-1d0/2*ctw**2*qmo*vmamo*mmo**2-1d0/2*ctw**2*qmo*vpamo/mz**
     & 2*mh**2*mmo**2-1d0/2*ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*qup/vpaup*cfl*qs*(1d0/2*qmo*vmamo/m
     & z**2*mmo**2+1d0/2*qmo*vpamo/mz**2*mmo**2-1d0/2*ctw**2*qmo*vmamo/m
     & z**2*mmo**2-1d0/2*ctw**2*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*cfq*(1d0/8/ctw**2*vmach**2/mz**2*mh
     & **2*mch**2+1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*cfq*qs*(1d0/8/ctw**2*vmach**2/mz**2
     & *mch**2+1d0/8/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*qup/vpaup*cfq*(1d0/2*qch*vmach/mz**
     & 2*mh**2*mch**2+1d0/2*qch*vmach*mch**2+1d0/2*qch*vpach/mz**2*mh**2
     & *mch**2+1d0/2*qch*vpach*mch**2-1d0/2*ctw**2*qch*vmach/mz**2*mh**2
     & *mch**2-1d0/2*ctw**2*qch*vmach*mch**2-1d0/2*ctw**2*qch*vpach/mz**
     & 2*mh**2*mch**2-1d0/2*ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fqschch*qup/vpaup*cfq*qs*(1d0/2*qch*vmach/m
     & z**2*mch**2+1d0/2*qch*vpach/mz**2*mch**2-1d0/2*ctw**2*qch*vmach/m
     & z**2*mch**2-1d0/2*ctw**2*qch*vpach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*cfq*(1d0/8/ctw**2*vmast**2/mz**2*mh
     & **2*mst**2+1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*cfq*qs*(1d0/8/ctw**2*vmast**2/mz**2
     & *mst**2+1d0/8/ctw**2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*qup/vpaup*cfq*(1d0/2*qst*vmast/mz**
     & 2*mh**2*mst**2+1d0/2*qst*vmast*mst**2+1d0/2*qst*vpast/mz**2*mh**2
     & *mst**2+1d0/2*qst*vpast*mst**2-1d0/2*ctw**2*qst*vmast/mz**2*mh**2
     & *mst**2-1d0/2*ctw**2*qst*vmast*mst**2-1d0/2*ctw**2*qst*vpast/mz**
     & 2*mh**2*mst**2-1d0/2*ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*qup/vpaup*cfq*qs*(1d0/2*qst*vmast/m
     & z**2*mst**2+1d0/2*qst*vpast/mz**2*mst**2-1d0/2*ctw**2*qst*vmast/m
     & z**2*mst**2-1d0/2*ctw**2*qst*vpast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*cfl*(1d0/8/ctw**2*vmata**2/mz**2*mh
     & **2*mta**2+1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*cfl*qs*(1d0/8/ctw**2*vmata**2/mz**2
     & *mta**2+1d0/8/ctw**2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*qup/vpaup*cfl*(1d0/2*qta*vmata/mz**
     & 2*mh**2*mta**2+1d0/2*qta*vmata*mta**2+1d0/2*qta*vpata/mz**2*mh**2
     & *mta**2+1d0/2*qta*vpata*mta**2-1d0/2*ctw**2*qta*vmata/mz**2*mh**2
     & *mta**2-1d0/2*ctw**2*qta*vmata*mta**2-1d0/2*ctw**2*qta*vpata/mz**
     & 2*mh**2*mta**2-1d0/2*ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fqstata*qup/vpaup*cfl*qs*(1d0/2*qta*vmata/m
     & z**2*mta**2+1d0/2*qta*vpata/mz**2*mta**2-1d0/2*ctw**2*qta*vmata/m
     & z**2*mta**2-1d0/2*ctw**2*qta*vpata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*cfq*(1d0/8/ctw**2*vmatp**2/mz**2*mh
     & **2*mtp**2+1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*cfq*qs*(1d0/8/ctw**2*vmatp**2/mz**2
     & *mtp**2+1d0/8/ctw**2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*qup/vpaup*cfq*(1d0/2*qtp*vmatp/mz**
     & 2*mh**2*mtp**2+1d0/2*qtp*vmatp*mtp**2+1d0/2*qtp*vpatp/mz**2*mh**2
     & *mtp**2+1d0/2*qtp*vpatp*mtp**2-1d0/2*ctw**2*qtp*vmatp/mz**2*mh**2
     & *mtp**2-1d0/2*ctw**2*qtp*vmatp*mtp**2-1d0/2*ctw**2*qtp*vpatp/mz**
     & 2*mh**2*mtp**2-1d0/2*ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*qup/vpaup*cfq*qs*(1d0/2*qtp*vmatp/m
     & z**2*mtp**2+1d0/2*qtp*vpatp/mz**2*mtp**2-1d0/2*ctw**2*qtp*vmatp/m
     & z**2*mtp**2-1d0/2*ctw**2*qtp*vpatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*cfq*(1d0/8/ctw**2*vmabt**2/mz**2*mh
     & **2*mbt**2+1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*cfq*qs*(1d0/8/ctw**2*vmabt**2/mz**2
     & *mbt**2+1d0/8/ctw**2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qup/vpaup*cfq*(1d0/2*qbt*vmabt/mz**
     & 2*mh**2*mbt**2+1d0/2*qbt*vmabt*mbt**2+1d0/2*qbt*vpabt/mz**2*mh**2
     & *mbt**2+1d0/2*qbt*vpabt*mbt**2-1d0/2*ctw**2*qbt*vmabt/mz**2*mh**2
     & *mbt**2-1d0/2*ctw**2*qbt*vmabt*mbt**2-1d0/2*ctw**2*qbt*vpabt/mz**
     & 2*mh**2*mbt**2-1d0/2*ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qup/vpaup*cfq*qs*(1d0/2*qbt*vmabt/m
     & z**2*mbt**2+1d0/2*qbt*vpabt/mz**2*mbt**2-1d0/2*ctw**2*qbt*vmabt/m
     & z**2*mbt**2-1d0/2*ctw**2*qbt*vpabt/mz**2*mbt**2)
     & +propizqs*sdet3ichts*c0chtscww*(-ctw**4*mz**2)
     & +propizqs*sdet3ichts*c0chtsczz*vpaup**2*(-1d0/2/ctw**2*mz**2)
     & +propizqs*sdet3ichts*b0fhww*(-ctw**2)
     & +propizqs*sdet3ichts*b0fhzz*vpaup**2*(-1d0/2/ctw**2)
     & +propizqs*sdet3ichts*b0ftswc*(ctw**2)
     & +propizqs*sdet3ichts*b0ftszc*vpaup**2*(1d0/2/ctw**2)
     & +propizqs*sdet3ichus*c0chuscww*(-ctw**4*mz**2)
     & +propizqs*sdet3ichus*c0chusczz*vpaup**2*(-1d0/2/ctw**2*mz**2)
     & +propizqs*sdet3ichus*b0fhww*(-ctw**2)
     & +propizqs*sdet3ichus*b0fhzz*vpaup**2*(-1d0/2/ctw**2)
     & +propizqs*sdet3ichus*b0fuswc*(ctw**2)
     & +propizqs*sdet3ichus*b0fuszc*vpaup**2*(1d0/2/ctw**2)
     & +propizqs*d0zchctsusccww/vpaup*vpadn/qs*(ctw**2*mz**2*mh**2+ctw**
     & 2*us*mh**2+ctw**2*us*mz**2+ctw**2*us**2+3d0/2*ctw**4*mz**2*mh**2-
     & 3d0/2*ctw**4*mz**4+2*sdet4izhtsus*ctw**6*mz**6*mh**2+1d0/2*sdet4i
     & zhtsus*ctw**6*us*mz**4*mh**2+1d0/2*sdet4izhtsus*ctw**6*us*mz**6+1
     & d0/2*sdet4izhtsus*ctw**6*ts*mz**4*mh**2+1d0/2*sdet4izhtsus*ctw**6
     & *ts*mz**6)
     & +propizqs*d0zchctsusccww/vpaup*vpadn*(ctw**2*mz**2+ctw**2*us+3d0/
     & 2*ctw**4*mz**2+1d0/2*sdet4izhtsus*ctw**6*us*mz**4+1d0/2*sdet4izht
     & sus*ctw**6*ts*mz**4)
     & +propizqs*d0zchctsuscczz*vpaup**2/qs*(5d0/4/ctw**2*mz**2*mh**2-3d
     & 0/4/ctw**2*mz**4+1d0/2/ctw**2*us*mh**2+1d0/2/ctw**2*us*mz**2+1d0/
     & 2/ctw**2*us**2+sdet4izhtsus/ctw**2*mz**6*mh**2+1d0/4*sdet4izhtsus
     & /ctw**2*us*mz**4*mh**2+1d0/4*sdet4izhtsus/ctw**2*us*mz**6+1d0/4*s
     & det4izhtsus/ctw**2*ts*mz**4*mh**2+1d0/4*sdet4izhtsus/ctw**2*ts*mz
     & **6)
     & +propizqs*d0zchctsuscczz*vpaup**2*(5d0/4/ctw**2*mz**2+1d0/2/ctw**
     & 2*us+1d0/4*sdet4izhtsus/ctw**2*us*mz**4+1d0/4*sdet4izhtsus/ctw**2
     & *ts*mz**4)
     & +propizqs*d0cchzqsuswcww/vpaup/qs*(1d0/2*ctw**4*mz**2*mh**2-1d0/2
     & *ctw**4*mz**4-2*ctw**6*mz**2*mh**2+2*ctw**6*mz**4+sdet4izhtsus*ct
     & w**8*mz**4*mh**4-2*sdet4izhtsus*ctw**8*mz**6*mh**2+sdet4izhtsus*c
     & tw**8*mz**8)
     & +propizqs*d0cchzqsuswcww/vpaup*(-1d0/2*ctw**2*us-1d0/2*ctw**4*mz*
     & *2-ctw**4*us-4*ctw**6*mz**2-sdet4izhtsus*ctw**4*us*mz**2*mh**2-sd
     & et4izhtsus*ctw**4*us**2*mh**2-sdet4izhtsus*ctw**4*us**2*mz**2-sde
     & t4izhtsus*ctw**4*us**3-2*sdet4izhtsus*ctw**6*mz**4*mh**2+2*sdet4i
     & zhtsus*ctw**6*us**2*mz**2+sdet4izhtsus*ctw**8*mz**4*mh**2+sdet4iz
     & htsus*ctw**8*mz**6-sdet4izhtsus*ctw**8*us*mz**4-sdet4izhtsus*ctw*
     & *8*ts*mz**4)
     & +propizqs*d0cczhqstswcww/vpaup/qs*(1d0/2*ctw**4*mz**2*mh**2-1d0/2
     & *ctw**4*mz**4-2*ctw**6*mz**2*mh**2+2*ctw**6*mz**4+sdet4izhtsus*ct
     & w**8*mz**4*mh**4-2*sdet4izhtsus*ctw**8*mz**6*mh**2+sdet4izhtsus*c
     & tw**8*mz**8)
     & +propizqs*d0cczhqstswcww/vpaup*(-1d0/2*ctw**2*ts-1d0/2*ctw**4*mz*
     & *2-ctw**4*ts-4*ctw**6*mz**2-sdet4izhtsus*ctw**4*ts*mz**2*mh**2-sd
     & et4izhtsus*ctw**4*ts**2*mh**2-sdet4izhtsus*ctw**4*ts**2*mz**2-sde
     & t4izhtsus*ctw**4*ts**3-2*sdet4izhtsus*ctw**6*mz**4*mh**2+2*sdet4i
     & zhtsus*ctw**6*ts**2*mz**2+sdet4izhtsus*ctw**8*mz**4*mh**2+sdet4iz
     & htsus*ctw**8*mz**6-sdet4izhtsus*ctw**8*us*mz**4-sdet4izhtsus*ctw*
     & *8*ts*mz**4)
     & +propizqs*c0zhqswww/vpaup/qs*(ctw**2*mh**2-ctw**2*mz**2-4*ctw**4*
     & mh**2+4*ctw**4*mz**2+2*sdet4izhtsus*ctw**6*mz**2*mh**4-4*sdet4izh
     & tsus*ctw**6*mz**4*mh**2+2*sdet4izhtsus*ctw**6*mz**6)
     & +propizqs*c0zhqswww/vpaup*(ctw**4-2*sdet4izhtsus*ctw**4*mz**2*mh*
     & *2+sdet4izhtsus*ctw**4*us**2+sdet4izhtsus*ctw**4*ts**2+2*sdet4izh
     & tsus*ctw**6*mz**2*mh**2+2*sdet4izhtsus*ctw**6*mz**4-2*sdet4izhtsu
     & s*ctw**6*us*mz**2-2*sdet4izhtsus*ctw**6*ts*mz**2)
     & +propizqs*c0zhqswww*qup/vpaup/qs*(-2*ctw**2*mh**2+4*ctw**2*mz**2+
     & 14*ctw**4*mh**2-16*ctw**4*mz**2-12*ctw**6*mh**2-12*ctw**6*mz**2+2
     & 4*ctw**8*mz**2)
     & +propizqs*c0zhqswww*qup/vpaup*(2*ctw**2+8*ctw**4-10*ctw**6)
     & +propizqs*c0zhqswww*(-ctw**2+5*ctw**4)
     & +propizqs*c0zhqsmomomo*cfl*(-1d0/4/ctw**2*vmamo**2/mz**2*mmo**2-1
     & d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*c0zhqsmomomo*qup/vpaup*cfl/qs*(4*qmo*vmamo/mz**2*mmo**4
     & -qmo*vmamo/mz**2*mh**2*mmo**2+qmo*vmamo*mmo**2+4*qmo*vpamo/mz**2*
     & mmo**4-qmo*vpamo/mz**2*mh**2*mmo**2+qmo*vpamo*mmo**2-4*ctw**2*qmo
     & *vmamo/mz**2*mmo**4+ctw**2*qmo*vmamo/mz**2*mh**2*mmo**2-ctw**2*qm
     & o*vmamo*mmo**2-4*ctw**2*qmo*vpamo/mz**2*mmo**4+ctw**2*qmo*vpamo/m
     & z**2*mh**2*mmo**2-ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*c0zhqsmomomo*qup/vpaup*cfl*(-qmo*vmamo/mz**2*mmo**2-qmo
     & *vpamo/mz**2*mmo**2+ctw**2*qmo*vmamo/mz**2*mmo**2+ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*cfq*(-1d0/4/ctw**2*vmach**2/mz**2*mch**2-1
     & d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*c0zhqschchch*qup/vpaup*cfq/qs*(4*qch*vmach/mz**2*mch**4
     & -qch*vmach/mz**2*mh**2*mch**2+qch*vmach*mch**2+4*qch*vpach/mz**2*
     & mch**4-qch*vpach/mz**2*mh**2*mch**2+qch*vpach*mch**2-4*ctw**2*qch
     & *vmach/mz**2*mch**4+ctw**2*qch*vmach/mz**2*mh**2*mch**2-ctw**2*qc
     & h*vmach*mch**2-4*ctw**2*qch*vpach/mz**2*mch**4+ctw**2*qch*vpach/m
     & z**2*mh**2*mch**2-ctw**2*qch*vpach*mch**2)
     & +propizqs*c0zhqschchch*qup/vpaup*cfq*(-qch*vmach/mz**2*mch**2-qch
     & *vpach/mz**2*mch**2+ctw**2*qch*vmach/mz**2*mch**2+ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*c0zhqsststst*cfq*(-1d0/4/ctw**2*vmast**2/mz**2*mst**2-1
     & d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +propizqs*c0zhqsststst*qup/vpaup*cfq/qs*(4*qst*vmast/mz**2*mst**4
     & -qst*vmast/mz**2*mh**2*mst**2+qst*vmast*mst**2+4*qst*vpast/mz**2*
     & mst**4-qst*vpast/mz**2*mh**2*mst**2+qst*vpast*mst**2-4*ctw**2*qst
     & *vmast/mz**2*mst**4+ctw**2*qst*vmast/mz**2*mh**2*mst**2-ctw**2*qs
     & t*vmast*mst**2-4*ctw**2*qst*vpast/mz**2*mst**4+ctw**2*qst*vpast/m
     & z**2*mh**2*mst**2-ctw**2*qst*vpast*mst**2)
     & +propizqs*c0zhqsststst*qup/vpaup*cfq*(-qst*vmast/mz**2*mst**2-qst
     & *vpast/mz**2*mst**2+ctw**2*qst*vmast/mz**2*mst**2+ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*c0zhqstatata*cfl*(-1d0/4/ctw**2*vmata**2/mz**2*mta**2-1
     & d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +propizqs*c0zhqstatata*qup/vpaup*cfl/qs*(4*qta*vmata/mz**2*mta**4
     & -qta*vmata/mz**2*mh**2*mta**2+qta*vmata*mta**2+4*qta*vpata/mz**2*
     & mta**4-qta*vpata/mz**2*mh**2*mta**2+qta*vpata*mta**2-4*ctw**2*qta
     & *vmata/mz**2*mta**4+ctw**2*qta*vmata/mz**2*mh**2*mta**2-ctw**2*qt
     & a*vmata*mta**2-4*ctw**2*qta*vpata/mz**2*mta**4+ctw**2*qta*vpata/m
     & z**2*mh**2*mta**2-ctw**2*qta*vpata*mta**2)
     & +propizqs*c0zhqstatata*qup/vpaup*cfl*(-qta*vmata/mz**2*mta**2-qta
     & *vpata/mz**2*mta**2+ctw**2*qta*vmata/mz**2*mta**2+ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*cfq*(-1d0/4/ctw**2*vmatp**2/mz**2*mtp**2-1
     & d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +propizqs*c0zhqstptptp*qup/vpaup*cfq/qs*(4*qtp*vmatp/mz**2*mtp**4
     & -qtp*vmatp/mz**2*mh**2*mtp**2+qtp*vmatp*mtp**2+4*qtp*vpatp/mz**2*
     & mtp**4-qtp*vpatp/mz**2*mh**2*mtp**2+qtp*vpatp*mtp**2-4*ctw**2*qtp
     & *vmatp/mz**2*mtp**4+ctw**2*qtp*vmatp/mz**2*mh**2*mtp**2-ctw**2*qt
     & p*vmatp*mtp**2-4*ctw**2*qtp*vpatp/mz**2*mtp**4+ctw**2*qtp*vpatp/m
     & z**2*mh**2*mtp**2-ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*c0zhqstptptp*qup/vpaup*cfq*(-qtp*vmatp/mz**2*mtp**2-qtp
     & *vpatp/mz**2*mtp**2+ctw**2*qtp*vmatp/mz**2*mtp**2+ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*cfq*(-1d0/4/ctw**2*vmabt**2/mz**2*mbt**2-1
     & d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +propizqs*c0zhqsbtbtbt*qup/vpaup*cfq/qs*(4*qbt*vmabt/mz**2*mbt**4
     & -qbt*vmabt/mz**2*mh**2*mbt**2+qbt*vmabt*mbt**2+4*qbt*vpabt/mz**2*
     & mbt**4-qbt*vpabt/mz**2*mh**2*mbt**2+qbt*vpabt*mbt**2-4*ctw**2*qbt
     & *vmabt/mz**2*mbt**4+ctw**2*qbt*vmabt/mz**2*mh**2*mbt**2-ctw**2*qb
     & t*vmabt*mbt**2-4*ctw**2*qbt*vpabt/mz**2*mbt**4+ctw**2*qbt*vpabt/m
     & z**2*mh**2*mbt**2-ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*c0zhqsbtbtbt*qup/vpaup*cfq*(-qbt*vmabt/mz**2*mbt**2-qbt
     & *vpabt/mz**2*mbt**2+ctw**2*qbt*vmabt/mz**2*mbt**2+ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*c0chtscww/vpaup/qs*(-1d0/2*ctw**2*mh**2-1d0/2*ctw**2*ts
     & +2*ctw**4*mh**2+2*ctw**4*ts-sdet4izhtsus*ctw**6*mz**2*mh**4+sdet4
     & izhtsus*ctw**6*mz**4*mh**2-sdet4izhtsus*ctw**6*ts*mz**2*mh**2+sde
     & t4izhtsus*ctw**6*ts*mz**4)
     & +propizqs*c0chtscww/vpaup*(2*ctw**4-sdet4izhtsus*ctw**4*ts*mh**2-
     & sdet4izhtsus*ctw**4*ts**2-sdet4izhtsus*ctw**6*mz**2*mh**2+sdet4iz
     & htsus*ctw**6*ts*mz**2)
     & +propizqs*c0chtscww/vpaup*vpadn/qs*(-ctw**2*mz**2-ctw**2*us+sdet4
     & izhtsus*ctw**4*mz**4*mh**2+1d0/2*sdet4izhtsus*ctw**4*us*mz**2*mh*
     & *2+1d0/2*sdet4izhtsus*ctw**4*ts*mz**4)
     & +propizqs*c0chtscww/vpaup*vpadn*(1d0/2*sdet4izhtsus*ctw**4*ts*mz*
     & *2)
     & +propizqs*c0chtsczz*vpaup**2/qs*(-1d0/2/ctw**2*mz**2-1d0/2/ctw**2
     & *us+1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2+1d0/4*sdet4izhtsus/ctw*
     & *2*us*mz**2*mh**2+1d0/4*sdet4izhtsus/ctw**2*ts*mz**4)
     & +propizqs*c0chtsczz*vpaup**2*(1d0/4*sdet4izhtsus/ctw**2*ts*mz**2)
     & +propizqs*c0chuscww/vpaup/qs*(-1d0/2*ctw**2*mh**2-1d0/2*ctw**2*us
     & +2*ctw**4*mh**2+2*ctw**4*us-sdet4izhtsus*ctw**6*mz**2*mh**4+sdet4
     & izhtsus*ctw**6*mz**4*mh**2-sdet4izhtsus*ctw**6*us*mz**2*mh**2+sde
     & t4izhtsus*ctw**6*us*mz**4)
     & +propizqs*c0chuscww/vpaup*(2*ctw**4-sdet4izhtsus*ctw**4*us*mh**2-
     & sdet4izhtsus*ctw**4*us**2-sdet4izhtsus*ctw**6*mz**2*mh**2+sdet4iz
     & htsus*ctw**6*us*mz**2)
     & +propizqs*c0chuscww/vpaup*vpadn/qs*(ctw**2*mh**2+ctw**2*us+sdet4i
     & zhtsus*ctw**4*mz**4*mh**2+1d0/2*sdet4izhtsus*ctw**4*us*mz**4+1d0/
     & 2*sdet4izhtsus*ctw**4*ts*mz**2*mh**2)
     & +propizqs*c0chuscww/vpaup*vpadn*(ctw**2+1d0/2*sdet4izhtsus*ctw**4
     & *us*mz**2)
     & +propizqs*c0chusczz*vpaup**2/qs*(1d0/2/ctw**2*mh**2+1d0/2/ctw**2*
     & us+1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2+1d0/4*sdet4izhtsus/ctw**
     & 2*us*mz**4+1d0/4*sdet4izhtsus/ctw**2*ts*mz**2*mh**2)
     & +propizqs*c0chusczz*vpaup**2*(1d0/2/ctw**2+1d0/4*sdet4izhtsus/ctw
     & **2*us*mz**2)
     & +propizqs*c0cztswcc/vpaup*vpadn/qs*(-ctw**2*mh**2-ctw**2*us-sdet4
     & izhtsus*ctw**4*mz**4*mh**2-1d0/2*sdet4izhtsus*ctw**4*us*mz**4-1d0
     & /2*sdet4izhtsus*ctw**4*ts*mz**2*mh**2)
     & +propizqs*c0cztswcc/vpaup*vpadn*(-ctw**2-1d0/2*sdet4izhtsus*ctw**
     & 4*ts*mz**2)
     & +propizqs*c0cztszcc*vpaup**2/qs*(-1d0/2/ctw**2*mh**2-1d0/2/ctw**2
     & *us-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2-1d0/4*sdet4izhtsus/ctw*
     & *2*us*mz**4-1d0/4*sdet4izhtsus/ctw**2*ts*mz**2*mh**2)
     & +propizqs*c0cztszcc*vpaup**2*(-1d0/2/ctw**2-1d0/4*sdet4izhtsus/ct
     & w**2*ts*mz**2)
     & +propizqs*c0cztscww/vpaup/qs*(1d0/2*ctw**2*mz**2+1d0/2*ctw**2*ts-
     & 2*ctw**4*mz**2-2*ctw**4*ts+sdet4izhtsus*ctw**6*mz**4*mh**2-sdet4i
     & zhtsus*ctw**6*mz**6+sdet4izhtsus*ctw**6*ts*mz**2*mh**2-sdet4izhts
     & us*ctw**6*ts*mz**4)
     & +propizqs*c0cztscww/vpaup*(-sdet4izhtsus*ctw**4*ts*mz**2-sdet4izh
     & tsus*ctw**4*ts**2-sdet4izhtsus*ctw**6*mz**4+sdet4izhtsus*ctw**6*t
     & s*mz**2)
     & +propizqs*c0czuswcc/vpaup*vpadn/qs*(ctw**2*mz**2+ctw**2*us-sdet4i
     & zhtsus*ctw**4*mz**4*mh**2-1d0/2*sdet4izhtsus*ctw**4*us*mz**2*mh**
     & 2-1d0/2*sdet4izhtsus*ctw**4*ts*mz**4)
     & +propizqs*c0czuswcc/vpaup*vpadn*(-1d0/2*sdet4izhtsus*ctw**4*us*mz
     & **2)
     & +propizqs*c0czuszcc*vpaup**2/qs*(1d0/2/ctw**2*mz**2+1d0/2/ctw**2*
     & us-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2-1d0/4*sdet4izhtsus/ctw**
     & 2*us*mz**2*mh**2-1d0/4*sdet4izhtsus/ctw**2*ts*mz**4)
     & +propizqs*c0czuszcc*vpaup**2*(-1d0/4*sdet4izhtsus/ctw**2*us*mz**2
     & )
     & +propizqs*c0czuscww/vpaup/qs*(1d0/2*ctw**2*mz**2+1d0/2*ctw**2*us-
     & 2*ctw**4*mz**2-2*ctw**4*us+sdet4izhtsus*ctw**6*mz**4*mh**2-sdet4i
     & zhtsus*ctw**6*mz**6+sdet4izhtsus*ctw**6*us*mz**2*mh**2-sdet4izhts
     & us*ctw**6*us*mz**4)
     & +propizqs*c0czuscww/vpaup*(-sdet4izhtsus*ctw**4*us*mz**2-sdet4izh
     & tsus*ctw**4*us**2-sdet4izhtsus*ctw**6*mz**4+sdet4izhtsus*ctw**6*u
     & s*mz**2)
     & +propizqs*c0ccqswcw/vpaup/qs*(2*ctw**6*mz**2)
     & +propizqs*c0ccqswcw/vpaup*(ctw**2+2*ctw**4+2*sdet4izhtsus*ctw**4*
     & mz**2*mh**2+sdet4izhtsus*ctw**4*us*mh**2+sdet4izhtsus*ctw**4*us*m
     & z**2+sdet4izhtsus*ctw**4*us**2+sdet4izhtsus*ctw**4*ts*mh**2+sdet4
     & izhtsus*ctw**4*ts*mz**2+sdet4izhtsus*ctw**4*ts**2)
     & +propizqs*c0ccqscwc/vpaup*vpadn/qs*(-ctw**4*mz**2)
     & +propizqs*c0ccqscwc/vpaup*vpadn*(-1)
     & +propizqs*c0ccqsczc*vpaup**2/qs*(-1d0/2/ctw**2*mz**2)
     & +propizqs*c0ccqsczc*vpaup**2*(-1d0/2/ctw**2)
     & +propizqs*a0fw/vpaup/qs*(2*ctw**4)
     & +propizqs*a0fw/vpaup*vpadn/qs*(ctw**2)
     & +propizqs*a0fw*qup/vpaup/qs*(4d0/3*ctw**2-28d0/3*ctw**4+8*ctw**6)
     & +propizqs*a0fz/vpaup/qs*(1d0/12/ctw**2/mz**2*mh**2-1d0/12/ctw**2)
     & +propizqs*a0fz*vpaup**2/qs*(1d0/2/ctw**2)
     & +propizqs*a0fz*qup/vpaup/qs*(-1d0/6-1d0/6/ctw**2/mz**2*mh**2+1d0/
     & 6/ctw**2+1d0/6/mz**2*mh**2)
     & +propizqs*a0fh/vpaup/qs*(-1d0/12/ctw**2/mz**4*mh**4+1d0/12/ctw**2
     & /mz**2*mh**2)
     & +propizqs*a0fh*qup/vpaup/qs*(1d0/6/ctw**2/mz**4*mh**4-1d0/6/ctw**
     & 2/mz**2*mh**2-1d0/6/mz**4*mh**4+1d0/6/mz**2*mh**2)
     & +propizqs*b0fhww*qup/vpaup/qs*(-1+3*ctw**2-2*ctw**4)
     & +propizqs*b0fzww*qup/vpaup/qs*(1-3*ctw**2+2*ctw**4)
     & +propizqs*b0fqsww/vpaup/qs*(2*ctw**4)
     & +propizqs*b0fqsww*qup/vpaup/qs*(4d0/3*ctw**2-28d0/3*ctw**4+8*ctw*
     & *6)
     & +propizqs*b0fqszh/vpaup/qs*(-1d0/12/ctw**2/mz**4*mh**4+1d0/6/ctw*
     & *2/mz**2*mh**2-1d0/12/ctw**2)
     & +propizqs*b0fqszh*qup/vpaup/qs*(-1d0/6+1d0/6/ctw**2/mz**4*mh**4-1
     & d0/3/ctw**2/mz**2*mh**2+1d0/6/ctw**2-1d0/6/mz**4*mh**4+1d0/3/mz**
     & 2*mh**2)
     & +propizqs*b0fqscc/vpaup*vpadn/qs*(ctw**2)
     & +propizqs*b0fqscc*vpaup**2/qs*(1d0/2/ctw**2)
     & +det3izhqs*c0zhqswww*(1d0/2/ctw**2*mz**4*mh**2-7d0/4*mz**4*mh**2+
     & ctw**2*mz**4*mh**2+3*ctw**4*mz**4*mh**2)
     & +det3izhqs*c0zhqszhh*(3/ctw**2*mz**4*mh**2)
     & +det3izhqs*c0zhqshzz*(6/ctw**2*mz**4*mh**2)
     & +det3izhqs*c0zhqsmomomo*cfl*(-1d0/4/ctw**2*vmamo**2*mz**2*mh**2*m
     & mo**2-1d0/4/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs*c0zhqschchch*cfq*(-1d0/4/ctw**2*vmach**2*mz**2*mh**2*m
     & ch**2-1d0/4/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs*c0zhqsststst*cfq*(-1d0/4/ctw**2*vmast**2*mz**2*mh**2*m
     & st**2-1d0/4/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs*c0zhqstatata*cfl*(-1d0/4/ctw**2*vmata**2*mz**2*mh**2*m
     & ta**2-1d0/4/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs*c0zhqstptptp*cfq*(-1d0/4/ctw**2*vmatp**2*mz**2*mh**2*m
     & tp**2-1d0/4/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs*c0zhqsbtbtbt*cfq*(-1d0/4/ctw**2*vmabt**2*mz**2*mh**2*m
     & bt**2-1d0/4/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*b0fhww*(-1d0/2/ctw**2*mz**2*mh**2+7d0/4*mz**2*mh**2-ct
     & w**2*mz**2*mh**2-3*ctw**4*mz**2*mh**2)
     & +det3izhqs*b0fhzz*(-3d0/2/ctw**2*mz**2*mh**2)
     & +det3izhqs*b0fhhh*(3d0/2/ctw**2*mz**2*mh**2)
     & +det3izhqs*b0fhmomo*cfl*(1d0/4/ctw**2*vmamo**2*mh**2*mmo**2+1d0/4
     & /ctw**2*vpamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fhchch*cfq*(1d0/4/ctw**2*vmach**2*mh**2*mch**2+1d0/4
     & /ctw**2*vpach**2*mh**2*mch**2)
     & +det3izhqs*b0fhstst*cfq*(1d0/4/ctw**2*vmast**2*mh**2*mst**2+1d0/4
     & /ctw**2*vpast**2*mh**2*mst**2)
     & +det3izhqs*b0fhtata*cfl*(1d0/4/ctw**2*vmata**2*mh**2*mta**2+1d0/4
     & /ctw**2*vpata**2*mh**2*mta**2)
     & +det3izhqs*b0fhtptp*cfq*(1d0/4/ctw**2*vmatp**2*mh**2*mtp**2+1d0/4
     & /ctw**2*vpatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fhbtbt*cfq*(1d0/4/ctw**2*vmabt**2*mh**2*mbt**2+1d0/4
     & /ctw**2*vpabt**2*mh**2*mbt**2)
     & +det3izhqs*b0fzww*(1d0/4/ctw**2*mz**2*mh**2-7d0/8*mz**2*mh**2+1d0
     & /2*ctw**2*mz**2*mh**2+3d0/2*ctw**4*mz**2*mh**2)
     & +det3izhqs*b0fzmomo*cfl*(-1d0/8/ctw**2*vmamo**2*mh**2*mmo**2-1d0/
     & 8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fzchch*cfq*(-1d0/8/ctw**2*vmach**2*mh**2*mch**2-1d0/
     & 8/ctw**2*vpach**2*mh**2*mch**2)
     & +det3izhqs*b0fzstst*cfq*(-1d0/8/ctw**2*vmast**2*mh**2*mst**2-1d0/
     & 8/ctw**2*vpast**2*mh**2*mst**2)
     & +det3izhqs*b0fztata*cfl*(-1d0/8/ctw**2*vmata**2*mh**2*mta**2-1d0/
     & 8/ctw**2*vpata**2*mh**2*mta**2)
     & +det3izhqs*b0fztptp*cfq*(-1d0/8/ctw**2*vmatp**2*mh**2*mtp**2-1d0/
     & 8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fzbtbt*cfq*(-1d0/8/ctw**2*vmabt**2*mh**2*mbt**2-1d0/
     & 8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +det3izhqs*b0fqsww*(1d0/4/ctw**2*mz**2*mh**2-7d0/8*mz**2*mh**2+1d
     & 0/2*ctw**2*mz**2*mh**2+3d0/2*ctw**4*mz**2*mh**2)
     & +det3izhqs*b0fqsmomo*cfl*(-1d0/8/ctw**2*vmamo**2*mh**2*mmo**2-1d0
     & /8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fqschch*cfq*(-1d0/8/ctw**2*vmach**2*mh**2*mch**2-1d0
     & /8/ctw**2*vpach**2*mh**2*mch**2)
     & +det3izhqs*b0fqsstst*cfq*(-1d0/8/ctw**2*vmast**2*mh**2*mst**2-1d0
     & /8/ctw**2*vpast**2*mh**2*mst**2)
     & +det3izhqs*b0fqstata*cfl*(-1d0/8/ctw**2*vmata**2*mh**2*mta**2-1d0
     & /8/ctw**2*vpata**2*mh**2*mta**2)
     & +det3izhqs*b0fqstptp*cfq*(-1d0/8/ctw**2*vmatp**2*mh**2*mtp**2-1d0
     & /8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*cfq*(-1d0/8/ctw**2*vmabt**2*mh**2*mbt**2-1d0
     & /8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +c0zhqswww*(-1d0/2/ctw**2*mz**2+1d0/2*mh**2+2*mz**2-2*ctw**2*mh**
     & 2+ctw**2*mz**2+6*ctw**4*mh**2-12*ctw**4*mz**2-12*ctw**6*mz**2)
     & +c0zhqszhh*(-3d0/4/ctw**2/mz**2*mh**4+3d0/4/ctw**2*mh**2-3/ctw**2
     & *mz**2)
     & +c0zhqshzz*(-1d0/2/ctw**2/mz**2*mh**4-2/ctw**2*mh**2-5/ctw**2*mz*
     & *2)
     & +c0zhqsmomomo*cfl*(1d0/2/ctw**2*vmamo**2*mmo**2+2/ctw**2*vpamo*vm
     & amo/mz**2*mmo**4-1d0/2/ctw**2*vpamo*vmamo/mz**2*mh**2*mmo**2+1d0/
     & 2/ctw**2*vpamo**2*mmo**2)
     & +c0zhqschchch*cfq*(1d0/2/ctw**2*vmach**2*mch**2+2/ctw**2*vpach*vm
     & ach/mz**2*mch**4-1d0/2/ctw**2*vpach*vmach/mz**2*mh**2*mch**2+1d0/
     & 2/ctw**2*vpach**2*mch**2)
     & +c0zhqsststst*cfq*(1d0/2/ctw**2*vmast**2*mst**2+2/ctw**2*vpast*vm
     & ast/mz**2*mst**4-1d0/2/ctw**2*vpast*vmast/mz**2*mh**2*mst**2+1d0/
     & 2/ctw**2*vpast**2*mst**2)
     & +c0zhqstatata*cfl*(1d0/2/ctw**2*vmata**2*mta**2+2/ctw**2*vpata*vm
     & ata/mz**2*mta**4-1d0/2/ctw**2*vpata*vmata/mz**2*mh**2*mta**2+1d0/
     & 2/ctw**2*vpata**2*mta**2)
     & +c0zhqstptptp*cfq*(1d0/2/ctw**2*vmatp**2*mtp**2+2/ctw**2*vpatp*vm
     & atp/mz**2*mtp**4-1d0/2/ctw**2*vpatp*vmatp/mz**2*mh**2*mtp**2+1d0/
     & 2/ctw**2*vpatp**2*mtp**2)
     & +c0zhqsbtbtbt*cfq*(1d0/2/ctw**2*vmabt**2*mbt**2+2/ctw**2*vpabt*vm
     & abt/mz**2*mbt**4-1d0/2/ctw**2*vpabt*vmabt/mz**2*mh**2*mbt**2+1d0/
     & 2/ctw**2*vpabt**2*mbt**2)
     & +c0ccqswcw/vpaup*(-4*ctw**4*mz**2-2*ctw**6*mz**2)
     & +c0ccqscwc/vpaup*vpadn*(mz**2+2*ctw**2*mz**2+ctw**4*mz**2)
     & +c0ccqsczc*vpaup**2*(2/ctw**2*mz**2)
     & +a0fw/vpaup*(-2d0/3*ctw**2+2*ctw**4)
     & +a0fw/vpaup*vpadn*(-2-ctw**2)
     & +a0fw*(1d0/4+8d0/3*ctw**2-3d0/2*ctw**2*mz**2/mh**2-4*ctw**4)
     & +a0fz*vpaup**2*(-5d0/4/ctw**2)
     & +a0fz*(-1d0/8/ctw**2/mz**2*mh**2-3d0/4/ctw**2*mz**2/mh**2)
     & +a0fh*(1d0/8/ctw**2/mz**4*mh**4-1d0/2/ctw**2/mz**2*mh**2)
     & +b0fhww*(-1+1d0/2/ctw**2+2*ctw**2)
     & +b0fhzz*(1d0/4/ctw**2/mz**2*mh**2+2/ctw**2)
     & +b0fhhh*(-3d0/4/ctw**2/mz**2*mh**2-3d0/2/ctw**2)
     & +b0fzww/vpaup*(-1d0/6+1d0/12/ctw**2+4d0/3*ctw**2+4*ctw**4)
     & +b0fzww*qup/vpaup*(1d0/2-1d0/6/ctw**2-3*ctw**2-16d0/3*ctw**4+8*ct
     & w**6)
     & +b0fzww*(1d0/3-3d0/8/ctw**2+7d0/6*ctw**2-4*ctw**4)
     & +b0fzzh/vpaup*(-1d0/12/ctw**2/mz**4*mh**4+1d0/6/ctw**2/mz**2*mh**
     & 2)
     & +b0fzzh*qup/vpaup*(1d0/6/ctw**2/mz**4*mh**4-1d0/3/ctw**2/mz**2*mh
     & **2-1d0/6/mz**4*mh**4+1d0/3/mz**2*mh**2)
     & +b0fzzh*(1d0/8/ctw**2/mz**4*mh**4-1d0/2/ctw**2)
     & +b0fzmomo*cfl*(1d0/4/ctw**2*vmamo**2/mz**2*mmo**2-1d0/2/ctw**2*vp
     & amo*vmamo/mz**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +b0fzchch*cfq*(1d0/4/ctw**2*vmach**2/mz**2*mch**2-1d0/2/ctw**2*vp
     & ach*vmach/mz**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +b0fzstst*cfq*(1d0/4/ctw**2*vmast**2/mz**2*mst**2-1d0/2/ctw**2*vp
     & ast*vmast/mz**2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +b0fztata*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mta**2-1d0/2/ctw**2*vp
     & ata*vmata/mz**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +b0fztptp*cfq*(1d0/4/ctw**2*vmatp**2/mz**2*mtp**2-1d0/2/ctw**2*vp
     & atp*vmatp/mz**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +b0fzbtbt*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mbt**2-1d0/2/ctw**2*vp
     & abt*vmabt/mz**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +b0fqsww/vpaup*(1d0/3-1d0/12/ctw**2+2*ctw**2-2*ctw**4)
     & +b0fqsww*qup/vpaup*(-1d0/2+1d0/6/ctw**2+3*ctw**2+16d0/3*ctw**4-8*
     & ctw**6)
     & +b0fqsww*(-1d0/4/ctw**2+ctw**2)
     & +b0fqszh/vpaup*(1d0/12/ctw**2/mz**4*mh**4-1d0/6/ctw**2/mz**2*mh**
     & 2)
     & +b0fqszh*qup/vpaup*(-1d0/6/ctw**2/mz**4*mh**4+1d0/3/ctw**2/mz**2*
     & mh**2+1d0/6/mz**4*mh**4-1d0/3/mz**2*mh**2)
     & +b0fqszh*(1d0/4/ctw**2/mz**2*mh**2-1d0/2/ctw**2)
     & +b0fqsmomo*cfl*(1d0/4/ctw**2*vmamo**2/mz**2*mmo**2-1d0/2/ctw**2*v
     & pamo*vmamo/mz**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +b0fqschch*cfq*(1d0/4/ctw**2*vmach**2/mz**2*mch**2-1d0/2/ctw**2*v
     & pach*vmach/mz**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +b0fqsstst*cfq*(1d0/4/ctw**2*vmast**2/mz**2*mst**2-1d0/2/ctw**2*v
     & past*vmast/mz**2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +b0fqstata*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mta**2-1d0/2/ctw**2*v
     & pata*vmata/mz**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +b0fqstptp*cfq*(1d0/4/ctw**2*vmatp**2/mz**2*mtp**2-1d0/2/ctw**2*v
     & patp*vmatp/mz**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +b0fqsbtbt*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mbt**2-1d0/2/ctw**2*v
     & pabt*vmabt/mz**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +b0fqscc/vpaup*vpadn*(-3d0/2-ctw**2)
     & +b0fqscc*vpaup**2*(-5d0/4/ctw**2)
     & +dreal(b0phww)*(1d0/8/ctw**2/mz**2*mh**4-1d0/2*mh**2+3d0/2*ctw**2
     & *mz**2)
     & +dreal(b0phzz)*(1d0/16/ctw**2/mz**2*mh**4-1d0/4/ctw**2*mh**2+3d0/
     & 4/ctw**2*mz**2)
     & +dreal(b0phhh)*(9d0/16/ctw**2/mz**2*mh**4)
     & +dreal(b0pzww)/vpaup*(-1d0/12/ctw**2*mz**2-4d0/3*mz**2+17d0/3*ctw
     & **2*mz**2+4*ctw**4*mz**2)
     & +dreal(b0pzww)*qup/vpaup*(1d0/6/ctw**2*mz**2+5d0/2*mz**2-14*ctw**
     & 2*mz**2+10d0/3*ctw**4*mz**2+8*ctw**6*mz**2)
     & +dreal(b0pzww)*(1d0/8/ctw**2*mz**2+2*mz**2-17d0/2*ctw**2*mz**2-6*
     & ctw**4*mz**2)
     & +dreal(b0pzzh)/vpaup*(-1d0/12/ctw**2/mz**2*mh**4+1d0/3/ctw**2*mh*
     & *2-1d0/ctw**2*mz**2)
     & +dreal(b0pzzh)*qup/vpaup*(1d0/6/ctw**2/mz**2*mh**4-2d0/3/ctw**2*m
     & h**2+2/ctw**2*mz**2-1d0/6/mz**2*mh**4+2d0/3*mh**2-2*mz**2)
     & +dreal(b0pzzh)*(1d0/8/ctw**2/mz**2*mh**4-1d0/2/ctw**2*mh**2+3d0/2
     & /ctw**2*mz**2)
     & +dreal(b0pccz)*vmaup**2*(-1d0/4/ctw**2*mz**2)
     & +dreal(b0pccz)*vpaup**2*(-1d0/4/ctw**2*mz**2)
     & +53d0/36+1d0/stw*ctw*zmsqrfer+3d0/4/ctw**2/mz**2*mh**2+1d0/12/ctw
     & **2-1d0/2/ctw**2*mz**2/mh**2-1d0/mz**2*mh**2+1d0/2*zh1fer+3d0/2*z
     & z1fer-1d0/2*deltarhofer-1d0/2*zmwzwfer+zmzzzfer-za1fer-1d0/2*delt
     & arhobos-1d0/2*zmwzwbos+zmzzzbos-za1bos+ctw**2/mz**2*mh**2+2d0/3*c
     & tw**2-ctw**2*mz**2/mh**2+2*ctw**4

      ffgp1=
     & +vpaup*(3d0/2/ctw**2/mz**2-2/mz**2+2*ctw**2/mz**2)
     & +propizqs*qup/qs*(-2/mz**2+6*ctw**2/mz**2-4*ctw**4/mz**2)
     & +propizqs*det3izhqs*vpaup*(-3d0/4+3d0/8/ctw**2/mz**2*mh**2+1d0/4/
     & ctw**2-1d0/2/mz**2*mh**2+1d0/2*ctw**2/mz**2*mh**2+3d0/2*ctw**2-3*
     & ctw**4)
     & +propizqs*det3izhqs*vpaup*qs*(3d0/8/ctw**2/mz**2-1d0/2/mz**2+1d0/
     & 2*ctw**2/mz**2)
     & +propizqs*det3izhqs*vpaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mbt**2
     & +1d0/4/ctw**2*vpabt**2/mz**2*mbt**2+1d0/4/ctw**2*vmatp**2/mz**2*m
     & tp**2+1d0/4/ctw**2*vpatp**2/mz**2*mtp**2+1d0/4/ctw**2*vmast**2/mz
     & **2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mst**2+1d0/4/ctw**2*vmach*
     & *2/mz**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*vpaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mta**2
     & +1d0/4/ctw**2*vpata**2/mz**2*mta**2+1d0/4/ctw**2*vmamo**2/mz**2*m
     & mo**2+1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*qup/qs*(1d0/2*mh**2-1d0/2*mz**2-1d0/2*ctw**2*
     & mh**2+1d0/2*ctw**2*mz**2-6*ctw**4*mh**2+6*ctw**4*mz**2+6*ctw**6*m
     & h**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*qup*(-1-1d0/2/mz**2*mh**2+3d0/2*ctw**2/mz**2*
     & mh**2+4*ctw**2-ctw**4/mz**2*mh**2-9*ctw**4+6*ctw**6)
     & +propizqs*det3izhqs*qup*qs*(-1d0/2/mz**2+3d0/2*ctw**2/mz**2-ctw**
     & 4/mz**2)
     & +propizqs*det3izhqs*qup*cfq/qs*(qbt*vmabt/mz**2*mh**2*mbt**2-qbt*
     & vmabt*mbt**2+qbt*vpabt/mz**2*mh**2*mbt**2-qbt*vpabt*mbt**2+qtp*vm
     & atp/mz**2*mh**2*mtp**2-qtp*vmatp*mtp**2+qtp*vpatp/mz**2*mh**2*mtp
     & **2-qtp*vpatp*mtp**2+qst*vmast/mz**2*mh**2*mst**2-qst*vmast*mst**
     & 2+qst*vpast/mz**2*mh**2*mst**2-qst*vpast*mst**2+qch*vmach/mz**2*m
     & h**2*mch**2-qch*vmach*mch**2+qch*vpach/mz**2*mh**2*mch**2-qch*vpa
     & ch*mch**2-ctw**2*qbt*vmabt/mz**2*mh**2*mbt**2+ctw**2*qbt*vmabt*mb
     & t**2-ctw**2*qbt*vpabt/mz**2*mh**2*mbt**2+ctw**2*qbt*vpabt*mbt**2-
     & ctw**2*qtp*vmatp/mz**2*mh**2*mtp**2+ctw**2*qtp*vmatp*mtp**2-ctw**
     & 2*qtp*vpatp/mz**2*mh**2*mtp**2+ctw**2*qtp*vpatp*mtp**2-ctw**2*qst
     & *vmast/mz**2*mh**2*mst**2+ctw**2*qst*vmast*mst**2-ctw**2*qst*vpas
     & t/mz**2*mh**2*mst**2+ctw**2*qst*vpast*mst**2-ctw**2*qch*vmach/mz*
     & *2*mh**2*mch**2+ctw**2*qch*vmach*mch**2-ctw**2*qch*vpach/mz**2*mh
     & **2*mch**2+ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*qup*cfq*(qbt*vmabt/mz**2*mbt**2+qbt*vpabt/mz*
     & *2*mbt**2+qtp*vmatp/mz**2*mtp**2+qtp*vpatp/mz**2*mtp**2+qst*vmast
     & /mz**2*mst**2+qst*vpast/mz**2*mst**2+qch*vmach/mz**2*mch**2+qch*v
     & pach/mz**2*mch**2-ctw**2*qbt*vmabt/mz**2*mbt**2-ctw**2*qbt*vpabt/
     & mz**2*mbt**2-ctw**2*qtp*vmatp/mz**2*mtp**2-ctw**2*qtp*vpatp/mz**2
     & *mtp**2-ctw**2*qst*vmast/mz**2*mst**2-ctw**2*qst*vpast/mz**2*mst*
     & *2-ctw**2*qch*vmach/mz**2*mch**2-ctw**2*qch*vpach/mz**2*mch**2)
     & +propizqs*det3izhqs*qup*cfl/qs*(qta*vmata/mz**2*mh**2*mta**2-qta*
     & vmata*mta**2+qta*vpata/mz**2*mh**2*mta**2-qta*vpata*mta**2+qmo*vm
     & amo/mz**2*mh**2*mmo**2-qmo*vmamo*mmo**2+qmo*vpamo/mz**2*mh**2*mmo
     & **2-qmo*vpamo*mmo**2-ctw**2*qta*vmata/mz**2*mh**2*mta**2+ctw**2*q
     & ta*vmata*mta**2-ctw**2*qta*vpata/mz**2*mh**2*mta**2+ctw**2*qta*vp
     & ata*mta**2-ctw**2*qmo*vmamo/mz**2*mh**2*mmo**2+ctw**2*qmo*vmamo*m
     & mo**2-ctw**2*qmo*vpamo/mz**2*mh**2*mmo**2+ctw**2*qmo*vpamo*mmo**2
     & )
     & +propizqs*det3izhqs*qup*cfl*(qta*vmata/mz**2*mta**2+qta*vpata/mz*
     & *2*mta**2+qmo*vmamo/mz**2*mmo**2+qmo*vpamo/mz**2*mmo**2-ctw**2*qt
     & a*vmata/mz**2*mta**2-ctw**2*qta*vpata/mz**2*mta**2-ctw**2*qmo*vma
     & mo/mz**2*mmo**2-ctw**2*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqswww*vpaup*(3d0/16/ctw**2*mh**6+15d0/
     & 16/ctw**2*mz**4*mh**2+3d0/8/ctw**2*mz**6-3d0/4*mh**6+3d0/8*mz**2*
     & mh**4-15d0/4*mz**4*mh**2-9d0/8*mz**6+3d0/4*ctw**2*mh**6-3d0/2*ctw
     & **2*mz**2*mh**4+15d0/4*ctw**2*mz**4*mh**2+9d0/2*ctw**4*mz**2*mh**
     & 4+9d0/2*ctw**4*mz**6)
     & +propizqs*det3izhqs**2*c0zhqswww*vpaup*qs*(3d0/16/ctw**2*mh**4+3d
     & 0/16/ctw**2*mz**2*mh**2+3d0/8/ctw**2*mz**4-3d0/4*mh**4-3d0/8*mz**
     & 2*mh**2-9d0/8*mz**4+3d0/4*ctw**2*mh**4-3d0/4*ctw**2*mz**2*mh**2+9
     & d0/2*ctw**4*mz**2*mh**2+9d0/2*ctw**4*mz**4)
     & +propizqs*det3izhqs**2*c0zhqswww*qup*(-3d0/4*mh**6+3d0/4*mz**2*mh
     & **4+9d0/4*ctw**2*mh**6-15d0/4*ctw**2*mz**2*mh**4+3d0/2*ctw**2*mz*
     & *4*mh**2-3d0/2*ctw**4*mh**6+12*ctw**4*mz**2*mh**4-21d0/2*ctw**4*m
     & z**4*mh**2-9*ctw**6*mz**2*mh**4+9*ctw**6*mz**4*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qup*qs*(-3d0/4*mh**4+9d0/4*ctw**
     & 2*mh**4-3d0/2*ctw**2*mz**2*mh**2-3d0/2*ctw**4*mh**4+21d0/2*ctw**4
     & *mz**2*mh**2-9*ctw**6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*c0zhqszhh*vpaup*(9d0/32/ctw**2/mz**2*mh**8
     & +45d0/32/ctw**2*mz**2*mh**4+81d0/16/ctw**2*mz**4*mh**2+9d0/4/ctw*
     & *2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqszhh*vpaup*qs*(9d0/32/ctw**2/mz**2*mh
     & **6+9d0/32/ctw**2*mh**4+9d0/16/ctw**2*mz**2*mh**2+9d0/4/ctw**2*mz
     & **4)
     & +propizqs*det3izhqs**2*c0zhqshzz*vpaup*(3d0/32/ctw**2/mz**2*mh**8
     & +15d0/16/ctw**2*mh**6+87d0/32/ctw**2*mz**2*mh**4+75d0/8/ctw**2*mz
     & **4*mh**2+39d0/8/ctw**2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqshzz*vpaup*qs*(3d0/32/ctw**2/mz**2*mh
     & **6+9d0/32/ctw**2*mh**4+9d0/8/ctw**2*mz**2*mh**2+39d0/8/ctw**2*mz
     & **4)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vpaup*cfl*(-3d0/8/ctw**2*vmam
     & o**2*mh**4*mmo**2-3d0/8/ctw**2*vmamo**2*mz**4*mmo**2-3d0/8/ctw**2
     & *vpamo**2*mh**4*mmo**2-3d0/8/ctw**2*vpamo**2*mz**4*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vpaup*cfl*qs*(-3d0/8/ctw**2*v
     & mamo**2*mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mz**2*mmo**2-3d0/8/ctw
     & **2*vpamo**2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qup*cfl*(-3d0/2*qmo*vmamo*mh*
     & *4*mmo**2+3d0/2*qmo*vmamo*mz**2*mh**2*mmo**2-3d0/2*qmo*vpamo*mh**
     & 4*mmo**2+3d0/2*qmo*vpamo*mz**2*mh**2*mmo**2+3d0/2*ctw**2*qmo*vmam
     & o*mh**4*mmo**2-3d0/2*ctw**2*qmo*vmamo*mz**2*mh**2*mmo**2+3d0/2*ct
     & w**2*qmo*vpamo*mh**4*mmo**2-3d0/2*ctw**2*qmo*vpamo*mz**2*mh**2*mm
     & o**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qup*cfl*qs*(-3d0/2*qmo*vmamo*
     & mh**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*
     & mh**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vpaup*cfq*(-3d0/8/ctw**2*vmac
     & h**2*mh**4*mch**2-3d0/8/ctw**2*vmach**2*mz**4*mch**2-3d0/8/ctw**2
     & *vpach**2*mh**4*mch**2-3d0/8/ctw**2*vpach**2*mz**4*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vpaup*cfq*qs*(-3d0/8/ctw**2*v
     & mach**2*mh**2*mch**2-3d0/8/ctw**2*vmach**2*mz**2*mch**2-3d0/8/ctw
     & **2*vpach**2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*mz**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qup*cfq*(-3d0/2*qch*vmach*mh*
     & *4*mch**2+3d0/2*qch*vmach*mz**2*mh**2*mch**2-3d0/2*qch*vpach*mh**
     & 4*mch**2+3d0/2*qch*vpach*mz**2*mh**2*mch**2+3d0/2*ctw**2*qch*vmac
     & h*mh**4*mch**2-3d0/2*ctw**2*qch*vmach*mz**2*mh**2*mch**2+3d0/2*ct
     & w**2*qch*vpach*mh**4*mch**2-3d0/2*ctw**2*qch*vpach*mz**2*mh**2*mc
     & h**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qup*cfq*qs*(-3d0/2*qch*vmach*
     & mh**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2+3d0/2*ctw**2*qch*vmach*
     & mh**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vpaup*cfq*(-3d0/8/ctw**2*vmas
     & t**2*mh**4*mst**2-3d0/8/ctw**2*vmast**2*mz**4*mst**2-3d0/8/ctw**2
     & *vpast**2*mh**4*mst**2-3d0/8/ctw**2*vpast**2*mz**4*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vpaup*cfq*qs*(-3d0/8/ctw**2*v
     & mast**2*mh**2*mst**2-3d0/8/ctw**2*vmast**2*mz**2*mst**2-3d0/8/ctw
     & **2*vpast**2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*mz**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qup*cfq*(-3d0/2*qst*vmast*mh*
     & *4*mst**2+3d0/2*qst*vmast*mz**2*mh**2*mst**2-3d0/2*qst*vpast*mh**
     & 4*mst**2+3d0/2*qst*vpast*mz**2*mh**2*mst**2+3d0/2*ctw**2*qst*vmas
     & t*mh**4*mst**2-3d0/2*ctw**2*qst*vmast*mz**2*mh**2*mst**2+3d0/2*ct
     & w**2*qst*vpast*mh**4*mst**2-3d0/2*ctw**2*qst*vpast*mz**2*mh**2*ms
     & t**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qup*cfq*qs*(-3d0/2*qst*vmast*
     & mh**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2+3d0/2*ctw**2*qst*vmast*
     & mh**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vpaup*cfl*(-3d0/8/ctw**2*vmat
     & a**2*mh**4*mta**2-3d0/8/ctw**2*vmata**2*mz**4*mta**2-3d0/8/ctw**2
     & *vpata**2*mh**4*mta**2-3d0/8/ctw**2*vpata**2*mz**4*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vpaup*cfl*qs*(-3d0/8/ctw**2*v
     & mata**2*mh**2*mta**2-3d0/8/ctw**2*vmata**2*mz**2*mta**2-3d0/8/ctw
     & **2*vpata**2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*mz**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qup*cfl*(-3d0/2*qta*vmata*mh*
     & *4*mta**2+3d0/2*qta*vmata*mz**2*mh**2*mta**2-3d0/2*qta*vpata*mh**
     & 4*mta**2+3d0/2*qta*vpata*mz**2*mh**2*mta**2+3d0/2*ctw**2*qta*vmat
     & a*mh**4*mta**2-3d0/2*ctw**2*qta*vmata*mz**2*mh**2*mta**2+3d0/2*ct
     & w**2*qta*vpata*mh**4*mta**2-3d0/2*ctw**2*qta*vpata*mz**2*mh**2*mt
     & a**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qup*cfl*qs*(-3d0/2*qta*vmata*
     & mh**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2+3d0/2*ctw**2*qta*vmata*
     & mh**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vpaup*cfq*(-3d0/8/ctw**2*vmat
     & p**2*mh**4*mtp**2-3d0/8/ctw**2*vmatp**2*mz**4*mtp**2-3d0/8/ctw**2
     & *vpatp**2*mh**4*mtp**2-3d0/8/ctw**2*vpatp**2*mz**4*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vpaup*cfq*qs*(-3d0/8/ctw**2*v
     & matp**2*mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mz**2*mtp**2-3d0/8/ctw
     & **2*vpatp**2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qup*cfq*(-3d0/2*qtp*vmatp*mh*
     & *4*mtp**2+3d0/2*qtp*vmatp*mz**2*mh**2*mtp**2-3d0/2*qtp*vpatp*mh**
     & 4*mtp**2+3d0/2*qtp*vpatp*mz**2*mh**2*mtp**2+3d0/2*ctw**2*qtp*vmat
     & p*mh**4*mtp**2-3d0/2*ctw**2*qtp*vmatp*mz**2*mh**2*mtp**2+3d0/2*ct
     & w**2*qtp*vpatp*mh**4*mtp**2-3d0/2*ctw**2*qtp*vpatp*mz**2*mh**2*mt
     & p**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qup*cfq*qs*(-3d0/2*qtp*vmatp*
     & mh**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*
     & mh**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vpaup*cfq*(-3d0/8/ctw**2*vmab
     & t**2*mh**4*mbt**2-3d0/8/ctw**2*vmabt**2*mz**4*mbt**2-3d0/8/ctw**2
     & *vpabt**2*mh**4*mbt**2-3d0/8/ctw**2*vpabt**2*mz**4*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vpaup*cfq*qs*(-3d0/8/ctw**2*v
     & mabt**2*mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mz**2*mbt**2-3d0/8/ctw
     & **2*vpabt**2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh*
     & *4*mbt**2+3d0/2*qbt*vmabt*mz**2*mh**2*mbt**2-3d0/2*qbt*vpabt*mh**
     & 4*mbt**2+3d0/2*qbt*vpabt*mz**2*mh**2*mbt**2+3d0/2*ctw**2*qbt*vmab
     & t*mh**4*mbt**2-3d0/2*ctw**2*qbt*vmabt*mz**2*mh**2*mbt**2+3d0/2*ct
     & w**2*qbt*vpabt*mh**4*mbt**2-3d0/2*ctw**2*qbt*vpabt*mz**2*mh**2*mb
     & t**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qup*cfq*qs*(-3d0/2*qbt*vmabt*
     & mh**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*
     & mh**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhww*vpaup*(-3d0/8/ctw**2*mh**4-3d0/4/ct
     & w**2*mz**2*mh**2-3d0/8/ctw**2*mz**4+3d0/2*mh**4+9d0/4*mz**2*mh**2
     & +3d0/2*mz**4-3d0/2*ctw**2*mh**4-3d0/2*ctw**2*mz**4-9*ctw**4*mz**2
     & *mh**2)
     & +propizqs*det3izhqs**2*b0fhww*vpaup*qs*(-3d0/8/ctw**2*mz**2+3d0/2
     & *mz**2-3d0/2*ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhww*qup*(3d0/2*mh**4-9d0/2*ctw**2*mh**4
     & +3*ctw**2*mz**2*mh**2+3*ctw**4*mh**4-21*ctw**4*mz**2*mh**2+18*ctw
     & **6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhzz*vpaup*(-3d0/32/ctw**2/mz**2*mh**6-3
     & d0/4/ctw**2*mh**4-87d0/32/ctw**2*mz**2*mh**2-15d0/16/ctw**2*mz**4
     & )
     & +propizqs*det3izhqs**2*b0fhzz*vpaup*qs*(-3d0/32/ctw**2/mz**2*mh**
     & 4-9d0/32/ctw**2*mh**2-15d0/16/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhhh*vpaup*(9d0/32/ctw**2/mz**2*mh**6+9d
     & 0/16/ctw**2*mh**4+81d0/32/ctw**2*mz**2*mh**2+9d0/8/ctw**2*mz**4)
     & +propizqs*det3izhqs**2*b0fhhh*vpaup*qs*(9d0/32/ctw**2/mz**2*mh**4
     & +9d0/32/ctw**2*mh**2+9d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhmomo*vpaup*cfl*(3d0/4/ctw**2*vmamo**2*
     & mh**2*mmo**2+3d0/4/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhmomo*qup*cfl*(3*qmo*vmamo*mh**2*mmo**2
     & +3*qmo*vpamo*mh**2*mmo**2-3*ctw**2*qmo*vmamo*mh**2*mmo**2-3*ctw**
     & 2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhchch*vpaup*cfq*(3d0/4/ctw**2*vmach**2*
     & mh**2*mch**2+3d0/4/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhchch*qup*cfq*(3*qch*vmach*mh**2*mch**2
     & +3*qch*vpach*mh**2*mch**2-3*ctw**2*qch*vmach*mh**2*mch**2-3*ctw**
     & 2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhstst*vpaup*cfq*(3d0/4/ctw**2*vmast**2*
     & mh**2*mst**2+3d0/4/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhstst*qup*cfq*(3*qst*vmast*mh**2*mst**2
     & +3*qst*vpast*mh**2*mst**2-3*ctw**2*qst*vmast*mh**2*mst**2-3*ctw**
     & 2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhtata*vpaup*cfl*(3d0/4/ctw**2*vmata**2*
     & mh**2*mta**2+3d0/4/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtata*qup*cfl*(3*qta*vmata*mh**2*mta**2
     & +3*qta*vpata*mh**2*mta**2-3*ctw**2*qta*vmata*mh**2*mta**2-3*ctw**
     & 2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtptp*vpaup*cfq*(3d0/4/ctw**2*vmatp**2*
     & mh**2*mtp**2+3d0/4/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhtptp*qup*cfq*(3*qtp*vmatp*mh**2*mtp**2
     & +3*qtp*vpatp*mh**2*mtp**2-3*ctw**2*qtp*vmatp*mh**2*mtp**2-3*ctw**
     & 2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*vpaup*cfq*(3d0/4/ctw**2*vmabt**2*
     & mh**2*mbt**2+3d0/4/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*qup*cfq*(3*qbt*vmabt*mh**2*mbt**2
     & +3*qbt*vpabt*mh**2*mbt**2-3*ctw**2*qbt*vmabt*mh**2*mbt**2-3*ctw**
     & 2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzww*vpaup*(3d0/16/ctw**2*mh**4+3d0/8/ct
     & w**2*mz**2*mh**2+3d0/16/ctw**2*mz**4-3d0/4*mh**4-9d0/8*mz**2*mh**
     & 2-3d0/4*mz**4+3d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**4+9d0/2*ctw**4*
     & mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fzww*vpaup*qs*(3d0/16/ctw**2*mh**2+3d0/1
     & 6/ctw**2*mz**2-3d0/4*mh**2-3d0/8*mz**2+3d0/4*ctw**2*mh**2-3d0/4*c
     & tw**2*mz**2+9d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs**2*b0fzww*qup*(-3d0/4*mh**4-3d0/4*mz**2*mh**2
     & +9d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**2*mh**2-3d0/2*ctw**2*mz**4-3
     & d0/2*ctw**4*mh**4+9*ctw**4*mz**2*mh**2+21d0/2*ctw**4*mz**4-9*ctw*
     & *6*mz**2*mh**2-9*ctw**6*mz**4)
     & +propizqs*det3izhqs**2*b0fzww*qup*qs*(-3d0/4*mh**2+9d0/4*ctw**2*m
     & h**2-3d0/2*ctw**2*mz**2-3d0/2*ctw**4*mh**2+21d0/2*ctw**4*mz**2-9*
     & ctw**6*mz**2)
     & +propizqs*det3izhqs**2*b0fzzh*vpaup*(-3d0/16/ctw**2*mh**4+3d0/8/c
     & tw**2*mz**2*mh**2-3d0/16/ctw**2*mz**4)
     & +propizqs*det3izhqs**2*b0fzzh*vpaup*qs*(3d0/16/ctw**2*mh**2+3d0/1
     & 6/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vpaup*cfl*(-3d0/8/ctw**2*vmamo**2
     & *mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vpaup*cfl*qs*(-3d0/8/ctw**2*vmamo
     & **2*mmo**2-3d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qup*cfl*(-3d0/2*qmo*vmamo*mh**2*m
     & mo**2-3d0/2*qmo*vmamo*mz**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2-3
     & d0/2*qmo*vpamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*mh**2*mmo**2+3
     & d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*m
     & mo**2+3d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qup*cfl*qs*(-3d0/2*qmo*vmamo*mmo*
     & *2-3d0/2*qmo*vpamo*mmo**2+3d0/2*ctw**2*qmo*vmamo*mmo**2+3d0/2*ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fzchch*vpaup*cfq*(-3d0/8/ctw**2*vmach**2
     & *mh**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vpaup*cfq*qs*(-3d0/8/ctw**2*vmach
     & **2*mch**2-3d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qup*cfq*(-3d0/2*qch*vmach*mh**2*m
     & ch**2-3d0/2*qch*vmach*mz**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2-3
     & d0/2*qch*vpach*mz**2*mch**2+3d0/2*ctw**2*qch*vmach*mh**2*mch**2+3
     & d0/2*ctw**2*qch*vmach*mz**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*m
     & ch**2+3d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qup*cfq*qs*(-3d0/2*qch*vmach*mch*
     & *2-3d0/2*qch*vpach*mch**2+3d0/2*ctw**2*qch*vmach*mch**2+3d0/2*ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs**2*b0fzstst*vpaup*cfq*(-3d0/8/ctw**2*vmast**2
     & *mh**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vpaup*cfq*qs*(-3d0/8/ctw**2*vmast
     & **2*mst**2-3d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qup*cfq*(-3d0/2*qst*vmast*mh**2*m
     & st**2-3d0/2*qst*vmast*mz**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2-3
     & d0/2*qst*vpast*mz**2*mst**2+3d0/2*ctw**2*qst*vmast*mh**2*mst**2+3
     & d0/2*ctw**2*qst*vmast*mz**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*m
     & st**2+3d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qup*cfq*qs*(-3d0/2*qst*vmast*mst*
     & *2-3d0/2*qst*vpast*mst**2+3d0/2*ctw**2*qst*vmast*mst**2+3d0/2*ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs**2*b0fztata*vpaup*cfl*(-3d0/8/ctw**2*vmata**2
     & *mh**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vpaup*cfl*qs*(-3d0/8/ctw**2*vmata
     & **2*mta**2-3d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qup*cfl*(-3d0/2*qta*vmata*mh**2*m
     & ta**2-3d0/2*qta*vmata*mz**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2-3
     & d0/2*qta*vpata*mz**2*mta**2+3d0/2*ctw**2*qta*vmata*mh**2*mta**2+3
     & d0/2*ctw**2*qta*vmata*mz**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*m
     & ta**2+3d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qup*cfl*qs*(-3d0/2*qta*vmata*mta*
     & *2-3d0/2*qta*vpata*mta**2+3d0/2*ctw**2*qta*vmata*mta**2+3d0/2*ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs**2*b0fztptp*vpaup*cfq*(-3d0/8/ctw**2*vmatp**2
     & *mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vpaup*cfq*qs*(-3d0/8/ctw**2*vmatp
     & **2*mtp**2-3d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qup*cfq*(-3d0/2*qtp*vmatp*mh**2*m
     & tp**2-3d0/2*qtp*vmatp*mz**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2-3
     & d0/2*qtp*vpatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*mh**2*mtp**2+3
     & d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*m
     & tp**2+3d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qup*cfq*qs*(-3d0/2*qtp*vmatp*mtp*
     & *2-3d0/2*qtp*vpatp*mtp**2+3d0/2*ctw**2*qtp*vmatp*mtp**2+3d0/2*ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vpaup*cfq*(-3d0/8/ctw**2*vmabt**2
     & *mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vpaup*cfq*qs*(-3d0/8/ctw**2*vmabt
     & **2*mbt**2-3d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh**2*m
     & bt**2-3d0/2*qbt*vmabt*mz**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2-3
     & d0/2*qbt*vpabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*mh**2*mbt**2+3
     & d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*m
     & bt**2+3d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qup*cfq*qs*(-3d0/2*qbt*vmabt*mbt*
     & *2-3d0/2*qbt*vpabt*mbt**2+3d0/2*ctw**2*qbt*vmabt*mbt**2+3d0/2*ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsww*vpaup*(3d0/16/ctw**2*mh**4+3d0/8/c
     & tw**2*mz**2*mh**2+3d0/16/ctw**2*mz**4-3d0/4*mh**4-9d0/8*mz**2*mh*
     & *2-3d0/4*mz**4+3d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**4+9d0/2*ctw**4
     & *mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqsww*vpaup*qs*(-3d0/16/ctw**2*mh**2+3d0
     & /16/ctw**2*mz**2+3d0/4*mh**2-9d0/8*mz**2-3d0/4*ctw**2*mh**2+9d0/4
     & *ctw**2*mz**2-9d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs**2*b0fqsww*qup*(-3d0/4*mh**4+3d0/4*mz**2*mh**
     & 2+9d0/4*ctw**2*mh**4-15d0/4*ctw**2*mz**2*mh**2+3d0/2*ctw**2*mz**4
     & -3d0/2*ctw**4*mh**4+12*ctw**4*mz**2*mh**2-21d0/2*ctw**4*mz**4-9*c
     & tw**6*mz**2*mh**2+9*ctw**6*mz**4)
     & +propizqs*det3izhqs**2*b0fqsww*qup*qs*(3d0/4*mh**2-9d0/4*ctw**2*m
     & h**2+3d0/2*ctw**2*mz**2+3d0/2*ctw**4*mh**2-21d0/2*ctw**4*mz**2+9*
     & ctw**6*mz**2)
     & +propizqs*det3izhqs**2*b0fqszh*vpaup*(-3d0/16/ctw**2/mz**2*mh**6+
     & 3d0/8/ctw**2*mh**4-3d0/16/ctw**2*mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqszh*vpaup*qs*(-3d0/16/ctw**2/mz**2*mh*
     & *4-3d0/16/ctw**2*mh**2-3d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vpaup*cfl*(-3d0/8/ctw**2*vmamo**
     & 2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vpaup*cfl*qs*(3d0/8/ctw**2*vmamo
     & **2*mmo**2+3d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qup*cfl*(-3d0/2*qmo*vmamo*mh**2*
     & mmo**2+3d0/2*qmo*vmamo*mz**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2+
     & 3d0/2*qmo*vpamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*mh**2*mmo**2-
     & 3d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*
     & mmo**2-3d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qup*cfl*qs*(3d0/2*qmo*vmamo*mmo*
     & *2+3d0/2*qmo*vpamo*mmo**2-3d0/2*ctw**2*qmo*vmamo*mmo**2-3d0/2*ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fqschch*vpaup*cfq*(-3d0/8/ctw**2*vmach**
     & 2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vpaup*cfq*qs*(3d0/8/ctw**2*vmach
     & **2*mch**2+3d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qup*cfq*(-3d0/2*qch*vmach*mh**2*
     & mch**2+3d0/2*qch*vmach*mz**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2+
     & 3d0/2*qch*vpach*mz**2*mch**2+3d0/2*ctw**2*qch*vmach*mh**2*mch**2-
     & 3d0/2*ctw**2*qch*vmach*mz**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*
     & mch**2-3d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qup*cfq*qs*(3d0/2*qch*vmach*mch*
     & *2+3d0/2*qch*vpach*mch**2-3d0/2*ctw**2*qch*vmach*mch**2-3d0/2*ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vpaup*cfq*(-3d0/8/ctw**2*vmast**
     & 2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vpaup*cfq*qs*(3d0/8/ctw**2*vmast
     & **2*mst**2+3d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qup*cfq*(-3d0/2*qst*vmast*mh**2*
     & mst**2+3d0/2*qst*vmast*mz**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2+
     & 3d0/2*qst*vpast*mz**2*mst**2+3d0/2*ctw**2*qst*vmast*mh**2*mst**2-
     & 3d0/2*ctw**2*qst*vmast*mz**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*
     & mst**2-3d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qup*cfq*qs*(3d0/2*qst*vmast*mst*
     & *2+3d0/2*qst*vpast*mst**2-3d0/2*ctw**2*qst*vmast*mst**2-3d0/2*ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs**2*b0fqstata*vpaup*cfl*(-3d0/8/ctw**2*vmata**
     & 2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vpaup*cfl*qs*(3d0/8/ctw**2*vmata
     & **2*mta**2+3d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qup*cfl*(-3d0/2*qta*vmata*mh**2*
     & mta**2+3d0/2*qta*vmata*mz**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2+
     & 3d0/2*qta*vpata*mz**2*mta**2+3d0/2*ctw**2*qta*vmata*mh**2*mta**2-
     & 3d0/2*ctw**2*qta*vmata*mz**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*
     & mta**2-3d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qup*cfl*qs*(3d0/2*qta*vmata*mta*
     & *2+3d0/2*qta*vpata*mta**2-3d0/2*ctw**2*qta*vmata*mta**2-3d0/2*ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vpaup*cfq*(-3d0/8/ctw**2*vmatp**
     & 2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vpaup*cfq*qs*(3d0/8/ctw**2*vmatp
     & **2*mtp**2+3d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qup*cfq*(-3d0/2*qtp*vmatp*mh**2*
     & mtp**2+3d0/2*qtp*vmatp*mz**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2+
     & 3d0/2*qtp*vpatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*mh**2*mtp**2-
     & 3d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*
     & mtp**2-3d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qup*cfq*qs*(3d0/2*qtp*vmatp*mtp*
     & *2+3d0/2*qtp*vpatp*mtp**2-3d0/2*ctw**2*qtp*vmatp*mtp**2-3d0/2*ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vpaup*cfq*(-3d0/8/ctw**2*vmabt**
     & 2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vpaup*cfq*qs*(3d0/8/ctw**2*vmabt
     & **2*mbt**2+3d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh**2*
     & mbt**2+3d0/2*qbt*vmabt*mz**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2+
     & 3d0/2*qbt*vpabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*mh**2*mbt**2-
     & 3d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*
     & mbt**2-3d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qup*cfq*qs*(3d0/2*qbt*vmabt*mbt*
     & *2+3d0/2*qbt*vpabt*mbt**2-3d0/2*ctw**2*qbt*vmabt*mbt**2-3d0/2*ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*c0zhqswww*vpaup*(1d0/4/ctw**2*mh**2-7d0/4*mh*
     & *2-1d0/4*mz**2+2*ctw**2*mh**2-1d0/2*ctw**2*mz**2-ctw**4*mh**2+3*c
     & tw**4*mz**2+6*ctw**6*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*vpaup*qs*(-3d0/4+ctw**2-ctw**4)
     & +propizqs*det3izhqs*c0zhqswww*qup/qs*(-ctw**2*mz**2*mh**2+ctw**2*
     & mz**4+ctw**4*mz**2*mh**2-ctw**4*mz**4+12*ctw**6*mz**2*mh**2-12*ct
     & w**6*mz**4-12*ctw**8*mz**2*mh**2+12*ctw**8*mz**4)
     & +propizqs*det3izhqs*c0zhqswww*qup*(-mh**2+4*ctw**2*mh**2-5*ctw**4
     & *mh**2+6*ctw**4*mz**2+2*ctw**6*mh**2+6*ctw**6*mz**2-12*ctw**8*mz*
     & *2)
     & +propizqs*det3izhqs*c0zhqswww*qup*qs*(ctw**2-3*ctw**4+2*ctw**6)
     & +propizqs*det3izhqs*c0zhqszhh*vpaup*(-3d0/4/ctw**2/mz**2*mh**4-6/
     & ctw**2*mh**2-21d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqszhh*vpaup*qs*(-3d0/4/ctw**2/mz**2*mh**2
     & -21d0/8/ctw**2)
     & +propizqs*det3izhqs*c0zhqshzz*vpaup*(-7d0/8/ctw**2/mz**2*mh**4-7/
     & ctw**2*mh**2-11d0/4/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqshzz*vpaup*qs*(-3d0/8/ctw**2/mz**2*mh**2
     & -7d0/2/ctw**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vpaup*cfl*(-1d0/2/ctw**2*vmamo**
     & 2/mz**2*mmo**4+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-3d0/8/ctw
     & **2*vmamo**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mh**2*mmo**2-1
     & d0/4/ctw**2*vpamo*vmamo*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mmo**4
     & +1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*m
     & mo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vpaup*cfl*qs*(1d0/8/ctw**2*vmamo
     & **2/mz**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2+1d0/8/ctw*
     & *2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup*cfl/qs*(-2*qmo*vmamo/mz**2*m
     & h**2*mmo**4+2*qmo*vmamo*mmo**4-2*qmo*vpamo/mz**2*mh**2*mmo**4+2*q
     & mo*vpamo*mmo**4+2*ctw**2*qmo*vmamo/mz**2*mh**2*mmo**4-2*ctw**2*qm
     & o*vmamo*mmo**4+2*ctw**2*qmo*vpamo/mz**2*mh**2*mmo**4-2*ctw**2*qmo
     & *vpamo*mmo**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup*cfl*(-2*qmo*vmamo/mz**2*mmo*
     & *4-2*qmo*vmamo*mmo**2-2*qmo*vpamo/mz**2*mmo**4-2*qmo*vpamo*mmo**2
     & +2*ctw**2*qmo*vmamo/mz**2*mmo**4+2*ctw**2*qmo*vmamo*mmo**2+2*ctw*
     & *2*qmo*vpamo/mz**2*mmo**4+2*ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*c0zhqschchch*vpaup*cfq*(-1d0/2/ctw**2*vmach**
     & 2/mz**2*mch**4+1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-3d0/8/ctw
     & **2*vmach**2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mh**2*mch**2-1
     & d0/4/ctw**2*vpach*vmach*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mch**4
     & +1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*m
     & ch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vpaup*cfq*qs*(1d0/8/ctw**2*vmach
     & **2/mz**2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mch**2+1d0/8/ctw*
     & *2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*qup*cfq/qs*(-2*qch*vmach/mz**2*m
     & h**2*mch**4+2*qch*vmach*mch**4-2*qch*vpach/mz**2*mh**2*mch**4+2*q
     & ch*vpach*mch**4+2*ctw**2*qch*vmach/mz**2*mh**2*mch**4-2*ctw**2*qc
     & h*vmach*mch**4+2*ctw**2*qch*vpach/mz**2*mh**2*mch**4-2*ctw**2*qch
     & *vpach*mch**4)
     & +propizqs*det3izhqs*c0zhqschchch*qup*cfq*(-2*qch*vmach/mz**2*mch*
     & *4-2*qch*vmach*mch**2-2*qch*vpach/mz**2*mch**4-2*qch*vpach*mch**2
     & +2*ctw**2*qch*vmach/mz**2*mch**4+2*ctw**2*qch*vmach*mch**2+2*ctw*
     & *2*qch*vpach/mz**2*mch**4+2*ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*c0zhqsststst*vpaup*cfq*(-1d0/2/ctw**2*vmast**
     & 2/mz**2*mst**4+1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-3d0/8/ctw
     & **2*vmast**2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mh**2*mst**2-1
     & d0/4/ctw**2*vpast*vmast*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mst**4
     & +1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*m
     & st**2)
     & +propizqs*det3izhqs*c0zhqsststst*vpaup*cfq*qs*(1d0/8/ctw**2*vmast
     & **2/mz**2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mst**2+1d0/8/ctw*
     & *2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*qup*cfq/qs*(-2*qst*vmast/mz**2*m
     & h**2*mst**4+2*qst*vmast*mst**4-2*qst*vpast/mz**2*mh**2*mst**4+2*q
     & st*vpast*mst**4+2*ctw**2*qst*vmast/mz**2*mh**2*mst**4-2*ctw**2*qs
     & t*vmast*mst**4+2*ctw**2*qst*vpast/mz**2*mh**2*mst**4-2*ctw**2*qst
     & *vpast*mst**4)
     & +propizqs*det3izhqs*c0zhqsststst*qup*cfq*(-2*qst*vmast/mz**2*mst*
     & *4-2*qst*vmast*mst**2-2*qst*vpast/mz**2*mst**4-2*qst*vpast*mst**2
     & +2*ctw**2*qst*vmast/mz**2*mst**4+2*ctw**2*qst*vmast*mst**2+2*ctw*
     & *2*qst*vpast/mz**2*mst**4+2*ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*c0zhqstatata*vpaup*cfl*(-1d0/2/ctw**2*vmata**
     & 2/mz**2*mta**4+1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-3d0/8/ctw
     & **2*vmata**2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mh**2*mta**2-1
     & d0/4/ctw**2*vpata*vmata*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mta**4
     & +1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*m
     & ta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vpaup*cfl*qs*(1d0/8/ctw**2*vmata
     & **2/mz**2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mta**2+1d0/8/ctw*
     & *2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*qup*cfl/qs*(-2*qta*vmata/mz**2*m
     & h**2*mta**4+2*qta*vmata*mta**4-2*qta*vpata/mz**2*mh**2*mta**4+2*q
     & ta*vpata*mta**4+2*ctw**2*qta*vmata/mz**2*mh**2*mta**4-2*ctw**2*qt
     & a*vmata*mta**4+2*ctw**2*qta*vpata/mz**2*mh**2*mta**4-2*ctw**2*qta
     & *vpata*mta**4)
     & +propizqs*det3izhqs*c0zhqstatata*qup*cfl*(-2*qta*vmata/mz**2*mta*
     & *4-2*qta*vmata*mta**2-2*qta*vpata/mz**2*mta**4-2*qta*vpata*mta**2
     & +2*ctw**2*qta*vmata/mz**2*mta**4+2*ctw**2*qta*vmata*mta**2+2*ctw*
     & *2*qta*vpata/mz**2*mta**4+2*ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vpaup*cfq*(-1d0/2/ctw**2*vmatp**
     & 2/mz**2*mtp**4+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-3d0/8/ctw
     & **2*vmatp**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mh**2*mtp**2-1
     & d0/4/ctw**2*vpatp*vmatp*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**4
     & +1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*m
     & tp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vpaup*cfq*qs*(1d0/8/ctw**2*vmatp
     & **2/mz**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2+1d0/8/ctw*
     & *2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qup*cfq/qs*(-2*qtp*vmatp/mz**2*m
     & h**2*mtp**4+2*qtp*vmatp*mtp**4-2*qtp*vpatp/mz**2*mh**2*mtp**4+2*q
     & tp*vpatp*mtp**4+2*ctw**2*qtp*vmatp/mz**2*mh**2*mtp**4-2*ctw**2*qt
     & p*vmatp*mtp**4+2*ctw**2*qtp*vpatp/mz**2*mh**2*mtp**4-2*ctw**2*qtp
     & *vpatp*mtp**4)
     & +propizqs*det3izhqs*c0zhqstptptp*qup*cfq*(-2*qtp*vmatp/mz**2*mtp*
     & *4-2*qtp*vmatp*mtp**2-2*qtp*vpatp/mz**2*mtp**4-2*qtp*vpatp*mtp**2
     & +2*ctw**2*qtp*vmatp/mz**2*mtp**4+2*ctw**2*qtp*vmatp*mtp**2+2*ctw*
     & *2*qtp*vpatp/mz**2*mtp**4+2*ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vpaup*cfq*(-1d0/2/ctw**2*vmabt**
     & 2/mz**2*mbt**4+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-3d0/8/ctw
     & **2*vmabt**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mh**2*mbt**2-1
     & d0/4/ctw**2*vpabt*vmabt*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**4
     & +1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*m
     & bt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vpaup*cfq*qs*(1d0/8/ctw**2*vmabt
     & **2/mz**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2+1d0/8/ctw*
     & *2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup*cfq/qs*(-2*qbt*vmabt/mz**2*m
     & h**2*mbt**4+2*qbt*vmabt*mbt**4-2*qbt*vpabt/mz**2*mh**2*mbt**4+2*q
     & bt*vpabt*mbt**4+2*ctw**2*qbt*vmabt/mz**2*mh**2*mbt**4-2*ctw**2*qb
     & t*vmabt*mbt**4+2*ctw**2*qbt*vpabt/mz**2*mh**2*mbt**4-2*ctw**2*qbt
     & *vpabt*mbt**4)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup*cfq*(-2*qbt*vmabt/mz**2*mbt*
     & *4-2*qbt*vmabt*mbt**2-2*qbt*vpabt/mz**2*mbt**4-2*qbt*vpabt*mbt**2
     & +2*ctw**2*qbt*vmabt/mz**2*mbt**4+2*ctw**2*qbt*vmabt*mbt**2+2*ctw*
     & *2*qbt*vpabt/mz**2*mbt**4+2*ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*a0fh*vpaup*(-1d0/2/ctw**2/mz**2*mh**2-1d0/4/c
     & tw**2)
     & +propizqs*det3izhqs*a0fh*vpaup*qs*(-1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhww*vpaup*(1d0/4+1d0/8/ctw**2/mz**2*mh**2-
     & 1d0/2/mz**2*mh**2+1d0/2*ctw**2/mz**2*mh**2-ctw**2+3*ctw**4)
     & +propizqs*det3izhqs*b0fhww*qup/qs*(1d0/2*mh**2-3d0/2*ctw**2*mh**2
     & +ctw**2*mz**2+ctw**4*mh**2-7*ctw**4*mz**2+6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qup*(-1d0/2/mz**2*mh**2+3d0/2*ctw**2/m
     & z**2*mh**2-ctw**2-ctw**4/mz**2*mh**2+7*ctw**4-6*ctw**6)
     & +propizqs*det3izhqs*b0fhzz*vpaup*(9d0/16/ctw**2/mz**2*mh**2+3d0/8
     & /ctw**2)
     & +propizqs*det3izhqs*b0fhzz*vpaup*qs*(1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhhh*vpaup*(-21d0/16/ctw**2/mz**2*mh**2-3d0
     & /4/ctw**2)
     & +propizqs*det3izhqs*b0fhhh*vpaup*qs*(-3d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhmomo*vpaup*cfl*(-1d0/4/ctw**2*vmamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup*cfl/qs*(qmo*vmamo*mmo**2+qmo*vpa
     & mo*mmo**2-ctw**2*qmo*vmamo*mmo**2-ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup*cfl*(-qmo*vmamo/mz**2*mmo**2-qmo
     & *vpamo/mz**2*mmo**2+ctw**2*qmo*vmamo/mz**2*mmo**2+ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*vpaup*cfq*(-1d0/4/ctw**2*vmach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup*cfq/qs*(qch*vmach*mch**2+qch*vpa
     & ch*mch**2-ctw**2*qch*vmach*mch**2-ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup*cfq*(-qch*vmach/mz**2*mch**2-qch
     & *vpach/mz**2*mch**2+ctw**2*qch*vmach/mz**2*mch**2+ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*vpaup*cfq*(-1d0/4/ctw**2*vmast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup*cfq/qs*(qst*vmast*mst**2+qst*vpa
     & st*mst**2-ctw**2*qst*vmast*mst**2-ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup*cfq*(-qst*vmast/mz**2*mst**2-qst
     & *vpast/mz**2*mst**2+ctw**2*qst*vmast/mz**2*mst**2+ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*vpaup*cfl*(-1d0/4/ctw**2*vmata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup*cfl/qs*(qta*vmata*mta**2+qta*vpa
     & ta*mta**2-ctw**2*qta*vmata*mta**2-ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup*cfl*(-qta*vmata/mz**2*mta**2-qta
     & *vpata/mz**2*mta**2+ctw**2*qta*vmata/mz**2*mta**2+ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*vpaup*cfq*(-1d0/4/ctw**2*vmatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup*cfq/qs*(qtp*vmatp*mtp**2+qtp*vpa
     & tp*mtp**2-ctw**2*qtp*vmatp*mtp**2-ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup*cfq*(-qtp*vmatp/mz**2*mtp**2-qtp
     & *vpatp/mz**2*mtp**2+ctw**2*qtp*vmatp/mz**2*mtp**2+ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*vpaup*cfq*(-1d0/4/ctw**2*vmabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup*cfq/qs*(qbt*vmabt*mbt**2+qbt*vpa
     & bt*mbt**2-ctw**2*qbt*vmabt*mbt**2-ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup*cfq*(-qbt*vmabt/mz**2*mbt**2-qbt
     & *vpabt/mz**2*mbt**2+ctw**2*qbt*vmabt/mz**2*mbt**2+ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzww*vpaup*(1d0/2)
     & +propizqs*det3izhqs*b0fzww*qup/qs*(-1d0/2*mh**2+3d0/2*ctw**2*mh**
     & 2-ctw**2*mz**2-ctw**4*mh**2+7*ctw**4*mz**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fzzh*vpaup*(1d0/4/ctw**2/mz**2*mh**2+3d0/8/
     & ctw**2)
     & +propizqs*det3izhqs*b0fzzh*vpaup*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fzmomo*vpaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz
     & **2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2-1d0/8/ctw**2*vpa
     & mo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*qup*cfl/qs*(-qmo*vmamo*mmo**2-qmo*vp
     & amo*mmo**2+ctw**2*qmo*vmamo*mmo**2+ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*vpaup*cfq*(-1d0/8/ctw**2*vmach**2/mz
     & **2*mch**2+1d0/4/ctw**2*vpach*vmach/mz**2*mch**2-1d0/8/ctw**2*vpa
     & ch**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*qup*cfq/qs*(-qch*vmach*mch**2-qch*vp
     & ach*mch**2+ctw**2*qch*vmach*mch**2+ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fzstst*vpaup*cfq*(-1d0/8/ctw**2*vmast**2/mz
     & **2*mst**2+1d0/4/ctw**2*vpast*vmast/mz**2*mst**2-1d0/8/ctw**2*vpa
     & st**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*qup*cfq/qs*(-qst*vmast*mst**2-qst*vp
     & ast*mst**2+ctw**2*qst*vmast*mst**2+ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fztata*vpaup*cfl*(-1d0/8/ctw**2*vmata**2/mz
     & **2*mta**2+1d0/4/ctw**2*vpata*vmata/mz**2*mta**2-1d0/8/ctw**2*vpa
     & ta**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*qup*cfl/qs*(-qta*vmata*mta**2-qta*vp
     & ata*mta**2+ctw**2*qta*vmata*mta**2+ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fztptp*vpaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz
     & **2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2-1d0/8/ctw**2*vpa
     & tp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*qup*cfq/qs*(-qtp*vmatp*mtp**2-qtp*vp
     & atp*mtp**2+ctw**2*qtp*vmatp*mtp**2+ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*vpaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz
     & **2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2-1d0/8/ctw**2*vpa
     & bt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*qup*cfq/qs*(-qbt*vmabt*mbt**2-qbt*vp
     & abt*mbt**2+ctw**2*qbt*vmabt*mbt**2+ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*vpaup*(-3d0/4-1d0/8/ctw**2/mz**2*mh**
     & 2+1d0/2/mz**2*mh**2-1d0/2*ctw**2/mz**2*mh**2+ctw**2-3*ctw**4)
     & +propizqs*det3izhqs*b0fqsww*qup*(1d0/2/mz**2*mh**2-3d0/2*ctw**2/m
     & z**2*mh**2+ctw**2+ctw**4/mz**2*mh**2-7*ctw**4+6*ctw**6)
     & +propizqs*det3izhqs*b0fqszh*vpaup*(-1d0/4/ctw**2)
     & +propizqs*det3izhqs*b0fqszh*vpaup*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fqsmomo*vpaup*cfl*(3d0/8/ctw**2*vmamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2+3d0/8/ctw**2*vpa
     & mo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*qup*cfl*(qmo*vmamo/mz**2*mmo**2+qmo
     & *vpamo/mz**2*mmo**2-ctw**2*qmo*vmamo/mz**2*mmo**2-ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*vpaup*cfq*(3d0/8/ctw**2*vmach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mch**2+3d0/8/ctw**2*vpa
     & ch**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*qup*cfq*(qch*vmach/mz**2*mch**2+qch
     & *vpach/mz**2*mch**2-ctw**2*qch*vmach/mz**2*mch**2-ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*vpaup*cfq*(3d0/8/ctw**2*vmast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mst**2+3d0/8/ctw**2*vpa
     & st**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*qup*cfq*(qst*vmast/mz**2*mst**2+qst
     & *vpast/mz**2*mst**2-ctw**2*qst*vmast/mz**2*mst**2-ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*vpaup*cfl*(3d0/8/ctw**2*vmata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mta**2+3d0/8/ctw**2*vpa
     & ta**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*qup*cfl*(qta*vmata/mz**2*mta**2+qta
     & *vpata/mz**2*mta**2-ctw**2*qta*vmata/mz**2*mta**2-ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*vpaup*cfq*(3d0/8/ctw**2*vmatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2+3d0/8/ctw**2*vpa
     & tp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*qup*cfq*(qtp*vmatp/mz**2*mtp**2+qtp
     & *vpatp/mz**2*mtp**2-ctw**2*qtp*vmatp/mz**2*mtp**2-ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*vpaup*cfq*(3d0/8/ctw**2*vmabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2+3d0/8/ctw**2*vpa
     & bt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qup*cfq*(qbt*vmabt/mz**2*mbt**2+qbt
     & *vpabt/mz**2*mbt**2-ctw**2*qbt*vmabt/mz**2*mbt**2-ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*sdet3iczus*c0czuswcc*vpadn/qs*(-2*ctw**4*mz**2)
     & +propizqs*sdet3iczus*c0czuszcc*vpaup**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3iczus*c0czuscww*(4*sdet4izhtsus*ctw**6*mz**4)
     & +propizqs*sdet3iczus*b0fzww*(4*sdet4izhtsus*ctw**4*mz**2)
     & +propizqs*sdet3iczus*b0fzcc*vpadn/qs*(2*ctw**2)
     & +propizqs*sdet3iczus*b0fzcc*vpaup**3/qs*(1d0/ctw**2)
     & +propizqs*sdet3iczus*b0fuswc*vpadn/qs*(-2*ctw**2)
     & +propizqs*sdet3iczus*b0fuswc*(-4*sdet4izhtsus*ctw**4*mz**2)
     & +propizqs*sdet3iczus*b0fuszc*vpaup**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichts*c0chtscww*vpadn/qs*(-2*ctw**4*mz**2)
     & +propizqs*sdet3ichts*c0chtscww*(-4*sdet4izhtsus*ctw**6*mz**2*mh**
     & 2)
     & +propizqs*sdet3ichts*c0chtsczz*vpaup**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3ichts*b0fhww*vpadn/qs*(-2*ctw**2)
     & +propizqs*sdet3ichts*b0fhww*(-4*sdet4izhtsus*ctw**4*mh**2)
     & +propizqs*sdet3ichts*b0fhzz*vpaup**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichts*b0ftswc*vpadn/qs*(2*ctw**2)
     & +propizqs*sdet3ichts*b0ftswc*(4*sdet4izhtsus*ctw**4*mh**2)
     & +propizqs*sdet3ichts*b0ftszc*vpaup**3/qs*(1d0/ctw**2)
     & +propizqs*d0zchctsusccww*vpadn/qs*(-ctw**2*mh**2-ctw**2*us-ctw**4
     & *mz**2-2*sdet4izhtsus*ctw**4*mz**4*mh**2+2*sdet4izhtsus*ctw**4*mz
     & **6-2*sdet4izhtsus*ctw**4*ts*mz**2*mh**2+2*sdet4izhtsus*ctw**4*ts
     & *mz**4+sdet4izhtsus*ctw**6*mz**4*mh**2-sdet4izhtsus*ctw**6*mz**6+
     & sdet4izhtsus**2*ctw**6*mz**6*mh**4-3*sdet4izhtsus**2*ctw**6*mz**8
     & *mh**2-sdet4izhtsus**2*ctw**6*us*mz**8+sdet4izhtsus**2*ctw**6*ts*
     & mz**4*mh**4-2*sdet4izhtsus**2*ctw**6*ts*mz**6*mh**2)
     & +propizqs*d0zchctsusccww*vpadn*(-ctw**2-2*sdet4izhtsus*ctw**4*ts*
     & mz**2-sdet4izhtsus**2*ctw**6*us*mz**6+sdet4izhtsus**2*ctw**6*ts*m
     & z**4*mh**2-sdet4izhtsus**2*ctw**6*ts**2*mz**4)
     & +propizqs*d0zchctsuscczz*vpaup**3/qs*(-1d0/2/ctw**2*mh**2-1d0/2/c
     & tw**2*mz**2-1d0/2/ctw**2*us-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2
     & +1d0/2*sdet4izhtsus/ctw**2*mz**6-sdet4izhtsus/ctw**2*ts*mz**2*mh*
     & *2+sdet4izhtsus/ctw**2*ts*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*mz**
     & 6*mh**4-3d0/2*sdet4izhtsus**2/ctw**2*mz**8*mh**2-1d0/2*sdet4izhts
     & us**2/ctw**2*us*mz**8+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**4
     & -sdet4izhtsus**2/ctw**2*ts*mz**6*mh**2)
     & +propizqs*d0zchctsuscczz*vpaup**3*(-1d0/2/ctw**2-sdet4izhtsus/ctw
     & **2*ts*mz**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6+1d0/2*sdet4izh
     & tsus**2/ctw**2*ts*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*ts**2*
     & mz**4)
     & +propizqs*d0cchzqsuswcww/qs*(sdet4izhtsus*ctw**4*mz**2*mh**4-sdet
     & 4izhtsus*ctw**4*mz**4*mh**2+sdet4izhtsus*ctw**4*us*mz**2*mh**2-sd
     & et4izhtsus*ctw**4*us*mz**4-2*sdet4izhtsus*ctw**6*mz**2*mh**4+2*sd
     & et4izhtsus*ctw**6*mz**4*mh**2-2*sdet4izhtsus*ctw**6*us*mz**2*mh**
     & 2+2*sdet4izhtsus*ctw**6*us*mz**4-2*sdet4izhtsus*ctw**8*mz**4*mh**
     & 2+2*sdet4izhtsus*ctw**8*mz**6+2*sdet4izhtsus**2*ctw**8*mz**4*mh**
     & 6-4*sdet4izhtsus**2*ctw**8*mz**6*mh**4+2*sdet4izhtsus**2*ctw**8*m
     & z**8*mh**2+2*sdet4izhtsus**2*ctw**8*us*mz**4*mh**4-4*sdet4izhtsus
     & **2*ctw**8*us*mz**6*mh**2+2*sdet4izhtsus**2*ctw**8*us*mz**8)
     & +propizqs*d0cchzqsuswcww*(2*ctw**4+sdet4izhtsus*ctw**2*us*mh**2+s
     & det4izhtsus*ctw**2*us**2+5*sdet4izhtsus*ctw**4*mz**2*mh**2+3*sdet
     & 4izhtsus*ctw**4*us*mz**2-2*sdet4izhtsus*ctw**6*mz**2*mh**2+4*sdet
     & 4izhtsus*ctw**6*mz**4+4*sdet4izhtsus*ctw**6*ts*mz**2+2*sdet4izhts
     & us**2*ctw**4*mz**4*mh**4+2*sdet4izhtsus**2*ctw**4*us*mz**2*mh**4+
     & 4*sdet4izhtsus**2*ctw**4*us*mz**4*mh**2+4*sdet4izhtsus**2*ctw**4*
     & us**2*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*us**2*mz**4+2*sdet4izh
     & tsus**2*ctw**4*us**3*mz**2+4*sdet4izhtsus**2*ctw**6*mz**6*mh**2-4
     & *sdet4izhtsus**2*ctw**6*us*mz**4*mh**2-4*sdet4izhtsus**2*ctw**6*u
     & s**2*mz**4+4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh**2+2*sdet4izhtsus
     & **2*ctw**8*mz**4*mh**4-4*sdet4izhtsus**2*ctw**8*mz**6*mh**2+2*sde
     & t4izhtsus**2*ctw**8*us*mz**6-2*sdet4izhtsus**2*ctw**8*ts*mz**4*mh
     & **2+2*sdet4izhtsus**2*ctw**8*ts**2*mz**4)
     & +propizqs*d0cczhqstswcww/qs*(2*sdet4izhtsus*ctw**6*mz**4*mh**2-2*
     & sdet4izhtsus*ctw**6*mz**6+2*sdet4izhtsus*ctw**6*ts*mz**2*mh**2-2*
     & sdet4izhtsus*ctw**6*ts*mz**4-2*sdet4izhtsus*ctw**8*mz**4*mh**2+2*
     & sdet4izhtsus*ctw**8*mz**6-2*sdet4izhtsus**2*ctw**8*mz**6*mh**4+4*
     & sdet4izhtsus**2*ctw**8*mz**8*mh**2-2*sdet4izhtsus**2*ctw**8*mz**1
     & 0-2*sdet4izhtsus**2*ctw**8*ts*mz**4*mh**4+4*sdet4izhtsus**2*ctw**
     & 8*ts*mz**6*mh**2-2*sdet4izhtsus**2*ctw**8*ts*mz**8)
     & +propizqs*d0cczhqstswcww*(2*sdet4izhtsus*ctw**6*mz**4+4*sdet4izht
     & sus*ctw**6*ts*mz**2+2*sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2+4*sde
     & t4izhtsus**2*ctw**4*ts**2*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*ts
     & **2*mz**4+2*sdet4izhtsus**2*ctw**4*ts**3*mh**2+4*sdet4izhtsus**2*
     & ctw**4*ts**3*mz**2+2*sdet4izhtsus**2*ctw**4*ts**4+4*sdet4izhtsus*
     & *2*ctw**6*mz**6*mh**2+4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh**2-4*s
     & det4izhtsus**2*ctw**6*ts**2*mz**4-4*sdet4izhtsus**2*ctw**6*ts**3*
     & mz**2-2*sdet4izhtsus**2*ctw**8*mz**8+2*sdet4izhtsus**2*ctw**8*us*
     & mz**6-2*sdet4izhtsus**2*ctw**8*ts*mz**4*mh**2+2*sdet4izhtsus**2*c
     & tw**8*ts**2*mz**4)
     & +propizqs*c0zhqswww/qs*(sdet4izhtsus*ctw**2*mh**4-sdet4izhtsus*ct
     & w**2*mz**2*mh**2+sdet4izhtsus*ctw**2*us*mh**2-sdet4izhtsus*ctw**2
     & *us*mz**2-2*sdet4izhtsus*ctw**4*mh**4+4*sdet4izhtsus*ctw**4*mz**2
     & *mh**2-2*sdet4izhtsus*ctw**4*mz**4-2*sdet4izhtsus*ctw**4*us*mh**2
     & +2*sdet4izhtsus*ctw**4*us*mz**2+2*sdet4izhtsus*ctw**4*ts*mh**2-2*
     & sdet4izhtsus*ctw**4*ts*mz**2-4*sdet4izhtsus*ctw**6*mz**2*mh**2+4*
     & sdet4izhtsus*ctw**6*mz**4+2*sdet4izhtsus**2*ctw**6*mz**2*mh**6-6*
     & sdet4izhtsus**2*ctw**6*mz**4*mh**4+6*sdet4izhtsus**2*ctw**6*mz**6
     & *mh**2-2*sdet4izhtsus**2*ctw**6*mz**8+2*sdet4izhtsus**2*ctw**6*us
     & *mz**2*mh**4-4*sdet4izhtsus**2*ctw**6*us*mz**4*mh**2+2*sdet4izhts
     & us**2*ctw**6*us*mz**6-2*sdet4izhtsus**2*ctw**6*ts*mz**2*mh**4+4*s
     & det4izhtsus**2*ctw**6*ts*mz**4*mh**2-2*sdet4izhtsus**2*ctw**6*ts*
     & mz**6)
     & +propizqs*c0zhqswww*qup/qs*(-4*ctw**2+28*ctw**4-24*ctw**6)
     & +propizqs*c0zhqswww*(sdet4izhtsus*ctw**2*mh**2-sdet4izhtsus*ctw**
     & 2*us-2*sdet4izhtsus*ctw**4*mh**2-2*sdet4izhtsus*ctw**4*mz**2+2*sd
     & et4izhtsus*ctw**4*ts+4*sdet4izhtsus**2*ctw**4*mz**4*mh**2-2*sdet4
     & izhtsus**2*ctw**4*us*mz**2*mh**2-2*sdet4izhtsus**2*ctw**4*us**2*m
     & z**2+4*sdet4izhtsus**2*ctw**4*ts*mz**2*mh**2-2*sdet4izhtsus**2*ct
     & w**4*ts**2*mz**2-2*sdet4izhtsus**2*ctw**4*ts**3+2*sdet4izhtsus**2
     & *ctw**6*mz**2*mh**4-4*sdet4izhtsus**2*ctw**6*mz**4*mh**2-2*sdet4i
     & zhtsus**2*ctw**6*mz**6+4*sdet4izhtsus**2*ctw**6*us*mz**4-4*sdet4i
     & zhtsus**2*ctw**6*ts*mz**2*mh**2+4*sdet4izhtsus**2*ctw**6*ts**2*mz
     & **2)
     & +propizqs*c0zhqsmomomo*qup*cfl/qs*(-2*qmo*vmamo/mz**2*mmo**2-2*qm
     & o*vpamo/mz**2*mmo**2+2*ctw**2*qmo*vmamo/mz**2*mmo**2+2*ctw**2*qmo
     & *vpamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qup*cfq/qs*(-2*qch*vmach/mz**2*mch**2-2*qc
     & h*vpach/mz**2*mch**2+2*ctw**2*qch*vmach/mz**2*mch**2+2*ctw**2*qch
     & *vpach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qup*cfq/qs*(-2*qst*vmast/mz**2*mst**2-2*qs
     & t*vpast/mz**2*mst**2+2*ctw**2*qst*vmast/mz**2*mst**2+2*ctw**2*qst
     & *vpast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qup*cfl/qs*(-2*qta*vmata/mz**2*mta**2-2*qt
     & a*vpata/mz**2*mta**2+2*ctw**2*qta*vmata/mz**2*mta**2+2*ctw**2*qta
     & *vpata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qup*cfq/qs*(-2*qtp*vmatp/mz**2*mtp**2-2*qt
     & p*vpatp/mz**2*mtp**2+2*ctw**2*qtp*vmatp/mz**2*mtp**2+2*ctw**2*qtp
     & *vpatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qup*cfq/qs*(-2*qbt*vmabt/mz**2*mbt**2-2*qb
     & t*vpabt/mz**2*mbt**2+2*ctw**2*qbt*vmabt/mz**2*mbt**2+2*ctw**2*qbt
     & *vpabt/mz**2*mbt**2)
     & +propizqs*c0chtscww/qs*(2*ctw**4+2*sdet4izhtsus*ctw**6*mz**4+2*sd
     & et4izhtsus*ctw**6*ts*mz**2)
     & +propizqs*c0chtscww*vpadn/qs*(ctw**2-sdet4izhtsus*ctw**4*mz**4-sd
     & et4izhtsus*ctw**4*ts*mz**2-sdet4izhtsus**2*ctw**4*mz**4*mh**4-sde
     & t4izhtsus**2*ctw**4*mz**6*mh**2-sdet4izhtsus**2*ctw**4*us*mz**4*m
     & h**2-sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2)
     & +propizqs*c0chtscww*vpadn*(-sdet4izhtsus*ctw**2*ts-sdet4izhtsus**
     & 2*ctw**4*ts**2*mz**2)
     & +propizqs*c0chtscww*(-2*sdet4izhtsus*ctw**4*ts+4*sdet4izhtsus*ctw
     & **6*mz**2+2*sdet4izhtsus**2*ctw**4*ts*mz**2*mh**2+2*sdet4izhtsus*
     & *2*ctw**4*ts**2*mh**2+2*sdet4izhtsus**2*ctw**4*ts**2*mz**2+2*sdet
     & 4izhtsus**2*ctw**4*ts**3+2*sdet4izhtsus**2*ctw**6*mz**4*mh**2-2*s
     & det4izhtsus**2*ctw**6*ts**2*mz**2)
     & +propizqs*c0chtsczz*vpaup**3/qs*(1d0/2/ctw**2-1d0/2*sdet4izhtsus/
     & ctw**2*mz**4-1d0/2*sdet4izhtsus/ctw**2*ts*mz**2-1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**4*mh**4-1d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2
     & /ctw**2*ts*mz**4*mh**2)
     & +propizqs*c0chtsczz*vpaup**3*(-1d0/2*sdet4izhtsus/ctw**2*ts-1d0/2
     & *sdet4izhtsus**2/ctw**2*ts**2*mz**2)
     & +propizqs*c0chuscww/qs*(ctw**2-2*ctw**4-sdet4izhtsus*ctw**2*mh**4
     & +sdet4izhtsus*ctw**2*mz**2*mh**2-sdet4izhtsus*ctw**2*us*mh**2+sde
     & t4izhtsus*ctw**2*us*mz**2+2*sdet4izhtsus*ctw**4*mh**4-2*sdet4izht
     & sus*ctw**4*mz**2*mh**2+2*sdet4izhtsus*ctw**4*us*mh**2-2*sdet4izht
     & sus*ctw**4*us*mz**2+4*sdet4izhtsus*ctw**6*mz**2*mh**2-2*sdet4izht
     & sus*ctw**6*mz**4+2*sdet4izhtsus*ctw**6*us*mz**2-2*sdet4izhtsus**2
     & *ctw**6*mz**2*mh**6+4*sdet4izhtsus**2*ctw**6*mz**4*mh**4-2*sdet4i
     & zhtsus**2*ctw**6*mz**6*mh**2-2*sdet4izhtsus**2*ctw**6*us*mz**2*mh
     & **4+4*sdet4izhtsus**2*ctw**6*us*mz**4*mh**2-2*sdet4izhtsus**2*ctw
     & **6*us*mz**6)
     & +propizqs*c0chuscww*vpadn/qs*(-ctw**2-2*sdet4izhtsus*ctw**2*mz**2
     & *mh**2-sdet4izhtsus*ctw**2*us*mz**2-sdet4izhtsus*ctw**2*ts*mh**2+
     & sdet4izhtsus*ctw**4*mz**2*mh**2-2*sdet4izhtsus*ctw**4*mz**4-sdet4
     & izhtsus*ctw**4*ts*mz**2+2*sdet4izhtsus**2*ctw**4*mz**4*mh**4-2*sd
     & et4izhtsus**2*ctw**4*mz**6*mh**2+sdet4izhtsus**2*ctw**4*us*mz**4*
     & mh**2-sdet4izhtsus**2*ctw**4*us*mz**6+sdet4izhtsus**2*ctw**4*ts*m
     & z**2*mh**4-sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2)
     & +propizqs*c0chuscww*vpadn*(-sdet4izhtsus**2*ctw**4*us*mz**4+sdet4
     & izhtsus**2*ctw**4*ts*mz**2*mh**2)
     & +propizqs*c0chuscww*(sdet4izhtsus*ctw**2*us+2*sdet4izhtsus*ctw**4
     & *mh**2+2*sdet4izhtsus*ctw**6*mz**2+2*sdet4izhtsus**2*ctw**4*mz**2
     & *mh**4+4*sdet4izhtsus**2*ctw**4*us*mz**2*mh**2+2*sdet4izhtsus**2*
     & ctw**4*us**2*mz**2-2*sdet4izhtsus**2*ctw**6*mz**2*mh**4+2*sdet4iz
     & htsus**2*ctw**6*mz**4*mh**2-2*sdet4izhtsus**2*ctw**6*us*mz**4+2*s
     & det4izhtsus**2*ctw**6*ts*mz**2*mh**2)
     & +propizqs*c0chusczz*vpaup**3/qs*(-1d0/2/ctw**2-1d0/2*sdet4izhtsus
     & /ctw**2*mz**2*mh**2-sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsus/
     & ctw**2*us*mz**2-1d0/2*sdet4izhtsus/ctw**2*ts*mh**2-1d0/2*sdet4izh
     & tsus/ctw**2*ts*mz**2+sdet4izhtsus**2/ctw**2*mz**4*mh**4-sdet4izht
     & sus**2/ctw**2*mz**6*mh**2+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*m
     & h**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6+1d0/2*sdet4izhtsus**2/
     & ctw**2*ts*mz**2*mh**4-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2
     & )
     & +propizqs*c0chusczz*vpaup**3*(-1d0/2*sdet4izhtsus**2/ctw**2*us*mz
     & **4+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**2*mh**2)
     & +propizqs*c0cztswcc*vpadn/qs*(ctw**2+sdet4izhtsus*ctw**2*mz**2*mh
     & **2-sdet4izhtsus*ctw**2*mz**4+sdet4izhtsus*ctw**2*ts*mh**2-sdet4i
     & zhtsus*ctw**2*ts*mz**2-sdet4izhtsus*ctw**4*mz**2*mh**2+2*sdet4izh
     & tsus*ctw**4*mz**4+sdet4izhtsus*ctw**4*ts*mz**2-sdet4izhtsus**2*ct
     & w**4*mz**4*mh**4+3*sdet4izhtsus**2*ctw**4*mz**6*mh**2+sdet4izhtsu
     & s**2*ctw**4*us*mz**6-sdet4izhtsus**2*ctw**4*ts*mz**2*mh**4+2*sdet
     & 4izhtsus**2*ctw**4*ts*mz**4*mh**2)
     & +propizqs*c0cztswcc*vpadn*(sdet4izhtsus*ctw**2*ts-sdet4izhtsus**2
     & *ctw**4*ts*mz**2*mh**2+sdet4izhtsus**2*ctw**4*ts*mz**4+sdet4izhts
     & us**2*ctw**4*ts**2*mz**2)
     & +propizqs*c0cztszcc*vpaup**3/qs*(1d0/2/ctw**2+1d0/2*sdet4izhtsus/
     & ctw**2*mz**4+1d0/2*sdet4izhtsus/ctw**2*ts*mh**2-1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**4*mh**4+3d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2+
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6-1d0/2*sdet4izhtsus**2/ctw**
     & 2*ts*mz**2*mh**4+sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2)
     & +propizqs*c0cztszcc*vpaup**3*(1d0/2*sdet4izhtsus/ctw**2*ts-1d0/2*
     & sdet4izhtsus**2/ctw**2*ts*mz**2*mh**2+1d0/2*sdet4izhtsus**2/ctw**
     & 2*ts*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*ts**2*mz**2)
     & +propizqs*c0cztscww/qs*(-2*ctw**4-2*sdet4izhtsus*ctw**4*mz**2*mh*
     & *2+2*sdet4izhtsus*ctw**4*mz**4-2*sdet4izhtsus*ctw**4*ts*mh**2+2*s
     & det4izhtsus*ctw**4*ts*mz**2+2*sdet4izhtsus*ctw**6*mz**2*mh**2-4*s
     & det4izhtsus*ctw**6*mz**4-2*sdet4izhtsus*ctw**6*ts*mz**2+2*sdet4iz
     & htsus**2*ctw**6*mz**4*mh**4-4*sdet4izhtsus**2*ctw**6*mz**6*mh**2+
     & 2*sdet4izhtsus**2*ctw**6*mz**8+2*sdet4izhtsus**2*ctw**6*ts*mz**2*
     & mh**4-4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh**2+2*sdet4izhtsus**2*c
     & tw**6*ts*mz**6)
     & +propizqs*c0cztscww*(-2*sdet4izhtsus*ctw**4*ts+2*sdet4izhtsus**2*
     & ctw**4*ts*mz**4+4*sdet4izhtsus**2*ctw**4*ts**2*mz**2+2*sdet4izhts
     & us**2*ctw**4*ts**3+2*sdet4izhtsus**2*ctw**6*mz**6+2*sdet4izhtsus*
     & *2*ctw**6*ts*mz**2*mh**2-2*sdet4izhtsus**2*ctw**6*ts*mz**4-2*sdet
     & 4izhtsus**2*ctw**6*ts**2*mz**2)
     & +propizqs*c0czuswcc*vpadn/qs*(-ctw**2+sdet4izhtsus*ctw**2*mz**2*m
     & h**2+sdet4izhtsus*ctw**2*mz**4+sdet4izhtsus*ctw**2*us*mz**2+sdet4
     & izhtsus*ctw**2*ts*mz**2+sdet4izhtsus*ctw**4*mz**4+sdet4izhtsus*ct
     & w**4*ts*mz**2)
     & +propizqs*c0czuswcc*vpadn*(sdet4izhtsus**2*ctw**4*us*mz**4-sdet4i
     & zhtsus**2*ctw**4*ts*mz**4)
     & +propizqs*c0czuszcc*vpaup**3/qs*(-1d0/2/ctw**2+1d0/2*sdet4izhtsus
     & /ctw**2*mz**2*mh**2+sdet4izhtsus/ctw**2*mz**4+1d0/2*sdet4izhtsus/
     & ctw**2*us*mz**2+sdet4izhtsus/ctw**2*ts*mz**2)
     & +propizqs*c0czuszcc*vpaup**3*(1d0/2*sdet4izhtsus**2/ctw**2*us*mz*
     & *4-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4)
     & +propizqs*c0czuscww/qs*(-ctw**2+2*ctw**4-2*sdet4izhtsus*ctw**6*mz
     & **2*mh**2-2*sdet4izhtsus*ctw**6*us*mz**2)
     & +propizqs*c0czuscww*(sdet4izhtsus*ctw**2*us+2*sdet4izhtsus*ctw**4
     & *mz**2-2*sdet4izhtsus*ctw**6*mz**2+2*sdet4izhtsus**2*ctw**4*mz**4
     & *mh**2+2*sdet4izhtsus**2*ctw**4*us*mz**2*mh**2+2*sdet4izhtsus**2*
     & ctw**4*us*mz**4+2*sdet4izhtsus**2*ctw**4*us**2*mz**2-2*sdet4izhts
     & us**2*ctw**6*us*mz**4+2*sdet4izhtsus**2*ctw**6*ts*mz**4)
     & +propizqs*c0ccqswcw*(-sdet4izhtsus*ctw**2*mh**2-sdet4izhtsus*ctw*
     & *2*us-4*sdet4izhtsus*ctw**4*mz**2-2*sdet4izhtsus*ctw**4*ts-2*sdet
     & 4izhtsus**2*ctw**4*mz**2*mh**4-6*sdet4izhtsus**2*ctw**4*mz**4*mh*
     & *2-4*sdet4izhtsus**2*ctw**4*us*mz**2*mh**2-2*sdet4izhtsus**2*ctw*
     & *4*us*mz**4-2*sdet4izhtsus**2*ctw**4*us**2*mz**2-6*sdet4izhtsus**
     & 2*ctw**4*ts*mz**2*mh**2-2*sdet4izhtsus**2*ctw**4*ts*mz**4-2*sdet4
     & izhtsus**2*ctw**4*ts**2*mh**2-4*sdet4izhtsus**2*ctw**4*ts**2*mz**
     & 2-2*sdet4izhtsus**2*ctw**4*ts**3)
     & +propizqs*b0fhww*vpadn/qs*(-2*sdet4izhtsus*ctw**2*mz**2-2*sdet4iz
     & htsus*ctw**2*ts)
     & +propizqs*b0fhww*(4*sdet4izhtsus*ctw**4)
     & +propizqs*b0fhzz*vpaup**3/qs*(-sdet4izhtsus/ctw**2*mz**2-sdet4izh
     & tsus/ctw**2*ts)
     & +propizqs*b0fzcc*vpadn/qs*(-2*sdet4izhtsus*ctw**2*mz**2-2*sdet4iz
     & htsus*ctw**2*ts)
     & +propizqs*b0fzcc*vpaup**3/qs*(-sdet4izhtsus/ctw**2*mz**2-sdet4izh
     & tsus/ctw**2*ts)
     & +propizqs*b0ftswc*vpadn/qs*(2*sdet4izhtsus*ctw**2*mz**2+2*sdet4iz
     & htsus*ctw**2*ts)
     & +propizqs*b0ftswc*(-4*sdet4izhtsus*ctw**4)
     & +propizqs*b0ftszc*vpaup**3/qs*(sdet4izhtsus/ctw**2*mz**2+sdet4izh
     & tsus/ctw**2*ts)
     & +propizqs*b0fuswc*vpadn/qs*(2*sdet4izhtsus*ctw**2*mz**2+2*sdet4iz
     & htsus*ctw**2*ts)
     & +propizqs*b0fuszc*vpaup**3/qs*(sdet4izhtsus/ctw**2*mz**2+sdet4izh
     & tsus/ctw**2*ts)
     & +det3izhqs*vpaup*(-7d0/8/ctw**2*mh**2+1d0/4/ctw**2*mz**2+3d0/4*mh
     & **2+1d0/2*mz**2-2*ctw**2*mz**2-3*ctw**4*mh**2+6*ctw**4*mz**2)
     & +det3izhqs*vpaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d
     & 0/2/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt*
     & *2-1d0/2/ctw**2*vpabt**2*mbt**2+1d0/4/ctw**2*vmatp**2/mz**2*mh**2
     & *mtp**2-1d0/2/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*
     & mh**2*mtp**2-1d0/2/ctw**2*vpatp**2*mtp**2+1d0/4/ctw**2*vmast**2/m
     & z**2*mh**2*mst**2-1d0/2/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast
     & **2/mz**2*mh**2*mst**2-1d0/2/ctw**2*vpast**2*mst**2+1d0/4/ctw**2*
     & vmach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vmach**2*mch**2+1d0/4/ct
     & w**2*vpach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vpach**2*mch**2)
     & +det3izhqs*vpaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d
     & 0/2/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta*
     & *2-1d0/2/ctw**2*vpata**2*mta**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2
     & *mmo**2-1d0/2/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*
     & mh**2*mmo**2-1d0/2/ctw**2*vpamo**2*mmo**2)
     & +det3izhqs**2*c0zhqswww*vpaup*(-3d0/2/ctw**2*mz**6*mh**2+21d0/4*m
     & z**6*mh**2-3*ctw**2*mz**6*mh**2-9*ctw**4*mz**6*mh**2)
     & +det3izhqs**2*c0zhqszhh*vpaup*(-9/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqshzz*vpaup*(-18/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqsmomomo*vpaup*cfl*(3d0/4/ctw**2*vmamo**2*mz**4
     & *mh**2*mmo**2+3d0/4/ctw**2*vpamo**2*mz**4*mh**2*mmo**2)
     & +det3izhqs**2*c0zhqschchch*vpaup*cfq*(3d0/4/ctw**2*vmach**2*mz**4
     & *mh**2*mch**2+3d0/4/ctw**2*vpach**2*mz**4*mh**2*mch**2)
     & +det3izhqs**2*c0zhqsststst*vpaup*cfq*(3d0/4/ctw**2*vmast**2*mz**4
     & *mh**2*mst**2+3d0/4/ctw**2*vpast**2*mz**4*mh**2*mst**2)
     & +det3izhqs**2*c0zhqstatata*vpaup*cfl*(3d0/4/ctw**2*vmata**2*mz**4
     & *mh**2*mta**2+3d0/4/ctw**2*vpata**2*mz**4*mh**2*mta**2)
     & +det3izhqs**2*c0zhqstptptp*vpaup*cfq*(3d0/4/ctw**2*vmatp**2*mz**4
     & *mh**2*mtp**2+3d0/4/ctw**2*vpatp**2*mz**4*mh**2*mtp**2)
     & +det3izhqs**2*c0zhqsbtbtbt*vpaup*cfq*(3d0/4/ctw**2*vmabt**2*mz**4
     & *mh**2*mbt**2+3d0/4/ctw**2*vpabt**2*mz**4*mh**2*mbt**2)
     & +det3izhqs**2*b0fhww*vpaup*(3d0/2/ctw**2*mz**4*mh**2-21d0/4*mz**4
     & *mh**2+3*ctw**2*mz**4*mh**2+9*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fhzz*vpaup*(9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhhh*vpaup*(-9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhmomo*vpaup*cfl*(-3d0/4/ctw**2*vmamo**2*mz**2*mh
     & **2*mmo**2-3d0/4/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fhchch*vpaup*cfq*(-3d0/4/ctw**2*vmach**2*mz**2*mh
     & **2*mch**2-3d0/4/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fhstst*vpaup*cfq*(-3d0/4/ctw**2*vmast**2*mz**2*mh
     & **2*mst**2-3d0/4/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fhtata*vpaup*cfl*(-3d0/4/ctw**2*vmata**2*mz**2*mh
     & **2*mta**2-3d0/4/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fhtptp*vpaup*cfq*(-3d0/4/ctw**2*vmatp**2*mz**2*mh
     & **2*mtp**2-3d0/4/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fhbtbt*vpaup*cfq*(-3d0/4/ctw**2*vmabt**2*mz**2*mh
     & **2*mbt**2-3d0/4/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fzww*vpaup*(-3d0/4/ctw**2*mz**4*mh**2+21d0/8*mz**
     & 4*mh**2-3d0/2*ctw**2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fzmomo*vpaup*cfl*(3d0/8/ctw**2*vmamo**2*mz**2*mh*
     & *2*mmo**2+3d0/8/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fzchch*vpaup*cfq*(3d0/8/ctw**2*vmach**2*mz**2*mh*
     & *2*mch**2+3d0/8/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fzstst*vpaup*cfq*(3d0/8/ctw**2*vmast**2*mz**2*mh*
     & *2*mst**2+3d0/8/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fztata*vpaup*cfl*(3d0/8/ctw**2*vmata**2*mz**2*mh*
     & *2*mta**2+3d0/8/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fztptp*vpaup*cfq*(3d0/8/ctw**2*vmatp**2*mz**2*mh*
     & *2*mtp**2+3d0/8/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fzbtbt*vpaup*cfq*(3d0/8/ctw**2*vmabt**2*mz**2*mh*
     & *2*mbt**2+3d0/8/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fqsww*vpaup*(-3d0/4/ctw**2*mz**4*mh**2+21d0/8*mz*
     & *4*mh**2-3d0/2*ctw**2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fqsmomo*vpaup*cfl*(3d0/8/ctw**2*vmamo**2*mz**2*mh
     & **2*mmo**2+3d0/8/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fqschch*vpaup*cfq*(3d0/8/ctw**2*vmach**2*mz**2*mh
     & **2*mch**2+3d0/8/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fqsstst*vpaup*cfq*(3d0/8/ctw**2*vmast**2*mz**2*mh
     & **2*mst**2+3d0/8/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fqstata*vpaup*cfl*(3d0/8/ctw**2*vmata**2*mz**2*mh
     & **2*mta**2+3d0/8/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fqstptp*vpaup*cfq*(3d0/8/ctw**2*vmatp**2*mz**2*mh
     & **2*mtp**2+3d0/8/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fqsbtbt*vpaup*cfq*(3d0/8/ctw**2*vmabt**2*mz**2*mh
     & **2*mbt**2+3d0/8/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*c0zhqswww*vpaup*(1d0/2/ctw**2*mz**2*mh**2+3d0/2/ctw**2
     & *mz**4-1d0/2*mz**2*mh**2-5*mz**4+1d0/2*ctw**2*mz**2*mh**2+ctw**2*
     & mz**4+16*ctw**4*mz**4+6*ctw**6*mz**2*mh**2-12*ctw**6*mz**4)
     & +det3izhqs*c0zhqszhh*vpaup*(51d0/4/ctw**2*mz**2*mh**2+9/ctw**2*mz
     & **4)
     & +det3izhqs*c0zhqshzz*vpaup*(17/ctw**2*mz**2*mh**2+18/ctw**2*mz**4
     & )
     & +det3izhqs*c0zhqsmomomo*vpaup*cfl*(-1d0/2/ctw**2*vmamo**2/mz**2*m
     & h**2*mmo**4+1d0/ctw**2*vmamo**2*mmo**4-1d0/4/ctw**2*vmamo**2*mh**
     & 2*mmo**2-1d0/ctw**2*vmamo**2*mz**2*mmo**2+1d0/2/ctw**2*vpamo*vmam
     & o*mh**2*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mh**2*mmo**4+1d0/ctw**
     & 2*vpamo**2*mmo**4-1d0/4/ctw**2*vpamo**2*mh**2*mmo**2-1d0/ctw**2*v
     & pamo**2*mz**2*mmo**2)
     & +det3izhqs*c0zhqschchch*vpaup*cfq*(-1d0/2/ctw**2*vmach**2/mz**2*m
     & h**2*mch**4+1d0/ctw**2*vmach**2*mch**4-1d0/4/ctw**2*vmach**2*mh**
     & 2*mch**2-1d0/ctw**2*vmach**2*mz**2*mch**2+1d0/2/ctw**2*vpach*vmac
     & h*mh**2*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mh**2*mch**4+1d0/ctw**
     & 2*vpach**2*mch**4-1d0/4/ctw**2*vpach**2*mh**2*mch**2-1d0/ctw**2*v
     & pach**2*mz**2*mch**2)
     & +det3izhqs*c0zhqsststst*vpaup*cfq*(-1d0/2/ctw**2*vmast**2/mz**2*m
     & h**2*mst**4+1d0/ctw**2*vmast**2*mst**4-1d0/4/ctw**2*vmast**2*mh**
     & 2*mst**2-1d0/ctw**2*vmast**2*mz**2*mst**2+1d0/2/ctw**2*vpast*vmas
     & t*mh**2*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mh**2*mst**4+1d0/ctw**
     & 2*vpast**2*mst**4-1d0/4/ctw**2*vpast**2*mh**2*mst**2-1d0/ctw**2*v
     & past**2*mz**2*mst**2)
     & +det3izhqs*c0zhqstatata*vpaup*cfl*(-1d0/2/ctw**2*vmata**2/mz**2*m
     & h**2*mta**4+1d0/ctw**2*vmata**2*mta**4-1d0/4/ctw**2*vmata**2*mh**
     & 2*mta**2-1d0/ctw**2*vmata**2*mz**2*mta**2+1d0/2/ctw**2*vpata*vmat
     & a*mh**2*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mh**2*mta**4+1d0/ctw**
     & 2*vpata**2*mta**4-1d0/4/ctw**2*vpata**2*mh**2*mta**2-1d0/ctw**2*v
     & pata**2*mz**2*mta**2)
     & +det3izhqs*c0zhqstptptp*vpaup*cfq*(-1d0/2/ctw**2*vmatp**2/mz**2*m
     & h**2*mtp**4+1d0/ctw**2*vmatp**2*mtp**4-1d0/4/ctw**2*vmatp**2*mh**
     & 2*mtp**2-1d0/ctw**2*vmatp**2*mz**2*mtp**2+1d0/2/ctw**2*vpatp*vmat
     & p*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mh**2*mtp**4+1d0/ctw**
     & 2*vpatp**2*mtp**4-1d0/4/ctw**2*vpatp**2*mh**2*mtp**2-1d0/ctw**2*v
     & patp**2*mz**2*mtp**2)
     & +det3izhqs*c0zhqsbtbtbt*vpaup*cfq*(-1d0/2/ctw**2*vmabt**2/mz**2*m
     & h**2*mbt**4+1d0/ctw**2*vmabt**2*mbt**4-1d0/4/ctw**2*vmabt**2*mh**
     & 2*mbt**2-1d0/ctw**2*vmabt**2*mz**2*mbt**2+1d0/2/ctw**2*vpabt*vmab
     & t*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mh**2*mbt**4+1d0/ctw**
     & 2*vpabt**2*mbt**4-1d0/4/ctw**2*vpabt**2*mh**2*mbt**2-1d0/ctw**2*v
     & pabt**2*mz**2*mbt**2)
     & +det3izhqs*a0fz*vpaup*(-1d0/4/ctw**2*mh**2+1d0/4/ctw**2*mz**2)
     & +det3izhqs*a0fh*vpaup*(3d0/4/ctw**2*mh**2)
     & +det3izhqs*b0fhww*vpaup*(-1d0/4/ctw**2*mh**2-3d0/2/ctw**2*mz**2+1
     & 1d0/2*mz**2-ctw**2*mh**2-4*ctw**2*mz**2-6*ctw**4*mz**2)
     & +det3izhqs*b0fhzz*vpaup*(-21d0/8/ctw**2*mh**2-17d0/4/ctw**2*mz**2
     & )
     & +det3izhqs*b0fhhh*vpaup*(33d0/8/ctw**2*mh**2+9d0/2/ctw**2*mz**2)
     & +det3izhqs*b0fhmomo*vpaup*cfl*(1d0/4/ctw**2*vmamo**2/mz**2*mh**2*
     & mmo**2+1d0/2/ctw**2*vmamo**2*mmo**2-1d0/2/ctw**2*vpamo*vmamo/mz**
     & 2*mh**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2+1d0/2/ctw
     & **2*vpamo**2*mmo**2)
     & +det3izhqs*b0fhchch*vpaup*cfq*(1d0/4/ctw**2*vmach**2/mz**2*mh**2*
     & mch**2+1d0/2/ctw**2*vmach**2*mch**2-1d0/2/ctw**2*vpach*vmach/mz**
     & 2*mh**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2+1d0/2/ctw
     & **2*vpach**2*mch**2)
     & +det3izhqs*b0fhstst*vpaup*cfq*(1d0/4/ctw**2*vmast**2/mz**2*mh**2*
     & mst**2+1d0/2/ctw**2*vmast**2*mst**2-1d0/2/ctw**2*vpast*vmast/mz**
     & 2*mh**2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2*mst**2+1d0/2/ctw
     & **2*vpast**2*mst**2)
     & +det3izhqs*b0fhtata*vpaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mh**2*
     & mta**2+1d0/2/ctw**2*vmata**2*mta**2-1d0/2/ctw**2*vpata*vmata/mz**
     & 2*mh**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta**2+1d0/2/ctw
     & **2*vpata**2*mta**2)
     & +det3izhqs*b0fhtptp*vpaup*cfq*(1d0/4/ctw**2*vmatp**2/mz**2*mh**2*
     & mtp**2+1d0/2/ctw**2*vmatp**2*mtp**2-1d0/2/ctw**2*vpatp*vmatp/mz**
     & 2*mh**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mh**2*mtp**2+1d0/2/ctw
     & **2*vpatp**2*mtp**2)
     & +det3izhqs*b0fhbtbt*vpaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mh**2*
     & mbt**2+1d0/2/ctw**2*vmabt**2*mbt**2-1d0/2/ctw**2*vpabt*vmabt/mz**
     & 2*mh**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt**2+1d0/2/ctw
     & **2*vpabt**2*mbt**2)
     & +det3izhqs*b0fzww*vpaup*(1d0/8/ctw**2*mh**2+3d0/4/ctw**2*mz**2-11
     & d0/4*mz**2+1d0/2*ctw**2*mh**2+2*ctw**2*mz**2+3*ctw**4*mz**2)
     & +det3izhqs*b0fzzh*vpaup*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fzmomo*vpaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh**2
     & *mmo**2-1d0/4/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz*
     & *2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ct
     & w**2*vpamo**2*mmo**2)
     & +det3izhqs*b0fzchch*vpaup*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh**2
     & *mch**2-1d0/4/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpach*vmach/mz*
     & *2*mh**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ct
     & w**2*vpach**2*mch**2)
     & +det3izhqs*b0fzstst*vpaup*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh**2
     & *mst**2-1d0/4/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast*vmast/mz*
     & *2*mh**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ct
     & w**2*vpast**2*mst**2)
     & +det3izhqs*b0fztata*vpaup*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh**2
     & *mta**2-1d0/4/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata*vmata/mz*
     & *2*mh**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ct
     & w**2*vpata**2*mta**2)
     & +det3izhqs*b0fztptp*vpaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh**2
     & *mtp**2-1d0/4/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz*
     & *2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ct
     & w**2*vpatp**2*mtp**2)
     & +det3izhqs*b0fzbtbt*vpaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh**2
     & *mbt**2-1d0/4/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz*
     & *2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ct
     & w**2*vpabt**2*mbt**2)
     & +det3izhqs*b0fqsww*vpaup*(1d0/8/ctw**2*mh**2+3d0/4/ctw**2*mz**2-1
     & 1d0/4*mz**2+1d0/2*ctw**2*mh**2+2*ctw**2*mz**2+3*ctw**4*mz**2)
     & +det3izhqs*b0fqszh*vpaup*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fqsmomo*vpaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh**
     & 2*mmo**2-1d0/4/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz
     & **2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/c
     & tw**2*vpamo**2*mmo**2)
     & +det3izhqs*b0fqschch*vpaup*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh**
     & 2*mch**2-1d0/4/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpach*vmach/mz
     & **2*mh**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/c
     & tw**2*vpach**2*mch**2)
     & +det3izhqs*b0fqsstst*vpaup*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh**
     & 2*mst**2-1d0/4/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast*vmast/mz
     & **2*mh**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/c
     & tw**2*vpast**2*mst**2)
     & +det3izhqs*b0fqstata*vpaup*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh**
     & 2*mta**2-1d0/4/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata*vmata/mz
     & **2*mh**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/c
     & tw**2*vpata**2*mta**2)
     & +det3izhqs*b0fqstptp*vpaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh**
     & 2*mtp**2-1d0/4/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz
     & **2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/c
     & tw**2*vpatp**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*vpaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh**
     & 2*mbt**2-1d0/4/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz
     & **2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/c
     & tw**2*vpabt**2*mbt**2)
     & +c0zhqswww*vpaup*(-1-4*ctw**2+12*ctw**4)
     & +c0zhqszhh*vpaup*(-3/ctw**2/mz**2*mh**2-21d0/2/ctw**2)
     & +c0zhqshzz*vpaup*(-3d0/2/ctw**2/mz**2*mh**2-13/ctw**2)
     & +c0zhqsmomomo*vpaup*cfl*(-1d0/ctw**2*vpamo*vmamo/mz**2*mmo**2)
     & +c0zhqschchch*vpaup*cfq*(-1d0/ctw**2*vpach*vmach/mz**2*mch**2)
     & +c0zhqsststst*vpaup*cfq*(-1d0/ctw**2*vpast*vmast/mz**2*mst**2)
     & +c0zhqstatata*vpaup*cfl*(-1d0/ctw**2*vpata*vmata/mz**2*mta**2)
     & +c0zhqstptptp*vpaup*cfq*(-1d0/ctw**2*vpatp*vmatp/mz**2*mtp**2)
     & +c0zhqsbtbtbt*vpaup*cfq*(-1d0/ctw**2*vpabt*vmabt/mz**2*mbt**2)
     & +a0fh*vpaup*(-1d0/ctw**2/mz**2)
     & +b0fhzz*vpaup*(1d0/ctw**2/mz**2)
     & +b0fhhh*vpaup*(-3/ctw**2/mz**2)
     & +b0fzzh*vpaup*(1d0/2/ctw**2/mz**2)
     & +b0fqszh*vpaup*(1d0/2/ctw**2/mz**2)

      ffgp2=
     & +vpaup*(3d0/2/ctw**2/mz**2-2/mz**2+2*ctw**2/mz**2)
     & +propizqs*qup/qs*(-2/mz**2+6*ctw**2/mz**2-4*ctw**4/mz**2)
     & +propizqs*det3izhqs*vpaup*(-3d0/4+3d0/8/ctw**2/mz**2*mh**2+1d0/4/
     & ctw**2-1d0/2/mz**2*mh**2+1d0/2*ctw**2/mz**2*mh**2+3d0/2*ctw**2-3*
     & ctw**4)
     & +propizqs*det3izhqs*vpaup*qs*(3d0/8/ctw**2/mz**2-1d0/2/mz**2+1d0/
     & 2*ctw**2/mz**2)
     & +propizqs*det3izhqs*vpaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mbt**2
     & +1d0/4/ctw**2*vpabt**2/mz**2*mbt**2+1d0/4/ctw**2*vmatp**2/mz**2*m
     & tp**2+1d0/4/ctw**2*vpatp**2/mz**2*mtp**2+1d0/4/ctw**2*vmast**2/mz
     & **2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mst**2+1d0/4/ctw**2*vmach*
     & *2/mz**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*vpaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mta**2
     & +1d0/4/ctw**2*vpata**2/mz**2*mta**2+1d0/4/ctw**2*vmamo**2/mz**2*m
     & mo**2+1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*qup/qs*(1d0/2*mh**2-1d0/2*mz**2-1d0/2*ctw**2*
     & mh**2+1d0/2*ctw**2*mz**2-6*ctw**4*mh**2+6*ctw**4*mz**2+6*ctw**6*m
     & h**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*qup*(-1-1d0/2/mz**2*mh**2+3d0/2*ctw**2/mz**2*
     & mh**2+4*ctw**2-ctw**4/mz**2*mh**2-9*ctw**4+6*ctw**6)
     & +propizqs*det3izhqs*qup*qs*(-1d0/2/mz**2+3d0/2*ctw**2/mz**2-ctw**
     & 4/mz**2)
     & +propizqs*det3izhqs*qup*cfq/qs*(qbt*vmabt/mz**2*mh**2*mbt**2-qbt*
     & vmabt*mbt**2+qbt*vpabt/mz**2*mh**2*mbt**2-qbt*vpabt*mbt**2+qtp*vm
     & atp/mz**2*mh**2*mtp**2-qtp*vmatp*mtp**2+qtp*vpatp/mz**2*mh**2*mtp
     & **2-qtp*vpatp*mtp**2+qst*vmast/mz**2*mh**2*mst**2-qst*vmast*mst**
     & 2+qst*vpast/mz**2*mh**2*mst**2-qst*vpast*mst**2+qch*vmach/mz**2*m
     & h**2*mch**2-qch*vmach*mch**2+qch*vpach/mz**2*mh**2*mch**2-qch*vpa
     & ch*mch**2-ctw**2*qbt*vmabt/mz**2*mh**2*mbt**2+ctw**2*qbt*vmabt*mb
     & t**2-ctw**2*qbt*vpabt/mz**2*mh**2*mbt**2+ctw**2*qbt*vpabt*mbt**2-
     & ctw**2*qtp*vmatp/mz**2*mh**2*mtp**2+ctw**2*qtp*vmatp*mtp**2-ctw**
     & 2*qtp*vpatp/mz**2*mh**2*mtp**2+ctw**2*qtp*vpatp*mtp**2-ctw**2*qst
     & *vmast/mz**2*mh**2*mst**2+ctw**2*qst*vmast*mst**2-ctw**2*qst*vpas
     & t/mz**2*mh**2*mst**2+ctw**2*qst*vpast*mst**2-ctw**2*qch*vmach/mz*
     & *2*mh**2*mch**2+ctw**2*qch*vmach*mch**2-ctw**2*qch*vpach/mz**2*mh
     & **2*mch**2+ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*qup*cfq*(qbt*vmabt/mz**2*mbt**2+qbt*vpabt/mz*
     & *2*mbt**2+qtp*vmatp/mz**2*mtp**2+qtp*vpatp/mz**2*mtp**2+qst*vmast
     & /mz**2*mst**2+qst*vpast/mz**2*mst**2+qch*vmach/mz**2*mch**2+qch*v
     & pach/mz**2*mch**2-ctw**2*qbt*vmabt/mz**2*mbt**2-ctw**2*qbt*vpabt/
     & mz**2*mbt**2-ctw**2*qtp*vmatp/mz**2*mtp**2-ctw**2*qtp*vpatp/mz**2
     & *mtp**2-ctw**2*qst*vmast/mz**2*mst**2-ctw**2*qst*vpast/mz**2*mst*
     & *2-ctw**2*qch*vmach/mz**2*mch**2-ctw**2*qch*vpach/mz**2*mch**2)
     & +propizqs*det3izhqs*qup*cfl/qs*(qta*vmata/mz**2*mh**2*mta**2-qta*
     & vmata*mta**2+qta*vpata/mz**2*mh**2*mta**2-qta*vpata*mta**2+qmo*vm
     & amo/mz**2*mh**2*mmo**2-qmo*vmamo*mmo**2+qmo*vpamo/mz**2*mh**2*mmo
     & **2-qmo*vpamo*mmo**2-ctw**2*qta*vmata/mz**2*mh**2*mta**2+ctw**2*q
     & ta*vmata*mta**2-ctw**2*qta*vpata/mz**2*mh**2*mta**2+ctw**2*qta*vp
     & ata*mta**2-ctw**2*qmo*vmamo/mz**2*mh**2*mmo**2+ctw**2*qmo*vmamo*m
     & mo**2-ctw**2*qmo*vpamo/mz**2*mh**2*mmo**2+ctw**2*qmo*vpamo*mmo**2
     & )
     & +propizqs*det3izhqs*qup*cfl*(qta*vmata/mz**2*mta**2+qta*vpata/mz*
     & *2*mta**2+qmo*vmamo/mz**2*mmo**2+qmo*vpamo/mz**2*mmo**2-ctw**2*qt
     & a*vmata/mz**2*mta**2-ctw**2*qta*vpata/mz**2*mta**2-ctw**2*qmo*vma
     & mo/mz**2*mmo**2-ctw**2*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqswww*vpaup*(3d0/16/ctw**2*mh**6+15d0/
     & 16/ctw**2*mz**4*mh**2+3d0/8/ctw**2*mz**6-3d0/4*mh**6+3d0/8*mz**2*
     & mh**4-15d0/4*mz**4*mh**2-9d0/8*mz**6+3d0/4*ctw**2*mh**6-3d0/2*ctw
     & **2*mz**2*mh**4+15d0/4*ctw**2*mz**4*mh**2+9d0/2*ctw**4*mz**2*mh**
     & 4+9d0/2*ctw**4*mz**6)
     & +propizqs*det3izhqs**2*c0zhqswww*vpaup*qs*(3d0/16/ctw**2*mh**4+3d
     & 0/16/ctw**2*mz**2*mh**2+3d0/8/ctw**2*mz**4-3d0/4*mh**4-3d0/8*mz**
     & 2*mh**2-9d0/8*mz**4+3d0/4*ctw**2*mh**4-3d0/4*ctw**2*mz**2*mh**2+9
     & d0/2*ctw**4*mz**2*mh**2+9d0/2*ctw**4*mz**4)
     & +propizqs*det3izhqs**2*c0zhqswww*qup*(-3d0/4*mh**6+3d0/4*mz**2*mh
     & **4+9d0/4*ctw**2*mh**6-15d0/4*ctw**2*mz**2*mh**4+3d0/2*ctw**2*mz*
     & *4*mh**2-3d0/2*ctw**4*mh**6+12*ctw**4*mz**2*mh**4-21d0/2*ctw**4*m
     & z**4*mh**2-9*ctw**6*mz**2*mh**4+9*ctw**6*mz**4*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qup*qs*(-3d0/4*mh**4+9d0/4*ctw**
     & 2*mh**4-3d0/2*ctw**2*mz**2*mh**2-3d0/2*ctw**4*mh**4+21d0/2*ctw**4
     & *mz**2*mh**2-9*ctw**6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*c0zhqszhh*vpaup*(9d0/32/ctw**2/mz**2*mh**8
     & +45d0/32/ctw**2*mz**2*mh**4+81d0/16/ctw**2*mz**4*mh**2+9d0/4/ctw*
     & *2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqszhh*vpaup*qs*(9d0/32/ctw**2/mz**2*mh
     & **6+9d0/32/ctw**2*mh**4+9d0/16/ctw**2*mz**2*mh**2+9d0/4/ctw**2*mz
     & **4)
     & +propizqs*det3izhqs**2*c0zhqshzz*vpaup*(3d0/32/ctw**2/mz**2*mh**8
     & +15d0/16/ctw**2*mh**6+87d0/32/ctw**2*mz**2*mh**4+75d0/8/ctw**2*mz
     & **4*mh**2+39d0/8/ctw**2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqshzz*vpaup*qs*(3d0/32/ctw**2/mz**2*mh
     & **6+9d0/32/ctw**2*mh**4+9d0/8/ctw**2*mz**2*mh**2+39d0/8/ctw**2*mz
     & **4)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vpaup*cfl*(-3d0/8/ctw**2*vmam
     & o**2*mh**4*mmo**2-3d0/8/ctw**2*vmamo**2*mz**4*mmo**2-3d0/8/ctw**2
     & *vpamo**2*mh**4*mmo**2-3d0/8/ctw**2*vpamo**2*mz**4*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vpaup*cfl*qs*(-3d0/8/ctw**2*v
     & mamo**2*mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mz**2*mmo**2-3d0/8/ctw
     & **2*vpamo**2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qup*cfl*(-3d0/2*qmo*vmamo*mh*
     & *4*mmo**2+3d0/2*qmo*vmamo*mz**2*mh**2*mmo**2-3d0/2*qmo*vpamo*mh**
     & 4*mmo**2+3d0/2*qmo*vpamo*mz**2*mh**2*mmo**2+3d0/2*ctw**2*qmo*vmam
     & o*mh**4*mmo**2-3d0/2*ctw**2*qmo*vmamo*mz**2*mh**2*mmo**2+3d0/2*ct
     & w**2*qmo*vpamo*mh**4*mmo**2-3d0/2*ctw**2*qmo*vpamo*mz**2*mh**2*mm
     & o**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qup*cfl*qs*(-3d0/2*qmo*vmamo*
     & mh**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*
     & mh**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vpaup*cfq*(-3d0/8/ctw**2*vmac
     & h**2*mh**4*mch**2-3d0/8/ctw**2*vmach**2*mz**4*mch**2-3d0/8/ctw**2
     & *vpach**2*mh**4*mch**2-3d0/8/ctw**2*vpach**2*mz**4*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vpaup*cfq*qs*(-3d0/8/ctw**2*v
     & mach**2*mh**2*mch**2-3d0/8/ctw**2*vmach**2*mz**2*mch**2-3d0/8/ctw
     & **2*vpach**2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*mz**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qup*cfq*(-3d0/2*qch*vmach*mh*
     & *4*mch**2+3d0/2*qch*vmach*mz**2*mh**2*mch**2-3d0/2*qch*vpach*mh**
     & 4*mch**2+3d0/2*qch*vpach*mz**2*mh**2*mch**2+3d0/2*ctw**2*qch*vmac
     & h*mh**4*mch**2-3d0/2*ctw**2*qch*vmach*mz**2*mh**2*mch**2+3d0/2*ct
     & w**2*qch*vpach*mh**4*mch**2-3d0/2*ctw**2*qch*vpach*mz**2*mh**2*mc
     & h**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qup*cfq*qs*(-3d0/2*qch*vmach*
     & mh**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2+3d0/2*ctw**2*qch*vmach*
     & mh**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vpaup*cfq*(-3d0/8/ctw**2*vmas
     & t**2*mh**4*mst**2-3d0/8/ctw**2*vmast**2*mz**4*mst**2-3d0/8/ctw**2
     & *vpast**2*mh**4*mst**2-3d0/8/ctw**2*vpast**2*mz**4*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vpaup*cfq*qs*(-3d0/8/ctw**2*v
     & mast**2*mh**2*mst**2-3d0/8/ctw**2*vmast**2*mz**2*mst**2-3d0/8/ctw
     & **2*vpast**2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*mz**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qup*cfq*(-3d0/2*qst*vmast*mh*
     & *4*mst**2+3d0/2*qst*vmast*mz**2*mh**2*mst**2-3d0/2*qst*vpast*mh**
     & 4*mst**2+3d0/2*qst*vpast*mz**2*mh**2*mst**2+3d0/2*ctw**2*qst*vmas
     & t*mh**4*mst**2-3d0/2*ctw**2*qst*vmast*mz**2*mh**2*mst**2+3d0/2*ct
     & w**2*qst*vpast*mh**4*mst**2-3d0/2*ctw**2*qst*vpast*mz**2*mh**2*ms
     & t**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qup*cfq*qs*(-3d0/2*qst*vmast*
     & mh**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2+3d0/2*ctw**2*qst*vmast*
     & mh**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vpaup*cfl*(-3d0/8/ctw**2*vmat
     & a**2*mh**4*mta**2-3d0/8/ctw**2*vmata**2*mz**4*mta**2-3d0/8/ctw**2
     & *vpata**2*mh**4*mta**2-3d0/8/ctw**2*vpata**2*mz**4*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vpaup*cfl*qs*(-3d0/8/ctw**2*v
     & mata**2*mh**2*mta**2-3d0/8/ctw**2*vmata**2*mz**2*mta**2-3d0/8/ctw
     & **2*vpata**2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*mz**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qup*cfl*(-3d0/2*qta*vmata*mh*
     & *4*mta**2+3d0/2*qta*vmata*mz**2*mh**2*mta**2-3d0/2*qta*vpata*mh**
     & 4*mta**2+3d0/2*qta*vpata*mz**2*mh**2*mta**2+3d0/2*ctw**2*qta*vmat
     & a*mh**4*mta**2-3d0/2*ctw**2*qta*vmata*mz**2*mh**2*mta**2+3d0/2*ct
     & w**2*qta*vpata*mh**4*mta**2-3d0/2*ctw**2*qta*vpata*mz**2*mh**2*mt
     & a**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qup*cfl*qs*(-3d0/2*qta*vmata*
     & mh**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2+3d0/2*ctw**2*qta*vmata*
     & mh**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vpaup*cfq*(-3d0/8/ctw**2*vmat
     & p**2*mh**4*mtp**2-3d0/8/ctw**2*vmatp**2*mz**4*mtp**2-3d0/8/ctw**2
     & *vpatp**2*mh**4*mtp**2-3d0/8/ctw**2*vpatp**2*mz**4*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vpaup*cfq*qs*(-3d0/8/ctw**2*v
     & matp**2*mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mz**2*mtp**2-3d0/8/ctw
     & **2*vpatp**2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qup*cfq*(-3d0/2*qtp*vmatp*mh*
     & *4*mtp**2+3d0/2*qtp*vmatp*mz**2*mh**2*mtp**2-3d0/2*qtp*vpatp*mh**
     & 4*mtp**2+3d0/2*qtp*vpatp*mz**2*mh**2*mtp**2+3d0/2*ctw**2*qtp*vmat
     & p*mh**4*mtp**2-3d0/2*ctw**2*qtp*vmatp*mz**2*mh**2*mtp**2+3d0/2*ct
     & w**2*qtp*vpatp*mh**4*mtp**2-3d0/2*ctw**2*qtp*vpatp*mz**2*mh**2*mt
     & p**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qup*cfq*qs*(-3d0/2*qtp*vmatp*
     & mh**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*
     & mh**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vpaup*cfq*(-3d0/8/ctw**2*vmab
     & t**2*mh**4*mbt**2-3d0/8/ctw**2*vmabt**2*mz**4*mbt**2-3d0/8/ctw**2
     & *vpabt**2*mh**4*mbt**2-3d0/8/ctw**2*vpabt**2*mz**4*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vpaup*cfq*qs*(-3d0/8/ctw**2*v
     & mabt**2*mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mz**2*mbt**2-3d0/8/ctw
     & **2*vpabt**2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh*
     & *4*mbt**2+3d0/2*qbt*vmabt*mz**2*mh**2*mbt**2-3d0/2*qbt*vpabt*mh**
     & 4*mbt**2+3d0/2*qbt*vpabt*mz**2*mh**2*mbt**2+3d0/2*ctw**2*qbt*vmab
     & t*mh**4*mbt**2-3d0/2*ctw**2*qbt*vmabt*mz**2*mh**2*mbt**2+3d0/2*ct
     & w**2*qbt*vpabt*mh**4*mbt**2-3d0/2*ctw**2*qbt*vpabt*mz**2*mh**2*mb
     & t**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qup*cfq*qs*(-3d0/2*qbt*vmabt*
     & mh**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*
     & mh**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhww*vpaup*(-3d0/8/ctw**2*mh**4-3d0/4/ct
     & w**2*mz**2*mh**2-3d0/8/ctw**2*mz**4+3d0/2*mh**4+9d0/4*mz**2*mh**2
     & +3d0/2*mz**4-3d0/2*ctw**2*mh**4-3d0/2*ctw**2*mz**4-9*ctw**4*mz**2
     & *mh**2)
     & +propizqs*det3izhqs**2*b0fhww*vpaup*qs*(-3d0/8/ctw**2*mz**2+3d0/2
     & *mz**2-3d0/2*ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhww*qup*(3d0/2*mh**4-9d0/2*ctw**2*mh**4
     & +3*ctw**2*mz**2*mh**2+3*ctw**4*mh**4-21*ctw**4*mz**2*mh**2+18*ctw
     & **6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhzz*vpaup*(-3d0/32/ctw**2/mz**2*mh**6-3
     & d0/4/ctw**2*mh**4-87d0/32/ctw**2*mz**2*mh**2-15d0/16/ctw**2*mz**4
     & )
     & +propizqs*det3izhqs**2*b0fhzz*vpaup*qs*(-3d0/32/ctw**2/mz**2*mh**
     & 4-9d0/32/ctw**2*mh**2-15d0/16/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhhh*vpaup*(9d0/32/ctw**2/mz**2*mh**6+9d
     & 0/16/ctw**2*mh**4+81d0/32/ctw**2*mz**2*mh**2+9d0/8/ctw**2*mz**4)
     & +propizqs*det3izhqs**2*b0fhhh*vpaup*qs*(9d0/32/ctw**2/mz**2*mh**4
     & +9d0/32/ctw**2*mh**2+9d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhmomo*vpaup*cfl*(3d0/4/ctw**2*vmamo**2*
     & mh**2*mmo**2+3d0/4/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhmomo*qup*cfl*(3*qmo*vmamo*mh**2*mmo**2
     & +3*qmo*vpamo*mh**2*mmo**2-3*ctw**2*qmo*vmamo*mh**2*mmo**2-3*ctw**
     & 2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhchch*vpaup*cfq*(3d0/4/ctw**2*vmach**2*
     & mh**2*mch**2+3d0/4/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhchch*qup*cfq*(3*qch*vmach*mh**2*mch**2
     & +3*qch*vpach*mh**2*mch**2-3*ctw**2*qch*vmach*mh**2*mch**2-3*ctw**
     & 2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhstst*vpaup*cfq*(3d0/4/ctw**2*vmast**2*
     & mh**2*mst**2+3d0/4/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhstst*qup*cfq*(3*qst*vmast*mh**2*mst**2
     & +3*qst*vpast*mh**2*mst**2-3*ctw**2*qst*vmast*mh**2*mst**2-3*ctw**
     & 2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhtata*vpaup*cfl*(3d0/4/ctw**2*vmata**2*
     & mh**2*mta**2+3d0/4/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtata*qup*cfl*(3*qta*vmata*mh**2*mta**2
     & +3*qta*vpata*mh**2*mta**2-3*ctw**2*qta*vmata*mh**2*mta**2-3*ctw**
     & 2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtptp*vpaup*cfq*(3d0/4/ctw**2*vmatp**2*
     & mh**2*mtp**2+3d0/4/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhtptp*qup*cfq*(3*qtp*vmatp*mh**2*mtp**2
     & +3*qtp*vpatp*mh**2*mtp**2-3*ctw**2*qtp*vmatp*mh**2*mtp**2-3*ctw**
     & 2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*vpaup*cfq*(3d0/4/ctw**2*vmabt**2*
     & mh**2*mbt**2+3d0/4/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*qup*cfq*(3*qbt*vmabt*mh**2*mbt**2
     & +3*qbt*vpabt*mh**2*mbt**2-3*ctw**2*qbt*vmabt*mh**2*mbt**2-3*ctw**
     & 2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzww*vpaup*(3d0/16/ctw**2*mh**4+3d0/8/ct
     & w**2*mz**2*mh**2+3d0/16/ctw**2*mz**4-3d0/4*mh**4-9d0/8*mz**2*mh**
     & 2-3d0/4*mz**4+3d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**4+9d0/2*ctw**4*
     & mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fzww*vpaup*qs*(3d0/16/ctw**2*mh**2+3d0/1
     & 6/ctw**2*mz**2-3d0/4*mh**2-3d0/8*mz**2+3d0/4*ctw**2*mh**2-3d0/4*c
     & tw**2*mz**2+9d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs**2*b0fzww*qup*(-3d0/4*mh**4-3d0/4*mz**2*mh**2
     & +9d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**2*mh**2-3d0/2*ctw**2*mz**4-3
     & d0/2*ctw**4*mh**4+9*ctw**4*mz**2*mh**2+21d0/2*ctw**4*mz**4-9*ctw*
     & *6*mz**2*mh**2-9*ctw**6*mz**4)
     & +propizqs*det3izhqs**2*b0fzww*qup*qs*(-3d0/4*mh**2+9d0/4*ctw**2*m
     & h**2-3d0/2*ctw**2*mz**2-3d0/2*ctw**4*mh**2+21d0/2*ctw**4*mz**2-9*
     & ctw**6*mz**2)
     & +propizqs*det3izhqs**2*b0fzzh*vpaup*(-3d0/16/ctw**2*mh**4+3d0/8/c
     & tw**2*mz**2*mh**2-3d0/16/ctw**2*mz**4)
     & +propizqs*det3izhqs**2*b0fzzh*vpaup*qs*(3d0/16/ctw**2*mh**2+3d0/1
     & 6/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vpaup*cfl*(-3d0/8/ctw**2*vmamo**2
     & *mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vpaup*cfl*qs*(-3d0/8/ctw**2*vmamo
     & **2*mmo**2-3d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qup*cfl*(-3d0/2*qmo*vmamo*mh**2*m
     & mo**2-3d0/2*qmo*vmamo*mz**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2-3
     & d0/2*qmo*vpamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*mh**2*mmo**2+3
     & d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*m
     & mo**2+3d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qup*cfl*qs*(-3d0/2*qmo*vmamo*mmo*
     & *2-3d0/2*qmo*vpamo*mmo**2+3d0/2*ctw**2*qmo*vmamo*mmo**2+3d0/2*ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fzchch*vpaup*cfq*(-3d0/8/ctw**2*vmach**2
     & *mh**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vpaup*cfq*qs*(-3d0/8/ctw**2*vmach
     & **2*mch**2-3d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qup*cfq*(-3d0/2*qch*vmach*mh**2*m
     & ch**2-3d0/2*qch*vmach*mz**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2-3
     & d0/2*qch*vpach*mz**2*mch**2+3d0/2*ctw**2*qch*vmach*mh**2*mch**2+3
     & d0/2*ctw**2*qch*vmach*mz**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*m
     & ch**2+3d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qup*cfq*qs*(-3d0/2*qch*vmach*mch*
     & *2-3d0/2*qch*vpach*mch**2+3d0/2*ctw**2*qch*vmach*mch**2+3d0/2*ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs**2*b0fzstst*vpaup*cfq*(-3d0/8/ctw**2*vmast**2
     & *mh**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vpaup*cfq*qs*(-3d0/8/ctw**2*vmast
     & **2*mst**2-3d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qup*cfq*(-3d0/2*qst*vmast*mh**2*m
     & st**2-3d0/2*qst*vmast*mz**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2-3
     & d0/2*qst*vpast*mz**2*mst**2+3d0/2*ctw**2*qst*vmast*mh**2*mst**2+3
     & d0/2*ctw**2*qst*vmast*mz**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*m
     & st**2+3d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qup*cfq*qs*(-3d0/2*qst*vmast*mst*
     & *2-3d0/2*qst*vpast*mst**2+3d0/2*ctw**2*qst*vmast*mst**2+3d0/2*ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs**2*b0fztata*vpaup*cfl*(-3d0/8/ctw**2*vmata**2
     & *mh**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vpaup*cfl*qs*(-3d0/8/ctw**2*vmata
     & **2*mta**2-3d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qup*cfl*(-3d0/2*qta*vmata*mh**2*m
     & ta**2-3d0/2*qta*vmata*mz**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2-3
     & d0/2*qta*vpata*mz**2*mta**2+3d0/2*ctw**2*qta*vmata*mh**2*mta**2+3
     & d0/2*ctw**2*qta*vmata*mz**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*m
     & ta**2+3d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qup*cfl*qs*(-3d0/2*qta*vmata*mta*
     & *2-3d0/2*qta*vpata*mta**2+3d0/2*ctw**2*qta*vmata*mta**2+3d0/2*ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs**2*b0fztptp*vpaup*cfq*(-3d0/8/ctw**2*vmatp**2
     & *mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vpaup*cfq*qs*(-3d0/8/ctw**2*vmatp
     & **2*mtp**2-3d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qup*cfq*(-3d0/2*qtp*vmatp*mh**2*m
     & tp**2-3d0/2*qtp*vmatp*mz**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2-3
     & d0/2*qtp*vpatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*mh**2*mtp**2+3
     & d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*m
     & tp**2+3d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qup*cfq*qs*(-3d0/2*qtp*vmatp*mtp*
     & *2-3d0/2*qtp*vpatp*mtp**2+3d0/2*ctw**2*qtp*vmatp*mtp**2+3d0/2*ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vpaup*cfq*(-3d0/8/ctw**2*vmabt**2
     & *mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vpaup*cfq*qs*(-3d0/8/ctw**2*vmabt
     & **2*mbt**2-3d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh**2*m
     & bt**2-3d0/2*qbt*vmabt*mz**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2-3
     & d0/2*qbt*vpabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*mh**2*mbt**2+3
     & d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*m
     & bt**2+3d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qup*cfq*qs*(-3d0/2*qbt*vmabt*mbt*
     & *2-3d0/2*qbt*vpabt*mbt**2+3d0/2*ctw**2*qbt*vmabt*mbt**2+3d0/2*ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsww*vpaup*(3d0/16/ctw**2*mh**4+3d0/8/c
     & tw**2*mz**2*mh**2+3d0/16/ctw**2*mz**4-3d0/4*mh**4-9d0/8*mz**2*mh*
     & *2-3d0/4*mz**4+3d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**4+9d0/2*ctw**4
     & *mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqsww*vpaup*qs*(-3d0/16/ctw**2*mh**2+3d0
     & /16/ctw**2*mz**2+3d0/4*mh**2-9d0/8*mz**2-3d0/4*ctw**2*mh**2+9d0/4
     & *ctw**2*mz**2-9d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs**2*b0fqsww*qup*(-3d0/4*mh**4+3d0/4*mz**2*mh**
     & 2+9d0/4*ctw**2*mh**4-15d0/4*ctw**2*mz**2*mh**2+3d0/2*ctw**2*mz**4
     & -3d0/2*ctw**4*mh**4+12*ctw**4*mz**2*mh**2-21d0/2*ctw**4*mz**4-9*c
     & tw**6*mz**2*mh**2+9*ctw**6*mz**4)
     & +propizqs*det3izhqs**2*b0fqsww*qup*qs*(3d0/4*mh**2-9d0/4*ctw**2*m
     & h**2+3d0/2*ctw**2*mz**2+3d0/2*ctw**4*mh**2-21d0/2*ctw**4*mz**2+9*
     & ctw**6*mz**2)
     & +propizqs*det3izhqs**2*b0fqszh*vpaup*(-3d0/16/ctw**2/mz**2*mh**6+
     & 3d0/8/ctw**2*mh**4-3d0/16/ctw**2*mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqszh*vpaup*qs*(-3d0/16/ctw**2/mz**2*mh*
     & *4-3d0/16/ctw**2*mh**2-3d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vpaup*cfl*(-3d0/8/ctw**2*vmamo**
     & 2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vpaup*cfl*qs*(3d0/8/ctw**2*vmamo
     & **2*mmo**2+3d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qup*cfl*(-3d0/2*qmo*vmamo*mh**2*
     & mmo**2+3d0/2*qmo*vmamo*mz**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2+
     & 3d0/2*qmo*vpamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*mh**2*mmo**2-
     & 3d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*
     & mmo**2-3d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qup*cfl*qs*(3d0/2*qmo*vmamo*mmo*
     & *2+3d0/2*qmo*vpamo*mmo**2-3d0/2*ctw**2*qmo*vmamo*mmo**2-3d0/2*ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fqschch*vpaup*cfq*(-3d0/8/ctw**2*vmach**
     & 2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vpaup*cfq*qs*(3d0/8/ctw**2*vmach
     & **2*mch**2+3d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qup*cfq*(-3d0/2*qch*vmach*mh**2*
     & mch**2+3d0/2*qch*vmach*mz**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2+
     & 3d0/2*qch*vpach*mz**2*mch**2+3d0/2*ctw**2*qch*vmach*mh**2*mch**2-
     & 3d0/2*ctw**2*qch*vmach*mz**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*
     & mch**2-3d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qup*cfq*qs*(3d0/2*qch*vmach*mch*
     & *2+3d0/2*qch*vpach*mch**2-3d0/2*ctw**2*qch*vmach*mch**2-3d0/2*ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vpaup*cfq*(-3d0/8/ctw**2*vmast**
     & 2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vpaup*cfq*qs*(3d0/8/ctw**2*vmast
     & **2*mst**2+3d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qup*cfq*(-3d0/2*qst*vmast*mh**2*
     & mst**2+3d0/2*qst*vmast*mz**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2+
     & 3d0/2*qst*vpast*mz**2*mst**2+3d0/2*ctw**2*qst*vmast*mh**2*mst**2-
     & 3d0/2*ctw**2*qst*vmast*mz**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*
     & mst**2-3d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qup*cfq*qs*(3d0/2*qst*vmast*mst*
     & *2+3d0/2*qst*vpast*mst**2-3d0/2*ctw**2*qst*vmast*mst**2-3d0/2*ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs**2*b0fqstata*vpaup*cfl*(-3d0/8/ctw**2*vmata**
     & 2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vpaup*cfl*qs*(3d0/8/ctw**2*vmata
     & **2*mta**2+3d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qup*cfl*(-3d0/2*qta*vmata*mh**2*
     & mta**2+3d0/2*qta*vmata*mz**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2+
     & 3d0/2*qta*vpata*mz**2*mta**2+3d0/2*ctw**2*qta*vmata*mh**2*mta**2-
     & 3d0/2*ctw**2*qta*vmata*mz**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*
     & mta**2-3d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qup*cfl*qs*(3d0/2*qta*vmata*mta*
     & *2+3d0/2*qta*vpata*mta**2-3d0/2*ctw**2*qta*vmata*mta**2-3d0/2*ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vpaup*cfq*(-3d0/8/ctw**2*vmatp**
     & 2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vpaup*cfq*qs*(3d0/8/ctw**2*vmatp
     & **2*mtp**2+3d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qup*cfq*(-3d0/2*qtp*vmatp*mh**2*
     & mtp**2+3d0/2*qtp*vmatp*mz**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2+
     & 3d0/2*qtp*vpatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*mh**2*mtp**2-
     & 3d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*
     & mtp**2-3d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qup*cfq*qs*(3d0/2*qtp*vmatp*mtp*
     & *2+3d0/2*qtp*vpatp*mtp**2-3d0/2*ctw**2*qtp*vmatp*mtp**2-3d0/2*ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vpaup*cfq*(-3d0/8/ctw**2*vmabt**
     & 2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vpaup*cfq*qs*(3d0/8/ctw**2*vmabt
     & **2*mbt**2+3d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh**2*
     & mbt**2+3d0/2*qbt*vmabt*mz**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2+
     & 3d0/2*qbt*vpabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*mh**2*mbt**2-
     & 3d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*
     & mbt**2-3d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qup*cfq*qs*(3d0/2*qbt*vmabt*mbt*
     & *2+3d0/2*qbt*vpabt*mbt**2-3d0/2*ctw**2*qbt*vmabt*mbt**2-3d0/2*ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*c0zhqswww*vpaup*(1d0/4/ctw**2*mh**2-7d0/4*mh*
     & *2-1d0/4*mz**2+2*ctw**2*mh**2-1d0/2*ctw**2*mz**2-ctw**4*mh**2+3*c
     & tw**4*mz**2+6*ctw**6*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*vpaup*qs*(-3d0/4+ctw**2-ctw**4)
     & +propizqs*det3izhqs*c0zhqswww*qup/qs*(-ctw**2*mz**2*mh**2+ctw**2*
     & mz**4+ctw**4*mz**2*mh**2-ctw**4*mz**4+12*ctw**6*mz**2*mh**2-12*ct
     & w**6*mz**4-12*ctw**8*mz**2*mh**2+12*ctw**8*mz**4)
     & +propizqs*det3izhqs*c0zhqswww*qup*(-mh**2+4*ctw**2*mh**2-5*ctw**4
     & *mh**2+6*ctw**4*mz**2+2*ctw**6*mh**2+6*ctw**6*mz**2-12*ctw**8*mz*
     & *2)
     & +propizqs*det3izhqs*c0zhqswww*qup*qs*(ctw**2-3*ctw**4+2*ctw**6)
     & +propizqs*det3izhqs*c0zhqszhh*vpaup*(-3d0/4/ctw**2/mz**2*mh**4-6/
     & ctw**2*mh**2-21d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqszhh*vpaup*qs*(-3d0/4/ctw**2/mz**2*mh**2
     & -21d0/8/ctw**2)
     & +propizqs*det3izhqs*c0zhqshzz*vpaup*(-7d0/8/ctw**2/mz**2*mh**4-7/
     & ctw**2*mh**2-11d0/4/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqshzz*vpaup*qs*(-3d0/8/ctw**2/mz**2*mh**2
     & -7d0/2/ctw**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vpaup*cfl*(-1d0/2/ctw**2*vmamo**
     & 2/mz**2*mmo**4+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-3d0/8/ctw
     & **2*vmamo**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mh**2*mmo**2-1
     & d0/4/ctw**2*vpamo*vmamo*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mmo**4
     & +1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*m
     & mo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vpaup*cfl*qs*(1d0/8/ctw**2*vmamo
     & **2/mz**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2+1d0/8/ctw*
     & *2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup*cfl/qs*(-2*qmo*vmamo/mz**2*m
     & h**2*mmo**4+2*qmo*vmamo*mmo**4-2*qmo*vpamo/mz**2*mh**2*mmo**4+2*q
     & mo*vpamo*mmo**4+2*ctw**2*qmo*vmamo/mz**2*mh**2*mmo**4-2*ctw**2*qm
     & o*vmamo*mmo**4+2*ctw**2*qmo*vpamo/mz**2*mh**2*mmo**4-2*ctw**2*qmo
     & *vpamo*mmo**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup*cfl*(-2*qmo*vmamo/mz**2*mmo*
     & *4-2*qmo*vmamo*mmo**2-2*qmo*vpamo/mz**2*mmo**4-2*qmo*vpamo*mmo**2
     & +2*ctw**2*qmo*vmamo/mz**2*mmo**4+2*ctw**2*qmo*vmamo*mmo**2+2*ctw*
     & *2*qmo*vpamo/mz**2*mmo**4+2*ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*c0zhqschchch*vpaup*cfq*(-1d0/2/ctw**2*vmach**
     & 2/mz**2*mch**4+1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-3d0/8/ctw
     & **2*vmach**2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mh**2*mch**2-1
     & d0/4/ctw**2*vpach*vmach*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mch**4
     & +1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*m
     & ch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vpaup*cfq*qs*(1d0/8/ctw**2*vmach
     & **2/mz**2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mch**2+1d0/8/ctw*
     & *2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*qup*cfq/qs*(-2*qch*vmach/mz**2*m
     & h**2*mch**4+2*qch*vmach*mch**4-2*qch*vpach/mz**2*mh**2*mch**4+2*q
     & ch*vpach*mch**4+2*ctw**2*qch*vmach/mz**2*mh**2*mch**4-2*ctw**2*qc
     & h*vmach*mch**4+2*ctw**2*qch*vpach/mz**2*mh**2*mch**4-2*ctw**2*qch
     & *vpach*mch**4)
     & +propizqs*det3izhqs*c0zhqschchch*qup*cfq*(-2*qch*vmach/mz**2*mch*
     & *4-2*qch*vmach*mch**2-2*qch*vpach/mz**2*mch**4-2*qch*vpach*mch**2
     & +2*ctw**2*qch*vmach/mz**2*mch**4+2*ctw**2*qch*vmach*mch**2+2*ctw*
     & *2*qch*vpach/mz**2*mch**4+2*ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*c0zhqsststst*vpaup*cfq*(-1d0/2/ctw**2*vmast**
     & 2/mz**2*mst**4+1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-3d0/8/ctw
     & **2*vmast**2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mh**2*mst**2-1
     & d0/4/ctw**2*vpast*vmast*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mst**4
     & +1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*m
     & st**2)
     & +propizqs*det3izhqs*c0zhqsststst*vpaup*cfq*qs*(1d0/8/ctw**2*vmast
     & **2/mz**2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mst**2+1d0/8/ctw*
     & *2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*qup*cfq/qs*(-2*qst*vmast/mz**2*m
     & h**2*mst**4+2*qst*vmast*mst**4-2*qst*vpast/mz**2*mh**2*mst**4+2*q
     & st*vpast*mst**4+2*ctw**2*qst*vmast/mz**2*mh**2*mst**4-2*ctw**2*qs
     & t*vmast*mst**4+2*ctw**2*qst*vpast/mz**2*mh**2*mst**4-2*ctw**2*qst
     & *vpast*mst**4)
     & +propizqs*det3izhqs*c0zhqsststst*qup*cfq*(-2*qst*vmast/mz**2*mst*
     & *4-2*qst*vmast*mst**2-2*qst*vpast/mz**2*mst**4-2*qst*vpast*mst**2
     & +2*ctw**2*qst*vmast/mz**2*mst**4+2*ctw**2*qst*vmast*mst**2+2*ctw*
     & *2*qst*vpast/mz**2*mst**4+2*ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*c0zhqstatata*vpaup*cfl*(-1d0/2/ctw**2*vmata**
     & 2/mz**2*mta**4+1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-3d0/8/ctw
     & **2*vmata**2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mh**2*mta**2-1
     & d0/4/ctw**2*vpata*vmata*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mta**4
     & +1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*m
     & ta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vpaup*cfl*qs*(1d0/8/ctw**2*vmata
     & **2/mz**2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mta**2+1d0/8/ctw*
     & *2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*qup*cfl/qs*(-2*qta*vmata/mz**2*m
     & h**2*mta**4+2*qta*vmata*mta**4-2*qta*vpata/mz**2*mh**2*mta**4+2*q
     & ta*vpata*mta**4+2*ctw**2*qta*vmata/mz**2*mh**2*mta**4-2*ctw**2*qt
     & a*vmata*mta**4+2*ctw**2*qta*vpata/mz**2*mh**2*mta**4-2*ctw**2*qta
     & *vpata*mta**4)
     & +propizqs*det3izhqs*c0zhqstatata*qup*cfl*(-2*qta*vmata/mz**2*mta*
     & *4-2*qta*vmata*mta**2-2*qta*vpata/mz**2*mta**4-2*qta*vpata*mta**2
     & +2*ctw**2*qta*vmata/mz**2*mta**4+2*ctw**2*qta*vmata*mta**2+2*ctw*
     & *2*qta*vpata/mz**2*mta**4+2*ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vpaup*cfq*(-1d0/2/ctw**2*vmatp**
     & 2/mz**2*mtp**4+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-3d0/8/ctw
     & **2*vmatp**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mh**2*mtp**2-1
     & d0/4/ctw**2*vpatp*vmatp*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**4
     & +1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*m
     & tp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vpaup*cfq*qs*(1d0/8/ctw**2*vmatp
     & **2/mz**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2+1d0/8/ctw*
     & *2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qup*cfq/qs*(-2*qtp*vmatp/mz**2*m
     & h**2*mtp**4+2*qtp*vmatp*mtp**4-2*qtp*vpatp/mz**2*mh**2*mtp**4+2*q
     & tp*vpatp*mtp**4+2*ctw**2*qtp*vmatp/mz**2*mh**2*mtp**4-2*ctw**2*qt
     & p*vmatp*mtp**4+2*ctw**2*qtp*vpatp/mz**2*mh**2*mtp**4-2*ctw**2*qtp
     & *vpatp*mtp**4)
     & +propizqs*det3izhqs*c0zhqstptptp*qup*cfq*(-2*qtp*vmatp/mz**2*mtp*
     & *4-2*qtp*vmatp*mtp**2-2*qtp*vpatp/mz**2*mtp**4-2*qtp*vpatp*mtp**2
     & +2*ctw**2*qtp*vmatp/mz**2*mtp**4+2*ctw**2*qtp*vmatp*mtp**2+2*ctw*
     & *2*qtp*vpatp/mz**2*mtp**4+2*ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vpaup*cfq*(-1d0/2/ctw**2*vmabt**
     & 2/mz**2*mbt**4+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-3d0/8/ctw
     & **2*vmabt**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mh**2*mbt**2-1
     & d0/4/ctw**2*vpabt*vmabt*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**4
     & +1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*m
     & bt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vpaup*cfq*qs*(1d0/8/ctw**2*vmabt
     & **2/mz**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2+1d0/8/ctw*
     & *2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup*cfq/qs*(-2*qbt*vmabt/mz**2*m
     & h**2*mbt**4+2*qbt*vmabt*mbt**4-2*qbt*vpabt/mz**2*mh**2*mbt**4+2*q
     & bt*vpabt*mbt**4+2*ctw**2*qbt*vmabt/mz**2*mh**2*mbt**4-2*ctw**2*qb
     & t*vmabt*mbt**4+2*ctw**2*qbt*vpabt/mz**2*mh**2*mbt**4-2*ctw**2*qbt
     & *vpabt*mbt**4)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup*cfq*(-2*qbt*vmabt/mz**2*mbt*
     & *4-2*qbt*vmabt*mbt**2-2*qbt*vpabt/mz**2*mbt**4-2*qbt*vpabt*mbt**2
     & +2*ctw**2*qbt*vmabt/mz**2*mbt**4+2*ctw**2*qbt*vmabt*mbt**2+2*ctw*
     & *2*qbt*vpabt/mz**2*mbt**4+2*ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*a0fh*vpaup*(-1d0/2/ctw**2/mz**2*mh**2-1d0/4/c
     & tw**2)
     & +propizqs*det3izhqs*a0fh*vpaup*qs*(-1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhww*vpaup*(1d0/4+1d0/8/ctw**2/mz**2*mh**2-
     & 1d0/2/mz**2*mh**2+1d0/2*ctw**2/mz**2*mh**2-ctw**2+3*ctw**4)
     & +propizqs*det3izhqs*b0fhww*qup/qs*(1d0/2*mh**2-3d0/2*ctw**2*mh**2
     & +ctw**2*mz**2+ctw**4*mh**2-7*ctw**4*mz**2+6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qup*(-1d0/2/mz**2*mh**2+3d0/2*ctw**2/m
     & z**2*mh**2-ctw**2-ctw**4/mz**2*mh**2+7*ctw**4-6*ctw**6)
     & +propizqs*det3izhqs*b0fhzz*vpaup*(9d0/16/ctw**2/mz**2*mh**2+3d0/8
     & /ctw**2)
     & +propizqs*det3izhqs*b0fhzz*vpaup*qs*(1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhhh*vpaup*(-21d0/16/ctw**2/mz**2*mh**2-3d0
     & /4/ctw**2)
     & +propizqs*det3izhqs*b0fhhh*vpaup*qs*(-3d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhmomo*vpaup*cfl*(-1d0/4/ctw**2*vmamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup*cfl/qs*(qmo*vmamo*mmo**2+qmo*vpa
     & mo*mmo**2-ctw**2*qmo*vmamo*mmo**2-ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup*cfl*(-qmo*vmamo/mz**2*mmo**2-qmo
     & *vpamo/mz**2*mmo**2+ctw**2*qmo*vmamo/mz**2*mmo**2+ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*vpaup*cfq*(-1d0/4/ctw**2*vmach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup*cfq/qs*(qch*vmach*mch**2+qch*vpa
     & ch*mch**2-ctw**2*qch*vmach*mch**2-ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup*cfq*(-qch*vmach/mz**2*mch**2-qch
     & *vpach/mz**2*mch**2+ctw**2*qch*vmach/mz**2*mch**2+ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*vpaup*cfq*(-1d0/4/ctw**2*vmast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup*cfq/qs*(qst*vmast*mst**2+qst*vpa
     & st*mst**2-ctw**2*qst*vmast*mst**2-ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup*cfq*(-qst*vmast/mz**2*mst**2-qst
     & *vpast/mz**2*mst**2+ctw**2*qst*vmast/mz**2*mst**2+ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*vpaup*cfl*(-1d0/4/ctw**2*vmata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup*cfl/qs*(qta*vmata*mta**2+qta*vpa
     & ta*mta**2-ctw**2*qta*vmata*mta**2-ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup*cfl*(-qta*vmata/mz**2*mta**2-qta
     & *vpata/mz**2*mta**2+ctw**2*qta*vmata/mz**2*mta**2+ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*vpaup*cfq*(-1d0/4/ctw**2*vmatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup*cfq/qs*(qtp*vmatp*mtp**2+qtp*vpa
     & tp*mtp**2-ctw**2*qtp*vmatp*mtp**2-ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup*cfq*(-qtp*vmatp/mz**2*mtp**2-qtp
     & *vpatp/mz**2*mtp**2+ctw**2*qtp*vmatp/mz**2*mtp**2+ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*vpaup*cfq*(-1d0/4/ctw**2*vmabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup*cfq/qs*(qbt*vmabt*mbt**2+qbt*vpa
     & bt*mbt**2-ctw**2*qbt*vmabt*mbt**2-ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup*cfq*(-qbt*vmabt/mz**2*mbt**2-qbt
     & *vpabt/mz**2*mbt**2+ctw**2*qbt*vmabt/mz**2*mbt**2+ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzww*vpaup*(1d0/2)
     & +propizqs*det3izhqs*b0fzww*qup/qs*(-1d0/2*mh**2+3d0/2*ctw**2*mh**
     & 2-ctw**2*mz**2-ctw**4*mh**2+7*ctw**4*mz**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fzzh*vpaup*(1d0/4/ctw**2/mz**2*mh**2+3d0/8/
     & ctw**2)
     & +propizqs*det3izhqs*b0fzzh*vpaup*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fzmomo*vpaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz
     & **2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2-1d0/8/ctw**2*vpa
     & mo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*qup*cfl/qs*(-qmo*vmamo*mmo**2-qmo*vp
     & amo*mmo**2+ctw**2*qmo*vmamo*mmo**2+ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*vpaup*cfq*(-1d0/8/ctw**2*vmach**2/mz
     & **2*mch**2+1d0/4/ctw**2*vpach*vmach/mz**2*mch**2-1d0/8/ctw**2*vpa
     & ch**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*qup*cfq/qs*(-qch*vmach*mch**2-qch*vp
     & ach*mch**2+ctw**2*qch*vmach*mch**2+ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fzstst*vpaup*cfq*(-1d0/8/ctw**2*vmast**2/mz
     & **2*mst**2+1d0/4/ctw**2*vpast*vmast/mz**2*mst**2-1d0/8/ctw**2*vpa
     & st**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*qup*cfq/qs*(-qst*vmast*mst**2-qst*vp
     & ast*mst**2+ctw**2*qst*vmast*mst**2+ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fztata*vpaup*cfl*(-1d0/8/ctw**2*vmata**2/mz
     & **2*mta**2+1d0/4/ctw**2*vpata*vmata/mz**2*mta**2-1d0/8/ctw**2*vpa
     & ta**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*qup*cfl/qs*(-qta*vmata*mta**2-qta*vp
     & ata*mta**2+ctw**2*qta*vmata*mta**2+ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fztptp*vpaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz
     & **2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2-1d0/8/ctw**2*vpa
     & tp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*qup*cfq/qs*(-qtp*vmatp*mtp**2-qtp*vp
     & atp*mtp**2+ctw**2*qtp*vmatp*mtp**2+ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*vpaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz
     & **2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2-1d0/8/ctw**2*vpa
     & bt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*qup*cfq/qs*(-qbt*vmabt*mbt**2-qbt*vp
     & abt*mbt**2+ctw**2*qbt*vmabt*mbt**2+ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*vpaup*(-3d0/4-1d0/8/ctw**2/mz**2*mh**
     & 2+1d0/2/mz**2*mh**2-1d0/2*ctw**2/mz**2*mh**2+ctw**2-3*ctw**4)
     & +propizqs*det3izhqs*b0fqsww*qup*(1d0/2/mz**2*mh**2-3d0/2*ctw**2/m
     & z**2*mh**2+ctw**2+ctw**4/mz**2*mh**2-7*ctw**4+6*ctw**6)
     & +propizqs*det3izhqs*b0fqszh*vpaup*(-1d0/4/ctw**2)
     & +propizqs*det3izhqs*b0fqszh*vpaup*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fqsmomo*vpaup*cfl*(3d0/8/ctw**2*vmamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2+3d0/8/ctw**2*vpa
     & mo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*qup*cfl*(qmo*vmamo/mz**2*mmo**2+qmo
     & *vpamo/mz**2*mmo**2-ctw**2*qmo*vmamo/mz**2*mmo**2-ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*vpaup*cfq*(3d0/8/ctw**2*vmach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mch**2+3d0/8/ctw**2*vpa
     & ch**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*qup*cfq*(qch*vmach/mz**2*mch**2+qch
     & *vpach/mz**2*mch**2-ctw**2*qch*vmach/mz**2*mch**2-ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*vpaup*cfq*(3d0/8/ctw**2*vmast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mst**2+3d0/8/ctw**2*vpa
     & st**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*qup*cfq*(qst*vmast/mz**2*mst**2+qst
     & *vpast/mz**2*mst**2-ctw**2*qst*vmast/mz**2*mst**2-ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*vpaup*cfl*(3d0/8/ctw**2*vmata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mta**2+3d0/8/ctw**2*vpa
     & ta**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*qup*cfl*(qta*vmata/mz**2*mta**2+qta
     & *vpata/mz**2*mta**2-ctw**2*qta*vmata/mz**2*mta**2-ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*vpaup*cfq*(3d0/8/ctw**2*vmatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2+3d0/8/ctw**2*vpa
     & tp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*qup*cfq*(qtp*vmatp/mz**2*mtp**2+qtp
     & *vpatp/mz**2*mtp**2-ctw**2*qtp*vmatp/mz**2*mtp**2-ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*vpaup*cfq*(3d0/8/ctw**2*vmabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2+3d0/8/ctw**2*vpa
     & bt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qup*cfq*(qbt*vmabt/mz**2*mbt**2+qbt
     & *vpabt/mz**2*mbt**2-ctw**2*qbt*vmabt/mz**2*mbt**2-ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*sdet3iczts*c0cztswcc*vpadn/qs*(-2*ctw**4*mz**2)
     & +propizqs*sdet3iczts*c0cztszcc*vpaup**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3iczts*c0cztscww*(4*sdet4izhtsus*ctw**6*mz**4)
     & +propizqs*sdet3iczts*b0fzww*(4*sdet4izhtsus*ctw**4*mz**2)
     & +propizqs*sdet3iczts*b0fzcc*vpadn/qs*(2*ctw**2)
     & +propizqs*sdet3iczts*b0fzcc*vpaup**3/qs*(1d0/ctw**2)
     & +propizqs*sdet3iczts*b0ftswc*vpadn/qs*(-2*ctw**2)
     & +propizqs*sdet3iczts*b0ftswc*(-4*sdet4izhtsus*ctw**4*mz**2)
     & +propizqs*sdet3iczts*b0ftszc*vpaup**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichus*c0chuscww*vpadn/qs*(-2*ctw**4*mz**2)
     & +propizqs*sdet3ichus*c0chuscww*(-4*sdet4izhtsus*ctw**6*mz**2*mh**
     & 2)
     & +propizqs*sdet3ichus*c0chusczz*vpaup**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3ichus*b0fhww*vpadn/qs*(-2*ctw**2)
     & +propizqs*sdet3ichus*b0fhww*(-4*sdet4izhtsus*ctw**4*mh**2)
     & +propizqs*sdet3ichus*b0fhzz*vpaup**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichus*b0fuswc*vpadn/qs*(2*ctw**2)
     & +propizqs*sdet3ichus*b0fuswc*(4*sdet4izhtsus*ctw**4*mh**2)
     & +propizqs*sdet3ichus*b0fuszc*vpaup**3/qs*(1d0/ctw**2)
     & +propizqs*d0zchctsusccww*vpadn/qs*(ctw**2*mz**2+ctw**2*us-ctw**4*
     & mz**2-2*sdet4izhtsus*ctw**4*mz**4*mh**2+2*sdet4izhtsus*ctw**4*mz*
     & *6-2*sdet4izhtsus*ctw**4*us*mz**2*mh**2+2*sdet4izhtsus*ctw**4*us*
     & mz**4+sdet4izhtsus*ctw**6*mz**4*mh**2-sdet4izhtsus*ctw**6*mz**6+s
     & det4izhtsus**2*ctw**6*mz**6*mh**4-3*sdet4izhtsus**2*ctw**6*mz**8*
     & mh**2+sdet4izhtsus**2*ctw**6*us*mz**4*mh**4-2*sdet4izhtsus**2*ctw
     & **6*us*mz**6*mh**2-sdet4izhtsus**2*ctw**6*ts*mz**8)
     & +propizqs*d0zchctsusccww*vpadn*(-2*sdet4izhtsus*ctw**4*us*mz**2+s
     & det4izhtsus**2*ctw**6*us*mz**4*mh**2-sdet4izhtsus**2*ctw**6*us**2
     & *mz**4-sdet4izhtsus**2*ctw**6*ts*mz**6)
     & +propizqs*d0zchctsuscczz*vpaup**3/qs*(1d0/2/ctw**2*us-1d0/2*sdet4
     & izhtsus/ctw**2*mz**4*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**6-sdet4i
     & zhtsus/ctw**2*us*mz**2*mh**2+sdet4izhtsus/ctw**2*us*mz**4+1d0/2*s
     & det4izhtsus**2/ctw**2*mz**6*mh**4-3d0/2*sdet4izhtsus**2/ctw**2*mz
     & **8*mh**2+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**4-sdet4izhtsu
     & s**2/ctw**2*us*mz**6*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**8)
     & 
     & +propizqs*d0zchctsuscczz*vpaup**3*(-sdet4izhtsus/ctw**2*us*mz**2+
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2
     & /ctw**2*us**2*mz**4-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6)
     & +propizqs*d0cchzqsuswcww/qs*(2*sdet4izhtsus*ctw**6*mz**4*mh**2-2*
     & sdet4izhtsus*ctw**6*mz**6+2*sdet4izhtsus*ctw**6*us*mz**2*mh**2-2*
     & sdet4izhtsus*ctw**6*us*mz**4-2*sdet4izhtsus*ctw**8*mz**4*mh**2+2*
     & sdet4izhtsus*ctw**8*mz**6-2*sdet4izhtsus**2*ctw**8*mz**6*mh**4+4*
     & sdet4izhtsus**2*ctw**8*mz**8*mh**2-2*sdet4izhtsus**2*ctw**8*mz**1
     & 0-2*sdet4izhtsus**2*ctw**8*us*mz**4*mh**4+4*sdet4izhtsus**2*ctw**
     & 8*us*mz**6*mh**2-2*sdet4izhtsus**2*ctw**8*us*mz**8)
     & +propizqs*d0cchzqsuswcww*(2*sdet4izhtsus*ctw**6*mz**4+4*sdet4izht
     & sus*ctw**6*us*mz**2+2*sdet4izhtsus**2*ctw**4*us*mz**4*mh**2+4*sde
     & t4izhtsus**2*ctw**4*us**2*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*us
     & **2*mz**4+2*sdet4izhtsus**2*ctw**4*us**3*mh**2+4*sdet4izhtsus**2*
     & ctw**4*us**3*mz**2+2*sdet4izhtsus**2*ctw**4*us**4+4*sdet4izhtsus*
     & *2*ctw**6*mz**6*mh**2+4*sdet4izhtsus**2*ctw**6*us*mz**4*mh**2-4*s
     & det4izhtsus**2*ctw**6*us**2*mz**4-4*sdet4izhtsus**2*ctw**6*us**3*
     & mz**2-2*sdet4izhtsus**2*ctw**8*mz**8-2*sdet4izhtsus**2*ctw**8*us*
     & mz**4*mh**2+2*sdet4izhtsus**2*ctw**8*us**2*mz**4+2*sdet4izhtsus**
     & 2*ctw**8*ts*mz**6)
     & +propizqs*d0cczhqstswcww/qs*(sdet4izhtsus*ctw**4*mz**2*mh**4-sdet
     & 4izhtsus*ctw**4*mz**4*mh**2+sdet4izhtsus*ctw**4*ts*mz**2*mh**2-sd
     & et4izhtsus*ctw**4*ts*mz**4-2*sdet4izhtsus*ctw**6*mz**2*mh**4+2*sd
     & et4izhtsus*ctw**6*mz**4*mh**2-2*sdet4izhtsus*ctw**6*ts*mz**2*mh**
     & 2+2*sdet4izhtsus*ctw**6*ts*mz**4-2*sdet4izhtsus*ctw**8*mz**4*mh**
     & 2+2*sdet4izhtsus*ctw**8*mz**6+2*sdet4izhtsus**2*ctw**8*mz**4*mh**
     & 6-4*sdet4izhtsus**2*ctw**8*mz**6*mh**4+2*sdet4izhtsus**2*ctw**8*m
     & z**8*mh**2+2*sdet4izhtsus**2*ctw**8*ts*mz**4*mh**4-4*sdet4izhtsus
     & **2*ctw**8*ts*mz**6*mh**2+2*sdet4izhtsus**2*ctw**8*ts*mz**8)
     & +propizqs*d0cczhqstswcww*(2*ctw**4+sdet4izhtsus*ctw**2*ts*mh**2+s
     & det4izhtsus*ctw**2*ts**2+5*sdet4izhtsus*ctw**4*mz**2*mh**2+3*sdet
     & 4izhtsus*ctw**4*ts*mz**2-2*sdet4izhtsus*ctw**6*mz**2*mh**2+4*sdet
     & 4izhtsus*ctw**6*mz**4+4*sdet4izhtsus*ctw**6*us*mz**2+2*sdet4izhts
     & us**2*ctw**4*mz**4*mh**4+2*sdet4izhtsus**2*ctw**4*ts*mz**2*mh**4+
     & 4*sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2+4*sdet4izhtsus**2*ctw**4*
     & ts**2*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*ts**2*mz**4+2*sdet4izh
     & tsus**2*ctw**4*ts**3*mz**2+4*sdet4izhtsus**2*ctw**6*mz**6*mh**2+4
     & *sdet4izhtsus**2*ctw**6*us*mz**4*mh**2-4*sdet4izhtsus**2*ctw**6*t
     & s*mz**4*mh**2-4*sdet4izhtsus**2*ctw**6*ts**2*mz**4+2*sdet4izhtsus
     & **2*ctw**8*mz**4*mh**4-4*sdet4izhtsus**2*ctw**8*mz**6*mh**2-2*sde
     & t4izhtsus**2*ctw**8*us*mz**4*mh**2+2*sdet4izhtsus**2*ctw**8*us**2
     & *mz**4+2*sdet4izhtsus**2*ctw**8*ts*mz**6)
     & +propizqs*c0zhqswww/qs*(sdet4izhtsus*ctw**2*mh**4-sdet4izhtsus*ct
     & w**2*mz**2*mh**2+sdet4izhtsus*ctw**2*ts*mh**2-sdet4izhtsus*ctw**2
     & *ts*mz**2-2*sdet4izhtsus*ctw**4*mh**4+4*sdet4izhtsus*ctw**4*mz**2
     & *mh**2-2*sdet4izhtsus*ctw**4*mz**4+2*sdet4izhtsus*ctw**4*us*mh**2
     & -2*sdet4izhtsus*ctw**4*us*mz**2-2*sdet4izhtsus*ctw**4*ts*mh**2+2*
     & sdet4izhtsus*ctw**4*ts*mz**2-4*sdet4izhtsus*ctw**6*mz**2*mh**2+4*
     & sdet4izhtsus*ctw**6*mz**4+2*sdet4izhtsus**2*ctw**6*mz**2*mh**6-6*
     & sdet4izhtsus**2*ctw**6*mz**4*mh**4+6*sdet4izhtsus**2*ctw**6*mz**6
     & *mh**2-2*sdet4izhtsus**2*ctw**6*mz**8-2*sdet4izhtsus**2*ctw**6*us
     & *mz**2*mh**4+4*sdet4izhtsus**2*ctw**6*us*mz**4*mh**2-2*sdet4izhts
     & us**2*ctw**6*us*mz**6+2*sdet4izhtsus**2*ctw**6*ts*mz**2*mh**4-4*s
     & det4izhtsus**2*ctw**6*ts*mz**4*mh**2+2*sdet4izhtsus**2*ctw**6*ts*
     & mz**6)
     & +propizqs*c0zhqswww*qup/qs*(-4*ctw**2+28*ctw**4-24*ctw**6)
     & +propizqs*c0zhqswww*(sdet4izhtsus*ctw**2*mh**2-sdet4izhtsus*ctw**
     & 2*ts-2*sdet4izhtsus*ctw**4*mh**2-2*sdet4izhtsus*ctw**4*mz**2+2*sd
     & et4izhtsus*ctw**4*us+4*sdet4izhtsus**2*ctw**4*mz**4*mh**2+4*sdet4
     & izhtsus**2*ctw**4*us*mz**2*mh**2-2*sdet4izhtsus**2*ctw**4*us**2*m
     & z**2-2*sdet4izhtsus**2*ctw**4*us**3-2*sdet4izhtsus**2*ctw**4*ts*m
     & z**2*mh**2-2*sdet4izhtsus**2*ctw**4*ts**2*mz**2+2*sdet4izhtsus**2
     & *ctw**6*mz**2*mh**4-4*sdet4izhtsus**2*ctw**6*mz**4*mh**2-2*sdet4i
     & zhtsus**2*ctw**6*mz**6-4*sdet4izhtsus**2*ctw**6*us*mz**2*mh**2+4*
     & sdet4izhtsus**2*ctw**6*us**2*mz**2+4*sdet4izhtsus**2*ctw**6*ts*mz
     & **4)
     & +propizqs*c0zhqsmomomo*qup*cfl/qs*(-2*qmo*vmamo/mz**2*mmo**2-2*qm
     & o*vpamo/mz**2*mmo**2+2*ctw**2*qmo*vmamo/mz**2*mmo**2+2*ctw**2*qmo
     & *vpamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qup*cfq/qs*(-2*qch*vmach/mz**2*mch**2-2*qc
     & h*vpach/mz**2*mch**2+2*ctw**2*qch*vmach/mz**2*mch**2+2*ctw**2*qch
     & *vpach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qup*cfq/qs*(-2*qst*vmast/mz**2*mst**2-2*qs
     & t*vpast/mz**2*mst**2+2*ctw**2*qst*vmast/mz**2*mst**2+2*ctw**2*qst
     & *vpast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qup*cfl/qs*(-2*qta*vmata/mz**2*mta**2-2*qt
     & a*vpata/mz**2*mta**2+2*ctw**2*qta*vmata/mz**2*mta**2+2*ctw**2*qta
     & *vpata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qup*cfq/qs*(-2*qtp*vmatp/mz**2*mtp**2-2*qt
     & p*vpatp/mz**2*mtp**2+2*ctw**2*qtp*vmatp/mz**2*mtp**2+2*ctw**2*qtp
     & *vpatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qup*cfq/qs*(-2*qbt*vmabt/mz**2*mbt**2-2*qb
     & t*vpabt/mz**2*mbt**2+2*ctw**2*qbt*vmabt/mz**2*mbt**2+2*ctw**2*qbt
     & *vpabt/mz**2*mbt**2)
     & +propizqs*c0chtscww/qs*(ctw**2-2*ctw**4-sdet4izhtsus*ctw**2*mh**4
     & +sdet4izhtsus*ctw**2*mz**2*mh**2-sdet4izhtsus*ctw**2*ts*mh**2+sde
     & t4izhtsus*ctw**2*ts*mz**2+2*sdet4izhtsus*ctw**4*mh**4-2*sdet4izht
     & sus*ctw**4*mz**2*mh**2+2*sdet4izhtsus*ctw**4*ts*mh**2-2*sdet4izht
     & sus*ctw**4*ts*mz**2+4*sdet4izhtsus*ctw**6*mz**2*mh**2-2*sdet4izht
     & sus*ctw**6*mz**4+2*sdet4izhtsus*ctw**6*ts*mz**2-2*sdet4izhtsus**2
     & *ctw**6*mz**2*mh**6+4*sdet4izhtsus**2*ctw**6*mz**4*mh**4-2*sdet4i
     & zhtsus**2*ctw**6*mz**6*mh**2-2*sdet4izhtsus**2*ctw**6*ts*mz**2*mh
     & **4+4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh**2-2*sdet4izhtsus**2*ctw
     & **6*ts*mz**6)
     & +propizqs*c0chtscww*vpadn/qs*(-ctw**2-2*sdet4izhtsus*ctw**2*mz**2
     & *mh**2-sdet4izhtsus*ctw**2*us*mh**2-sdet4izhtsus*ctw**2*ts*mz**2+
     & sdet4izhtsus*ctw**4*mz**2*mh**2-2*sdet4izhtsus*ctw**4*mz**4-sdet4
     & izhtsus*ctw**4*us*mz**2+2*sdet4izhtsus**2*ctw**4*mz**4*mh**4-2*sd
     & et4izhtsus**2*ctw**4*mz**6*mh**2+sdet4izhtsus**2*ctw**4*us*mz**2*
     & mh**4-sdet4izhtsus**2*ctw**4*us*mz**4*mh**2+sdet4izhtsus**2*ctw**
     & 4*ts*mz**4*mh**2-sdet4izhtsus**2*ctw**4*ts*mz**6)
     & +propizqs*c0chtscww*vpadn*(sdet4izhtsus**2*ctw**4*us*mz**2*mh**2-
     & sdet4izhtsus**2*ctw**4*ts*mz**4)
     & +propizqs*c0chtscww*(sdet4izhtsus*ctw**2*ts+2*sdet4izhtsus*ctw**4
     & *mh**2+2*sdet4izhtsus*ctw**6*mz**2+2*sdet4izhtsus**2*ctw**4*mz**2
     & *mh**4+4*sdet4izhtsus**2*ctw**4*ts*mz**2*mh**2+2*sdet4izhtsus**2*
     & ctw**4*ts**2*mz**2-2*sdet4izhtsus**2*ctw**6*mz**2*mh**4+2*sdet4iz
     & htsus**2*ctw**6*mz**4*mh**2+2*sdet4izhtsus**2*ctw**6*us*mz**2*mh*
     & *2-2*sdet4izhtsus**2*ctw**6*ts*mz**4)
     & +propizqs*c0chtsczz*vpaup**3/qs*(-1d0/2/ctw**2-1d0/2*sdet4izhtsus
     & /ctw**2*mz**2*mh**2-sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsus/
     & ctw**2*us*mh**2-1d0/2*sdet4izhtsus/ctw**2*us*mz**2-1d0/2*sdet4izh
     & tsus/ctw**2*ts*mz**2+sdet4izhtsus**2/ctw**2*mz**4*mh**4-sdet4izht
     & sus**2/ctw**2*mz**6*mh**2+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**2*m
     & h**4-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2+1d0/2*sdet4izhts
     & us**2/ctw**2*ts*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6
     & )
     & +propizqs*c0chtsczz*vpaup**3*(1d0/2*sdet4izhtsus**2/ctw**2*us*mz*
     & *2*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4)
     & +propizqs*c0chuscww/qs*(2*ctw**4+2*sdet4izhtsus*ctw**6*mz**4+2*sd
     & et4izhtsus*ctw**6*us*mz**2)
     & +propizqs*c0chuscww*vpadn/qs*(ctw**2-sdet4izhtsus*ctw**4*mz**4-sd
     & et4izhtsus*ctw**4*us*mz**2-sdet4izhtsus**2*ctw**4*mz**4*mh**4-sde
     & t4izhtsus**2*ctw**4*mz**6*mh**2-sdet4izhtsus**2*ctw**4*us*mz**4*m
     & h**2-sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2)
     & +propizqs*c0chuscww*vpadn*(-sdet4izhtsus*ctw**2*us-sdet4izhtsus**
     & 2*ctw**4*us**2*mz**2)
     & +propizqs*c0chuscww*(-2*sdet4izhtsus*ctw**4*us+4*sdet4izhtsus*ctw
     & **6*mz**2+2*sdet4izhtsus**2*ctw**4*us*mz**2*mh**2+2*sdet4izhtsus*
     & *2*ctw**4*us**2*mh**2+2*sdet4izhtsus**2*ctw**4*us**2*mz**2+2*sdet
     & 4izhtsus**2*ctw**4*us**3+2*sdet4izhtsus**2*ctw**6*mz**4*mh**2-2*s
     & det4izhtsus**2*ctw**6*us**2*mz**2)
     & +propizqs*c0chusczz*vpaup**3/qs*(1d0/2/ctw**2-1d0/2*sdet4izhtsus/
     & ctw**2*mz**4-1d0/2*sdet4izhtsus/ctw**2*us*mz**2-1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**4*mh**4-1d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2
     & /ctw**2*ts*mz**4*mh**2)
     & +propizqs*c0chusczz*vpaup**3*(-1d0/2*sdet4izhtsus/ctw**2*us-1d0/2
     & *sdet4izhtsus**2/ctw**2*us**2*mz**2)
     & +propizqs*c0cztswcc*vpadn/qs*(-ctw**2+sdet4izhtsus*ctw**2*mz**2*m
     & h**2+sdet4izhtsus*ctw**2*mz**4+sdet4izhtsus*ctw**2*us*mz**2+sdet4
     & izhtsus*ctw**2*ts*mz**2+sdet4izhtsus*ctw**4*mz**4+sdet4izhtsus*ct
     & w**4*us*mz**2)
     & +propizqs*c0cztswcc*vpadn*(-sdet4izhtsus**2*ctw**4*us*mz**4+sdet4
     & izhtsus**2*ctw**4*ts*mz**4)
     & +propizqs*c0cztszcc*vpaup**3/qs*(-1d0/2/ctw**2+1d0/2*sdet4izhtsus
     & /ctw**2*mz**2*mh**2+sdet4izhtsus/ctw**2*mz**4+sdet4izhtsus/ctw**2
     & *us*mz**2+1d0/2*sdet4izhtsus/ctw**2*ts*mz**2)
     & +propizqs*c0cztszcc*vpaup**3*(-1d0/2*sdet4izhtsus**2/ctw**2*us*mz
     & **4+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4)
     & +propizqs*c0cztscww/qs*(-ctw**2+2*ctw**4-2*sdet4izhtsus*ctw**6*mz
     & **2*mh**2-2*sdet4izhtsus*ctw**6*ts*mz**2)
     & +propizqs*c0cztscww*(sdet4izhtsus*ctw**2*ts+2*sdet4izhtsus*ctw**4
     & *mz**2-2*sdet4izhtsus*ctw**6*mz**2+2*sdet4izhtsus**2*ctw**4*mz**4
     & *mh**2+2*sdet4izhtsus**2*ctw**4*ts*mz**2*mh**2+2*sdet4izhtsus**2*
     & ctw**4*ts*mz**4+2*sdet4izhtsus**2*ctw**4*ts**2*mz**2+2*sdet4izhts
     & us**2*ctw**6*us*mz**4-2*sdet4izhtsus**2*ctw**6*ts*mz**4)
     & +propizqs*c0czuswcc*vpadn/qs*(ctw**2+sdet4izhtsus*ctw**2*mz**2*mh
     & **2-sdet4izhtsus*ctw**2*mz**4+sdet4izhtsus*ctw**2*us*mh**2-sdet4i
     & zhtsus*ctw**2*us*mz**2-sdet4izhtsus*ctw**4*mz**2*mh**2+2*sdet4izh
     & tsus*ctw**4*mz**4+sdet4izhtsus*ctw**4*us*mz**2-sdet4izhtsus**2*ct
     & w**4*mz**4*mh**4+3*sdet4izhtsus**2*ctw**4*mz**6*mh**2-sdet4izhtsu
     & s**2*ctw**4*us*mz**2*mh**4+2*sdet4izhtsus**2*ctw**4*us*mz**4*mh**
     & 2+sdet4izhtsus**2*ctw**4*ts*mz**6)
     & +propizqs*c0czuswcc*vpadn*(sdet4izhtsus*ctw**2*us-sdet4izhtsus**2
     & *ctw**4*us*mz**2*mh**2+sdet4izhtsus**2*ctw**4*us*mz**4+sdet4izhts
     & us**2*ctw**4*us**2*mz**2)
     & +propizqs*c0czuszcc*vpaup**3/qs*(1d0/2/ctw**2+1d0/2*sdet4izhtsus/
     & ctw**2*mz**4+1d0/2*sdet4izhtsus/ctw**2*us*mh**2-1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**4*mh**4+3d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**2*mh**4+sdet4izhtsus**2/ctw**
     & 2*us*mz**4*mh**2+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6)
     & +propizqs*c0czuszcc*vpaup**3*(1d0/2*sdet4izhtsus/ctw**2*us-1d0/2*
     & sdet4izhtsus**2/ctw**2*us*mz**2*mh**2+1d0/2*sdet4izhtsus**2/ctw**
     & 2*us*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*us**2*mz**2)
     & +propizqs*c0czuscww/qs*(-2*ctw**4-2*sdet4izhtsus*ctw**4*mz**2*mh*
     & *2+2*sdet4izhtsus*ctw**4*mz**4-2*sdet4izhtsus*ctw**4*us*mh**2+2*s
     & det4izhtsus*ctw**4*us*mz**2+2*sdet4izhtsus*ctw**6*mz**2*mh**2-4*s
     & det4izhtsus*ctw**6*mz**4-2*sdet4izhtsus*ctw**6*us*mz**2+2*sdet4iz
     & htsus**2*ctw**6*mz**4*mh**4-4*sdet4izhtsus**2*ctw**6*mz**6*mh**2+
     & 2*sdet4izhtsus**2*ctw**6*mz**8+2*sdet4izhtsus**2*ctw**6*us*mz**2*
     & mh**4-4*sdet4izhtsus**2*ctw**6*us*mz**4*mh**2+2*sdet4izhtsus**2*c
     & tw**6*us*mz**6)
     & +propizqs*c0czuscww*(-2*sdet4izhtsus*ctw**4*us+2*sdet4izhtsus**2*
     & ctw**4*us*mz**4+4*sdet4izhtsus**2*ctw**4*us**2*mz**2+2*sdet4izhts
     & us**2*ctw**4*us**3+2*sdet4izhtsus**2*ctw**6*mz**6+2*sdet4izhtsus*
     & *2*ctw**6*us*mz**2*mh**2-2*sdet4izhtsus**2*ctw**6*us*mz**4-2*sdet
     & 4izhtsus**2*ctw**6*us**2*mz**2)
     & +propizqs*c0ccqswcw*(-sdet4izhtsus*ctw**2*mh**2-sdet4izhtsus*ctw*
     & *2*ts-4*sdet4izhtsus*ctw**4*mz**2-2*sdet4izhtsus*ctw**4*us-2*sdet
     & 4izhtsus**2*ctw**4*mz**2*mh**4-6*sdet4izhtsus**2*ctw**4*mz**4*mh*
     & *2-6*sdet4izhtsus**2*ctw**4*us*mz**2*mh**2-2*sdet4izhtsus**2*ctw*
     & *4*us*mz**4-2*sdet4izhtsus**2*ctw**4*us**2*mh**2-4*sdet4izhtsus**
     & 2*ctw**4*us**2*mz**2-2*sdet4izhtsus**2*ctw**4*us**3-4*sdet4izhtsu
     & s**2*ctw**4*ts*mz**2*mh**2-2*sdet4izhtsus**2*ctw**4*ts*mz**4-2*sd
     & et4izhtsus**2*ctw**4*ts**2*mz**2)
     & +propizqs*b0fhww*vpadn/qs*(-2*sdet4izhtsus*ctw**2*mz**2-2*sdet4iz
     & htsus*ctw**2*us)
     & +propizqs*b0fhww*(4*sdet4izhtsus*ctw**4)
     & +propizqs*b0fhzz*vpaup**3/qs*(-sdet4izhtsus/ctw**2*mz**2-sdet4izh
     & tsus/ctw**2*us)
     & +propizqs*b0fzcc*vpadn/qs*(-2*sdet4izhtsus*ctw**2*mz**2-2*sdet4iz
     & htsus*ctw**2*us)
     & +propizqs*b0fzcc*vpaup**3/qs*(-sdet4izhtsus/ctw**2*mz**2-sdet4izh
     & tsus/ctw**2*us)
     & +propizqs*b0ftswc*vpadn/qs*(2*sdet4izhtsus*ctw**2*mz**2+2*sdet4iz
     & htsus*ctw**2*us)
     & +propizqs*b0ftszc*vpaup**3/qs*(sdet4izhtsus/ctw**2*mz**2+sdet4izh
     & tsus/ctw**2*us)
     & +propizqs*b0fuswc*vpadn/qs*(2*sdet4izhtsus*ctw**2*mz**2+2*sdet4iz
     & htsus*ctw**2*us)
     & +propizqs*b0fuswc*(-4*sdet4izhtsus*ctw**4)
     & +propizqs*b0fuszc*vpaup**3/qs*(sdet4izhtsus/ctw**2*mz**2+sdet4izh
     & tsus/ctw**2*us)
     & +det3izhqs*vpaup*(-7d0/8/ctw**2*mh**2+1d0/4/ctw**2*mz**2+3d0/4*mh
     & **2+1d0/2*mz**2-2*ctw**2*mz**2-3*ctw**4*mh**2+6*ctw**4*mz**2)
     & +det3izhqs*vpaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d
     & 0/2/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt*
     & *2-1d0/2/ctw**2*vpabt**2*mbt**2+1d0/4/ctw**2*vmatp**2/mz**2*mh**2
     & *mtp**2-1d0/2/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*
     & mh**2*mtp**2-1d0/2/ctw**2*vpatp**2*mtp**2+1d0/4/ctw**2*vmast**2/m
     & z**2*mh**2*mst**2-1d0/2/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast
     & **2/mz**2*mh**2*mst**2-1d0/2/ctw**2*vpast**2*mst**2+1d0/4/ctw**2*
     & vmach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vmach**2*mch**2+1d0/4/ct
     & w**2*vpach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vpach**2*mch**2)
     & +det3izhqs*vpaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d
     & 0/2/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta*
     & *2-1d0/2/ctw**2*vpata**2*mta**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2
     & *mmo**2-1d0/2/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*
     & mh**2*mmo**2-1d0/2/ctw**2*vpamo**2*mmo**2)
     & +det3izhqs**2*c0zhqswww*vpaup*(-3d0/2/ctw**2*mz**6*mh**2+21d0/4*m
     & z**6*mh**2-3*ctw**2*mz**6*mh**2-9*ctw**4*mz**6*mh**2)
     & +det3izhqs**2*c0zhqszhh*vpaup*(-9/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqshzz*vpaup*(-18/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqsmomomo*vpaup*cfl*(3d0/4/ctw**2*vmamo**2*mz**4
     & *mh**2*mmo**2+3d0/4/ctw**2*vpamo**2*mz**4*mh**2*mmo**2)
     & +det3izhqs**2*c0zhqschchch*vpaup*cfq*(3d0/4/ctw**2*vmach**2*mz**4
     & *mh**2*mch**2+3d0/4/ctw**2*vpach**2*mz**4*mh**2*mch**2)
     & +det3izhqs**2*c0zhqsststst*vpaup*cfq*(3d0/4/ctw**2*vmast**2*mz**4
     & *mh**2*mst**2+3d0/4/ctw**2*vpast**2*mz**4*mh**2*mst**2)
     & +det3izhqs**2*c0zhqstatata*vpaup*cfl*(3d0/4/ctw**2*vmata**2*mz**4
     & *mh**2*mta**2+3d0/4/ctw**2*vpata**2*mz**4*mh**2*mta**2)
     & +det3izhqs**2*c0zhqstptptp*vpaup*cfq*(3d0/4/ctw**2*vmatp**2*mz**4
     & *mh**2*mtp**2+3d0/4/ctw**2*vpatp**2*mz**4*mh**2*mtp**2)
     & +det3izhqs**2*c0zhqsbtbtbt*vpaup*cfq*(3d0/4/ctw**2*vmabt**2*mz**4
     & *mh**2*mbt**2+3d0/4/ctw**2*vpabt**2*mz**4*mh**2*mbt**2)
     & +det3izhqs**2*b0fhww*vpaup*(3d0/2/ctw**2*mz**4*mh**2-21d0/4*mz**4
     & *mh**2+3*ctw**2*mz**4*mh**2+9*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fhzz*vpaup*(9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhhh*vpaup*(-9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhmomo*vpaup*cfl*(-3d0/4/ctw**2*vmamo**2*mz**2*mh
     & **2*mmo**2-3d0/4/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fhchch*vpaup*cfq*(-3d0/4/ctw**2*vmach**2*mz**2*mh
     & **2*mch**2-3d0/4/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fhstst*vpaup*cfq*(-3d0/4/ctw**2*vmast**2*mz**2*mh
     & **2*mst**2-3d0/4/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fhtata*vpaup*cfl*(-3d0/4/ctw**2*vmata**2*mz**2*mh
     & **2*mta**2-3d0/4/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fhtptp*vpaup*cfq*(-3d0/4/ctw**2*vmatp**2*mz**2*mh
     & **2*mtp**2-3d0/4/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fhbtbt*vpaup*cfq*(-3d0/4/ctw**2*vmabt**2*mz**2*mh
     & **2*mbt**2-3d0/4/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fzww*vpaup*(-3d0/4/ctw**2*mz**4*mh**2+21d0/8*mz**
     & 4*mh**2-3d0/2*ctw**2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fzmomo*vpaup*cfl*(3d0/8/ctw**2*vmamo**2*mz**2*mh*
     & *2*mmo**2+3d0/8/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fzchch*vpaup*cfq*(3d0/8/ctw**2*vmach**2*mz**2*mh*
     & *2*mch**2+3d0/8/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fzstst*vpaup*cfq*(3d0/8/ctw**2*vmast**2*mz**2*mh*
     & *2*mst**2+3d0/8/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fztata*vpaup*cfl*(3d0/8/ctw**2*vmata**2*mz**2*mh*
     & *2*mta**2+3d0/8/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fztptp*vpaup*cfq*(3d0/8/ctw**2*vmatp**2*mz**2*mh*
     & *2*mtp**2+3d0/8/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fzbtbt*vpaup*cfq*(3d0/8/ctw**2*vmabt**2*mz**2*mh*
     & *2*mbt**2+3d0/8/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fqsww*vpaup*(-3d0/4/ctw**2*mz**4*mh**2+21d0/8*mz*
     & *4*mh**2-3d0/2*ctw**2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fqsmomo*vpaup*cfl*(3d0/8/ctw**2*vmamo**2*mz**2*mh
     & **2*mmo**2+3d0/8/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fqschch*vpaup*cfq*(3d0/8/ctw**2*vmach**2*mz**2*mh
     & **2*mch**2+3d0/8/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fqsstst*vpaup*cfq*(3d0/8/ctw**2*vmast**2*mz**2*mh
     & **2*mst**2+3d0/8/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fqstata*vpaup*cfl*(3d0/8/ctw**2*vmata**2*mz**2*mh
     & **2*mta**2+3d0/8/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fqstptp*vpaup*cfq*(3d0/8/ctw**2*vmatp**2*mz**2*mh
     & **2*mtp**2+3d0/8/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fqsbtbt*vpaup*cfq*(3d0/8/ctw**2*vmabt**2*mz**2*mh
     & **2*mbt**2+3d0/8/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*c0zhqswww*vpaup*(1d0/2/ctw**2*mz**2*mh**2+3d0/2/ctw**2
     & *mz**4-1d0/2*mz**2*mh**2-5*mz**4+1d0/2*ctw**2*mz**2*mh**2+ctw**2*
     & mz**4+16*ctw**4*mz**4+6*ctw**6*mz**2*mh**2-12*ctw**6*mz**4)
     & +det3izhqs*c0zhqszhh*vpaup*(51d0/4/ctw**2*mz**2*mh**2+9/ctw**2*mz
     & **4)
     & +det3izhqs*c0zhqshzz*vpaup*(17/ctw**2*mz**2*mh**2+18/ctw**2*mz**4
     & )
     & +det3izhqs*c0zhqsmomomo*vpaup*cfl*(-1d0/2/ctw**2*vmamo**2/mz**2*m
     & h**2*mmo**4+1d0/ctw**2*vmamo**2*mmo**4-1d0/4/ctw**2*vmamo**2*mh**
     & 2*mmo**2-1d0/ctw**2*vmamo**2*mz**2*mmo**2+1d0/2/ctw**2*vpamo*vmam
     & o*mh**2*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mh**2*mmo**4+1d0/ctw**
     & 2*vpamo**2*mmo**4-1d0/4/ctw**2*vpamo**2*mh**2*mmo**2-1d0/ctw**2*v
     & pamo**2*mz**2*mmo**2)
     & +det3izhqs*c0zhqschchch*vpaup*cfq*(-1d0/2/ctw**2*vmach**2/mz**2*m
     & h**2*mch**4+1d0/ctw**2*vmach**2*mch**4-1d0/4/ctw**2*vmach**2*mh**
     & 2*mch**2-1d0/ctw**2*vmach**2*mz**2*mch**2+1d0/2/ctw**2*vpach*vmac
     & h*mh**2*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mh**2*mch**4+1d0/ctw**
     & 2*vpach**2*mch**4-1d0/4/ctw**2*vpach**2*mh**2*mch**2-1d0/ctw**2*v
     & pach**2*mz**2*mch**2)
     & +det3izhqs*c0zhqsststst*vpaup*cfq*(-1d0/2/ctw**2*vmast**2/mz**2*m
     & h**2*mst**4+1d0/ctw**2*vmast**2*mst**4-1d0/4/ctw**2*vmast**2*mh**
     & 2*mst**2-1d0/ctw**2*vmast**2*mz**2*mst**2+1d0/2/ctw**2*vpast*vmas
     & t*mh**2*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mh**2*mst**4+1d0/ctw**
     & 2*vpast**2*mst**4-1d0/4/ctw**2*vpast**2*mh**2*mst**2-1d0/ctw**2*v
     & past**2*mz**2*mst**2)
     & +det3izhqs*c0zhqstatata*vpaup*cfl*(-1d0/2/ctw**2*vmata**2/mz**2*m
     & h**2*mta**4+1d0/ctw**2*vmata**2*mta**4-1d0/4/ctw**2*vmata**2*mh**
     & 2*mta**2-1d0/ctw**2*vmata**2*mz**2*mta**2+1d0/2/ctw**2*vpata*vmat
     & a*mh**2*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mh**2*mta**4+1d0/ctw**
     & 2*vpata**2*mta**4-1d0/4/ctw**2*vpata**2*mh**2*mta**2-1d0/ctw**2*v
     & pata**2*mz**2*mta**2)
     & +det3izhqs*c0zhqstptptp*vpaup*cfq*(-1d0/2/ctw**2*vmatp**2/mz**2*m
     & h**2*mtp**4+1d0/ctw**2*vmatp**2*mtp**4-1d0/4/ctw**2*vmatp**2*mh**
     & 2*mtp**2-1d0/ctw**2*vmatp**2*mz**2*mtp**2+1d0/2/ctw**2*vpatp*vmat
     & p*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mh**2*mtp**4+1d0/ctw**
     & 2*vpatp**2*mtp**4-1d0/4/ctw**2*vpatp**2*mh**2*mtp**2-1d0/ctw**2*v
     & patp**2*mz**2*mtp**2)
     & +det3izhqs*c0zhqsbtbtbt*vpaup*cfq*(-1d0/2/ctw**2*vmabt**2/mz**2*m
     & h**2*mbt**4+1d0/ctw**2*vmabt**2*mbt**4-1d0/4/ctw**2*vmabt**2*mh**
     & 2*mbt**2-1d0/ctw**2*vmabt**2*mz**2*mbt**2+1d0/2/ctw**2*vpabt*vmab
     & t*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mh**2*mbt**4+1d0/ctw**
     & 2*vpabt**2*mbt**4-1d0/4/ctw**2*vpabt**2*mh**2*mbt**2-1d0/ctw**2*v
     & pabt**2*mz**2*mbt**2)
     & +det3izhqs*a0fz*vpaup*(-1d0/4/ctw**2*mh**2+1d0/4/ctw**2*mz**2)
     & +det3izhqs*a0fh*vpaup*(3d0/4/ctw**2*mh**2)
     & +det3izhqs*b0fhww*vpaup*(-1d0/4/ctw**2*mh**2-3d0/2/ctw**2*mz**2+1
     & 1d0/2*mz**2-ctw**2*mh**2-4*ctw**2*mz**2-6*ctw**4*mz**2)
     & +det3izhqs*b0fhzz*vpaup*(-21d0/8/ctw**2*mh**2-17d0/4/ctw**2*mz**2
     & )
     & +det3izhqs*b0fhhh*vpaup*(33d0/8/ctw**2*mh**2+9d0/2/ctw**2*mz**2)
     & +det3izhqs*b0fhmomo*vpaup*cfl*(1d0/4/ctw**2*vmamo**2/mz**2*mh**2*
     & mmo**2+1d0/2/ctw**2*vmamo**2*mmo**2-1d0/2/ctw**2*vpamo*vmamo/mz**
     & 2*mh**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2+1d0/2/ctw
     & **2*vpamo**2*mmo**2)
     & +det3izhqs*b0fhchch*vpaup*cfq*(1d0/4/ctw**2*vmach**2/mz**2*mh**2*
     & mch**2+1d0/2/ctw**2*vmach**2*mch**2-1d0/2/ctw**2*vpach*vmach/mz**
     & 2*mh**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2+1d0/2/ctw
     & **2*vpach**2*mch**2)
     & +det3izhqs*b0fhstst*vpaup*cfq*(1d0/4/ctw**2*vmast**2/mz**2*mh**2*
     & mst**2+1d0/2/ctw**2*vmast**2*mst**2-1d0/2/ctw**2*vpast*vmast/mz**
     & 2*mh**2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2*mst**2+1d0/2/ctw
     & **2*vpast**2*mst**2)
     & +det3izhqs*b0fhtata*vpaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mh**2*
     & mta**2+1d0/2/ctw**2*vmata**2*mta**2-1d0/2/ctw**2*vpata*vmata/mz**
     & 2*mh**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta**2+1d0/2/ctw
     & **2*vpata**2*mta**2)
     & +det3izhqs*b0fhtptp*vpaup*cfq*(1d0/4/ctw**2*vmatp**2/mz**2*mh**2*
     & mtp**2+1d0/2/ctw**2*vmatp**2*mtp**2-1d0/2/ctw**2*vpatp*vmatp/mz**
     & 2*mh**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mh**2*mtp**2+1d0/2/ctw
     & **2*vpatp**2*mtp**2)
     & +det3izhqs*b0fhbtbt*vpaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mh**2*
     & mbt**2+1d0/2/ctw**2*vmabt**2*mbt**2-1d0/2/ctw**2*vpabt*vmabt/mz**
     & 2*mh**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt**2+1d0/2/ctw
     & **2*vpabt**2*mbt**2)
     & +det3izhqs*b0fzww*vpaup*(1d0/8/ctw**2*mh**2+3d0/4/ctw**2*mz**2-11
     & d0/4*mz**2+1d0/2*ctw**2*mh**2+2*ctw**2*mz**2+3*ctw**4*mz**2)
     & +det3izhqs*b0fzzh*vpaup*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fzmomo*vpaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh**2
     & *mmo**2-1d0/4/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz*
     & *2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ct
     & w**2*vpamo**2*mmo**2)
     & +det3izhqs*b0fzchch*vpaup*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh**2
     & *mch**2-1d0/4/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpach*vmach/mz*
     & *2*mh**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ct
     & w**2*vpach**2*mch**2)
     & +det3izhqs*b0fzstst*vpaup*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh**2
     & *mst**2-1d0/4/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast*vmast/mz*
     & *2*mh**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ct
     & w**2*vpast**2*mst**2)
     & +det3izhqs*b0fztata*vpaup*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh**2
     & *mta**2-1d0/4/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata*vmata/mz*
     & *2*mh**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ct
     & w**2*vpata**2*mta**2)
     & +det3izhqs*b0fztptp*vpaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh**2
     & *mtp**2-1d0/4/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz*
     & *2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ct
     & w**2*vpatp**2*mtp**2)
     & +det3izhqs*b0fzbtbt*vpaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh**2
     & *mbt**2-1d0/4/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz*
     & *2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ct
     & w**2*vpabt**2*mbt**2)
     & +det3izhqs*b0fqsww*vpaup*(1d0/8/ctw**2*mh**2+3d0/4/ctw**2*mz**2-1
     & 1d0/4*mz**2+1d0/2*ctw**2*mh**2+2*ctw**2*mz**2+3*ctw**4*mz**2)
     & +det3izhqs*b0fqszh*vpaup*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fqsmomo*vpaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh**
     & 2*mmo**2-1d0/4/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz
     & **2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/c
     & tw**2*vpamo**2*mmo**2)
     & +det3izhqs*b0fqschch*vpaup*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh**
     & 2*mch**2-1d0/4/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpach*vmach/mz
     & **2*mh**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/c
     & tw**2*vpach**2*mch**2)
     & +det3izhqs*b0fqsstst*vpaup*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh**
     & 2*mst**2-1d0/4/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast*vmast/mz
     & **2*mh**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/c
     & tw**2*vpast**2*mst**2)
     & +det3izhqs*b0fqstata*vpaup*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh**
     & 2*mta**2-1d0/4/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata*vmata/mz
     & **2*mh**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/c
     & tw**2*vpata**2*mta**2)
     & +det3izhqs*b0fqstptp*vpaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh**
     & 2*mtp**2-1d0/4/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz
     & **2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/c
     & tw**2*vpatp**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*vpaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh**
     & 2*mbt**2-1d0/4/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz
     & **2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/c
     & tw**2*vpabt**2*mbt**2)
     & +c0zhqswww*vpaup*(-1-4*ctw**2+12*ctw**4)
     & +c0zhqszhh*vpaup*(-3/ctw**2/mz**2*mh**2-21d0/2/ctw**2)
     & +c0zhqshzz*vpaup*(-3d0/2/ctw**2/mz**2*mh**2-13/ctw**2)
     & +c0zhqsmomomo*vpaup*cfl*(-1d0/ctw**2*vpamo*vmamo/mz**2*mmo**2)
     & +c0zhqschchch*vpaup*cfq*(-1d0/ctw**2*vpach*vmach/mz**2*mch**2)
     & +c0zhqsststst*vpaup*cfq*(-1d0/ctw**2*vpast*vmast/mz**2*mst**2)
     & +c0zhqstatata*vpaup*cfl*(-1d0/ctw**2*vpata*vmata/mz**2*mta**2)
     & +c0zhqstptptp*vpaup*cfq*(-1d0/ctw**2*vpatp*vmatp/mz**2*mtp**2)
     & +c0zhqsbtbtbt*vpaup*cfq*(-1d0/ctw**2*vpabt*vmabt/mz**2*mbt**2)
     & +a0fh*vpaup*(-1d0/ctw**2/mz**2)
     & +b0fhzz*vpaup*(1d0/ctw**2/mz**2)
     & +b0fhhh*vpaup*(-3/ctw**2/mz**2)
     & +b0fzzh*vpaup*(1d0/2/ctw**2/mz**2)
     & +b0fqszh*vpaup*(1d0/2/ctw**2/mz**2)

      ffgm0=
     & +cfq*(-1d0/2/ctw**2*vmabt**2/mz**2*mbt**2-1d0/2/ctw**2*vpabt**2/m
     & z**2*mbt**2-1d0/2/ctw**2*vmatp**2/mz**2*mtp**2-1d0/2/ctw**2*vpatp
     & **2/mz**2*mtp**2-1d0/2/ctw**2*vmast**2/mz**2*mst**2-1d0/2/ctw**2*
     & vpast**2/mz**2*mst**2-1d0/2/ctw**2*vmach**2/mz**2*mch**2-1d0/2/ct
     & w**2*vpach**2/mz**2*mch**2)
     & +cfl*(-1d0/2/ctw**2*vmata**2/mz**2*mta**2-1d0/2/ctw**2*vpata**2/m
     & z**2*mta**2-1d0/2/ctw**2*vmamo**2/mz**2*mmo**2-1d0/2/ctw**2*vpamo
     & **2/mz**2*mmo**2)
     & +vmaup**2*(-1d0/4/ctw**2)
     & +vpaup**2*(-1d0/8/ctw**2)
     & +propzqs*a0fw*(1d0/6*mz**2-8d0/3*ctw**2*mz**2+3*ctw**2*mz**4/mh**
     & 2-4*ctw**4*mz**2)
     & +propzqs*a0fz*(-1d0/12/ctw**2*mh**2+1d0/6/ctw**2*mz**2+3d0/2/ctw*
     & *2*mz**4/mh**2)
     & +propzqs*a0fh*(1d0/12/ctw**2/mz**2*mh**4+1d0/2/ctw**2*mh**2)
     & +propzqs*b0fqsww*(1d0/12/ctw**2*mz**2+4d0/3*mz**2-17d0/3*ctw**2*m
     & z**2-4*ctw**4*mz**2)
     & +propzqs*b0fqszh*(1d0/12/ctw**2/mz**2*mh**4-1d0/3/ctw**2*mh**2+1d
     & 0/ctw**2*mz**2)
     & +propzqs*(-1d0/6/ctw**2*mh**2-1d0/18/ctw**2*mz**2+1d0/ctw**2*mz**
     & 4/mh**2-5d0/9*mz**2-mz**2*zmzzzbos-8d0/3*ctw**2*mz**2+2*ctw**2*mz
     & **4/mh**2-4*ctw**4*mz**2)
     & +propizqs/qs*(1d0/2/mz**2*mh**2-ctw**2/mz**2*mh**2+1d0/3*ctw**2-2
     & *ctw**4)
     & +propizqs*cfq/qs*(qbt*vmabt/mz**2*mbt**2+qbt*vpabt/mz**2*mbt**2+q
     & tp*vmatp/mz**2*mtp**2+qtp*vpatp/mz**2*mtp**2+qst*vmast/mz**2*mst*
     & *2+qst*vpast/mz**2*mst**2+qch*vmach/mz**2*mch**2+qch*vpach/mz**2*
     & mch**2)
     & +propizqs*cfl/qs*(qta*vmata/mz**2*mta**2+qta*vpata/mz**2*mta**2+q
     & mo*vmamo/mz**2*mmo**2+qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqswww*qs*(-1d0/8/ctw**2*mz**2+1d0/2*mz**2
     & -1d0/2*ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*(-1d0/8/ctw**2*mh**4-1d0/4/ctw**2*m
     & z**2*mh**2-1d0/8/ctw**2*mz**4+1d0/4*mh**4+3d0/4*mz**2*mh**2+1d0/2
     & *mz**4-1d0/2*ctw**2*mz**2*mh**2-1d0/2*ctw**2*mz**4)
     & +propizqs*det3izhqs*c0zhqszhh*qs*(-3d0/16/ctw**2*mh**2-3d0/4/ctw*
     & *2*mz**2)
     & +propizqs*det3izhqs*c0zhqszhh*(-3d0/16/ctw**2/mz**2*mh**6-3d0/8/c
     & tw**2*mh**4-27d0/16/ctw**2*mz**2*mh**2-3d0/4/ctw**2*mz**4)
     & +propizqs*det3izhqs*c0zhqshzz*qs*(-1d0/8/ctw**2/mz**2*mh**4-7d0/1
     & 6/ctw**2*mh**2-11d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqshzz*(-3d0/16/ctw**2/mz**2*mh**6-1d0/ctw
     & **2*mh**4-55d0/16/ctw**2*mz**2*mh**2-11d0/8/ctw**2*mz**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*cfl*(1d0/4/ctw**2*vmamo**2*mh**2
     & *mmo**2+1d0/4/ctw**2*vpamo**2*mh**2*mmo**2-1d0/2*qmo*vmamo*mh**2*
     & mmo**2-1d0/2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqschchch*cfq*(1d0/4/ctw**2*vmach**2*mh**2
     & *mch**2+1d0/4/ctw**2*vpach**2*mh**2*mch**2-1d0/2*qch*vmach*mh**2*
     & mch**2-1d0/2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs*c0zhqsststst*cfq*(1d0/4/ctw**2*vmast**2*mh**2
     & *mst**2+1d0/4/ctw**2*vpast**2*mh**2*mst**2-1d0/2*qst*vmast*mh**2*
     & mst**2-1d0/2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs*c0zhqstatata*cfl*(1d0/4/ctw**2*vmata**2*mh**2
     & *mta**2+1d0/4/ctw**2*vpata**2*mh**2*mta**2-1d0/2*qta*vmata*mh**2*
     & mta**2-1d0/2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*cfq*(1d0/4/ctw**2*vmatp**2*mh**2
     & *mtp**2+1d0/4/ctw**2*vpatp**2*mh**2*mtp**2-1d0/2*qtp*vmatp*mh**2*
     & mtp**2-1d0/2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*cfq*(1d0/4/ctw**2*vmabt**2*mh**2
     & *mbt**2+1d0/4/ctw**2*vpabt**2*mh**2*mbt**2-1d0/2*qbt*vmabt*mh**2*
     & mbt**2-1d0/2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fhww/qs*(-1d0/8*mz**2*mh**2+1d0/8*mz**4+3d0
     & /2*ctw**4*mz**2*mh**2-3d0/2*ctw**4*mz**4)
     & +propizqs*det3izhqs*b0fhww*qs*(-1d0/4+1d0/16/ctw**2/mz**2*mh**2+1
     & d0/8/ctw**2-1d0/8/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fhww*(1d0/16/ctw**2/mz**2*mh**4+5d0/16/ctw*
     & *2*mh**2+1d0/8/ctw**2*mz**2-1d0/8/mz**2*mh**4-5d0/8*mh**2-1d0/8*m
     & z**2-3d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs*b0fhzz*qs*(3d0/32/ctw**2/mz**2*mh**2+7d0/16/c
     & tw**2)
     & +propizqs*det3izhqs*b0fhzz*(5d0/32/ctw**2/mz**2*mh**4+29d0/32/ctw
     & **2*mh**2+7d0/16/ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fhhh*qs*(-3d0/32/ctw**2/mz**2*mh**2-3d0/8/c
     & tw**2)
     & +propizqs*det3izhqs*b0fhhh*(-9d0/32/ctw**2/mz**2*mh**4-27d0/32/ct
     & w**2*mh**2-3d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl/qs*(-1d0/4*qmo*vmamo*mh**2*mmo**
     & 2+1d0/4*qmo*vmamo*mz**2*mmo**2-1d0/4*qmo*vpamo*mh**2*mmo**2+1d0/4
     & *qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh
     & **2*mmo**2-1d0/8/ctw**2*vmamo**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz*
     & *2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2*mmo**2+1d0/4*qmo*vmamo/mz**
     & 2*mh**2*mmo**2+1d0/2*qmo*vmamo*mmo**2+1d0/4*qmo*vpamo/mz**2*mh**2
     & *mmo**2+1d0/2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl*qs*(-1d0/8/ctw**2*vmamo**2/mz**2
     & *mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mmo**2+1d0/4*qmo*vmamo/mz**2*
     & mmo**2+1d0/4*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*cfq/qs*(-1d0/4*qch*vmach*mh**2*mch**
     & 2+1d0/4*qch*vmach*mz**2*mch**2-1d0/4*qch*vpach*mh**2*mch**2+1d0/4
     & *qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh
     & **2*mch**2-1d0/8/ctw**2*vmach**2*mch**2-1d0/8/ctw**2*vpach**2/mz*
     & *2*mh**2*mch**2-1d0/8/ctw**2*vpach**2*mch**2+1d0/4*qch*vmach/mz**
     & 2*mh**2*mch**2+1d0/2*qch*vmach*mch**2+1d0/4*qch*vpach/mz**2*mh**2
     & *mch**2+1d0/2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*cfq*qs*(-1d0/8/ctw**2*vmach**2/mz**2
     & *mch**2-1d0/8/ctw**2*vpach**2/mz**2*mch**2+1d0/4*qch*vmach/mz**2*
     & mch**2+1d0/4*qch*vpach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*cfq/qs*(-1d0/4*qst*vmast*mh**2*mst**
     & 2+1d0/4*qst*vmast*mz**2*mst**2-1d0/4*qst*vpast*mh**2*mst**2+1d0/4
     & *qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh
     & **2*mst**2-1d0/8/ctw**2*vmast**2*mst**2-1d0/8/ctw**2*vpast**2/mz*
     & *2*mh**2*mst**2-1d0/8/ctw**2*vpast**2*mst**2+1d0/4*qst*vmast/mz**
     & 2*mh**2*mst**2+1d0/2*qst*vmast*mst**2+1d0/4*qst*vpast/mz**2*mh**2
     & *mst**2+1d0/2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*cfq*qs*(-1d0/8/ctw**2*vmast**2/mz**2
     & *mst**2-1d0/8/ctw**2*vpast**2/mz**2*mst**2+1d0/4*qst*vmast/mz**2*
     & mst**2+1d0/4*qst*vpast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*cfl/qs*(-1d0/4*qta*vmata*mh**2*mta**
     & 2+1d0/4*qta*vmata*mz**2*mta**2-1d0/4*qta*vpata*mh**2*mta**2+1d0/4
     & *qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh
     & **2*mta**2-1d0/8/ctw**2*vmata**2*mta**2-1d0/8/ctw**2*vpata**2/mz*
     & *2*mh**2*mta**2-1d0/8/ctw**2*vpata**2*mta**2+1d0/4*qta*vmata/mz**
     & 2*mh**2*mta**2+1d0/2*qta*vmata*mta**2+1d0/4*qta*vpata/mz**2*mh**2
     & *mta**2+1d0/2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*cfl*qs*(-1d0/8/ctw**2*vmata**2/mz**2
     & *mta**2-1d0/8/ctw**2*vpata**2/mz**2*mta**2+1d0/4*qta*vmata/mz**2*
     & mta**2+1d0/4*qta*vpata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq/qs*(-1d0/4*qtp*vmatp*mh**2*mtp**
     & 2+1d0/4*qtp*vmatp*mz**2*mtp**2-1d0/4*qtp*vpatp*mh**2*mtp**2+1d0/4
     & *qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh
     & **2*mtp**2-1d0/8/ctw**2*vmatp**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz*
     & *2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2*mtp**2+1d0/4*qtp*vmatp/mz**
     & 2*mh**2*mtp**2+1d0/2*qtp*vmatp*mtp**2+1d0/4*qtp*vpatp/mz**2*mh**2
     & *mtp**2+1d0/2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq*qs*(-1d0/8/ctw**2*vmatp**2/mz**2
     & *mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mtp**2+1d0/4*qtp*vmatp/mz**2*
     & mtp**2+1d0/4*qtp*vpatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq/qs*(-1d0/4*qbt*vmabt*mh**2*mbt**
     & 2+1d0/4*qbt*vmabt*mz**2*mbt**2-1d0/4*qbt*vpabt*mh**2*mbt**2+1d0/4
     & *qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh
     & **2*mbt**2-1d0/8/ctw**2*vmabt**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz*
     & *2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2*mbt**2+1d0/4*qbt*vmabt/mz**
     & 2*mh**2*mbt**2+1d0/2*qbt*vmabt*mbt**2+1d0/4*qbt*vpabt/mz**2*mh**2
     & *mbt**2+1d0/2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq*qs*(-1d0/8/ctw**2*vmabt**2/mz**2
     & *mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mbt**2+1d0/4*qbt*vmabt/mz**2*
     & mbt**2+1d0/4*qbt*vpabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzww/qs*(1d0/8*mz**2*mh**2-1d0/8*mz**4-3d0/
     & 2*ctw**4*mz**2*mh**2+3d0/2*ctw**4*mz**4)
     & +propizqs*det3izhqs*b0fzww*qs*(1d0/8-1d0/16/ctw**2)
     & +propizqs*det3izhqs*b0fzww*(-3d0/16/ctw**2*mh**2-1d0/16/ctw**2*mz
     & **2+3d0/8*mh**2-1d0/8*mz**2+1d0/2*ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fzzh*qs*(1d0/16/ctw**2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fzzh*(1d0/16/ctw**2/mz**2*mh**4+1d0/16/ctw*
     & *2*mh**2-1d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fzmomo*cfl/qs*(1d0/4*qmo*vmamo*mh**2*mmo**2
     & -1d0/4*qmo*vmamo*mz**2*mmo**2+1d0/4*qmo*vpamo*mh**2*mmo**2-1d0/4*
     & qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*cfl*(1d0/8/ctw**2*vmamo**2*mmo**2+1d
     & 0/8/ctw**2*vpamo**2*mmo**2-1d0/4*qmo*vmamo*mmo**2-1d0/4*qmo*vpamo
     & *mmo**2)
     & +propizqs*det3izhqs*b0fzchch*cfq/qs*(1d0/4*qch*vmach*mh**2*mch**2
     & -1d0/4*qch*vmach*mz**2*mch**2+1d0/4*qch*vpach*mh**2*mch**2-1d0/4*
     & qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*cfq*(1d0/8/ctw**2*vmach**2*mch**2+1d
     & 0/8/ctw**2*vpach**2*mch**2-1d0/4*qch*vmach*mch**2-1d0/4*qch*vpach
     & *mch**2)
     & +propizqs*det3izhqs*b0fzstst*cfq/qs*(1d0/4*qst*vmast*mh**2*mst**2
     & -1d0/4*qst*vmast*mz**2*mst**2+1d0/4*qst*vpast*mh**2*mst**2-1d0/4*
     & qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*cfq*(1d0/8/ctw**2*vmast**2*mst**2+1d
     & 0/8/ctw**2*vpast**2*mst**2-1d0/4*qst*vmast*mst**2-1d0/4*qst*vpast
     & *mst**2)
     & +propizqs*det3izhqs*b0fztata*cfl/qs*(1d0/4*qta*vmata*mh**2*mta**2
     & -1d0/4*qta*vmata*mz**2*mta**2+1d0/4*qta*vpata*mh**2*mta**2-1d0/4*
     & qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*cfl*(1d0/8/ctw**2*vmata**2*mta**2+1d
     & 0/8/ctw**2*vpata**2*mta**2-1d0/4*qta*vmata*mta**2-1d0/4*qta*vpata
     & *mta**2)
     & +propizqs*det3izhqs*b0fztptp*cfq/qs*(1d0/4*qtp*vmatp*mh**2*mtp**2
     & -1d0/4*qtp*vmatp*mz**2*mtp**2+1d0/4*qtp*vpatp*mh**2*mtp**2-1d0/4*
     & qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*cfq*(1d0/8/ctw**2*vmatp**2*mtp**2+1d
     & 0/8/ctw**2*vpatp**2*mtp**2-1d0/4*qtp*vmatp*mtp**2-1d0/4*qtp*vpatp
     & *mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*cfq/qs*(1d0/4*qbt*vmabt*mh**2*mbt**2
     & -1d0/4*qbt*vmabt*mz**2*mbt**2+1d0/4*qbt*vpabt*mh**2*mbt**2-1d0/4*
     & qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*cfq*(1d0/8/ctw**2*vmabt**2*mbt**2+1d
     & 0/8/ctw**2*vpabt**2*mbt**2-1d0/4*qbt*vmabt*mbt**2-1d0/4*qbt*vpabt
     & *mbt**2)
     & +propizqs*det3izhqs*b0fqsww*qs*(1d0/8-1d0/16/ctw**2/mz**2*mh**2-1
     & d0/16/ctw**2+1d0/8/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fqsww*(-1d0/16/ctw**2/mz**2*mh**4-1d0/8/ctw
     & **2*mh**2-1d0/16/ctw**2*mz**2+1d0/8/mz**2*mh**4+1d0/4*mh**2+1d0/4
     & *mz**2-1d0/2*ctw**2*mz**2+3d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs*b0fqszh*qs*(-1d0/16/ctw**2/mz**2*mh**2-1d0/16
     & /ctw**2)
     & +propizqs*det3izhqs*b0fqszh*(1d0/16/ctw**2/mz**2*mh**4-1d0/8/ctw*
     & *2*mh**2+1d0/16/ctw**2*mz**2)
     & +propizqs*det3izhqs*b0fqsmomo*cfl*(1d0/8/ctw**2*vmamo**2/mz**2*mh
     & **2*mmo**2+1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4*qmo*vma
     & mo/mz**2*mh**2*mmo**2-1d0/4*qmo*vmamo*mmo**2-1d0/4*qmo*vpamo/mz**
     & 2*mh**2*mmo**2-1d0/4*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*cfl*qs*(1d0/8/ctw**2*vmamo**2/mz**2
     & *mmo**2+1d0/8/ctw**2*vpamo**2/mz**2*mmo**2-1d0/4*qmo*vmamo/mz**2*
     & mmo**2-1d0/4*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*cfq*(1d0/8/ctw**2*vmach**2/mz**2*mh
     & **2*mch**2+1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4*qch*vma
     & ch/mz**2*mh**2*mch**2-1d0/4*qch*vmach*mch**2-1d0/4*qch*vpach/mz**
     & 2*mh**2*mch**2-1d0/4*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fqschch*cfq*qs*(1d0/8/ctw**2*vmach**2/mz**2
     & *mch**2+1d0/8/ctw**2*vpach**2/mz**2*mch**2-1d0/4*qch*vmach/mz**2*
     & mch**2-1d0/4*qch*vpach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*cfq*(1d0/8/ctw**2*vmast**2/mz**2*mh
     & **2*mst**2+1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4*qst*vma
     & st/mz**2*mh**2*mst**2-1d0/4*qst*vmast*mst**2-1d0/4*qst*vpast/mz**
     & 2*mh**2*mst**2-1d0/4*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*cfq*qs*(1d0/8/ctw**2*vmast**2/mz**2
     & *mst**2+1d0/8/ctw**2*vpast**2/mz**2*mst**2-1d0/4*qst*vmast/mz**2*
     & mst**2-1d0/4*qst*vpast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*cfl*(1d0/8/ctw**2*vmata**2/mz**2*mh
     & **2*mta**2+1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4*qta*vma
     & ta/mz**2*mh**2*mta**2-1d0/4*qta*vmata*mta**2-1d0/4*qta*vpata/mz**
     & 2*mh**2*mta**2-1d0/4*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fqstata*cfl*qs*(1d0/8/ctw**2*vmata**2/mz**2
     & *mta**2+1d0/8/ctw**2*vpata**2/mz**2*mta**2-1d0/4*qta*vmata/mz**2*
     & mta**2-1d0/4*qta*vpata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*cfq*(1d0/8/ctw**2*vmatp**2/mz**2*mh
     & **2*mtp**2+1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4*qtp*vma
     & tp/mz**2*mh**2*mtp**2-1d0/4*qtp*vmatp*mtp**2-1d0/4*qtp*vpatp/mz**
     & 2*mh**2*mtp**2-1d0/4*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*cfq*qs*(1d0/8/ctw**2*vmatp**2/mz**2
     & *mtp**2+1d0/8/ctw**2*vpatp**2/mz**2*mtp**2-1d0/4*qtp*vmatp/mz**2*
     & mtp**2-1d0/4*qtp*vpatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*cfq*(1d0/8/ctw**2*vmabt**2/mz**2*mh
     & **2*mbt**2+1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4*qbt*vma
     & bt/mz**2*mh**2*mbt**2-1d0/4*qbt*vmabt*mbt**2-1d0/4*qbt*vpabt/mz**
     & 2*mh**2*mbt**2-1d0/4*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*cfq*qs*(1d0/8/ctw**2*vmabt**2/mz**2
     & *mbt**2+1d0/8/ctw**2*vpabt**2/mz**2*mbt**2-1d0/4*qbt*vmabt/mz**2*
     & mbt**2-1d0/4*qbt*vpabt/mz**2*mbt**2)
     & +propizqs*sdet3ichts*c0chtsczz*vmaup**2*(-1d0/2/ctw**2*mz**2)
     & +propizqs*sdet3ichts*b0fhzz*vmaup**2*(-1d0/2/ctw**2)
     & +propizqs*sdet3ichts*b0ftszc*vmaup**2*(1d0/2/ctw**2)
     & +propizqs*sdet3ichus*c0chusczz*vmaup**2*(-1d0/2/ctw**2*mz**2)
     & +propizqs*sdet3ichus*b0fhzz*vmaup**2*(-1d0/2/ctw**2)
     & +propizqs*sdet3ichus*b0fuszc*vmaup**2*(1d0/2/ctw**2)
     & +propizqs*d0zchctsuscczz*vmaup**2/qs*(5d0/4/ctw**2*mz**2*mh**2-3d
     & 0/4/ctw**2*mz**4+1d0/2/ctw**2*us*mh**2+1d0/2/ctw**2*us*mz**2+1d0/
     & 2/ctw**2*us**2+sdet4izhtsus/ctw**2*mz**6*mh**2+1d0/4*sdet4izhtsus
     & /ctw**2*us*mz**4*mh**2+1d0/4*sdet4izhtsus/ctw**2*us*mz**6+1d0/4*s
     & det4izhtsus/ctw**2*ts*mz**4*mh**2+1d0/4*sdet4izhtsus/ctw**2*ts*mz
     & **6)
     & +propizqs*d0zchctsuscczz*vmaup**2*(5d0/4/ctw**2*mz**2+1d0/2/ctw**
     & 2*us+1d0/4*sdet4izhtsus/ctw**2*us*mz**4+1d0/4*sdet4izhtsus/ctw**2
     & *ts*mz**4)
     & +propizqs*c0zhqswww/qs*(ctw**2*mh**2-2*ctw**2*mz**2-6*ctw**4*mh**
     & 2+6*ctw**4*mz**2+12*ctw**6*mz**2)
     & +propizqs*c0zhqswww*(-2*ctw**2)
     & +propizqs*c0zhqsmomomo*cfl/qs*(-2*qmo*vmamo/mz**2*mmo**4+1d0/2*qm
     & o*vmamo/mz**2*mh**2*mmo**2-1d0/2*qmo*vmamo*mmo**2-2*qmo*vpamo/mz*
     & *2*mmo**4+1d0/2*qmo*vpamo/mz**2*mh**2*mmo**2-1d0/2*qmo*vpamo*mmo*
     & *2)
     & +propizqs*c0zhqsmomomo*cfl*(-1d0/4/ctw**2*vmamo**2/mz**2*mmo**2-1
     & d0/4/ctw**2*vpamo**2/mz**2*mmo**2+1d0/2*qmo*vmamo/mz**2*mmo**2+1d
     & 0/2*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*cfq/qs*(-2*qch*vmach/mz**2*mch**4+1d0/2*qc
     & h*vmach/mz**2*mh**2*mch**2-1d0/2*qch*vmach*mch**2-2*qch*vpach/mz*
     & *2*mch**4+1d0/2*qch*vpach/mz**2*mh**2*mch**2-1d0/2*qch*vpach*mch*
     & *2)
     & +propizqs*c0zhqschchch*cfq*(-1d0/4/ctw**2*vmach**2/mz**2*mch**2-1
     & d0/4/ctw**2*vpach**2/mz**2*mch**2+1d0/2*qch*vmach/mz**2*mch**2+1d
     & 0/2*qch*vpach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*cfq/qs*(-2*qst*vmast/mz**2*mst**4+1d0/2*qs
     & t*vmast/mz**2*mh**2*mst**2-1d0/2*qst*vmast*mst**2-2*qst*vpast/mz*
     & *2*mst**4+1d0/2*qst*vpast/mz**2*mh**2*mst**2-1d0/2*qst*vpast*mst*
     & *2)
     & +propizqs*c0zhqsststst*cfq*(-1d0/4/ctw**2*vmast**2/mz**2*mst**2-1
     & d0/4/ctw**2*vpast**2/mz**2*mst**2+1d0/2*qst*vmast/mz**2*mst**2+1d
     & 0/2*qst*vpast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*cfl/qs*(-2*qta*vmata/mz**2*mta**4+1d0/2*qt
     & a*vmata/mz**2*mh**2*mta**2-1d0/2*qta*vmata*mta**2-2*qta*vpata/mz*
     & *2*mta**4+1d0/2*qta*vpata/mz**2*mh**2*mta**2-1d0/2*qta*vpata*mta*
     & *2)
     & +propizqs*c0zhqstatata*cfl*(-1d0/4/ctw**2*vmata**2/mz**2*mta**2-1
     & d0/4/ctw**2*vpata**2/mz**2*mta**2+1d0/2*qta*vmata/mz**2*mta**2+1d
     & 0/2*qta*vpata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*cfq/qs*(-2*qtp*vmatp/mz**2*mtp**4+1d0/2*qt
     & p*vmatp/mz**2*mh**2*mtp**2-1d0/2*qtp*vmatp*mtp**2-2*qtp*vpatp/mz*
     & *2*mtp**4+1d0/2*qtp*vpatp/mz**2*mh**2*mtp**2-1d0/2*qtp*vpatp*mtp*
     & *2)
     & +propizqs*c0zhqstptptp*cfq*(-1d0/4/ctw**2*vmatp**2/mz**2*mtp**2-1
     & d0/4/ctw**2*vpatp**2/mz**2*mtp**2+1d0/2*qtp*vmatp/mz**2*mtp**2+1d
     & 0/2*qtp*vpatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*cfq/qs*(-2*qbt*vmabt/mz**2*mbt**4+1d0/2*qb
     & t*vmabt/mz**2*mh**2*mbt**2-1d0/2*qbt*vmabt*mbt**2-2*qbt*vpabt/mz*
     & *2*mbt**4+1d0/2*qbt*vpabt/mz**2*mh**2*mbt**2-1d0/2*qbt*vpabt*mbt*
     & *2)
     & +propizqs*c0zhqsbtbtbt*cfq*(-1d0/4/ctw**2*vmabt**2/mz**2*mbt**2-1
     & d0/4/ctw**2*vpabt**2/mz**2*mbt**2+1d0/2*qbt*vmabt/mz**2*mbt**2+1d
     & 0/2*qbt*vpabt/mz**2*mbt**2)
     & +propizqs*c0chtsczz*vmaup**2/qs*(-1d0/2/ctw**2*mz**2-1d0/2/ctw**2
     & *us+1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2+1d0/4*sdet4izhtsus/ctw*
     & *2*us*mz**2*mh**2+1d0/4*sdet4izhtsus/ctw**2*ts*mz**4)
     & +propizqs*c0chtsczz*vmaup**2*(1d0/4*sdet4izhtsus/ctw**2*ts*mz**2)
     & +propizqs*c0chusczz*vmaup**2/qs*(1d0/2/ctw**2*mh**2+1d0/2/ctw**2*
     & us+1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2+1d0/4*sdet4izhtsus/ctw**
     & 2*us*mz**4+1d0/4*sdet4izhtsus/ctw**2*ts*mz**2*mh**2)
     & +propizqs*c0chusczz*vmaup**2*(1d0/2/ctw**2+1d0/4*sdet4izhtsus/ctw
     & **2*us*mz**2)
     & +propizqs*c0cztszcc*vmaup**2/qs*(-1d0/2/ctw**2*mh**2-1d0/2/ctw**2
     & *us-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2-1d0/4*sdet4izhtsus/ctw*
     & *2*us*mz**4-1d0/4*sdet4izhtsus/ctw**2*ts*mz**2*mh**2)
     & +propizqs*c0cztszcc*vmaup**2*(-1d0/2/ctw**2-1d0/4*sdet4izhtsus/ct
     & w**2*ts*mz**2)
     & +propizqs*c0czuszcc*vmaup**2/qs*(1d0/2/ctw**2*mz**2+1d0/2/ctw**2*
     & us-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2-1d0/4*sdet4izhtsus/ctw**
     & 2*us*mz**2*mh**2-1d0/4*sdet4izhtsus/ctw**2*ts*mz**4)
     & +propizqs*c0czuszcc*vmaup**2*(-1d0/4*sdet4izhtsus/ctw**2*us*mz**2
     & )
     & +propizqs*c0ccqsczc*vmaup**2/qs*(-1d0/2/ctw**2*mz**2)
     & +propizqs*c0ccqsczc*vmaup**2*(-1d0/2/ctw**2)
     & +propizqs*a0fw/qs*(-2d0/3*ctw**2+4*ctw**4)
     & +propizqs*a0fz/qs*(1d0/12/ctw**2/mz**2*mh**2-1d0/12/ctw**2)
     & +propizqs*a0fz*vmaup**2/qs*(1d0/2/ctw**2)
     & +propizqs*a0fh/qs*(-1d0/12/ctw**2/mz**4*mh**4+1d0/12/ctw**2/mz**2
     & *mh**2)
     & +propizqs*b0fhww/qs*(1d0/2-ctw**2)
     & +propizqs*b0fzww/qs*(-1d0/2+ctw**2)
     & +propizqs*b0fqsww/qs*(-2d0/3*ctw**2+4*ctw**4)
     & +propizqs*b0fqszh/qs*(-1d0/12/ctw**2/mz**4*mh**4+1d0/6/ctw**2/mz*
     & *2*mh**2-1d0/12/ctw**2)
     & +propizqs*b0fqscc*vmaup**2/qs*(1d0/2/ctw**2)
     & +det3izhqs*c0zhqswww*(1d0/2/ctw**2*mz**4*mh**2-7d0/4*mz**4*mh**2+
     & ctw**2*mz**4*mh**2+3*ctw**4*mz**4*mh**2)
     & +det3izhqs*c0zhqszhh*(3/ctw**2*mz**4*mh**2)
     & +det3izhqs*c0zhqshzz*(6/ctw**2*mz**4*mh**2)
     & +det3izhqs*c0zhqsmomomo*cfl*(-1d0/4/ctw**2*vmamo**2*mz**2*mh**2*m
     & mo**2-1d0/4/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs*c0zhqschchch*cfq*(-1d0/4/ctw**2*vmach**2*mz**2*mh**2*m
     & ch**2-1d0/4/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs*c0zhqsststst*cfq*(-1d0/4/ctw**2*vmast**2*mz**2*mh**2*m
     & st**2-1d0/4/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs*c0zhqstatata*cfl*(-1d0/4/ctw**2*vmata**2*mz**2*mh**2*m
     & ta**2-1d0/4/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs*c0zhqstptptp*cfq*(-1d0/4/ctw**2*vmatp**2*mz**2*mh**2*m
     & tp**2-1d0/4/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs*c0zhqsbtbtbt*cfq*(-1d0/4/ctw**2*vmabt**2*mz**2*mh**2*m
     & bt**2-1d0/4/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*b0fhww*(-1d0/2/ctw**2*mz**2*mh**2+7d0/4*mz**2*mh**2-ct
     & w**2*mz**2*mh**2-3*ctw**4*mz**2*mh**2)
     & +det3izhqs*b0fhzz*(-3d0/2/ctw**2*mz**2*mh**2)
     & +det3izhqs*b0fhhh*(3d0/2/ctw**2*mz**2*mh**2)
     & +det3izhqs*b0fhmomo*cfl*(1d0/4/ctw**2*vmamo**2*mh**2*mmo**2+1d0/4
     & /ctw**2*vpamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fhchch*cfq*(1d0/4/ctw**2*vmach**2*mh**2*mch**2+1d0/4
     & /ctw**2*vpach**2*mh**2*mch**2)
     & +det3izhqs*b0fhstst*cfq*(1d0/4/ctw**2*vmast**2*mh**2*mst**2+1d0/4
     & /ctw**2*vpast**2*mh**2*mst**2)
     & +det3izhqs*b0fhtata*cfl*(1d0/4/ctw**2*vmata**2*mh**2*mta**2+1d0/4
     & /ctw**2*vpata**2*mh**2*mta**2)
     & +det3izhqs*b0fhtptp*cfq*(1d0/4/ctw**2*vmatp**2*mh**2*mtp**2+1d0/4
     & /ctw**2*vpatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fhbtbt*cfq*(1d0/4/ctw**2*vmabt**2*mh**2*mbt**2+1d0/4
     & /ctw**2*vpabt**2*mh**2*mbt**2)
     & +det3izhqs*b0fzww*(1d0/4/ctw**2*mz**2*mh**2-7d0/8*mz**2*mh**2+1d0
     & /2*ctw**2*mz**2*mh**2+3d0/2*ctw**4*mz**2*mh**2)
     & +det3izhqs*b0fzmomo*cfl*(-1d0/8/ctw**2*vmamo**2*mh**2*mmo**2-1d0/
     & 8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fzchch*cfq*(-1d0/8/ctw**2*vmach**2*mh**2*mch**2-1d0/
     & 8/ctw**2*vpach**2*mh**2*mch**2)
     & +det3izhqs*b0fzstst*cfq*(-1d0/8/ctw**2*vmast**2*mh**2*mst**2-1d0/
     & 8/ctw**2*vpast**2*mh**2*mst**2)
     & +det3izhqs*b0fztata*cfl*(-1d0/8/ctw**2*vmata**2*mh**2*mta**2-1d0/
     & 8/ctw**2*vpata**2*mh**2*mta**2)
     & +det3izhqs*b0fztptp*cfq*(-1d0/8/ctw**2*vmatp**2*mh**2*mtp**2-1d0/
     & 8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fzbtbt*cfq*(-1d0/8/ctw**2*vmabt**2*mh**2*mbt**2-1d0/
     & 8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +det3izhqs*b0fqsww*(1d0/4/ctw**2*mz**2*mh**2-7d0/8*mz**2*mh**2+1d
     & 0/2*ctw**2*mz**2*mh**2+3d0/2*ctw**4*mz**2*mh**2)
     & +det3izhqs*b0fqsmomo*cfl*(-1d0/8/ctw**2*vmamo**2*mh**2*mmo**2-1d0
     & /8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fqschch*cfq*(-1d0/8/ctw**2*vmach**2*mh**2*mch**2-1d0
     & /8/ctw**2*vpach**2*mh**2*mch**2)
     & +det3izhqs*b0fqsstst*cfq*(-1d0/8/ctw**2*vmast**2*mh**2*mst**2-1d0
     & /8/ctw**2*vpast**2*mh**2*mst**2)
     & +det3izhqs*b0fqstata*cfl*(-1d0/8/ctw**2*vmata**2*mh**2*mta**2-1d0
     & /8/ctw**2*vpata**2*mh**2*mta**2)
     & +det3izhqs*b0fqstptp*cfq*(-1d0/8/ctw**2*vmatp**2*mh**2*mtp**2-1d0
     & /8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*cfq*(-1d0/8/ctw**2*vmabt**2*mh**2*mbt**2-1d0
     & /8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +c0zhqswww*(-1d0/2/ctw**2*mz**2+1d0/2*mh**2+2*mz**2-2*ctw**2*mh**
     & 2+ctw**2*mz**2+6*ctw**4*mh**2-12*ctw**4*mz**2-12*ctw**6*mz**2)
     & +c0zhqszhh*(-3d0/4/ctw**2/mz**2*mh**4+3d0/4/ctw**2*mh**2-3/ctw**2
     & *mz**2)
     & +c0zhqshzz*(-1d0/2/ctw**2/mz**2*mh**4-2/ctw**2*mh**2-5/ctw**2*mz*
     & *2)
     & +c0zhqsmomomo*cfl*(1d0/2/ctw**2*vmamo**2*mmo**2+2/ctw**2*vpamo*vm
     & amo/mz**2*mmo**4-1d0/2/ctw**2*vpamo*vmamo/mz**2*mh**2*mmo**2+1d0/
     & 2/ctw**2*vpamo**2*mmo**2)
     & +c0zhqschchch*cfq*(1d0/2/ctw**2*vmach**2*mch**2+2/ctw**2*vpach*vm
     & ach/mz**2*mch**4-1d0/2/ctw**2*vpach*vmach/mz**2*mh**2*mch**2+1d0/
     & 2/ctw**2*vpach**2*mch**2)
     & +c0zhqsststst*cfq*(1d0/2/ctw**2*vmast**2*mst**2+2/ctw**2*vpast*vm
     & ast/mz**2*mst**4-1d0/2/ctw**2*vpast*vmast/mz**2*mh**2*mst**2+1d0/
     & 2/ctw**2*vpast**2*mst**2)
     & +c0zhqstatata*cfl*(1d0/2/ctw**2*vmata**2*mta**2+2/ctw**2*vpata*vm
     & ata/mz**2*mta**4-1d0/2/ctw**2*vpata*vmata/mz**2*mh**2*mta**2+1d0/
     & 2/ctw**2*vpata**2*mta**2)
     & +c0zhqstptptp*cfq*(1d0/2/ctw**2*vmatp**2*mtp**2+2/ctw**2*vpatp*vm
     & atp/mz**2*mtp**4-1d0/2/ctw**2*vpatp*vmatp/mz**2*mh**2*mtp**2+1d0/
     & 2/ctw**2*vpatp**2*mtp**2)
     & +c0zhqsbtbtbt*cfq*(1d0/2/ctw**2*vmabt**2*mbt**2+2/ctw**2*vpabt*vm
     & abt/mz**2*mbt**4-1d0/2/ctw**2*vpabt*vmabt/mz**2*mh**2*mbt**2+1d0/
     & 2/ctw**2*vpabt**2*mbt**2)
     & +c0ccqsczc*vmaup**2*(2/ctw**2*mz**2)
     & +a0fw*(-1d0/4+8d0/3*ctw**2-3d0/2*ctw**2*mz**2/mh**2-4*ctw**4)
     & +a0fz*vmaup**2*(-5d0/4/ctw**2)
     & +a0fz*(-1d0/8/ctw**2/mz**2*mh**2-3d0/4/ctw**2*mz**2/mh**2)
     & +a0fh*(1d0/8/ctw**2/mz**4*mh**4-1d0/2/ctw**2/mz**2*mh**2)
     & +b0fhww*(-1+1d0/2/ctw**2+2*ctw**2)
     & +b0fhzz*(1d0/4/ctw**2/mz**2*mh**2+2/ctw**2)
     & +b0fhhh*(-3d0/4/ctw**2/mz**2*mh**2-3d0/2/ctw**2)
     & +b0fzww*(1d0/6-7d0/24/ctw**2+5d0/2*ctw**2)
     & +b0fzzh*(1d0/24/ctw**2/mz**4*mh**4+1d0/6/ctw**2/mz**2*mh**2-1d0/2
     & /ctw**2)
     & +b0fzmomo*cfl*(1d0/4/ctw**2*vmamo**2/mz**2*mmo**2-1d0/2/ctw**2*vp
     & amo*vmamo/mz**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +b0fzchch*cfq*(1d0/4/ctw**2*vmach**2/mz**2*mch**2-1d0/2/ctw**2*vp
     & ach*vmach/mz**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +b0fzstst*cfq*(1d0/4/ctw**2*vmast**2/mz**2*mst**2-1d0/2/ctw**2*vp
     & ast*vmast/mz**2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +b0fztata*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mta**2-1d0/2/ctw**2*vp
     & ata*vmata/mz**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +b0fztptp*cfq*(1d0/4/ctw**2*vmatp**2/mz**2*mtp**2-1d0/2/ctw**2*vp
     & atp*vmatp/mz**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +b0fzbtbt*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mbt**2-1d0/2/ctw**2*vp
     & abt*vmabt/mz**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +b0fqsww*(1d0/6-1d0/3/ctw**2-1d0/3*ctw**2-4*ctw**4)
     & +b0fqszh*(1d0/12/ctw**2/mz**4*mh**4+1d0/12/ctw**2/mz**2*mh**2-1d0
     & /2/ctw**2)
     & +b0fqsmomo*cfl*(1d0/4/ctw**2*vmamo**2/mz**2*mmo**2-1d0/2/ctw**2*v
     & pamo*vmamo/mz**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +b0fqschch*cfq*(1d0/4/ctw**2*vmach**2/mz**2*mch**2-1d0/2/ctw**2*v
     & pach*vmach/mz**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +b0fqsstst*cfq*(1d0/4/ctw**2*vmast**2/mz**2*mst**2-1d0/2/ctw**2*v
     & past*vmast/mz**2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +b0fqstata*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mta**2-1d0/2/ctw**2*v
     & pata*vmata/mz**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +b0fqstptp*cfq*(1d0/4/ctw**2*vmatp**2/mz**2*mtp**2-1d0/2/ctw**2*v
     & patp*vmatp/mz**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +b0fqsbtbt*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mbt**2-1d0/2/ctw**2*v
     & pabt*vmabt/mz**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +b0fqscc*vmaup**2*(-5d0/4/ctw**2)
     & +dreal(b0phww)*(1d0/8/ctw**2/mz**2*mh**4-1d0/2*mh**2+3d0/2*ctw**2
     & *mz**2)
     & +dreal(b0phzz)*(1d0/16/ctw**2/mz**2*mh**4-1d0/4/ctw**2*mh**2+3d0/
     & 4/ctw**2*mz**2)
     & +dreal(b0phhh)*(9d0/16/ctw**2/mz**2*mh**4)
     & +dreal(b0pzww)*(1d0/24/ctw**2*mz**2+2d0/3*mz**2-17d0/6*ctw**2*mz*
     & *2-2*ctw**4*mz**2)
     & +dreal(b0pzzh)*(1d0/24/ctw**2/mz**2*mh**4-1d0/6/ctw**2*mh**2+1d0/
     & 2/ctw**2*mz**2)
     & +dreal(b0pccz)*vmaup**2*(-1d0/4/ctw**2*mz**2)
     & +dreal(b0pccz)*vpaup**2*(-1d0/4/ctw**2*mz**2)
     & +13d0/18+3d0/4/ctw**2/mz**2*mh**2+1d0/12/ctw**2-1d0/2/ctw**2*mz**
     & 2/mh**2-1d0/mz**2*mh**2-pizgfer+caldzfer+1d0/2*zh1fer+1d0/2*zz1fe
     & r-1d0/2*deltarhofer-1d0/2*zmwzwfer+zmzzzfer-za1fer-1d0/2*deltarho
     & bos-1d0/2*zmwzwbos+zmzzzbos-za1bos+ctw**2/mz**2*mh**2+2d0/3*ctw**
     & 2-ctw**2*mz**2/mh**2+2*ctw**4

      ffgm1=
     & +vmaup*(3d0/2/ctw**2/mz**2-2/mz**2+2*ctw**2/mz**2)
     & +propizqs*qup/qs*(-2/mz**2+6*ctw**2/mz**2-4*ctw**4/mz**2)
     & +propizqs*det3izhqs*vmaup*(-3d0/4+3d0/8/ctw**2/mz**2*mh**2+1d0/4/
     & ctw**2-1d0/2/mz**2*mh**2+1d0/2*ctw**2/mz**2*mh**2+3d0/2*ctw**2-3*
     & ctw**4)
     & +propizqs*det3izhqs*vmaup*qs*(3d0/8/ctw**2/mz**2-1d0/2/mz**2+1d0/
     & 2*ctw**2/mz**2)
     & +propizqs*det3izhqs*vmaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mbt**2
     & +1d0/4/ctw**2*vpabt**2/mz**2*mbt**2+1d0/4/ctw**2*vmatp**2/mz**2*m
     & tp**2+1d0/4/ctw**2*vpatp**2/mz**2*mtp**2+1d0/4/ctw**2*vmast**2/mz
     & **2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mst**2+1d0/4/ctw**2*vmach*
     & *2/mz**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*vmaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mta**2
     & +1d0/4/ctw**2*vpata**2/mz**2*mta**2+1d0/4/ctw**2*vmamo**2/mz**2*m
     & mo**2+1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*qup/qs*(1d0/2*mh**2-1d0/2*mz**2-1d0/2*ctw**2*
     & mh**2+1d0/2*ctw**2*mz**2-6*ctw**4*mh**2+6*ctw**4*mz**2+6*ctw**6*m
     & h**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*qup*(-1-1d0/2/mz**2*mh**2+3d0/2*ctw**2/mz**2*
     & mh**2+4*ctw**2-ctw**4/mz**2*mh**2-9*ctw**4+6*ctw**6)
     & +propizqs*det3izhqs*qup*qs*(-1d0/2/mz**2+3d0/2*ctw**2/mz**2-ctw**
     & 4/mz**2)
     & +propizqs*det3izhqs*qup*cfq/qs*(qbt*vmabt/mz**2*mh**2*mbt**2-qbt*
     & vmabt*mbt**2+qbt*vpabt/mz**2*mh**2*mbt**2-qbt*vpabt*mbt**2+qtp*vm
     & atp/mz**2*mh**2*mtp**2-qtp*vmatp*mtp**2+qtp*vpatp/mz**2*mh**2*mtp
     & **2-qtp*vpatp*mtp**2+qst*vmast/mz**2*mh**2*mst**2-qst*vmast*mst**
     & 2+qst*vpast/mz**2*mh**2*mst**2-qst*vpast*mst**2+qch*vmach/mz**2*m
     & h**2*mch**2-qch*vmach*mch**2+qch*vpach/mz**2*mh**2*mch**2-qch*vpa
     & ch*mch**2-ctw**2*qbt*vmabt/mz**2*mh**2*mbt**2+ctw**2*qbt*vmabt*mb
     & t**2-ctw**2*qbt*vpabt/mz**2*mh**2*mbt**2+ctw**2*qbt*vpabt*mbt**2-
     & ctw**2*qtp*vmatp/mz**2*mh**2*mtp**2+ctw**2*qtp*vmatp*mtp**2-ctw**
     & 2*qtp*vpatp/mz**2*mh**2*mtp**2+ctw**2*qtp*vpatp*mtp**2-ctw**2*qst
     & *vmast/mz**2*mh**2*mst**2+ctw**2*qst*vmast*mst**2-ctw**2*qst*vpas
     & t/mz**2*mh**2*mst**2+ctw**2*qst*vpast*mst**2-ctw**2*qch*vmach/mz*
     & *2*mh**2*mch**2+ctw**2*qch*vmach*mch**2-ctw**2*qch*vpach/mz**2*mh
     & **2*mch**2+ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*qup*cfq*(qbt*vmabt/mz**2*mbt**2+qbt*vpabt/mz*
     & *2*mbt**2+qtp*vmatp/mz**2*mtp**2+qtp*vpatp/mz**2*mtp**2+qst*vmast
     & /mz**2*mst**2+qst*vpast/mz**2*mst**2+qch*vmach/mz**2*mch**2+qch*v
     & pach/mz**2*mch**2-ctw**2*qbt*vmabt/mz**2*mbt**2-ctw**2*qbt*vpabt/
     & mz**2*mbt**2-ctw**2*qtp*vmatp/mz**2*mtp**2-ctw**2*qtp*vpatp/mz**2
     & *mtp**2-ctw**2*qst*vmast/mz**2*mst**2-ctw**2*qst*vpast/mz**2*mst*
     & *2-ctw**2*qch*vmach/mz**2*mch**2-ctw**2*qch*vpach/mz**2*mch**2)
     & +propizqs*det3izhqs*qup*cfl/qs*(qta*vmata/mz**2*mh**2*mta**2-qta*
     & vmata*mta**2+qta*vpata/mz**2*mh**2*mta**2-qta*vpata*mta**2+qmo*vm
     & amo/mz**2*mh**2*mmo**2-qmo*vmamo*mmo**2+qmo*vpamo/mz**2*mh**2*mmo
     & **2-qmo*vpamo*mmo**2-ctw**2*qta*vmata/mz**2*mh**2*mta**2+ctw**2*q
     & ta*vmata*mta**2-ctw**2*qta*vpata/mz**2*mh**2*mta**2+ctw**2*qta*vp
     & ata*mta**2-ctw**2*qmo*vmamo/mz**2*mh**2*mmo**2+ctw**2*qmo*vmamo*m
     & mo**2-ctw**2*qmo*vpamo/mz**2*mh**2*mmo**2+ctw**2*qmo*vpamo*mmo**2
     & )
     & +propizqs*det3izhqs*qup*cfl*(qta*vmata/mz**2*mta**2+qta*vpata/mz*
     & *2*mta**2+qmo*vmamo/mz**2*mmo**2+qmo*vpamo/mz**2*mmo**2-ctw**2*qt
     & a*vmata/mz**2*mta**2-ctw**2*qta*vpata/mz**2*mta**2-ctw**2*qmo*vma
     & mo/mz**2*mmo**2-ctw**2*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqswww*vmaup*(3d0/16/ctw**2*mh**6+15d0/
     & 16/ctw**2*mz**4*mh**2+3d0/8/ctw**2*mz**6-3d0/4*mh**6+3d0/8*mz**2*
     & mh**4-15d0/4*mz**4*mh**2-9d0/8*mz**6+3d0/4*ctw**2*mh**6-3d0/2*ctw
     & **2*mz**2*mh**4+15d0/4*ctw**2*mz**4*mh**2+9d0/2*ctw**4*mz**2*mh**
     & 4+9d0/2*ctw**4*mz**6)
     & +propizqs*det3izhqs**2*c0zhqswww*vmaup*qs*(3d0/16/ctw**2*mh**4+3d
     & 0/16/ctw**2*mz**2*mh**2+3d0/8/ctw**2*mz**4-3d0/4*mh**4-3d0/8*mz**
     & 2*mh**2-9d0/8*mz**4+3d0/4*ctw**2*mh**4-3d0/4*ctw**2*mz**2*mh**2+9
     & d0/2*ctw**4*mz**2*mh**2+9d0/2*ctw**4*mz**4)
     & +propizqs*det3izhqs**2*c0zhqswww*qup*(-3d0/4*mh**6+3d0/4*mz**2*mh
     & **4+9d0/4*ctw**2*mh**6-15d0/4*ctw**2*mz**2*mh**4+3d0/2*ctw**2*mz*
     & *4*mh**2-3d0/2*ctw**4*mh**6+12*ctw**4*mz**2*mh**4-21d0/2*ctw**4*m
     & z**4*mh**2-9*ctw**6*mz**2*mh**4+9*ctw**6*mz**4*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qup*qs*(-3d0/4*mh**4+9d0/4*ctw**
     & 2*mh**4-3d0/2*ctw**2*mz**2*mh**2-3d0/2*ctw**4*mh**4+21d0/2*ctw**4
     & *mz**2*mh**2-9*ctw**6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*c0zhqszhh*vmaup*(9d0/32/ctw**2/mz**2*mh**8
     & +45d0/32/ctw**2*mz**2*mh**4+81d0/16/ctw**2*mz**4*mh**2+9d0/4/ctw*
     & *2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqszhh*vmaup*qs*(9d0/32/ctw**2/mz**2*mh
     & **6+9d0/32/ctw**2*mh**4+9d0/16/ctw**2*mz**2*mh**2+9d0/4/ctw**2*mz
     & **4)
     & +propizqs*det3izhqs**2*c0zhqshzz*vmaup*(3d0/32/ctw**2/mz**2*mh**8
     & +15d0/16/ctw**2*mh**6+87d0/32/ctw**2*mz**2*mh**4+75d0/8/ctw**2*mz
     & **4*mh**2+39d0/8/ctw**2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqshzz*vmaup*qs*(3d0/32/ctw**2/mz**2*mh
     & **6+9d0/32/ctw**2*mh**4+9d0/8/ctw**2*mz**2*mh**2+39d0/8/ctw**2*mz
     & **4)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vmaup*cfl*(-3d0/8/ctw**2*vmam
     & o**2*mh**4*mmo**2-3d0/8/ctw**2*vmamo**2*mz**4*mmo**2-3d0/8/ctw**2
     & *vpamo**2*mh**4*mmo**2-3d0/8/ctw**2*vpamo**2*mz**4*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vmaup*cfl*qs*(-3d0/8/ctw**2*v
     & mamo**2*mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mz**2*mmo**2-3d0/8/ctw
     & **2*vpamo**2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qup*cfl*(-3d0/2*qmo*vmamo*mh*
     & *4*mmo**2+3d0/2*qmo*vmamo*mz**2*mh**2*mmo**2-3d0/2*qmo*vpamo*mh**
     & 4*mmo**2+3d0/2*qmo*vpamo*mz**2*mh**2*mmo**2+3d0/2*ctw**2*qmo*vmam
     & o*mh**4*mmo**2-3d0/2*ctw**2*qmo*vmamo*mz**2*mh**2*mmo**2+3d0/2*ct
     & w**2*qmo*vpamo*mh**4*mmo**2-3d0/2*ctw**2*qmo*vpamo*mz**2*mh**2*mm
     & o**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qup*cfl*qs*(-3d0/2*qmo*vmamo*
     & mh**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*
     & mh**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vmaup*cfq*(-3d0/8/ctw**2*vmac
     & h**2*mh**4*mch**2-3d0/8/ctw**2*vmach**2*mz**4*mch**2-3d0/8/ctw**2
     & *vpach**2*mh**4*mch**2-3d0/8/ctw**2*vpach**2*mz**4*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vmaup*cfq*qs*(-3d0/8/ctw**2*v
     & mach**2*mh**2*mch**2-3d0/8/ctw**2*vmach**2*mz**2*mch**2-3d0/8/ctw
     & **2*vpach**2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*mz**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qup*cfq*(-3d0/2*qch*vmach*mh*
     & *4*mch**2+3d0/2*qch*vmach*mz**2*mh**2*mch**2-3d0/2*qch*vpach*mh**
     & 4*mch**2+3d0/2*qch*vpach*mz**2*mh**2*mch**2+3d0/2*ctw**2*qch*vmac
     & h*mh**4*mch**2-3d0/2*ctw**2*qch*vmach*mz**2*mh**2*mch**2+3d0/2*ct
     & w**2*qch*vpach*mh**4*mch**2-3d0/2*ctw**2*qch*vpach*mz**2*mh**2*mc
     & h**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qup*cfq*qs*(-3d0/2*qch*vmach*
     & mh**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2+3d0/2*ctw**2*qch*vmach*
     & mh**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vmaup*cfq*(-3d0/8/ctw**2*vmas
     & t**2*mh**4*mst**2-3d0/8/ctw**2*vmast**2*mz**4*mst**2-3d0/8/ctw**2
     & *vpast**2*mh**4*mst**2-3d0/8/ctw**2*vpast**2*mz**4*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vmaup*cfq*qs*(-3d0/8/ctw**2*v
     & mast**2*mh**2*mst**2-3d0/8/ctw**2*vmast**2*mz**2*mst**2-3d0/8/ctw
     & **2*vpast**2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*mz**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qup*cfq*(-3d0/2*qst*vmast*mh*
     & *4*mst**2+3d0/2*qst*vmast*mz**2*mh**2*mst**2-3d0/2*qst*vpast*mh**
     & 4*mst**2+3d0/2*qst*vpast*mz**2*mh**2*mst**2+3d0/2*ctw**2*qst*vmas
     & t*mh**4*mst**2-3d0/2*ctw**2*qst*vmast*mz**2*mh**2*mst**2+3d0/2*ct
     & w**2*qst*vpast*mh**4*mst**2-3d0/2*ctw**2*qst*vpast*mz**2*mh**2*ms
     & t**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qup*cfq*qs*(-3d0/2*qst*vmast*
     & mh**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2+3d0/2*ctw**2*qst*vmast*
     & mh**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vmaup*cfl*(-3d0/8/ctw**2*vmat
     & a**2*mh**4*mta**2-3d0/8/ctw**2*vmata**2*mz**4*mta**2-3d0/8/ctw**2
     & *vpata**2*mh**4*mta**2-3d0/8/ctw**2*vpata**2*mz**4*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vmaup*cfl*qs*(-3d0/8/ctw**2*v
     & mata**2*mh**2*mta**2-3d0/8/ctw**2*vmata**2*mz**2*mta**2-3d0/8/ctw
     & **2*vpata**2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*mz**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qup*cfl*(-3d0/2*qta*vmata*mh*
     & *4*mta**2+3d0/2*qta*vmata*mz**2*mh**2*mta**2-3d0/2*qta*vpata*mh**
     & 4*mta**2+3d0/2*qta*vpata*mz**2*mh**2*mta**2+3d0/2*ctw**2*qta*vmat
     & a*mh**4*mta**2-3d0/2*ctw**2*qta*vmata*mz**2*mh**2*mta**2+3d0/2*ct
     & w**2*qta*vpata*mh**4*mta**2-3d0/2*ctw**2*qta*vpata*mz**2*mh**2*mt
     & a**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qup*cfl*qs*(-3d0/2*qta*vmata*
     & mh**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2+3d0/2*ctw**2*qta*vmata*
     & mh**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vmaup*cfq*(-3d0/8/ctw**2*vmat
     & p**2*mh**4*mtp**2-3d0/8/ctw**2*vmatp**2*mz**4*mtp**2-3d0/8/ctw**2
     & *vpatp**2*mh**4*mtp**2-3d0/8/ctw**2*vpatp**2*mz**4*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vmaup*cfq*qs*(-3d0/8/ctw**2*v
     & matp**2*mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mz**2*mtp**2-3d0/8/ctw
     & **2*vpatp**2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qup*cfq*(-3d0/2*qtp*vmatp*mh*
     & *4*mtp**2+3d0/2*qtp*vmatp*mz**2*mh**2*mtp**2-3d0/2*qtp*vpatp*mh**
     & 4*mtp**2+3d0/2*qtp*vpatp*mz**2*mh**2*mtp**2+3d0/2*ctw**2*qtp*vmat
     & p*mh**4*mtp**2-3d0/2*ctw**2*qtp*vmatp*mz**2*mh**2*mtp**2+3d0/2*ct
     & w**2*qtp*vpatp*mh**4*mtp**2-3d0/2*ctw**2*qtp*vpatp*mz**2*mh**2*mt
     & p**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qup*cfq*qs*(-3d0/2*qtp*vmatp*
     & mh**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*
     & mh**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vmaup*cfq*(-3d0/8/ctw**2*vmab
     & t**2*mh**4*mbt**2-3d0/8/ctw**2*vmabt**2*mz**4*mbt**2-3d0/8/ctw**2
     & *vpabt**2*mh**4*mbt**2-3d0/8/ctw**2*vpabt**2*mz**4*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vmaup*cfq*qs*(-3d0/8/ctw**2*v
     & mabt**2*mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mz**2*mbt**2-3d0/8/ctw
     & **2*vpabt**2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh*
     & *4*mbt**2+3d0/2*qbt*vmabt*mz**2*mh**2*mbt**2-3d0/2*qbt*vpabt*mh**
     & 4*mbt**2+3d0/2*qbt*vpabt*mz**2*mh**2*mbt**2+3d0/2*ctw**2*qbt*vmab
     & t*mh**4*mbt**2-3d0/2*ctw**2*qbt*vmabt*mz**2*mh**2*mbt**2+3d0/2*ct
     & w**2*qbt*vpabt*mh**4*mbt**2-3d0/2*ctw**2*qbt*vpabt*mz**2*mh**2*mb
     & t**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qup*cfq*qs*(-3d0/2*qbt*vmabt*
     & mh**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*
     & mh**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhww*vmaup*(-3d0/8/ctw**2*mh**4-3d0/4/ct
     & w**2*mz**2*mh**2-3d0/8/ctw**2*mz**4+3d0/2*mh**4+9d0/4*mz**2*mh**2
     & +3d0/2*mz**4-3d0/2*ctw**2*mh**4-3d0/2*ctw**2*mz**4-9*ctw**4*mz**2
     & *mh**2)
     & +propizqs*det3izhqs**2*b0fhww*vmaup*qs*(-3d0/8/ctw**2*mz**2+3d0/2
     & *mz**2-3d0/2*ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhww*qup*(3d0/2*mh**4-9d0/2*ctw**2*mh**4
     & +3*ctw**2*mz**2*mh**2+3*ctw**4*mh**4-21*ctw**4*mz**2*mh**2+18*ctw
     & **6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhzz*vmaup*(-3d0/32/ctw**2/mz**2*mh**6-3
     & d0/4/ctw**2*mh**4-87d0/32/ctw**2*mz**2*mh**2-15d0/16/ctw**2*mz**4
     & )
     & +propizqs*det3izhqs**2*b0fhzz*vmaup*qs*(-3d0/32/ctw**2/mz**2*mh**
     & 4-9d0/32/ctw**2*mh**2-15d0/16/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhhh*vmaup*(9d0/32/ctw**2/mz**2*mh**6+9d
     & 0/16/ctw**2*mh**4+81d0/32/ctw**2*mz**2*mh**2+9d0/8/ctw**2*mz**4)
     & +propizqs*det3izhqs**2*b0fhhh*vmaup*qs*(9d0/32/ctw**2/mz**2*mh**4
     & +9d0/32/ctw**2*mh**2+9d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhmomo*vmaup*cfl*(3d0/4/ctw**2*vmamo**2*
     & mh**2*mmo**2+3d0/4/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhmomo*qup*cfl*(3*qmo*vmamo*mh**2*mmo**2
     & +3*qmo*vpamo*mh**2*mmo**2-3*ctw**2*qmo*vmamo*mh**2*mmo**2-3*ctw**
     & 2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhchch*vmaup*cfq*(3d0/4/ctw**2*vmach**2*
     & mh**2*mch**2+3d0/4/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhchch*qup*cfq*(3*qch*vmach*mh**2*mch**2
     & +3*qch*vpach*mh**2*mch**2-3*ctw**2*qch*vmach*mh**2*mch**2-3*ctw**
     & 2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhstst*vmaup*cfq*(3d0/4/ctw**2*vmast**2*
     & mh**2*mst**2+3d0/4/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhstst*qup*cfq*(3*qst*vmast*mh**2*mst**2
     & +3*qst*vpast*mh**2*mst**2-3*ctw**2*qst*vmast*mh**2*mst**2-3*ctw**
     & 2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhtata*vmaup*cfl*(3d0/4/ctw**2*vmata**2*
     & mh**2*mta**2+3d0/4/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtata*qup*cfl*(3*qta*vmata*mh**2*mta**2
     & +3*qta*vpata*mh**2*mta**2-3*ctw**2*qta*vmata*mh**2*mta**2-3*ctw**
     & 2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtptp*vmaup*cfq*(3d0/4/ctw**2*vmatp**2*
     & mh**2*mtp**2+3d0/4/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhtptp*qup*cfq*(3*qtp*vmatp*mh**2*mtp**2
     & +3*qtp*vpatp*mh**2*mtp**2-3*ctw**2*qtp*vmatp*mh**2*mtp**2-3*ctw**
     & 2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*vmaup*cfq*(3d0/4/ctw**2*vmabt**2*
     & mh**2*mbt**2+3d0/4/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*qup*cfq*(3*qbt*vmabt*mh**2*mbt**2
     & +3*qbt*vpabt*mh**2*mbt**2-3*ctw**2*qbt*vmabt*mh**2*mbt**2-3*ctw**
     & 2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzww*vmaup*(3d0/16/ctw**2*mh**4+3d0/8/ct
     & w**2*mz**2*mh**2+3d0/16/ctw**2*mz**4-3d0/4*mh**4-9d0/8*mz**2*mh**
     & 2-3d0/4*mz**4+3d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**4+9d0/2*ctw**4*
     & mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fzww*vmaup*qs*(3d0/16/ctw**2*mh**2+3d0/1
     & 6/ctw**2*mz**2-3d0/4*mh**2-3d0/8*mz**2+3d0/4*ctw**2*mh**2-3d0/4*c
     & tw**2*mz**2+9d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs**2*b0fzww*qup*(-3d0/4*mh**4-3d0/4*mz**2*mh**2
     & +9d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**2*mh**2-3d0/2*ctw**2*mz**4-3
     & d0/2*ctw**4*mh**4+9*ctw**4*mz**2*mh**2+21d0/2*ctw**4*mz**4-9*ctw*
     & *6*mz**2*mh**2-9*ctw**6*mz**4)
     & +propizqs*det3izhqs**2*b0fzww*qup*qs*(-3d0/4*mh**2+9d0/4*ctw**2*m
     & h**2-3d0/2*ctw**2*mz**2-3d0/2*ctw**4*mh**2+21d0/2*ctw**4*mz**2-9*
     & ctw**6*mz**2)
     & +propizqs*det3izhqs**2*b0fzzh*vmaup*(-3d0/16/ctw**2*mh**4+3d0/8/c
     & tw**2*mz**2*mh**2-3d0/16/ctw**2*mz**4)
     & +propizqs*det3izhqs**2*b0fzzh*vmaup*qs*(3d0/16/ctw**2*mh**2+3d0/1
     & 6/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vmaup*cfl*(-3d0/8/ctw**2*vmamo**2
     & *mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vmaup*cfl*qs*(-3d0/8/ctw**2*vmamo
     & **2*mmo**2-3d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qup*cfl*(-3d0/2*qmo*vmamo*mh**2*m
     & mo**2-3d0/2*qmo*vmamo*mz**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2-3
     & d0/2*qmo*vpamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*mh**2*mmo**2+3
     & d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*m
     & mo**2+3d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qup*cfl*qs*(-3d0/2*qmo*vmamo*mmo*
     & *2-3d0/2*qmo*vpamo*mmo**2+3d0/2*ctw**2*qmo*vmamo*mmo**2+3d0/2*ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fzchch*vmaup*cfq*(-3d0/8/ctw**2*vmach**2
     & *mh**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vmaup*cfq*qs*(-3d0/8/ctw**2*vmach
     & **2*mch**2-3d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qup*cfq*(-3d0/2*qch*vmach*mh**2*m
     & ch**2-3d0/2*qch*vmach*mz**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2-3
     & d0/2*qch*vpach*mz**2*mch**2+3d0/2*ctw**2*qch*vmach*mh**2*mch**2+3
     & d0/2*ctw**2*qch*vmach*mz**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*m
     & ch**2+3d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qup*cfq*qs*(-3d0/2*qch*vmach*mch*
     & *2-3d0/2*qch*vpach*mch**2+3d0/2*ctw**2*qch*vmach*mch**2+3d0/2*ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs**2*b0fzstst*vmaup*cfq*(-3d0/8/ctw**2*vmast**2
     & *mh**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vmaup*cfq*qs*(-3d0/8/ctw**2*vmast
     & **2*mst**2-3d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qup*cfq*(-3d0/2*qst*vmast*mh**2*m
     & st**2-3d0/2*qst*vmast*mz**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2-3
     & d0/2*qst*vpast*mz**2*mst**2+3d0/2*ctw**2*qst*vmast*mh**2*mst**2+3
     & d0/2*ctw**2*qst*vmast*mz**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*m
     & st**2+3d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qup*cfq*qs*(-3d0/2*qst*vmast*mst*
     & *2-3d0/2*qst*vpast*mst**2+3d0/2*ctw**2*qst*vmast*mst**2+3d0/2*ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs**2*b0fztata*vmaup*cfl*(-3d0/8/ctw**2*vmata**2
     & *mh**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vmaup*cfl*qs*(-3d0/8/ctw**2*vmata
     & **2*mta**2-3d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qup*cfl*(-3d0/2*qta*vmata*mh**2*m
     & ta**2-3d0/2*qta*vmata*mz**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2-3
     & d0/2*qta*vpata*mz**2*mta**2+3d0/2*ctw**2*qta*vmata*mh**2*mta**2+3
     & d0/2*ctw**2*qta*vmata*mz**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*m
     & ta**2+3d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qup*cfl*qs*(-3d0/2*qta*vmata*mta*
     & *2-3d0/2*qta*vpata*mta**2+3d0/2*ctw**2*qta*vmata*mta**2+3d0/2*ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs**2*b0fztptp*vmaup*cfq*(-3d0/8/ctw**2*vmatp**2
     & *mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vmaup*cfq*qs*(-3d0/8/ctw**2*vmatp
     & **2*mtp**2-3d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qup*cfq*(-3d0/2*qtp*vmatp*mh**2*m
     & tp**2-3d0/2*qtp*vmatp*mz**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2-3
     & d0/2*qtp*vpatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*mh**2*mtp**2+3
     & d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*m
     & tp**2+3d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qup*cfq*qs*(-3d0/2*qtp*vmatp*mtp*
     & *2-3d0/2*qtp*vpatp*mtp**2+3d0/2*ctw**2*qtp*vmatp*mtp**2+3d0/2*ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vmaup*cfq*(-3d0/8/ctw**2*vmabt**2
     & *mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vmaup*cfq*qs*(-3d0/8/ctw**2*vmabt
     & **2*mbt**2-3d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh**2*m
     & bt**2-3d0/2*qbt*vmabt*mz**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2-3
     & d0/2*qbt*vpabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*mh**2*mbt**2+3
     & d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*m
     & bt**2+3d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qup*cfq*qs*(-3d0/2*qbt*vmabt*mbt*
     & *2-3d0/2*qbt*vpabt*mbt**2+3d0/2*ctw**2*qbt*vmabt*mbt**2+3d0/2*ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsww*vmaup*(3d0/16/ctw**2*mh**4+3d0/8/c
     & tw**2*mz**2*mh**2+3d0/16/ctw**2*mz**4-3d0/4*mh**4-9d0/8*mz**2*mh*
     & *2-3d0/4*mz**4+3d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**4+9d0/2*ctw**4
     & *mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqsww*vmaup*qs*(-3d0/16/ctw**2*mh**2+3d0
     & /16/ctw**2*mz**2+3d0/4*mh**2-9d0/8*mz**2-3d0/4*ctw**2*mh**2+9d0/4
     & *ctw**2*mz**2-9d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs**2*b0fqsww*qup*(-3d0/4*mh**4+3d0/4*mz**2*mh**
     & 2+9d0/4*ctw**2*mh**4-15d0/4*ctw**2*mz**2*mh**2+3d0/2*ctw**2*mz**4
     & -3d0/2*ctw**4*mh**4+12*ctw**4*mz**2*mh**2-21d0/2*ctw**4*mz**4-9*c
     & tw**6*mz**2*mh**2+9*ctw**6*mz**4)
     & +propizqs*det3izhqs**2*b0fqsww*qup*qs*(3d0/4*mh**2-9d0/4*ctw**2*m
     & h**2+3d0/2*ctw**2*mz**2+3d0/2*ctw**4*mh**2-21d0/2*ctw**4*mz**2+9*
     & ctw**6*mz**2)
     & +propizqs*det3izhqs**2*b0fqszh*vmaup*(-3d0/16/ctw**2/mz**2*mh**6+
     & 3d0/8/ctw**2*mh**4-3d0/16/ctw**2*mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqszh*vmaup*qs*(-3d0/16/ctw**2/mz**2*mh*
     & *4-3d0/16/ctw**2*mh**2-3d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vmaup*cfl*(-3d0/8/ctw**2*vmamo**
     & 2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vmaup*cfl*qs*(3d0/8/ctw**2*vmamo
     & **2*mmo**2+3d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qup*cfl*(-3d0/2*qmo*vmamo*mh**2*
     & mmo**2+3d0/2*qmo*vmamo*mz**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2+
     & 3d0/2*qmo*vpamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*mh**2*mmo**2-
     & 3d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*
     & mmo**2-3d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qup*cfl*qs*(3d0/2*qmo*vmamo*mmo*
     & *2+3d0/2*qmo*vpamo*mmo**2-3d0/2*ctw**2*qmo*vmamo*mmo**2-3d0/2*ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fqschch*vmaup*cfq*(-3d0/8/ctw**2*vmach**
     & 2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vmaup*cfq*qs*(3d0/8/ctw**2*vmach
     & **2*mch**2+3d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qup*cfq*(-3d0/2*qch*vmach*mh**2*
     & mch**2+3d0/2*qch*vmach*mz**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2+
     & 3d0/2*qch*vpach*mz**2*mch**2+3d0/2*ctw**2*qch*vmach*mh**2*mch**2-
     & 3d0/2*ctw**2*qch*vmach*mz**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*
     & mch**2-3d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qup*cfq*qs*(3d0/2*qch*vmach*mch*
     & *2+3d0/2*qch*vpach*mch**2-3d0/2*ctw**2*qch*vmach*mch**2-3d0/2*ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vmaup*cfq*(-3d0/8/ctw**2*vmast**
     & 2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vmaup*cfq*qs*(3d0/8/ctw**2*vmast
     & **2*mst**2+3d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qup*cfq*(-3d0/2*qst*vmast*mh**2*
     & mst**2+3d0/2*qst*vmast*mz**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2+
     & 3d0/2*qst*vpast*mz**2*mst**2+3d0/2*ctw**2*qst*vmast*mh**2*mst**2-
     & 3d0/2*ctw**2*qst*vmast*mz**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*
     & mst**2-3d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qup*cfq*qs*(3d0/2*qst*vmast*mst*
     & *2+3d0/2*qst*vpast*mst**2-3d0/2*ctw**2*qst*vmast*mst**2-3d0/2*ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs**2*b0fqstata*vmaup*cfl*(-3d0/8/ctw**2*vmata**
     & 2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vmaup*cfl*qs*(3d0/8/ctw**2*vmata
     & **2*mta**2+3d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qup*cfl*(-3d0/2*qta*vmata*mh**2*
     & mta**2+3d0/2*qta*vmata*mz**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2+
     & 3d0/2*qta*vpata*mz**2*mta**2+3d0/2*ctw**2*qta*vmata*mh**2*mta**2-
     & 3d0/2*ctw**2*qta*vmata*mz**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*
     & mta**2-3d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qup*cfl*qs*(3d0/2*qta*vmata*mta*
     & *2+3d0/2*qta*vpata*mta**2-3d0/2*ctw**2*qta*vmata*mta**2-3d0/2*ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vmaup*cfq*(-3d0/8/ctw**2*vmatp**
     & 2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vmaup*cfq*qs*(3d0/8/ctw**2*vmatp
     & **2*mtp**2+3d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qup*cfq*(-3d0/2*qtp*vmatp*mh**2*
     & mtp**2+3d0/2*qtp*vmatp*mz**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2+
     & 3d0/2*qtp*vpatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*mh**2*mtp**2-
     & 3d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*
     & mtp**2-3d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qup*cfq*qs*(3d0/2*qtp*vmatp*mtp*
     & *2+3d0/2*qtp*vpatp*mtp**2-3d0/2*ctw**2*qtp*vmatp*mtp**2-3d0/2*ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vmaup*cfq*(-3d0/8/ctw**2*vmabt**
     & 2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vmaup*cfq*qs*(3d0/8/ctw**2*vmabt
     & **2*mbt**2+3d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh**2*
     & mbt**2+3d0/2*qbt*vmabt*mz**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2+
     & 3d0/2*qbt*vpabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*mh**2*mbt**2-
     & 3d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*
     & mbt**2-3d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qup*cfq*qs*(3d0/2*qbt*vmabt*mbt*
     & *2+3d0/2*qbt*vpabt*mbt**2-3d0/2*ctw**2*qbt*vmabt*mbt**2-3d0/2*ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*c0zhqswww*vmaup*(1d0/4/ctw**2*mh**2-7d0/4*mh*
     & *2-1d0/4*mz**2+2*ctw**2*mh**2-1d0/2*ctw**2*mz**2-ctw**4*mh**2+3*c
     & tw**4*mz**2+6*ctw**6*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*vmaup*qs*(-3d0/4+ctw**2-ctw**4)
     & +propizqs*det3izhqs*c0zhqswww*qup/qs*(-ctw**2*mz**2*mh**2+ctw**2*
     & mz**4+ctw**4*mz**2*mh**2-ctw**4*mz**4+12*ctw**6*mz**2*mh**2-12*ct
     & w**6*mz**4-12*ctw**8*mz**2*mh**2+12*ctw**8*mz**4)
     & +propizqs*det3izhqs*c0zhqswww*qup*(-mh**2+4*ctw**2*mh**2-5*ctw**4
     & *mh**2+6*ctw**4*mz**2+2*ctw**6*mh**2+6*ctw**6*mz**2-12*ctw**8*mz*
     & *2)
     & +propizqs*det3izhqs*c0zhqswww*qup*qs*(ctw**2-3*ctw**4+2*ctw**6)
     & +propizqs*det3izhqs*c0zhqszhh*vmaup*(-3d0/4/ctw**2/mz**2*mh**4-6/
     & ctw**2*mh**2-21d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqszhh*vmaup*qs*(-3d0/4/ctw**2/mz**2*mh**2
     & -21d0/8/ctw**2)
     & +propizqs*det3izhqs*c0zhqshzz*vmaup*(-7d0/8/ctw**2/mz**2*mh**4-7/
     & ctw**2*mh**2-11d0/4/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqshzz*vmaup*qs*(-3d0/8/ctw**2/mz**2*mh**2
     & -7d0/2/ctw**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vmaup*cfl*(-1d0/2/ctw**2*vmamo**
     & 2/mz**2*mmo**4+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-3d0/8/ctw
     & **2*vmamo**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mh**2*mmo**2-1
     & d0/4/ctw**2*vpamo*vmamo*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mmo**4
     & +1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*m
     & mo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vmaup*cfl*qs*(1d0/8/ctw**2*vmamo
     & **2/mz**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2+1d0/8/ctw*
     & *2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup*cfl/qs*(-2*qmo*vmamo/mz**2*m
     & h**2*mmo**4+2*qmo*vmamo*mmo**4-2*qmo*vpamo/mz**2*mh**2*mmo**4+2*q
     & mo*vpamo*mmo**4+2*ctw**2*qmo*vmamo/mz**2*mh**2*mmo**4-2*ctw**2*qm
     & o*vmamo*mmo**4+2*ctw**2*qmo*vpamo/mz**2*mh**2*mmo**4-2*ctw**2*qmo
     & *vpamo*mmo**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup*cfl*(-2*qmo*vmamo/mz**2*mmo*
     & *4-2*qmo*vmamo*mmo**2-2*qmo*vpamo/mz**2*mmo**4-2*qmo*vpamo*mmo**2
     & +2*ctw**2*qmo*vmamo/mz**2*mmo**4+2*ctw**2*qmo*vmamo*mmo**2+2*ctw*
     & *2*qmo*vpamo/mz**2*mmo**4+2*ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*c0zhqschchch*vmaup*cfq*(-1d0/2/ctw**2*vmach**
     & 2/mz**2*mch**4+1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-3d0/8/ctw
     & **2*vmach**2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mh**2*mch**2-1
     & d0/4/ctw**2*vpach*vmach*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mch**4
     & +1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*m
     & ch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vmaup*cfq*qs*(1d0/8/ctw**2*vmach
     & **2/mz**2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mch**2+1d0/8/ctw*
     & *2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*qup*cfq/qs*(-2*qch*vmach/mz**2*m
     & h**2*mch**4+2*qch*vmach*mch**4-2*qch*vpach/mz**2*mh**2*mch**4+2*q
     & ch*vpach*mch**4+2*ctw**2*qch*vmach/mz**2*mh**2*mch**4-2*ctw**2*qc
     & h*vmach*mch**4+2*ctw**2*qch*vpach/mz**2*mh**2*mch**4-2*ctw**2*qch
     & *vpach*mch**4)
     & +propizqs*det3izhqs*c0zhqschchch*qup*cfq*(-2*qch*vmach/mz**2*mch*
     & *4-2*qch*vmach*mch**2-2*qch*vpach/mz**2*mch**4-2*qch*vpach*mch**2
     & +2*ctw**2*qch*vmach/mz**2*mch**4+2*ctw**2*qch*vmach*mch**2+2*ctw*
     & *2*qch*vpach/mz**2*mch**4+2*ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*c0zhqsststst*vmaup*cfq*(-1d0/2/ctw**2*vmast**
     & 2/mz**2*mst**4+1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-3d0/8/ctw
     & **2*vmast**2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mh**2*mst**2-1
     & d0/4/ctw**2*vpast*vmast*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mst**4
     & +1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*m
     & st**2)
     & +propizqs*det3izhqs*c0zhqsststst*vmaup*cfq*qs*(1d0/8/ctw**2*vmast
     & **2/mz**2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mst**2+1d0/8/ctw*
     & *2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*qup*cfq/qs*(-2*qst*vmast/mz**2*m
     & h**2*mst**4+2*qst*vmast*mst**4-2*qst*vpast/mz**2*mh**2*mst**4+2*q
     & st*vpast*mst**4+2*ctw**2*qst*vmast/mz**2*mh**2*mst**4-2*ctw**2*qs
     & t*vmast*mst**4+2*ctw**2*qst*vpast/mz**2*mh**2*mst**4-2*ctw**2*qst
     & *vpast*mst**4)
     & +propizqs*det3izhqs*c0zhqsststst*qup*cfq*(-2*qst*vmast/mz**2*mst*
     & *4-2*qst*vmast*mst**2-2*qst*vpast/mz**2*mst**4-2*qst*vpast*mst**2
     & +2*ctw**2*qst*vmast/mz**2*mst**4+2*ctw**2*qst*vmast*mst**2+2*ctw*
     & *2*qst*vpast/mz**2*mst**4+2*ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*c0zhqstatata*vmaup*cfl*(-1d0/2/ctw**2*vmata**
     & 2/mz**2*mta**4+1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-3d0/8/ctw
     & **2*vmata**2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mh**2*mta**2-1
     & d0/4/ctw**2*vpata*vmata*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mta**4
     & +1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*m
     & ta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vmaup*cfl*qs*(1d0/8/ctw**2*vmata
     & **2/mz**2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mta**2+1d0/8/ctw*
     & *2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*qup*cfl/qs*(-2*qta*vmata/mz**2*m
     & h**2*mta**4+2*qta*vmata*mta**4-2*qta*vpata/mz**2*mh**2*mta**4+2*q
     & ta*vpata*mta**4+2*ctw**2*qta*vmata/mz**2*mh**2*mta**4-2*ctw**2*qt
     & a*vmata*mta**4+2*ctw**2*qta*vpata/mz**2*mh**2*mta**4-2*ctw**2*qta
     & *vpata*mta**4)
     & +propizqs*det3izhqs*c0zhqstatata*qup*cfl*(-2*qta*vmata/mz**2*mta*
     & *4-2*qta*vmata*mta**2-2*qta*vpata/mz**2*mta**4-2*qta*vpata*mta**2
     & +2*ctw**2*qta*vmata/mz**2*mta**4+2*ctw**2*qta*vmata*mta**2+2*ctw*
     & *2*qta*vpata/mz**2*mta**4+2*ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vmaup*cfq*(-1d0/2/ctw**2*vmatp**
     & 2/mz**2*mtp**4+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-3d0/8/ctw
     & **2*vmatp**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mh**2*mtp**2-1
     & d0/4/ctw**2*vpatp*vmatp*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**4
     & +1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*m
     & tp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vmaup*cfq*qs*(1d0/8/ctw**2*vmatp
     & **2/mz**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2+1d0/8/ctw*
     & *2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qup*cfq/qs*(-2*qtp*vmatp/mz**2*m
     & h**2*mtp**4+2*qtp*vmatp*mtp**4-2*qtp*vpatp/mz**2*mh**2*mtp**4+2*q
     & tp*vpatp*mtp**4+2*ctw**2*qtp*vmatp/mz**2*mh**2*mtp**4-2*ctw**2*qt
     & p*vmatp*mtp**4+2*ctw**2*qtp*vpatp/mz**2*mh**2*mtp**4-2*ctw**2*qtp
     & *vpatp*mtp**4)
     & +propizqs*det3izhqs*c0zhqstptptp*qup*cfq*(-2*qtp*vmatp/mz**2*mtp*
     & *4-2*qtp*vmatp*mtp**2-2*qtp*vpatp/mz**2*mtp**4-2*qtp*vpatp*mtp**2
     & +2*ctw**2*qtp*vmatp/mz**2*mtp**4+2*ctw**2*qtp*vmatp*mtp**2+2*ctw*
     & *2*qtp*vpatp/mz**2*mtp**4+2*ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vmaup*cfq*(-1d0/2/ctw**2*vmabt**
     & 2/mz**2*mbt**4+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-3d0/8/ctw
     & **2*vmabt**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mh**2*mbt**2-1
     & d0/4/ctw**2*vpabt*vmabt*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**4
     & +1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*m
     & bt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vmaup*cfq*qs*(1d0/8/ctw**2*vmabt
     & **2/mz**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2+1d0/8/ctw*
     & *2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup*cfq/qs*(-2*qbt*vmabt/mz**2*m
     & h**2*mbt**4+2*qbt*vmabt*mbt**4-2*qbt*vpabt/mz**2*mh**2*mbt**4+2*q
     & bt*vpabt*mbt**4+2*ctw**2*qbt*vmabt/mz**2*mh**2*mbt**4-2*ctw**2*qb
     & t*vmabt*mbt**4+2*ctw**2*qbt*vpabt/mz**2*mh**2*mbt**4-2*ctw**2*qbt
     & *vpabt*mbt**4)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup*cfq*(-2*qbt*vmabt/mz**2*mbt*
     & *4-2*qbt*vmabt*mbt**2-2*qbt*vpabt/mz**2*mbt**4-2*qbt*vpabt*mbt**2
     & +2*ctw**2*qbt*vmabt/mz**2*mbt**4+2*ctw**2*qbt*vmabt*mbt**2+2*ctw*
     & *2*qbt*vpabt/mz**2*mbt**4+2*ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*a0fh*vmaup*(-1d0/2/ctw**2/mz**2*mh**2-1d0/4/c
     & tw**2)
     & +propizqs*det3izhqs*a0fh*vmaup*qs*(-1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhww*vmaup*(1d0/4+1d0/8/ctw**2/mz**2*mh**2-
     & 1d0/2/mz**2*mh**2+1d0/2*ctw**2/mz**2*mh**2-ctw**2+3*ctw**4)
     & +propizqs*det3izhqs*b0fhww*qup/qs*(1d0/2*mh**2-3d0/2*ctw**2*mh**2
     & +ctw**2*mz**2+ctw**4*mh**2-7*ctw**4*mz**2+6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qup*(-1d0/2/mz**2*mh**2+3d0/2*ctw**2/m
     & z**2*mh**2-ctw**2-ctw**4/mz**2*mh**2+7*ctw**4-6*ctw**6)
     & +propizqs*det3izhqs*b0fhzz*vmaup*(9d0/16/ctw**2/mz**2*mh**2+3d0/8
     & /ctw**2)
     & +propizqs*det3izhqs*b0fhzz*vmaup*qs*(1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhhh*vmaup*(-21d0/16/ctw**2/mz**2*mh**2-3d0
     & /4/ctw**2)
     & +propizqs*det3izhqs*b0fhhh*vmaup*qs*(-3d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhmomo*vmaup*cfl*(-1d0/4/ctw**2*vmamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup*cfl/qs*(qmo*vmamo*mmo**2+qmo*vpa
     & mo*mmo**2-ctw**2*qmo*vmamo*mmo**2-ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup*cfl*(-qmo*vmamo/mz**2*mmo**2-qmo
     & *vpamo/mz**2*mmo**2+ctw**2*qmo*vmamo/mz**2*mmo**2+ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*vmaup*cfq*(-1d0/4/ctw**2*vmach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup*cfq/qs*(qch*vmach*mch**2+qch*vpa
     & ch*mch**2-ctw**2*qch*vmach*mch**2-ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup*cfq*(-qch*vmach/mz**2*mch**2-qch
     & *vpach/mz**2*mch**2+ctw**2*qch*vmach/mz**2*mch**2+ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*vmaup*cfq*(-1d0/4/ctw**2*vmast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup*cfq/qs*(qst*vmast*mst**2+qst*vpa
     & st*mst**2-ctw**2*qst*vmast*mst**2-ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup*cfq*(-qst*vmast/mz**2*mst**2-qst
     & *vpast/mz**2*mst**2+ctw**2*qst*vmast/mz**2*mst**2+ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*vmaup*cfl*(-1d0/4/ctw**2*vmata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup*cfl/qs*(qta*vmata*mta**2+qta*vpa
     & ta*mta**2-ctw**2*qta*vmata*mta**2-ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup*cfl*(-qta*vmata/mz**2*mta**2-qta
     & *vpata/mz**2*mta**2+ctw**2*qta*vmata/mz**2*mta**2+ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*vmaup*cfq*(-1d0/4/ctw**2*vmatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup*cfq/qs*(qtp*vmatp*mtp**2+qtp*vpa
     & tp*mtp**2-ctw**2*qtp*vmatp*mtp**2-ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup*cfq*(-qtp*vmatp/mz**2*mtp**2-qtp
     & *vpatp/mz**2*mtp**2+ctw**2*qtp*vmatp/mz**2*mtp**2+ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*vmaup*cfq*(-1d0/4/ctw**2*vmabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup*cfq/qs*(qbt*vmabt*mbt**2+qbt*vpa
     & bt*mbt**2-ctw**2*qbt*vmabt*mbt**2-ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup*cfq*(-qbt*vmabt/mz**2*mbt**2-qbt
     & *vpabt/mz**2*mbt**2+ctw**2*qbt*vmabt/mz**2*mbt**2+ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzww*vmaup*(1d0/2)
     & +propizqs*det3izhqs*b0fzww*qup/qs*(-1d0/2*mh**2+3d0/2*ctw**2*mh**
     & 2-ctw**2*mz**2-ctw**4*mh**2+7*ctw**4*mz**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fzzh*vmaup*(1d0/4/ctw**2/mz**2*mh**2+3d0/8/
     & ctw**2)
     & +propizqs*det3izhqs*b0fzzh*vmaup*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fzmomo*vmaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz
     & **2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2-1d0/8/ctw**2*vpa
     & mo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*qup*cfl/qs*(-qmo*vmamo*mmo**2-qmo*vp
     & amo*mmo**2+ctw**2*qmo*vmamo*mmo**2+ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*vmaup*cfq*(-1d0/8/ctw**2*vmach**2/mz
     & **2*mch**2+1d0/4/ctw**2*vpach*vmach/mz**2*mch**2-1d0/8/ctw**2*vpa
     & ch**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*qup*cfq/qs*(-qch*vmach*mch**2-qch*vp
     & ach*mch**2+ctw**2*qch*vmach*mch**2+ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fzstst*vmaup*cfq*(-1d0/8/ctw**2*vmast**2/mz
     & **2*mst**2+1d0/4/ctw**2*vpast*vmast/mz**2*mst**2-1d0/8/ctw**2*vpa
     & st**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*qup*cfq/qs*(-qst*vmast*mst**2-qst*vp
     & ast*mst**2+ctw**2*qst*vmast*mst**2+ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fztata*vmaup*cfl*(-1d0/8/ctw**2*vmata**2/mz
     & **2*mta**2+1d0/4/ctw**2*vpata*vmata/mz**2*mta**2-1d0/8/ctw**2*vpa
     & ta**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*qup*cfl/qs*(-qta*vmata*mta**2-qta*vp
     & ata*mta**2+ctw**2*qta*vmata*mta**2+ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fztptp*vmaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz
     & **2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2-1d0/8/ctw**2*vpa
     & tp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*qup*cfq/qs*(-qtp*vmatp*mtp**2-qtp*vp
     & atp*mtp**2+ctw**2*qtp*vmatp*mtp**2+ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*vmaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz
     & **2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2-1d0/8/ctw**2*vpa
     & bt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*qup*cfq/qs*(-qbt*vmabt*mbt**2-qbt*vp
     & abt*mbt**2+ctw**2*qbt*vmabt*mbt**2+ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*vmaup*(-3d0/4-1d0/8/ctw**2/mz**2*mh**
     & 2+1d0/2/mz**2*mh**2-1d0/2*ctw**2/mz**2*mh**2+ctw**2-3*ctw**4)
     & +propizqs*det3izhqs*b0fqsww*qup*(1d0/2/mz**2*mh**2-3d0/2*ctw**2/m
     & z**2*mh**2+ctw**2+ctw**4/mz**2*mh**2-7*ctw**4+6*ctw**6)
     & +propizqs*det3izhqs*b0fqszh*vmaup*(-1d0/4/ctw**2)
     & +propizqs*det3izhqs*b0fqszh*vmaup*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fqsmomo*vmaup*cfl*(3d0/8/ctw**2*vmamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2+3d0/8/ctw**2*vpa
     & mo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*qup*cfl*(qmo*vmamo/mz**2*mmo**2+qmo
     & *vpamo/mz**2*mmo**2-ctw**2*qmo*vmamo/mz**2*mmo**2-ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*vmaup*cfq*(3d0/8/ctw**2*vmach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mch**2+3d0/8/ctw**2*vpa
     & ch**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*qup*cfq*(qch*vmach/mz**2*mch**2+qch
     & *vpach/mz**2*mch**2-ctw**2*qch*vmach/mz**2*mch**2-ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*vmaup*cfq*(3d0/8/ctw**2*vmast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mst**2+3d0/8/ctw**2*vpa
     & st**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*qup*cfq*(qst*vmast/mz**2*mst**2+qst
     & *vpast/mz**2*mst**2-ctw**2*qst*vmast/mz**2*mst**2-ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*vmaup*cfl*(3d0/8/ctw**2*vmata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mta**2+3d0/8/ctw**2*vpa
     & ta**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*qup*cfl*(qta*vmata/mz**2*mta**2+qta
     & *vpata/mz**2*mta**2-ctw**2*qta*vmata/mz**2*mta**2-ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*vmaup*cfq*(3d0/8/ctw**2*vmatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2+3d0/8/ctw**2*vpa
     & tp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*qup*cfq*(qtp*vmatp/mz**2*mtp**2+qtp
     & *vpatp/mz**2*mtp**2-ctw**2*qtp*vmatp/mz**2*mtp**2-ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*vmaup*cfq*(3d0/8/ctw**2*vmabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2+3d0/8/ctw**2*vpa
     & bt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qup*cfq*(qbt*vmabt/mz**2*mbt**2+qbt
     & *vpabt/mz**2*mbt**2-ctw**2*qbt*vmabt/mz**2*mbt**2-ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*sdet3iczus*c0czuszcc*vmaup**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3iczus*b0fzcc*vmaup**3/qs*(1d0/ctw**2)
     & +propizqs*sdet3iczus*b0fuszc*vmaup**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichts*c0chtsczz*vmaup**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3ichts*b0fhzz*vmaup**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichts*b0ftszc*vmaup**3/qs*(1d0/ctw**2)
     & +propizqs*d0zchctsuscczz*vmaup**3/qs*(-1d0/2/ctw**2*mh**2-1d0/2/c
     & tw**2*mz**2-1d0/2/ctw**2*us-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2
     & +1d0/2*sdet4izhtsus/ctw**2*mz**6-sdet4izhtsus/ctw**2*ts*mz**2*mh*
     & *2+sdet4izhtsus/ctw**2*ts*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*mz**
     & 6*mh**4-3d0/2*sdet4izhtsus**2/ctw**2*mz**8*mh**2-1d0/2*sdet4izhts
     & us**2/ctw**2*us*mz**8+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**4
     & -sdet4izhtsus**2/ctw**2*ts*mz**6*mh**2)
     & +propizqs*d0zchctsuscczz*vmaup**3*(-1d0/2/ctw**2-sdet4izhtsus/ctw
     & **2*ts*mz**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6+1d0/2*sdet4izh
     & tsus**2/ctw**2*ts*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*ts**2*
     & mz**4)
     & +propizqs*c0zhqswww*qup/qs*(-4*ctw**2+28*ctw**4-24*ctw**6)
     & +propizqs*c0zhqsmomomo*qup*cfl/qs*(-2*qmo*vmamo/mz**2*mmo**2-2*qm
     & o*vpamo/mz**2*mmo**2+2*ctw**2*qmo*vmamo/mz**2*mmo**2+2*ctw**2*qmo
     & *vpamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qup*cfq/qs*(-2*qch*vmach/mz**2*mch**2-2*qc
     & h*vpach/mz**2*mch**2+2*ctw**2*qch*vmach/mz**2*mch**2+2*ctw**2*qch
     & *vpach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qup*cfq/qs*(-2*qst*vmast/mz**2*mst**2-2*qs
     & t*vpast/mz**2*mst**2+2*ctw**2*qst*vmast/mz**2*mst**2+2*ctw**2*qst
     & *vpast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qup*cfl/qs*(-2*qta*vmata/mz**2*mta**2-2*qt
     & a*vpata/mz**2*mta**2+2*ctw**2*qta*vmata/mz**2*mta**2+2*ctw**2*qta
     & *vpata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qup*cfq/qs*(-2*qtp*vmatp/mz**2*mtp**2-2*qt
     & p*vpatp/mz**2*mtp**2+2*ctw**2*qtp*vmatp/mz**2*mtp**2+2*ctw**2*qtp
     & *vpatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qup*cfq/qs*(-2*qbt*vmabt/mz**2*mbt**2-2*qb
     & t*vpabt/mz**2*mbt**2+2*ctw**2*qbt*vmabt/mz**2*mbt**2+2*ctw**2*qbt
     & *vpabt/mz**2*mbt**2)
     & +propizqs*c0chtsczz*vmaup**3/qs*(1d0/2/ctw**2-1d0/2*sdet4izhtsus/
     & ctw**2*mz**4-1d0/2*sdet4izhtsus/ctw**2*ts*mz**2-1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**4*mh**4-1d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2
     & /ctw**2*ts*mz**4*mh**2)
     & +propizqs*c0chtsczz*vmaup**3*(-1d0/2*sdet4izhtsus/ctw**2*ts-1d0/2
     & *sdet4izhtsus**2/ctw**2*ts**2*mz**2)
     & +propizqs*c0chusczz*vmaup**3/qs*(-1d0/2/ctw**2-1d0/2*sdet4izhtsus
     & /ctw**2*mz**2*mh**2-sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsus/
     & ctw**2*us*mz**2-1d0/2*sdet4izhtsus/ctw**2*ts*mh**2-1d0/2*sdet4izh
     & tsus/ctw**2*ts*mz**2+sdet4izhtsus**2/ctw**2*mz**4*mh**4-sdet4izht
     & sus**2/ctw**2*mz**6*mh**2+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*m
     & h**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6+1d0/2*sdet4izhtsus**2/
     & ctw**2*ts*mz**2*mh**4-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2
     & )
     & +propizqs*c0chusczz*vmaup**3*(-1d0/2*sdet4izhtsus**2/ctw**2*us*mz
     & **4+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**2*mh**2)
     & +propizqs*c0cztszcc*vmaup**3/qs*(1d0/2/ctw**2+1d0/2*sdet4izhtsus/
     & ctw**2*mz**4+1d0/2*sdet4izhtsus/ctw**2*ts*mh**2-1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**4*mh**4+3d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2+
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6-1d0/2*sdet4izhtsus**2/ctw**
     & 2*ts*mz**2*mh**4+sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2)
     & +propizqs*c0cztszcc*vmaup**3*(1d0/2*sdet4izhtsus/ctw**2*ts-1d0/2*
     & sdet4izhtsus**2/ctw**2*ts*mz**2*mh**2+1d0/2*sdet4izhtsus**2/ctw**
     & 2*ts*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*ts**2*mz**2)
     & +propizqs*c0czuszcc*vmaup**3/qs*(-1d0/2/ctw**2+1d0/2*sdet4izhtsus
     & /ctw**2*mz**2*mh**2+sdet4izhtsus/ctw**2*mz**4+1d0/2*sdet4izhtsus/
     & ctw**2*us*mz**2+sdet4izhtsus/ctw**2*ts*mz**2)
     & +propizqs*c0czuszcc*vmaup**3*(1d0/2*sdet4izhtsus**2/ctw**2*us*mz*
     & *4-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4)
     & +propizqs*b0fhzz*vmaup**3/qs*(-sdet4izhtsus/ctw**2*mz**2-sdet4izh
     & tsus/ctw**2*ts)
     & +propizqs*b0fzcc*vmaup**3/qs*(-sdet4izhtsus/ctw**2*mz**2-sdet4izh
     & tsus/ctw**2*ts)
     & +propizqs*b0ftszc*vmaup**3/qs*(sdet4izhtsus/ctw**2*mz**2+sdet4izh
     & tsus/ctw**2*ts)
     & +propizqs*b0fuszc*vmaup**3/qs*(sdet4izhtsus/ctw**2*mz**2+sdet4izh
     & tsus/ctw**2*ts)
     & +det3izhqs*vmaup*(-7d0/8/ctw**2*mh**2+1d0/4/ctw**2*mz**2+3d0/4*mh
     & **2+1d0/2*mz**2-2*ctw**2*mz**2-3*ctw**4*mh**2+6*ctw**4*mz**2)
     & +det3izhqs*vmaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d
     & 0/2/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt*
     & *2-1d0/2/ctw**2*vpabt**2*mbt**2+1d0/4/ctw**2*vmatp**2/mz**2*mh**2
     & *mtp**2-1d0/2/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*
     & mh**2*mtp**2-1d0/2/ctw**2*vpatp**2*mtp**2+1d0/4/ctw**2*vmast**2/m
     & z**2*mh**2*mst**2-1d0/2/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast
     & **2/mz**2*mh**2*mst**2-1d0/2/ctw**2*vpast**2*mst**2+1d0/4/ctw**2*
     & vmach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vmach**2*mch**2+1d0/4/ct
     & w**2*vpach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vpach**2*mch**2)
     & +det3izhqs*vmaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d
     & 0/2/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta*
     & *2-1d0/2/ctw**2*vpata**2*mta**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2
     & *mmo**2-1d0/2/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*
     & mh**2*mmo**2-1d0/2/ctw**2*vpamo**2*mmo**2)
     & +det3izhqs**2*c0zhqswww*vmaup*(-3d0/2/ctw**2*mz**6*mh**2+21d0/4*m
     & z**6*mh**2-3*ctw**2*mz**6*mh**2-9*ctw**4*mz**6*mh**2)
     & +det3izhqs**2*c0zhqszhh*vmaup*(-9/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqshzz*vmaup*(-18/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqsmomomo*vmaup*cfl*(3d0/4/ctw**2*vmamo**2*mz**4
     & *mh**2*mmo**2+3d0/4/ctw**2*vpamo**2*mz**4*mh**2*mmo**2)
     & +det3izhqs**2*c0zhqschchch*vmaup*cfq*(3d0/4/ctw**2*vmach**2*mz**4
     & *mh**2*mch**2+3d0/4/ctw**2*vpach**2*mz**4*mh**2*mch**2)
     & +det3izhqs**2*c0zhqsststst*vmaup*cfq*(3d0/4/ctw**2*vmast**2*mz**4
     & *mh**2*mst**2+3d0/4/ctw**2*vpast**2*mz**4*mh**2*mst**2)
     & +det3izhqs**2*c0zhqstatata*vmaup*cfl*(3d0/4/ctw**2*vmata**2*mz**4
     & *mh**2*mta**2+3d0/4/ctw**2*vpata**2*mz**4*mh**2*mta**2)
     & +det3izhqs**2*c0zhqstptptp*vmaup*cfq*(3d0/4/ctw**2*vmatp**2*mz**4
     & *mh**2*mtp**2+3d0/4/ctw**2*vpatp**2*mz**4*mh**2*mtp**2)
     & +det3izhqs**2*c0zhqsbtbtbt*vmaup*cfq*(3d0/4/ctw**2*vmabt**2*mz**4
     & *mh**2*mbt**2+3d0/4/ctw**2*vpabt**2*mz**4*mh**2*mbt**2)
     & +det3izhqs**2*b0fhww*vmaup*(3d0/2/ctw**2*mz**4*mh**2-21d0/4*mz**4
     & *mh**2+3*ctw**2*mz**4*mh**2+9*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fhzz*vmaup*(9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhhh*vmaup*(-9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhmomo*vmaup*cfl*(-3d0/4/ctw**2*vmamo**2*mz**2*mh
     & **2*mmo**2-3d0/4/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fhchch*vmaup*cfq*(-3d0/4/ctw**2*vmach**2*mz**2*mh
     & **2*mch**2-3d0/4/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fhstst*vmaup*cfq*(-3d0/4/ctw**2*vmast**2*mz**2*mh
     & **2*mst**2-3d0/4/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fhtata*vmaup*cfl*(-3d0/4/ctw**2*vmata**2*mz**2*mh
     & **2*mta**2-3d0/4/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fhtptp*vmaup*cfq*(-3d0/4/ctw**2*vmatp**2*mz**2*mh
     & **2*mtp**2-3d0/4/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fhbtbt*vmaup*cfq*(-3d0/4/ctw**2*vmabt**2*mz**2*mh
     & **2*mbt**2-3d0/4/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fzww*vmaup*(-3d0/4/ctw**2*mz**4*mh**2+21d0/8*mz**
     & 4*mh**2-3d0/2*ctw**2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fzmomo*vmaup*cfl*(3d0/8/ctw**2*vmamo**2*mz**2*mh*
     & *2*mmo**2+3d0/8/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fzchch*vmaup*cfq*(3d0/8/ctw**2*vmach**2*mz**2*mh*
     & *2*mch**2+3d0/8/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fzstst*vmaup*cfq*(3d0/8/ctw**2*vmast**2*mz**2*mh*
     & *2*mst**2+3d0/8/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fztata*vmaup*cfl*(3d0/8/ctw**2*vmata**2*mz**2*mh*
     & *2*mta**2+3d0/8/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fztptp*vmaup*cfq*(3d0/8/ctw**2*vmatp**2*mz**2*mh*
     & *2*mtp**2+3d0/8/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fzbtbt*vmaup*cfq*(3d0/8/ctw**2*vmabt**2*mz**2*mh*
     & *2*mbt**2+3d0/8/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fqsww*vmaup*(-3d0/4/ctw**2*mz**4*mh**2+21d0/8*mz*
     & *4*mh**2-3d0/2*ctw**2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fqsmomo*vmaup*cfl*(3d0/8/ctw**2*vmamo**2*mz**2*mh
     & **2*mmo**2+3d0/8/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fqschch*vmaup*cfq*(3d0/8/ctw**2*vmach**2*mz**2*mh
     & **2*mch**2+3d0/8/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fqsstst*vmaup*cfq*(3d0/8/ctw**2*vmast**2*mz**2*mh
     & **2*mst**2+3d0/8/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fqstata*vmaup*cfl*(3d0/8/ctw**2*vmata**2*mz**2*mh
     & **2*mta**2+3d0/8/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fqstptp*vmaup*cfq*(3d0/8/ctw**2*vmatp**2*mz**2*mh
     & **2*mtp**2+3d0/8/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fqsbtbt*vmaup*cfq*(3d0/8/ctw**2*vmabt**2*mz**2*mh
     & **2*mbt**2+3d0/8/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*c0zhqswww*vmaup*(1d0/2/ctw**2*mz**2*mh**2+3d0/2/ctw**2
     & *mz**4-1d0/2*mz**2*mh**2-5*mz**4+1d0/2*ctw**2*mz**2*mh**2+ctw**2*
     & mz**4+16*ctw**4*mz**4+6*ctw**6*mz**2*mh**2-12*ctw**6*mz**4)
     & +det3izhqs*c0zhqszhh*vmaup*(51d0/4/ctw**2*mz**2*mh**2+9/ctw**2*mz
     & **4)
     & +det3izhqs*c0zhqshzz*vmaup*(17/ctw**2*mz**2*mh**2+18/ctw**2*mz**4
     & )
     & +det3izhqs*c0zhqsmomomo*vmaup*cfl*(-1d0/2/ctw**2*vmamo**2/mz**2*m
     & h**2*mmo**4+1d0/ctw**2*vmamo**2*mmo**4-1d0/4/ctw**2*vmamo**2*mh**
     & 2*mmo**2-1d0/ctw**2*vmamo**2*mz**2*mmo**2+1d0/2/ctw**2*vpamo*vmam
     & o*mh**2*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mh**2*mmo**4+1d0/ctw**
     & 2*vpamo**2*mmo**4-1d0/4/ctw**2*vpamo**2*mh**2*mmo**2-1d0/ctw**2*v
     & pamo**2*mz**2*mmo**2)
     & +det3izhqs*c0zhqschchch*vmaup*cfq*(-1d0/2/ctw**2*vmach**2/mz**2*m
     & h**2*mch**4+1d0/ctw**2*vmach**2*mch**4-1d0/4/ctw**2*vmach**2*mh**
     & 2*mch**2-1d0/ctw**2*vmach**2*mz**2*mch**2+1d0/2/ctw**2*vpach*vmac
     & h*mh**2*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mh**2*mch**4+1d0/ctw**
     & 2*vpach**2*mch**4-1d0/4/ctw**2*vpach**2*mh**2*mch**2-1d0/ctw**2*v
     & pach**2*mz**2*mch**2)
     & +det3izhqs*c0zhqsststst*vmaup*cfq*(-1d0/2/ctw**2*vmast**2/mz**2*m
     & h**2*mst**4+1d0/ctw**2*vmast**2*mst**4-1d0/4/ctw**2*vmast**2*mh**
     & 2*mst**2-1d0/ctw**2*vmast**2*mz**2*mst**2+1d0/2/ctw**2*vpast*vmas
     & t*mh**2*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mh**2*mst**4+1d0/ctw**
     & 2*vpast**2*mst**4-1d0/4/ctw**2*vpast**2*mh**2*mst**2-1d0/ctw**2*v
     & past**2*mz**2*mst**2)
     & +det3izhqs*c0zhqstatata*vmaup*cfl*(-1d0/2/ctw**2*vmata**2/mz**2*m
     & h**2*mta**4+1d0/ctw**2*vmata**2*mta**4-1d0/4/ctw**2*vmata**2*mh**
     & 2*mta**2-1d0/ctw**2*vmata**2*mz**2*mta**2+1d0/2/ctw**2*vpata*vmat
     & a*mh**2*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mh**2*mta**4+1d0/ctw**
     & 2*vpata**2*mta**4-1d0/4/ctw**2*vpata**2*mh**2*mta**2-1d0/ctw**2*v
     & pata**2*mz**2*mta**2)
     & +det3izhqs*c0zhqstptptp*vmaup*cfq*(-1d0/2/ctw**2*vmatp**2/mz**2*m
     & h**2*mtp**4+1d0/ctw**2*vmatp**2*mtp**4-1d0/4/ctw**2*vmatp**2*mh**
     & 2*mtp**2-1d0/ctw**2*vmatp**2*mz**2*mtp**2+1d0/2/ctw**2*vpatp*vmat
     & p*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mh**2*mtp**4+1d0/ctw**
     & 2*vpatp**2*mtp**4-1d0/4/ctw**2*vpatp**2*mh**2*mtp**2-1d0/ctw**2*v
     & patp**2*mz**2*mtp**2)
     & +det3izhqs*c0zhqsbtbtbt*vmaup*cfq*(-1d0/2/ctw**2*vmabt**2/mz**2*m
     & h**2*mbt**4+1d0/ctw**2*vmabt**2*mbt**4-1d0/4/ctw**2*vmabt**2*mh**
     & 2*mbt**2-1d0/ctw**2*vmabt**2*mz**2*mbt**2+1d0/2/ctw**2*vpabt*vmab
     & t*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mh**2*mbt**4+1d0/ctw**
     & 2*vpabt**2*mbt**4-1d0/4/ctw**2*vpabt**2*mh**2*mbt**2-1d0/ctw**2*v
     & pabt**2*mz**2*mbt**2)
     & +det3izhqs*a0fz*vmaup*(-1d0/4/ctw**2*mh**2+1d0/4/ctw**2*mz**2)
     & +det3izhqs*a0fh*vmaup*(3d0/4/ctw**2*mh**2)
     & +det3izhqs*b0fhww*vmaup*(-1d0/4/ctw**2*mh**2-3d0/2/ctw**2*mz**2+1
     & 1d0/2*mz**2-ctw**2*mh**2-4*ctw**2*mz**2-6*ctw**4*mz**2)
     & +det3izhqs*b0fhzz*vmaup*(-21d0/8/ctw**2*mh**2-17d0/4/ctw**2*mz**2
     & )
     & +det3izhqs*b0fhhh*vmaup*(33d0/8/ctw**2*mh**2+9d0/2/ctw**2*mz**2)
     & +det3izhqs*b0fhmomo*vmaup*cfl*(1d0/4/ctw**2*vmamo**2/mz**2*mh**2*
     & mmo**2+1d0/2/ctw**2*vmamo**2*mmo**2-1d0/2/ctw**2*vpamo*vmamo/mz**
     & 2*mh**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2+1d0/2/ctw
     & **2*vpamo**2*mmo**2)
     & +det3izhqs*b0fhchch*vmaup*cfq*(1d0/4/ctw**2*vmach**2/mz**2*mh**2*
     & mch**2+1d0/2/ctw**2*vmach**2*mch**2-1d0/2/ctw**2*vpach*vmach/mz**
     & 2*mh**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2+1d0/2/ctw
     & **2*vpach**2*mch**2)
     & +det3izhqs*b0fhstst*vmaup*cfq*(1d0/4/ctw**2*vmast**2/mz**2*mh**2*
     & mst**2+1d0/2/ctw**2*vmast**2*mst**2-1d0/2/ctw**2*vpast*vmast/mz**
     & 2*mh**2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2*mst**2+1d0/2/ctw
     & **2*vpast**2*mst**2)
     & +det3izhqs*b0fhtata*vmaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mh**2*
     & mta**2+1d0/2/ctw**2*vmata**2*mta**2-1d0/2/ctw**2*vpata*vmata/mz**
     & 2*mh**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta**2+1d0/2/ctw
     & **2*vpata**2*mta**2)
     & +det3izhqs*b0fhtptp*vmaup*cfq*(1d0/4/ctw**2*vmatp**2/mz**2*mh**2*
     & mtp**2+1d0/2/ctw**2*vmatp**2*mtp**2-1d0/2/ctw**2*vpatp*vmatp/mz**
     & 2*mh**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mh**2*mtp**2+1d0/2/ctw
     & **2*vpatp**2*mtp**2)
     & +det3izhqs*b0fhbtbt*vmaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mh**2*
     & mbt**2+1d0/2/ctw**2*vmabt**2*mbt**2-1d0/2/ctw**2*vpabt*vmabt/mz**
     & 2*mh**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt**2+1d0/2/ctw
     & **2*vpabt**2*mbt**2)
     & +det3izhqs*b0fzww*vmaup*(1d0/8/ctw**2*mh**2+3d0/4/ctw**2*mz**2-11
     & d0/4*mz**2+1d0/2*ctw**2*mh**2+2*ctw**2*mz**2+3*ctw**4*mz**2)
     & +det3izhqs*b0fzzh*vmaup*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fzmomo*vmaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh**2
     & *mmo**2-1d0/4/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz*
     & *2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ct
     & w**2*vpamo**2*mmo**2)
     & +det3izhqs*b0fzchch*vmaup*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh**2
     & *mch**2-1d0/4/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpach*vmach/mz*
     & *2*mh**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ct
     & w**2*vpach**2*mch**2)
     & +det3izhqs*b0fzstst*vmaup*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh**2
     & *mst**2-1d0/4/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast*vmast/mz*
     & *2*mh**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ct
     & w**2*vpast**2*mst**2)
     & +det3izhqs*b0fztata*vmaup*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh**2
     & *mta**2-1d0/4/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata*vmata/mz*
     & *2*mh**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ct
     & w**2*vpata**2*mta**2)
     & +det3izhqs*b0fztptp*vmaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh**2
     & *mtp**2-1d0/4/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz*
     & *2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ct
     & w**2*vpatp**2*mtp**2)
     & +det3izhqs*b0fzbtbt*vmaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh**2
     & *mbt**2-1d0/4/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz*
     & *2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ct
     & w**2*vpabt**2*mbt**2)
     & +det3izhqs*b0fqsww*vmaup*(1d0/8/ctw**2*mh**2+3d0/4/ctw**2*mz**2-1
     & 1d0/4*mz**2+1d0/2*ctw**2*mh**2+2*ctw**2*mz**2+3*ctw**4*mz**2)
     & +det3izhqs*b0fqszh*vmaup*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fqsmomo*vmaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh**
     & 2*mmo**2-1d0/4/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz
     & **2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/c
     & tw**2*vpamo**2*mmo**2)
     & +det3izhqs*b0fqschch*vmaup*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh**
     & 2*mch**2-1d0/4/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpach*vmach/mz
     & **2*mh**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/c
     & tw**2*vpach**2*mch**2)
     & +det3izhqs*b0fqsstst*vmaup*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh**
     & 2*mst**2-1d0/4/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast*vmast/mz
     & **2*mh**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/c
     & tw**2*vpast**2*mst**2)
     & +det3izhqs*b0fqstata*vmaup*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh**
     & 2*mta**2-1d0/4/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata*vmata/mz
     & **2*mh**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/c
     & tw**2*vpata**2*mta**2)
     & +det3izhqs*b0fqstptp*vmaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh**
     & 2*mtp**2-1d0/4/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz
     & **2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/c
     & tw**2*vpatp**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*vmaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh**
     & 2*mbt**2-1d0/4/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz
     & **2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/c
     & tw**2*vpabt**2*mbt**2)
     & +c0zhqswww*vmaup*(-1-4*ctw**2+12*ctw**4)
     & +c0zhqszhh*vmaup*(-3/ctw**2/mz**2*mh**2-21d0/2/ctw**2)
     & +c0zhqshzz*vmaup*(-3d0/2/ctw**2/mz**2*mh**2-13/ctw**2)
     & +c0zhqsmomomo*vmaup*cfl*(-1d0/ctw**2*vpamo*vmamo/mz**2*mmo**2)
     & +c0zhqschchch*vmaup*cfq*(-1d0/ctw**2*vpach*vmach/mz**2*mch**2)
     & +c0zhqsststst*vmaup*cfq*(-1d0/ctw**2*vpast*vmast/mz**2*mst**2)
     & +c0zhqstatata*vmaup*cfl*(-1d0/ctw**2*vpata*vmata/mz**2*mta**2)
     & +c0zhqstptptp*vmaup*cfq*(-1d0/ctw**2*vpatp*vmatp/mz**2*mtp**2)
     & +c0zhqsbtbtbt*vmaup*cfq*(-1d0/ctw**2*vpabt*vmabt/mz**2*mbt**2)
     & +a0fh*vmaup*(-1d0/ctw**2/mz**2)
     & +b0fhzz*vmaup*(1d0/ctw**2/mz**2)
     & +b0fhhh*vmaup*(-3/ctw**2/mz**2)
     & +b0fzzh*vmaup*(1d0/2/ctw**2/mz**2)
     & +b0fqszh*vmaup*(1d0/2/ctw**2/mz**2)

      ffgm2=
     & +vmaup*(3d0/2/ctw**2/mz**2-2/mz**2+2*ctw**2/mz**2)
     & +propizqs*qup/qs*(-2/mz**2+6*ctw**2/mz**2-4*ctw**4/mz**2)
     & +propizqs*det3izhqs*vmaup*(-3d0/4+3d0/8/ctw**2/mz**2*mh**2+1d0/4/
     & ctw**2-1d0/2/mz**2*mh**2+1d0/2*ctw**2/mz**2*mh**2+3d0/2*ctw**2-3*
     & ctw**4)
     & +propizqs*det3izhqs*vmaup*qs*(3d0/8/ctw**2/mz**2-1d0/2/mz**2+1d0/
     & 2*ctw**2/mz**2)
     & +propizqs*det3izhqs*vmaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mbt**2
     & +1d0/4/ctw**2*vpabt**2/mz**2*mbt**2+1d0/4/ctw**2*vmatp**2/mz**2*m
     & tp**2+1d0/4/ctw**2*vpatp**2/mz**2*mtp**2+1d0/4/ctw**2*vmast**2/mz
     & **2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mst**2+1d0/4/ctw**2*vmach*
     & *2/mz**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*vmaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mta**2
     & +1d0/4/ctw**2*vpata**2/mz**2*mta**2+1d0/4/ctw**2*vmamo**2/mz**2*m
     & mo**2+1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*qup/qs*(1d0/2*mh**2-1d0/2*mz**2-1d0/2*ctw**2*
     & mh**2+1d0/2*ctw**2*mz**2-6*ctw**4*mh**2+6*ctw**4*mz**2+6*ctw**6*m
     & h**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*qup*(-1-1d0/2/mz**2*mh**2+3d0/2*ctw**2/mz**2*
     & mh**2+4*ctw**2-ctw**4/mz**2*mh**2-9*ctw**4+6*ctw**6)
     & +propizqs*det3izhqs*qup*qs*(-1d0/2/mz**2+3d0/2*ctw**2/mz**2-ctw**
     & 4/mz**2)
     & +propizqs*det3izhqs*qup*cfq/qs*(qbt*vmabt/mz**2*mh**2*mbt**2-qbt*
     & vmabt*mbt**2+qbt*vpabt/mz**2*mh**2*mbt**2-qbt*vpabt*mbt**2+qtp*vm
     & atp/mz**2*mh**2*mtp**2-qtp*vmatp*mtp**2+qtp*vpatp/mz**2*mh**2*mtp
     & **2-qtp*vpatp*mtp**2+qst*vmast/mz**2*mh**2*mst**2-qst*vmast*mst**
     & 2+qst*vpast/mz**2*mh**2*mst**2-qst*vpast*mst**2+qch*vmach/mz**2*m
     & h**2*mch**2-qch*vmach*mch**2+qch*vpach/mz**2*mh**2*mch**2-qch*vpa
     & ch*mch**2-ctw**2*qbt*vmabt/mz**2*mh**2*mbt**2+ctw**2*qbt*vmabt*mb
     & t**2-ctw**2*qbt*vpabt/mz**2*mh**2*mbt**2+ctw**2*qbt*vpabt*mbt**2-
     & ctw**2*qtp*vmatp/mz**2*mh**2*mtp**2+ctw**2*qtp*vmatp*mtp**2-ctw**
     & 2*qtp*vpatp/mz**2*mh**2*mtp**2+ctw**2*qtp*vpatp*mtp**2-ctw**2*qst
     & *vmast/mz**2*mh**2*mst**2+ctw**2*qst*vmast*mst**2-ctw**2*qst*vpas
     & t/mz**2*mh**2*mst**2+ctw**2*qst*vpast*mst**2-ctw**2*qch*vmach/mz*
     & *2*mh**2*mch**2+ctw**2*qch*vmach*mch**2-ctw**2*qch*vpach/mz**2*mh
     & **2*mch**2+ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*qup*cfq*(qbt*vmabt/mz**2*mbt**2+qbt*vpabt/mz*
     & *2*mbt**2+qtp*vmatp/mz**2*mtp**2+qtp*vpatp/mz**2*mtp**2+qst*vmast
     & /mz**2*mst**2+qst*vpast/mz**2*mst**2+qch*vmach/mz**2*mch**2+qch*v
     & pach/mz**2*mch**2-ctw**2*qbt*vmabt/mz**2*mbt**2-ctw**2*qbt*vpabt/
     & mz**2*mbt**2-ctw**2*qtp*vmatp/mz**2*mtp**2-ctw**2*qtp*vpatp/mz**2
     & *mtp**2-ctw**2*qst*vmast/mz**2*mst**2-ctw**2*qst*vpast/mz**2*mst*
     & *2-ctw**2*qch*vmach/mz**2*mch**2-ctw**2*qch*vpach/mz**2*mch**2)
     & +propizqs*det3izhqs*qup*cfl/qs*(qta*vmata/mz**2*mh**2*mta**2-qta*
     & vmata*mta**2+qta*vpata/mz**2*mh**2*mta**2-qta*vpata*mta**2+qmo*vm
     & amo/mz**2*mh**2*mmo**2-qmo*vmamo*mmo**2+qmo*vpamo/mz**2*mh**2*mmo
     & **2-qmo*vpamo*mmo**2-ctw**2*qta*vmata/mz**2*mh**2*mta**2+ctw**2*q
     & ta*vmata*mta**2-ctw**2*qta*vpata/mz**2*mh**2*mta**2+ctw**2*qta*vp
     & ata*mta**2-ctw**2*qmo*vmamo/mz**2*mh**2*mmo**2+ctw**2*qmo*vmamo*m
     & mo**2-ctw**2*qmo*vpamo/mz**2*mh**2*mmo**2+ctw**2*qmo*vpamo*mmo**2
     & )
     & +propizqs*det3izhqs*qup*cfl*(qta*vmata/mz**2*mta**2+qta*vpata/mz*
     & *2*mta**2+qmo*vmamo/mz**2*mmo**2+qmo*vpamo/mz**2*mmo**2-ctw**2*qt
     & a*vmata/mz**2*mta**2-ctw**2*qta*vpata/mz**2*mta**2-ctw**2*qmo*vma
     & mo/mz**2*mmo**2-ctw**2*qmo*vpamo/mz**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqswww*vmaup*(3d0/16/ctw**2*mh**6+15d0/
     & 16/ctw**2*mz**4*mh**2+3d0/8/ctw**2*mz**6-3d0/4*mh**6+3d0/8*mz**2*
     & mh**4-15d0/4*mz**4*mh**2-9d0/8*mz**6+3d0/4*ctw**2*mh**6-3d0/2*ctw
     & **2*mz**2*mh**4+15d0/4*ctw**2*mz**4*mh**2+9d0/2*ctw**4*mz**2*mh**
     & 4+9d0/2*ctw**4*mz**6)
     & +propizqs*det3izhqs**2*c0zhqswww*vmaup*qs*(3d0/16/ctw**2*mh**4+3d
     & 0/16/ctw**2*mz**2*mh**2+3d0/8/ctw**2*mz**4-3d0/4*mh**4-3d0/8*mz**
     & 2*mh**2-9d0/8*mz**4+3d0/4*ctw**2*mh**4-3d0/4*ctw**2*mz**2*mh**2+9
     & d0/2*ctw**4*mz**2*mh**2+9d0/2*ctw**4*mz**4)
     & +propizqs*det3izhqs**2*c0zhqswww*qup*(-3d0/4*mh**6+3d0/4*mz**2*mh
     & **4+9d0/4*ctw**2*mh**6-15d0/4*ctw**2*mz**2*mh**4+3d0/2*ctw**2*mz*
     & *4*mh**2-3d0/2*ctw**4*mh**6+12*ctw**4*mz**2*mh**4-21d0/2*ctw**4*m
     & z**4*mh**2-9*ctw**6*mz**2*mh**4+9*ctw**6*mz**4*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qup*qs*(-3d0/4*mh**4+9d0/4*ctw**
     & 2*mh**4-3d0/2*ctw**2*mz**2*mh**2-3d0/2*ctw**4*mh**4+21d0/2*ctw**4
     & *mz**2*mh**2-9*ctw**6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*c0zhqszhh*vmaup*(9d0/32/ctw**2/mz**2*mh**8
     & +45d0/32/ctw**2*mz**2*mh**4+81d0/16/ctw**2*mz**4*mh**2+9d0/4/ctw*
     & *2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqszhh*vmaup*qs*(9d0/32/ctw**2/mz**2*mh
     & **6+9d0/32/ctw**2*mh**4+9d0/16/ctw**2*mz**2*mh**2+9d0/4/ctw**2*mz
     & **4)
     & +propizqs*det3izhqs**2*c0zhqshzz*vmaup*(3d0/32/ctw**2/mz**2*mh**8
     & +15d0/16/ctw**2*mh**6+87d0/32/ctw**2*mz**2*mh**4+75d0/8/ctw**2*mz
     & **4*mh**2+39d0/8/ctw**2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqshzz*vmaup*qs*(3d0/32/ctw**2/mz**2*mh
     & **6+9d0/32/ctw**2*mh**4+9d0/8/ctw**2*mz**2*mh**2+39d0/8/ctw**2*mz
     & **4)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vmaup*cfl*(-3d0/8/ctw**2*vmam
     & o**2*mh**4*mmo**2-3d0/8/ctw**2*vmamo**2*mz**4*mmo**2-3d0/8/ctw**2
     & *vpamo**2*mh**4*mmo**2-3d0/8/ctw**2*vpamo**2*mz**4*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vmaup*cfl*qs*(-3d0/8/ctw**2*v
     & mamo**2*mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mz**2*mmo**2-3d0/8/ctw
     & **2*vpamo**2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qup*cfl*(-3d0/2*qmo*vmamo*mh*
     & *4*mmo**2+3d0/2*qmo*vmamo*mz**2*mh**2*mmo**2-3d0/2*qmo*vpamo*mh**
     & 4*mmo**2+3d0/2*qmo*vpamo*mz**2*mh**2*mmo**2+3d0/2*ctw**2*qmo*vmam
     & o*mh**4*mmo**2-3d0/2*ctw**2*qmo*vmamo*mz**2*mh**2*mmo**2+3d0/2*ct
     & w**2*qmo*vpamo*mh**4*mmo**2-3d0/2*ctw**2*qmo*vpamo*mz**2*mh**2*mm
     & o**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qup*cfl*qs*(-3d0/2*qmo*vmamo*
     & mh**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*
     & mh**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vmaup*cfq*(-3d0/8/ctw**2*vmac
     & h**2*mh**4*mch**2-3d0/8/ctw**2*vmach**2*mz**4*mch**2-3d0/8/ctw**2
     & *vpach**2*mh**4*mch**2-3d0/8/ctw**2*vpach**2*mz**4*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vmaup*cfq*qs*(-3d0/8/ctw**2*v
     & mach**2*mh**2*mch**2-3d0/8/ctw**2*vmach**2*mz**2*mch**2-3d0/8/ctw
     & **2*vpach**2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*mz**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qup*cfq*(-3d0/2*qch*vmach*mh*
     & *4*mch**2+3d0/2*qch*vmach*mz**2*mh**2*mch**2-3d0/2*qch*vpach*mh**
     & 4*mch**2+3d0/2*qch*vpach*mz**2*mh**2*mch**2+3d0/2*ctw**2*qch*vmac
     & h*mh**4*mch**2-3d0/2*ctw**2*qch*vmach*mz**2*mh**2*mch**2+3d0/2*ct
     & w**2*qch*vpach*mh**4*mch**2-3d0/2*ctw**2*qch*vpach*mz**2*mh**2*mc
     & h**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qup*cfq*qs*(-3d0/2*qch*vmach*
     & mh**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2+3d0/2*ctw**2*qch*vmach*
     & mh**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vmaup*cfq*(-3d0/8/ctw**2*vmas
     & t**2*mh**4*mst**2-3d0/8/ctw**2*vmast**2*mz**4*mst**2-3d0/8/ctw**2
     & *vpast**2*mh**4*mst**2-3d0/8/ctw**2*vpast**2*mz**4*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vmaup*cfq*qs*(-3d0/8/ctw**2*v
     & mast**2*mh**2*mst**2-3d0/8/ctw**2*vmast**2*mz**2*mst**2-3d0/8/ctw
     & **2*vpast**2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*mz**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qup*cfq*(-3d0/2*qst*vmast*mh*
     & *4*mst**2+3d0/2*qst*vmast*mz**2*mh**2*mst**2-3d0/2*qst*vpast*mh**
     & 4*mst**2+3d0/2*qst*vpast*mz**2*mh**2*mst**2+3d0/2*ctw**2*qst*vmas
     & t*mh**4*mst**2-3d0/2*ctw**2*qst*vmast*mz**2*mh**2*mst**2+3d0/2*ct
     & w**2*qst*vpast*mh**4*mst**2-3d0/2*ctw**2*qst*vpast*mz**2*mh**2*ms
     & t**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qup*cfq*qs*(-3d0/2*qst*vmast*
     & mh**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2+3d0/2*ctw**2*qst*vmast*
     & mh**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vmaup*cfl*(-3d0/8/ctw**2*vmat
     & a**2*mh**4*mta**2-3d0/8/ctw**2*vmata**2*mz**4*mta**2-3d0/8/ctw**2
     & *vpata**2*mh**4*mta**2-3d0/8/ctw**2*vpata**2*mz**4*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vmaup*cfl*qs*(-3d0/8/ctw**2*v
     & mata**2*mh**2*mta**2-3d0/8/ctw**2*vmata**2*mz**2*mta**2-3d0/8/ctw
     & **2*vpata**2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*mz**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qup*cfl*(-3d0/2*qta*vmata*mh*
     & *4*mta**2+3d0/2*qta*vmata*mz**2*mh**2*mta**2-3d0/2*qta*vpata*mh**
     & 4*mta**2+3d0/2*qta*vpata*mz**2*mh**2*mta**2+3d0/2*ctw**2*qta*vmat
     & a*mh**4*mta**2-3d0/2*ctw**2*qta*vmata*mz**2*mh**2*mta**2+3d0/2*ct
     & w**2*qta*vpata*mh**4*mta**2-3d0/2*ctw**2*qta*vpata*mz**2*mh**2*mt
     & a**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qup*cfl*qs*(-3d0/2*qta*vmata*
     & mh**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2+3d0/2*ctw**2*qta*vmata*
     & mh**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vmaup*cfq*(-3d0/8/ctw**2*vmat
     & p**2*mh**4*mtp**2-3d0/8/ctw**2*vmatp**2*mz**4*mtp**2-3d0/8/ctw**2
     & *vpatp**2*mh**4*mtp**2-3d0/8/ctw**2*vpatp**2*mz**4*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vmaup*cfq*qs*(-3d0/8/ctw**2*v
     & matp**2*mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mz**2*mtp**2-3d0/8/ctw
     & **2*vpatp**2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qup*cfq*(-3d0/2*qtp*vmatp*mh*
     & *4*mtp**2+3d0/2*qtp*vmatp*mz**2*mh**2*mtp**2-3d0/2*qtp*vpatp*mh**
     & 4*mtp**2+3d0/2*qtp*vpatp*mz**2*mh**2*mtp**2+3d0/2*ctw**2*qtp*vmat
     & p*mh**4*mtp**2-3d0/2*ctw**2*qtp*vmatp*mz**2*mh**2*mtp**2+3d0/2*ct
     & w**2*qtp*vpatp*mh**4*mtp**2-3d0/2*ctw**2*qtp*vpatp*mz**2*mh**2*mt
     & p**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qup*cfq*qs*(-3d0/2*qtp*vmatp*
     & mh**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*
     & mh**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vmaup*cfq*(-3d0/8/ctw**2*vmab
     & t**2*mh**4*mbt**2-3d0/8/ctw**2*vmabt**2*mz**4*mbt**2-3d0/8/ctw**2
     & *vpabt**2*mh**4*mbt**2-3d0/8/ctw**2*vpabt**2*mz**4*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vmaup*cfq*qs*(-3d0/8/ctw**2*v
     & mabt**2*mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mz**2*mbt**2-3d0/8/ctw
     & **2*vpabt**2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh*
     & *4*mbt**2+3d0/2*qbt*vmabt*mz**2*mh**2*mbt**2-3d0/2*qbt*vpabt*mh**
     & 4*mbt**2+3d0/2*qbt*vpabt*mz**2*mh**2*mbt**2+3d0/2*ctw**2*qbt*vmab
     & t*mh**4*mbt**2-3d0/2*ctw**2*qbt*vmabt*mz**2*mh**2*mbt**2+3d0/2*ct
     & w**2*qbt*vpabt*mh**4*mbt**2-3d0/2*ctw**2*qbt*vpabt*mz**2*mh**2*mb
     & t**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qup*cfq*qs*(-3d0/2*qbt*vmabt*
     & mh**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*
     & mh**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhww*vmaup*(-3d0/8/ctw**2*mh**4-3d0/4/ct
     & w**2*mz**2*mh**2-3d0/8/ctw**2*mz**4+3d0/2*mh**4+9d0/4*mz**2*mh**2
     & +3d0/2*mz**4-3d0/2*ctw**2*mh**4-3d0/2*ctw**2*mz**4-9*ctw**4*mz**2
     & *mh**2)
     & +propizqs*det3izhqs**2*b0fhww*vmaup*qs*(-3d0/8/ctw**2*mz**2+3d0/2
     & *mz**2-3d0/2*ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhww*qup*(3d0/2*mh**4-9d0/2*ctw**2*mh**4
     & +3*ctw**2*mz**2*mh**2+3*ctw**4*mh**4-21*ctw**4*mz**2*mh**2+18*ctw
     & **6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhzz*vmaup*(-3d0/32/ctw**2/mz**2*mh**6-3
     & d0/4/ctw**2*mh**4-87d0/32/ctw**2*mz**2*mh**2-15d0/16/ctw**2*mz**4
     & )
     & +propizqs*det3izhqs**2*b0fhzz*vmaup*qs*(-3d0/32/ctw**2/mz**2*mh**
     & 4-9d0/32/ctw**2*mh**2-15d0/16/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhhh*vmaup*(9d0/32/ctw**2/mz**2*mh**6+9d
     & 0/16/ctw**2*mh**4+81d0/32/ctw**2*mz**2*mh**2+9d0/8/ctw**2*mz**4)
     & +propizqs*det3izhqs**2*b0fhhh*vmaup*qs*(9d0/32/ctw**2/mz**2*mh**4
     & +9d0/32/ctw**2*mh**2+9d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fhmomo*vmaup*cfl*(3d0/4/ctw**2*vmamo**2*
     & mh**2*mmo**2+3d0/4/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhmomo*qup*cfl*(3*qmo*vmamo*mh**2*mmo**2
     & +3*qmo*vpamo*mh**2*mmo**2-3*ctw**2*qmo*vmamo*mh**2*mmo**2-3*ctw**
     & 2*qmo*vpamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhchch*vmaup*cfq*(3d0/4/ctw**2*vmach**2*
     & mh**2*mch**2+3d0/4/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhchch*qup*cfq*(3*qch*vmach*mh**2*mch**2
     & +3*qch*vpach*mh**2*mch**2-3*ctw**2*qch*vmach*mh**2*mch**2-3*ctw**
     & 2*qch*vpach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhstst*vmaup*cfq*(3d0/4/ctw**2*vmast**2*
     & mh**2*mst**2+3d0/4/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhstst*qup*cfq*(3*qst*vmast*mh**2*mst**2
     & +3*qst*vpast*mh**2*mst**2-3*ctw**2*qst*vmast*mh**2*mst**2-3*ctw**
     & 2*qst*vpast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhtata*vmaup*cfl*(3d0/4/ctw**2*vmata**2*
     & mh**2*mta**2+3d0/4/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtata*qup*cfl*(3*qta*vmata*mh**2*mta**2
     & +3*qta*vpata*mh**2*mta**2-3*ctw**2*qta*vmata*mh**2*mta**2-3*ctw**
     & 2*qta*vpata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtptp*vmaup*cfq*(3d0/4/ctw**2*vmatp**2*
     & mh**2*mtp**2+3d0/4/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhtptp*qup*cfq*(3*qtp*vmatp*mh**2*mtp**2
     & +3*qtp*vpatp*mh**2*mtp**2-3*ctw**2*qtp*vmatp*mh**2*mtp**2-3*ctw**
     & 2*qtp*vpatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*vmaup*cfq*(3d0/4/ctw**2*vmabt**2*
     & mh**2*mbt**2+3d0/4/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*qup*cfq*(3*qbt*vmabt*mh**2*mbt**2
     & +3*qbt*vpabt*mh**2*mbt**2-3*ctw**2*qbt*vmabt*mh**2*mbt**2-3*ctw**
     & 2*qbt*vpabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzww*vmaup*(3d0/16/ctw**2*mh**4+3d0/8/ct
     & w**2*mz**2*mh**2+3d0/16/ctw**2*mz**4-3d0/4*mh**4-9d0/8*mz**2*mh**
     & 2-3d0/4*mz**4+3d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**4+9d0/2*ctw**4*
     & mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fzww*vmaup*qs*(3d0/16/ctw**2*mh**2+3d0/1
     & 6/ctw**2*mz**2-3d0/4*mh**2-3d0/8*mz**2+3d0/4*ctw**2*mh**2-3d0/4*c
     & tw**2*mz**2+9d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs**2*b0fzww*qup*(-3d0/4*mh**4-3d0/4*mz**2*mh**2
     & +9d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**2*mh**2-3d0/2*ctw**2*mz**4-3
     & d0/2*ctw**4*mh**4+9*ctw**4*mz**2*mh**2+21d0/2*ctw**4*mz**4-9*ctw*
     & *6*mz**2*mh**2-9*ctw**6*mz**4)
     & +propizqs*det3izhqs**2*b0fzww*qup*qs*(-3d0/4*mh**2+9d0/4*ctw**2*m
     & h**2-3d0/2*ctw**2*mz**2-3d0/2*ctw**4*mh**2+21d0/2*ctw**4*mz**2-9*
     & ctw**6*mz**2)
     & +propizqs*det3izhqs**2*b0fzzh*vmaup*(-3d0/16/ctw**2*mh**4+3d0/8/c
     & tw**2*mz**2*mh**2-3d0/16/ctw**2*mz**4)
     & +propizqs*det3izhqs**2*b0fzzh*vmaup*qs*(3d0/16/ctw**2*mh**2+3d0/1
     & 6/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vmaup*cfl*(-3d0/8/ctw**2*vmamo**2
     & *mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vmaup*cfl*qs*(-3d0/8/ctw**2*vmamo
     & **2*mmo**2-3d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qup*cfl*(-3d0/2*qmo*vmamo*mh**2*m
     & mo**2-3d0/2*qmo*vmamo*mz**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2-3
     & d0/2*qmo*vpamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*mh**2*mmo**2+3
     & d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*m
     & mo**2+3d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qup*cfl*qs*(-3d0/2*qmo*vmamo*mmo*
     & *2-3d0/2*qmo*vpamo*mmo**2+3d0/2*ctw**2*qmo*vmamo*mmo**2+3d0/2*ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fzchch*vmaup*cfq*(-3d0/8/ctw**2*vmach**2
     & *mh**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vmaup*cfq*qs*(-3d0/8/ctw**2*vmach
     & **2*mch**2-3d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qup*cfq*(-3d0/2*qch*vmach*mh**2*m
     & ch**2-3d0/2*qch*vmach*mz**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2-3
     & d0/2*qch*vpach*mz**2*mch**2+3d0/2*ctw**2*qch*vmach*mh**2*mch**2+3
     & d0/2*ctw**2*qch*vmach*mz**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*m
     & ch**2+3d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qup*cfq*qs*(-3d0/2*qch*vmach*mch*
     & *2-3d0/2*qch*vpach*mch**2+3d0/2*ctw**2*qch*vmach*mch**2+3d0/2*ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs**2*b0fzstst*vmaup*cfq*(-3d0/8/ctw**2*vmast**2
     & *mh**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vmaup*cfq*qs*(-3d0/8/ctw**2*vmast
     & **2*mst**2-3d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qup*cfq*(-3d0/2*qst*vmast*mh**2*m
     & st**2-3d0/2*qst*vmast*mz**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2-3
     & d0/2*qst*vpast*mz**2*mst**2+3d0/2*ctw**2*qst*vmast*mh**2*mst**2+3
     & d0/2*ctw**2*qst*vmast*mz**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*m
     & st**2+3d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qup*cfq*qs*(-3d0/2*qst*vmast*mst*
     & *2-3d0/2*qst*vpast*mst**2+3d0/2*ctw**2*qst*vmast*mst**2+3d0/2*ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs**2*b0fztata*vmaup*cfl*(-3d0/8/ctw**2*vmata**2
     & *mh**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vmaup*cfl*qs*(-3d0/8/ctw**2*vmata
     & **2*mta**2-3d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qup*cfl*(-3d0/2*qta*vmata*mh**2*m
     & ta**2-3d0/2*qta*vmata*mz**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2-3
     & d0/2*qta*vpata*mz**2*mta**2+3d0/2*ctw**2*qta*vmata*mh**2*mta**2+3
     & d0/2*ctw**2*qta*vmata*mz**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*m
     & ta**2+3d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qup*cfl*qs*(-3d0/2*qta*vmata*mta*
     & *2-3d0/2*qta*vpata*mta**2+3d0/2*ctw**2*qta*vmata*mta**2+3d0/2*ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs**2*b0fztptp*vmaup*cfq*(-3d0/8/ctw**2*vmatp**2
     & *mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vmaup*cfq*qs*(-3d0/8/ctw**2*vmatp
     & **2*mtp**2-3d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qup*cfq*(-3d0/2*qtp*vmatp*mh**2*m
     & tp**2-3d0/2*qtp*vmatp*mz**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2-3
     & d0/2*qtp*vpatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*mh**2*mtp**2+3
     & d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*m
     & tp**2+3d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qup*cfq*qs*(-3d0/2*qtp*vmatp*mtp*
     & *2-3d0/2*qtp*vpatp*mtp**2+3d0/2*ctw**2*qtp*vmatp*mtp**2+3d0/2*ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vmaup*cfq*(-3d0/8/ctw**2*vmabt**2
     & *mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vmaup*cfq*qs*(-3d0/8/ctw**2*vmabt
     & **2*mbt**2-3d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh**2*m
     & bt**2-3d0/2*qbt*vmabt*mz**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2-3
     & d0/2*qbt*vpabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*mh**2*mbt**2+3
     & d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*m
     & bt**2+3d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qup*cfq*qs*(-3d0/2*qbt*vmabt*mbt*
     & *2-3d0/2*qbt*vpabt*mbt**2+3d0/2*ctw**2*qbt*vmabt*mbt**2+3d0/2*ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsww*vmaup*(3d0/16/ctw**2*mh**4+3d0/8/c
     & tw**2*mz**2*mh**2+3d0/16/ctw**2*mz**4-3d0/4*mh**4-9d0/8*mz**2*mh*
     & *2-3d0/4*mz**4+3d0/4*ctw**2*mh**4+3d0/4*ctw**2*mz**4+9d0/2*ctw**4
     & *mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqsww*vmaup*qs*(-3d0/16/ctw**2*mh**2+3d0
     & /16/ctw**2*mz**2+3d0/4*mh**2-9d0/8*mz**2-3d0/4*ctw**2*mh**2+9d0/4
     & *ctw**2*mz**2-9d0/2*ctw**4*mz**2)
     & +propizqs*det3izhqs**2*b0fqsww*qup*(-3d0/4*mh**4+3d0/4*mz**2*mh**
     & 2+9d0/4*ctw**2*mh**4-15d0/4*ctw**2*mz**2*mh**2+3d0/2*ctw**2*mz**4
     & -3d0/2*ctw**4*mh**4+12*ctw**4*mz**2*mh**2-21d0/2*ctw**4*mz**4-9*c
     & tw**6*mz**2*mh**2+9*ctw**6*mz**4)
     & +propizqs*det3izhqs**2*b0fqsww*qup*qs*(3d0/4*mh**2-9d0/4*ctw**2*m
     & h**2+3d0/2*ctw**2*mz**2+3d0/2*ctw**4*mh**2-21d0/2*ctw**4*mz**2+9*
     & ctw**6*mz**2)
     & +propizqs*det3izhqs**2*b0fqszh*vmaup*(-3d0/16/ctw**2/mz**2*mh**6+
     & 3d0/8/ctw**2*mh**4-3d0/16/ctw**2*mz**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqszh*vmaup*qs*(-3d0/16/ctw**2/mz**2*mh*
     & *4-3d0/16/ctw**2*mh**2-3d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vmaup*cfl*(-3d0/8/ctw**2*vmamo**
     & 2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vmaup*cfl*qs*(3d0/8/ctw**2*vmamo
     & **2*mmo**2+3d0/8/ctw**2*vpamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qup*cfl*(-3d0/2*qmo*vmamo*mh**2*
     & mmo**2+3d0/2*qmo*vmamo*mz**2*mmo**2-3d0/2*qmo*vpamo*mh**2*mmo**2+
     & 3d0/2*qmo*vpamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vmamo*mh**2*mmo**2-
     & 3d0/2*ctw**2*qmo*vmamo*mz**2*mmo**2+3d0/2*ctw**2*qmo*vpamo*mh**2*
     & mmo**2-3d0/2*ctw**2*qmo*vpamo*mz**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qup*cfl*qs*(3d0/2*qmo*vmamo*mmo*
     & *2+3d0/2*qmo*vpamo*mmo**2-3d0/2*ctw**2*qmo*vmamo*mmo**2-3d0/2*ctw
     & **2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fqschch*vmaup*cfq*(-3d0/8/ctw**2*vmach**
     & 2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vmaup*cfq*qs*(3d0/8/ctw**2*vmach
     & **2*mch**2+3d0/8/ctw**2*vpach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qup*cfq*(-3d0/2*qch*vmach*mh**2*
     & mch**2+3d0/2*qch*vmach*mz**2*mch**2-3d0/2*qch*vpach*mh**2*mch**2+
     & 3d0/2*qch*vpach*mz**2*mch**2+3d0/2*ctw**2*qch*vmach*mh**2*mch**2-
     & 3d0/2*ctw**2*qch*vmach*mz**2*mch**2+3d0/2*ctw**2*qch*vpach*mh**2*
     & mch**2-3d0/2*ctw**2*qch*vpach*mz**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qup*cfq*qs*(3d0/2*qch*vmach*mch*
     & *2+3d0/2*qch*vpach*mch**2-3d0/2*ctw**2*qch*vmach*mch**2-3d0/2*ctw
     & **2*qch*vpach*mch**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vmaup*cfq*(-3d0/8/ctw**2*vmast**
     & 2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vmaup*cfq*qs*(3d0/8/ctw**2*vmast
     & **2*mst**2+3d0/8/ctw**2*vpast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qup*cfq*(-3d0/2*qst*vmast*mh**2*
     & mst**2+3d0/2*qst*vmast*mz**2*mst**2-3d0/2*qst*vpast*mh**2*mst**2+
     & 3d0/2*qst*vpast*mz**2*mst**2+3d0/2*ctw**2*qst*vmast*mh**2*mst**2-
     & 3d0/2*ctw**2*qst*vmast*mz**2*mst**2+3d0/2*ctw**2*qst*vpast*mh**2*
     & mst**2-3d0/2*ctw**2*qst*vpast*mz**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qup*cfq*qs*(3d0/2*qst*vmast*mst*
     & *2+3d0/2*qst*vpast*mst**2-3d0/2*ctw**2*qst*vmast*mst**2-3d0/2*ctw
     & **2*qst*vpast*mst**2)
     & +propizqs*det3izhqs**2*b0fqstata*vmaup*cfl*(-3d0/8/ctw**2*vmata**
     & 2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vmaup*cfl*qs*(3d0/8/ctw**2*vmata
     & **2*mta**2+3d0/8/ctw**2*vpata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qup*cfl*(-3d0/2*qta*vmata*mh**2*
     & mta**2+3d0/2*qta*vmata*mz**2*mta**2-3d0/2*qta*vpata*mh**2*mta**2+
     & 3d0/2*qta*vpata*mz**2*mta**2+3d0/2*ctw**2*qta*vmata*mh**2*mta**2-
     & 3d0/2*ctw**2*qta*vmata*mz**2*mta**2+3d0/2*ctw**2*qta*vpata*mh**2*
     & mta**2-3d0/2*ctw**2*qta*vpata*mz**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qup*cfl*qs*(3d0/2*qta*vmata*mta*
     & *2+3d0/2*qta*vpata*mta**2-3d0/2*ctw**2*qta*vmata*mta**2-3d0/2*ctw
     & **2*qta*vpata*mta**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vmaup*cfq*(-3d0/8/ctw**2*vmatp**
     & 2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vmaup*cfq*qs*(3d0/8/ctw**2*vmatp
     & **2*mtp**2+3d0/8/ctw**2*vpatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qup*cfq*(-3d0/2*qtp*vmatp*mh**2*
     & mtp**2+3d0/2*qtp*vmatp*mz**2*mtp**2-3d0/2*qtp*vpatp*mh**2*mtp**2+
     & 3d0/2*qtp*vpatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vmatp*mh**2*mtp**2-
     & 3d0/2*ctw**2*qtp*vmatp*mz**2*mtp**2+3d0/2*ctw**2*qtp*vpatp*mh**2*
     & mtp**2-3d0/2*ctw**2*qtp*vpatp*mz**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qup*cfq*qs*(3d0/2*qtp*vmatp*mtp*
     & *2+3d0/2*qtp*vpatp*mtp**2-3d0/2*ctw**2*qtp*vmatp*mtp**2-3d0/2*ctw
     & **2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vmaup*cfq*(-3d0/8/ctw**2*vmabt**
     & 2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vmaup*cfq*qs*(3d0/8/ctw**2*vmabt
     & **2*mbt**2+3d0/8/ctw**2*vpabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qup*cfq*(-3d0/2*qbt*vmabt*mh**2*
     & mbt**2+3d0/2*qbt*vmabt*mz**2*mbt**2-3d0/2*qbt*vpabt*mh**2*mbt**2+
     & 3d0/2*qbt*vpabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vmabt*mh**2*mbt**2-
     & 3d0/2*ctw**2*qbt*vmabt*mz**2*mbt**2+3d0/2*ctw**2*qbt*vpabt*mh**2*
     & mbt**2-3d0/2*ctw**2*qbt*vpabt*mz**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qup*cfq*qs*(3d0/2*qbt*vmabt*mbt*
     & *2+3d0/2*qbt*vpabt*mbt**2-3d0/2*ctw**2*qbt*vmabt*mbt**2-3d0/2*ctw
     & **2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*c0zhqswww*vmaup*(1d0/4/ctw**2*mh**2-7d0/4*mh*
     & *2-1d0/4*mz**2+2*ctw**2*mh**2-1d0/2*ctw**2*mz**2-ctw**4*mh**2+3*c
     & tw**4*mz**2+6*ctw**6*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*vmaup*qs*(-3d0/4+ctw**2-ctw**4)
     & +propizqs*det3izhqs*c0zhqswww*qup/qs*(-ctw**2*mz**2*mh**2+ctw**2*
     & mz**4+ctw**4*mz**2*mh**2-ctw**4*mz**4+12*ctw**6*mz**2*mh**2-12*ct
     & w**6*mz**4-12*ctw**8*mz**2*mh**2+12*ctw**8*mz**4)
     & +propizqs*det3izhqs*c0zhqswww*qup*(-mh**2+4*ctw**2*mh**2-5*ctw**4
     & *mh**2+6*ctw**4*mz**2+2*ctw**6*mh**2+6*ctw**6*mz**2-12*ctw**8*mz*
     & *2)
     & +propizqs*det3izhqs*c0zhqswww*qup*qs*(ctw**2-3*ctw**4+2*ctw**6)
     & +propizqs*det3izhqs*c0zhqszhh*vmaup*(-3d0/4/ctw**2/mz**2*mh**4-6/
     & ctw**2*mh**2-21d0/8/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqszhh*vmaup*qs*(-3d0/4/ctw**2/mz**2*mh**2
     & -21d0/8/ctw**2)
     & +propizqs*det3izhqs*c0zhqshzz*vmaup*(-7d0/8/ctw**2/mz**2*mh**4-7/
     & ctw**2*mh**2-11d0/4/ctw**2*mz**2)
     & +propizqs*det3izhqs*c0zhqshzz*vmaup*qs*(-3d0/8/ctw**2/mz**2*mh**2
     & -7d0/2/ctw**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vmaup*cfl*(-1d0/2/ctw**2*vmamo**
     & 2/mz**2*mmo**4+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-3d0/8/ctw
     & **2*vmamo**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mh**2*mmo**2-1
     & d0/4/ctw**2*vpamo*vmamo*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mmo**4
     & +1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-3d0/8/ctw**2*vpamo**2*m
     & mo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vmaup*cfl*qs*(1d0/8/ctw**2*vmamo
     & **2/mz**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2+1d0/8/ctw*
     & *2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup*cfl/qs*(-2*qmo*vmamo/mz**2*m
     & h**2*mmo**4+2*qmo*vmamo*mmo**4-2*qmo*vpamo/mz**2*mh**2*mmo**4+2*q
     & mo*vpamo*mmo**4+2*ctw**2*qmo*vmamo/mz**2*mh**2*mmo**4-2*ctw**2*qm
     & o*vmamo*mmo**4+2*ctw**2*qmo*vpamo/mz**2*mh**2*mmo**4-2*ctw**2*qmo
     & *vpamo*mmo**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qup*cfl*(-2*qmo*vmamo/mz**2*mmo*
     & *4-2*qmo*vmamo*mmo**2-2*qmo*vpamo/mz**2*mmo**4-2*qmo*vpamo*mmo**2
     & +2*ctw**2*qmo*vmamo/mz**2*mmo**4+2*ctw**2*qmo*vmamo*mmo**2+2*ctw*
     & *2*qmo*vpamo/mz**2*mmo**4+2*ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*c0zhqschchch*vmaup*cfq*(-1d0/2/ctw**2*vmach**
     & 2/mz**2*mch**4+1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-3d0/8/ctw
     & **2*vmach**2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mh**2*mch**2-1
     & d0/4/ctw**2*vpach*vmach*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mch**4
     & +1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-3d0/8/ctw**2*vpach**2*m
     & ch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vmaup*cfq*qs*(1d0/8/ctw**2*vmach
     & **2/mz**2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mch**2+1d0/8/ctw*
     & *2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*qup*cfq/qs*(-2*qch*vmach/mz**2*m
     & h**2*mch**4+2*qch*vmach*mch**4-2*qch*vpach/mz**2*mh**2*mch**4+2*q
     & ch*vpach*mch**4+2*ctw**2*qch*vmach/mz**2*mh**2*mch**4-2*ctw**2*qc
     & h*vmach*mch**4+2*ctw**2*qch*vpach/mz**2*mh**2*mch**4-2*ctw**2*qch
     & *vpach*mch**4)
     & +propizqs*det3izhqs*c0zhqschchch*qup*cfq*(-2*qch*vmach/mz**2*mch*
     & *4-2*qch*vmach*mch**2-2*qch*vpach/mz**2*mch**4-2*qch*vpach*mch**2
     & +2*ctw**2*qch*vmach/mz**2*mch**4+2*ctw**2*qch*vmach*mch**2+2*ctw*
     & *2*qch*vpach/mz**2*mch**4+2*ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*c0zhqsststst*vmaup*cfq*(-1d0/2/ctw**2*vmast**
     & 2/mz**2*mst**4+1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-3d0/8/ctw
     & **2*vmast**2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mh**2*mst**2-1
     & d0/4/ctw**2*vpast*vmast*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mst**4
     & +1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-3d0/8/ctw**2*vpast**2*m
     & st**2)
     & +propizqs*det3izhqs*c0zhqsststst*vmaup*cfq*qs*(1d0/8/ctw**2*vmast
     & **2/mz**2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mst**2+1d0/8/ctw*
     & *2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*qup*cfq/qs*(-2*qst*vmast/mz**2*m
     & h**2*mst**4+2*qst*vmast*mst**4-2*qst*vpast/mz**2*mh**2*mst**4+2*q
     & st*vpast*mst**4+2*ctw**2*qst*vmast/mz**2*mh**2*mst**4-2*ctw**2*qs
     & t*vmast*mst**4+2*ctw**2*qst*vpast/mz**2*mh**2*mst**4-2*ctw**2*qst
     & *vpast*mst**4)
     & +propizqs*det3izhqs*c0zhqsststst*qup*cfq*(-2*qst*vmast/mz**2*mst*
     & *4-2*qst*vmast*mst**2-2*qst*vpast/mz**2*mst**4-2*qst*vpast*mst**2
     & +2*ctw**2*qst*vmast/mz**2*mst**4+2*ctw**2*qst*vmast*mst**2+2*ctw*
     & *2*qst*vpast/mz**2*mst**4+2*ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*c0zhqstatata*vmaup*cfl*(-1d0/2/ctw**2*vmata**
     & 2/mz**2*mta**4+1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-3d0/8/ctw
     & **2*vmata**2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mh**2*mta**2-1
     & d0/4/ctw**2*vpata*vmata*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mta**4
     & +1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-3d0/8/ctw**2*vpata**2*m
     & ta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vmaup*cfl*qs*(1d0/8/ctw**2*vmata
     & **2/mz**2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mta**2+1d0/8/ctw*
     & *2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*qup*cfl/qs*(-2*qta*vmata/mz**2*m
     & h**2*mta**4+2*qta*vmata*mta**4-2*qta*vpata/mz**2*mh**2*mta**4+2*q
     & ta*vpata*mta**4+2*ctw**2*qta*vmata/mz**2*mh**2*mta**4-2*ctw**2*qt
     & a*vmata*mta**4+2*ctw**2*qta*vpata/mz**2*mh**2*mta**4-2*ctw**2*qta
     & *vpata*mta**4)
     & +propizqs*det3izhqs*c0zhqstatata*qup*cfl*(-2*qta*vmata/mz**2*mta*
     & *4-2*qta*vmata*mta**2-2*qta*vpata/mz**2*mta**4-2*qta*vpata*mta**2
     & +2*ctw**2*qta*vmata/mz**2*mta**4+2*ctw**2*qta*vmata*mta**2+2*ctw*
     & *2*qta*vpata/mz**2*mta**4+2*ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vmaup*cfq*(-1d0/2/ctw**2*vmatp**
     & 2/mz**2*mtp**4+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-3d0/8/ctw
     & **2*vmatp**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mh**2*mtp**2-1
     & d0/4/ctw**2*vpatp*vmatp*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**4
     & +1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-3d0/8/ctw**2*vpatp**2*m
     & tp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vmaup*cfq*qs*(1d0/8/ctw**2*vmatp
     & **2/mz**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2+1d0/8/ctw*
     & *2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qup*cfq/qs*(-2*qtp*vmatp/mz**2*m
     & h**2*mtp**4+2*qtp*vmatp*mtp**4-2*qtp*vpatp/mz**2*mh**2*mtp**4+2*q
     & tp*vpatp*mtp**4+2*ctw**2*qtp*vmatp/mz**2*mh**2*mtp**4-2*ctw**2*qt
     & p*vmatp*mtp**4+2*ctw**2*qtp*vpatp/mz**2*mh**2*mtp**4-2*ctw**2*qtp
     & *vpatp*mtp**4)
     & +propizqs*det3izhqs*c0zhqstptptp*qup*cfq*(-2*qtp*vmatp/mz**2*mtp*
     & *4-2*qtp*vmatp*mtp**2-2*qtp*vpatp/mz**2*mtp**4-2*qtp*vpatp*mtp**2
     & +2*ctw**2*qtp*vmatp/mz**2*mtp**4+2*ctw**2*qtp*vmatp*mtp**2+2*ctw*
     & *2*qtp*vpatp/mz**2*mtp**4+2*ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vmaup*cfq*(-1d0/2/ctw**2*vmabt**
     & 2/mz**2*mbt**4+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-3d0/8/ctw
     & **2*vmabt**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mh**2*mbt**2-1
     & d0/4/ctw**2*vpabt*vmabt*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**4
     & +1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-3d0/8/ctw**2*vpabt**2*m
     & bt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vmaup*cfq*qs*(1d0/8/ctw**2*vmabt
     & **2/mz**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2+1d0/8/ctw*
     & *2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup*cfq/qs*(-2*qbt*vmabt/mz**2*m
     & h**2*mbt**4+2*qbt*vmabt*mbt**4-2*qbt*vpabt/mz**2*mh**2*mbt**4+2*q
     & bt*vpabt*mbt**4+2*ctw**2*qbt*vmabt/mz**2*mh**2*mbt**4-2*ctw**2*qb
     & t*vmabt*mbt**4+2*ctw**2*qbt*vpabt/mz**2*mh**2*mbt**4-2*ctw**2*qbt
     & *vpabt*mbt**4)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qup*cfq*(-2*qbt*vmabt/mz**2*mbt*
     & *4-2*qbt*vmabt*mbt**2-2*qbt*vpabt/mz**2*mbt**4-2*qbt*vpabt*mbt**2
     & +2*ctw**2*qbt*vmabt/mz**2*mbt**4+2*ctw**2*qbt*vmabt*mbt**2+2*ctw*
     & *2*qbt*vpabt/mz**2*mbt**4+2*ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*a0fh*vmaup*(-1d0/2/ctw**2/mz**2*mh**2-1d0/4/c
     & tw**2)
     & +propizqs*det3izhqs*a0fh*vmaup*qs*(-1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhww*vmaup*(1d0/4+1d0/8/ctw**2/mz**2*mh**2-
     & 1d0/2/mz**2*mh**2+1d0/2*ctw**2/mz**2*mh**2-ctw**2+3*ctw**4)
     & +propizqs*det3izhqs*b0fhww*qup/qs*(1d0/2*mh**2-3d0/2*ctw**2*mh**2
     & +ctw**2*mz**2+ctw**4*mh**2-7*ctw**4*mz**2+6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qup*(-1d0/2/mz**2*mh**2+3d0/2*ctw**2/m
     & z**2*mh**2-ctw**2-ctw**4/mz**2*mh**2+7*ctw**4-6*ctw**6)
     & +propizqs*det3izhqs*b0fhzz*vmaup*(9d0/16/ctw**2/mz**2*mh**2+3d0/8
     & /ctw**2)
     & +propizqs*det3izhqs*b0fhzz*vmaup*qs*(1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhhh*vmaup*(-21d0/16/ctw**2/mz**2*mh**2-3d0
     & /4/ctw**2)
     & +propizqs*det3izhqs*b0fhhh*vmaup*qs*(-3d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhmomo*vmaup*cfl*(-1d0/4/ctw**2*vmamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vpamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup*cfl/qs*(qmo*vmamo*mmo**2+qmo*vpa
     & mo*mmo**2-ctw**2*qmo*vmamo*mmo**2-ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qup*cfl*(-qmo*vmamo/mz**2*mmo**2-qmo
     & *vpamo/mz**2*mmo**2+ctw**2*qmo*vmamo/mz**2*mmo**2+ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*vmaup*cfq*(-1d0/4/ctw**2*vmach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vpach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup*cfq/qs*(qch*vmach*mch**2+qch*vpa
     & ch*mch**2-ctw**2*qch*vmach*mch**2-ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qup*cfq*(-qch*vmach/mz**2*mch**2-qch
     & *vpach/mz**2*mch**2+ctw**2*qch*vmach/mz**2*mch**2+ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*vmaup*cfq*(-1d0/4/ctw**2*vmast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vpast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup*cfq/qs*(qst*vmast*mst**2+qst*vpa
     & st*mst**2-ctw**2*qst*vmast*mst**2-ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qup*cfq*(-qst*vmast/mz**2*mst**2-qst
     & *vpast/mz**2*mst**2+ctw**2*qst*vmast/mz**2*mst**2+ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*vmaup*cfl*(-1d0/4/ctw**2*vmata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vpata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup*cfl/qs*(qta*vmata*mta**2+qta*vpa
     & ta*mta**2-ctw**2*qta*vmata*mta**2-ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qup*cfl*(-qta*vmata/mz**2*mta**2-qta
     & *vpata/mz**2*mta**2+ctw**2*qta*vmata/mz**2*mta**2+ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*vmaup*cfq*(-1d0/4/ctw**2*vmatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vpatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup*cfq/qs*(qtp*vmatp*mtp**2+qtp*vpa
     & tp*mtp**2-ctw**2*qtp*vmatp*mtp**2-ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qup*cfq*(-qtp*vmatp/mz**2*mtp**2-qtp
     & *vpatp/mz**2*mtp**2+ctw**2*qtp*vmatp/mz**2*mtp**2+ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*vmaup*cfq*(-1d0/4/ctw**2*vmabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vpabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup*cfq/qs*(qbt*vmabt*mbt**2+qbt*vpa
     & bt*mbt**2-ctw**2*qbt*vmabt*mbt**2-ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qup*cfq*(-qbt*vmabt/mz**2*mbt**2-qbt
     & *vpabt/mz**2*mbt**2+ctw**2*qbt*vmabt/mz**2*mbt**2+ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzww*vmaup*(1d0/2)
     & +propizqs*det3izhqs*b0fzww*qup/qs*(-1d0/2*mh**2+3d0/2*ctw**2*mh**
     & 2-ctw**2*mz**2-ctw**4*mh**2+7*ctw**4*mz**2-6*ctw**6*mz**2)
     & +propizqs*det3izhqs*b0fzzh*vmaup*(1d0/4/ctw**2/mz**2*mh**2+3d0/8/
     & ctw**2)
     & +propizqs*det3izhqs*b0fzzh*vmaup*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fzmomo*vmaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz
     & **2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2-1d0/8/ctw**2*vpa
     & mo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*qup*cfl/qs*(-qmo*vmamo*mmo**2-qmo*vp
     & amo*mmo**2+ctw**2*qmo*vmamo*mmo**2+ctw**2*qmo*vpamo*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*vmaup*cfq*(-1d0/8/ctw**2*vmach**2/mz
     & **2*mch**2+1d0/4/ctw**2*vpach*vmach/mz**2*mch**2-1d0/8/ctw**2*vpa
     & ch**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*qup*cfq/qs*(-qch*vmach*mch**2-qch*vp
     & ach*mch**2+ctw**2*qch*vmach*mch**2+ctw**2*qch*vpach*mch**2)
     & +propizqs*det3izhqs*b0fzstst*vmaup*cfq*(-1d0/8/ctw**2*vmast**2/mz
     & **2*mst**2+1d0/4/ctw**2*vpast*vmast/mz**2*mst**2-1d0/8/ctw**2*vpa
     & st**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*qup*cfq/qs*(-qst*vmast*mst**2-qst*vp
     & ast*mst**2+ctw**2*qst*vmast*mst**2+ctw**2*qst*vpast*mst**2)
     & +propizqs*det3izhqs*b0fztata*vmaup*cfl*(-1d0/8/ctw**2*vmata**2/mz
     & **2*mta**2+1d0/4/ctw**2*vpata*vmata/mz**2*mta**2-1d0/8/ctw**2*vpa
     & ta**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*qup*cfl/qs*(-qta*vmata*mta**2-qta*vp
     & ata*mta**2+ctw**2*qta*vmata*mta**2+ctw**2*qta*vpata*mta**2)
     & +propizqs*det3izhqs*b0fztptp*vmaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz
     & **2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2-1d0/8/ctw**2*vpa
     & tp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*qup*cfq/qs*(-qtp*vmatp*mtp**2-qtp*vp
     & atp*mtp**2+ctw**2*qtp*vmatp*mtp**2+ctw**2*qtp*vpatp*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*vmaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz
     & **2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2-1d0/8/ctw**2*vpa
     & bt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*qup*cfq/qs*(-qbt*vmabt*mbt**2-qbt*vp
     & abt*mbt**2+ctw**2*qbt*vmabt*mbt**2+ctw**2*qbt*vpabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*vmaup*(-3d0/4-1d0/8/ctw**2/mz**2*mh**
     & 2+1d0/2/mz**2*mh**2-1d0/2*ctw**2/mz**2*mh**2+ctw**2-3*ctw**4)
     & +propizqs*det3izhqs*b0fqsww*qup*(1d0/2/mz**2*mh**2-3d0/2*ctw**2/m
     & z**2*mh**2+ctw**2+ctw**4/mz**2*mh**2-7*ctw**4+6*ctw**6)
     & +propizqs*det3izhqs*b0fqszh*vmaup*(-1d0/4/ctw**2)
     & +propizqs*det3izhqs*b0fqszh*vmaup*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fqsmomo*vmaup*cfl*(3d0/8/ctw**2*vmamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vpamo*vmamo/mz**2*mmo**2+3d0/8/ctw**2*vpa
     & mo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*qup*cfl*(qmo*vmamo/mz**2*mmo**2+qmo
     & *vpamo/mz**2*mmo**2-ctw**2*qmo*vmamo/mz**2*mmo**2-ctw**2*qmo*vpam
     & o/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*vmaup*cfq*(3d0/8/ctw**2*vmach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vpach*vmach/mz**2*mch**2+3d0/8/ctw**2*vpa
     & ch**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*qup*cfq*(qch*vmach/mz**2*mch**2+qch
     & *vpach/mz**2*mch**2-ctw**2*qch*vmach/mz**2*mch**2-ctw**2*qch*vpac
     & h/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*vmaup*cfq*(3d0/8/ctw**2*vmast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vpast*vmast/mz**2*mst**2+3d0/8/ctw**2*vpa
     & st**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*qup*cfq*(qst*vmast/mz**2*mst**2+qst
     & *vpast/mz**2*mst**2-ctw**2*qst*vmast/mz**2*mst**2-ctw**2*qst*vpas
     & t/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*vmaup*cfl*(3d0/8/ctw**2*vmata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vpata*vmata/mz**2*mta**2+3d0/8/ctw**2*vpa
     & ta**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*qup*cfl*(qta*vmata/mz**2*mta**2+qta
     & *vpata/mz**2*mta**2-ctw**2*qta*vmata/mz**2*mta**2-ctw**2*qta*vpat
     & a/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*vmaup*cfq*(3d0/8/ctw**2*vmatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vpatp*vmatp/mz**2*mtp**2+3d0/8/ctw**2*vpa
     & tp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*qup*cfq*(qtp*vmatp/mz**2*mtp**2+qtp
     & *vpatp/mz**2*mtp**2-ctw**2*qtp*vmatp/mz**2*mtp**2-ctw**2*qtp*vpat
     & p/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*vmaup*cfq*(3d0/8/ctw**2*vmabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vpabt*vmabt/mz**2*mbt**2+3d0/8/ctw**2*vpa
     & bt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qup*cfq*(qbt*vmabt/mz**2*mbt**2+qbt
     & *vpabt/mz**2*mbt**2-ctw**2*qbt*vmabt/mz**2*mbt**2-ctw**2*qbt*vpab
     & t/mz**2*mbt**2)
     & +propizqs*sdet3iczts*c0cztszcc*vmaup**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3iczts*b0fzcc*vmaup**3/qs*(1d0/ctw**2)
     & +propizqs*sdet3iczts*b0ftszc*vmaup**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichus*c0chusczz*vmaup**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3ichus*b0fhzz*vmaup**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichus*b0fuszc*vmaup**3/qs*(1d0/ctw**2)
     & +propizqs*d0zchctsuscczz*vmaup**3/qs*(1d0/2/ctw**2*us-1d0/2*sdet4
     & izhtsus/ctw**2*mz**4*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**6-sdet4i
     & zhtsus/ctw**2*us*mz**2*mh**2+sdet4izhtsus/ctw**2*us*mz**4+1d0/2*s
     & det4izhtsus**2/ctw**2*mz**6*mh**4-3d0/2*sdet4izhtsus**2/ctw**2*mz
     & **8*mh**2+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**4-sdet4izhtsu
     & s**2/ctw**2*us*mz**6*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**8)
     & 
     & +propizqs*d0zchctsuscczz*vmaup**3*(-sdet4izhtsus/ctw**2*us*mz**2+
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2
     & /ctw**2*us**2*mz**4-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6)
     & +propizqs*c0zhqswww*qup/qs*(-4*ctw**2+28*ctw**4-24*ctw**6)
     & +propizqs*c0zhqsmomomo*qup*cfl/qs*(-2*qmo*vmamo/mz**2*mmo**2-2*qm
     & o*vpamo/mz**2*mmo**2+2*ctw**2*qmo*vmamo/mz**2*mmo**2+2*ctw**2*qmo
     & *vpamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qup*cfq/qs*(-2*qch*vmach/mz**2*mch**2-2*qc
     & h*vpach/mz**2*mch**2+2*ctw**2*qch*vmach/mz**2*mch**2+2*ctw**2*qch
     & *vpach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qup*cfq/qs*(-2*qst*vmast/mz**2*mst**2-2*qs
     & t*vpast/mz**2*mst**2+2*ctw**2*qst*vmast/mz**2*mst**2+2*ctw**2*qst
     & *vpast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qup*cfl/qs*(-2*qta*vmata/mz**2*mta**2-2*qt
     & a*vpata/mz**2*mta**2+2*ctw**2*qta*vmata/mz**2*mta**2+2*ctw**2*qta
     & *vpata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qup*cfq/qs*(-2*qtp*vmatp/mz**2*mtp**2-2*qt
     & p*vpatp/mz**2*mtp**2+2*ctw**2*qtp*vmatp/mz**2*mtp**2+2*ctw**2*qtp
     & *vpatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qup*cfq/qs*(-2*qbt*vmabt/mz**2*mbt**2-2*qb
     & t*vpabt/mz**2*mbt**2+2*ctw**2*qbt*vmabt/mz**2*mbt**2+2*ctw**2*qbt
     & *vpabt/mz**2*mbt**2)
     & +propizqs*c0chtsczz*vmaup**3/qs*(-1d0/2/ctw**2-1d0/2*sdet4izhtsus
     & /ctw**2*mz**2*mh**2-sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsus/
     & ctw**2*us*mh**2-1d0/2*sdet4izhtsus/ctw**2*us*mz**2-1d0/2*sdet4izh
     & tsus/ctw**2*ts*mz**2+sdet4izhtsus**2/ctw**2*mz**4*mh**4-sdet4izht
     & sus**2/ctw**2*mz**6*mh**2+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**2*m
     & h**4-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2+1d0/2*sdet4izhts
     & us**2/ctw**2*ts*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6
     & )
     & +propizqs*c0chtsczz*vmaup**3*(1d0/2*sdet4izhtsus**2/ctw**2*us*mz*
     & *2*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4)
     & +propizqs*c0chusczz*vmaup**3/qs*(1d0/2/ctw**2-1d0/2*sdet4izhtsus/
     & ctw**2*mz**4-1d0/2*sdet4izhtsus/ctw**2*us*mz**2-1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**4*mh**4-1d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2
     & /ctw**2*ts*mz**4*mh**2)
     & +propizqs*c0chusczz*vmaup**3*(-1d0/2*sdet4izhtsus/ctw**2*us-1d0/2
     & *sdet4izhtsus**2/ctw**2*us**2*mz**2)
     & +propizqs*c0cztszcc*vmaup**3/qs*(-1d0/2/ctw**2+1d0/2*sdet4izhtsus
     & /ctw**2*mz**2*mh**2+sdet4izhtsus/ctw**2*mz**4+sdet4izhtsus/ctw**2
     & *us*mz**2+1d0/2*sdet4izhtsus/ctw**2*ts*mz**2)
     & +propizqs*c0cztszcc*vmaup**3*(-1d0/2*sdet4izhtsus**2/ctw**2*us*mz
     & **4+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4)
     & +propizqs*c0czuszcc*vmaup**3/qs*(1d0/2/ctw**2+1d0/2*sdet4izhtsus/
     & ctw**2*mz**4+1d0/2*sdet4izhtsus/ctw**2*us*mh**2-1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**4*mh**4+3d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**2*mh**4+sdet4izhtsus**2/ctw**
     & 2*us*mz**4*mh**2+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6)
     & +propizqs*c0czuszcc*vmaup**3*(1d0/2*sdet4izhtsus/ctw**2*us-1d0/2*
     & sdet4izhtsus**2/ctw**2*us*mz**2*mh**2+1d0/2*sdet4izhtsus**2/ctw**
     & 2*us*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*us**2*mz**2)
     & +propizqs*b0fhzz*vmaup**3/qs*(-sdet4izhtsus/ctw**2*mz**2-sdet4izh
     & tsus/ctw**2*us)
     & +propizqs*b0fzcc*vmaup**3/qs*(-sdet4izhtsus/ctw**2*mz**2-sdet4izh
     & tsus/ctw**2*us)
     & +propizqs*b0ftszc*vmaup**3/qs*(sdet4izhtsus/ctw**2*mz**2+sdet4izh
     & tsus/ctw**2*us)
     & +propizqs*b0fuszc*vmaup**3/qs*(sdet4izhtsus/ctw**2*mz**2+sdet4izh
     & tsus/ctw**2*us)
     & +det3izhqs*vmaup*(-7d0/8/ctw**2*mh**2+1d0/4/ctw**2*mz**2+3d0/4*mh
     & **2+1d0/2*mz**2-2*ctw**2*mz**2-3*ctw**4*mh**2+6*ctw**4*mz**2)
     & +det3izhqs*vmaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d
     & 0/2/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt*
     & *2-1d0/2/ctw**2*vpabt**2*mbt**2+1d0/4/ctw**2*vmatp**2/mz**2*mh**2
     & *mtp**2-1d0/2/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*
     & mh**2*mtp**2-1d0/2/ctw**2*vpatp**2*mtp**2+1d0/4/ctw**2*vmast**2/m
     & z**2*mh**2*mst**2-1d0/2/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast
     & **2/mz**2*mh**2*mst**2-1d0/2/ctw**2*vpast**2*mst**2+1d0/4/ctw**2*
     & vmach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vmach**2*mch**2+1d0/4/ct
     & w**2*vpach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vpach**2*mch**2)
     & +det3izhqs*vmaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d
     & 0/2/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta*
     & *2-1d0/2/ctw**2*vpata**2*mta**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2
     & *mmo**2-1d0/2/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*
     & mh**2*mmo**2-1d0/2/ctw**2*vpamo**2*mmo**2)
     & +det3izhqs**2*c0zhqswww*vmaup*(-3d0/2/ctw**2*mz**6*mh**2+21d0/4*m
     & z**6*mh**2-3*ctw**2*mz**6*mh**2-9*ctw**4*mz**6*mh**2)
     & +det3izhqs**2*c0zhqszhh*vmaup*(-9/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqshzz*vmaup*(-18/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqsmomomo*vmaup*cfl*(3d0/4/ctw**2*vmamo**2*mz**4
     & *mh**2*mmo**2+3d0/4/ctw**2*vpamo**2*mz**4*mh**2*mmo**2)
     & +det3izhqs**2*c0zhqschchch*vmaup*cfq*(3d0/4/ctw**2*vmach**2*mz**4
     & *mh**2*mch**2+3d0/4/ctw**2*vpach**2*mz**4*mh**2*mch**2)
     & +det3izhqs**2*c0zhqsststst*vmaup*cfq*(3d0/4/ctw**2*vmast**2*mz**4
     & *mh**2*mst**2+3d0/4/ctw**2*vpast**2*mz**4*mh**2*mst**2)
     & +det3izhqs**2*c0zhqstatata*vmaup*cfl*(3d0/4/ctw**2*vmata**2*mz**4
     & *mh**2*mta**2+3d0/4/ctw**2*vpata**2*mz**4*mh**2*mta**2)
     & +det3izhqs**2*c0zhqstptptp*vmaup*cfq*(3d0/4/ctw**2*vmatp**2*mz**4
     & *mh**2*mtp**2+3d0/4/ctw**2*vpatp**2*mz**4*mh**2*mtp**2)
     & +det3izhqs**2*c0zhqsbtbtbt*vmaup*cfq*(3d0/4/ctw**2*vmabt**2*mz**4
     & *mh**2*mbt**2+3d0/4/ctw**2*vpabt**2*mz**4*mh**2*mbt**2)
     & +det3izhqs**2*b0fhww*vmaup*(3d0/2/ctw**2*mz**4*mh**2-21d0/4*mz**4
     & *mh**2+3*ctw**2*mz**4*mh**2+9*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fhzz*vmaup*(9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhhh*vmaup*(-9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhmomo*vmaup*cfl*(-3d0/4/ctw**2*vmamo**2*mz**2*mh
     & **2*mmo**2-3d0/4/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fhchch*vmaup*cfq*(-3d0/4/ctw**2*vmach**2*mz**2*mh
     & **2*mch**2-3d0/4/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fhstst*vmaup*cfq*(-3d0/4/ctw**2*vmast**2*mz**2*mh
     & **2*mst**2-3d0/4/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fhtata*vmaup*cfl*(-3d0/4/ctw**2*vmata**2*mz**2*mh
     & **2*mta**2-3d0/4/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fhtptp*vmaup*cfq*(-3d0/4/ctw**2*vmatp**2*mz**2*mh
     & **2*mtp**2-3d0/4/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fhbtbt*vmaup*cfq*(-3d0/4/ctw**2*vmabt**2*mz**2*mh
     & **2*mbt**2-3d0/4/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fzww*vmaup*(-3d0/4/ctw**2*mz**4*mh**2+21d0/8*mz**
     & 4*mh**2-3d0/2*ctw**2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fzmomo*vmaup*cfl*(3d0/8/ctw**2*vmamo**2*mz**2*mh*
     & *2*mmo**2+3d0/8/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fzchch*vmaup*cfq*(3d0/8/ctw**2*vmach**2*mz**2*mh*
     & *2*mch**2+3d0/8/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fzstst*vmaup*cfq*(3d0/8/ctw**2*vmast**2*mz**2*mh*
     & *2*mst**2+3d0/8/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fztata*vmaup*cfl*(3d0/8/ctw**2*vmata**2*mz**2*mh*
     & *2*mta**2+3d0/8/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fztptp*vmaup*cfq*(3d0/8/ctw**2*vmatp**2*mz**2*mh*
     & *2*mtp**2+3d0/8/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fzbtbt*vmaup*cfq*(3d0/8/ctw**2*vmabt**2*mz**2*mh*
     & *2*mbt**2+3d0/8/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fqsww*vmaup*(-3d0/4/ctw**2*mz**4*mh**2+21d0/8*mz*
     & *4*mh**2-3d0/2*ctw**2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2)
     & +det3izhqs**2*b0fqsmomo*vmaup*cfl*(3d0/8/ctw**2*vmamo**2*mz**2*mh
     & **2*mmo**2+3d0/8/ctw**2*vpamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fqschch*vmaup*cfq*(3d0/8/ctw**2*vmach**2*mz**2*mh
     & **2*mch**2+3d0/8/ctw**2*vpach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fqsstst*vmaup*cfq*(3d0/8/ctw**2*vmast**2*mz**2*mh
     & **2*mst**2+3d0/8/ctw**2*vpast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fqstata*vmaup*cfl*(3d0/8/ctw**2*vmata**2*mz**2*mh
     & **2*mta**2+3d0/8/ctw**2*vpata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fqstptp*vmaup*cfq*(3d0/8/ctw**2*vmatp**2*mz**2*mh
     & **2*mtp**2+3d0/8/ctw**2*vpatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fqsbtbt*vmaup*cfq*(3d0/8/ctw**2*vmabt**2*mz**2*mh
     & **2*mbt**2+3d0/8/ctw**2*vpabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*c0zhqswww*vmaup*(1d0/2/ctw**2*mz**2*mh**2+3d0/2/ctw**2
     & *mz**4-1d0/2*mz**2*mh**2-5*mz**4+1d0/2*ctw**2*mz**2*mh**2+ctw**2*
     & mz**4+16*ctw**4*mz**4+6*ctw**6*mz**2*mh**2-12*ctw**6*mz**4)
     & +det3izhqs*c0zhqszhh*vmaup*(51d0/4/ctw**2*mz**2*mh**2+9/ctw**2*mz
     & **4)
     & +det3izhqs*c0zhqshzz*vmaup*(17/ctw**2*mz**2*mh**2+18/ctw**2*mz**4
     & )
     & +det3izhqs*c0zhqsmomomo*vmaup*cfl*(-1d0/2/ctw**2*vmamo**2/mz**2*m
     & h**2*mmo**4+1d0/ctw**2*vmamo**2*mmo**4-1d0/4/ctw**2*vmamo**2*mh**
     & 2*mmo**2-1d0/ctw**2*vmamo**2*mz**2*mmo**2+1d0/2/ctw**2*vpamo*vmam
     & o*mh**2*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mh**2*mmo**4+1d0/ctw**
     & 2*vpamo**2*mmo**4-1d0/4/ctw**2*vpamo**2*mh**2*mmo**2-1d0/ctw**2*v
     & pamo**2*mz**2*mmo**2)
     & +det3izhqs*c0zhqschchch*vmaup*cfq*(-1d0/2/ctw**2*vmach**2/mz**2*m
     & h**2*mch**4+1d0/ctw**2*vmach**2*mch**4-1d0/4/ctw**2*vmach**2*mh**
     & 2*mch**2-1d0/ctw**2*vmach**2*mz**2*mch**2+1d0/2/ctw**2*vpach*vmac
     & h*mh**2*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mh**2*mch**4+1d0/ctw**
     & 2*vpach**2*mch**4-1d0/4/ctw**2*vpach**2*mh**2*mch**2-1d0/ctw**2*v
     & pach**2*mz**2*mch**2)
     & +det3izhqs*c0zhqsststst*vmaup*cfq*(-1d0/2/ctw**2*vmast**2/mz**2*m
     & h**2*mst**4+1d0/ctw**2*vmast**2*mst**4-1d0/4/ctw**2*vmast**2*mh**
     & 2*mst**2-1d0/ctw**2*vmast**2*mz**2*mst**2+1d0/2/ctw**2*vpast*vmas
     & t*mh**2*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mh**2*mst**4+1d0/ctw**
     & 2*vpast**2*mst**4-1d0/4/ctw**2*vpast**2*mh**2*mst**2-1d0/ctw**2*v
     & past**2*mz**2*mst**2)
     & +det3izhqs*c0zhqstatata*vmaup*cfl*(-1d0/2/ctw**2*vmata**2/mz**2*m
     & h**2*mta**4+1d0/ctw**2*vmata**2*mta**4-1d0/4/ctw**2*vmata**2*mh**
     & 2*mta**2-1d0/ctw**2*vmata**2*mz**2*mta**2+1d0/2/ctw**2*vpata*vmat
     & a*mh**2*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mh**2*mta**4+1d0/ctw**
     & 2*vpata**2*mta**4-1d0/4/ctw**2*vpata**2*mh**2*mta**2-1d0/ctw**2*v
     & pata**2*mz**2*mta**2)
     & +det3izhqs*c0zhqstptptp*vmaup*cfq*(-1d0/2/ctw**2*vmatp**2/mz**2*m
     & h**2*mtp**4+1d0/ctw**2*vmatp**2*mtp**4-1d0/4/ctw**2*vmatp**2*mh**
     & 2*mtp**2-1d0/ctw**2*vmatp**2*mz**2*mtp**2+1d0/2/ctw**2*vpatp*vmat
     & p*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mh**2*mtp**4+1d0/ctw**
     & 2*vpatp**2*mtp**4-1d0/4/ctw**2*vpatp**2*mh**2*mtp**2-1d0/ctw**2*v
     & patp**2*mz**2*mtp**2)
     & +det3izhqs*c0zhqsbtbtbt*vmaup*cfq*(-1d0/2/ctw**2*vmabt**2/mz**2*m
     & h**2*mbt**4+1d0/ctw**2*vmabt**2*mbt**4-1d0/4/ctw**2*vmabt**2*mh**
     & 2*mbt**2-1d0/ctw**2*vmabt**2*mz**2*mbt**2+1d0/2/ctw**2*vpabt*vmab
     & t*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mh**2*mbt**4+1d0/ctw**
     & 2*vpabt**2*mbt**4-1d0/4/ctw**2*vpabt**2*mh**2*mbt**2-1d0/ctw**2*v
     & pabt**2*mz**2*mbt**2)
     & +det3izhqs*a0fz*vmaup*(-1d0/4/ctw**2*mh**2+1d0/4/ctw**2*mz**2)
     & +det3izhqs*a0fh*vmaup*(3d0/4/ctw**2*mh**2)
     & +det3izhqs*b0fhww*vmaup*(-1d0/4/ctw**2*mh**2-3d0/2/ctw**2*mz**2+1
     & 1d0/2*mz**2-ctw**2*mh**2-4*ctw**2*mz**2-6*ctw**4*mz**2)
     & +det3izhqs*b0fhzz*vmaup*(-21d0/8/ctw**2*mh**2-17d0/4/ctw**2*mz**2
     & )
     & +det3izhqs*b0fhhh*vmaup*(33d0/8/ctw**2*mh**2+9d0/2/ctw**2*mz**2)
     & +det3izhqs*b0fhmomo*vmaup*cfl*(1d0/4/ctw**2*vmamo**2/mz**2*mh**2*
     & mmo**2+1d0/2/ctw**2*vmamo**2*mmo**2-1d0/2/ctw**2*vpamo*vmamo/mz**
     & 2*mh**2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2+1d0/2/ctw
     & **2*vpamo**2*mmo**2)
     & +det3izhqs*b0fhchch*vmaup*cfq*(1d0/4/ctw**2*vmach**2/mz**2*mh**2*
     & mch**2+1d0/2/ctw**2*vmach**2*mch**2-1d0/2/ctw**2*vpach*vmach/mz**
     & 2*mh**2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2+1d0/2/ctw
     & **2*vpach**2*mch**2)
     & +det3izhqs*b0fhstst*vmaup*cfq*(1d0/4/ctw**2*vmast**2/mz**2*mh**2*
     & mst**2+1d0/2/ctw**2*vmast**2*mst**2-1d0/2/ctw**2*vpast*vmast/mz**
     & 2*mh**2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2*mst**2+1d0/2/ctw
     & **2*vpast**2*mst**2)
     & +det3izhqs*b0fhtata*vmaup*cfl*(1d0/4/ctw**2*vmata**2/mz**2*mh**2*
     & mta**2+1d0/2/ctw**2*vmata**2*mta**2-1d0/2/ctw**2*vpata*vmata/mz**
     & 2*mh**2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta**2+1d0/2/ctw
     & **2*vpata**2*mta**2)
     & +det3izhqs*b0fhtptp*vmaup*cfq*(1d0/4/ctw**2*vmatp**2/mz**2*mh**2*
     & mtp**2+1d0/2/ctw**2*vmatp**2*mtp**2-1d0/2/ctw**2*vpatp*vmatp/mz**
     & 2*mh**2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mh**2*mtp**2+1d0/2/ctw
     & **2*vpatp**2*mtp**2)
     & +det3izhqs*b0fhbtbt*vmaup*cfq*(1d0/4/ctw**2*vmabt**2/mz**2*mh**2*
     & mbt**2+1d0/2/ctw**2*vmabt**2*mbt**2-1d0/2/ctw**2*vpabt*vmabt/mz**
     & 2*mh**2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt**2+1d0/2/ctw
     & **2*vpabt**2*mbt**2)
     & +det3izhqs*b0fzww*vmaup*(1d0/8/ctw**2*mh**2+3d0/4/ctw**2*mz**2-11
     & d0/4*mz**2+1d0/2*ctw**2*mh**2+2*ctw**2*mz**2+3*ctw**4*mz**2)
     & +det3izhqs*b0fzzh*vmaup*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fzmomo*vmaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh**2
     & *mmo**2-1d0/4/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz*
     & *2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ct
     & w**2*vpamo**2*mmo**2)
     & +det3izhqs*b0fzchch*vmaup*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh**2
     & *mch**2-1d0/4/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpach*vmach/mz*
     & *2*mh**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ct
     & w**2*vpach**2*mch**2)
     & +det3izhqs*b0fzstst*vmaup*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh**2
     & *mst**2-1d0/4/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast*vmast/mz*
     & *2*mh**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ct
     & w**2*vpast**2*mst**2)
     & +det3izhqs*b0fztata*vmaup*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh**2
     & *mta**2-1d0/4/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata*vmata/mz*
     & *2*mh**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ct
     & w**2*vpata**2*mta**2)
     & +det3izhqs*b0fztptp*vmaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh**2
     & *mtp**2-1d0/4/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz*
     & *2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ct
     & w**2*vpatp**2*mtp**2)
     & +det3izhqs*b0fzbtbt*vmaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh**2
     & *mbt**2-1d0/4/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz*
     & *2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ct
     & w**2*vpabt**2*mbt**2)
     & +det3izhqs*b0fqsww*vmaup*(1d0/8/ctw**2*mh**2+3d0/4/ctw**2*mz**2-1
     & 1d0/4*mz**2+1d0/2*ctw**2*mh**2+2*ctw**2*mz**2+3*ctw**4*mz**2)
     & +det3izhqs*b0fqszh*vmaup*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fqsmomo*vmaup*cfl*(-1d0/8/ctw**2*vmamo**2/mz**2*mh**
     & 2*mmo**2-1d0/4/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpamo*vmamo/mz
     & **2*mh**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/c
     & tw**2*vpamo**2*mmo**2)
     & +det3izhqs*b0fqschch*vmaup*cfq*(-1d0/8/ctw**2*vmach**2/mz**2*mh**
     & 2*mch**2-1d0/4/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpach*vmach/mz
     & **2*mh**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/c
     & tw**2*vpach**2*mch**2)
     & +det3izhqs*b0fqsstst*vmaup*cfq*(-1d0/8/ctw**2*vmast**2/mz**2*mh**
     & 2*mst**2-1d0/4/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpast*vmast/mz
     & **2*mh**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/c
     & tw**2*vpast**2*mst**2)
     & +det3izhqs*b0fqstata*vmaup*cfl*(-1d0/8/ctw**2*vmata**2/mz**2*mh**
     & 2*mta**2-1d0/4/ctw**2*vmata**2*mta**2+1d0/4/ctw**2*vpata*vmata/mz
     & **2*mh**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/c
     & tw**2*vpata**2*mta**2)
     & +det3izhqs*b0fqstptp*vmaup*cfq*(-1d0/8/ctw**2*vmatp**2/mz**2*mh**
     & 2*mtp**2-1d0/4/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*vpatp*vmatp/mz
     & **2*mh**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/c
     & tw**2*vpatp**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*vmaup*cfq*(-1d0/8/ctw**2*vmabt**2/mz**2*mh**
     & 2*mbt**2-1d0/4/ctw**2*vmabt**2*mbt**2+1d0/4/ctw**2*vpabt*vmabt/mz
     & **2*mh**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/c
     & tw**2*vpabt**2*mbt**2)
     & +c0zhqswww*vmaup*(-1-4*ctw**2+12*ctw**4)
     & +c0zhqszhh*vmaup*(-3/ctw**2/mz**2*mh**2-21d0/2/ctw**2)
     & +c0zhqshzz*vmaup*(-3d0/2/ctw**2/mz**2*mh**2-13/ctw**2)
     & +c0zhqsmomomo*vmaup*cfl*(-1d0/ctw**2*vpamo*vmamo/mz**2*mmo**2)
     & +c0zhqschchch*vmaup*cfq*(-1d0/ctw**2*vpach*vmach/mz**2*mch**2)
     & +c0zhqsststst*vmaup*cfq*(-1d0/ctw**2*vpast*vmast/mz**2*mst**2)
     & +c0zhqstatata*vmaup*cfl*(-1d0/ctw**2*vpata*vmata/mz**2*mta**2)
     & +c0zhqstptptp*vmaup*cfq*(-1d0/ctw**2*vpatp*vmatp/mz**2*mtp**2)
     & +c0zhqsbtbtbt*vmaup*cfq*(-1d0/ctw**2*vpabt*vmabt/mz**2*mbt**2)
     & +a0fh*vmaup*(-1d0/ctw**2/mz**2)
     & +b0fhzz*vmaup*(1d0/ctw**2/mz**2)
     & +b0fhhh*vmaup*(-3/ctw**2/mz**2)
     & +b0fzzh*vmaup*(1d0/2/ctw**2/mz**2)
     & +b0fqszh*vmaup*(1d0/2/ctw**2/mz**2)

      ffarray(1,1) = ffgp0
      ffarray(1,2) = ffgp1
      ffarray(1,3) = ffgp2
      ffarray(1,4) = ffgm0
      ffarray(1,5) = ffgm1
      ffarray(1,6) = ffgm2

      return
      end
